(* Mathematica package *)

TenSidedDie::usage = "TenSidedDie[] gives an image of a ten sided die."

Begin["Private`"]

propLis = {"AdjacentFaceIndices", "Centroid","Circumcenter", "Circumradius", 
  "Circumsphere", "Concave", "Convex", "DihedralAngleRules", 
  "DihedralAngles", "DualName", "EdgeCount", "EdgeIndices", 
  "EdgeLengths", "Edges", "FaceCount", "FaceCountRules", 
  "FaceIndices", "Faces","GeneralizedDiameter", "Image", "Incenter", "Inradius", "Insphere",
   "Name", "NetCoordinates", "NetEdgeIndices", "NetEdges", 
  "NetFaceIndices", "NetFaces", "NetGraph", "NetImage", "Platonic",
  "SkeletonCoordinates", "SkeletonGraph", "SkeletonImage", 
  "SkeletonRules", "StandardName", "StandardNames", "SurfaceArea", 
  "VertexCoordinates", "VertexCount", "VertexIndices", "Volume"}

altLis= {"AlternateNames", "AlternateStandardNames", "Amphichiral", \
"Antiprism", "Archimedean", "ArchimedeanDual",  "Chiral", \
"Classes", "Compound", "Cuboid", "DefaultOrientation", "Deltahedron", \
"Dipyramid", "DualCompound", "DualScale", "Equilateral", \
"Hypercube", "InertiaTensor", "Information", \
"Isohedron", "Johnson", "KeplerPoinsot", "Midcenter", "Midradius", \
"Midsphere", "MultipieceNetCoordinates", "MultipieceNetFaceIndices", \
"MultipieceNetImage", "NetCount", "NotationRules", "Orientations", \
"Orthotope", "PlatonicDual", "PolyhedronIndices", \
"Prism", "Pyramid", "Quasiregular", "RectangularParallelepiped", \
"RegionFunction", "Rhombohedron", "Rigid", "SchlaefliSymbol", \
"SelfDual", "Shaky", "Simplex", "SkeletonGraphName", "SpaceFilling", \
"Stellation", "StellationCount", "SymmetryGroupString", "Uniform", \
"UniformDual", "VertexSubsetHulls", "WythoffSymbol", "Zonohedron"}

TenSidedDie::notdef = "TenSidedDie has no value associated with the \
specified argument(s)."

vertCoords = Map[ToRadicals,{{0, 0, 
    Root[6400 - 67200 #1^2 + 227760 #1^4 - 308360 #1^6 + 
       141761 #1^8 &, 2]}, {0, 0, 
    Root[6400 - 67200 #1^2 + 227760 #1^4 - 308360 #1^6 + 
       141761 #1^8 &, 7]}, {Root[
     25 - 1300 #1^2 + 21710 #1^4 - 122180 #1^6 + 141761 #1^8 &, 6], 
    Root[625 - 14500 #1^2 + 84150 #1^4 - 186180 #1^6 + 141761 #1^8 &, 
     8], Root[1 - 404 #1^2 + 41446 #1^4 - 207124 #1^6 + 141761 #1^8 &,
      6]}, {Root[
     25 - 1850 #1^2 + 25835 #1^4 - 109090 #1^6 + 141761 #1^8 &, 1], 
    Root[625 - 11750 #1^2 + 77275 #1^4 - 199270 #1^6 + 141761 #1^8 &, 
     7], Root[1 - 404 #1^2 + 41446 #1^4 - 207124 #1^6 + 141761 #1^8 &,
      6]}, {Root[
     25 - 1850 #1^2 + 25835 #1^4 - 109090 #1^6 + 141761 #1^8 &, 1], 
    Root[625 - 11750 #1^2 + 77275 #1^4 - 199270 #1^6 + 141761 #1^8 &, 
     2], Root[1 - 404 #1^2 + 41446 #1^4 - 207124 #1^6 + 141761 #1^8 &,
      6]}, {Root[
     25 - 1300 #1^2 + 21710 #1^4 - 122180 #1^6 + 141761 #1^8 &, 6], 
    Root[625 - 14500 #1^2 + 84150 #1^4 - 186180 #1^6 + 141761 #1^8 &, 
     1], Root[1 - 404 #1^2 + 41446 #1^4 - 207124 #1^6 + 141761 #1^8 &,
      6]}, {Root[
     6400 - 67200 #1^2 + 227760 #1^4 - 308360 #1^6 + 141761 #1^8 &, 
     7], 0, Root[
     1 - 404 #1^2 + 41446 #1^4 - 207124 #1^6 + 141761 #1^8 &, 
     6]}, {Root[
     25 - 1850 #1^2 + 25835 #1^4 - 109090 #1^6 + 141761 #1^8 &, 8], 
    Root[625 - 11750 #1^2 + 77275 #1^4 - 199270 #1^6 + 141761 #1^8 &, 
     7], Root[1 - 404 #1^2 + 41446 #1^4 - 207124 #1^6 + 141761 #1^8 &,
      3]}, {Root[
     25 - 1300 #1^2 + 21710 #1^4 - 122180 #1^6 + 141761 #1^8 &, 3], 
    Root[625 - 14500 #1^2 + 84150 #1^4 - 186180 #1^6 + 141761 #1^8 &, 
     8], Root[1 - 404 #1^2 + 41446 #1^4 - 207124 #1^6 + 141761 #1^8 &,
      3]}, {Root[
     6400 - 67200 #1^2 + 227760 #1^4 - 308360 #1^6 + 141761 #1^8 &, 
     2], 0, Root[
     1 - 404 #1^2 + 41446 #1^4 - 207124 #1^6 + 141761 #1^8 &, 
     3]}, {Root[
     25 - 1300 #1^2 + 21710 #1^4 - 122180 #1^6 + 141761 #1^8 &, 3], 
    Root[625 - 14500 #1^2 + 84150 #1^4 - 186180 #1^6 + 141761 #1^8 &, 
     1], Root[1 - 404 #1^2 + 41446 #1^4 - 207124 #1^6 + 141761 #1^8 &,
      3]}, {Root[
     25 - 1850 #1^2 + 25835 #1^4 - 109090 #1^6 + 141761 #1^8 &, 8], 
    Root[625 - 11750 #1^2 + 77275 #1^4 - 199270 #1^6 + 141761 #1^8 &, 
     2], Root[1 - 404 #1^2 + 41446 #1^4 - 207124 #1^6 + 141761 #1^8 &,
      3]}},{2}]

vertCnt=Length[vertCoords]

polyLis = {{2, 3, 9, 4}, {2, 4, 10, 5}, {2, 5, 11, 6}, {2, 6, 12, 
    7}, {2, 7, 8, 3}, {1, 8, 3, 9}, {1, 9, 4, 10}, {1, 10, 5, 11}, {1,
     11, 6, 12}, {1, 12, 7, 8}};
     
edgCnt= Length[polyLIs]

edgLis = {{2, 3}, {3, 9}, {4, 9}, {2, 4}, {4, 10}, {5, 10}, {2, 5}, {5, 
  11}, {6, 11}, {2, 6}, {6, 12}, {7, 12}, {2, 7}, {7, 8}, {3, 8}, {1, 
  8}, {1, 9}, {1, 10}, {1, 11}, {1, 12}}

polyImg=Graphics3D[GraphicsComplex[vertCoords, Polygon[polyLis]]]

lngEdgeLen = 1

shrtEdgeLen = 
ToRadicals[Root[65536 - 679936 #1^2 + 2009856 #1^4 - 1317216 #1^6 + 
   141761 #1^8 &, 6]]

circmCent={0, 0, 0}

circumRad= ToRadicals[Root[6400 - 67200 #1^2 + 227760 #1^4 - 308360 #1^6 + 141761 #1^8 &, 7]]

inCent = {0, 0, 0}

inRad = 2 Sqrt[(10 (763 + 55 Sqrt[5]))/141761]
  
dihedralRules = {{1, 2} -> ArcCos[1/16 (-1 - 4 Sqrt[5])], {1, 5} -> 
  ArcCos[1/16 (-1 - 4 Sqrt[5])], {2, 3} -> 
  ArcCos[1/16 (-1 - 4 Sqrt[5])], {3, 4} -> 
  ArcCos[1/16 (-1 - 4 Sqrt[5])], {4, 5} -> 
  ArcCos[1/16 (-1 - 4 Sqrt[5])], {6, 7} -> 
  ArcCos[1/16 (-1 - 4 Sqrt[5])], {6, 10} -> 
  ArcCos[1/16 (-1 - 4 Sqrt[5])], {7, 8} -> 
  ArcCos[1/16 (-1 - 4 Sqrt[5])], {8, 9} -> 
  ArcCos[1/16 (-1 - 4 Sqrt[5])], {9, 10} -> 
  ArcCos[1/16 (-1 - 4 Sqrt[5])], {1, 6} -> 
  ArcSec[Sqrt[402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {1, 
   7} -> ArcSec[Sqrt[
   402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {2, 7} -> 
  ArcSec[Sqrt[402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {2, 
   8} -> ArcSec[Sqrt[
   402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {3, 8} -> 
  ArcSec[Sqrt[402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {3, 
   9} -> ArcSec[Sqrt[
   402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {4, 9} -> 
  ArcSec[Sqrt[402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {4, 
   10} -> 
  ArcSec[Sqrt[402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {5, 
   6} -> ArcSec[Sqrt[
   402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {5, 10} -> 
  ArcSec[Sqrt[402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]]}

netVerts = {{0.`, 
    0.`}, {0.8994564173893753`, -0.4370104726629212`}, \
{1.1054323176124483`, 0.`}, {0.8994564173893753`, 
    0.4370104726629212`}, {0.6832054725642668`, 
    0.869028705555959`}, {0.21235031542031596`, 
    0.9771936059660298`}, {-0.26093065015639133`, 
    1.0741954219931267`}, {-0.6369728708448802`, 
    0.7708862184574526`}, {-1.0057385581386615`, 
    0.45877070688438104`}, {-0.9997044470167549`, \
-0.024310874417104222`}, {-0.9822500963108509`, \
-0.5071147376278395`}, {-0.5987491869720221`, -0.8009365836945784`}, \
{2.0048887350018236`, -0.4370104726629212`}, {1.1054323176124483`, \
-0.8740209453258424`}, {1.3216832624375567`, -1.3060391782188803`}, \
{1.7925384195815077`, -1.414204078628951`}, {2.265819385158215`, \
-1.5112058946560478`}, {2.641861605846704`, -1.207896691120374`}, \
{3.010627293140485`, -0.8957811795473023`}, {3.0045931820185787`, \
-0.412699598245817`}, {2.9871388313126745`, 
    0.07010426496491834`}, {2.6036379219738457`, 
    0.36392611103165723`}}

netPolyVerts = {{1, 2, 3, 4}, {1, 4, 5, 6}, {1, 6, 7, 8}, {1, 8, 9, 
    10}, {1, 10, 11, 12}, {13, 3, 2, 14}, {13, 14, 15, 16}, {13, 16, 
    17, 18}, {13, 18, 19, 20}, {13, 20, 21, 22}}

netImg=Graphics[{RGBColor[1., 1., .85], EdgeForm[Black], 
  GraphicsComplex[netVerts, {Polygon[netPolyVerts]}]}]

graphEdges = {1 \[UndirectedEdge] 2, 2 \[UndirectedEdge] 3, 
   3 \[UndirectedEdge] 4, 1 \[UndirectedEdge] 4, 
   4 \[UndirectedEdge] 5, 5 \[UndirectedEdge] 6, 
   1 \[UndirectedEdge] 6, 6 \[UndirectedEdge] 7, 
   7 \[UndirectedEdge] 8, 1 \[UndirectedEdge] 8, 
   8 \[UndirectedEdge] 9, 9 \[UndirectedEdge] 10, 
   1 \[UndirectedEdge] 10, 10 \[UndirectedEdge] 11, 
   11 \[UndirectedEdge] 12, 3 \[UndirectedEdge] 13, 
   2 \[UndirectedEdge] 14, 13 \[UndirectedEdge] 14, 
   14 \[UndirectedEdge] 15, 15 \[UndirectedEdge] 16, 
   13 \[UndirectedEdge] 16, 16 \[UndirectedEdge] 17, 
   17 \[UndirectedEdge] 18, 13 \[UndirectedEdge] 18, 
   18 \[UndirectedEdge] 19, 19 \[UndirectedEdge] 20, 
   13 \[UndirectedEdge] 20, 20 \[UndirectedEdge] 21, 
   21 \[UndirectedEdge] 22, 1 \[UndirectedEdge] 12, 
   13 \[UndirectedEdge] 22}
   
 netGrph=Graph[graphEdges, VertexCoordinates -> netVerts]


skelPts = {{0, 1/2}, {0, 2}, {1/Sqrt[2], 1/Sqrt[
    2]}, {14/15 Sin[(3 \[Pi])/16], 
    14/15 Cos[(3 \[Pi])/16]}, {Sin[\[Pi]/8], 
    Cos[\[Pi]/8]}, {14/15 Sin[\[Pi]/16], 14/15 Cos[\[Pi]/16]}, {0, 
    1}, {-(14/15) Sin[\[Pi]/16], 14/15 Cos[\[Pi]/16]}, {-Sin[\[Pi]/8],
     Cos[\[Pi]/8]}, {-(14/15) Sin[(3 \[Pi])/16], 
    14/15 Cos[(3 \[Pi])/16]}, {-(1/Sqrt[2]), 1/Sqrt[2]}, {0, -(1/4)}}

skelEdges = {1 \[UndirectedEdge] 4, 1 \[UndirectedEdge] 6, 
   1 \[UndirectedEdge] 8, 1 \[UndirectedEdge] 10, 
   1 \[UndirectedEdge] 12, 2 \[UndirectedEdge] 3, 
   2 \[UndirectedEdge] 5, 2 \[UndirectedEdge] 7, 
   2 \[UndirectedEdge] 9, 2 \[UndirectedEdge] 11, 
   3 \[UndirectedEdge] 4, 3 \[UndirectedEdge] 12, 
   4 \[UndirectedEdge] 5, 5 \[UndirectedEdge] 6, 
   6 \[UndirectedEdge] 7, 7 \[UndirectedEdge] 8, 
   8 \[UndirectedEdge] 9, 9 \[UndirectedEdge] 10, 
   10 \[UndirectedEdge] 11, 11 \[UndirectedEdge] 12}
   
skelGrph= Graph[Range[12], skelEdges, VertexCoordinates -> skelPts]


diahedAngs = {{1, 2} -> ArcCos[1/16 (-1 - 4 Sqrt[5])], {1, 5} -> 
    ArcCos[1/16 (-1 - 4 Sqrt[5])], {2, 3} -> 
    ArcCos[1/16 (-1 - 4 Sqrt[5])], {3, 4} -> 
    ArcCos[1/16 (-1 - 4 Sqrt[5])], {4, 5} -> 
    ArcCos[1/16 (-1 - 4 Sqrt[5])], {6, 7} -> 
    ArcCos[1/16 (-1 - 4 Sqrt[5])], {6, 10} -> 
    ArcCos[1/16 (-1 - 4 Sqrt[5])], {7, 8} -> 
    ArcCos[1/16 (-1 - 4 Sqrt[5])], {8, 9} -> 
    ArcCos[1/16 (-1 - 4 Sqrt[5])], {9, 10} -> 
    ArcCos[1/16 (-1 - 4 Sqrt[5])], {1, 6} -> 
    ArcSec[Sqrt[
     402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {1, 7} -> 
    ArcSec[Sqrt[
     402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {2, 7} -> 
    ArcSec[Sqrt[
     402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {2, 8} -> 
    ArcSec[Sqrt[
     402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {3, 8} -> 
    ArcSec[Sqrt[
     402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {3, 9} -> 
    ArcSec[Sqrt[
     402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {4, 9} -> 
    ArcSec[Sqrt[
     402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {4, 10} -> 
    ArcSec[Sqrt[
     402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {5, 6} -> 
    ArcSec[Sqrt[
     402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]], {5, 10} -> 
    ArcSec[Sqrt[402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]]}
    
TenSidedDie["Properties"] = propLis
    
TenSidedDie[] = polyImg

TenSidedDie["AdjacentFaceIndices"] = {{1, 2}, {1, 5}, {2, 3}, {3, 4}, {4, 5}, {6, 7}, {6, 10}, {7, 8}, {8, 
  9}, {9, 10}, {1, 6}, {1, 7}, {2, 7}, {2, 8}, {3, 8}, {3, 9}, {4, 
  9}, {4, 10}, {5, 6}, {5, 10}}
  
TenSidedDie["Centroid"] = {0,0,0}

TenSidedDie["Circumcenter"]= circumCent

TenSidedDie["Circumradius"] = circumRad

TenSidedDie["Circumsphere"] = Sphere[circmCent,circumRad]

TenSidedDie["Concave"] = False

TenSidedDie["Convex"] = True

TenSidedDie["DihedralAngleRules"] = dihedralRules

TenSidedDie["DihedralAngles"] = {ArcCos[1/16 (-1 - 4 Sqrt[5])], ArcSec[Sqrt[402 + 176 Sqrt[5] + 4 Sqrt[19730 + 8822 Sqrt[5]]]]}

TenSidedDie["DualName"] = "pentagonal antiprism" 

TenSidedDie["EdgeCount"]= edgCnt

TenSidedDie["EdgeIndices"] = edgLis

TenSidedDie["EdgeLengths"] = {lngEdgeLen,shrtEdgeLen}

TenSidedDie["Edges"] = GraphicsComplex[vertCoords,Line[edgLis]]

TenSidedDie["FaceCount"] = 10

TenSidedDie["FaceCountRules"] = {4-> 10}

TenSidedDie["FaceIndices"] = polyLis

TenSidedDie["Faces"] = GraphicsComplex[vertCoords,Polygon[polyLis]]

TenSidedDie["GeneralizedDiameter"] = 2 circumRad

TenSidedDie["Image"] = TenSidedDie[]

TenSidedDie["Incenter"] = inCent

TenSidedDie["Inradius"] = inRad

TenSidedDie["Insphere"] = Sphere[inCent,inRad]

TenSidedDie["Name"] = " "

TenSidedDie["NetCoordinates"] = netVerts

TenSidedDie["NetEdgeIndices"] = {{1, 2}, {2, 3}, {3, 4}, {1, 4}, {4, 5}, {5, 6}, {1, 6}, {6, 7}, {7, 
  8}, {1, 8}, {8, 9}, {9, 10}, {1, 10}, {10, 11}, {11, 12}, {3, 
  13}, {2, 14}, {13, 14}, {14, 15}, {15, 16}, {13, 16}, {16, 17}, {17,
   18}, {13, 18}, {18, 19}, {19, 20}, {13, 20}, {20, 21}, {21, 
  22}, {1, 12}, {13, 22}}
  
TenSidedDie["NetEdges"] = GraphicsComplex[netVerts,Line[graphEdges/.UndirectedEdge-> List]]  

TenSidedDie["NetFaceIndices"] = netPolyVerts

TenSidedDie["NetFaces"] = GraphicsComplex[netVerts,Polygon[netPolyVerts]]

TenSidedDie["NetGraph"] = netGrph

TenSidedDie["NetImage"] = netImg

TenSidedDie["Platonic"] = False

TenSidedDie["SkeletonCoordinates"] = skelPts

TenSidedDie["SkeletonGraph"] = skelGrph

TenSidedDie["SkeletonImage"] = Graphics[GraphicsComplex[skelPts,Line[skelEdges/.UndirectedEdge-> List]]]

TenSidedDie["SkeletonRules"] = skelEdges/. UndirectedEdge-> Rule

TenSidedDie["StandardName"] = "pentagonal trapezohedron"

TenSidedDie["StandardNames"] = {"pentagonal trapezohedron","deltohedron"}

TenSidedDie["SurfaceArea"] = ToRadicals[5 Root[22681760000 - 254802672000 #1^2 + 620482388400 #1^4 - 
    418946320280 #1^6 + 20096181121 #1^8 &, 7]]
         
TenSidedDie["VertexCoordinates"] = vertCoords

TenSidedDie["VertexCount"]= vertCnt

TenSidedDie["VertexIndices"]= Range[12]

TenSidedDie["Volume"] = (10/3)*Sqrt[(10*(763 + 55*Sqrt[5]))/141761]*
   ToRadicals[Root[22681760000 - 254802672000*#1^2 + 
         620482388400*#1^4 - 418946320280*#1^6 + 
         20096181121*#1^8 & , 7]]
         
TenSidedDie[str_String/;MemberQ[altLis,str]] := Missing["NotAvailable"]

TenSidedDie[__String]/;Message[TenSidedDie::notdef]:=Null

End[]