(* Content-type: application/mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 7.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       145,          7]
NotebookDataLength[     29189,        811]
NotebookOptionsPosition[     28109,        770]
NotebookOutlinePosition[     28598,        789]
CellTagsIndexPosition[     28555,        786]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Load package for FunctionTable", "Subsection",
 CellChangeTimes->{{3.480095875757674*^9, 3.4800958797573853`*^9}}],

Cell[BoxData[
 RowBox[{"<<", "ClassroomUtilities`"}]], "Input",
 CellChangeTimes->{{3.4800938422451067`*^9, 3.4800938467020493`*^9}, {
  3.510389593441352*^9, 3.510389599122508*^9}}]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create exercises", "Subsection",
 CellChangeTimes->{{3.480095883909988*^9, 3.480095889517783*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"tables", "=", 
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"FunctionTable", "[", 
      RowBox[{
       RowBox[{"x", "^", "2"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"-", "2"}], ",", "6"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "4", ",", "6", ",", "8"}], "}"}]}], "]"}], ",", " ",
      "\[IndentingNewLine]", 
     RowBox[{"FunctionTable", "[", 
      RowBox[{
       RowBox[{
        SuperscriptBox["x", "2"], "+", " ", "1"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", "2"}], ",", 
           RowBox[{"-", "1"}], ",", "0", ",", "2", ",", "4", ",", "6", ",", 
           "8", ",", "10", ",", "100"}], "}"}]}], "}"}], ",", 
       RowBox[{"FunctionValues", "\[Rule]", " ", "Exact"}], ",", 
       RowBox[{"TableHeadings", "\[Rule]", " ", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{"\"\<\[ScriptX]\>\"", ",", "14", ",", "Bold"}], "]"}], ",",
           "None"}], "}"}]}]}], "]"}], ",", 
     RowBox[{"FunctionTable", "[", 
      RowBox[{
       RowBox[{"Cos", "[", "\[Theta]", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"\[Theta]", ",", "0", ",", 
         RowBox[{"2", " ", "\[Pi]"}], ",", 
         RowBox[{"\[Pi]", "/", "3"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "4", ",", "5"}], "}"}], ",", 
       RowBox[{"FunctionValues", "\[Rule]", "Exact"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"FunctionTable", "[", 
      RowBox[{
       RowBox[{"Sin", "[", 
        RowBox[{"2", " ", "x"}], "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", 
         RowBox[{"2", "\[Pi]"}], ",", 
         RowBox[{"\[Pi]", "/", "3"}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"2", ",", "4", ",", "6"}], "}"}], ",", 
       RowBox[{"FunctionValues", "\[Rule]", "Exact"}]}], "]"}], " ", ",", 
     "\[IndentingNewLine]", 
     RowBox[{"FunctionTable", "[", 
      RowBox[{
       RowBox[{"Log", "[", "x", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "1", ",", "8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "3", ",", "7"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "4", ",", "5"}], "}"}]}], "}"}]}], "]"}], ",", 
     "\[IndentingNewLine]", 
     RowBox[{"FunctionTable", "[", 
      RowBox[{
       RowBox[{"Exp", "[", "x", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0", ",", "8"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", "3", ",", "7"}], "}"}], ",", 
         RowBox[{"{", 
          RowBox[{"2", ",", "4", ",", "5", ",", "8"}], "}"}]}], "}"}]}], 
      "]"}]}], "\[IndentingNewLine]", "}"}]}], ";"}]], "Input",
 CellChangeTimes->{
  3.480093837348415*^9, {3.480093885804961*^9, 3.4800938926206303`*^9}, {
   3.480093925338031*^9, 3.480093934422073*^9}, {3.480094012674594*^9, 
   3.480094018016843*^9}, {3.480094461416939*^9, 3.480094471751038*^9}, 
   3.4800951172136087`*^9, {3.480095178758692*^9, 3.480095369965522*^9}, {
   3.480095416823147*^9, 3.4800954608241177`*^9}, {3.480096370509156*^9, 
   3.480096384603755*^9}, {3.480096486894155*^9, 3.48009661158265*^9}, {
   3.480096646916485*^9, 3.480096666760317*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Prototype", "Subsection",
 CellChangeTimes->{{3.480095855726553*^9, 3.480095856924748*^9}}],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"partitionedTable", "=", 
  RowBox[{"Partition", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"MapIndexed", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"Column", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"Style", "[", 
           RowBox[{
            RowBox[{"StringForm", "[", 
             RowBox[{"\"\<Exercise `1`.\>\"", ",", 
              RowBox[{"First", "[", "#2", "]"}]}], "]"}], ",", 
            "\"\<Subsection\>\""}], "]"}], ",", "#1"}], "}"}], "]"}], "&"}], 
      ",", "tables"}], "]"}], ",", "2"}], "]"}]}]], "Input",
 CellChangeTimes->{{3.480094162310913*^9, 3.4800943373916616`*^9}, {
  3.4800943814495087`*^9, 3.48009438725382*^9}, {3.480094478725102*^9, 
  3.4800946271769123`*^9}, {3.480095022870082*^9, 3.4800950271901417`*^9}}],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     TagBox[GridBox[{
        {
         StyleBox[
          InterpretationBox["\<\"Exercise \\!\\(1\\).\"\>",
           StringForm["Exercise `1`.", 1],
           Editable->False], "Subsection",
          StripOnInput->False]},
        {
         TagBox[GridBox[{
            {
             ItemBox[
              TagBox[
               FormBox["x",
                TraditionalForm],
               TraditionalForm,
               Editable->True],
              Alignment->Center,
              BaseStyle->{FontWeight -> "Bold"},
              StripOnInput->False], 
             ItemBox[
              
              InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`\\\"\
\\\\[ScriptF]\\\"\\), TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`x\\^2\\), \
TraditionalForm, Rule[Editable, True]]\\)\"\>",
               StringForm["`3`(`2`) = `1`", 
                TraditionalForm[$CellContext`x^2], 
                TraditionalForm[$CellContext`x], 
                TraditionalForm["\[ScriptF]"]],
               Editable->False],
              Alignment->Center,
              BaseStyle->{FontWeight -> "Bold"},
              StripOnInput->False]},
            {
             RowBox[{"-", "2"}], 
             TagBox[
              InterpretationBox["\<\"4.\"\>",
               4.,
               AutoDelete->True],
              NumberForm[#, 5]& ]},
            {
             RowBox[{"-", "1"}], "\<\"   \"\>"},
            {"0", 
             TagBox[
              InterpretationBox["\<\"0.\"\>",
               0.,
               AutoDelete->True],
              NumberForm[#, 5]& ]},
            {"1", "\<\"   \"\>"},
            {"2", 
             TagBox[
              InterpretationBox["\<\"4.\"\>",
               4.,
               AutoDelete->True],
              NumberForm[#, 5]& ]},
            {"3", "\<\"   \"\>"},
            {"4", 
             TagBox[
              InterpretationBox["\<\"16.\"\>",
               16.,
               AutoDelete->True],
              NumberForm[#, 5]& ]},
            {"5", "\<\"   \"\>"},
            {"6", 
             TagBox[
              InterpretationBox["\<\"36.\"\>",
               36.,
               AutoDelete->True],
              NumberForm[#, 5]& ]}
           },
           AutoDelete->False,
           BaseStyle->{"Menu"},
           
           GridBoxAlignment->{
            "Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
           GridBoxBackground->{"Columns" -> {{
                RGBColor[1, 1, 0.85]}}},
           GridBoxDividers->{"Columns" -> {
               AbsoluteThickness[1.5], None, 
               AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
             "RowsIndexed" -> {2 -> Directive[
                 AbsoluteThickness[1.5]], 1 -> Directive[
                 AbsoluteThickness[1.5]], -1 -> Directive[
                 AbsoluteThickness[1.5]]}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
           GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
          "Grid"]}
       },
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"], ",", 
     TagBox[GridBox[{
        {
         StyleBox[
          InterpretationBox["\<\"Exercise \\!\\(2\\).\"\>",
           StringForm["Exercise `1`.", 2],
           Editable->False], "Subsection",
          StripOnInput->False]},
        {
         TagBox[GridBox[{
            {
             StyleBox["\<\"\[ScriptX]\"\>",
              StripOnInput->False,
              FontSize->14,
              FontWeight->Bold], "\<\"            \"\>"},
            {
             RowBox[{"-", "2"}], "5"},
            {
             RowBox[{"-", "1"}], "2"},
            {"0", "1"},
            {"2", "5"},
            {"4", "17"},
            {"6", "37"},
            {"8", "65"},
            {"10", "101"},
            {"100", "10001"}
           },
           AutoDelete->False,
           BaseStyle->{"Menu"},
           
           GridBoxAlignment->{
            "Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
           GridBoxBackground->{"Columns" -> {{
                RGBColor[1, 1, 0.85]}}},
           GridBoxDividers->{"Columns" -> {
               AbsoluteThickness[1.5], None, 
               AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
             "RowsIndexed" -> {2 -> Directive[
                 AbsoluteThickness[1.5]], 1 -> Directive[
                 AbsoluteThickness[1.5]], -1 -> Directive[
                 AbsoluteThickness[1.5]]}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
           GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
          "Grid"]}
       },
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[GridBox[{
        {
         StyleBox[
          InterpretationBox["\<\"Exercise \\!\\(3\\).\"\>",
           StringForm["Exercise `1`.", 3],
           Editable->False], "Subsection",
          StripOnInput->False]},
        {
         TagBox[GridBox[{
            {
             ItemBox[
              TagBox[
               FormBox["\[Theta]",
                TraditionalForm],
               TraditionalForm,
               Editable->True],
              Alignment->Center,
              BaseStyle->{FontWeight -> "Bold"},
              StripOnInput->False], 
             ItemBox[
              
              InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`\\\"\
\\\\[ScriptF]\\\"\\), TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`\[Theta]\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`\\(cos(\
\[Theta])\\)\\), TraditionalForm, Rule[Editable, True]]\\)\"\>",
               StringForm["`3`(`2`) = `1`", 
                TraditionalForm[
                 Cos[$CellContext`\[Theta]]], 
                TraditionalForm[$CellContext`\[Theta]], 
                TraditionalForm["\[ScriptF]"]],
               Editable->False],
              Alignment->Center,
              BaseStyle->{FontWeight -> "Bold"},
              StripOnInput->False]},
            {"0", "1"},
            {
             FractionBox["\[Pi]", "3"], "\<\"   \"\>"},
            {
             FractionBox[
              RowBox[{"2", " ", "\[Pi]"}], "3"], 
             RowBox[{"-", 
              FractionBox["1", "2"]}]},
            {"\[Pi]", "\<\"   \"\>"},
            {
             FractionBox[
              RowBox[{"4", " ", "\[Pi]"}], "3"], "\<\"   \"\>"},
            {
             FractionBox[
              RowBox[{"5", " ", "\[Pi]"}], "3"], 
             FractionBox["1", "2"]},
            {
             RowBox[{"2", " ", "\[Pi]"}], "1"}
           },
           AutoDelete->False,
           BaseStyle->{"Menu"},
           
           GridBoxAlignment->{
            "Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
           GridBoxBackground->{"Columns" -> {{
                RGBColor[1, 1, 0.85]}}},
           GridBoxDividers->{"Columns" -> {
               AbsoluteThickness[1.5], None, 
               AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
             "RowsIndexed" -> {2 -> Directive[
                 AbsoluteThickness[1.5]], 1 -> Directive[
                 AbsoluteThickness[1.5]], -1 -> Directive[
                 AbsoluteThickness[1.5]]}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
           GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
          "Grid"]}
       },
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"], ",", 
     TagBox[GridBox[{
        {
         StyleBox[
          InterpretationBox["\<\"Exercise \\!\\(4\\).\"\>",
           StringForm["Exercise `1`.", 4],
           Editable->False], "Subsection",
          StripOnInput->False]},
        {
         TagBox[GridBox[{
            {
             ItemBox[
              TagBox[
               FormBox["x",
                TraditionalForm],
               TraditionalForm,
               Editable->True],
              Alignment->Center,
              BaseStyle->{FontWeight -> "Bold"},
              StripOnInput->False], 
             ItemBox[
              
              InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`\\\"\
\\\\[ScriptF]\\\"\\), TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \
\\!\\(\\*TagBox[\\(TraditionalForm\\`\\(sin(\\(\\(2\\\\ x\\)\\))\\)\\), \
TraditionalForm, Rule[Editable, True]]\\)\"\>",
               StringForm["`3`(`2`) = `1`", 
                TraditionalForm[
                 Sin[2 $CellContext`x]], 
                TraditionalForm[$CellContext`x], 
                TraditionalForm["\[ScriptF]"]],
               Editable->False],
              Alignment->Center,
              BaseStyle->{FontWeight -> "Bold"},
              StripOnInput->False]},
            {"0", "0"},
            {
             FractionBox["\[Pi]", "3"], "\<\"   \"\>"},
            {
             FractionBox[
              RowBox[{"2", " ", "\[Pi]"}], "3"], 
             RowBox[{"-", 
              FractionBox[
               SqrtBox["3"], "2"]}]},
            {"\[Pi]", "\<\"   \"\>"},
            {
             FractionBox[
              RowBox[{"4", " ", "\[Pi]"}], "3"], 
             FractionBox[
              SqrtBox["3"], "2"]},
            {
             FractionBox[
              RowBox[{"5", " ", "\[Pi]"}], "3"], "\<\"   \"\>"},
            {
             RowBox[{"2", " ", "\[Pi]"}], "0"}
           },
           AutoDelete->False,
           BaseStyle->{"Menu"},
           
           GridBoxAlignment->{
            "Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
           GridBoxBackground->{"Columns" -> {{
                RGBColor[1, 1, 0.85]}}},
           GridBoxDividers->{"Columns" -> {
               AbsoluteThickness[1.5], None, 
               AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
             "RowsIndexed" -> {2 -> Directive[
                 AbsoluteThickness[1.5]], 1 -> Directive[
                 AbsoluteThickness[1.5]], -1 -> Directive[
                 AbsoluteThickness[1.5]]}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
           GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
          "Grid"]}
       },
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     TagBox[GridBox[{
        {
         StyleBox[
          InterpretationBox["\<\"Exercise \\!\\(5\\).\"\>",
           StringForm["Exercise `1`.", 5],
           Editable->False], "Subsection",
          StripOnInput->False]},
        {
         TagBox[GridBox[{
            {
             ItemBox[
              TagBox[
               FormBox["x",
                TraditionalForm],
               TraditionalForm,
               Editable->True],
              Alignment->Center,
              BaseStyle->{FontWeight -> "Bold"},
              StripOnInput->False], 
             ItemBox[
              
              InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`\\\"\
\\\\[ScriptF]\\\"\\), TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`\\(log(x)\\)\
\\), TraditionalForm, Rule[Editable, True]]\\)\"\>",
               StringForm["`3`(`2`) = `1`", 
                TraditionalForm[
                 Log[$CellContext`x]], 
                TraditionalForm[$CellContext`x], 
                TraditionalForm["\[ScriptF]"]],
               Editable->False],
              Alignment->Center,
              BaseStyle->{FontWeight -> "Bold"},
              StripOnInput->False]},
            {"\<\"   \"\>", 
             TagBox[
              InterpretationBox["\<\"0.\"\>",
               0.,
               AutoDelete->True],
              NumberForm[#, 5]& ]},
            {"2", "\<\"   \"\>"},
            {"\<\"   \"\>", 
             TagBox[
              InterpretationBox["\<\"1.0986\"\>",
               1.0986122886681098`,
               AutoDelete->True],
              NumberForm[#, 5]& ]},
            {"4", "\<\"   \"\>"},
            {"5", "\<\"   \"\>"},
            {"6", 
             TagBox[
              InterpretationBox["\<\"1.7918\"\>",
               1.791759469228055,
               AutoDelete->True],
              NumberForm[#, 5]& ]},
            {"\<\"   \"\>", 
             TagBox[
              InterpretationBox["\<\"1.9459\"\>",
               1.9459101490553132`,
               AutoDelete->True],
              NumberForm[#, 5]& ]},
            {"8", 
             TagBox[
              InterpretationBox["\<\"2.0794\"\>",
               2.0794415416798357`,
               AutoDelete->True],
              NumberForm[#, 5]& ]}
           },
           AutoDelete->False,
           BaseStyle->{"Menu"},
           
           GridBoxAlignment->{
            "Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
           GridBoxBackground->{"Columns" -> {{
                RGBColor[1, 1, 0.85]}}},
           GridBoxDividers->{"Columns" -> {
               AbsoluteThickness[1.5], None, 
               AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
             "RowsIndexed" -> {2 -> Directive[
                 AbsoluteThickness[1.5]], 1 -> Directive[
                 AbsoluteThickness[1.5]], -1 -> Directive[
                 AbsoluteThickness[1.5]]}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
           GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
          "Grid"]}
       },
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"], ",", 
     TagBox[GridBox[{
        {
         StyleBox[
          InterpretationBox["\<\"Exercise \\!\\(6\\).\"\>",
           StringForm["Exercise `1`.", 6],
           Editable->False], "Subsection",
          StripOnInput->False]},
        {
         TagBox[GridBox[{
            {
             ItemBox[
              TagBox[
               FormBox["x",
                TraditionalForm],
               TraditionalForm,
               Editable->True],
              Alignment->Center,
              BaseStyle->{FontWeight -> "Bold"},
              StripOnInput->False], 
             ItemBox[
              
              InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`\\\"\
\\\\[ScriptF]\\\"\\), TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`\
\[ExponentialE]\\^x\\), TraditionalForm, Rule[Editable, True]]\\)\"\>",
               StringForm["`3`(`2`) = `1`", 
                TraditionalForm[E^$CellContext`x], 
                TraditionalForm[$CellContext`x], 
                TraditionalForm["\[ScriptF]"]],
               Editable->False],
              Alignment->Center,
              BaseStyle->{FontWeight -> "Bold"},
              StripOnInput->False]},
            {"\<\"   \"\>", 
             TagBox[
              InterpretationBox["\<\"1.\"\>",
               1.,
               AutoDelete->True],
              NumberForm[#, 5]& ]},
            {"1", "\<\"   \"\>"},
            {"\<\"   \"\>", 
             TagBox[
              InterpretationBox["\<\"7.3891\"\>",
               7.38905609893065,
               AutoDelete->True],
              NumberForm[#, 5]& ]},
            {"3", "\<\"   \"\>"},
            {"4", "\<\"   \"\>"},
            {"5", 
             TagBox[
              InterpretationBox["\<\"148.41\"\>",
               148.4131591025766,
               AutoDelete->True],
              NumberForm[#, 5]& ]},
            {"\<\"   \"\>", 
             TagBox[
              InterpretationBox["\<\"403.43\"\>",
               403.4287934927351,
               AutoDelete->True],
              NumberForm[#, 5]& ]},
            {"7", "\<\"   \"\>"},
            {"8", 
             TagBox[
              InterpretationBox["\<\"2981.\"\>",
               2980.9579870417283`,
               AutoDelete->True],
              NumberForm[#, 5]& ]}
           },
           AutoDelete->False,
           BaseStyle->{"Menu"},
           
           GridBoxAlignment->{
            "Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
           GridBoxBackground->{"Columns" -> {{
                RGBColor[1, 1, 0.85]}}},
           GridBoxDividers->{"Columns" -> {
               AbsoluteThickness[1.5], None, 
               AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
             "RowsIndexed" -> {2 -> Directive[
                 AbsoluteThickness[1.5]], 1 -> Directive[
                 AbsoluteThickness[1.5]], -1 -> Directive[
                 AbsoluteThickness[1.5]]}},
           
           GridBoxItemSize->{
            "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
           GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
          "Grid"]}
       },
       GridBoxAlignment->{"Columns" -> {{Left}}},
       GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
      "Column"]}], "}"}]}], "}"}]], "Output"]
}, Open  ]],

Cell[BoxData[
 RowBox[{"CreateDocument", "[", 
  RowBox[{
   RowBox[{"{", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"TextCell", "[", 
      RowBox[{
      "\"\<Name____________________________             Hour_______\>\"", 
       ",", "\"\<Subsection\>\""}], "]"}], ",", 
     RowBox[{"TextCell", "[", 
      RowBox[{
      "\"\<Fill in the blanks in each table\>\"", ",", 
       "\"\<Subsubsection\>\""}], "]"}], ",", "\[IndentingNewLine]", 
     RowBox[{"TextCell", "[", 
      RowBox[{
       RowBox[{"Grid", "[", "\[IndentingNewLine]", 
        RowBox[{"partitionedTable", ",", "\[IndentingNewLine]", 
         RowBox[{"Spacings", "\[Rule]", 
          RowBox[{"{", 
           RowBox[{"12", ",", "2"}], "}"}]}]}], "]"}], ",", 
       RowBox[{"ShowStringCharacters", "\[Rule]", "False"}], ",", 
       RowBox[{"CellMargins", "\[Rule]", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"32", ",", "Inherited"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Inherited", ",", "24"}], "}"}]}], "}"}]}]}], "]"}]}], 
    "\[IndentingNewLine]", "}"}], ",", 
   RowBox[{"ShowCellLabel", "\[Rule]", " ", "False"}], ",", 
   RowBox[{"WindowTitle", "\[Rule]", " ", "\"\<Homework 4.b\>\""}]}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.480093742031056*^9, 3.4800938150723257`*^9}, {
   3.480093851195485*^9, 3.480093851873747*^9}, {3.4800939470470953`*^9, 
   3.4800939482684937`*^9}, 3.480094644102566*^9, {3.480094707313796*^9, 
   3.480094712217229*^9}, {3.480094892742332*^9, 3.480094932080381*^9}, {
   3.480094977713523*^9, 3.480094991210814*^9}, {3.4800950376931267`*^9, 
   3.480095047712933*^9}, 3.480095476423994*^9, {3.480095518120006*^9, 
   3.4800955648593893`*^9}}]
}, Closed]],

Cell[CellGroupData[{

Cell["Encapsulate", "Subsection",
 InitializationGroup->True,
 CellChangeTimes->{{3.480095867309374*^9, 3.480095868957114*^9}}],

Cell[BoxData[
 RowBox[{
  RowBox[{"CreateExerciseSheet", "[", 
   RowBox[{
   "problems_List", ",", "instructions_String", ",", "windowTitle_String"}], 
   "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", "partitionedTable", "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"partitionedTable", "=", 
      RowBox[{"Partition", "[", "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"MapIndexed", "[", 
         RowBox[{
          RowBox[{
           RowBox[{"Column", "[", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"Style", "[", 
               RowBox[{
                RowBox[{"StringForm", "[", 
                 RowBox[{"\"\<Exercise `1`.\>\"", ",", 
                  RowBox[{"First", "[", "#2", "]"}]}], "]"}], ",", 
                "\"\<Subsubsection\>\""}], "]"}], ",", "#1"}], "}"}], "]"}], 
           "&"}], ",", "problems"}], "]"}], ",", "2"}], "]"}]}], ";", 
     "\[IndentingNewLine]", 
     RowBox[{"CreateDocument", "[", 
      RowBox[{
       RowBox[{"{", "\[IndentingNewLine]", 
        RowBox[{
         RowBox[{"TextCell", "[", 
          RowBox[{
          "\"\<Name____________________________             Hour_______\>\"", 
           ",", "\"\<Subsection\>\""}], "]"}], ",", 
         RowBox[{"TextCell", "[", 
          RowBox[{"instructions", ",", "\"\<Subsubsection\>\""}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"TextCell", "[", 
          RowBox[{
           RowBox[{"Grid", "[", "\[IndentingNewLine]", 
            RowBox[{"partitionedTable", ",", "\[IndentingNewLine]", 
             RowBox[{"Spacings", "\[Rule]", 
              RowBox[{"{", 
               RowBox[{"12", ",", "2"}], "}"}]}]}], "]"}], ",", 
           RowBox[{"ShowStringCharacters", "\[Rule]", "False"}], ",", 
           RowBox[{"CellMargins", "\[Rule]", 
            RowBox[{"{", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"42", ",", "Inherited"}], "}"}], ",", 
              RowBox[{"{", 
               RowBox[{"Inherited", ",", "24"}], "}"}]}], "}"}]}]}], "]"}]}], 
        "\[IndentingNewLine]", "}"}], ",", 
       RowBox[{"ShowCellLabel", "\[Rule]", " ", "False"}], ",", 
       RowBox[{"WindowTitle", "\[Rule]", " ", "windowTitle"}]}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]], "Input",
 CellChangeTimes->{{3.480095629663136*^9, 3.4800957686752787`*^9}, {
   3.480096337631528*^9, 3.480096353022195*^9}, 3.4800966916234694`*^9}]
}, Closed]],

Cell[CellGroupData[{

Cell["Examples", "Subsection",
 CellChangeTimes->{{3.480095900070284*^9, 3.480095906862298*^9}}],

Cell[BoxData[
 RowBox[{"CreateExerciseSheet", "[", 
  RowBox[{
  "tables", ",", "\"\<Fill in the blanks in each table.\>\"", ",", 
   "\"\<Exercise 3.14\>\""}], "]"}]], "Input",
 CellChangeTimes->{{3.480095780788768*^9, 3.480095812933095*^9}, 
   3.480096150018524*^9}]
}, Closed]]
},
AutoGeneratedPackage->None,
WindowSize->{1049, 659},
WindowMargins->{{227, Automatic}, {Automatic, 101}},
Magnification:>FEPrivate`If[
  FEPrivate`Equal[FEPrivate`$VersionNumber, 6.], 1.25, 1.25 Inherited],
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (February 23, \
2011)",
StyleDefinitions->"Default.nb"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[567, 22, 120, 1, 42, "Subsection"],
Cell[690, 25, 182, 3, 33, "Input"]
}, Open  ]],
Cell[CellGroupData[{
Cell[909, 33, 104, 1, 42, "Subsection"],
Cell[1016, 36, 3406, 86, 210, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[4459, 127, 97, 1, 31, "Subsection"],
Cell[CellGroupData[{
Cell[4581, 132, 809, 19, 53, "Input"],
Cell[5393, 153, 17920, 492, 597, "Output"]
}, Open  ]],
Cell[23328, 648, 1728, 38, 150, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[25093, 691, 127, 2, 31, "Subsection",
 InitializationGroup->True],
Cell[25223, 695, 2465, 58, 227, "Input"]
}, Closed]],
Cell[CellGroupData[{
Cell[27725, 758, 96, 1, 31, "Subsection"],
Cell[27824, 761, 269, 6, 33, "Input"]
}, Closed]]
}
]
*)

(* End of internal cache information *)
