(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     43254,       1329]
NotebookOptionsPosition[     35552,       1101]
NotebookOutlinePosition[     37525,       1147]
CellTagsIndexPosition[     37482,       1144]
WindowTitle->Classroom Utilities - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES GUIDE", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Functions \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AddToRow\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/AddToRow"], \
"\<\"AugmentIdentityMatrix\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/AugmentIdentityMatrix"], \
"\<\"ChangeIndices\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/ChangeIndices"], \
"\<\"CreateAugmentedMatrix\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/CreateAugmentedMatrix"], \
"\<\"CreateEquations\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/CreateEquations"], \
"\<\"CreatePopulation\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/CreatePopulation"], "\<\"CubicBezier\"\
\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/CubicBezier"], \
"\<\"CubicBezierComponents\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/CubicBezierComponents"], "\<\"D\"\>":>
       Documentation`HelpLookup["paclet:ref/D"], "\<\"Det\"\>":>
       Documentation`HelpLookup[
       "paclet:ref/Det"], "\<\"DifferenceQuotient\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/DifferenceQuotient"], \
"\<\"DirectionFieldPlot\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/DirectionFieldPlot"], \
"\<\"Distance\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/Distance"], "\<\"DSolve\"\>":>
       Documentation`HelpLookup["paclet:ref/DSolve"], "\<\"EulerEstimate\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/EulerEstimate"], "\<\"EulerSolve\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/EulerSolve"], "\<\"FindRoot\"\>":>
       Documentation`HelpLookup[
       "paclet:ref/FindRoot"], "\<\"FiveNumberSummaryTable\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/FiveNumberSummaryTable"], \
"\<\"FunctionArrowDiagram\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/FunctionArrowDiagram"], \
"\<\"FunctionTable\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/FunctionTable"], "\<\"GetColumns\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/GetColumns"], "\<\"GetSummands\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/GetSummands"], "\<\"Integrate\"\>":>
       Documentation`HelpLookup["paclet:ref/Integrate"], "\<\"Inverse\"\>":>
       Documentation`HelpLookup[
       "paclet:ref/Inverse"], "\<\"KSeparateSamples\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/KSeparateSamples"], \
"\<\"LinearEstimate\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/LinearEstimate"], "\<\"LinearSolve\"\>":>
       Documentation`HelpLookup[
       "paclet:ref/LinearSolve"], "\<\"MakeCircle\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/MakeCircle"], "\<\"MakeColorList\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/MakeColorList"], "\<\"MakeSeries\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/MakeSeries"], "\<\"MultiplyARow\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/MultiplyARow"], "\<\"NDSolve\"\>":>
       Documentation`HelpLookup["paclet:ref/NDSolve"], "\<\"NIntegrate\"\>":>
       Documentation`HelpLookup["paclet:ref/NIntegrate"], "\<\"NullSpace\"\>":>
       Documentation`HelpLookup[
       "paclet:ref/NullSpace"], "\<\"OddRootPlot\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/OddRootPlot"], \
"\<\"PartsIntegrate\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PartsIntegrate"], \
"\<\"PerpendicularLine\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PerpendicularLine"], "\<\"PiecewisePlot\
\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PiecewisePlot"], \
"\<\"PiecewisePolarPlot\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PiecewisePolarPlot"], \
"\<\"PlotGrid\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PlotGrid"], "\<\"PointLineDistance\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PointLineDistance"], \
"\<\"PointLineSegment\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PointLineSegment"], "\<\"PointSlopeLine\
\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PointSlopeLine"], \
"\<\"PolarPlotGrid\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PolarPlotGrid"], \
"\<\"PolygonInteriorQ\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/PolygonInteriorQ"], \
"\<\"RealSolve\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/RealSolve"], "\<\"RiemannSum\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/RiemannSum"], "\<\"RiemannSum3D\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/RiemannSum3D"], \
"\<\"RiemannSumPlot\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/RiemannSumPlot"], "\<\"RiemannSumPlot3D\
\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/RiemannSumPlot3D"], "\<\"RollTheDice\"\
\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/RollTheDice"], "\<\"RowReduce\"\>":>
       Documentation`HelpLookup["paclet:ref/RowReduce"], "\<\"SecantLine\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/SecantLine"], "\<\"SecantLinePlot\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/SecantLinePlot"], "\<\"Slope\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/Slope"], "\<\"Solve\"\>":>
       Documentation`HelpLookup["paclet:ref/Solve"], "\<\"SRSChart\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/SRSChart"], "\<\"SubstituteIntegrate\"\
\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/SubstituteIntegrate"], \
"\<\"SwitchRows\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/SwitchRows"], "\<\"TangentLine\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/TangentLine"], \
"\<\"TangentLinePlot\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/TangentLinePlot"], \
"\<\"TenSidedDie\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/TenSidedDie"], "\<\"TimeIntervalPlot\"\
\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/TimeIntervalPlot"], \
"\<\"Trajectory\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/Trajectory"], \
"\<\"TrapezoidalDistribution\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/TrapezoidalDistribution"], \
"\<\"TwoPointLine\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/TwoPointLine"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideFunction"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Calculus\"\>":>Documentation`HelpLookup[
       "paclet:ref/Calculus"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideMoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Problems in Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/ProblemsInAnalyticGeometry"], \
"\<\"Building an Understanding of Functions\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
BuildingAnUnderstandingOfFunctions"], "\<\"Using Integration Techniques \
Functions\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
UsingIntegrationTechniquesFunctions"], "\<\"Falling Body Problems\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/FallingBodyProblems"], "\<\"Series \
Solutions of ODEs\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/SeriesSolutionsOfODEs"], \
"\<\"Visualizing Statistical Concepts\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"], \
"\<\"Working with Riemann Sums\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/WorkingWithRiemannSums"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideTutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/guide/ClassroomUtilities\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/guide/ClassroomUtilities"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
guide/ClassroomUtilities.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/guide/ClassroomUtilities", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["Classroom Utilities", "GuideTitle",
 CellID->942062912],

Cell[TextData[{
 "The functions described here are defined in a set of packages developed for \
use in teaching mathematics at the high school and community college level. \
They extend the standard functions of calculus and linear algebra built in to \
",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 " in a way that forces students to think about the steps needed to solve a \
problem and help develop a clearer understanding of the processes of \
mathematics."
}], "GuideAbstract",
 CellID->2001916300],

Cell[CellGroupData[{

Cell[TextData[{
 ButtonBox["Analytic Geometry",
  BaseStyle->{"Link", "GuideFunctionsSubsection"},
  ButtonData->"paclet:ClassroomUtilities/guide/AnalyticGeometry"],
 " \[RightGuillemet]"
}], "GuideFunctionsSubsection",
 CellID->2118385067],

Cell[TextData[{
 Cell[TextData[ButtonBox["Distance",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/Distance"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " ",
 "find the Euclidean distance between two points"
}], "GuideText",
 CellID->974120541],

Cell[TextData[{
 Cell[TextData[ButtonBox["Slope",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/Slope"]], "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " ",
 "find the slope of a line passing through two points"
}], "GuideText",
 CellID->1776091506],

Cell[TextData[{
 Cell[TextData[ButtonBox["MakeCircle",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/MakeCircle"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " create an expression for a circle given the radius and center"
}], "GuideText",
 CellID->1363329760],

Cell[TextData[{
 Cell[TextData[ButtonBox["PointSlopeLine",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/PointSlopeLine"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " construct a slope-intercept expression given a point and slope"
}], "GuideText",
 CellID->1980246477],

Cell[TextData[{
 Cell[TextData[ButtonBox["TwoPointLine",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/TwoPointLine"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " construct the slope-intercept form of the line containing two points"
}], "GuideText",
 CellID->824530996],

Cell[TextData[{
 Cell[TextData[ButtonBox["PerpendicularLine",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/PerpendicularLine"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " construct and expression for a line perpendicular to a given line"
}], "GuideText",
 CellID->1931928580],

Cell[TextData[{
 Cell[TextData[ButtonBox["PointLineSegment",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/PointLineSegment"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " find the shortest line from a given point to a line"
}], "GuideText",
 CellID->1208769846],

Cell[TextData[{
 Cell[TextData[ButtonBox["PointLineDistance",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/PointLineDistance"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " find the shortest distance from a given point to a line"
}], "GuideText",
 CellID->116067096],

Cell[TextData[{
 Cell[TextData[ButtonBox["SecantLine",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/SecantLine"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " construct the expression for a line passing through two points on a curve"
}], "GuideText",
 CellID->180475681],

Cell[TextData[{
 Cell[TextData[ButtonBox["SecantLinePlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/SecantLinePlot"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " visualize a secant line with a curve"
}], "GuideText",
 CellID->1007861003],

Cell[TextData[{
 Cell[TextData[ButtonBox["TangentLine",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/TangentLine"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " construct an expression for a tangent to a curve"
}], "GuideText",
 CellID->1916353532],

Cell[TextData[{
 Cell[TextData[ButtonBox["TangentLinePlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/TangentLinePlot"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " visualize a tangent to a curve"
}], "GuideText",
 CellID->194074618],

Cell[TextData[{
 StyleBox[ButtonBox["PolygonInteriorQ",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/PolygonInteriorQ"],
  FontWeight->"Bold"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " find if a point is iterior to a polygon"
}], "GuideText",
 CellID->1849714656],

Cell["\t", "GuideDelimiterSubsection",
 CellID->566437456]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[{
 ButtonBox["Matrix Operations",
  BaseStyle->{"Link", "GuideFunctionsSubsection"},
  ButtonData->"paclet:ClassroomUtilities/guide/MatrixOperations"],
 " \[RightGuillemet]"
}], "GuideFunctionsSubsection",
 CellID->1446971400],

Cell[TextData[{
 Cell[TextData[ButtonBox["AddToRow",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/AddToRow"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " add a multiple of one row to another"
}], "GuideText",
 CellID->2139084322],

Cell[TextData[{
 Cell[TextData[ButtonBox["AugmentIdentityMatrix",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/AugmentIdentityMatrix"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " augment a square matrix with an identity matrix"
}], "GuideText",
 CellID->1984484197],

Cell[TextData[{
 Cell[TextData[ButtonBox["CreateAugmentedMatrix",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/CreateAugmentedMatrix"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " create an augmented matrix from a system of equations"
}], "GuideText",
 CellID->566465427],

Cell[TextData[{
 Cell[TextData[ButtonBox["CreateEquations",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/CreateEquations"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " create a list of equations from a matrix and a list of variables"
}], "GuideText",
 CellID->702558300],

Cell[TextData[{
 Cell[TextData[ButtonBox["GetColumns",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/GetColumns"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " extract columns from a matrix"
}], "GuideText",
 CellID->1032256894],

Cell[TextData[{
 Cell[TextData[ButtonBox["MultiplyARow",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/MultiplyARow"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " multiply a row in a matrix by a given value"
}], "GuideText",
 CellID->1768716992],

Cell[TextData[{
 Cell[TextData[ButtonBox["SwitchRows",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/SwitchRows"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " switch two rows in a matrix"
}], "GuideText",
 CellID->1357842770],

Cell["\t", "GuideDelimiterSubsection",
 CellID->1661903926]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["Understanding Functions \[RightGuillemet]",
 BaseStyle->{"Link", "GuideFunctionsSubsection"},
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], \
"GuideFunctionsSubsection",
 CellID->319315841],

Cell[TextData[{
 Cell[TextData[ButtonBox["FunctionArrowDiagram",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/FunctionArrowDiagram"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " create a function arrow diagram for functions and relations"
}], "GuideText",
 CellID->179705834],

Cell[TextData[{
 Cell[TextData[ButtonBox["FunctionTable",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/FunctionTable"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " create a table of function values"
}], "GuideText",
 CellID->953944356],

Cell[TextData[{
 Cell[TextData[ButtonBox["PlotGrid",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/PlotGrid"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " create a grid for use in plotting"
}], "GuideText",
 CellID->1977366437],

Cell[TextData[{
 Cell[TextData[ButtonBox["PolarPlotGrid",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/PolarPlotGrid"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " create a grid for plotting using polar coordinates"
}], "GuideText",
 CellID->1288269334],

Cell[TextData[{
 Cell[TextData[ButtonBox["PiecewisePlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/PiecewisePlot"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " plot a piecewise continuous function using traditional textbook \
representations"
}], "GuideText",
 CellID->479410447],

Cell[TextData[{
 Cell[TextData[ButtonBox["PiecewisePolarPlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/PiecewisePolarPlot"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " plot a piecewise continuous function in polar coordinates"
}], "GuideText",
 CellID->92739185],

Cell[TextData[{
 Cell[TextData[ButtonBox["OddRootPlot",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/OddRootPlot"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " plot expressions containing odd roots such as ",
 Cell[BoxData[
  SuperscriptBox["x", 
   FractionBox["1", "3"]]], "InlineFormula"]
}], "GuideText",
 CellID->2082535727],

Cell["\t", "GuideDelimiterSubsection",
 CellID->768614888]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["Differentiation \[RightGuillemet]",
 BaseStyle->{"Link", "GuideFunctionsSubsection"},
 ButtonData->
  "paclet:ClassroomUtilities/guide/Differentiation"]], \
"GuideFunctionsSubsection",
 CellID->1561284760],

Cell[TextData[{
 Cell[TextData[ButtonBox["TimeIntervalPlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/TimeIntervalPlot"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " visualize rate of change compared to slope"
}], "GuideText",
 CellID->410278627],

Cell[TextData[{
 Cell[TextData[ButtonBox["DifferenceQuotient",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/DifferenceQuotient"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " create a difference quotient for a function"
}], "GuideText",
 CellID->2130377119],

Cell[TextData[{
 Cell[TextData[ButtonBox["LinearEstimate",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/LinearEstimate"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " estimate the value of a function at a point near a point of known function \
value"
}], "GuideText",
 CellID->309389813],

Cell[TextData[{
 Cell[TextData[ButtonBox["DirectionFieldPlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/DirectionFieldPlot"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " plot a direction field for a differential equation"
}], "GuideText",
 CellID->856677704],

Cell[TextData[{
 Cell[TextData[ButtonBox["EulerEstimate",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/EulerEstimate"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " estimate the value of a function from its slope and given point"
}], "GuideText",
 CellID->1451801640],

Cell[TextData[{
 Cell[TextData[ButtonBox["EulerSolve",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/EulerSolve"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " approximate a solution for a differential equation using Euler's method"
}], "GuideText",
 CellID->720966266],

Cell["\t", "GuideDelimiterSubsection",
 CellID->932087504]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["Integration Techniques \[RightGuillemet]",
 BaseStyle->{"Link", "GuideFunctionsSubsection"},
 ButtonData->
  "paclet:ClassroomUtilities/guide/IntegrationTechniques"]], \
"GuideFunctionsSubsection",
 CellID->1530468709],

Cell[TextData[{
 Cell[TextData[ButtonBox["SubstituteIntegrate",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/SubstituteIntegrate"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " use substitution to convert an integrand to a recognizable form"
}], "GuideText",
 CellID->28468397],

Cell[TextData[{
 Cell[TextData[ButtonBox["PartsIntegrate",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/PartsIntegrate"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " select the parts to use integration by parts"
}], "GuideText",
 CellID->1726978745],

Cell[TextData[{
 StyleBox[ButtonBox["RiemannSumPlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/RiemannSumPlot"],
  FontWeight->"Bold"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " estimate the area under a curve using rectangles"
}], "GuideText",
 CellID->2090278010],

Cell[TextData[{
 StyleBox[ButtonBox["RiemannSum",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/RiemannSum"],
  FontWeight->"Bold"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " estimate the value of a definite integral by adding areas of rectangles"
}], "GuideText",
 CellID->617532797],

Cell[TextData[{
 Cell[TextData[ButtonBox["RiemannSumPlot3D",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/RiemannSumPlot3D"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " estimate the volume of a solid of revolution with shells and washers"
}], "GuideText",
 CellID->1122575509],

Cell[TextData[{
 Cell[TextData[ButtonBox["RiemannSum3D",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/RiemannSum3D"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " give the numerical estimate of the volume of revolution"
}], "GuideText",
 CellID->1695559320],

Cell["\t", "GuideDelimiterSubsection",
 CellID->1379494588]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["Calculus Applications \[RightGuillemet]",
 BaseStyle->{"Link", "GuideFunctionsSubsection"},
 ButtonData->
  "paclet:ClassroomUtilities/guide/CalculusApplications"]], \
"GuideFunctionsSubsection",
 CellID->1741838220],

Cell[TextData[{
 Cell[TextData[ButtonBox["RealSolve",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/RealSolve"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " returns only real valued solution when using ",
 ButtonBox["Solve",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Solve"]
}], "GuideText",
 CellID->997189376],

Cell[TextData[{
 Cell[TextData[ButtonBox["Trajectory",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/Trajectory"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " model trajectories subject to air resistance"
}], "GuideText",
 CellID->799461244],

Cell[TextData[{
 Cell[TextData[ButtonBox["CubicBezier",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/CubicBezier"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " create a parametric representation for a cubic Bezier curve"
}], "GuideText",
 CellID->1887432276],

Cell[TextData[{
 Cell[TextData[ButtonBox["CubicBezierComponents",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/CubicBezierComponents"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " get the components of a cubic Bezier representation"
}], "GuideText",
 CellID->1593312895],

Cell[TextData[{
 Cell[TextData[ButtonBox["MakeSeries",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/MakeSeries"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " create a symbolic Taylor series with its derivatives"
}], "GuideText",
 CellID->1836231822],

Cell[TextData[{
 Cell[TextData[ButtonBox["ChangeIndices",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/ChangeIndices"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " change the index set for a Taylor series"
}], "GuideText",
 CellID->60741317],

Cell[TextData[{
 Cell[TextData[ButtonBox["GetSummands",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/GetSummands"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " get the general term from a sum of Taylor series"
}], "GuideText",
 CellID->1046002567],

Cell["\t", "GuideDelimiterSubsection",
 CellID->725067038]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["Statistics \[RightGuillemet]",
 BaseStyle->{"Link", "GuideFunctionsSubsection"},
 ButtonData->
  "paclet:Classroom Utilities/guide/Statistics"]], "GuideFunctionsSubsection",
 CellID->594354735],

Cell[TextData[{
 Cell[TextData[ButtonBox["SRSChart",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/SRSChart"]], 
  "InlineFunctionSans",
  FontWeight->"Bold"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " creates a visualization of a population with a random sample"
}], "GuideText",
 CellID->1373588948],

Cell[TextData[{
 Cell[TextData[ButtonBox["CreatePopulation",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/CreatePopulation"]], 
  "InlineFunctionSans",
  FontWeight->"Bold"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " creates images to use in SRSChart"
}], "GuideText",
 CellID->460243786],

Cell[TextData[{
 Cell[TextData[ButtonBox["MakeColorList",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/MakeColorList"]], 
  "InlineFunctionSans",
  FontWeight->"Bold"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " creates a ColorList and the corresponding ColorListFunction"
}], "GuideText",
 CellID->81214808],

Cell[TextData[{
 Cell[TextData[ButtonBox["KSeparateSamples",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/KSeparateSamples"]], 
  "InlineFunctionSans",
  FontWeight->"Bold"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " generates k disjoint samples from a population"
}], "GuideText",
 CellID->1325162211],

Cell[TextData[{
 Cell[TextData[ButtonBox["FiveNumberSummaryTable",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/FiveNumberSummaryTable"]], 
  "InlineFunctionSans",
  FontWeight->"Bold"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " create a formatted table of five number summaries of data"
}], "GuideText",
 CellID->1704888336],

Cell[TextData[{
 StyleBox[ButtonBox["TrapezoidalDistribution",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/TrapezoidalDistribution"],
  FontWeight->"Bold"],
 StyleBox[" ",
  FontWeight->"Bold"],
 StyleBox["\[LongDash]", "GuideEmDash"],
 " a trapezoidal distribution"
}], "GuideText",
 CellID->183961231],

Cell[TextData[{
 StyleBox[ButtonBox["RollTheDice",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/RollTheDice"],
  FontWeight->"Bold"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " simulate rolling game dice"
}], "GuideText",
 CellID->2031179949],

Cell[TextData[{
 StyleBox[ButtonBox["TenSidedDie",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/TenSidedDie"],
  FontWeight->"Bold"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " a polyhedron in the form of a ten sided game die"
}], "GuideText",
 CellID->1641350131],

Cell["\t", "GuideDelimiter",
 CellID->1913215114],

Cell[TextData[{
 ButtonBox["D",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/D"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 ButtonBox["Integrate",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Integrate"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 ButtonBox["Solve",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Solve"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 ButtonBox["DSolve",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/DSolve"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 ButtonBox["FindRoot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/FindRoot"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 ButtonBox["NIntegrate",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/NIntegrate"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 ButtonBox["NDSolve",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/NDSolve"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 ButtonBox["RowReduce",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/RowReduce"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 ButtonBox["LinearSolve",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/LinearSolve"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 ButtonBox["Inverse",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Inverse"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 ButtonBox["NullSpace",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/NullSpace"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 ButtonBox["Det",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Det"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " "
}], "InlineGuideFunctionListing",
 CellID->1848958510]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["TUTORIALS", "GuideTutorialsSection",
 WholeCellGroupOpener->True,
 CellID->415694126],

Cell[TextData[ButtonBox["Problems in Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/ProblemsInAnalyticGeometry"]], \
"GuideTutorial",
 CellID->806871991],

Cell[TextData[ButtonBox["Building an Understanding of Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/BuildingAnUnderstandingOfFunctions"]], \
"GuideTutorial",
 CellID->864009227],

Cell[TextData[ButtonBox["Using Integration Techniques Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/UsingIntegrationTechniquesFunctions"]], \
"GuideTutorial",
 CellID->1406315809],

Cell[TextData[ButtonBox["Falling Body Problems",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/FallingBodyProblems"]], "GuideTutorial",
 CellID->744782981],

Cell[TextData[ButtonBox["Series Solutions of ODEs",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/SeriesSolutionsOfODEs"]], \
"GuideTutorial",
 CellID->2032866951],

Cell[TextData[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]], \
"GuideTutorial",
 CellID->448377240],

Cell[TextData[ButtonBox["Working with Riemann Sums",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/WorkingWithRiemannSums"]], \
"GuideTutorial",
 CellID->636763764]
}, Open  ]],

Cell[CellGroupData[{

Cell["MORE ABOUT", "GuideMoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->23220180],

Cell[TextData[ButtonBox["Calculus",
 BaseStyle->"Link",
 ButtonData->"paclet:ref/Calculus"]], "GuideMoreAbout",
 CellID->1567025153]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Classroom Utilities - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "GuideColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 24, 31.1332624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Guide", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "The functions described here are defined in a set of packages developed \
for use in teaching mathematics at the high school and community college \
level. They extend the standard functions of calculus and linear algebra \
built in to Mathematica in a way that forces students to think about the \
steps needed to solve a problem and help develop a clearer understanding of \
the processes of mathematics.", "synonyms" -> {}, "title" -> 
    "Classroom Utilities", "titlemodifier" -> "", "windowtitle" -> 
    "Classroom Utilities", "type" -> "Guide", "uri" -> 
    "ClassroomUtilities/guide/ClassroomUtilities"}, "SearchTextTranslated" -> 
  ""},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[612, 21, 10978, 213, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[11615, 238, 61, 1, 70, "GuideTitle",
 CellID->942062912],
Cell[11679, 241, 510, 11, 70, "GuideAbstract",
 CellID->2001916300],
Cell[CellGroupData[{
Cell[12214, 256, 240, 6, 70, "GuideFunctionsSubsection",
 CellID->2118385067],
Cell[12457, 264, 297, 10, 70, "GuideText",
 CellID->974120541],
Cell[12757, 276, 294, 9, 70, "GuideText",
 CellID->1776091506],
Cell[13054, 287, 312, 9, 70, "GuideText",
 CellID->1363329760],
Cell[13369, 298, 321, 9, 70, "GuideText",
 CellID->1980246477],
Cell[13693, 309, 322, 9, 70, "GuideText",
 CellID->824530996],
Cell[14018, 320, 330, 9, 70, "GuideText",
 CellID->1931928580],
Cell[14351, 331, 314, 9, 70, "GuideText",
 CellID->1208769846],
Cell[14668, 342, 319, 9, 70, "GuideText",
 CellID->116067096],
Cell[14990, 353, 323, 9, 70, "GuideText",
 CellID->180475681],
Cell[15316, 364, 295, 9, 70, "GuideText",
 CellID->1007861003],
Cell[15614, 375, 301, 9, 70, "GuideText",
 CellID->1916353532],
Cell[15918, 386, 290, 9, 70, "GuideText",
 CellID->194074618],
Cell[16211, 397, 294, 9, 70, "GuideText",
 CellID->1849714656],
Cell[16508, 408, 58, 1, 70, "GuideDelimiterSubsection",
 CellID->566437456]
}, Open  ]],
Cell[CellGroupData[{
Cell[16603, 414, 240, 6, 70, "GuideFunctionsSubsection",
 CellID->1446971400],
Cell[16846, 422, 283, 9, 70, "GuideText",
 CellID->2139084322],
Cell[17132, 433, 320, 9, 70, "GuideText",
 CellID->1984484197],
Cell[17455, 444, 325, 9, 70, "GuideText",
 CellID->566465427],
Cell[17783, 455, 324, 9, 70, "GuideText",
 CellID->702558300],
Cell[18110, 466, 280, 9, 70, "GuideText",
 CellID->1032256894],
Cell[18393, 477, 298, 9, 70, "GuideText",
 CellID->1768716992],
Cell[18694, 488, 278, 9, 70, "GuideText",
 CellID->1357842770],
Cell[18975, 499, 59, 1, 70, "GuideDelimiterSubsection",
 CellID->1661903926]
}, Open  ]],
Cell[CellGroupData[{
Cell[19071, 505, 244, 5, 70, "GuideFunctionsSubsection",
 CellID->319315841],
Cell[19318, 512, 329, 9, 70, "GuideText",
 CellID->179705834],
Cell[19650, 523, 289, 9, 70, "GuideText",
 CellID->953944356],
Cell[19942, 534, 280, 9, 70, "GuideText",
 CellID->1977366437],
Cell[20225, 545, 307, 9, 70, "GuideText",
 CellID->1288269334],
Cell[20535, 556, 337, 10, 70, "GuideText",
 CellID->479410447],
Cell[20875, 568, 322, 9, 70, "GuideText",
 CellID->92739185],
Cell[21200, 579, 384, 12, 70, "GuideText",
 CellID->2082535727],
Cell[21587, 593, 58, 1, 70, "GuideDelimiterSubsection",
 CellID->768614888]
}, Open  ]],
Cell[CellGroupData[{
Cell[21682, 599, 230, 5, 70, "GuideFunctionsSubsection",
 CellID->1561284760],
Cell[21915, 606, 304, 9, 70, "GuideText",
 CellID->410278627],
Cell[22222, 617, 310, 9, 70, "GuideText",
 CellID->2130377119],
Cell[22535, 628, 340, 10, 70, "GuideText",
 CellID->309389813],
Cell[22878, 640, 316, 9, 70, "GuideText",
 CellID->856677704],
Cell[23197, 651, 320, 9, 70, "GuideText",
 CellID->1451801640],
Cell[23520, 662, 321, 9, 70, "GuideText",
 CellID->720966266],
Cell[23844, 673, 58, 1, 70, "GuideDelimiterSubsection",
 CellID->932087504]
}, Open  ]],
Cell[CellGroupData[{
Cell[23939, 679, 243, 5, 70, "GuideFunctionsSubsection",
 CellID->1530468709],
Cell[24185, 686, 330, 9, 70, "GuideText",
 CellID->28468397],
Cell[24518, 697, 303, 9, 70, "GuideText",
 CellID->1726978745],
Cell[24824, 708, 298, 9, 70, "GuideText",
 CellID->2090278010],
Cell[25125, 719, 312, 9, 70, "GuideText",
 CellID->617532797],
Cell[25440, 730, 332, 9, 70, "GuideText",
 CellID->1122575509],
Cell[25775, 741, 311, 9, 70, "GuideText",
 CellID->1695559320],
Cell[26089, 752, 59, 1, 70, "GuideDelimiterSubsection",
 CellID->1379494588]
}, Open  ]],
Cell[CellGroupData[{
Cell[26185, 758, 241, 5, 70, "GuideFunctionsSubsection",
 CellID->1741838220],
Cell[26429, 765, 369, 12, 70, "GuideText",
 CellID->997189376],
Cell[26801, 779, 294, 9, 70, "GuideText",
 CellID->799461244],
Cell[27098, 790, 312, 9, 70, "GuideText",
 CellID->1887432276],
Cell[27413, 801, 324, 9, 70, "GuideText",
 CellID->1593312895],
Cell[27740, 812, 303, 9, 70, "GuideText",
 CellID->1836231822],
Cell[28046, 823, 295, 9, 70, "GuideText",
 CellID->60741317],
Cell[28344, 834, 301, 9, 70, "GuideText",
 CellID->1046002567],
Cell[28648, 845, 58, 1, 70, "GuideDelimiterSubsection",
 CellID->725067038]
}, Open  ]],
Cell[CellGroupData[{
Cell[28743, 851, 218, 4, 70, "GuideFunctionsSubsection",
 CellID->594354735],
Cell[28964, 857, 330, 10, 70, "GuideText",
 CellID->1373588948],
Cell[29297, 869, 318, 10, 70, "GuideText",
 CellID->460243786],
Cell[29618, 881, 337, 10, 70, "GuideText",
 CellID->81214808],
Cell[29958, 893, 332, 10, 70, "GuideText",
 CellID->1325162211],
Cell[30293, 905, 355, 10, 70, "GuideText",
 CellID->1704888336],
Cell[30651, 917, 326, 10, 70, "GuideText",
 CellID->183961231],
Cell[30980, 929, 271, 9, 70, "GuideText",
 CellID->2031179949],
Cell[31254, 940, 293, 9, 70, "GuideText",
 CellID->1641350131],
Cell[31550, 951, 49, 1, 70, "GuideDelimiter",
 CellID->1913215114],
Cell[31602, 954, 2087, 74, 70, "InlineGuideFunctionListing",
 CellID->1848958510]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[33738, 1034, 91, 2, 70, "GuideTutorialsSection",
 CellID->415694126],
Cell[33832, 1038, 198, 5, 70, "GuideTutorial",
 CellID->806871991],
Cell[34033, 1045, 215, 5, 70, "GuideTutorial",
 CellID->864009227],
Cell[34251, 1052, 217, 5, 70, "GuideTutorial",
 CellID->1406315809],
Cell[34471, 1059, 181, 4, 70, "GuideTutorial",
 CellID->744782981],
Cell[34655, 1065, 189, 5, 70, "GuideTutorial",
 CellID->2032866951],
Cell[34847, 1072, 206, 5, 70, "GuideTutorial",
 CellID->448377240],
Cell[35056, 1079, 191, 5, 70, "GuideTutorial",
 CellID->636763764]
}, Open  ]],
Cell[CellGroupData[{
Cell[35284, 1089, 91, 2, 70, "GuideMoreAboutSection",
 CellID->23220180],
Cell[35378, 1093, 132, 3, 70, "GuideMoreAbout",
 CellID->1567025153]
}, Open  ]],
Cell[35525, 1099, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

