(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     13345,        392]
NotebookOptionsPosition[     10182,        304]
NotebookOutlinePosition[     11946,        346]
CellTagsIndexPosition[     11903,        343]
WindowTitle->Statistics - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES GUIDE", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Functions \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"CreatePopulation\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/CreatePopulation"], \
"\<\"FittedModelPlot\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/FittedModelPlot"], \
"\<\"FiveNumberSummaryTable\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/FiveNumberSummaryTable"], \
"\<\"Grumpy\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/Grumpy"], "\<\"Happy\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/Happy"], "\<\"KSeparateSamples\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/KSeparateSamples"], "\<\"MakeColorList\
\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/MakeColorList"], "\<\"Oh\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/Oh"], "\<\"RollTheDice\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/RollTheDice"], "\<\"Sleepy\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/Sleepy"], "\<\"SRSChart\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/SRSChart"], "\<\"TenSidedDie\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/TenSidedDie"], \
"\<\"TrapezoidalDistribution\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/TrapezoidalDistribution"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideFunction"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utiliities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideMoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Visualizing Statistical Concepts\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideTutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities/guide/Statistics\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/guide/Statistics"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/guide/Statistics.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/guide/Statistics", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["Statistics", "GuideTitle",
 CellID->942062912],

Cell["\<\
The functions included here are intended to introduce statistical concepts in \
a visual format. The notions of populations and simple random samples can be \
explored in a form suitable for the audience and the analysis being conducted.\
\>", "GuideAbstract",
 CellID->2001916300],

Cell[TextData[{
 Cell[TextData[ButtonBox["CreatePopulation",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/CreatePopulation"]], 
  "InlineFunctionSans",
  FontWeight->"Bold"],
 StyleBox[" ",
  FontWeight->"Bold"],
 StyleBox["\[LongDash]", "GuideEmDash"],
 " give a face to your population in the SRSChart"
}], "GuideText",
 CellID->203374175],

Cell[TextData[{
 Cell[TextData[ButtonBox["SRSChart",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/SRSChart"]], 
  "InlineFunctionSans",
  FontWeight->"Bold"],
 StyleBox[" ",
  FontWeight->"Bold"],
 StyleBox["\[LongDash]", "GuideEmDash"],
 " visualize a population with one or more random samples"
}], "GuideText",
 CellID->1463276848],

Cell[TextData[{
 Cell[TextData[ButtonBox["KSeparateSamples",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/KSeparateSamples"]], 
  "InlineFunctionSans",
  FontWeight->"Bold"],
 StyleBox[" ",
  FontWeight->"Bold"],
 StyleBox["\[LongDash]", "GuideEmDash"],
 " create k random samples from a list of values"
}], "GuideText",
 CellID->1578244528],

Cell["\t", "GuideDelimiter",
 CellID->311258892],

Cell[TextData[{
 Cell[TextData[ButtonBox["TrapezoidalDistribution",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/TrapezoidalDistribution"]], 
  "InlineFunctionSans",
  FontWeight->"Bold"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " a trapezoidal distribution"
}], "GuideText",
 CellID->176068189],

Cell["\t", "GuideDelimiter",
 CellID->1985257999],

Cell[TextData[{
 Cell[TextData[ButtonBox["MakeColorList",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/MakeColorList"]], 
  "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 Cell[TextData[ButtonBox["Happy",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/Happy"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 Cell[TextData[ButtonBox["Sleepy",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/Sleepy"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 Cell[TextData[ButtonBox["Grumpy",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/Grumpy"]], "InlineFunctionSans"],
 "\[NonBreakingSpace]",
 StyleBox["\[FilledVerySmallSquare]", "InlineSeparator"],
 " ",
 Cell[TextData[ButtonBox["Oh",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/Oh"]], "InlineFunctionSans"],
 " "
}], "InlineGuideFunctionListing",
 CellID->58033752],

Cell["\t", "GuideDelimiter",
 CellID->99248058],

Cell[TextData[{
 Cell[TextData[ButtonBox["FiveNumberSummaryTable",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/FiveNumberSummaryTable"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " a formatted table of five number summaries for data"
}], "GuideText",
 CellID->57605552],

Cell[TextData[{
 Cell[TextData[ButtonBox["FittedModelPlot",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/FittedModelPlot"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " display a fitted model together with the data"
}], "GuideText",
 CellID->195307961],

Cell["\t", "GuideDelimiter",
 CellID->1808871314],

Cell[TextData[{
 Cell[TextData[ButtonBox["RollTheDice",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/RollTheDice"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " roll various combinations of game playing dice"
}], "GuideText",
 CellID->1921667466],

Cell["\t", "GuideDelimiter",
 CellID->52233498],

Cell[TextData[Cell[TextData[ButtonBox["TenSidedDie",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/ref/TenSidedDie"]], "InlineFunctionSans"]], \
"InlineGuideFunctionListing",
 CellID->1458533829]
}, Open  ]],

Cell[CellGroupData[{

Cell["TUTORIALS", "GuideTutorialsSection",
 WholeCellGroupOpener->True,
 CellID->415694126],

Cell[TextData[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]], \
"GuideTutorial",
 CellID->806871991]
}, Open  ]],

Cell[CellGroupData[{

Cell["MORE ABOUT", "GuideMoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->23220180],

Cell[TextData[ButtonBox["Classroom Utiliities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "GuideMoreAbout",
 CellID->1272781170]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Statistics - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "GuideColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 24, 40.2904624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Guide", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "The functions included here are intended to introduce statistical \
concepts in a visual format. The notions of populations and simple random \
samples can be explored in a form suitable for the audience and the analysis \
being conducted.", "synonyms" -> {}, "title" -> "Statistics", "titlemodifier" -> 
    "", "windowtitle" -> "Statistics", "type" -> "Guide", "uri" -> 
    "Classroom Utilities/guide/Statistics"}, "SearchTextTranslated" -> ""},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[603, 21, 4575, 100, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[5203, 125, 52, 1, 70, "GuideTitle",
 CellID->942062912],
Cell[5258, 128, 291, 5, 70, "GuideAbstract",
 CellID->2001916300],
Cell[5552, 135, 363, 11, 70, "GuideText",
 CellID->203374175],
Cell[5918, 148, 356, 11, 70, "GuideText",
 CellID->1463276848],
Cell[6277, 161, 363, 11, 70, "GuideText",
 CellID->1578244528],
Cell[6643, 174, 48, 1, 70, "GuideDelimiter",
 CellID->311258892],
Cell[6694, 177, 325, 10, 70, "GuideText",
 CellID->176068189],
Cell[7022, 189, 49, 1, 70, "GuideDelimiter",
 CellID->1985257999],
Cell[7074, 192, 1112, 31, 70, "InlineGuideFunctionListing",
 CellID->58033752],
Cell[8189, 225, 47, 1, 70, "GuideDelimiter",
 CellID->99248058],
Cell[8239, 228, 325, 9, 70, "GuideText",
 CellID->57605552],
Cell[8567, 239, 306, 9, 70, "GuideText",
 CellID->195307961],
Cell[8876, 250, 49, 1, 70, "GuideDelimiter",
 CellID->1808871314],
Cell[8928, 253, 300, 9, 70, "GuideText",
 CellID->1921667466],
Cell[9231, 264, 47, 1, 70, "GuideDelimiter",
 CellID->52233498],
Cell[9281, 267, 213, 5, 70, "InlineGuideFunctionListing",
 CellID->1458533829]
}, Open  ]],
Cell[CellGroupData[{
Cell[9531, 277, 91, 2, 70, "GuideTutorialsSection",
 CellID->415694126],
Cell[9625, 281, 206, 5, 70, "GuideTutorial",
 CellID->806871991]
}, Open  ]],
Cell[CellGroupData[{
Cell[9868, 291, 91, 2, 70, "GuideMoreAboutSection",
 CellID->23220180],
Cell[9962, 295, 178, 4, 70, "GuideMoreAbout",
 CellID->1272781170]
}, Open  ]],
Cell[10155, 302, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

