(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     10262,        305]
NotebookOptionsPosition[      7132,        217]
NotebookOutlinePosition[      9081,        263]
CellTagsIndexPosition[      9038,        260]
WindowTitle->Visualizing Piecewise Continuous Functions - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES GUIDE", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Functions \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"PiecewisePlot\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PiecewisePlot"], \
"\<\"PiecewisePolarPlot\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PiecewisePolarPlot"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideFunction"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Plotting Piecewise Continuous Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
PlottingPiecewiseContinuousFunctions"], "\<\"Basic Plotting\"\>":>
       Documentation`HelpLookup["paclet:tutorial/BasicPlotting"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"GuideTutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/guide/\
VisualizingPiecewiseContinuousFunctions\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
             "ClassroomUtilities/guide/\
VisualizingPiecewiseContinuousFunctions"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
guide/VisualizingPiecewiseContinuousFunctions.html"], StandardForm]], "Input",
               TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/guide/\
VisualizingPiecewiseContinuousFunctions", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["Visualizing Piecewise Continuous Functions", "GuideTitle",
 CellID->942062912],

Cell[TextData[{
 "The functions PiecewisePlot and PiecewisePolarPlot, defined in this \
package, extend ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "'s plot functions to include the standard textbook representations of \
piecewise continuous functions. Function values are represented by solid \
points and missing values by open circles."
}], "GuideAbstract",
 CellID->2001916300],

Cell[CellGroupData[{

Cell["Piecewise Plotting Functions", "GuideFunctionsSubsection",
 CellID->1712327189],

Cell[TextData[{
 Cell[TextData[ButtonBox["PiecewisePlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/PiecewisePlot"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " plot a piecewise continuous function as seen in textbooks"
}], "GuideText",
 CellID->203374175],

Cell[TextData[{
 Cell[TextData[ButtonBox["PiecewisePolarPlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/PiecewisePolarPlot"]], 
  "InlineFunctionSans"],
 " ",
 StyleBox["\[LongDash]", "GuideEmDash"],
 " plot a piecewise continuous function in polar coordinates"
}], "GuideText",
 CellID->1463276848]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["TUTORIALS", "GuideTutorialsSection",
 WholeCellGroupOpener->True,
 CellID->415694126],

Cell[TextData[ButtonBox["Plotting Piecewise Continuous Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/PlottingPiecewiseContinuousFunctions"]],\
 "GuideTutorial",
 CellID->806871991],

Cell[TextData[ButtonBox["Basic Plotting",
 BaseStyle->"Link",
 ButtonData->"paclet:tutorial/BasicPlotting"]], "GuideTutorial",
 CellID->1885805579]
}, Open  ]],

Cell[CellGroupData[{

Cell["MORE ABOUT", "GuideMoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->23220180],

Cell[TextData[ButtonBox["Graphics and Sound",
 BaseStyle->"Link",
 ButtonData->"paclet:tutorial/GraphicsAndSoundOverview"]], "GuideText",
 CellID->151800574],

Cell[TextData[ButtonBox["How to: Create Plots",
 BaseStyle->"Link",
 ButtonData->"paclet:howto/CreatePlots"]], "GuideText",
 CellID->1287817965],

Cell[TextData[ButtonBox["How to: Customize Plots and Graphics",
 BaseStyle->"Link",
 ButtonData->"paclet:howto/CustomizePlotsAndGraphics"]], "GuideText",
 CellID->2016343289],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/guide/ClassroomUtilities"]], "GuideText",
 CellID->1596152073]
}, Open  ]],

Cell[CellGroupData[{

Cell["RELATED LINKS", "GuideRelatedLinksSection",
 WholeCellGroupOpener->True,
 CellID->415694148],

Cell[TextData[{
 ButtonBox["M101: A First Course in ",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m101.html"], None}],
 StyleBox[ButtonBox["Mathematica",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m101.html"], None}],
  FontSlant->"Italic"]
}], "GuideText",
 CellID->8535635],

Cell[TextData[ButtonBox["M205: Visualization and Dynamic Interactivity",
 BaseStyle->"Hyperlink",
 ButtonData->{
   URL["http://www.wolfram.com/services/education/minicourses/m205.html"], 
   None}]], "GuideText",
 CellID->1618417]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Visualizing Piecewise Continuous Functions - Wolfram \
Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "GuideColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 24, 44.5336624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Guide", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "The functions PiecewisePlot and PiecewisePolarPlot, defined in this \
package, extend Mathematica's plot functions to include the standard textbook \
representations of piecewise continuous functions. Function values are \
represented by solid points and missing values by open circles.", 
    "synonyms" -> {}, "title" -> "Visualizing Piecewise Continuous Functions",
     "titlemodifier" -> "", "windowtitle" -> 
    "Visualizing Piecewise Continuous Functions", "type" -> "Guide", "uri" -> 
    "ClassroomUtilities/guide/VisualizingPiecewiseContinuousFunctions"}, 
  "SearchTextTranslated" -> ""},
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->FrontEnd`FileName[{"Wolfram"}, "Reference.nb", 
  CharacterEncoding -> "WindowsANSI"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[635, 21, 3138, 73, 70, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3798, 98, 84, 1, 70, "GuideTitle",
 CellID->942062912],
Cell[3885, 101, 390, 9, 70, "GuideAbstract",
 CellID->2001916300],
Cell[CellGroupData[{
Cell[4300, 114, 85, 1, 70, "GuideFunctionsSubsection",
 CellID->1712327189],
Cell[4388, 117, 313, 9, 70, "GuideText",
 CellID->203374175],
Cell[4704, 128, 324, 9, 70, "GuideText",
 CellID->1463276848]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[5077, 143, 91, 2, 70, "GuideTutorialsSection",
 CellID->415694126],
Cell[5171, 147, 218, 5, 70, "GuideTutorial",
 CellID->806871991],
Cell[5392, 154, 147, 3, 70, "GuideTutorial",
 CellID->1885805579]
}, Open  ]],
Cell[CellGroupData[{
Cell[5576, 162, 91, 2, 70, "GuideMoreAboutSection",
 CellID->23220180],
Cell[5670, 166, 157, 3, 70, "GuideText",
 CellID->151800574],
Cell[5830, 171, 144, 3, 70, "GuideText",
 CellID->1287817965],
Cell[5977, 176, 174, 3, 70, "GuideText",
 CellID->2016343289],
Cell[6154, 181, 173, 4, 70, "GuideText",
 CellID->1596152073]
}, Open  ]],
Cell[CellGroupData[{
Cell[6364, 190, 98, 2, 70, "GuideRelatedLinksSection",
 CellID->415694148],
Cell[6465, 194, 391, 11, 70, "GuideText",
 CellID->8535635],
Cell[6859, 207, 231, 5, 70, "GuideText",
 CellID->1618417]
}, Open  ]],
Cell[7105, 215, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

