(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     18089,        595]
NotebookOptionsPosition[     13967,        465]
NotebookOutlinePosition[     16055,        521]
CellTagsIndexPosition[     15970,        516]
WindowTitle->AddToRow - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Elementary Matrix Operations\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/ElementaryMatrixOperations"], \
"\<\"Solving Linear Systems\"\>":>Documentation`HelpLookup[
       "paclet:tutorial/SolvingLinearSystems"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"MultiplyARow\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/MultiplyARow"], "\<\"SwitchRows\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/SwitchRows"], "\<\"RowReduce\"\>":>
       Documentation`HelpLookup["paclet:ref/RowReduce"], "\<\"Inverse\"\>":>
       Documentation`HelpLookup["paclet:ref/Inverse"], "\<\"LinearSolve\"\>":>
       Documentation`HelpLookup[
       "paclet:ref/LinearSolve"], "\<\"NullSpace\"\>":>
       Documentation`HelpLookup["paclet:ref/NullSpace"], "\<\"Solve\"\>":>
       Documentation`HelpLookup["paclet:ref/Solve"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], "\<\"Matrix \
Operations\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/MatrixOperations"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/AddToRow\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/AddToRow"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/AddToRow.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/AddToRow", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["AddToRow", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"AddToRow", "[", 
       RowBox[{
        StyleBox["mat", "TI"], ",", 
        SubscriptBox[
         StyleBox["row", "TI"], 
         StyleBox["i", "TI"]], ",", 
        SubscriptBox[
         StyleBox["row", "TI"], 
         StyleBox["j", "TI"]], ",", " ", 
        StyleBox["mult", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]add ",
     Cell[BoxData[
      RowBox[{
       StyleBox["mult", "TI"], "\[Times]", 
       SubscriptBox[
        StyleBox["row", "TI"], 
        StyleBox["j", "TI"]], " "}]], "InlineFormula"],
     "to ",
     Cell[BoxData[
      RowBox[{
       SubscriptBox[
        StyleBox["row", "TI"], 
        StyleBox["i", "TI"]], " "}]], "InlineFormula"],
     "of the matrix ",
     Cell[BoxData[
      StyleBox["mat", "TI"]], "InlineFormula"]
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->304522928],

Cell["The row specs should be integers", "Notes",
 CellID->1067943069],

Cell["The value mult can be any expression", "Notes",
 CellID->719342227],

Cell["AddToRow works with symbolic and numeric matrices", "Notes",
 CellID->1799360226],

Cell["The matrix need not be square", "Notes",
 CellID->982601328]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->363529895],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->31605411],

Cell["This loads the package.", "ExampleText",
 CellID->1263446582],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->428402138],

Cell["Add 5 times row one to row two in a symbolic matrix.", "ExampleText",
 CellID->1789548622],

Cell[BoxData[
 RowBox[{
  RowBox[{"mat", "=", " ", 
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {"a", "b", "c"},
      {"d", "e", "f"},
      {"g", "h", "i"}
     }], "\[NoBreak]", ")"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1435213719],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AddToRow", "[", 
   RowBox[{"mat", ",", "2", ",", "1", ",", "5"}], "]"}], "//", 
  "TraditionalForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1100652129],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"a", "b", "c"},
     {
      RowBox[{
       RowBox[{"5", " ", "a"}], "+", "d"}], 
      RowBox[{
       RowBox[{"5", " ", "b"}], "+", "e"}], 
      RowBox[{
       RowBox[{"5", " ", "c"}], "+", "f"}]},
     {"g", "h", "i"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 ImageSize->{142, 48},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//TraditionalForm=",
 CellID->1210594259]
}, Open  ]],

Cell["Work with a numeric matrix.", "ExampleText",
 CellID->1197639335],

Cell[BoxData[
 RowBox[{
  RowBox[{"nmat", " ", "=", " ", 
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {"5", "4", 
       RowBox[{"-", "6"}], 
       RowBox[{"-", "10"}]},
      {
       RowBox[{"-", "4"}], "0", "4", "4"},
      {"7", "8", "4", 
       RowBox[{"-", "6"}]}
     }], "\[NoBreak]", ")"}]}], ";"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->360080014],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"AddToRow", "[", 
   RowBox[{"nmat", ",", "2", ",", "1", ",", 
    RowBox[{"4", "/", "5"}]}], "]"}], "//", "TraditionalForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->255878052],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"5", "4", 
      RowBox[{"-", "6"}], 
      RowBox[{"-", "10"}]},
     {"0", 
      FractionBox["16", "5"], 
      RowBox[{"-", 
       FractionBox["4", "5"]}], 
      RowBox[{"-", "4"}]},
     {"7", "8", "4", 
      RowBox[{"-", "6"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 ImageSize->{103, 59},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//TraditionalForm=",
 CellID->1280158670]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["MultiplyARow",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/MultiplyARow"],
   FontFamily->"Verdana"]], "InlineFormula",
  FontSize->10],
 StyleBox[" . ",
  FontSize->10],
 Cell[BoxData[
  StyleBox[
   ButtonBox["SwitchRows",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/SwitchRows"],
   FontFamily->"Verdana"]], "InlineFormula",
  FontSize->10],
 " . ",
 StyleBox[ButtonBox["RowReduce",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/RowReduce"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["Inverse",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Inverse"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["LinearSolve",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/LinearSolve"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["NullSpace",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/NullSpace"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["Solve",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Solve"],
  FontFamily->"Verdana"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Elementary Matrix Operations",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/ElementaryMatrixOperations"]], \
"Tutorials",
 CellID->341631938],

Cell[TextData[ButtonBox["Solving Linear Systems",
 BaseStyle->"Link",
 ButtonData->"paclet:tutorial/SolvingLinearSystems"]], "Tutorials",
 CellID->431274266]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->772645294],

Cell[TextData[ButtonBox["Matrix Operations",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/MatrixOperations"]], "MoreAbout",
 CellID->266308993]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"AddToRow - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 24, 48.5272624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "AddToRow[mat, row_i, row_j, mult] add mult*row_j to row_i of the matrix \
mat", "synonyms" -> {}, "title" -> "AddToRow", "titlemodifier" -> "", 
    "windowtitle" -> "AddToRow", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/AddToRow"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6642, 190, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->363529895]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15827, 509}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 3929, 87, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4555, 112, 51, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[4609, 115, 1042, 35, 91, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5688, 155, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->304522928],
Cell[6300, 175, 70, 1, 70, "Notes",
 CellID->1067943069],
Cell[6373, 178, 73, 1, 70, "Notes",
 CellID->719342227],
Cell[6449, 181, 87, 1, 70, "Notes",
 CellID->1799360226],
Cell[6539, 184, 66, 1, 70, "Notes",
 CellID->982601328]
}, Closed]],
Cell[CellGroupData[{
Cell[6642, 190, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->363529895],
Cell[CellGroupData[{
Cell[7157, 208, 194, 6, 31, "ExampleSection",
 CellID->31605411],
Cell[7354, 216, 67, 1, 32, "ExampleText",
 CellID->1263446582],
Cell[7424, 219, 127, 3, 28, "Input",
 CellID->428402138],
Cell[7554, 224, 96, 1, 32, "ExampleText",
 CellID->1789548622],
Cell[7653, 227, 252, 9, 54, "Input",
 CellID->1435213719],
Cell[CellGroupData[{
Cell[7930, 240, 192, 6, 28, "Input",
 CellID->1100652129],
Cell[8125, 248, 900, 28, 83, "Output",
 CellID->1210594259]
}, Open  ]],
Cell[9040, 279, 71, 1, 32, "ExampleText",
 CellID->1197639335],
Cell[9114, 282, 365, 13, 70, "Input",
 CellID->360080014],
Cell[CellGroupData[{
Cell[9504, 299, 214, 6, 70, "Input",
 CellID->255878052],
Cell[9721, 307, 913, 29, 94, "Output",
 CellID->1280158670]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10695, 343, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[11144, 358, 1114, 43, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[12295, 406, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[12746, 421, 193, 5, 70, "Tutorials",
 CellID->341631938],
Cell[12942, 428, 157, 3, 70, "Tutorials",
 CellID->431274266]
}, Open  ]],
Cell[CellGroupData[{
Cell[13136, 436, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[13587, 451, 171, 4, 70, "MoreAbout",
 CellID->772645294],
Cell[13761, 457, 164, 3, 70, "MoreAbout",
 CellID->266308993]
}, Open  ]],
Cell[13940, 463, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

