(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     24669,        668]
NotebookOptionsPosition[     21060,        556]
NotebookOutlinePosition[     23176,        613]
CellTagsIndexPosition[     23091,        608]
WindowTitle->ArrowStyle - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Building an Understanding of Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
BuildingAnUnderstandingOfFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Understanding Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingFunctions"], \
"\<\"Classroom Utilities\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/ArrowStyle\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/ArrowStyle"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/ArrowStyle.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/ArrowStyle", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["ArrowStyle", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["ArrowStyle"], "InlineFormula"],
     "\[LineSeparator]is an option for ",
     Cell[BoxData[
      ButtonBox["FunctionArrowDiagram",
       BaseStyle->"Link",
       ButtonData->"paclet:ClassroomUtilities/ref/FunctionArrowDiagram"]], 
      "InlineFormula"],
     " that determines how the arrows are rendered."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->22879690],

Cell["\<\
ArrowStyle will accept any values that can be used in styling arrows.\
\>", "Notes",
 CellID->1067943069],

Cell["Multiple values can be given in a list or as a directive.", "Notes",
 CellID->282125163]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->293376945],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->890989462],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->33721965],

Cell["\<\
Setting the styles for the arrows in a diagram illustrating an onto mapping.\
\>", "ExampleText",
 CellID->1976866594],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionArrowDiagram", "[", 
  RowBox[{"8", ",", "6", ",", "\"\<Onto\>\"", ",", 
   RowBox[{"ArrowStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Dashed", ",", "Red"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1477342621],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.986419, 0.970581, 0.342397], Opacity[0.2], EdgeForm[GrayLevel[
   0]], DiskBox[{0, 0}, {1.1, 1.6500000000000001`}], 
   {RGBColor[0.0692454, 0.645548, 0.968322], 
    DiskBox[{3, 0}, {1.1, 1.6500000000000001`}]}, 
   {GrayLevel[0], PointSize[Medium], Opacity[1], 
    PointBox[{{-0.4, 
      1.0392304845413265`}, {-0.4, -0.34641016151377546`}, \
{-0.6000000000000001, -1.0392304845413265`}, {-0.2, 
      0.34641016151377546`}, {-0.9, 0.5196152422706632}, {
      0.7000000000000001, -0.5196152422706632}, {
      0.1, -0.17320508075688773`}, {0, -1.0392304845413265`}, {3.9, 
      0.5196152422706632}, {3.8, -0.34641016151377546`}, {2.8, 
      1.0392304845413265`}, {2.6, 0.}, {3.3, -0.17320508075688773`}, {
      2.8, -1.0392304845413265`}}], 
    {RGBColor[1, 0, 0], Dashing[{Small, Small}], ArrowBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQbWIMAo/3zzrOqLphwYf9LllsnWe23t3/MXzvo5YH
7/ZfEBWOF7lwZb/F4tN2rze92c+ns+Htm+Lj+zOaH1vt3vlqf4Dh2xSNQ4v3
374S8YTh24v9CsbPBaIO7LY/c/nxq9UZz/d7rImIkau6YM+yuVixX+jZ/pB3
9fsOKdyyF1kXyJfw5cn+c7da44veP7S/9/F81za+J/u3sR+uXXP9mX1u2fYi
nqTH+y/EZeuUHntt3941P3nvu0f72e4tM5we88HePT6wh23ro/06oT2Mc659
gvNPNf+d88P/K1x92PrALzHHv8PNO+NawFxl/Qtu3xzzyc1Mq//A3aPAITtn
tch/uHsZEoROTtvN4ADzT5yfrvWiF4wOMP9GzSnJuCHA7AALj+A/1apzjFkc
YOH1MG2XVnAAqwMsPNPAgM0BFt4AXWDR1g==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAAAAAAAAAAACaxwElsKDwvxQ13mVe
fME/XVFDDzy27b/BxX0ooMzRP0fC09z3Xuq/f0X9toQm2z//2WuAWT3nv8Ib
9FVzY+I/dlyZUApT5L8y4ew2VVTnPxu+EUuWoeG/9pcu2Uhj7D9OryqF1lTe
v+VziZHPxvA/TsqoObDd2b/ITo05TWjzP6iceUEY4NW/XkYbCrgU9j+wAh6r
LF7Sv75TgNykyvg/cAg9zJOzzr9JC45+o4j7PxDvfowTqcm/zer3dT9N/j9g
lxlUhZ/Fv48g+2KAiwBAcLVhig2Zwr+o6GJbNvIBQBBQ7R1Hl8C/nStNTwNa
A0C49RJVhTa/v8qmzFUowgRAePsp0QtLv79K5ThX5ikGQCCrDGYLtsC/z/mS
cn6QB0BACW+JQszCv6A3zWIy9QhAgMZ13g/nxb9VLcDjRFcKQGBDfKzNBMq/
I1CXFvq1C0BYZEPWTCPPv48OgOWXEA1ALPhNAeuf0r9nZmZmZmYOQCIKrYaV
K9a/pmS9hw==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAZ2ZmZmZm5j+axwElsKDgv3f/3Pry
euk/2HY1XYe73L/JxSjTB6nsP6To6Yypfti/lMfd+/Tu7z/KejF6Bo3UvwlE
T+1+pfE/2S1x27Xo0L+q9QENrV3zP5SWRcBMJ8u/ckXfTRsf9T84NrRUOR/F
v818ODjb6PY/iNZoesl4v78mul/q+bn4P4CB6SlVA7a/clyHmYCR+j/AT24U
Ncarv9CgtBR1bvw/ICFSf6VxnL8e939J2k/+PwC3Hn2hLXu/w04uZVgaAEAA
YpsEobWCP5whEKv7DQFA4CobiHP4kz9/ZEGwVQICQMA1XrjeB5k/OtmmzeT2
AkDg8wC6YoaYP8Q++T8n6wNAYAFPQUR0kj+2b59sm94EQIBwBK7vUns/Bety
JsDQBUAA8JntFqSEvw9KSvIUwQZAIBiqE3x7oL/rRSVLGq8HQBiNJScDh66/
xx/W5VGaCEDI/ZuWE6K3v9+FBPQ+gglAJEMynYGqwL9mZmZmZmYKQCQKrYaV
K8a/t/m99g==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAmpmZmZmZ2b8iCq2GlSvWv/12+7DI
atK/epn76nkW0b/y3tnnTgXGv0KFG8rRrMi/4AQNwR8pq7+Gjy/Nnre/v2gB
m2XdprE/OLpm8mj6rr9EoXfSi8vIPwCXlI8dYGa/Hjk8JMuK1D9wG/LIRT6p
P1AeD7t01Nw/iPPjjiVyuD9195J2Lp/iP4Ki33jgX8E/n4wHbwbi5j/skADF
PsHFP9db7nl/MOs/7HyXrNpayT8Rua6eUIjvPwg6Yy7LKsw/UGu495Xz8T/k
5ZVKki/OP1DpEOFfJfQ/bCaFzR1ozz9Ukrn1W1j2P5jrJ+HH088/FCSXfV+L
+D+8gRRlV3LPP/Zlmrw/vfo/MEXQDABEzj/OSUKR0uz8P5TgYERiScw/wgrM
Eu8Y/z88pS3bioPJP6OtXhc3oABAHCdedfLzxT9+hbqiFbEBQIzKAcR8nME/
w4i3YoK+AkBAmtQI7/64PzfOdGLuxwNAaN4FHWV+qj/NzMzMzMwEQAAAAAAA
AJA8x5LGqg==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAmpmZmZmZuT8iCq2GlSvGv9qh33M0
GMk//L8VAVmUvL/gh6C3Fd7SP8R3xrlt6Ku/emt5X/5Y2T8AW0XA0KFfv+rL
Tvpj+d8/vADhCiOLpz86hmk24V3jPwTQhFqR0bY/CZSXykHO5j+ygsfZzU/A
Pw3XFZkATOo/FGCoXj6VxD813XNpQ9XtPwAwUg7WNsg/n7iF8xS08D9CCxar
pzLLP4fE7k9ngfI/uoff7B2HzT+b+BIDpFH0Pwp7P1j8Ms8/64QOutQj9j98
aCzzrxrQP7DgrhgC9/c/PS6rvt9G0D9MjbI8NMr5P0zclBz2HdA/5vpPQXOc
+z+en2yEEUDPP9fEvcLHbP0/yoVXAbWazT+fe3ZhOzr/P5Cv2UK2TMs/+Cp5
ouyBAEDOY/hVTlfIPya2yE5XZAFABiu0Gw+8xD8TyLiS5UMCQHI+zHPifMA/
OrH1zyAgA0CAlqJxEji3P1qCuSuU+ANAINVFOGhwqD/NzMzMzMwEQAAAAAAA
AAAA4G++Wg==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAmpmZmZmZyb8iCq2GlSvWP15BlWfV
orS/yBnc0sAz2T/Q7kruduWkPzpgn1YW4ts/yKQBkYD+xD98ZubmKTXePzQh
XNnPetI/eZo64t8V4D9rPpxAIYvaPx2ntqFm4uA/yNZ+lfZV4T/ZRmasvH/h
P4Qcc8NxbOU/AmvLho7t4T98KRvn1obpP126tuuhK+I/sqTDqfii7T+gnDLr
1TniP71pZ2RU3/A/zzf9+yIY4j+We/We3OvyP9cZiP+axuE/L1aUs/719D/g
bns4aUXhP6UYKpel/PY/bs3BM9KU4D+gbnoXvv74P+yLUUhnat8/EmUrbTf7
+j8dBVNhCE7dP9HdgcwD8fw/TLDnaqbV2j8l1oj0GN/+P9Rguu+QAtg/jMUr
XjhiAEBvUreaR9bUP/nCFc8EUAFAHEp5a3lS0T8YYQagczgCQKo6M6MH8so/
P7bZfAkbA0AR7rhe45fCP4EXtCtO9wNABBL/EOk1sz/OzMzMzMwEQAAAAAAA
AAAAl0jFkA==
      "]], ArrowBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQffYMCLzZP+s4o+qGBQ/sH2gu96tb9Wx/0s1QO4c/
j+3nedxl3pj0YL9Vr3JDMf9zeyYube6Sj5f3zzGKsVpx46X9CY2kbJaG3fsn
bLjyPznsjf2M1d3H5BbstL9SKpAf0v7OXum2hs+s+5fttQuefVI3/WBvOGfF
thP7H9grvCnj1/7/wb5wf7N+5ILn9iUvrWM9Fn60j29zzrzR+87+Yffy65rS
n+zFsl6v9zn0yV7zm/3lvpxP9id6nwqVOnyzt5jzXt5n6id7iyKpt137f8L5
r6aKBGy2/QtXnyG3/mlnDIMDzDwVAfktL8WZHGD2fb4Reon3ArMDzD1znlRt
42lhdYC5d/Gi05z/jdgdYP5xFYxWZrjD4QDzr2NiaqNeHZcDLDzUg747rJHg
cYCFV/mplZPnr+J1gIWnMRjwO8DCGwArKb1O
      "]], ArrowBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQPWsmCNzcP+s4o+qGBR/st4gKzbmdfXG/UcWJJtP9
H+2TarcU2Ekc2l/Fyftu9tFP9geUfgZXbq3f7/paXidi82f7NWbnSt/mHbCf
njVX4k37F/uUTEtndaGL9msZY148c/pqb7Fl0v8Onlv2LVWuqU8ff7U3rGw0
fTPhoX2N0m+lSVnf7NmfZdxeqPbMfouC5pql177ZL82avObbkVf2QY8KVjxT
/27fOO9rQHnme/umumu/NOO+2++YqDj1Gscne/O3C24EVX63X3fF5WJ/7Bc4
X2X6672rNn6DqxfaKCPwmvkn3LykzxsrRIN/w+07s3Kp94e5f+HuidjZqOby
+D/cvWxsZ7zeCTA6wPxzwv9atIsOkwPMv0f0777ndWZ2gIUHZ7Wd1PYQFgdY
eL0s3bpsXQKrAyw808CAzQEW3gAzLMbT
      "]], 
     {GrayLevel[0]}}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->False,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->True,
  FrameLabel->FormBox[
    StyleBox[
    "\"\[ScriptX] \[RightTeeArrow] \[ScriptF](\[ScriptX])\"", 18, Bold, 
     StripOnInput -> False], TraditionalForm],
  FrameStyle->{},
  FrameTicks->None,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 259},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->688243404]
}, Open  ]],

Cell["Using Directive in place of a list.", "ExampleText",
 CellID->1494579769],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionArrowDiagram", "[", 
  RowBox[{"7", ",", "9", ",", "\"\<OneToOne\>\"", ",", 
   RowBox[{"ArrowStyle", "\[Rule]", " ", 
    RowBox[{"Directive", "[", 
     RowBox[{"Dashed", ",", "Blue", ",", 
      RowBox[{"Arrowheads", "[", "Small", "]"}]}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->285958624],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.986419, 0.970581, 0.342397], Opacity[0.2], EdgeForm[GrayLevel[
   0]], DiskBox[{0, 0}, {1.1, 1.6500000000000001`}], 
   {RGBColor[0.0692454, 0.645548, 0.968322], 
    DiskBox[{3, 0}, {1.1, 1.6500000000000001`}]}, 
   {GrayLevel[0], PointSize[Medium], Opacity[1], 
    PointBox[{{-0.2, 0.34641016151377546`}, {
      0.8, -0.34641016151377546`}, {-0.6000000000000001, \
-1.0392304845413265`}, {0.7000000000000001, 0.5196152422706632}, {
      0, 1.0392304845413265`}, {
      0.30000000000000004`, -0.8660254037844386}, {-0.30000000000000004`, \
-0.17320508075688773`}, {3.6, -1.0392304845413265`}, {2.1, 
      0.5196152422706632}, {2.5, 0.17320508075688773`}, {3.3, 
      1.2124355652982142`}, {2.8, -1.3856406460551018`}, {3.3, 
      0.17320508075688773`}, {2.4, -1.0392304845413265`}, {
      3., -0.34641016151377546`}, {2.5, 0.8660254037844386}}], 
    {RGBColor[0, 0, 1], Dashing[{Small, Small}], Arrowheads[Small], 
     ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAANDMzMzMz47+axwElsKDwvziB9VO7
Od2/KIXBoNhR77+2WpTJY+LTv3QrpnZHmO2/jOqVPqnKxL+nkzsXlxXsv4DP
qgzW8oi/rhzFr5TK6r+8atSgd+PBP2GXYeLvt+m/hmIcDnrB0j9VatpoOt7o
v6j5KU5votw/MCdRx+c96L8ybtjZrkfjP3+Y9A5N1+e/RuK4g4BB6D+gzd2w
oKrnv8h6lsEIPO0/3xctYfq357+0k7inURrxP1RMdgpT/+e/2Qqed1aU8z9K
94LRhIDov8URk2fCCvY/QIJoKUs76b+enEz3Rnz4P0qk5/dCL+q/fo+ZQJjn
+j9N0AHK6lvrv266fadtS/0/CrqoGKPA7L+u9Y2Igqb/P8OAY52uXO6/E22Y
csv7AECjSl5bmRfwv1NYtAa4HgJADIkh7psb8b9yQGajbDsDQB388BDVOfK/
ttMrOFJRBEAG0CPlrHHzvwKEXFHVXwVA5dcH9H3C9L9lZmZmZmYGQCIKrYaV
K/a/ltTRvQ==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAANDMzMzMz0z+qTFjoerbrv8BnL7tn
4Ns/DJfwtTGg6b9B8x3Z+F3iP+pYnrUCvee/J+Ny+I7g5j85K9ZH7g3mv9AK
OpyRdes/a3CdJ9mT5L+mQEEvSQ3wP64WLfGLT+O/pq+CLo1m8j9SB4C3skHi
v05q8sNVxfQ/x70Fqdxq4b/dIR36YCj3PzZ4qcN7y+C/CeDfmGqO+T8pUVaY
5GPgvyDTb9Es9vs/GVoYHk404L+D3znrYF7+P56F8pTRPOC/SB6f+N9iAEAZ
23h4an3gv6EQxq+BlQFASQ82gvb14L/SuUDocsYCQH4827s1puG/IEe51BH1
A0AeFDChyo3iv3Y/L+O9IAVANYexUTqs478oUioS2EgGQIqSxNHsAOW/8p8Y
RcNsB0ChlVpbLYvmv3S6q5fkiwhAIWvcvSpK6L+CHgiwo6UJQIRdKc33POq/
xo2bD2u5CkA4E2/fi2Lsv15jb2KoxgtAX6yXWcO57r/MzMzMzMwMQJrHASWw
oPC/+m7J5A==
      "]], ArrowBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQPWsmCLy0V+Ja2zZV+9r+j3oHXgRlvrFvWHLqyDLx
y/tvJbCvtvZ6b/9L5Jwsr9uF/W/KT+anyX60FwswedZXcHr/s9dBs3fP+WR/
VbgpMPH+sf2Bggc/BSp9sb915eWtv7cO7dfLUtgftfarfV3F6XCe0/v239ky
PZXF9rv9FYe/BgsYd+53c5p/rerCD/ucEGafkzFb9t+93/rvedov+wVM70r+
3duwf+NCdvOS/7/tFWYqXDUWWbs/yX3XTreZf+0niO4+umHfqv05rULCbcb/
4fy+qY+81qQxOMDUV5Qpp38yYnSAmedyVOy3xj9GB5h9P7pnGT85zuQAc0+A
4TW2nf3MDjD37rvLmmsbyuIA80/Jhz0zOCRYHWD+LVrVqLf5OqsDLDwM+pZU
X5/M5gALr1VRZmsEfdgdYOHJAAYcDrDwBgDZcsaq
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAANDMzMzMz078iCq2GlSvGv6wR21R8
Dsm/PQJb/EEhub8G+2nOYpS2v4DgoD+RnZy/gKcCMGP5lj8kwhhyyBmjP+Q2
CnUZZsE/KBSLoLryuD/WBtVBcCHQP7qawa75gMM/ptoPYc+21z+Et8dYjNnJ
P/a7KwEkb98/dFYiT7d/zz97z0K/KqPjPwuA/J09ONI/XLykah2c5z/ZBvuE
nFTUP1ZoRWtOoOs/yxUtpNkT1j8+7XAynK3vP69YoK0Hddc/OFHXLfDg8T+b
rrk7a3fYPxFjZWh47fM/jeqjNHsa2T91+up3UPv1Py+0DhPhXdk/ETg/WWEJ
+D+p7xYUeUHZP4s+E+uTFvo/8VBASlLF2D9rYQ2C0SH8P58IdpWu6dc/M72l
fAQq/j8pyRaAAq/WP0DiOmsMFwBA368eAfUV1T8aTFZdfhYBQGvhjyNfH9M/
rDqtitASAkAp20iTS8zQP3IQoxF9CwNAbikLH+w7zD8AAAAAAAAEQCIKrYaV
K8Y/p6KwfQ==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAmpmZmZmZyb8iCq2GlSvWPxgAwSfj
5ay/hCHuQsmf2j+8cD9hJRO3PxrCY97Ap94/OsNUWJSlzj/4arxkrCDhP+8g
vD00CNk/sNWEAlS14j9iGWll8G/hP1AC7ZIAEeQ/uMHOcUtq5j/HQDec+TLl
P/y4CRiHcOs/UT9oQqUa5j9yz15v/D/wP6hE6piIx+Y/w+GqtPjK8j/qY8bj
RznnP3rmXfLeV/U/gA5RyKZv5z8EX/K6VOX3P9EwMG2Iauc/QvC4VP9x+j9W
26mJ7ynnPxtB0XGE/Pw/UFkzZP6t5j8dpennioP/P5R4QcD29uU/7Qmys90C
AUDAqGO7OQXlP/efv5jgQAJA5HW8mUfZ4z8mk5FmJXsDQJC18oG/c+I/hZP4
XAWxBEBeg78oX9XgP6NSnBDc4QVA9rWL2AT+3T+xJDnCBw0HQFxx0r5F49k/
qahytOkxCECCTcKKrlzVP+7tDYDmTwlA4vaf+6Vs0D9lZmZmZmYKQCMKrYaV
K8Y/Zr3Ifw==
      "]], ArrowBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQnZ4GAs/sZx1nVN2w4IG9I/edr+kGL+zlF/FfT5n9
0N7LaY12JOsre7uFr0v+NTyyZ2q7Zur45LX9BTUbbebAx/a/ex/9UDzz1t78
m+YsFu4n9vz9W6b92P3ePnvXB/4F657Yb+P+8jvu5gd7NRbbvXXWT+2bg7as
3nz9o738d+vHoRuf2gd9+pdefOOT/QRTl9/P+J/Zh9gf+Cp6+7P9739MN/6H
PbNfu2urpND9L/ZLn0sfqGp7Zn9gvd3Du4+/2jdz6DbZzXtmzyPb9/rdi29w
voKQ+OZdb7/D1Vf08lzf9vEH3LyaW2dTIr/8hNvnVSWhKPn1F9w9YgdvXMj9
/BvuXrfWosYL7/7A/XOuNfrC7md/4f490/nQcM2tf/DwWLH6m5nCqf/w8JqW
/D7DJ4rBARaeZ8+AAIMDLLwBqTjN6A==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAAAAAAAAAAACaxwElsKDwP/+W1qVG
YsA/BLk3nX7k8T80+InpDZvQP5gFTFoaEPM/WHIl5kg52T9y4G5j5CL0P2BJ
hNSgA+E/o1kV60oc9T9ns9AeJoDlP2NEVpzJ+/U/keqJ6tIP6j/vRSHh6cD2
P1k1dqY7sO4/mcsqIUNr9z9dCyfwda/xPySFa/l6+vc/9CUYybMM9D/08BVs
RW74P1d4DTqWbvY/j4foCGXG+D8IXVuo2dP4P6chxw2rAvk/Frpfrjg7+z9k
TIp/9yL5P3nGKchso/0/J2L3Ojkn+T/I3FyAlwUAQJ9m2P1tD/k/3zu+T5w4
AUAY0y5ootv4P6WX0+ohagJAULCA9fGL+D/6dIs1hpkDQIqLQ+6GIPg/eiws
NSjGBEDcA21Rmpn3PxhKvmVo7wVA/tY0tnP39j8EFLAOqRQHQJd5GCZpOvY/
/E+Flk41CEC+YjTv3mL1P9XfZtW/UAlArUMLb0dx9D9mZmZmZmYKQN5o19Ui
ZvM/hA+4wg==
      "]], 
     {GrayLevel[0]}}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->False,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->True,
  FrameLabel->FormBox[
    StyleBox[
    "\"\[ScriptX] \[RightTeeArrow] \[ScriptF](\[ScriptX])\"", 18, Bold, 
     StripOnInput -> False], TraditionalForm],
  FrameStyle->{},
  FrameTicks->None,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 259},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->959968286]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Building an Understanding of Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/BuildingAnUnderstandingOfFunctions"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Understanding Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], "MoreAbout",
 CellID->391837567],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->993040801]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"ArrowStyle - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 24, 55.5316624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "ArrowStyle is an option for FunctionArrowDiagram that determines how the \
arrows are rendered.", "synonyms" -> {}, "title" -> "ArrowStyle", 
    "titlemodifier" -> "", "windowtitle" -> "ArrowStyle", "type" -> "Symbol", 
    "uri" -> "ClassroomUtilities/ref/ArrowStyle"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5032, 146, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->293376945]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 22948, 601}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[603, 21, 2912, 67, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3540, 92, 53, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3596, 95, 539, 15, 85, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4172, 115, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->22879690],
Cell[4783, 135, 115, 3, 70, "Notes",
 CellID->1067943069],
Cell[4901, 140, 94, 1, 70, "Notes",
 CellID->282125163]
}, Closed]],
Cell[CellGroupData[{
Cell[5032, 146, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->293376945],
Cell[CellGroupData[{
Cell[5547, 164, 195, 6, 31, "ExampleSection",
 CellID->890989462],
Cell[5745, 172, 126, 3, 28, "Input",
 CellID->33721965],
Cell[5874, 177, 128, 3, 32, "ExampleText",
 CellID->1976866594],
Cell[CellGroupData[{
Cell[6027, 184, 273, 7, 28, "Input",
 CellID->1477342621],
Cell[6303, 193, 6526, 145, 280, "Output",
 CellID->688243404]
}, Open  ]],
Cell[12844, 341, 79, 1, 70, "ExampleText",
 CellID->1494579769],
Cell[CellGroupData[{
Cell[12948, 346, 345, 8, 70, "Input",
 CellID->285958624],
Cell[13296, 356, 6158, 138, 280, "Output",
 CellID->959968286]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19515, 501, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[19966, 516, 211, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[20214, 526, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[20665, 541, 179, 4, 70, "MoreAbout",
 CellID->391837567],
Cell[20847, 547, 171, 4, 70, "MoreAbout",
 CellID->993040801]
}, Open  ]],
Cell[21033, 554, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

