(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     45994,       1114]
NotebookOptionsPosition[     42102,        992]
NotebookOutlinePosition[     44203,       1048]
CellTagsIndexPosition[     44117,       1043]
WindowTitle->ArrowStyles - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/ArrowStyles\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/ArrowStyles"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/ArrowStyles.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/ArrowStyles", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["ArrowStyles", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["ArrowStyles"], "InlineFormula"],
     " \[LineSeparator]an option for TimeIntervalPlot to set the styles of \
the arrows."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->185353122],

Cell["The value of the option should be an ordered pair.", "Notes",
 CellID->1067943069],

Cell["\<\
If a single value is given all arrows will have the same style.\
\>", "Notes",
 CellID->624705439],

Cell["A value of None will omit the arrows from the plot.", "Notes",
 CellID->376763090]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->245972510],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->569210223],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1475462274],

Cell["\<\
By default the arrows are rendered in contrasting colors to the rectangles.\
\>", "ExampleText",
 CellID->1100767209],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   RowBox[{"4", "-", 
    SuperscriptBox["x", "2"]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "2"}], "}"}], ",", "8"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->22862758],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0., 4.}], Scaled[{-0.04, 0}, {0., 3.9375}], 
        Scaled[{0, 0}, {0., 3.9375}], Scaled[{0, 0}, {0., 4.}]}, {
       Scaled[{-0.04, 0}, {0., 3.75}], Scaled[{-0.04, 0}, {0., 3.4375}], 
        Scaled[{0, 0}, {0., 3.4375}], Scaled[{0, 0}, {0., 3.75}]}, {
       Scaled[{-0.04, 0}, {0., 3.}], Scaled[{-0.04, 0}, {0., 2.4375}], 
        Scaled[{0, 0}, {0., 2.4375}], Scaled[{0, 0}, {0., 3.}]}, {
       Scaled[{-0.04, 0}, {0., 1.75}], Scaled[{-0.04, 0}, {0., 0.9375}], 
        Scaled[{0, 0}, {0., 0.9375}], Scaled[{0, 0}, {0., 1.75}]}}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0., 3.9375}], Scaled[{-0.04, 0}, {0., 3.75}], 
        Scaled[{0, 0}, {0., 3.75}], Scaled[{0, 0}, {0., 3.9375}]}, {
       Scaled[{-0.04, 0}, {0., 3.4375}], Scaled[{-0.04, 0}, {0., 3.}], 
        Scaled[{0, 0}, {0., 3.}], Scaled[{0, 0}, {0., 3.4375}]}, {
       Scaled[{-0.04, 0}, {0., 2.4375}], Scaled[{-0.04, 0}, {0., 1.75}], 
        Scaled[{0, 0}, {0., 1.75}], Scaled[{0, 0}, {0., 2.4375}]}, {
       Scaled[{-0.04, 0}, {0., 0.9375}], Scaled[{-0.04, 0}, {0., 0.}], 
        Scaled[{0, 0}, {0., 0.}], Scaled[{0, 0}, {0., 0.9375}]}}], 
     {RGBColor[0.9, 0, 1.], Thickness[Medium], Opacity[0.95], Arrowheads[
      Small], ArrowBox[{
       Scaled[{-0.02, 0}, {0., 1.546875}], 
        Scaled[{-0.02, 0}, {0., 1.140625}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 2.859375}], 
        Scaled[{-0.02, 0}, {0., 2.578125}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 3.671875}], 
        Scaled[{-0.02, 0}, {0., 3.515625}]}], 
      {RGBColor[1, 0.95, 0], Thickness[Large], Opacity[0.95], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 0.703125}], 
         Scaled[{-0.02, 0}, {0., 0.234375}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 2.265625}], 
         Scaled[{-0.02, 0}, {0., 1.921875}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 3.328125}], 
         Scaled[{-0.02, 0}, {0., 3.109375}]}]}, 
      {GrayLevel[0.4], Thickness[Small], Opacity[1], 
       LineBox[NCache[{{
          Scaled[{-0.04, 0}, {0., 3.9375}], {
           Rational[1, 4], Rational[63, 16]}, {Rational[1, 4], 0}}, {
          Scaled[{-0.04, 0}, {0., 3.75}], {Rational[1, 2], Rational[15, 4]}, {
           Rational[1, 2], 0}}, {
          Scaled[{-0.04, 0}, {0., 3.4375}], {
           Rational[3, 4], Rational[55, 16]}, {Rational[3, 4], 0}}, {
          Scaled[{-0.04, 0}, {0., 3.}], {1, 3}, {1, 0}}, {
          Scaled[{-0.04, 0}, {0., 2.4375}], {
           Rational[5, 4], Rational[39, 16]}, {Rational[5, 4], 0}}, {
          Scaled[{-0.04, 0}, {0., 1.75}], {Rational[3, 2], Rational[7, 4]}, {
           Rational[3, 2], 0}}, {
          Scaled[{-0.04, 0}, {0., 0.9375}], {
           Rational[7, 4], Rational[15, 16]}, {Rational[7, 4], 0}}, {
          Scaled[{-0.04, 0}, {0., 0.}], {2, 0}, {2, 0}}}, {{
          Scaled[{-0.04, 0}, {0., 3.9375}], {0.25, 3.9375}, {0.25, 0}}, {
          Scaled[{-0.04, 0}, {0., 3.75}], {0.5, 3.75}, {0.5, 0}}, {
          Scaled[{-0.04, 0}, {0., 3.4375}], {0.75, 3.4375}, {0.75, 0}}, {
          Scaled[{-0.04, 0}, {0., 3.}], {1, 3}, {1, 0}}, {
          Scaled[{-0.04, 0}, {0., 2.4375}], {1.25, 2.4375}, {1.25, 0}}, {
          Scaled[{-0.04, 0}, {0., 1.75}], {1.5, 1.75}, {1.5, 0}}, {
          Scaled[{-0.04, 0}, {0., 0.9375}], {1.75, 0.9375}, {1.75, 0}}, {
          Scaled[{-0.04, 0}, {0., 0.}], {2, 0}, {2, 0}}}]], 
       LineBox[{{0, 0}, {2, 0}}], 
       {RGBColor[1, 0, 0], PointSize[Medium], 
        PointBox[
         NCache[{{0, 4}, {Rational[1, 4], Rational[63, 16]}, {
           Rational[1, 2], Rational[15, 4]}, {
           Rational[3, 4], Rational[55, 16]}, {1, 3}, {
           Rational[5, 4], Rational[39, 16]}, {
           Rational[3, 2], Rational[7, 4]}, {
           Rational[7, 4], Rational[15, 16]}, {2, 0}}, {{0, 4}, {0.25, 
           3.9375}, {0.5, 3.75}, {0.75, 3.4375}, {1, 3}, {1.25, 2.4375}, {1.5,
            1.75}, {1.75, 0.9375}, {2, 0}}]]}}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1gk01NsfAHBrppQfnld/siRboWl7kl71vS9FWSqMrTT0bFHPUl6KyMio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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->2002284540]
}, Open  ]],

Cell["Alternate between black and gray.", "ExampleText",
 CellID->1327515290],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   RowBox[{"4", "-", 
    SuperscriptBox["x", "2"]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "2"}], "}"}], ",", "8", ",", 
   RowBox[{"ArrowStyles", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Gray", ",", "Black"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1341870347],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0., 4.}], Scaled[{-0.04, 0}, {0., 3.9375}], 
        Scaled[{0, 0}, {0., 3.9375}], Scaled[{0, 0}, {0., 4.}]}, {
       Scaled[{-0.04, 0}, {0., 3.75}], Scaled[{-0.04, 0}, {0., 3.4375}], 
        Scaled[{0, 0}, {0., 3.4375}], Scaled[{0, 0}, {0., 3.75}]}, {
       Scaled[{-0.04, 0}, {0., 3.}], Scaled[{-0.04, 0}, {0., 2.4375}], 
        Scaled[{0, 0}, {0., 2.4375}], Scaled[{0, 0}, {0., 3.}]}, {
       Scaled[{-0.04, 0}, {0., 1.75}], Scaled[{-0.04, 0}, {0., 0.9375}], 
        Scaled[{0, 0}, {0., 0.9375}], Scaled[{0, 0}, {0., 1.75}]}}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0., 3.9375}], Scaled[{-0.04, 0}, {0., 3.75}], 
        Scaled[{0, 0}, {0., 3.75}], Scaled[{0, 0}, {0., 3.9375}]}, {
       Scaled[{-0.04, 0}, {0., 3.4375}], Scaled[{-0.04, 0}, {0., 3.}], 
        Scaled[{0, 0}, {0., 3.}], Scaled[{0, 0}, {0., 3.4375}]}, {
       Scaled[{-0.04, 0}, {0., 2.4375}], Scaled[{-0.04, 0}, {0., 1.75}], 
        Scaled[{0, 0}, {0., 1.75}], Scaled[{0, 0}, {0., 2.4375}]}, {
       Scaled[{-0.04, 0}, {0., 0.9375}], Scaled[{-0.04, 0}, {0., 0.}], 
        Scaled[{0, 0}, {0., 0.}], Scaled[{0, 0}, {0., 0.9375}]}}], 
     {GrayLevel[0.5], Opacity[1], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 1.546875}], 
        Scaled[{-0.02, 0}, {0., 1.140625}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 2.859375}], 
        Scaled[{-0.02, 0}, {0., 2.578125}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 3.671875}], 
        Scaled[{-0.02, 0}, {0., 3.515625}]}], 
      {GrayLevel[0], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 0.703125}], 
         Scaled[{-0.02, 0}, {0., 0.234375}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 2.265625}], 
         Scaled[{-0.02, 0}, {0., 1.921875}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 3.328125}], 
         Scaled[{-0.02, 0}, {0., 3.109375}]}]}, 
      {GrayLevel[0.4], Thickness[Small], Opacity[1], 
       LineBox[
        NCache[{{
          Scaled[{-0.04, 0}, {0., 3.9375}], {
           Rational[1, 4], Rational[63, 16]}, {Rational[1, 4], 0}}, {
          Scaled[{-0.04, 0}, {0., 3.75}], {Rational[1, 2], Rational[15, 4]}, {
           Rational[1, 2], 0}}, {
          Scaled[{-0.04, 0}, {0., 3.4375}], {
           Rational[3, 4], Rational[55, 16]}, {Rational[3, 4], 0}}, {
          Scaled[{-0.04, 0}, {0., 3.}], {1, 3}, {1, 0}}, {
          Scaled[{-0.04, 0}, {0., 2.4375}], {
           Rational[5, 4], Rational[39, 16]}, {Rational[5, 4], 0}}, {
          Scaled[{-0.04, 0}, {0., 1.75}], {Rational[3, 2], Rational[7, 4]}, {
           Rational[3, 2], 0}}, {
          Scaled[{-0.04, 0}, {0., 0.9375}], {
           Rational[7, 4], Rational[15, 16]}, {Rational[7, 4], 0}}, {
          Scaled[{-0.04, 0}, {0., 0.}], {2, 0}, {2, 0}}}, {{
          Scaled[{-0.04, 0}, {0., 3.9375}], {0.25, 3.9375}, {0.25, 0}}, {
          Scaled[{-0.04, 0}, {0., 3.75}], {0.5, 3.75}, {0.5, 0}}, {
          Scaled[{-0.04, 0}, {0., 3.4375}], {0.75, 3.4375}, {0.75, 0}}, {
          Scaled[{-0.04, 0}, {0., 3.}], {1, 3}, {1, 0}}, {
          Scaled[{-0.04, 0}, {0., 2.4375}], {1.25, 2.4375}, {1.25, 0}}, {
          Scaled[{-0.04, 0}, {0., 1.75}], {1.5, 1.75}, {1.5, 0}}, {
          Scaled[{-0.04, 0}, {0., 0.9375}], {1.75, 0.9375}, {1.75, 0}}, {
          Scaled[{-0.04, 0}, {0., 0.}], {2, 0}, {2, 0}}}]], 
       LineBox[{{0, 0}, {2, 0}}], 
       {RGBColor[1, 0, 0], PointSize[Medium], 
        PointBox[
         NCache[{{0, 4}, {Rational[1, 4], Rational[63, 16]}, {
           Rational[1, 2], Rational[15, 4]}, {
           Rational[3, 4], Rational[55, 16]}, {1, 3}, {
           Rational[5, 4], Rational[39, 16]}, {
           Rational[3, 2], Rational[7, 4]}, {
           Rational[7, 4], Rational[15, 16]}, {2, 0}}, {{0, 4}, {0.25, 
           3.9375}, {0.5, 3.75}, {0.75, 3.4375}, {1, 3}, {1.25, 2.4375}, {1.5,
            1.75}, {1.75, 0.9375}, {2, 0}}]]}}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1gk01NsfAHBrppQfnld/siRboWl7kl71vS9FWSqMrTT0bFHPUl6KyMio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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1451086209]
}, Open  ]],

Cell["Include Arrowheads in the specification.", "ExampleText",
 CellID->1581619331],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   RowBox[{"4", "-", 
    SuperscriptBox["x", "2"]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "2"}], "}"}], ",", "8", ",", 
   RowBox[{"ArrowStyles", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Arrowheads", "[", "Small", "]"}], ",", "Gray"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Arrowheads", "[", "Small", "]"}], ",", "Black"}], "}"}]}], 
     "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->723513551],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0., 4.}], Scaled[{-0.04, 0}, {0., 3.9375}], 
        Scaled[{0, 0}, {0., 3.9375}], Scaled[{0, 0}, {0., 4.}]}, {
       Scaled[{-0.04, 0}, {0., 3.75}], Scaled[{-0.04, 0}, {0., 3.4375}], 
        Scaled[{0, 0}, {0., 3.4375}], Scaled[{0, 0}, {0., 3.75}]}, {
       Scaled[{-0.04, 0}, {0., 3.}], Scaled[{-0.04, 0}, {0., 2.4375}], 
        Scaled[{0, 0}, {0., 2.4375}], Scaled[{0, 0}, {0., 3.}]}, {
       Scaled[{-0.04, 0}, {0., 1.75}], Scaled[{-0.04, 0}, {0., 0.9375}], 
        Scaled[{0, 0}, {0., 0.9375}], Scaled[{0, 0}, {0., 1.75}]}}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0., 3.9375}], Scaled[{-0.04, 0}, {0., 3.75}], 
        Scaled[{0, 0}, {0., 3.75}], Scaled[{0, 0}, {0., 3.9375}]}, {
       Scaled[{-0.04, 0}, {0., 3.4375}], Scaled[{-0.04, 0}, {0., 3.}], 
        Scaled[{0, 0}, {0., 3.}], Scaled[{0, 0}, {0., 3.4375}]}, {
       Scaled[{-0.04, 0}, {0., 2.4375}], Scaled[{-0.04, 0}, {0., 1.75}], 
        Scaled[{0, 0}, {0., 1.75}], Scaled[{0, 0}, {0., 2.4375}]}, {
       Scaled[{-0.04, 0}, {0., 0.9375}], Scaled[{-0.04, 0}, {0., 0.}], 
        Scaled[{0, 0}, {0., 0.}], Scaled[{0, 0}, {0., 0.9375}]}}], 
     {GrayLevel[0.5], Opacity[1], Arrowheads[Small], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 1.546875}], 
        Scaled[{-0.02, 0}, {0., 1.140625}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 2.859375}], 
        Scaled[{-0.02, 0}, {0., 2.578125}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 3.671875}], 
        Scaled[{-0.02, 0}, {0., 3.515625}]}], 
      {GrayLevel[0], Arrowheads[Small], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 0.703125}], 
         Scaled[{-0.02, 0}, {0., 0.234375}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 2.265625}], 
         Scaled[{-0.02, 0}, {0., 1.921875}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 3.328125}], 
         Scaled[{-0.02, 0}, {0., 3.109375}]}], 
       {GrayLevel[0.4], Thickness[Small], Opacity[1], 
        LineBox[
         NCache[{{
           Scaled[{-0.04, 0}, {0., 3.9375}], {
            Rational[1, 4], Rational[63, 16]}, {Rational[1, 4], 0}}, {
           Scaled[{-0.04, 0}, {0., 3.75}], {
            Rational[1, 2], Rational[15, 4]}, {Rational[1, 2], 0}}, {
           Scaled[{-0.04, 0}, {0., 3.4375}], {
            Rational[3, 4], Rational[55, 16]}, {Rational[3, 4], 0}}, {
           Scaled[{-0.04, 0}, {0., 3.}], {1, 3}, {1, 0}}, {
           Scaled[{-0.04, 0}, {0., 2.4375}], {
            Rational[5, 4], Rational[39, 16]}, {Rational[5, 4], 0}}, {
           Scaled[{-0.04, 0}, {0., 1.75}], {Rational[3, 2], Rational[7, 4]}, {
            Rational[3, 2], 0}}, {
           Scaled[{-0.04, 0}, {0., 0.9375}], {
            Rational[7, 4], Rational[15, 16]}, {Rational[7, 4], 0}}, {
           Scaled[{-0.04, 0}, {0., 0.}], {2, 0}, {2, 0}}}, {{
           Scaled[{-0.04, 0}, {0., 3.9375}], {0.25, 3.9375}, {0.25, 0}}, {
           Scaled[{-0.04, 0}, {0., 3.75}], {0.5, 3.75}, {0.5, 0}}, {
           Scaled[{-0.04, 0}, {0., 3.4375}], {0.75, 3.4375}, {0.75, 0}}, {
           Scaled[{-0.04, 0}, {0., 3.}], {1, 3}, {1, 0}}, {
           Scaled[{-0.04, 0}, {0., 2.4375}], {1.25, 2.4375}, {1.25, 0}}, {
           Scaled[{-0.04, 0}, {0., 1.75}], {1.5, 1.75}, {1.5, 0}}, {
           Scaled[{-0.04, 0}, {0., 0.9375}], {1.75, 0.9375}, {1.75, 0}}, {
           Scaled[{-0.04, 0}, {0., 0.}], {2, 0}, {2, 0}}}]], 
        LineBox[{{0, 0}, {2, 0}}], 
        {RGBColor[1, 0, 0], PointSize[Medium], 
         PointBox[
          NCache[{{0, 4}, {Rational[1, 4], Rational[63, 16]}, {
            Rational[1, 2], Rational[15, 4]}, {
            Rational[3, 4], Rational[55, 16]}, {1, 3}, {
            Rational[5, 4], Rational[39, 16]}, {
            Rational[3, 2], Rational[7, 4]}, {
            Rational[7, 4], Rational[15, 16]}, {2, 0}}, {{0, 4}, {0.25, 
            3.9375}, {0.5, 3.75}, {0.75, 3.4375}, {1, 3}, {1.25, 2.4375}, {
            1.5, 1.75}, {1.75, 0.9375}, {2, 0}}]]}}}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1gk01NsfAHBrppQfnld/siRboWl7kl71vS9FWSqMrTT0bFHPUl6KyMio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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->408339515]
}, Open  ]],

Cell["Don't show the arrows.", "ExampleText",
 CellID->1751976440],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   RowBox[{"4", "-", 
    SuperscriptBox["x", "2"]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "2"}], "}"}], ",", "8", ",", 
   RowBox[{"ArrowStyles", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"None", ",", "None"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1319743063],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0., 4.}], Scaled[{-0.04, 0}, {0., 3.9375}], 
        Scaled[{0, 0}, {0., 3.9375}], Scaled[{0, 0}, {0., 4.}]}, {
       Scaled[{-0.04, 0}, {0., 3.75}], Scaled[{-0.04, 0}, {0., 3.4375}], 
        Scaled[{0, 0}, {0., 3.4375}], Scaled[{0, 0}, {0., 3.75}]}, {
       Scaled[{-0.04, 0}, {0., 3.}], Scaled[{-0.04, 0}, {0., 2.4375}], 
        Scaled[{0, 0}, {0., 2.4375}], Scaled[{0, 0}, {0., 3.}]}, {
       Scaled[{-0.04, 0}, {0., 1.75}], Scaled[{-0.04, 0}, {0., 0.9375}], 
        Scaled[{0, 0}, {0., 0.9375}], Scaled[{0, 0}, {0., 1.75}]}}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0., 3.9375}], Scaled[{-0.04, 0}, {0., 3.75}], 
        Scaled[{0, 0}, {0., 3.75}], Scaled[{0, 0}, {0., 3.9375}]}, {
       Scaled[{-0.04, 0}, {0., 3.4375}], Scaled[{-0.04, 0}, {0., 3.}], 
        Scaled[{0, 0}, {0., 3.}], Scaled[{0, 0}, {0., 3.4375}]}, {
       Scaled[{-0.04, 0}, {0., 2.4375}], Scaled[{-0.04, 0}, {0., 1.75}], 
        Scaled[{0, 0}, {0., 1.75}], Scaled[{0, 0}, {0., 2.4375}]}, {
       Scaled[{-0.04, 0}, {0., 0.9375}], Scaled[{-0.04, 0}, {0., 0.}], 
        Scaled[{0, 0}, {0., 0.}], Scaled[{0, 0}, {0., 0.9375}]}}], 
     {Opacity[0], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 1.546875}], 
        Scaled[{-0.02, 0}, {0., 1.140625}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 2.859375}], 
        Scaled[{-0.02, 0}, {0., 2.578125}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 3.671875}], 
        Scaled[{-0.02, 0}, {0., 3.515625}]}]}, 
     {Opacity[0], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 0.703125}], 
        Scaled[{-0.02, 0}, {0., 0.234375}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 2.265625}], 
        Scaled[{-0.02, 0}, {0., 1.921875}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 3.328125}], 
        Scaled[{-0.02, 0}, {0., 3.109375}]}]}, 
     {GrayLevel[0.4], Thickness[Small], Opacity[1], 
      LineBox[NCache[{{
         Scaled[{-0.04, 0}, {0., 3.9375}], {
          Rational[1, 4], Rational[63, 16]}, {Rational[1, 4], 0}}, {
         Scaled[{-0.04, 0}, {0., 3.75}], {Rational[1, 2], Rational[15, 4]}, {
          Rational[1, 2], 0}}, {
         Scaled[{-0.04, 0}, {0., 3.4375}], {
          Rational[3, 4], Rational[55, 16]}, {Rational[3, 4], 0}}, {
         Scaled[{-0.04, 0}, {0., 3.}], {1, 3}, {1, 0}}, {
         Scaled[{-0.04, 0}, {0., 2.4375}], {
          Rational[5, 4], Rational[39, 16]}, {Rational[5, 4], 0}}, {
         Scaled[{-0.04, 0}, {0., 1.75}], {Rational[3, 2], Rational[7, 4]}, {
          Rational[3, 2], 0}}, {
         Scaled[{-0.04, 0}, {0., 0.9375}], {
          Rational[7, 4], Rational[15, 16]}, {Rational[7, 4], 0}}, {
         Scaled[{-0.04, 0}, {0., 0.}], {2, 0}, {2, 0}}}, {{
         Scaled[{-0.04, 0}, {0., 3.9375}], {0.25, 3.9375}, {0.25, 0}}, {
         Scaled[{-0.04, 0}, {0., 3.75}], {0.5, 3.75}, {0.5, 0}}, {
         Scaled[{-0.04, 0}, {0., 3.4375}], {0.75, 3.4375}, {0.75, 0}}, {
         Scaled[{-0.04, 0}, {0., 3.}], {1, 3}, {1, 0}}, {
         Scaled[{-0.04, 0}, {0., 2.4375}], {1.25, 2.4375}, {1.25, 0}}, {
         Scaled[{-0.04, 0}, {0., 1.75}], {1.5, 1.75}, {1.5, 0}}, {
         Scaled[{-0.04, 0}, {0., 0.9375}], {1.75, 0.9375}, {1.75, 0}}, {
         Scaled[{-0.04, 0}, {0., 0.}], {2, 0}, {2, 0}}}]], 
      LineBox[{{0, 0}, {2, 0}}], 
      {RGBColor[1, 0, 0], PointSize[Medium], 
       PointBox[
        NCache[{{0, 4}, {Rational[1, 4], Rational[63, 16]}, {
          Rational[1, 2], Rational[15, 4]}, {
          Rational[3, 4], Rational[55, 16]}, {1, 3}, {
          Rational[5, 4], Rational[39, 16]}, {
          Rational[3, 2], Rational[7, 4]}, {
          Rational[7, 4], Rational[15, 16]}, {2, 0}}, {{0, 4}, {0.25, 
          3.9375}, {0.5, 3.75}, {0.75, 3.4375}, {1, 3}, {1.25, 2.4375}, {1.5, 
          1.75}, {1.75, 0.9375}, {2, 0}}]]}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1gk01NsfAHBrppQfnld/siRboWl7kl71vS9FWSqMrTT0bFHPUl6KyMio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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1710553625]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->1941321570]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"ArrowStyles - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 24, 59.4004624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "ArrowStyles an option for TimeIntervalPlot to set the styles of the \
arrows.", "synonyms" -> {}, "title" -> "ArrowStyles", "titlemodifier" -> "", 
    "windowtitle" -> "ArrowStyles", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/ArrowStyles"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4460, 133, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->245972510]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 43974, 1036}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 2428, 55, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3057, 80, 54, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3114, 83, 370, 11, 83, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3521, 99, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->185353122],
Cell[4133, 119, 88, 1, 70, "Notes",
 CellID->1067943069],
Cell[4224, 122, 108, 3, 70, "Notes",
 CellID->624705439],
Cell[4335, 127, 88, 1, 70, "Notes",
 CellID->376763090]
}, Closed]],
Cell[CellGroupData[{
Cell[4460, 133, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->245972510],
Cell[CellGroupData[{
Cell[4975, 151, 195, 6, 31, "ExampleSection",
 CellID->569210223],
Cell[5173, 159, 128, 3, 28, "Input",
 CellID->1475462274],
Cell[5304, 164, 127, 3, 32, "ExampleText",
 CellID->1100767209],
Cell[CellGroupData[{
Cell[5456, 171, 253, 8, 30, "Input",
 CellID->22862758],
Cell[5712, 181, 8558, 177, 382, "Output",
 CellID->2002284540]
}, Open  ]],
Cell[14285, 361, 77, 1, 70, "ExampleText",
 CellID->1327515290],
Cell[CellGroupData[{
Cell[14387, 366, 368, 11, 70, "Input",
 CellID->1341870347],
Cell[14758, 379, 8479, 178, 382, "Output",
 CellID->1451086209]
}, Open  ]],
Cell[23252, 560, 84, 1, 70, "ExampleText",
 CellID->1581619331],
Cell[CellGroupData[{
Cell[23361, 565, 577, 18, 70, "Input",
 CellID->723513551],
Cell[23941, 585, 8552, 178, 382, "Output",
 CellID->408339515]
}, Open  ]],
Cell[32508, 766, 66, 1, 70, "ExampleText",
 CellID->1751976440],
Cell[CellGroupData[{
Cell[32599, 771, 367, 11, 70, "Input",
 CellID->1319743063],
Cell[32969, 784, 8407, 177, 382, "Output",
 CellID->1710553625]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[41437, 968, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[41888, 983, 172, 4, 70, "MoreAbout",
 CellID->1941321570]
}, Open  ]],
Cell[42075, 990, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

