(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     14473,        473]
NotebookOptionsPosition[     10722,        356]
NotebookOutlinePosition[     12867,        413]
CellTagsIndexPosition[     12782,        408]
WindowTitle->AutoSimplify - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Using Integration Techniques Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
UsingIntegrationTechniquesFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"SubstituteIntegrate\"\>":>
       Documentation`HelpLookup["paclet:ClassroomUtilities/ref/SIntegrate"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Integration Techniques\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/IntegrationTechniques"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/AutoSimplify\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/AutoSimplify"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/AutoSimplify.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/AutoSimplify", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["AutoSimplify", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["AutoSimplify"], "InlineFormula"],
     " \[LineSeparator]AutoSimplify is an option for ",
     Cell[BoxData[
      ButtonBox["SubstituteIntegrate",
       BaseStyle->"Link",
       ButtonData->"paclet:IntegrationTechniques/ref/SubstituteIntegrate"]], 
      "InlineFormula"],
     " specifying whether the result should be simplified."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->77640869],

Cell["AutoSimplify can take the values True or False.", "Notes",
 CellID->1067943069],

Cell["The default value is False.", "Notes",
 CellID->1710631282]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->16771176],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->180615801],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->198538383],

Cell["This leaves unwanted variables in the integral.", "ExampleText",
 CellID->1792499290],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SubstituteIntegrate", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"x", "+", "1"}], 
    RowBox[{
     SuperscriptBox["x", "2"], "+", " ", 
     RowBox[{"2", " ", "x"}]}]], ",", "x", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["x", "2"], "+", " ", 
       RowBox[{"2", " ", "x"}]}], "\[Rule]", " ", "u"}], ",", 
     RowBox[{
      RowBox[{"\[DifferentialD]", "x"}], "\[Rule]", " ", 
      RowBox[{
       RowBox[{"\[DifferentialD]", "u"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "x"}], "+", "2"}], ")"}]}]}]}], "}"}]}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1634966914],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   FractionBox[
    RowBox[{"1", "+", "x"}], 
    RowBox[{"u", " ", 
     RowBox[{"(", 
      RowBox[{"2", "+", 
       RowBox[{"2", " ", "x"}]}], ")"}]}]], 
   RowBox[{"\[DifferentialD]", "u"}]}]}]], "Output",
 ImageSize->{100, 34},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1401168603]
}, Open  ]],

Cell["\<\
These are automatically removed using the option AutoSimplify.\
\>", "ExampleText",
 CellID->1191463229],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SubstituteIntegrate", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"x", "+", "1"}], 
    RowBox[{
     SuperscriptBox["x", "2"], "+", " ", 
     RowBox[{"2", " ", "x"}]}]], ",", "x", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{
       SuperscriptBox["x", "2"], "+", " ", 
       RowBox[{"2", " ", "x"}]}], "\[Rule]", " ", "u"}], ",", 
     RowBox[{
      RowBox[{"\[DifferentialD]", "x"}], "\[Rule]", " ", 
      RowBox[{
       RowBox[{"\[DifferentialD]", "u"}], "/", 
       RowBox[{"(", 
        RowBox[{
         RowBox[{"2", " ", "x"}], "+", "2"}], ")"}]}]}]}], "}"}], ",", 
   RowBox[{"AutoSimplify", "\[Rule]", " ", "True"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1784965175],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   FractionBox["1", 
    RowBox[{"2", " ", "u"}]], 
   RowBox[{"\[DifferentialD]", "u"}]}]}]], "Output",
 ImageSize->{56, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->135037619]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["SubstituteIntegrate",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/SIntegrate"],
  FontFamily->"Verdana"]], "InlineFormula"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Using Integration Techniques Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/UsingIntegrationTechniquesFunctions"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Integration Techniques",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/IntegrationTechniques"]], "MoreAbout",
 CellID->24914849]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"AutoSimplify - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 25, 6.3892624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "AutoSimplify AutoSimplify is an option for SubstituteIntegrate \
specifying whether the result should be simplified.", "synonyms" -> {}, 
    "title" -> "AutoSimplify", "titlemodifier" -> "", "windowtitle" -> 
    "AutoSimplify", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/AutoSimplify"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5358, 154, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->16771176]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 12640, 401}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[605, 21, 3249, 76, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3879, 101, 55, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3937, 104, 583, 16, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[4557, 125, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->77640869],
Cell[5168, 145, 85, 1, 70, "Notes",
 CellID->1067943069],
Cell[5256, 148, 65, 1, 70, "Notes",
 CellID->1710631282]
}, Closed]],
Cell[CellGroupData[{
Cell[5358, 154, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->16771176],
Cell[CellGroupData[{
Cell[5872, 172, 195, 6, 31, "ExampleSection",
 CellID->180615801],
Cell[6070, 180, 127, 3, 28, "Input",
 CellID->198538383],
Cell[6200, 185, 91, 1, 32, "ExampleText",
 CellID->1792499290],
Cell[CellGroupData[{
Cell[6316, 190, 683, 23, 45, "Input",
 CellID->1634966914],
Cell[7002, 215, 392, 14, 55, "Output",
 CellID->1401168603]
}, Open  ]],
Cell[7409, 232, 114, 3, 32, "ExampleText",
 CellID->1191463229],
Cell[CellGroupData[{
Cell[7548, 239, 739, 23, 45, "Input",
 CellID->1784965175],
Cell[8290, 264, 284, 10, 54, "Output",
 CellID->135037619]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8635, 281, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[9084, 296, 232, 6, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[9353, 307, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[9804, 322, 212, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[10053, 332, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[10504, 347, 176, 4, 70, "MoreAbout",
 CellID->24914849]
}, Open  ]],
Cell[10695, 354, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

