(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     35464,        835]
NotebookOptionsPosition[     31034,        696]
NotebookOutlinePosition[     33617,        767]
CellTagsIndexPosition[     33497,        761]
WindowTitle->BarStyles - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/BarStyles\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/BarStyles"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/BarStyles.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/BarStyles", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["BarStyles", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["BarStyles"], "InlineFormula"],
     "\[LineSeparator]an option for TimeIntervalPlot and IntegratePlot used \
to set the styles of the bars in the plot."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->240430713],

Cell["Any styles appropriate for use with polygons can be used.", "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The style for the edges of the bars is set using ",
 ButtonBox["EdgeForm",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/EdgeForm"],
 " as one of the style specifications."
}], "Notes",
 CellID->862606867]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->76062902],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->473268993],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->842923030],

Cell["The option values can be given in a list.", "ExampleText",
 CellID->99562197],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IPlot", "[", 
  RowBox[{
   RowBox[{"Sin", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "6"}], "}"}], ",", "12", ",", "\"\<Left\>\"", 
   ",", 
   RowBox[{"BarStyles", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Green", ",", " ", "Red"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->2056351094],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnSuUq74WxnPXNUgktrISORaJrBz5r7lrVVxR2SsrkZVjkUgkFomMjEVG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    "], {{0, 124}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 124},
  PlotRange->{{0, 360}, {0, 124}}]], "Output",
 ImageSize->{364, 124},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->558946706]
}, Open  ]],

Cell["To have all bars colored the same use a list of lists.", "ExampleText",
 CellID->1992819852],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IPlot", "[", 
  RowBox[{
   RowBox[{"Sin", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "6"}], "}"}], ",", "12", ",", "\"\<Left\>\"", 
   ",", 
   RowBox[{"BarStyles", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"EdgeForm", "[", "Black", "]"}], ",", " ", "Red"}], "}"}], 
     "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->139184604],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS2Uqzweh7NnDRIZi6xE1iKRlZVvzZ5TsaKyKyuRlWORSCQWiYyMRSIj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    "], {{0, 124}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 124},
  PlotRange->{{0, 360}, {0, 124}}]], "Output",
 ImageSize->{364, 124},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->931757679]
}, Open  ]],

Cell["Directive can also be used.", "ExampleText",
 CellID->452083966],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IPlot", "[", 
  RowBox[{
   RowBox[{"Sin", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "6"}], "}"}], ",", "12", ",", 
   "\"\<Center\>\"", ",", 
   RowBox[{"BarStyles", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Directive", "[", 
      RowBox[{
       RowBox[{"EdgeForm", "[", "Black", "]"}], ",", " ", "Yellow"}], "]"}], 
     "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->598650237],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS3YqsoWgOc+txCJVKKRaOW5iWjc8RgNJxitRqLRSiQSqUTixKkTJ070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    "], {{0, 111}, {324, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{324, 111},
  PlotRange->{{0, 324}, {0, 111}}]], "Output",
 ImageSize->{328, 111},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->21336589]
}, Open  ]],

Cell["\<\
A list with two elements distinguishes the positive from the negative bars \
\>", "ExampleText",
 CellID->1168293952],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IPlot", "[", 
  RowBox[{
   RowBox[{"Sin", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "6"}], "}"}], ",", "12", ",", 
   "\"\<Center\>\"", ",", 
   RowBox[{"BarStyles", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"EdgeForm", "[", "Black", "]"}], ",", " ", "Yellow"}], "]"}], 
      ",", 
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"EdgeForm", "[", "Yellow", "]"}], ",", "Red"}], "]"}]}], 
     "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1073466743],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnSG0ssoWgOetV4hEKtFItLJeIhpPvEbDDUYrkWg8lUgkUokTJ06dOHEi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    "], {{0, 111}, {324, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{324, 111},
  PlotRange->{{0, 324}, {0, 111}}]], "Output",
 ImageSize->{328, 111},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[5]=",
 CellID->58222816]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->842713115]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"BarStyles - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 25, 10.0708624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "BarStyles an option for TimeIntervalPlot and IntegratePlot used to set \
the styles of the bars in the plot.", "synonyms" -> {}, "title" -> 
    "BarStyles", "titlemodifier" -> "", "windowtitle" -> "BarStyles", "type" -> 
    "Symbol", "uri" -> "ClassroomUtilities/ref/BarStyles"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4510, 134, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->76062902]},
 "RasterizedOutput"->{
  Cell[5824, 183, 5834, 104, 145, "Output",
   CellTags->"RasterizedOutput",
   CellID->558946706],
  Cell[12232, 311, 5899, 105, 145, "Output",
   CellTags->"RasterizedOutput",
   CellID->931757679],
  Cell[18695, 440, 5406, 97, 132, "Output",
   CellTags->"RasterizedOutput",
   CellID->21336589],
  Cell[24875, 568, 5434, 97, 132, "Output",
   CellTags->"RasterizedOutput",
   CellID->58222816]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 32932, 741},
 {"RasterizedOutput", 33074, 745}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[602, 21, 2420, 55, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3047, 80, 52, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3102, 83, 400, 11, 83, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3539, 99, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->240430713],
Cell[4151, 119, 95, 1, 70, "Notes",
 CellID->1067943069],
Cell[4249, 122, 224, 7, 70, "Notes",
 CellID->862606867]
}, Closed]],
Cell[CellGroupData[{
Cell[4510, 134, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->76062902],
Cell[CellGroupData[{
Cell[5024, 152, 195, 6, 31, "ExampleSection",
 CellID->473268993],
Cell[5222, 160, 127, 3, 28, "Input",
 CellID->842923030],
Cell[5352, 165, 83, 1, 32, "ExampleText",
 CellID->99562197],
Cell[CellGroupData[{
Cell[5460, 170, 361, 11, 28, "Input",
 CellID->2056351094],
Cell[5824, 183, 5834, 104, 145, "Output",
 CellTags->"RasterizedOutput",
 CellID->558946706]
}, Open  ]],
Cell[11673, 290, 98, 1, 32, "ExampleText",
 CellID->1992819852],
Cell[CellGroupData[{
Cell[11796, 295, 433, 14, 28, "Input",
 CellID->139184604],
Cell[12232, 311, 5899, 105, 145, "Output",
 CellTags->"RasterizedOutput",
 CellID->931757679]
}, Open  ]],
Cell[18146, 419, 70, 1, 70, "ExampleText",
 CellID->452083966],
Cell[CellGroupData[{
Cell[18241, 424, 451, 14, 47, "Input",
 CellID->598650237],
Cell[18695, 440, 5406, 97, 132, "Output",
 CellTags->"RasterizedOutput",
 CellID->21336589]
}, Open  ]],
Cell[24116, 540, 127, 3, 70, "ExampleText",
 CellID->1168293952],
Cell[CellGroupData[{
Cell[24268, 547, 604, 19, 47, "Input",
 CellID->1073466743],
Cell[24875, 568, 5434, 97, 132, "Output",
 CellTags->"RasterizedOutput",
 CellID->58222816]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[30370, 672, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[30821, 687, 171, 4, 70, "MoreAbout",
 CellID->842713115]
}, Open  ]],
Cell[31007, 694, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

