(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     40371,        976]
NotebookOptionsPosition[     36256,        848]
NotebookOutlinePosition[     38574,        910]
CellTagsIndexPosition[     38454,        904]
WindowTitle->BarWidths - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/BarWidths\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/BarWidths"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/BarWidths.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/BarWidths", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["BarWidths", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["BarWidths"], "InlineFormula"],
     "\[LineSeparator]an option for ",
     Cell[BoxData[
      ButtonBox["TimeIntervalPlot",
       BaseStyle->"Link",
       ButtonData->"paclet:Differentiation/ref/TimeIntervalPlot"]], 
      "InlineFormula"],
     " that determines the widths of the bars. It should be given as a \
fraction of the width of the plot."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->118342929],

Cell["The default value for BarWidths is .04.", "Notes",
 CellID->1067943069],

Cell["\<\
The width of the bars is based on the width of the function plot.\
\>", "Notes",
 CellID->531976276],

Cell["\<\
The width of the bars can be affected by the setting for PlotRangeClipping.\
\>", "Notes",
 CellID->950848271],

Cell["The value should generally fall between 0.0 and .5.", "Notes",
 CellID->1968760636]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->118284056],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->641018334],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1481073370],

Cell["\<\
With the default setting the bars are .04 times the width of the function \
plot.\
\>", "ExampleText",
 CellID->917177213],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   SqrtBox["x"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "4"}], "}"}], ",", "8"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->359800725],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0., 0.}], 
        Scaled[{-0.04, 0}, {0., 0.7071067811865475}], 
        Scaled[{0, 0}, {0., 0.7071067811865475}], Scaled[{0, 0}, {0., 0.}]}, {
       Scaled[{-0.04, 0}, {0., 1.}], 
        Scaled[{-0.04, 0}, {0., 1.224744871391589}], 
        Scaled[{0, 0}, {0., 1.224744871391589}], Scaled[{0, 0}, {0., 1.}]}, {
       Scaled[{-0.04, 0}, {0., 1.4142135623730951`}], 
        Scaled[{-0.04, 0}, {0., 1.5811388300841898`}], 
        Scaled[{0, 0}, {0., 1.5811388300841898`}], 
        Scaled[{0, 0}, {0., 1.4142135623730951`}]}, {
       Scaled[{-0.04, 0}, {0., 1.7320508075688772`}], 
        Scaled[{-0.04, 0}, {0., 1.8708286933869707`}], 
        Scaled[{0, 0}, {0., 1.8708286933869707`}], 
        Scaled[{0, 0}, {0., 1.7320508075688772`}]}}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0., 0.7071067811865475}], 
        Scaled[{-0.04, 0}, {0., 1.}], Scaled[{0, 0}, {0., 1.}], 
        Scaled[{0, 0}, {0., 0.7071067811865475}]}, {
       Scaled[{-0.04, 0}, {0., 1.224744871391589}], 
        Scaled[{-0.04, 0}, {0., 1.4142135623730951`}], 
        Scaled[{0, 0}, {0., 1.4142135623730951`}], 
        Scaled[{0, 0}, {0., 1.224744871391589}]}, {
       Scaled[{-0.04, 0}, {0., 1.5811388300841898`}], 
        Scaled[{-0.04, 0}, {0., 1.7320508075688772`}], 
        Scaled[{0, 0}, {0., 1.7320508075688772`}], 
        Scaled[{0, 0}, {0., 1.5811388300841898`}]}, {
       Scaled[{-0.04, 0}, {0., 1.8708286933869707`}], 
        Scaled[{-0.04, 0}, {0., 2.}], Scaled[{0, 0}, {0., 2.}], 
        Scaled[{0, 0}, {0., 1.8708286933869707`}]}}], 
     {RGBColor[0.9, 0, 1.], Thickness[Medium], Opacity[0.95], Arrowheads[
      Small], ArrowBox[{
       Scaled[{-0.02, 0}, {0., 0.17677669529663687`}], 
        Scaled[{-0.02, 0}, {0., 0.5303300858899106}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 1.0561862178478973`}], 
        Scaled[{-0.02, 0}, {0., 1.1685586535436916`}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 1.455944879300869}], 
        Scaled[{-0.02, 0}, {0., 1.539407513156416}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 1.7667452790234006`}], 
        Scaled[{-0.02, 0}, {0., 1.8361342219324475`}]}], 
      {RGBColor[1, 0.95, 0], Thickness[Large], Opacity[0.95], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 0.7803300858899106}], 
         Scaled[{-0.02, 0}, {0., 0.9267766952966369}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 1.2721120441369655`}], 
         Scaled[{-0.02, 0}, {0., 1.3668463896277188`}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 1.6188668244553615`}], 
         Scaled[{-0.02, 0}, {0., 1.6943228131977055`}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 1.903121520040228}], 
         Scaled[{-0.02, 0}, {0., 1.9677071733467426`}]}]}, 
      {GrayLevel[0.4], Thickness[Small], Opacity[1], 
       LineBox[NCache[{{
          Scaled[{-0.04, 0}, {0., 0.7071067811865475}], {
           Rational[1, 2], 2^Rational[-1, 2]}, {Rational[1, 2], 0}}, {
          Scaled[{-0.04, 0}, {0., 1.}], {1, 1}, {1, 0}}, {
          Scaled[{-0.04, 0}, {0., 1.224744871391589}], {
           Rational[3, 2], Rational[3, 2]^Rational[1, 2]}, {
           Rational[3, 2], 0}}, {
          Scaled[{-0.04, 0}, {0., 1.4142135623730951`}], {
           2, 2^Rational[1, 2]}, {2, 0}}, {
          Scaled[{-0.04, 0}, {0., 1.5811388300841898`}], {
           Rational[5, 2], Rational[5, 2]^Rational[1, 2]}, {
           Rational[5, 2], 0}}, {
          Scaled[{-0.04, 0}, {0., 1.7320508075688772`}], {
           3, 3^Rational[1, 2]}, {3, 0}}, {
          Scaled[{-0.04, 0}, {0., 1.8708286933869707`}], {
           Rational[7, 2], Rational[7, 2]^Rational[1, 2]}, {
           Rational[7, 2], 0}}, {
          Scaled[{-0.04, 0}, {0., 2.}], {4, 2}, {4, 0}}}, {{
          Scaled[{-0.04, 0}, {0., 0.7071067811865475}], {0.5, 
           0.7071067811865475}, {0.5, 0}}, {
          Scaled[{-0.04, 0}, {0., 1.}], {1, 1}, {1, 0}}, {
          Scaled[{-0.04, 0}, {0., 1.224744871391589}], {1.5, 
           1.224744871391589}, {1.5, 0}}, {
          Scaled[{-0.04, 0}, {0., 1.4142135623730951`}], {
           2, 1.4142135623730951`}, {2, 0}}, {
          Scaled[{-0.04, 0}, {0., 1.5811388300841898`}], {2.5, 
           1.5811388300841898`}, {2.5, 0}}, {
          Scaled[{-0.04, 0}, {0., 1.7320508075688772`}], {
           3, 1.7320508075688772`}, {3, 0}}, {
          Scaled[{-0.04, 0}, {0., 1.8708286933869707`}], {3.5, 
           1.8708286933869707`}, {3.5, 0}}, {
          Scaled[{-0.04, 0}, {0., 2.}], {4, 2}, {4, 0}}}]], 
       LineBox[{{0, 0}, {4, 0}}], 
       {RGBColor[1, 0, 0], PointSize[Medium], 
        PointBox[
         NCache[{{0, 0}, {Rational[1, 2], 2^Rational[-1, 2]}, {1, 1}, {
           Rational[3, 2], Rational[3, 2]^Rational[1, 2]}, {
           2, 2^Rational[1, 2]}, {
           Rational[5, 2], Rational[5, 2]^Rational[1, 2]}, {
           3, 3^Rational[1, 2]}, {
           Rational[7, 2], Rational[7, 2]^Rational[1, 2]}, {4, 2}}, {{0, 0}, {
           0.5, 0.7071067811865475}, {1, 1}, {1.5, 1.224744871391589}, {
           2, 1.4142135623730951`}, {2.5, 1.5811388300841898`}, {
           3, 1.7320508075688772`}, {3.5, 1.8708286933869707`}, {4, 
           2}}]]}}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVk/k/1PkDx92mHJ9V2xaJhxyVK9tubLX1estuRKdIJCpqSwp9qXT5iqlU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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->2004318770]
}, Open  ]],

Cell[TextData[{
 "This makes the width of the bars ",
 Cell[BoxData[
  FractionBox["1", "8"]], "InlineFormula"],
 " the distance across the plot of ",
 Cell[BoxData[
  SqrtBox["x"]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->1157080548],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   SqrtBox["x"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "4"}], "}"}], ",", "8", ",", 
   RowBox[{"BarWidths", "\[Rule]", " ", ".125"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1588346651],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.125, 0}, {0., 0.}], 
        Scaled[{-0.125, 0}, {0., 0.7071067811865475}], 
        Scaled[{0, 0}, {0., 0.7071067811865475}], Scaled[{0, 0}, {0., 0.}]}, {
       Scaled[{-0.125, 0}, {0., 1.}], 
        Scaled[{-0.125, 0}, {0., 1.224744871391589}], 
        Scaled[{0, 0}, {0., 1.224744871391589}], Scaled[{0, 0}, {0., 1.}]}, {
       Scaled[{-0.125, 0}, {0., 1.4142135623730951`}], 
        Scaled[{-0.125, 0}, {0., 1.5811388300841898`}], 
        Scaled[{0, 0}, {0., 1.5811388300841898`}], 
        Scaled[{0, 0}, {0., 1.4142135623730951`}]}, {
       Scaled[{-0.125, 0}, {0., 1.7320508075688772`}], 
        Scaled[{-0.125, 0}, {0., 1.8708286933869707`}], 
        Scaled[{0, 0}, {0., 1.8708286933869707`}], 
        Scaled[{0, 0}, {0., 1.7320508075688772`}]}}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.125, 0}, {0., 0.7071067811865475}], 
        Scaled[{-0.125, 0}, {0., 1.}], Scaled[{0, 0}, {0., 1.}], 
        Scaled[{0, 0}, {0., 0.7071067811865475}]}, {
       Scaled[{-0.125, 0}, {0., 1.224744871391589}], 
        Scaled[{-0.125, 0}, {0., 1.4142135623730951`}], 
        Scaled[{0, 0}, {0., 1.4142135623730951`}], 
        Scaled[{0, 0}, {0., 1.224744871391589}]}, {
       Scaled[{-0.125, 0}, {0., 1.5811388300841898`}], 
        Scaled[{-0.125, 0}, {0., 1.7320508075688772`}], 
        Scaled[{0, 0}, {0., 1.7320508075688772`}], 
        Scaled[{0, 0}, {0., 1.5811388300841898`}]}, {
       Scaled[{-0.125, 0}, {0., 1.8708286933869707`}], 
        Scaled[{-0.125, 0}, {0., 2.}], Scaled[{0, 0}, {0., 2.}], 
        Scaled[{0, 0}, {0., 1.8708286933869707`}]}}], 
     {RGBColor[0.9, 0, 1.], Thickness[Medium], Opacity[0.95], Arrowheads[
      Small], ArrowBox[{
       Scaled[{-0.0625, 0}, {0., 0.17677669529663687`}], 
        Scaled[{-0.0625, 0}, {0., 0.5303300858899106}]}], 
      ArrowBox[{
       Scaled[{-0.0625, 0}, {0., 1.0561862178478973`}], 
        Scaled[{-0.0625, 0}, {0., 1.1685586535436916`}]}], 
      ArrowBox[{
       Scaled[{-0.0625, 0}, {0., 1.455944879300869}], 
        Scaled[{-0.0625, 0}, {0., 1.539407513156416}]}], 
      ArrowBox[{
       Scaled[{-0.0625, 0}, {0., 1.7667452790234006`}], 
        Scaled[{-0.0625, 0}, {0., 1.8361342219324475`}]}], 
      {RGBColor[1, 0.95, 0], Thickness[Large], Opacity[0.95], 
       ArrowBox[{
        Scaled[{-0.0625, 0}, {0., 0.7803300858899106}], 
         Scaled[{-0.0625, 0}, {0., 0.9267766952966369}]}], 
       ArrowBox[{
        Scaled[{-0.0625, 0}, {0., 1.2721120441369655`}], 
         Scaled[{-0.0625, 0}, {0., 1.3668463896277188`}]}], 
       ArrowBox[{
        Scaled[{-0.0625, 0}, {0., 1.6188668244553615`}], 
         Scaled[{-0.0625, 0}, {0., 1.6943228131977055`}]}], 
       ArrowBox[{
        Scaled[{-0.0625, 0}, {0., 1.903121520040228}], 
         Scaled[{-0.0625, 0}, {0., 1.9677071733467426`}]}]}, 
      {GrayLevel[0.4], Thickness[Small], Opacity[1], 
       LineBox[NCache[{{
          Scaled[{-0.125, 0}, {0., 0.7071067811865475}], {
           Rational[1, 2], 2^Rational[-1, 2]}, {Rational[1, 2], 0}}, {
          Scaled[{-0.125, 0}, {0., 1.}], {1, 1}, {1, 0}}, {
          Scaled[{-0.125, 0}, {0., 1.224744871391589}], {
           Rational[3, 2], Rational[3, 2]^Rational[1, 2]}, {
           Rational[3, 2], 0}}, {
          Scaled[{-0.125, 0}, {0., 1.4142135623730951`}], {
           2, 2^Rational[1, 2]}, {2, 0}}, {
          Scaled[{-0.125, 0}, {0., 1.5811388300841898`}], {
           Rational[5, 2], Rational[5, 2]^Rational[1, 2]}, {
           Rational[5, 2], 0}}, {
          Scaled[{-0.125, 0}, {0., 1.7320508075688772`}], {
           3, 3^Rational[1, 2]}, {3, 0}}, {
          Scaled[{-0.125, 0}, {0., 1.8708286933869707`}], {
           Rational[7, 2], Rational[7, 2]^Rational[1, 2]}, {
           Rational[7, 2], 0}}, {
          Scaled[{-0.125, 0}, {0., 2.}], {4, 2}, {4, 0}}}, {{
          Scaled[{-0.125, 0}, {0., 0.7071067811865475}], {0.5, 
           0.7071067811865475}, {0.5, 0}}, {
          Scaled[{-0.125, 0}, {0., 1.}], {1, 1}, {1, 0}}, {
          Scaled[{-0.125, 0}, {0., 1.224744871391589}], {1.5, 
           1.224744871391589}, {1.5, 0}}, {
          Scaled[{-0.125, 0}, {0., 1.4142135623730951`}], {
           2, 1.4142135623730951`}, {2, 0}}, {
          Scaled[{-0.125, 0}, {0., 1.5811388300841898`}], {2.5, 
           1.5811388300841898`}, {2.5, 0}}, {
          Scaled[{-0.125, 0}, {0., 1.7320508075688772`}], {
           3, 1.7320508075688772`}, {3, 0}}, {
          Scaled[{-0.125, 0}, {0., 1.8708286933869707`}], {3.5, 
           1.8708286933869707`}, {3.5, 0}}, {
          Scaled[{-0.125, 0}, {0., 2.}], {4, 2}, {4, 0}}}]], 
       LineBox[{{0, 0}, {4, 0}}], 
       {RGBColor[1, 0, 0], PointSize[Medium], 
        PointBox[
         NCache[{{0, 0}, {Rational[1, 2], 2^Rational[-1, 2]}, {1, 1}, {
           Rational[3, 2], Rational[3, 2]^Rational[1, 2]}, {
           2, 2^Rational[1, 2]}, {
           Rational[5, 2], Rational[5, 2]^Rational[1, 2]}, {
           3, 3^Rational[1, 2]}, {
           Rational[7, 2], Rational[7, 2]^Rational[1, 2]}, {4, 2}}, {{0, 0}, {
           0.5, 0.7071067811865475}, {1, 1}, {1.5, 1.224744871391589}, {
           2, 1.4142135623730951`}, {2.5, 1.5811388300841898`}, {
           3, 1.7320508075688772`}, {3.5, 1.8708286933869707`}, {4, 
           2}}]]}}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVk/k/1PkDx92mHJ9V2xaJhxyVK9tubLX1estuRKdIJCpqSwp9qXT5iqlU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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 334},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->2120431147]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Possible Issues",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->595165664],

Cell["\<\
The setting for PlotRangeClipping can interfere with the setting for \
BarWidths.\
\>", "ExampleText",
 CellID->2117970769],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"TimeIntervalPlot", "[", 
    RowBox[{
     SqrtBox["x"], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "4"}], "}"}], ",", "8", ",", 
     RowBox[{"BarWidths", "\[Rule]", " ", ".125"}]}], "]"}], ",", 
   RowBox[{"TimeIntervalPlot", "[", 
    RowBox[{
     SqrtBox["x"], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "4"}], "}"}], ",", "8", ",", 
     RowBox[{"BarWidths", "\[Rule]", " ", ".125"}], ",", 
     RowBox[{"PlotRangeClipping", "\[Rule]", " ", "True"}]}], "]"}]}], 
  "}"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->657432551],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS10q8C3xfvWM5WVtZWRkbFXVkZG/pGIJ5CotxYSicQikUjEM0gkEotE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    "], {{0, 193}, {385, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{385, 193},
  PlotRange->{{0, 385}, {0, 193}}]], "Output",
 ImageSize->{389, 193},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->31866738]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->824671840]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"BarWidths - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 25, 13.9708624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "BarWidths an option for TimeIntervalPlot that determines the widths of \
the bars. It should be given as a fraction of the width of the plot.", 
    "synonyms" -> {}, "title" -> "BarWidths", "titlemodifier" -> "", 
    "windowtitle" -> "BarWidths", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/BarWidths"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4774, 143, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->118284056]},
 "RasterizedOutput"->{
  Cell[25692, 648, 9838, 169, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->31866738]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 38188, 893},
 {"RasterizedOutput", 38331, 897}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[602, 21, 2421, 55, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3048, 80, 52, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3103, 83, 580, 16, 99, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3720, 104, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->118342929],
Cell[4332, 124, 77, 1, 70, "Notes",
 CellID->1067943069],
Cell[4412, 127, 110, 3, 70, "Notes",
 CellID->531976276],
Cell[4525, 132, 120, 3, 70, "Notes",
 CellID->950848271],
Cell[4648, 137, 89, 1, 70, "Notes",
 CellID->1968760636]
}, Closed]],
Cell[CellGroupData[{
Cell[4774, 143, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->118284056],
Cell[CellGroupData[{
Cell[5289, 161, 195, 6, 31, "ExampleSection",
 CellID->641018334],
Cell[5487, 169, 128, 3, 28, "Input",
 CellID->1481073370],
Cell[5618, 174, 132, 4, 32, "ExampleText",
 CellID->917177213],
Cell[CellGroupData[{
Cell[5775, 182, 217, 7, 37, "Input",
 CellID->359800725],
Cell[5995, 191, 8918, 191, 382, "Output",
 CellID->2004318770]
}, Open  ]],
Cell[14928, 385, 245, 9, 70, "ExampleText",
 CellID->1157080548],
Cell[CellGroupData[{
Cell[15198, 398, 274, 8, 70, "Input",
 CellID->1588346651],
Cell[15475, 408, 8982, 191, 355, "Output",
 CellID->2120431147]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[24506, 605, 278, 8, 70, "ExampleSection",
 CellID->1305812373],
Cell[24787, 615, 127, 3, 70, "Input",
 CellID->595165664],
Cell[24917, 620, 133, 4, 70, "ExampleText",
 CellID->2117970769],
Cell[CellGroupData[{
Cell[25075, 628, 614, 18, 70, "Input",
 CellID->657432551],
Cell[25692, 648, 9838, 169, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->31866738]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[35591, 824, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[36042, 839, 172, 4, 70, "MoreAbout",
 CellID->824671840]
}, Open  ]],
Cell[36229, 846, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

