(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     18644,        486]
NotebookOptionsPosition[     15255,        383]
NotebookOutlinePosition[     17370,        440]
CellTagsIndexPosition[     17285,        435]
WindowTitle->CapStyle - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Working with Riemann Sums\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/WorkingWithRiemannSums"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Shell\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/Shell"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities/ref/CapStyle\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/CapStyle"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/CapStyle.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/CapStyle", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["CapStyle", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["CapStyle"], "InlineFormula"],
     "\[LineSeparator]an option for RiemannSumPlot3D to set the style for \
flat surfaces of washers and shells."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->268714648],

Cell["\<\
Values for the option can include color specifications, EdgeForm and Opacity.\
\>", "Notes",
 CellID->1067943069]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->179700559],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->16052914],

Cell["This loads the package", "ExampleText",
 CellID->783567506],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1049349938],

Cell["Change the style of the ends of a shell.", "ExampleText",
 CellID->1288698802],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"{", 
   RowBox[{"Blue", ",", 
    RowBox[{"Shell", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"1", "/", "2"}], ",", "1", ",", "0", ",", "2"}], "}"}], ",", 
      RowBox[{"CapStyle", "\[Rule]", " ", 
       RowBox[{"{", 
        RowBox[{"Red", ",", 
         RowBox[{"EdgeForm", "[", "Yellow", "]"}]}], "}"}]}]}], "]"}]}], 
   "}"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1788185219],

Cell[BoxData[
 Graphics3DBox[
  {RGBColor[0, 0, 1], GraphicsComplex3DBox[CompressedData["
1:eJx111Fol1UYBvD/llTkBAO3pm5ZN94NgqDlGnwPQThByFYXFetGWIU3XhS1
1Vr+8aLNjXREEV1IeSHivIzVxeCtIG/W5qhmkejGGjI2miHVBIOCnec9H98L
zy4UHv9+nu887zm/v48ePd7b31ir1R5pqNXuqfnPUlELP+eaW7/8aWmxaKx/
9/XVZ8/nP3+orT4+dnKxGH1j+/CerqmcN1vPweurN4oz93707Xtnvsl5W0fv
0/88eKP4e/upNy/8/n3OX/ul47HB2vXi+U873+5omsn55OEXV9+Zulb8t/Vz
JecHP2h+afiJ34qBQ0N3pl/+MecHjlw5d/zkr0VbS3fvVxM/53z2qfdfPfv5
1eIH/u55Oz/nf8/zQT7X/x3PG7Z+nS8ucl2e+7r9PTzf5Hvu5Xt77vvi++T5
OPfR99Xzndx378Hz+/p2Pb7/fL079rZ5YuvzFj8/kp5v8fkfpvVYXA97sraw
/ufS+9rr4X3/TT3ZZNift9J+2qGwn9x/i/vPnmw29PVk+pw9HPp9Jj3X3g3z
wHVYnB/2ZC+EeWNPdifM5660L/ZxmGfuo30S5p/7btvCeWFPlnqb6I6fv83e
PG/l84fZm+fsySbYm+fsyf5ib56zJzvC3jy/xP25y948Z0/mvXnOnoznK+dz
7Mt785w9mffmOXsy783zbVu/ztsFrsvzPq67n+/heUNTes89fG/PwzznfLQ6
/zm/v145Lzl/4NTZwwcGP5v23jzfOFE5jzkf4hy0huePcG5awnrWOWftYf09
nMtj8X3T/vj9k/OB6n1VzgPPSVfY/xmeq7nQVyfP4b7QL3sqhsI8sKfCe/Oc
PRWvhHnbzXuksak6n37vnA7z7PfUWJh/v9d21KvnhT1FvyD8gvALwi8IvyD8
gvALwi8IvyD8gvALwi8IvyD8gvALwi8IvyD8gvALwi8IvyD8gvALwi8IvyD8
gvALwi8IvyD8gvALwi8IvyD8gvALwi+wp+gXhF8QfkH4BeEXhF8QfkH4BeEX
hF8QfkH4BeEXhF8QfsV5zrnwC8IvCL8g/ILwC8IvCL8g/Ir3T86FXxB+QfgF
4ReEXxB+QfgF4ReEXxB+QfiF9Nuf0S96d4t+ld8z0/Nv0a/LOU/r2aBf8zlP
52uDfi2E78N/0K/ye3u6f9bpV/n/hdTTGv1aznk6X6v0ayXn6R68Sb9uhu//
K4X/Pc8H+Vz/dzxP87PE+VnPua/b38PzTb7nXr63574vvk+ej3MffV8938l9
9x48r96DZW/JrymLn09+Xbb4/HTe5y2uhz1ZW1h/8usa/SrfN/m1aJNhf9I9
uEy/1uL+W9x/9mSzoa90D67Sr7LfdL7W6NdynB+L88Oe6Fc5b+yJfpXzmfza
oF/zcf7pVzn/3Hf6VZ4X9kS/vuiOn7/N3jxv5fOH2Zvn7Il+ld972RP9Wsg5
e6Jf5ff2S9yfu+zNc/Zk3pvn7Il+reR8jn15b56zJ/PePGdP5r15nu7BJfq1
nvM+rruf7+F58muBfm3kPMxzzker85/z5Fc+LzlPfl2c9t48T37l85jzIc5B
a3j+COemJaxnnXPWHtbfw7k8Ft837Y/fPzkfqN5X5TzwnHSF/Z/huZoLfXXy
HO4L/bIn+lXOA3sqvDfP2RP9KudtN++RxqbqfPq9czrMs99TY2H+/V7bUa+e
F/YU/YLwC8IvCL8g/ILwC8IvCL8g/ILwC8IvCL8g/ILwC8IvCL8g/ILwC8Iv
CL8g/ILwC8IvCL8g/ILwC8IvCL8g/ILwC8IvCL8g/ILwC8IvCL/AnqJfEH5B
+AXhF4RfEH5B+AXhF4RfEH5B+AXhF4RfEH5B+BXnOefCLwi/IPyC8AvCLwi/
IPyC8CvePzkXfkH4BeEXhF8QfkH4BeEXhF8QfkH4BeEX/gf/p/Ek
    "], {
     {EdgeForm[None], Polygon3DBox[CompressedData["
1:eJwtl2W0VmUUBve+l+7utLtbVESxFcVuxS7AVgwQEBMFu8Xu7u7u7u7uzm/W
nh+z3jPrmf9n7aFjxo0e2xQRQzKiufGu2aDxGU2Cr9XgjQYzG5wk+JtudM2C
r+1Gd7Lgb7nRtRB8HTe6UwR/242upeDrutGdKvg7bnStBF/Pje40wd91o2st
+Cg3utMFf8+Nro3g67vRnSH4+250bQXfwI3uTME/cKNrJ/hoN7qzBP/Qja69
4Bu60Z0t+EdudB0E38iN7hzBP3aj6yj4xm505wr+iRtdJ8E3caM7T/BP3eg6
C76pG935gn/mRtdF8M3c6GYJ/rkbXVfBN3eju0DwL9zougm+hRvdhYJ/6UbX
XfAt3eguEvwrN7oegm/lRnex4F+70fUUfGs3uksE/8aNrpfg27jRXSr4t250
vQXf1o3uMsG/c6PrI/h2bnSXC/69G11fwbd3o7tC8B/c6PoJPsaN7krBf3Sj
6y/4Dm50Vwn+kxvdAMF3dKO7WvCf3egGCr6TG901gv/iRjdI8J3d6K4V/Fc3
usGC7+JGd53gv7nRDRF8Vze66wX/3Y1uqOC7udHdIPgfbnSzCb67G92Ngv/p
Rje74Hu40d0k+F9udHMIvqcb3c2C/+1GN6fge7nR3SL4P250cwk+1o3uVsH/
daObW/BxbnS3Cf6fG908go93o7tdcH6k4+3mFXxvN7o7BM+sjW4+wfeJ2uju
FLwpa6ObX/B9oza6uwRvztroFhB8v6iN7m7BW2RtdAsKvn/URneP4C2zNrqF
BD8gaqO7V/BWWRvdwoIfGLXR3Sd466yNbhHBD4ra6O4XvE3WRreo4AdHbXQP
CN42a6NbTPAJURvdg4K3y9roFhf8kKiN7iHB22dtdEsIfmjURvew4B2yNrol
BT8saqN7RPCOWRvdUoIfHrXRPSp4p6yNbmnBJ0ZtdI8J3jlro1tG8ElRG93j
gnfJ2uiWFfyIqI3uCcG7Zm10ywk+OWqje1Lwblkb3fKCT4na6J4SvHvWRjdM
8KlRG93TgvfI2uhWEPzIqI3uGcF7Zm10Kwo+LWqje1bwXlkb3UqCHxW10T0n
eO+sjW644EdHbXTPC94na6NbWfBjoja6FwTvm7XRjRD82KiN7kXB+2VtdKsI
flzURveS4P2zNrpVBT8+aqN7WfABWRvdSMGnR210rwg+MGujW03wE6I2ulcF
H5S10a0u+IlRG91rgg/O2ujWEHxG1Eb3uuDcVDPsUnBuKja6mYJzU/0PUP2G
+w==
       "]]}, 
     {RGBColor[1, 0, 0], EdgeForm[RGBColor[1, 1, 0]], 
      Polygon3DBox[CompressedData["
1:eJwt0mO0EAYYx+GbbfPmtmzbXFwtu2W3uGzbLS9sadm2lm1r2a167ul+eM77
fv6df/LG7au2CxkQEBBkAiGC/1CEJgxhCUd4IhCRSEQmClGJRnRiEJNYxCYO
cYlHfBKQkEQkJglJCSQZyUlBSlKRmjSk5Qd+JB3pyUBGMpGZLGQlG9nJQU5y
kZs85CUf+SlAQQpRmCIUpRjFKUFJSlGaMsF9xnOB85zjLGc4zSlO8i8nOM4x
jnKEwxziIAfYzz72sofd7GInO9jONrayhc1sYiMbWM861rKGf1jNKlayguX8
zV8sYylLWMyfLGIhC5jPPOYyhz+YzSxmMoPpTGMqU5jMJCYGfN9QUJ+ylKM8
FajIT1SiMlWoSjWq8zM1qMkv1KI2dahLPerTgIY0ojFNaEozmvMrLWhJK1rT
hra0oz0d6EgnOtOFrvxGN7rTg570oje/04e+9KM/AxjIIAYzhKEMYzgjGMko
RjOGsYwL7nORZAYVSFKSkJhEJCQB8YlHXOIQm1jEJAbRiUZUohCZSEQkAuEJ
R1jCEJpQhCRE0Jj56nzhfz7ziY984D3veMsbXvOKl7zgOc/4j6c84TGPeMgD
7nOPu9zhNre4yQ2uc42rXOEyl4L7fAMr1IWu
       "]]}}]}]], "Output",
 ImageSize->{184, 195},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1068509115,
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["Shell",
   BaseStyle->"Link",
   ButtonData->"paclet:Classroom Utilities/ref/Shell"],
  FontFamily->"Verdana"]], "InlineFormula"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Working with Riemann Sums",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/WorkingWithRiemannSums"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"CapStyle - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 25, 17.8240624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "CapStyle an option for RiemannSumPlot3D to set the style for flat \
surfaces of washers and shells.", "synonyms" -> {}, "title" -> "CapStyle", 
    "titlemodifier" -> "", "windowtitle" -> "CapStyle", "type" -> "Symbol", 
    "uri" -> "Classroom Utilities/ref/CapStyle"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4583, 134, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->179700559]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 17142, 428}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 2703, 62, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3329, 87, 51, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3383, 90, 391, 11, 83, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3811, 106, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->268714648],
Cell[4423, 126, 123, 3, 70, "Notes",
 CellID->1067943069]
}, Closed]],
Cell[CellGroupData[{
Cell[4583, 134, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->179700559],
Cell[CellGroupData[{
Cell[5098, 152, 194, 6, 31, "ExampleSection",
 CellID->16052914],
Cell[5295, 160, 65, 1, 32, "ExampleText",
 CellID->783567506],
Cell[5363, 163, 128, 3, 28, "Input",
 CellID->1049349938],
Cell[5494, 168, 84, 1, 32, "ExampleText",
 CellID->1288698802],
Cell[CellGroupData[{
Cell[5603, 173, 476, 15, 28, "Input",
 CellID->1788185219],
Cell[6082, 190, 7734, 136, 216, 4167, 73, "CachedBoxData", "BoxData", "Output",
 CellID->1068509115]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13877, 333, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[14326, 348, 214, 6, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[14577, 359, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[15028, 374, 185, 4, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[15228, 381, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

