(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     13399,        441]
NotebookOptionsPosition[      9894,        332]
NotebookOutlinePosition[     12025,        389]
CellTagsIndexPosition[     11940,        384]
WindowTitle->ChangeIndices - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Series Solutions of ODEs\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/SeriesSolutionsOfODEs"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Calculus Applications\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/CalculusApplications"], \
"\<\"Classroom Utilities\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/ChangeIndices\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/ChangeIndices"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/ChangeIndices.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/ChangeIndices", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["ChangeIndices", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"ChangeIndices", "[", 
       RowBox[{
        StyleBox["sum", "TI"], ",", " ", 
        StyleBox["index", "TI"], ",", " ", 
        StyleBox["newindex", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]adjusts the index set in the series from index to new \
index."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->771486475],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->176602863],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->884588361],

Cell["Adjust the exponents on the second derivative of a series.", \
"ExampleText",
 CellID->2117930291],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeSeries", "[", 
  RowBox[{"x", ",", " ", "a", ",", " ", "n", ",", " ", "2"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1512951812],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"n", "=", "0"}], "\[Infinity]"], 
    RowBox[{
     SuperscriptBox["x", "n"], " ", 
     RowBox[{"a", "[", "n", "]"}]}]}], ",", 
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"n", "=", "0"}], "\[Infinity]"], 
    RowBox[{"n", " ", 
     SuperscriptBox["x", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "n"}]], " ", 
     RowBox[{"a", "[", "n", "]"}]}]}], ",", 
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"n", "=", "0"}], "\[Infinity]"], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "n"}], ")"}], " ", "n", " ", 
     SuperscriptBox["x", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "n"}]], " ", 
     RowBox[{"a", "[", "n", "]"}]}]}]}], "}"}]], "Output",
 ImageSize->{325, 38},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1974723804]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ChangeIndices", "[", 
  RowBox[{
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"n", "=", "0"}], "\[Infinity]"], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", "n"}], ")"}], " ", "n", " ", 
     SuperscriptBox["x", 
      RowBox[{
       RowBox[{"-", "2"}], "+", "n"}]], " ", 
     RowBox[{"a", "[", "n", "]"}]}]}], ",", "n", ",", 
   RowBox[{"n", "+", "2"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1970693090],

Cell[BoxData[
 RowBox[{
  UnderoverscriptBox["\[Sum]", 
   RowBox[{"n", "=", 
    RowBox[{"-", "2"}]}], "\[Infinity]"], 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "+", "n"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"2", "+", "n"}], ")"}], " ", 
   SuperscriptBox["x", "n"], " ", 
   RowBox[{"a", "[", 
    RowBox[{"2", "+", "n"}], "]"}]}]}]], "Output",
 ImageSize->{178, 38},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->798475949]
}, Open  ]],

Cell["Change the sum to start from 0.", "ExampleText",
 CellID->359964740],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PartitionSum", "[", 
  RowBox[{
   RowBox[{
    UnderoverscriptBox["\[Sum]", 
     RowBox[{"n", "=", 
      RowBox[{"-", "2"}]}], "\[Infinity]"], 
    RowBox[{
     RowBox[{"(", 
      RowBox[{"1", "+", "n"}], ")"}], " ", 
     RowBox[{"(", 
      RowBox[{"2", "+", "n"}], ")"}], " ", 
     SuperscriptBox["x", "n"], " ", 
     RowBox[{"a", "[", 
      RowBox[{"2", "+", "n"}], "]"}]}]}], ",", "0"}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->465951581],

Cell[BoxData[
 RowBox[{
  UnderoverscriptBox["\[Sum]", 
   RowBox[{"n", "=", "0"}], "\[Infinity]"], 
  RowBox[{
   RowBox[{"(", 
    RowBox[{"1", "+", "n"}], ")"}], " ", 
   RowBox[{"(", 
    RowBox[{"2", "+", "n"}], ")"}], " ", 
   SuperscriptBox["x", "n"], " ", 
   RowBox[{"a", "[", 
    RowBox[{"2", "+", "n"}], "]"}]}]}]], "Output",
 ImageSize->{173, 38},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->744213389]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Series Solutions of ODEs",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/SeriesSolutionsOfODEs"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Calculus Applications",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/CalculusApplications"]], "MoreAbout",
 CellID->334735727],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->564169356]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"ChangeIndices - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 25, 21.2404624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "ChangeIndices[sum, index, newindex] adjusts the index set in the series \
from index to new index.", "synonyms" -> {}, "title" -> "ChangeIndices", 
    "titlemodifier" -> "", "windowtitle" -> "ChangeIndices", "type" -> 
    "Symbol", "uri" -> "ClassroomUtilities/ref/ChangeIndices"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4138, 114, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->771486475]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 11797, 377}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[606, 21, 2895, 66, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3526, 91, 56, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3585, 94, 516, 15, 83, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4138, 114, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->771486475],
Cell[CellGroupData[{
Cell[4653, 132, 195, 6, 31, "ExampleSection",
 CellID->176602863],
Cell[4851, 140, 127, 3, 28, "Input",
 CellID->884588361],
Cell[4981, 145, 104, 2, 32, "ExampleText",
 CellID->2117930291],
Cell[CellGroupData[{
Cell[5110, 151, 165, 4, 28, "Input",
 CellID->1512951812],
Cell[5278, 157, 955, 32, 59, "Output",
 CellID->1974723804]
}, Open  ]],
Cell[CellGroupData[{
Cell[6270, 194, 491, 16, 50, "Input",
 CellID->1970693090],
Cell[6764, 212, 488, 17, 59, "Output",
 CellID->798475949]
}, Open  ]],
Cell[7267, 232, 74, 1, 32, "ExampleText",
 CellID->359964740],
Cell[CellGroupData[{
Cell[7366, 237, 484, 16, 50, "Input",
 CellID->465951581],
Cell[7853, 255, 468, 16, 59, "Output",
 CellID->744213389]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8382, 278, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[8833, 293, 182, 4, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[9052, 302, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[9503, 317, 175, 4, 70, "MoreAbout",
 CellID->334735727],
Cell[9681, 323, 171, 4, 70, "MoreAbout",
 CellID->564169356]
}, Open  ]],
Cell[9867, 330, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

