(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     13033,        421]
NotebookOptionsPosition[      9419,        309]
NotebookOutlinePosition[     11516,        365]
CellTagsIndexPosition[     11431,        360]
WindowTitle->ColorList - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Visualizing Statistical Concepts\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities/ref/ColorList\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/ColorList"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/ColorList.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/ColorList", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["ColorList", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"ColorList", "[", "\"\<\!\(\*
StyleBox[\"name\", \"TI\"]\)\>\"", "]"}]], "InlineFormula"],
     " \[LineSeparator]is used to call ColorListFunction associated with ",
     Cell[BoxData["\"\<\!\(\*
StyleBox[\"name\", \"TI\"]\)\>\""], "InlineFormula"]
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->117977883],

Cell["\<\
MakeColorList needs to be used to create a ColorListFunction before ColorList \
will work.\
\>", "Notes",
 CellID->1067943069]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->32687776],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->271628576],

Cell["This loads the package.", "ExampleText",
 CellID->21558250],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1552255054],

Cell["Use MakeColorList to create a ColorListFunction.", "ExampleText",
 CellID->1119348822],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeColorList", "[", 
  RowBox[{"\"\<MyColors\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"Yellow", ",", "Green", ",", "Blue"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->938903634],

Cell[BoxData[
 RowBox[{"ColorListFunction", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
   PanelBox[
    StyleBox[
     GraphicsBox[{
       {RGBColor[1, 1, 0], EdgeForm[Opacity[0.1]], 
        RectangleBox[{1, 0}, Offset[{-1, -1}, {2, 1}]]}, 
       {RGBColor[0, 1, 0], EdgeForm[Opacity[0.1]], 
        RectangleBox[{2, 0}, Offset[{-1, -1}, {3, 1}]]}, 
       {RGBColor[0, 0, 1], EdgeForm[Opacity[0.1]], 
        RectangleBox[{3, 0}, Offset[{-1, -1}, {4, 1}]]}},
      AspectRatio->NCache[
        Rational[1, 10], 0.1],
      ImageSize->65,
      PlotRangePadding->None],
     StripOnInput->False,
     CacheGraphics->False],
    FrameMargins->5]}], "]"}]], "Output",
 ImageSize->{288, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->443538482]
}, Open  ]],

Cell["\<\
Call the ColorListFunction using ColorList with the name \"MyColors\".\
\>", "ExampleText",
 CellID->635528237],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ColorList", "[", "\"\<MyColors\>\"", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1886902728],

Cell[BoxData[
 RowBox[{"ColorListFunction", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
   PanelBox[
    StyleBox[
     GraphicsBox[{
       {RGBColor[1, 1, 0], EdgeForm[Opacity[0.1]], 
        RectangleBox[{1, 0}, Offset[{-1, -1}, {2, 1}]]}, 
       {RGBColor[0, 1, 0], EdgeForm[Opacity[0.1]], 
        RectangleBox[{2, 0}, Offset[{-1, -1}, {3, 1}]]}, 
       {RGBColor[0, 0, 1], EdgeForm[Opacity[0.1]], 
        RectangleBox[{3, 0}, Offset[{-1, -1}, {4, 1}]]}},
      AspectRatio->NCache[
        Rational[1, 10], 0.1],
      ImageSize->65,
      PlotRangePadding->None],
     StripOnInput->False,
     CacheGraphics->False],
    FrameMargins->5]}], "]"}]], "Output",
 ImageSize->{288, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1283134247]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[StyleBox[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"],
 FontWeight->"Bold"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["RELATED LINKS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "RelatedLinksSection",
 WholeCellGroupOpener->True,
 CellID->1584193535],

Cell[TextData[Cell[BoxData[
 ButtonBox["MakeColorList",
  BaseStyle->"Link",
  ButtonData->
   "paclet:Classroom Utilities/ref/MakeColorList"]], "InlineFormula",
 FontWeight->"Bold"]], "RelatedLinks",
 CellID->1038487239],

Cell[TextData[Cell[BoxData[
 ButtonBox["ColorListFunction",
  BaseStyle->"Link",
  ButtonData->
   "paclet:Classroom Utilities/ref/ColorListFunction"]], "InlineFormula",
 FontWeight->"Bold"]], "RelatedLinks",
 CellID->149378590]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"ColorList - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 25, 28.6504624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "ColorList[\"name\"] is used to call ColorListFunction associated with \" \
name\"", "synonyms" -> {}, "title" -> "ColorList", "titlemodifier" -> "", 
    "windowtitle" -> "ColorList", "type" -> "Symbol", "uri" -> 
    "Classroom Utilities/ref/ColorList"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4467, 131, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->32687776]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 11289, 353}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[602, 21, 2452, 55, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3079, 80, 52, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3134, 83, 511, 14, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3682, 102, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->117977883],
Cell[4294, 122, 136, 4, 70, "Notes",
 CellID->1067943069]
}, Closed]],
Cell[CellGroupData[{
Cell[4467, 131, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->32687776],
Cell[CellGroupData[{
Cell[4981, 149, 195, 6, 31, "ExampleSection",
 CellID->271628576],
Cell[5179, 157, 65, 1, 32, "ExampleText",
 CellID->21558250],
Cell[5247, 160, 128, 3, 28, "Input",
 CellID->1552255054],
Cell[5378, 165, 92, 1, 32, "ExampleText",
 CellID->1119348822],
Cell[CellGroupData[{
Cell[5495, 170, 218, 6, 28, "Input",
 CellID->938903634],
Cell[5716, 178, 842, 25, 49, "Output",
 CellID->443538482]
}, Open  ]],
Cell[6573, 206, 121, 3, 32, "ExampleText",
 CellID->635528237],
Cell[CellGroupData[{
Cell[6719, 213, 121, 3, 28, "Input",
 CellID->1886902728],
Cell[6843, 218, 843, 25, 49, "Output",
 CellID->1283134247]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7747, 250, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[8198, 265, 231, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[8466, 275, 456, 13, 70, "RelatedLinksSection",
 CellID->1584193535],
Cell[8925, 290, 221, 6, 70, "RelatedLinks",
 CellID->1038487239],
Cell[9149, 298, 228, 6, 70, "RelatedLinks",
 CellID->149378590]
}, Open  ]],
Cell[9392, 307, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

