(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     16030,        519]
NotebookOptionsPosition[     12029,        394]
NotebookOutlinePosition[     14159,        451]
CellTagsIndexPosition[     14074,        446]
WindowTitle->ColumnHeadings - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[Cell[
    BoxData[
     ActionMenuBox[
      FrameBox["\<\"URL \[RightGuillemet]\"\>",
       StripOnInput->
        False], {"\<\"Classroom Utilities/ref/ColumnHeadings\"\>":>
      None, "\<\"Copy Mathematica URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["Classroom Utilities/ref/ColumnHeadings"]}, Visible -> 
           False]]; SelectionMove[
        DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/ColumnHeadings.html"], StandardForm]], "Input", 
             TextClipboardType -> "PlainText"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
           "http://reference.wolfram.com/mathematica/", 
            "Classroom Utilities/ref/ColumnHeadings", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic]],
     LineSpacing->{1.4, 0}]], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["ColumnHeadings", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["ColumnHeadings"], "InlineFormula"],
     "\[LineSeparator]an option for FiveNumberSummaryTable to add column \
headings to the table."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->222123572],

Cell["The value of ColumnHeadings must be a list.", "Notes",
 CellID->1067943069]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->265704929],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->256241258],

Cell["This loads the package.", "ExampleText",
 CellID->769437841],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1942755100],

Cell["Get some data.", "ExampleText",
 CellID->1627482824],

Cell[BoxData[
 RowBox[{
  RowBox[{"ofData", "=", " ", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<Statistics\>\"", ",", "\"\<OldFaithful\>\""}], "}"}], 
    "]"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->604611129],

Cell["Include column headings.", "ExampleText",
 CellID->1122730570],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FiveNumberSummaryTable", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", "ofData", "]"}], ",", 
   RowBox[{"ColumnHeadings", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"\"\<duration\>\"", ",", "\"\<waiting\>\""}], "}"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1941367448],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"\"\>", "\<\"duration\"\>", "\<\"waiting\"\>"},
    {"\<\"max\"\>", "5.1`", "96"},
    {"\<\"75%\"\>", "4.45`", "82"},
    {"\<\"median\"\>", "4.`", "76"},
    {"\<\"25%\"\>", "2.15`", "58"},
    {"\<\"min\"\>", "1.6`", "43"}
   },
   AllowScriptLevelChange->True,
   AllowedDimensions->Automatic,
   AutoDelete->False,
   BaseStyle->{},
   BaselinePosition->Automatic,
   DefaultBaseStyle->"Grid",
   DeleteWithContents->True,
   Editable->Automatic,
   FrameStyle->Automatic,
   GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       Thickness[Large], {True}, 
       Thickness[Large]}, "Rows" -> {
       Thickness[Large], {True}, 
       Thickness[Large]}},
   GridBoxFrame->{"Columns" -> None, "Rows" -> None},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{None}}, "Rows" -> {{None}}},
   GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridDefaultElement->"\[Placeholder]",
   Selectable->Automatic],
  "Grid"]], "Output",
 ImageSize->{183, 102},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->635263755]
}, Open  ]],

Cell["Style can be used with ColumnHeadings.", "ExampleText",
 CellID->79318955],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FiveNumberSummaryTable", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", "ofData", "]"}], ",", 
   RowBox[{"ColumnHeadings", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Style", "[", 
       RowBox[{"\"\<duration\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", " ", "\"\<Times\>\""}], ",", 
        "Italic"}], "]"}], ",", 
      RowBox[{"Style", "[", 
       RowBox[{"\"\<waiting\>\"", ",", 
        RowBox[{"FontFamily", "\[Rule]", " ", "\"\<Times\>\""}], ",", 
        "Italic"}], "]"}]}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1736721048],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"\"\>", 
     StyleBox["\<\"duration\"\>",
      StripOnInput->False,
      FontFamily->"Times",
      FontSlant->Italic], 
     StyleBox["\<\"waiting\"\>",
      StripOnInput->False,
      FontFamily->"Times",
      FontSlant->Italic]},
    {"\<\"max\"\>", "5.1`", "96"},
    {"\<\"75%\"\>", "4.45`", "82"},
    {"\<\"median\"\>", "4.`", "76"},
    {"\<\"25%\"\>", "2.15`", "58"},
    {"\<\"min\"\>", "1.6`", "43"}
   },
   AllowScriptLevelChange->True,
   AllowedDimensions->Automatic,
   AutoDelete->False,
   BaseStyle->{},
   BaselinePosition->Automatic,
   DefaultBaseStyle->"Grid",
   DeleteWithContents->True,
   Editable->Automatic,
   FrameStyle->Automatic,
   GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       Thickness[Large], {True}, 
       Thickness[Large]}, "Rows" -> {
       Thickness[Large], {True}, 
       Thickness[Large]}},
   GridBoxFrame->{"Columns" -> None, "Rows" -> None},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{None}}, "Rows" -> {{None}}},
   GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridDefaultElement->"\[Placeholder]",
   Selectable->Automatic],
  "Grid"]], "Output",
 ImageSize->{155, 104},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->591850037]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Possible Issues",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373],

Cell["This loads the package.", "ExampleText",
 CellID->1673815545],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1929572762],

Cell["Get some data.", "ExampleText",
 CellID->1178857587],

Cell[BoxData[
 RowBox[{
  RowBox[{"ofData", "=", " ", 
   RowBox[{"ExampleData", "[", 
    RowBox[{"{", 
     RowBox[{"\"\<Statistics\>\"", ",", "\"\<OldFaithful\>\""}], "}"}], 
    "]"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->375337487],

Cell["\<\
If the length of the list is not equal to the number of data sets the heading \
will be omitted.\
\>", "ExampleText",
 CellID->1137672770],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FiveNumberSummaryTable", "[", 
  RowBox[{
   RowBox[{"Transpose", "[", "ofData", "]"}], ",", 
   RowBox[{"ColumnHeadings", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
     "\"\<duration\>\"", ",", "\"\<waiting\>\"", ",", "\"\<volume\>\""}], 
     "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1819336149],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"FiveNumberSummaryTable", "::", "colnm"}], "MessageName"], ":", 
  " ", "\<\"The length of the column headings list must equal the number of \
data lists. Column headings will be omitted.\"\>"}]], "Message", "MSG",
 CellLabel->"During evaluation of In[3]:=",
 CellID->1710490257],

Cell[BoxData[
 TagBox[GridBox[{
    {"\<\"max\"\>", "5.1`", "96"},
    {"\<\"75%\"\>", "4.45`", "82"},
    {"\<\"median\"\>", "4.`", "76"},
    {"\<\"25%\"\>", "2.15`", "58"},
    {"\<\"min\"\>", "1.6`", "43"}
   },
   AllowScriptLevelChange->True,
   AllowedDimensions->Automatic,
   AutoDelete->False,
   BaseStyle->{},
   BaselinePosition->Automatic,
   DefaultBaseStyle->"Grid",
   DeleteWithContents->True,
   Editable->Automatic,
   FrameStyle->Automatic,
   GridBoxAlignment->{"Columns" -> {{Center}}, "Rows" -> {{Baseline}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       Thickness[Large], {True}, 
       Thickness[Large]}, "Rows" -> {
       Thickness[Large], {True}, 
       Thickness[Large]}},
   GridBoxFrame->{"Columns" -> None, "Rows" -> None},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxItemStyle->{"Columns" -> {{None}}, "Rows" -> {{None}}},
   GridBoxSpacings->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridDefaultElement->"\[Placeholder]",
   Selectable->Automatic],
  "Grid"]], "Output",
 ImageSize->{120, 86},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1993650657]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"ColumnHeadings - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 25, 32.5972624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "ColumnHeadings an option for FiveNumberSummaryTable to add column \
headings to the table.", "synonyms" -> {}, "title" -> "ColumnHeadings", 
    "titlemodifier" -> "", "windowtitle" -> "ColumnHeadings", "type" -> 
    "Symbol", "uri" -> "Classroom Utilities/ref/ColumnHeadings"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[3793, 114, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->265704929]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13931, 439}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[607, 21, 1952, 44, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[2584, 69, 57, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[2644, 72, 382, 11, 83, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3063, 88, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->222123572],
Cell[3675, 108, 81, 1, 70, "Notes",
 CellID->1067943069]
}, Closed]],
Cell[CellGroupData[{
Cell[3793, 114, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->265704929],
Cell[CellGroupData[{
Cell[4308, 132, 195, 6, 31, "ExampleSection",
 CellID->256241258],
Cell[4506, 140, 66, 1, 32, "ExampleText",
 CellID->769437841],
Cell[4575, 143, 128, 3, 28, "Input",
 CellID->1942755100],
Cell[4706, 148, 58, 1, 32, "ExampleText",
 CellID->1627482824],
Cell[4767, 151, 250, 8, 28, "Input",
 CellID->604611129],
Cell[5020, 161, 68, 1, 32, "ExampleText",
 CellID->1122730570],
Cell[CellGroupData[{
Cell[5113, 166, 315, 9, 28, "Input",
 CellID->1941367448],
Cell[5431, 177, 1323, 37, 123, "Output",
 CellID->635263755]
}, Open  ]],
Cell[6769, 217, 80, 1, 70, "ExampleText",
 CellID->79318955],
Cell[CellGroupData[{
Cell[6874, 222, 610, 16, 70, "Input",
 CellID->1736721048],
Cell[7487, 240, 1513, 45, 125, "Output",
 CellID->591850037]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9049, 291, 278, 8, 70, "ExampleSection",
 CellID->1305812373],
Cell[9330, 301, 67, 1, 70, "ExampleText",
 CellID->1673815545],
Cell[9400, 304, 128, 3, 70, "Input",
 CellID->1929572762],
Cell[9531, 309, 58, 1, 70, "ExampleText",
 CellID->1178857587],
Cell[9592, 312, 250, 8, 70, "Input",
 CellID->375337487],
Cell[9845, 322, 148, 4, 70, "ExampleText",
 CellID->1137672770],
Cell[CellGroupData[{
Cell[10018, 330, 347, 10, 70, "Input",
 CellID->1819336149],
Cell[10368, 342, 326, 7, 70, "Message",
 CellID->1710490257],
Cell[10697, 351, 1266, 36, 107, "Output",
 CellID->1993650657]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[12002, 392, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

