(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     26068,        869]
NotebookOptionsPosition[     20958,        705]
NotebookOutlinePosition[     23140,        763]
CellTagsIndexPosition[     23055,        758]
WindowTitle->CreateAugmentedMatrix - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Elementary Matrix Operations\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/ElementaryMatrixOperations"], \
"\<\"Solving Linear Systems\"\>":>Documentation`HelpLookup[
       "paclet:tutorial/SolvingLinearSystems"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AddToRow\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/AddToRow"], \
"\<\"AugmentIdentityMatrix\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/AugmentIdentityMatrix"], \
"\<\"MultiplyARow\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/MultiplyARow"], "\<\"SwitchRows\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/SwitchRows"], "\<\"RowReduce\"\>":>
       Documentation`HelpLookup["paclet:ref/RowReduce"], "\<\"Inverse\"\>":>
       Documentation`HelpLookup["paclet:ref/Inverse"], "\<\"LinearSolve\"\>":>
       Documentation`HelpLookup[
       "paclet:ref/LinearSolve"], "\<\"NullSpace\"\>":>
       Documentation`HelpLookup["paclet:ref/NullSpace"], "\<\"Solve\"\>":>
       Documentation`HelpLookup["paclet:ref/Solve"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], "\<\"Matrix \
Operations\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/MatrixOperations"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/CreateAugmentedMatrix\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/CreateAugmentedMatrix"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/CreateAugmentedMatrix.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/CreateAugmentedMatrix", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["CreateAugmentedMatrix", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"CreateAugmentedMatrix", "[", 
       RowBox[{
        StyleBox["eqs", "TI"], ",", 
        StyleBox["vars", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]create an augmented matrix from a set of equations ",
     Cell[BoxData[
      StyleBox["eqs", "TI"]], "InlineFormula"],
     " in the variables ",
     Cell[BoxData[
      StyleBox["vars", "TI"]], "InlineFormula"]
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->2373079],

Cell["\<\
CreateAugmentedMatrix works with numeric and symbolic matrices.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
The order of the variables in the equations does not affect on the result\
\>", "Notes",
 CellID->1924482922],

Cell["\<\
The order of the variable list determines the order of the columns in the \
matrix\
\>", "Notes",
 CellID->1533262587],

Cell["\<\
The last column in the matrix gives the constant term from each equation\
\>", "Notes",
 CellID->1888019356],

Cell["Missing terms are represented by zero in the matrix", "Notes",
 CellID->722948220]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->863124010],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->340032444],

Cell["This loads the package.", "ExampleText",
 CellID->1985343189],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->62070437],

Cell["Create an augmented matrix from a system of equations.", "ExampleText",
 CellID->1688265864],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CreateAugmentedMatrix", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"3", " ", "x"}], " ", "+", " ", 
        RowBox[{"2", " ", "y"}]}], " ", "\[Equal]", "7"}], ",", 
      RowBox[{
       RowBox[{
        RowBox[{"5", " ", "x"}], " ", "-", " ", "y"}], "\[Equal]", "4"}]}], 
     "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", 
  "TraditionalForm"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->2130432084],

Cell[BoxData[
 FormBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"3", "2", 
      RowBox[{"-", "7"}]},
     {"5", 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "4"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
  TraditionalForm]], "Output",
 ImageSize->{72, 31},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]//TraditionalForm=",
 CellID->2014234768]
}, Open  ]],

Cell["Give the system of equations in symbolic form.", "ExampleText",
 CellID->254683288],

Cell[BoxData[
 RowBox[{
  RowBox[{"CreateAugmentedMatrix", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"a", " ", "x"}], " ", "+", " ", 
        RowBox[{"b", " ", "y"}]}], " ", "\[Equal]", "r"}], ",", " ", 
      RowBox[{
       RowBox[{
        RowBox[{"d", " ", "x"}], " ", "+", 
        RowBox[{"e", " ", "y"}]}], " ", "\[Equal]", " ", "s"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}]}], "]"}], "//", 
  "TraditionalForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->527112945],

Cell[BoxData[
 FormBox[
  StyleBox[
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {"a", "b", 
       RowBox[{"-", "r"}]},
      {"d", "e", 
       RowBox[{"-", "s"}]}
     },
     GridBoxAlignment->{
      "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
        "RowsIndexed" -> {}},
     GridBoxSpacings->{"Columns" -> {
         Offset[0.27999999999999997`], {
          Offset[0.7]}, 
         Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
         Offset[0.2], {
          Offset[0.4]}, 
         Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}], 
   "ExampleText"], TraditionalForm]], "Input",
 CellLabel->"In[4]:=",
 CellID->311534468],

Cell["The equations can be given in any order.", "ExampleText",
 CellID->394672290],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CreateAugmentedMatrix", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"x", "+", " ", "y", " ", "+", "z"}], "\[Equal]", "5"}], ",", 
      RowBox[{
       RowBox[{"x", "-", "y"}], "\[Equal]", 
       RowBox[{"2", " ", "z"}]}], ",", 
      RowBox[{
       RowBox[{"x", "-", "z"}], "\[Equal]", 
       RowBox[{"8", "-", 
        RowBox[{"2", " ", "y"}]}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1629639646],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "1", "1", 
      RowBox[{"-", "5"}]},
     {"1", 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "2"}], "0"},
     {"1", "2", 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "8"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{100, 42},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//MatrixForm=",
 CellID->1085021336]
}, Open  ]],

Cell["\<\
The order of the columns is determined by the order of the variable list.\
\>", "ExampleText",
 CellID->1669947475],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CreateAugmentedMatrix", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"x", "+", " ", "y", " ", "+", "z"}], "\[Equal]", "5"}], ",", 
      RowBox[{
       RowBox[{"x", "-", "y"}], "\[Equal]", 
       RowBox[{"2", " ", "z"}]}], ",", 
      RowBox[{
       RowBox[{"x", "-", "z"}], "\[Equal]", 
       RowBox[{"8", "-", 
        RowBox[{"2", " ", "y"}]}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "z", ",", "y"}], "}"}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->1343429682],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "1", "1", 
      RowBox[{"-", "5"}]},
     {"1", 
      RowBox[{"-", "2"}], 
      RowBox[{"-", "1"}], "0"},
     {"1", 
      RowBox[{"-", "1"}], "2", 
      RowBox[{"-", "8"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{100, 42},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]//MatrixForm=",
 CellID->379600816]
}, Open  ]],

Cell["Missing terms are represented as zero in the matrix.", "ExampleText",
 CellID->128258814],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CreateAugmentedMatrix", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "\[Equal]", 
       RowBox[{"2", " ", "z"}]}], ",", 
      RowBox[{
       RowBox[{"x", "-", "z"}], "\[Equal]", 
       RowBox[{"8", "-", 
        RowBox[{"2", " ", "y"}]}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "y", ",", "z"}], "}"}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->1719788957],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", "0", 
      RowBox[{"-", "2"}], "0"},
     {"1", "2", 
      RowBox[{"-", "1"}], 
      RowBox[{"-", "8"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{92, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]//MatrixForm=",
 CellID->1510595326]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Scope",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell["\<\
Variables do not need to be standard keyboard characters. This uses the \
HappySmiley and SadSmiley characters.\
\>", "ExampleText",
 CellID->1904668615],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"CreateAugmentedMatrix", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"3", " ", "\[HappySmiley]"}], " ", "+", " ", 
        RowBox[{"2", " ", "\[SadSmiley]"}]}], " ", "\[Equal]", " ", "1"}], 
      ",", " ", 
      RowBox[{
       RowBox[{"\[HappySmiley]", " ", "+", " ", 
        RowBox[{"3", " ", "\[SadSmiley]"}]}], " ", "\[Equal]", 
       RowBox[{"-", "4"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"\[HappySmiley]", ",", "\[SadSmiley]"}], "}"}]}], "]"}], "//", 
  "MatrixForm"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1374170123],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"3", "2", "1"},
     {"1", "3", 
      RowBox[{"-", "4"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{69, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]//MatrixForm=",
 CellID->1099173821]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["AddToRow",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/AddToRow"],
   FontFamily->"Verdana"]], "InlineFormula",
  FontSize->10],
 StyleBox[" . ",
  FontSize->10],
 Cell[BoxData[
  StyleBox[
   ButtonBox["AugmentIdentityMatrix",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/AugmentIdentityMatrix"],
   FontFamily->"Verdana"]], "InlineFormula",
  FontSize->10],
 StyleBox[" . ",
  FontSize->10],
 Cell[BoxData[
  StyleBox[
   ButtonBox["MultiplyARow",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/MultiplyARow"],
   FontFamily->"Verdana"]], "InlineFormula",
  FontSize->10],
 StyleBox[" . ",
  FontSize->10],
 Cell[BoxData[
  StyleBox[
   ButtonBox["SwitchRows",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/SwitchRows"],
   FontFamily->"Verdana"]], "InlineFormula",
  FontSize->10],
 StyleBox[" ",
  FontSize->10],
 ". ",
 StyleBox[ButtonBox["RowReduce",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/RowReduce"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["Inverse",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Inverse"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["LinearSolve",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/LinearSolve"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["NullSpace",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/NullSpace"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["Solve",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Solve"],
  FontFamily->"Verdana"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Elementary Matrix Operations",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/ElementaryMatrixOperations"]], \
"Tutorials",
 CellID->341631938],

Cell[TextData[ButtonBox["Solving Linear Systems",
 BaseStyle->"Link",
 ButtonData->"paclet:tutorial/SolvingLinearSystems"]], "Tutorials",
 CellID->1319896665]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->386162399],

Cell[TextData[ButtonBox["Matrix Operations",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/MatrixOperations"]], "MoreAbout",
 CellID->212725276]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"CreateAugmentedMatrix - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 25, 36.9652624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "CreateAugmentedMatrix[eqs, vars] create an augmented matrix from a set \
of equations eqs in the variables vars", "synonyms" -> {}, "title" -> 
    "CreateAugmentedMatrix", "titlemodifier" -> "", "windowtitle" -> 
    "CreateAugmentedMatrix", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/CreateAugmentedMatrix"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6838, 192, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->863124010]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 22912, 751}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[614, 21, 4231, 93, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4870, 118, 64, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[4937, 121, 643, 19, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5617, 145, 607, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->2373079],
Cell[6227, 165, 109, 3, 70, "Notes",
 CellID->1067943069],
Cell[6339, 170, 119, 3, 70, "Notes",
 CellID->1924482922],
Cell[6461, 175, 128, 4, 70, "Notes",
 CellID->1533262587],
Cell[6592, 181, 118, 3, 70, "Notes",
 CellID->1888019356],
Cell[6713, 186, 88, 1, 70, "Notes",
 CellID->722948220]
}, Closed]],
Cell[CellGroupData[{
Cell[6838, 192, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->863124010],
Cell[CellGroupData[{
Cell[7353, 210, 195, 6, 31, "ExampleSection",
 CellID->340032444],
Cell[7551, 218, 67, 1, 32, "ExampleText",
 CellID->1985343189],
Cell[7621, 221, 126, 3, 28, "Input",
 CellID->62070437],
Cell[7750, 226, 98, 1, 32, "ExampleText",
 CellID->1688265864],
Cell[CellGroupData[{
Cell[7873, 231, 527, 18, 28, "Input",
 CellID->2130432084],
Cell[8403, 251, 778, 24, 66, "Output",
 CellID->2014234768]
}, Open  ]],
Cell[9196, 278, 89, 1, 32, "ExampleText",
 CellID->254683288],
Cell[9288, 281, 559, 18, 28, "Input",
 CellID->527112945],
Cell[9850, 301, 695, 21, 38, "Input",
 CellID->311534468],
Cell[10548, 324, 83, 1, 70, "ExampleText",
 CellID->394672290],
Cell[CellGroupData[{
Cell[10656, 329, 591, 19, 70, "Input",
 CellID->1629639646],
Cell[11250, 350, 886, 28, 77, "Output",
 CellID->1085021336]
}, Open  ]],
Cell[12151, 381, 125, 3, 70, "ExampleText",
 CellID->1669947475],
Cell[CellGroupData[{
Cell[12301, 388, 591, 19, 70, "Input",
 CellID->1343429682],
Cell[12895, 409, 885, 28, 77, "Output",
 CellID->379600816]
}, Open  ]],
Cell[13795, 440, 95, 1, 70, "ExampleText",
 CellID->128258814],
Cell[CellGroupData[{
Cell[13915, 445, 471, 16, 70, "Input",
 CellID->1719788957],
Cell[14389, 463, 814, 25, 63, "Output",
 CellID->1510595326]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15252, 494, 268, 8, 70, "ExampleSection",
 CellID->1293636265],
Cell[15523, 504, 163, 4, 70, "ExampleText",
 CellID->1904668615],
Cell[CellGroupData[{
Cell[15711, 512, 633, 19, 70, "Input",
 CellID->1374170123],
Cell[16347, 533, 760, 23, 63, "Output",
 CellID->1099173821]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[17168, 563, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[17617, 578, 1631, 63, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[19285, 646, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[19736, 661, 193, 5, 70, "Tutorials",
 CellID->341631938],
Cell[19932, 668, 158, 3, 70, "Tutorials",
 CellID->1319896665]
}, Open  ]],
Cell[CellGroupData[{
Cell[20127, 676, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[20578, 691, 171, 4, 70, "MoreAbout",
 CellID->386162399],
Cell[20752, 697, 164, 3, 70, "MoreAbout",
 CellID->212725276]
}, Open  ]],
Cell[20931, 703, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

