(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     23369,        701]
NotebookOptionsPosition[     19010,        567]
NotebookOutlinePosition[     21367,        627]
CellTagsIndexPosition[     21282,        622]
WindowTitle->CreatePopulation - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Visualizing Statistical Concepts\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Classroom Utilities/ref/CreatePopulation\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/CreatePopulation"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/CreatePopulation.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/CreatePopulation", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["CreatePopulation", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"CreatePopulation", "[", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox[
          StyleBox["gr", "TI"], 
          StyleBox["1", "TR"]], ",", 
         SubscriptBox[
          StyleBox["gr", "TI"], 
          StyleBox["2", "TR"]], ",", 
         StyleBox["\[Ellipsis]", "TR"]}], "}"}], "]"}]], "InlineFormula"],
     " \[LineSeparator]generates a list of insets to use in the ",
     Cell[BoxData[
      ButtonBox["SRSChart",
       BaseStyle->"Link",
       ButtonData->"paclet:Classroom Utilities/ref/SRSChart"]], 
      "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"CreatePopulation", "[", 
       RowBox[{
        StyleBox["lis", "TI"], ",", 
        StyleBox["n", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]generates a list of",
     Cell[BoxData[
      RowBox[{" ", 
       StyleBox["n", "TI"]}]], "InlineFormula"],
     " insets from the list ",
     Cell[BoxData[
      StyleBox["lis", "TI"]], "InlineFormula"],
     ", repeating elements if necessary,  for use in ",
     Cell[BoxData[
      ButtonBox["SRSChart",
       BaseStyle->"Link",
       ButtonData->"paclet:Classroom Utilities/ref/SRSChart"]], 
      "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"CreatePopulation", "[", 
       RowBox[{
        StyleBox["lis", "TI"], ",", 
        StyleBox["n", "TI"], ",", 
        StyleBox["scl", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]generates a list ",
     Cell[BoxData[
      StyleBox["n", "TI"]], "InlineFormula"],
     " insets from lis scaled according to ",
     Cell[BoxData[
      StyleBox["scl", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->5027348],

Cell["\<\
The list of elements should be a list of graphics or graphics primitives or a \
list of images.\
\>", "Notes",
 CellID->1067943069],

Cell["The list cannot be a mix of graphics and images.", "Notes",
 CellID->1701228511],

Cell[TextData[{
 "If the length of the list is less than ",
 Cell[BoxData[
  StyleBox["n", "TI"]], "InlineFormula"],
 " the list will be padded using the elements of the list."
}], "Notes",
 CellID->950308219],

Cell["Even a single graphic or image must be enclosed in a list.", "Notes",
 CellID->62430442],

Cell[TextData[{
 "The scale can be used to obtain a better fit of the list elements in the ",
 Cell[BoxData[
  ButtonBox["SRSChart",
   BaseStyle->"Link",
   ButtonData->"paclet:Classroom Utilities/ref/SRSChart"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->994353994]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->347712759],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->275520326],

Cell["This loads the package.", "ExampleText",
 CellID->389836204],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->4473631],

Cell["Use happy faces to create a population list.", "ExampleText",
 CellID->26388572],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"happyPop", "=", 
  RowBox[{"CreatePopulation", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"Happy", "[", "]"}], "}"}], ",", "3"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1131098322],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Inset", "[", 
    RowBox[{
     GraphicsBox[
      {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
       {GrayLevel[0], Thickness[0.03], 
        DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
          0.4871392896287467, 0.28125}], NCache[
         Rational[1, 6], 0.16666666666666666`]], 
        DiskBox[NCache[{
          Rational[-9, 32] 3^Rational[1, 2], Rational[
           9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
         Rational[1, 6], 0.16666666666666666`]]}, 
       {RGBColor[1, 0, 0], Thickness[0.03], 
        CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
         NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
           Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         SqrtBox["3"], "2"]}], ",", 
       FractionBox["3", "2"]}], "}"}], ",", "Center", ",", "1.2`"}], "]"}], 
   ",", 
   RowBox[{"Inset", "[", 
    RowBox[{
     GraphicsBox[
      {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
       {GrayLevel[0], Thickness[0.03], 
        DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
          0.4871392896287467, 0.28125}], NCache[
         Rational[1, 6], 0.16666666666666666`]], 
        DiskBox[NCache[{
          Rational[-9, 32] 3^Rational[1, 2], Rational[
           9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
         Rational[1, 6], 0.16666666666666666`]]}, 
       {RGBColor[1, 0, 0], Thickness[0.03], 
        CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
         NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
           Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        SqrtBox["3"], "2"], ",", 
       FractionBox["3", "2"]}], "}"}], ",", "Center", ",", "1.2`"}], "]"}], 
   ",", 
   RowBox[{"Inset", "[", 
    RowBox[{
     GraphicsBox[
      {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
       {GrayLevel[0], Thickness[0.03], 
        DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
          0.4871392896287467, 0.28125}], NCache[
         Rational[1, 6], 0.16666666666666666`]], 
        DiskBox[NCache[{
          Rational[-9, 32] 3^Rational[1, 2], Rational[
           9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
         Rational[1, 6], 0.16666666666666666`]]}, 
       {RGBColor[1, 0, 0], Thickness[0.03], 
        CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
         NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
           Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["3"]}], ",", "0"}], "}"}], ",", "Center", ",", "1.2`"}], 
    "]"}]}], "}"}]], "Output",
 ImageSize->{416, 572},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->962774541]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SRSChart", "[", "happyPop", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1296418958],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0.75], DiskBox[{0, 0}, 2.6630281166371486`]}, 
   {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGAAYXYgZgLihvfnJrF92bzf42GVyDr3//YrfSJeVG17DeUz
O2yK1a63Kv+13xMqD+PvlGt9Hbjjg/0aqHqw9MNH9hOg5m2DyqObD9VvD+Ov
hui3h9nXAVFvD7OvAsqH2bcCqh5m30aoeTD70M2fqbVp12+Td/vB0nJ37VeB
9f/eLw/mv7VnPrT6p7UmywEVqDwLlC8N4e9fjap+/xyoeWpQ+VlQvjxUPwBq
Q7Zq
     "]], {InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], 
      NCache[{Rational[-1, 2] 3^Rational[1, 2], Rational[
        3, 2]}, {-0.8660254037844386, 1.5}], Center, 1.2], InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], 
      NCache[{Rational[1, 2] 3^Rational[1, 2], Rational[3, 2]}, {
       0.8660254037844386, 1.5}], Center, 1.2], InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], 
      NCache[{-3^Rational[1, 2], 0}, {-1.7320508075688772`, 0}], Center, 
      1.2]}}}]], "Output",
 ImageSize->{184, 175},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->544344644]
}, Open  ]],

Cell["Use the Text primitive to label population element.", "ExampleText",
 CellID->520095488],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"lblPop", "=", 
  RowBox[{"CreatePopulation", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Text", "[", 
      RowBox[{"Style", "[", 
       RowBox[{"#", ",", "14", ",", 
        RowBox[{"FontColor", "\[Rule]", " ", "Yellow"}]}], "]"}], "]"}], 
     "&"}], "/@", 
    RowBox[{"CharacterRange", "[", 
     RowBox[{"\"\<A\>\"", ",", "\"\<C\>\""}], "]"}]}], "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->986423526],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"Inset", "[", 
    RowBox[{
     GraphicsBox[InsetBox[
       StyleBox["\<\"A\"\>",
        StripOnInput->False,
        FontSize->14,
        FontColor->RGBColor[1, 1, 0]], {0, 0}]], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        FractionBox[
         SqrtBox["3"], "2"]}], ",", 
       FractionBox["3", "2"]}], "}"}], ",", "Center", ",", "1.2`"}], "]"}], 
   ",", 
   RowBox[{"Inset", "[", 
    RowBox[{
     GraphicsBox[InsetBox[
       StyleBox["\<\"B\"\>",
        StripOnInput->False,
        FontSize->14,
        FontColor->RGBColor[1, 1, 0]], {0, 0}]], ",", 
     RowBox[{"{", 
      RowBox[{
       FractionBox[
        SqrtBox["3"], "2"], ",", 
       FractionBox["3", "2"]}], "}"}], ",", "Center", ",", "1.2`"}], "]"}], 
   ",", 
   RowBox[{"Inset", "[", 
    RowBox[{
     GraphicsBox[InsetBox[
       StyleBox["\<\"C\"\>",
        StripOnInput->False,
        FontSize->14,
        FontColor->RGBColor[1, 1, 0]], {0, 0}]], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", 
        SqrtBox["3"]}], ",", "0"}], "}"}], ",", "Center", ",", "1.2`"}], 
    "]"}]}], "}"}]], "Output",
 ImageSize->{416, 572},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1680240678]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SRSChart", "[", "lblPop", "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->395117096],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0.75], DiskBox[{0, 0}, 2.6630281166371486`]}, 
   {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGAAYXYgZgLihvfnJrF92bzf42GVyDr3//YrfSJeVG17DeUz
O2yK1a63Kv+13xMqD+PvlGt9Hbjjg/0aqHqw9MNH9hOg5m2DyqObD9VvD+Ov
hui3h9nXAVFvD7OvAsqH2bcCqh5m30aoeTD70M2fqbVp12+Td/vB0nJ37VeB
9f/eLw/mv7VnPrT6p7UmywEVqDwLlC8N4e9fjap+/xyoeWpQ+VlQvjxUPwBq
Q7Zq
     "]], {InsetBox[
      GraphicsBox[InsetBox[
        StyleBox["\<\"A\"\>",
         StripOnInput->False,
         FontSize->14,
         FontColor->RGBColor[1, 1, 0]], {0, 0}]], 
      NCache[{Rational[-1, 2] 3^Rational[1, 2], Rational[
        3, 2]}, {-0.8660254037844386, 1.5}], Center, 1.2], InsetBox[
      GraphicsBox[InsetBox[
        StyleBox["\<\"B\"\>",
         StripOnInput->False,
         FontSize->14,
         FontColor->RGBColor[1, 1, 0]], {0, 0}]], 
      NCache[{Rational[1, 2] 3^Rational[1, 2], Rational[3, 2]}, {
       0.8660254037844386, 1.5}], Center, 1.2], InsetBox[
      GraphicsBox[InsetBox[
        StyleBox["\<\"C\"\>",
         StripOnInput->False,
         FontSize->14,
         FontColor->RGBColor[1, 1, 0]], {0, 0}]], 
      NCache[{-3^Rational[1, 2], 0}, {-1.7320508075688772`, 0}], Center, 
      1.2]}}}]], "Output",
 ImageSize->{184, 175},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->713595948]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[StyleBox[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"],
 FontWeight->"Bold"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["RELATED LINKS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "RelatedLinksSection",
 WholeCellGroupOpener->True,
 CellID->1584193535],

Cell[TextData[ButtonBox["SRSChart",
 BaseStyle->"Link",
 ButtonData->"paclet:Classroom Utilities/ref/SRSChart"]], "RelatedLinks",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"CreatePopulation - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 25, 44.9056624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "CreatePopulation[{gr_1, gr_2, ...}] generates a list of insets to use in \
the SRSChart.CreatePopulation[lis, n] generates a list of n insets from the \
list lis, repeating elements if necessary, for use in \
SRSChart.CreatePopulation[lis, n, scl] generates a list n insets from lis \
scaled according to scl.", "synonyms" -> {}, "title" -> "CreatePopulation", 
    "titlemodifier" -> "", "windowtitle" -> "CreatePopulation", "type" -> 
    "Symbol", "uri" -> "Classroom Utilities/ref/CreatePopulation"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6663, 205, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->347712759]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 21139, 615}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[609, 21, 2504, 57, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3138, 82, 59, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3200, 85, 1967, 62, 209, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5204, 152, 607, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->5027348],
Cell[5814, 172, 141, 4, 70, "Notes",
 CellID->1067943069],
Cell[5958, 178, 86, 1, 70, "Notes",
 CellID->1701228511],
Cell[6047, 181, 209, 6, 70, "Notes",
 CellID->950308219],
Cell[6259, 189, 94, 1, 70, "Notes",
 CellID->62430442],
Cell[6356, 192, 270, 8, 70, "Notes",
 CellID->994353994]
}, Closed]],
Cell[CellGroupData[{
Cell[6663, 205, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->347712759],
Cell[CellGroupData[{
Cell[7178, 223, 195, 6, 31, "ExampleSection",
 CellID->275520326],
Cell[7376, 231, 66, 1, 32, "ExampleText",
 CellID->389836204],
Cell[7445, 234, 125, 3, 28, "Input",
 CellID->4473631],
Cell[7573, 239, 86, 1, 32, "ExampleText",
 CellID->26388572],
Cell[CellGroupData[{
Cell[7684, 244, 222, 7, 28, "Input",
 CellID->1131098322],
Cell[7909, 253, 2993, 73, 593, "Output",
 CellID->962774541]
}, Open  ]],
Cell[CellGroupData[{
Cell[10939, 331, 112, 3, 70, "Input",
 CellID->1296418958],
Cell[11054, 336, 3103, 62, 196, "Output",
 CellID->544344644]
}, Open  ]],
Cell[14172, 401, 94, 1, 70, "ExampleText",
 CellID->520095488],
Cell[CellGroupData[{
Cell[14291, 406, 438, 13, 70, "Input",
 CellID->986423526],
Cell[14732, 421, 1308, 46, 593, "Output",
 CellID->1680240678]
}, Open  ]],
Cell[CellGroupData[{
Cell[16077, 472, 109, 3, 70, "Input",
 CellID->395117096],
Cell[16189, 477, 1390, 35, 196, "Output",
 CellID->713595948]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[17640, 519, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[18091, 534, 231, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[18359, 544, 456, 13, 70, "RelatedLinksSection",
 CellID->1584193535],
Cell[18818, 559, 150, 3, 70, "RelatedLinks",
 CellID->1038487239]
}, Open  ]],
Cell[18983, 565, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

