(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     21627,        729]
NotebookOptionsPosition[     16878,        590]
NotebookOutlinePosition[     19636,        656]
CellTagsIndexPosition[     19551,        651]
WindowTitle->CubicBezierComponents - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"CubicBezier\"\>":>
       Documentation`HelpLookup["paclet:ClassroomUtilities/ref/CubicBezier"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Calculus Applications\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/CalculusApplications"], \
"\<\"Classroom Utilities\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/CubicBezierComponents\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/CubicBezierComponents"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/CubicBezierComponents.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/CubicBezierComponents", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["CubicBezierComponents", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"CubicBezierComponents", "[", 
       RowBox[{
        StyleBox["t", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["pt", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["pt", "TI"], 
           StyleBox["2", "TR"]], ",", 
          SubscriptBox[
           StyleBox["pt", "TI"], 
           StyleBox["3", "TR"]], ",", 
          SubscriptBox[
           StyleBox["pt", "TI"], 
           StyleBox["4", "TR"]]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]generates the function pair used in a parametric \
representation of a cubic Bezier curve with anchors ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["4", "TR"]]], "InlineFormula"],
     " and control points ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["3", "TR"]]], "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"CubicBezierComponents", "[", 
       RowBox[{
        StyleBox["t", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["pt", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["pt", "TI"], 
           StyleBox["2", "TR"]], ",", 
          SubscriptBox[
           StyleBox["pt", "TI"], 
           StyleBox["3", "TR"]], ",", 
          SubscriptBox[
           StyleBox["pt", "TI"], 
           StyleBox["4", "TR"]]}], "}"}], ",", "\"\<Horizontal\>\""}], "]"}]],
       "InlineFormula"],
     "\[LineSeparator]returns the first element from the function pair used \
in a parametric representation of a cubic Bezier curve with anchors ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["4", "TR"]]], "InlineFormula"],
     " and control points ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["3", "TR"]]], "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"CubicBezierComponents", "[", 
       RowBox[{
        StyleBox["t", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["pt", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["pt", "TI"], 
           StyleBox["2", "TR"]], ",", 
          SubscriptBox[
           StyleBox["pt", "TI"], 
           StyleBox["3", "TR"]], ",", 
          SubscriptBox[
           StyleBox["pt", "TI"], 
           StyleBox["4", "TR"]]}], "}"}], ",", "\"\<Vertical\>\""}], "]"}]], 
      "InlineFormula"],
     "\[LineSeparator]returns the second element from the function pair used \
in a parametric representation of a cubic Bezier curve with anchors ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["4", "TR"]]], "InlineFormula"],
     " and control points ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["3", "TR"]]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->32324713],

Cell[TextData[{
 "The points ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["p", "TI"], 
   StyleBox["i", "TI"]]], "InlineFormula"],
 " should be ordered pairs but can be either numeric or symbolic."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The variable ",
 Cell[BoxData[
  StyleBox["t", "TI"]], "InlineFormula"],
 " should be given as a symbol."
}], "Notes",
 CellID->2070185373],

Cell[TextData[{
 "Values of ",
 Cell[BoxData[
  StyleBox["t", "TI"]], "InlineFormula"],
 " outside the interval (0, 1) may return nonsensical results."
}], "Notes",
 CellID->75515317]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->320795420],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->474968395],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->23097442],

Cell["\<\
Create the components of a Bezier curve with anchor-controlpairs {-1,-1}, \
{-3,1} and {1,1}, {3,-1}.\
\>", "ExampleText",
 CellID->1651651234],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"CubicBezierComponents", "[", 
  RowBox[{"t", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "1"}], ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"3", ",", 
       RowBox[{"-", "1"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->928668716],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "1"}], "-", 
    RowBox[{"6", " ", "t"}], "+", 
    RowBox[{"24", " ", 
     SuperscriptBox["t", "2"]}], "-", 
    RowBox[{"16", " ", 
     SuperscriptBox["t", "3"]}]}], ",", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"2", " ", "t"}]}], ")"}], "3"]}], "}"}]], "Output",
 ImageSize->{225, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1761783168]
}, Open  ]],

Cell["The results can be differentiated.", "ExampleText",
 CellID->909915490],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"D", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"-", "1"}], "-", 
      RowBox[{"6", " ", "t"}], "+", 
      RowBox[{"24", " ", 
       SuperscriptBox["t", "2"]}], "-", 
      RowBox[{"16", " ", 
       SuperscriptBox["t", "3"]}]}], ",", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{
        RowBox[{"-", "1"}], "+", 
        RowBox[{"2", " ", "t"}]}], ")"}], "3"]}], "}"}], ",", "t"}], 
  "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->718590143],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "6"}], "+", 
    RowBox[{"48", " ", "t"}], "-", 
    RowBox[{"48", " ", 
     SuperscriptBox["t", "2"]}]}], ",", 
   RowBox[{"6", " ", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "1"}], "+", 
       RowBox[{"2", " ", "t"}]}], ")"}], "2"]}]}], "}"}]], "Output",
 ImageSize->{199, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->2043986320]
}, Open  ]],

Cell["\<\
Dividing the derivative terms give the rate of one component with respect to \
the other.\
\>", "ExampleText",
 CellID->2129662828],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"(", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{"-", "6"}], "+", 
       RowBox[{"48", " ", "t"}], "-", 
       RowBox[{"48", " ", 
        SuperscriptBox["t", "2"]}]}], ",", 
      RowBox[{"6", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "1"}], "+", 
          RowBox[{"2", " ", "t"}]}], ")"}], "2"]}]}], "}"}], "/.", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a_", ",", "b_"}], "}"}], "\[RuleDelayed]", " ", 
     RowBox[{"b", "/", "a"}]}]}], ")"}], "//", "Simplify"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1133205647],

Cell[BoxData[
 RowBox[{"-", 
  FractionBox[
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", 
      RowBox[{"2", " ", "t"}]}], ")"}], "2"], 
   RowBox[{"1", "-", 
    RowBox[{"8", " ", "t"}], "+", 
    RowBox[{"8", " ", 
     SuperscriptBox["t", "2"]}]}]]}]], "Output",
 ImageSize->{90, 36},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->682310595]
}, Open  ]],

Cell["\<\
The same results can be obtained by specifying the components.\
\>", "ExampleText",
 CellID->31495185],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"D", "[", 
   RowBox[{
    RowBox[{"CubicBezierComponents", "[", 
     RowBox[{"t", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "3"}], ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", "\"\<Vertical\>\""}], 
     "]"}], ",", "t"}], "]"}], "/", 
  RowBox[{"D", "[", 
   RowBox[{
    RowBox[{"CubicBezierComponents", "[", 
     RowBox[{"t", ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "1"}], ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"-", "3"}], ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"3", ",", 
          RowBox[{"-", "1"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}]}], "}"}], ",", "\"\<Horizontal\>\""}],
      "]"}], ",", "t"}], "]"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->2087482583],

Cell[BoxData[
 FractionBox[
  RowBox[{"6", " ", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "1"}], "+", 
      RowBox[{"2", " ", "t"}]}], ")"}], "2"]}], 
  RowBox[{
   RowBox[{"-", "6"}], "+", 
   RowBox[{"48", " ", "t"}], "-", 
   RowBox[{"48", " ", 
    SuperscriptBox["t", "2"]}]}]]], "Output",
 ImageSize->{104, 36},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1621787040]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["CubicBezier",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/CubicBezier"],
  FontFamily->"Verdana"]], "InlineFormula"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Calculus Applications",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/CalculusApplications"]], "MoreAbout",
 CellID->347959879],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->10658810]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"CubicBezierComponents - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 25, 48.8212624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "CubicBezierComponents[t, {pt_1, pt_2, pt_3, pt_4}] generates the \
function pair used in a parametric representation of a cubic Bezier curve \
with anchors pt_1 and pt_4 and control points pt_2 and \
pt_3.CubicBezierComponents[t, {pt_1, pt_2, pt_3, pt_4}, \"Horizontal\"] \
returns the first element from the function pair used in a parametric \
representation of a cubic Bezier curve with anchors pt_1 and pt_4 and control \
points pt_2 and pt_3.CubicBezierComponents[t, {pt_1, pt_2, pt_3, pt_4}, \
\"Vertical\"] returns the second element from the function pair used in a \
parametric representation of a cubic Bezier curve with anchors pt_1 and pt_4 \
and control points pt_2 and pt_3.", "synonyms" -> {}, "title" -> 
    "CubicBezierComponents", "titlemodifier" -> "", "windowtitle" -> 
    "CubicBezierComponents", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/CubicBezierComponents"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[8984, 282, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->320795420]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 19408, 644}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[614, 21, 2910, 67, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3549, 92, 64, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3616, 95, 4105, 133, 265, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[7758, 233, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->32324713],
Cell[8369, 253, 232, 8, 70, "Notes",
 CellID->1067943069],
Cell[8604, 263, 157, 6, 70, "Notes",
 CellID->2070185373],
Cell[8764, 271, 183, 6, 70, "Notes",
 CellID->75515317]
}, Closed]],
Cell[CellGroupData[{
Cell[8984, 282, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->320795420],
Cell[CellGroupData[{
Cell[9499, 300, 195, 6, 31, "ExampleSection",
 CellID->474968395],
Cell[9697, 308, 126, 3, 28, "Input",
 CellID->23097442],
Cell[9826, 313, 153, 4, 32, "ExampleText",
 CellID->1651651234],
Cell[CellGroupData[{
Cell[10004, 321, 513, 18, 28, "Input",
 CellID->928668716],
Cell[10520, 341, 525, 19, 39, "Output",
 CellID->1761783168]
}, Open  ]],
Cell[11060, 363, 77, 1, 70, "ExampleText",
 CellID->909915490],
Cell[CellGroupData[{
Cell[11162, 368, 516, 19, 70, "Input",
 CellID->718590143],
Cell[11681, 389, 492, 18, 39, "Output",
 CellID->2043986320]
}, Open  ]],
Cell[12188, 410, 141, 4, 70, "ExampleText",
 CellID->2129662828],
Cell[CellGroupData[{
Cell[12354, 418, 644, 22, 70, "Input",
 CellID->1133205647],
Cell[13001, 442, 410, 15, 57, "Output",
 CellID->682310595]
}, Open  ]],
Cell[13426, 460, 112, 3, 70, "ExampleText",
 CellID->31495185],
Cell[CellGroupData[{
Cell[13563, 467, 1243, 41, 70, "Input",
 CellID->2087482583],
Cell[14809, 510, 456, 17, 57, "Output",
 CellID->1621787040]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15326, 534, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[15775, 549, 225, 6, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[16037, 560, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[16488, 575, 175, 4, 70, "MoreAbout",
 CellID->347959879],
Cell[16666, 581, 170, 4, 70, "MoreAbout",
 CellID->10658810]
}, Open  ]],
Cell[16851, 588, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

