(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     20451,        728]
NotebookOptionsPosition[     15036,        556]
NotebookOutlinePosition[     17501,        618]
CellTagsIndexPosition[     17416,        613]
WindowTitle->DifferenceQuotient - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Differentiation\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/Differentiation"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/DifferenceQuotient\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/DifferenceQuotient"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/DifferenceQuotient.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/DifferenceQuotient", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["DifferenceQuotient", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DifferenceQuotient", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        StyleBox["x", "TI"], ",", 
        StyleBox["\[Delta]", "TR"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]returns the difference quotient for ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " where ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " is given as a symbol."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DifferenceQuotient", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["a", "TI"], ",", 
          StyleBox["b", "TI"]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns ",
     Cell[BoxData[
      FractionBox[
       RowBox[{
        RowBox[{
         StyleBox["f", "TI"], 
         RowBox[{"(", 
          StyleBox["a", "TI"], ")"}]}], "-", 
        RowBox[{
         StyleBox["f", "TI"], 
         RowBox[{"(", 
          StyleBox["b", "TI"], ")"}]}]}], 
       RowBox[{
        StyleBox["a", "TI"], "-", 
        StyleBox["b", "TI"]}]]], "InlineFormula"],
     " where ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " is given as a symbol"
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DifferenceQuotient", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          StyleBox["fun", "TI"], ",", 
          StyleBox["var", "TI"]}], 
         StyleBox["}", "TI"]}], ",", " ", 
        StyleBox["\[Delta]", "TR"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns the standard difference quotient for ",
     Cell[BoxData[
      StyleBox["fun", "TI"]], "InlineFormula"],
     " with offset \[Delta]."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DifferenceQuotient", "[", 
       RowBox[{
        RowBox[{"{", 
         StyleBox[
          RowBox[{"f", ",", " ", "var"}], "TI"], 
         StyleBox["}", "TI"]}], ",", " ", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["a", "TI"], ",", 
          StyleBox["b", "TI"]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]",
     "returns the difference quotient ",
     Cell[BoxData[
      FractionBox[
       RowBox[{
        RowBox[{
         StyleBox["f", "TI"], 
         RowBox[{"(", 
          StyleBox["a", "TI"], ")"}]}], "-", 
        RowBox[{
         StyleBox["f", "TI"], 
         RowBox[{"(", 
          StyleBox["b", "TI"], ")"}]}]}], 
       RowBox[{
        StyleBox["a", "TI"], "-", 
        StyleBox["b", "TI"]}]]], "InlineFormula"]
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->22305657],

Cell["\<\
Note the function must be given in a list along with the variable.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
The function can be entered as an expression or you can use a previously \
defined function.\
\>", "Notes",
 CellID->1011743334],

Cell["\<\
DifferenenceQuotient will work with piecewise defined functions.\
\>", "Notes",
 CellID->594697592]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->45235413],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->569578284],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1234661206],

Cell["Calculate a symbolic difference for f.", "ExampleText",
 CellID->1461489585],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DifferenceQuotient", "[", 
  RowBox[{"f", ",", "x", ",", "\[Delta]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->337500709],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", 
    RowBox[{"f", "[", "x", "]"}]}], "+", 
   RowBox[{"f", "[", 
    RowBox[{"x", "+", "\[Delta]"}], "]"}]}], "\[Delta]"]], "Output",
 ImageSize->{106, 32},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1629103429]
}, Open  ]],

Cell["Use the two point form.", "ExampleText",
 CellID->2072315600],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DifferenceQuotient", "[", 
  RowBox[{"g", ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1518502154],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"g", "[", "a", "]"}], "-", 
   RowBox[{"g", "[", "b", "]"}]}], 
  RowBox[{"a", "-", "b"}]]], "Output",
 ImageSize->{78, 32},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1348176488]
}, Open  ]],

Cell[TextData[{
 "Calculate the difference quotient for ",
 Cell[BoxData[
  RowBox[{
   SuperscriptBox["x", "2"], "."}]], "InlineFormula"]
}], "ExampleText",
 CellID->1963891928],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DifferenceQuotient", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SuperscriptBox["x", "3"], ",", "x"}], "}"}], ",", "\[Delta]"}], 
  "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->307979506],

Cell[BoxData[
 FractionBox[
  RowBox[{
   RowBox[{"-", 
    SuperscriptBox["x", "3"]}], "+", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"x", "+", "\[Delta]"}], ")"}], "3"]}], "\[Delta]"]], "Output",
 ImageSize->{90, 35},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->775968072]
}, Open  ]],

Cell["\<\
Use the alternate form with two values for the independent variable.\
\>", "ExampleText",
 CellID->27197873],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DifferenceQuotient", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SuperscriptBox["x", "3"], ",", "x"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", "b"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1848118347],

Cell[BoxData[
 FractionBox[
  RowBox[{
   SuperscriptBox["a", "3"], "-", 
   SuperscriptBox["b", "3"]}], 
  RowBox[{"a", "-", "b"}]]], "Output",
 ImageSize->{48, 35},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->121587821]
}, Open  ]],

Cell["\<\
Let one of the values for the independent variable be a number.\
\>", "ExampleText",
 CellID->1269559250],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DifferenceQuotient", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SuperscriptBox["x", "3"], ",", "x"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "b"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->84798158],

Cell[BoxData[
 FractionBox[
  RowBox[{"27", "-", 
   SuperscriptBox["b", "3"]}], 
  RowBox[{"3", "-", "b"}]]], "Output",
 ImageSize->{49, 35},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->1420983545]
}, Open  ]],

Cell["Use Expand or Simplify to clear the denominator.", "ExampleText",
 CellID->304802528],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{"DifferenceQuotient", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      SuperscriptBox["x", "3"], ",", "x"}], "}"}], ",", "\[Delta]"}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->1067590001],

Cell[BoxData[
 RowBox[{
  RowBox[{"3", " ", 
   SuperscriptBox["x", "2"]}], "+", 
  RowBox[{"3", " ", "x", " ", "\[Delta]"}], "+", 
  SuperscriptBox["\[Delta]", "2"]}]], "Output",
 ImageSize->{93, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->759276122]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Simplify", "[", 
  RowBox[{"DifferenceQuotient", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      SuperscriptBox["x", "3"], ",", "x"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "b"}], "}"}]}], "]"}], "]"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->805951980],

Cell[BoxData[
 RowBox[{"9", "+", 
  RowBox[{"3", " ", "b"}], "+", 
  SuperscriptBox["b", "2"]}]], "Output",
 ImageSize->{67, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->1455566231]
}, Open  ]],

Cell["Use Limit to find the derivative.", "ExampleText",
 CellID->1715421440],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"3", " ", 
     SuperscriptBox["x", "2"]}], "+", 
    RowBox[{"3", " ", "x", " ", "\[Delta]"}], "+", 
    SuperscriptBox["\[Delta]", "2"]}], ",", 
   RowBox[{"\[Delta]", "\[Rule]", " ", "0"}]}], "]"}]], "Input",
 CellLabel->"In[9]:=",
 CellID->1120181105],

Cell[BoxData[
 RowBox[{"3", " ", 
  SuperscriptBox["x", "2"]}]], "Output",
 ImageSize->{27, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]=",
 CellID->2042182133]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Limit", "[", 
  RowBox[{
   RowBox[{"9", "+", 
    RowBox[{"3", " ", "b"}], "+", 
    SuperscriptBox["b", "2"]}], ",", 
   RowBox[{"b", "\[Rule]", " ", "3"}]}], "]"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->1871462977],

Cell[BoxData["27"], "Output",
 ImageSize->{18, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[10]=",
 CellID->1632760477]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"D", "[", 
   RowBox[{
    SuperscriptBox["x", "3"], ",", "x"}], "]"}], "/.", 
  RowBox[{"x", "\[Rule]", " ", "3"}]}]], "Input",
 CellLabel->"In[11]:=",
 CellID->1259295573],

Cell[BoxData["27"], "Output",
 ImageSize->{18, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[11]=",
 CellID->1529354226]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->1915074],

Cell[TextData[ButtonBox["Differentiation",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/Differentiation"]], "MoreAbout",
 CellID->71453413]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DifferenceQuotient - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 26, 0.6928624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "DifferenceQuotient[f, x, \\[Delta]] returns the difference quotient for \
f where f is given as a symbol.DifferenceQuotient[f, {a, b}] returns (f (a) - \
f (b))/(a - b) where f is given as a symbolDifferenceQuotient[{fun, var}, \
\\[Delta]] returns the standard difference quotient for fun with offset \
\\[Delta].DifferenceQuotient[{f, var}, {a, b}] returns the difference \
quotient (f (a) - f (b))/(a - b)", "synonyms" -> {}, "title" -> 
    "DifferenceQuotient", "titlemodifier" -> "", "windowtitle" -> 
    "DifferenceQuotient", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/DifferenceQuotient"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7202, 225, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->45235413]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 17274, 606}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[611, 21, 2594, 59, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3230, 84, 61, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3294, 87, 2858, 94, 288, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[6189, 186, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->22305657],
Cell[6800, 206, 112, 3, 70, "Notes",
 CellID->1067943069],
Cell[6915, 211, 138, 4, 70, "Notes",
 CellID->1011743334],
Cell[7056, 217, 109, 3, 70, "Notes",
 CellID->594697592]
}, Closed]],
Cell[CellGroupData[{
Cell[7202, 225, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->45235413],
Cell[CellGroupData[{
Cell[7716, 243, 195, 6, 31, "ExampleSection",
 CellID->569578284],
Cell[7914, 251, 128, 3, 28, "Input",
 CellID->1234661206],
Cell[8045, 256, 82, 1, 32, "ExampleText",
 CellID->1461489585],
Cell[CellGroupData[{
Cell[8152, 261, 154, 4, 28, "Input",
 CellID->337500709],
Cell[8309, 267, 320, 11, 53, "Output",
 CellID->1629103429]
}, Open  ]],
Cell[8644, 281, 67, 1, 70, "ExampleText",
 CellID->2072315600],
Cell[CellGroupData[{
Cell[8736, 286, 187, 6, 70, "Input",
 CellID->1518502154],
Cell[8926, 294, 283, 10, 53, "Output",
 CellID->1348176488]
}, Open  ]],
Cell[9224, 307, 178, 6, 70, "ExampleText",
 CellID->1963891928],
Cell[CellGroupData[{
Cell[9427, 317, 223, 8, 70, "Input",
 CellID->307979506],
Cell[9653, 327, 336, 12, 56, "Output",
 CellID->775968072]
}, Open  ]],
Cell[10004, 342, 118, 3, 70, "ExampleText",
 CellID->27197873],
Cell[CellGroupData[{
Cell[10147, 349, 263, 9, 70, "Input",
 CellID->1848118347],
Cell[10413, 360, 274, 10, 56, "Output",
 CellID->121587821]
}, Open  ]],
Cell[10702, 373, 115, 3, 70, "ExampleText",
 CellID->1269559250],
Cell[CellGroupData[{
Cell[10842, 380, 261, 9, 70, "Input",
 CellID->84798158],
Cell[11106, 391, 251, 9, 56, "Output",
 CellID->1420983545]
}, Open  ]],
Cell[11372, 403, 91, 1, 70, "ExampleText",
 CellID->304802528],
Cell[CellGroupData[{
Cell[11488, 408, 261, 9, 70, "Input",
 CellID->1067590001],
Cell[11752, 419, 309, 10, 36, "Output",
 CellID->759276122]
}, Open  ]],
Cell[CellGroupData[{
Cell[12098, 434, 303, 10, 70, "Input",
 CellID->805951980],
Cell[12404, 446, 238, 8, 36, "Output",
 CellID->1455566231]
}, Open  ]],
Cell[12657, 457, 77, 1, 70, "ExampleText",
 CellID->1715421440],
Cell[CellGroupData[{
Cell[12759, 462, 328, 10, 70, "Input",
 CellID->1120181105],
Cell[13090, 474, 205, 7, 36, "Output",
 CellID->2042182133]
}, Open  ]],
Cell[CellGroupData[{
Cell[13332, 486, 246, 8, 70, "Input",
 CellID->1871462977],
Cell[13581, 496, 161, 5, 36, "Output",
 CellID->1632760477]
}, Open  ]],
Cell[CellGroupData[{
Cell[13779, 506, 207, 7, 70, "Input",
 CellID->1259295573],
Cell[13989, 515, 161, 5, 36, "Output",
 CellID->1529354226]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14211, 527, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[14662, 542, 169, 4, 70, "MoreAbout",
 CellID->1915074],
Cell[14834, 548, 160, 3, 70, "MoreAbout",
 CellID->71453413]
}, Open  ]],
Cell[15009, 554, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

