(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    402886,       7182]
NotebookOptionsPosition[    394862,       6924]
NotebookOutlinePosition[    398246,       7017]
CellTagsIndexPosition[    398122,       7011]
WindowTitle->DirectionFieldPlot - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Differentiation\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/Differentiation"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/DirectionFieldPlot\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/DirectionFieldPlot"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/DirectionFieldPlot.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/DirectionFieldPlot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["DirectionFieldPlot", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"DirectionFieldPlot", "[", 
       RowBox[{
        SubscriptBox[
         StyleBox["y", "TI"], 
         StyleBox["prm", "TI"]], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["y", "TI"], ",", 
          SubscriptBox[
           StyleBox["y", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["y", "TI"], 
           StyleBox["max", "TI"]]}], "}"}]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]plots a direction field for the derivative ",
     Cell[BoxData[
      RowBox[{" ", 
       SubscriptBox[
        StyleBox["y", "TI"], 
        StyleBox["prm", "TI"]]}]], "InlineFormula"],
     " including 5 solution curves"
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->394872697],

Cell["\<\
DirectionFieldPlot takes any options that will work with VectorPlot in \
addition to PointStyle.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
The number of solutions can be set with the option StreamPoints.\
\>", "Notes",
 CellID->763815093],

Cell["\<\
The hash marks are set to divide unit intervals into four equal parts.\
\>", "Notes",
 CellID->488935064],

Cell["\<\
AspectRatio is set to Automatic by default to help students better understand \
how slope influences the solution.\
\>", "Notes",
 CellID->2128863058]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->93268675],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->331067006],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1930509932],

Cell[TextData[{
 "Plot the direction field for the ODE ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"y", "'"}], "==", " ", 
   RowBox[{"x", " ", "+", " ", "y"}]}]], "InlineFormula"],
 "  "
}], "ExampleText",
 CellID->1897488248],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DirectionFieldPlot", "[", 
  RowBox[{
   RowBox[{"x", "+", "y"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->952826186],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS906zyz7t+7Ltlww9LCwg1LCwsDA0/IWavggsLQwMDA0MBAw9DAwMDQ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    "], {{0, 360}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 360},
  PlotRange->{{0, 360}, {0, 360}}]], "Output",
 ImageSize->{364, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->61507767]
}, Open  ]],

Cell[TextData[{
 "Plot the direction field for ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"y", "'"}], "\[Equal]", " ", 
   RowBox[{
    RowBox[{"x", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "2"}], " ", "x"}]]}], " ", "-", " ", 
    RowBox[{"2", " ", "y"}]}]}]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->352579191],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DirectionFieldPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "2"}], " ", "x"}]]}], "-", 
    RowBox[{"2", " ", "y"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "2"}], ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "3"}], ",", "2"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->891081064],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS2UIk2zrd+7rhk5cuzIkS3btmyJbHkwZ60WVyDbIpFILBKJxCKRSCwS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    "], {{0, 360}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 360},
  PlotRange->{{0, 360}, {0, 360}}]], "Output",
 ImageSize->{364, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->472824334]
}, Open  ]],

Cell[TextData[{
 "Plot the direction field for ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"y", "'"}], "\[Equal]", " ", 
   RowBox[{
    RowBox[{"x", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "2"}], " ", "x"}]]}], " ", "-", " ", 
    RowBox[{"2", " ", "y"}]}]}]], "InlineFormula"],
 " and show the solution satisfying ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"y", 
    RowBox[{"(", "0", ")"}]}], "\[Equal]", 
   RowBox[{
    RowBox[{"-", "1"}], "/", "2"}]}]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->1220482771],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DirectionFieldPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"x", " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "2"}], " ", "x"}]]}], "-", 
    RowBox[{"2", " ", "y"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "2"}], ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "3"}], ",", "2"}], "}"}], ",", 
   RowBox[{"StreamPoints", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"0", ",", 
       RowBox[{
        RowBox[{"-", "1"}], "/", "2"}]}], "}"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1056756723],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS90Izuz7c9bjww8cOiBAweGDgwMDLwmdy2DBwJDDQ0NTQ0NG5oaGjY0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    "], {{0, 360}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 360},
  PlotRange->{{0, 360}, {0, 360}}]], "Output",
 ImageSize->{364, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->581505]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(4)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->326097713],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "PointStyle",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->345995247],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1133845624],

Cell["\<\
By default DirectionFieldPlot inserts pale blue points at integer lattice \
points.\
\>", "ExampleText",
 CellID->187658081],

Cell[CellGroupData[{

Cell["DirectionFieldPlot[x-y,{x,-4,4},{y,-3,3}]", "Input",
 CellLabel->"In[2]:=",
 CellID->1463373571],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS1wIzvw7e+rRxYueVVLFwYuDA0MDAz8m7yqgAcCQw0NDU0NDQ1NDQ0N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    "], {{0, 277}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 277},
  PlotRange->{{0, 360}, {0, 277}}]], "Output",
 ImageSize->{364, 277},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->90677503]
}, Open  ]],

Cell["The style can be changed using PointStyle.", "ExampleText",
 CellID->1624585645],

Cell[CellGroupData[{

Cell["\<\
DirectionFieldPlot[x-y,{x,-4,4},{y,-3,3},PointStyle-> \
{PointSize[Medium],Green}]\
\>", "Input",
 CellLabel->"In[3]:=",
 CellID->1303847557],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS9wIz3zrXPrkhcuuVVLFwYGhgYaGhr+TG6VwQWGpoaGhqaGgYamgYaG
poaBgXOPJHs8f9SPxjOZxJt1135v7bfyjEZSq9VqHZ3+8z//b/g///vh4eH/
/K+Hh/+r/7m/Z9fIw13ucpe7XG83PvFnP+PZv+6D78/eeKW3/+zdbnR/9q/7
4PuzN17p7T/bwm408VK6fPlfJ/9UY7N/rL3/VGOzBu292X3KXyf/VGOzf6y9
/1Rjs+/ep9zlB8tdB+5ytxt3uVbuOnCXPuzGx0f70vd3Kv55z3LpbcrdbtzF
1IH94tlHP54X+0a/L8jmdb9cvlml6/Vef6zS1XK32Zils9l2tztapdPpdr9/
t0pHo1eY4MPhqzWF9e/D4dp6UO/Um61Sfc90urFKt9vDYgEdtXt9NbtCD769
QVdsDgezK8Zj7gqzseoKNdbSATV2Pjebo7bAyGrcYWThtWrIarWzSvXOw8Fs
6d6uMfs7TfqXiW039n6MN+Oy4WhiN5aH18Fu/JrFZ5ObLKhdoAYqgqk0eV2O
j1OrXrY5kwlNtNFQEy1etM22j69Dq1LJYAA2J2ttcxb7NXSyN85mNy6dcT5Y
pdxRo9VCOmDVC+aXDaxs4Hy+hQ9We+fZPFqveslaL7iHQdn0tVqGNtk2Wqm6
F1ao7rI16v1cUa9a9WqSwjTMknZgv1iUNTdpNzbZ5kG/8n/WWWTKaHpqklqP
S2NhskjbrQU6Wa/6AafSG6yG89n27S0y0dTPeaXWKE/GZJFkVWBds2xOsl7X
yWOzG9UWGQerdGt38qneB7NePQgWSSMLFkle0NHwDTbYXnkUetZ6LehM5o2k
5bat31+tSjVk0mHLbR6PXqVO0WHVPyYNThOlykX2zdIujaNsZnQ4jkfXY5WG
F+sdvc65XrADp51KWf2SWNNRNsprH2SD+g+c209LcGFV2lfH5bA3bU6y3rft
gb1oMLCv63hpslLJcr7dvZpv5sXdTaVjRP+a1At+TqS00NWwLzvV+2DWyz6S
Wgr2ShpeXwFL9drtlWXQEmm92W9gydVs18lahvTmqH3Y+DkrnansB1WR+ufl
ZaX/1p0WleqdL8dhXu/T+4v+pTL39c6ww1UV8oTrmqlS/bt+EN2NylxE9SrZ
3mtw5ptx2XAk/Y1ltsxrX2SL6G+klrDIqldPfxsMNADFIj1lTYdkvbwqsRek
ro4qfJPG7mbLw+Oz9WaOBWkeRfdlTeqFlTTzU6lkr15e1Mj8/6krosviqd4H
qpfjSO1Kk+3lTZBKYej94rupK6QqyiuV9x59Vn0o78JyITR2I8P30COa786G
PMuGbMMo73dHGZPh2zSvd7ib5PFAqaizFcO13qkVUMah3lfBXi3mcYuReY2y
9oOLwyTZ3lxSdmC/GF8d31CH/zk+jd8nH1n84zmAeQk1TKdqZ6V0ZO+gVe/v
w+M0m1n1csQv4QUN44qnSp+z5+ftyKr0qJXuv1/Wm/0CbS7Bftcftyqq9+nj
ebAbW/Vq22Ut31ndv5rP3Z+zaI2znHA3mx4eBnuzXo5BcSkEXlTv4/FpdDSV
ys2vlflmDkFbjpAqfcleJvIR5hHDEsRFQiabVzvU7+by8BVaLR2olIZ6Z2VN
1s+8rYi/RNbPWQzDxwg/0HfGu9eHgbI/v4dvk3q9UbHsgPyM2HFK0zM43udy
qezhaaFcrWREKqW8R+bwphYdiK6zFzTEQMTFR4rJu+zG0fzm1IbCfLO3ZmTr
wE4GNbv8/91Oxs8sLYt0AOrlZ/mb+ejKnebYpVlqBFlzZCphoyqlsrYkQfTs
1lbpzHVLj3HUzHcO4wFkGONTQ+vFf/9pUDejuAMZlZ5wX7BXTZZq1ThZ77Iy
B2m9YGX+OA92wRxqSBwBy17ZHtT+8eV9aU7/xFFOD25/vPTPn6Jxg2elA/zN
XKpRAG9TawrN7tX+zR7B3e4d5r5mFp8RgF5lKZTOXymvr9nv36etyfPLVY/2
ZDc0RrCyq9SKnGd+wTqNkX73q+rhqwhG8PJsTECZQyksKPwsB8nfZ3O35zKE
V6LkN39aqVy71cW4QTdKB6KBxCbPZndcxC3Ifu8iWg8Plz+1MwiWr8eLslJV
S2UPCzu66569ndK3NzdMV0oXoGmbubndukB0A7njRf9i0WzSAlG0GPpjL2qW
9GE3XvGMgHEU1a2ENHl7CVhZOIogY0RKyPGGVRKCDBwyVY1jQkoc9c3uFdpC
1oQPfz2kpOWuyp0t2h6duiJuWGSlPyj+oHdOpxtLBxgstEwhQsH8wgG63gmv
haLsR249kqK9ydNTyWho0GvBN2k1d04f/Bt8TM84impUvHykwsGNS0A1Ju2Q
EqdStDkcFD1ZJA1WzRUM8BvrQe7GFEad8KIm2mE81pMJvKiNM/dxy5Yn3WxC
k59k+VfQS3pkOt1as0PfA7p0U1st+JilpSFyOXws1P2pHVkGVBtEt3ri3+CI
OuModhWkhBpVOFJhNDJjIbyfwwFVsEgJWBFaJO8FyQAuIvFqOKYBsErW4F4M
w1HmUYvktyoMsFQ3gg4kOsqAhQSB0xA+SWGMsYWByc5gcmtFkKZZ6qS+lZZG
PTp9qnT4Ew2LPs/SrjMiNNK6KCL0JKvV8WW4G02d0dByVhO20kF6iosm3H48
xStZlfKmO4lRTyzQrfGiiQ0FHeKcFvfNRs2ul86czaGDY/Bz/JGHVXglXjQX
v1Xhe3ygA10GqOkpW0wYL6pK7QssH+B1aEpODTSpQ3yNX2VbKltjjYiq03Kg
UulMZeYGRGjwBov/rVg2/Uw2QS8fDl81ynVcCiNCVWpqznoto+F8UX2oXI5t
dTjYpc+lJ7vBwYQrsBBqnTTZKi1LwiJ1wIuml2/bC9qGfZm2kH/+1Ev9vsy+
x2evlVnqTg2DZMw1pcFWRTpAsL1UlKmPY2UNPVzy1b+D481eR1AMyyhp6NVe
D42oPi5909ipSCZavwnrjt629ncWwrhf/n5GhEpVpMNqS7jv3AIRqgfNOID3
NC76tqmq9BZjCEXpyW6odgY5832BkuKVI4q8BDPyp+USfNWdmppcLFIZIBFE
/ZDCi7ZBk2apAIhZ6h08flY60No361LKCFh2ZhiXy16HRl/z1IwVnH0Pho2B
Dc/FuRnbA18oZkQomLiLp2F/JGz3KtKT3WBvJ7kUlmxOOaLolkLbIlkXK4LA
jcss5SOljmNWaXvll/Los9aDHOLo8ixZQnf2TVsV6QBYUfb6MvzmzN0jIMvP
iN8FRlc4bsOmIzwO3l3mpy2UforwGYcWERMLVPE0ahIctuZhmZ7sBi9YvJOt
BjBHI3d4dBbe5ybslbwgW684psfPsmN/8r5isPksZeu6IDOn7Z49b1Wsr5IO
yAsCj1GDC96mg2TbPbl109Ms1SfBipl5uDiUQr3ZjZ2SfKZotRqP2eZIE66y
e/3xi8JnMJa+WrpYaFo2fJY7R58EutHl2Ub4SXlNsfB1st70mz+31G9VGC/6
Y6fYzxNNHy0Eny194De6TIRIaeEk4utA19eUXjG1f/0qrmopYG370q5oUn+q
YhXe8aJ/jczpgkM76Q+/0Y5TIi+t7iILRyoJkGQPzFpZ6mLpdcxaMoCFIPba
oAMK0pU7C6PHVtGJqsIIxWj3of2apQNqDnPDwuhASFPNhP0FbIiyL4k53K7I
Sy846hVxGxM7UsQXALN+9impY/preCGCnJdpRkosExNtu7eREq35RbOrjmnK
NBed8KKbA0T4GeTGaAeHUV9vrAs1jBcd2nhRPv3hkbUouTJkGAuIUGtY9T3Q
RTcFQQfd01DGV8PJ5DCaWtEeRoRycDJIH3aDORba8Is+P7s79amQeJd7MewF
8b0Yx4uLKOiLztcuuIEXxIe/DMrd7+h4ly2SM90y7OUbhbmoh0EH+LQLTkMC
U7rVFVoZGaNujTubjsC4FZ0+aoiFbtU7pYefyKehPrG4OwJjWFQzQ5/E3a3x
eDeew+kJIJydw2kPRC7fgxe9llnrfMU7ic6aAjoLMS1sYy1+0SCN8KK5lJkB
OrGsJzI7IA1RkjxHLm4MGC97BTrQxYNK4EX5xo192sWmY78/WudZwZOJYo3k
6amZ6iXV623IpaMtRKj+WxyOgOjIkaV1zyewhEnrooMoO2P6YDIakwX0FZ85
NgGZZ73ZjS7MWhEsxHKZh3dSl8jMUl6gGU3KFql6p6YsVXx7mckznWumLZrU
2au2lGsuFvG6jZ7+ZF4H0vdxDOEYVJdDZyhl0+GRGxurn4PnFrUteq0GV8Mn
vdIGbT7fhsM+RoTmCFI9+Ba7yQKspEE0duYaNxw6o2HrDCNC+S5GUXrDiyIp
LrJjRcaocEtFapm6svH5aNIkf90VaNLyOp7yoGi70ZqbNGt4lyd2hzc74TfM
N3O9XRCw3FcBTA6bPjAdmTfRgJYMvgfMKXedrcEyrZ0fzIuQ7aXOgp5LAhE6
HL7N1q0RoWrCbLCo31iJyg3iRSOlx2PxSCVxWR7RpK2XswSadLhme3UpfX2t
XHBrjQjt+Gwa1Vlw84oS+EV5E8SYT4jk8/iuMd7LF2OD6YBBdMS/iAb/gmAp
Bxa0jzPjKvI05itGhEIsVLIazvn8vSh94DeybnjReOn5SIVPCrqgSVPkHogm
XRCatBTiqJEf6s2INaX95iL1LKA6OVOko9nZ7KN38TT6zPPJkOz97h3GSPM6
wQJqP5uliHp+LFxNK9GWaJMzb/ToVPp14y6CNSB86w+/EeSTae6en0NYIPkg
/KDLs5+ZPFr+/+4yNbpgPnvnEiyD/IPccV+3Jd5odHrDen3i8ImBdqLSh93o
hMy04h6e+AtWzyxFDtzt2fYtikz8M4pD+9kO2HUo7IQmLUn54Dg8eLcbtyIa
D62nHY2GVDHnDGS9KUhP/KKcG/oKftHCY9qeJbj+mPRjSCHTwUvLa/K8p44z
a50nowce0Nkio7PAmiXiLXZUJAKjenzMo6PagADfF6cwgPwjgZXCejBKQ1F8
1ir64aLefHl535r6A0RhmZ9objim04vROC8QPhCUuFDfh91IRNSv4hfNxV8K
+y5+0dbEHWapD3Ew2iFBitiBHSvVFeUTq0J0NCBCLR3owiAKOeXDIYL1IGBf
5WFCkO2mDA4YRg1WxAvQP728bBebTojQ8bhEUHw+5uMT/CC3zi9alP/+68Iv
ylgI5he9LtdqWeJe0BnF8S38onyIX/WC9B0FyrUkXhQ6CowzN4fHHY7n9O/W
wb3aKK8sanPUYnVCMnF8c/HX/+PaFdAa0envqfJjHKHHo8ssujAxJxkuDe7A
Wl39MqhmQ9ifECZw3yqXr8eLciktwY+Px+2uNX0le0G8fCd3Xgn8VV05zyGO
RBo4exXOkuyjbe/URGjJCymZmF+0I16U+ZCv7uTzJ1mYB/VPyOpeL9VE1lMv
Lyt9sDy3onMScsprsaj81zsGl+GQtxMwISH7fN2yMSJUpR4DH2mPFp3N8q0L
IvSweXPqNxxeWM21G/XC2KpcvoVftGUqEx/bZ37RDmlQEnjRFtnqg8QX93OI
gycLX5hNoEkxjsS+aDXKtNsVsaPSAXAq+C5Pyk6mrCgcSadAQRZqS5NdpUPD
99D3qCc1+lKtcJlFiiR90L/rv3v/3/zv2RlbFbLM68Go2WdEqP5RfRj3nE9G
Ywvj3gBZdy49HJy50B9Nan9zlpHPRekJv8H8oi3RpJ7Ap9uVDQyNoo/UmhnP
9MB9iKMpN2mLUrR1V7NxFuDxGn3AqXb55tMtfkOSyCW+5xtYvi0fLPgecJsg
Sx2rFX5GiVcYERpWqPjs0DRPeRocC6qSAYakZnqtvA4PDICrhbn0it/ogrAy
F47NRi29jpu0Vtqam7RLpvv46caZi2OYwpoyMpMIwFOnKvDmqk9YYE+SDnB7
uZ+1ksLoM80Cm50sBaIL+QXg8S8QnpiaGnFXfL/Pnp/f1m9dEKGl9fr11Tnw
+d9TiMqK9GQ3HMGL7X5zaTjsixR4Ah+z1Et+gcgqZTQphEbXqz3YK342jsw8
n1MkcZutuTr1zVS6ptIIz+eZj93fa6OT03An1CqVerN+cv6OTwxX/jUiZ0D+
XsoVUDljfko2U6NZ9r3AXNflNvGipsi3f6es8Un5FqRxvNIz3ehfA34+G7o7
7utLRVuJBkbjOjGyBzaXnvCiEMnn9SJxv+CxhNCuCFPGcSnX2xovqn4goLjB
jRPkaiLWcr0graH4YZG6242vk9otyE8Qgx/7KrF1YDP20Y/nxb7Z7y/SIM16
y+tjb0+D97lpJ1vzi6aOWijjPDNr8XHJ4Xmwn5rN4egxx1vgJiyfHPFp9f5l
dJzOLR2AzbWsHO9b4YZsk/vpP1PW62w0ipwRnO8nqFfx9MHI0OSueiGeAXUg
iKUD+8XCv1fWo2Q5mtiN5eF1sJNqxpUzwS+KJ49vo9n70CR1H78ux8epVW8X
LAQctWyz7ePr0KrUMSrYlJvvi9XuMU7jmaXuFM936+F+YtXLJwt8Rg9nUsfd
YTv6LR2I1stIYPgk9RJQZwS+LPXzPJtX6g00ONaD3SMh0UpbSDi6tUpdiuqy
7rl6D6PX1UuE5UzbFp+Fh6Og5lj4XCoWQ11o78tqmuRzTtqBzfg6u7HJNjkE
bZ1FplsbftG8dLV9/x252d2k3k54BgOToH7OK7W0i8AqKvjvF3lBhs1J1tvF
Czrxi0K9D2a9yYx4MMdh3GdvK6u9Lsfi6NWESQzXFYK+ICE2qzGFfVmTwS1+
RvSkw1W02lkcoVFEaLHeybbgjvpj1BzYyYhQecgRkyID/fgo4x9FhF7V3pQd
2FRc9Iey1B8YZaO89kEWuc7fhl/0LEd55v/9ihYl601mf05MpZhWJCvNUuyj
x9+Px1fzqywfqUm9nK2eSXus0lO9D2a9KbwoEZQBZJfb64j+JhvrpEyLRRTI
rTGVPjjKvsnGkY3sLpR9ARH6uB/klf45PAdcaHEJ8LZif4aEbSujHEyTlDlq
uMIHRBGho8NTpLG7nQsu6d98uIPvH5mbfX+p3DOmtlGq5NzP5bxbKT0Lv5cs
s2Ve+yKLb94TmATEFRz++xMlr0vWy+isdndqmjSW0aTH8fTtxdx5WY5Bk3q7
ZbqPl57qfaB6kwRHCQ7nWGmT9gZy8mhRmMJDw/fQoh8SxweK4GAZnP9znF/W
/eMsR4Qej+85BF3mKBplWnkfw+p/x8g328b347PZYvOS16tdQ/jHyy2SzeYK
RGhRPAJkb2ujOrZary1gB/aLZ79F2SwKG5Um8Q19wJ/j8+g4+cji85/RpAxF
3j0N3+dLu96nycfUqlfGv7W9smydKn3JXh43Q6vSBDfp2+74K77zyhBNqnqf
s5cnu94uSFSuVzowW/5qV2+ALMIZk2MBja2GoZ+Hh8nq1Q7b7t6ZS0HTnBGh
lWdDpbNsVmksR068exP3McKz8uHjGq5tyGKx1vZqPznVe9yfcODhz9PTdYjQ
onh0KCNCn15H0fbWxbIDp9MUL8WdSsMzOL5YwXhRd+Bil26H0+NgZJUyZ0V/
aFLe1zO68uO/X+9tUyH0Vwp95e6nyHpPzSWJkYcMcQ/zgmgwHRDOHGLHMf7d
iFAWaX68daOROk7ae/FSFovLvbOzs8FW1zyD83BfHpc4V4whPeG+ZPnZleJT
OchEtltu3v88WqVbRJPKQ4Z+04CCNeNSRmYyqvP4MjrMzNNYVQrH1r6UbmTA
Nyd5Pq0wstMBFf/+A2gPRoQCN2n2byZnHA6rfIyTSfWeuwddcOeYy6IH3jAQ
V6XNe/678KLtn63x+n5ivd8jfWB7+pSTDhhs53e5TjxtVzFr8EWOxxK1zorY
6Un8hdAu31iXPuyG/HmI5CdQnbgSnVZt7fgOsVPRJs+2+iq44aiWgrevrgA7
dslXG7OEXShPYeHojv+/6IAG4vivgrI+RTxtlwmB9vw8J/7PAnXS1VXESOk7
qkEfdoO3URzJb8SsVc7qnkviEj1ehAdk13UZ58vSNOP8YFBvEWech5uwnnjH
bA5zLKQpXw4FnHnBU9LHcE55aAvEK36yBLOwM+4tes7h9+3OhWtkNJaRs4D5
3EwHEwKk7m8FzqVcdngiw7mSg/TBv8HZ4lJpQMnmnLAQhoecoPXoBy+aIRaC
8QwXsJNnXa6UMqSE86XyiRVERJP0gzLdpdEv8HKwzQHuC2ipg1LYyeiLoIvv
Fc7XNqtDJjwDj/5rjqOLeGxObX+LdA6jc08zxbiKwtrO2J7++Df64hfNz6Zr
Wd2DML9o716QIUkqIaf50qKaM5kEnLRm5NsiXpT5MfTakg6UNRMUkj8YKE/D
kXF0m6lBkWelsYv28MrPnU9JsqaXuHB9jKEriQhVUVU91GlS4MPBxNh4gFYb
RKgXdyYVPOSYZ84eMqCFi3Jr/KK83nnd21ih0S75UhlLwzf12EfiqyKXUu+y
VkodtG/X8iCV+UXhHD/CL1oQvbOqA17Jw1+TlwgSSWkNa6ZPkgdrnbKdafeq
RJ1v/oVqi0pDP+cTTa2IcoQWsZQfp7TRu/E5bfT2ekRo5N5NMBrgaXjnsyUi
9FzqlrkC1VJRkmpzXYyrmTT8ffKeQoekAz5bvZHyuHW2eo9vtxf33rLVX+zV
bBaYiovCxOPpaya2rXtl3wy9L3evrVJ6pvTJUveA2OtLtndi71nkbco9W8Z8
D0fz5ffOPnH8Oswa4Ah1y5P/pT5ms4mfTiYRoevRItL/gUzj/d30NDxFD6A6
s+Qdrrw0NkcYvdwrv2iTn2mM4GSErWWSutadbozH0Zx0XdhHk2FVRpNaRXA9
rfRsbCvKz7JjEKgsrdIkqhNKpQNVd6VIOudHAdYFHl+O6gRU2M72wcISb5Vm
KWaSYkVQOgZEqPbho/HHr9+HZa0DQxj548P0NHyk9ONw5CYw5vO0VSyPSLWU
n20gPdkNzkTGpwy8vz6hSRcLIzSKm4KUd5ewZm3RpFMuzc9NtGrXzpf5VKUL
ArZRP8dEOuDJEMqzu5BJlunffaifEKEbBLOF7YNV+m2iz9JmTZtNj7X4qLPE
aPehLvpwcRLz3pAe3+8ZEco6fJl3BQ8wF0aE8qhVpC+86J7wolyqaQIrjkrd
PlfunDq5JuoZou/oUCpNZjQpoDojXJ3lek+uu7YqNfY2RnUyz6e7sWWXauVl
FlDr2aAD1d7Q6+QvnZdzJtv5lFjlrcibT3xWBITXF3rtQGvnZVU5G172iLhj
ZVKcK2IcOEoPwZ3Qs5xDuSj94UV7F43UDxPDGN6amDpgBOJ+psgzlJEPd9tr
aPCSyGLUIldV+VxIZ41z+NOlD/yGTwRslnZBdZZW7VrYh8EqsOJniBdVW2CX
IQMOERUGGET26QX3klcWqFQ1Qv9/Jl60LoWzlZ8v2nr8+lUyGvq/ld2BXJEk
Pny7dcC/z5Kz18qWAxwPeYPwbH/4jSRIsgWzVpBxkUG0FhpNplWyJkXyyjnw
i/KekY8PInvVwqlKikG05ekPn6RA/pFATJcZOrDfHV1bwm2L2oHyLUYkPkXk
YuWmQw5wBaAla+BVlFalt71j2zYmqrbzeGZa04EzECiJCga15DkYpA+70QUL
wfyiJe6s2iauS65VZsfqJd2tj13MKoCTkHrPCwNrmUaMuwIC8gzACNywlg6o
h52Sqx+12yovu/KsLDV2aY5tvlNHWXwb12P1ndX1TkZeTu+ZVOd9Vub0k/3c
uiYTsvf94/j7UaYjWshwl7gCnP29ZO5gZKckbQ/Sh91gLEQXftHS+X7t4JJX
0v68IM5bymCVCB2Q7Ibff/XnBfFpF/OfaOwsHbiQxsQCNTALAi9fdJvpWW5e
57P4sitlsBi3rpUc41F3Wf1RicN+XELfIWGu3w4cNesfHj6Go+K7cqeLWdeO
j8/7RXwX4zrTBgbEE2Ker7B1QYTyZYFceoqLAhMg84uyuavanHJodL8nMl5G
k7bjFw3S6E6NIRE06TlVfZZyG7qcxfOKMybgB+lAyKrs/haLkYLXkXmNtUpl
BjXudd5veSl50md5bhqmItrTQoTmXaq2hHGXTcgxpZWucPiu4WtpBOVgyCr6
E3ONu1PI4gGKz+IaLD/fIToMJ/uRSUTAMOP4/aOzs9GFr4lRTLn0ZDeS38ZL
cNPsz4VLVedSikEBmlQ1or2i7QZ7UAk0ad2/KtxV4R0f40UTpeibsecmHWhU
bwxjw7632uu50eKas/OlM8P3yBPHa5R359TwFiI0+HLyisOVZPAxSouv9h1y
M7xVd2TI0xpHqOfwDHu0hKexWO//mGdn7HXHgRaqVJ6qx4e0RoTys0XpyW4k
Mkcn0KSJS2SXMEVhaQ7SJTd06gJaey7lVG7o2tJfuKuS5EQ1y1LAQm4vYD4f
fD56OOu/uFjRS9zodYSbI5R76815ld2vwfKqquaXfAyXCGfk4pzezVDbI5om
q6KB81/Gnka22x9/m5x1WUNEaEXOV9jYz+QoH9+HKkpPdoOTK6lLOTd0U27S
GlMW780ZIdkFTcq27moUq7zNM0woSQAOpdzPvM+FPbJ0IL6/LsgpRpp5OFPt
RoDLIADTKkWj9NWi4dBSXuDx2zmkQXluqo1nVdTEBE9DhuX468/HviWqOYLU
zS6xPo5rcUyMY/gV6QO/Eb4B1hR9P7jfKgV+UQ3KxSLVLsaWSvnZmqjPAV15
QXVG34yoTqdIsM+tozoLHE2c213aC/WmM79jqaW9YfQh41tWwYEYl4n+Agnx
T+222L+RYRmbySyq4s5ZKItiMoFy5FvOzgYfP/mdmmmQpcPMthekP/zGl8r5
9OGnSZ2o9makjQ78daZDplvf7C+MJH45m13Bsxq79dxVgnH7WunDbniiA7NU
jhYYb14BIytvQSHZ9YUdir4HLK0MOOVz2dVc1nIpZRIE877ZfLyYmG29k/F+
5ms/425Iy7VDI/XpU6YP8VmRnL/XxND5jCdN33w9Dp/dnJMOGLSZEMqTDoD+
MD9wkD7sBvMT+qAZ0UnBJI1knC+gv1rzizJBWSrXaoJkDLqC77p+/PcrO8bH
j0+rOSrO58KQu2S/O+3Uojqgd4KSn4o0H2/8AovUSRbDsG+lBmpqneGgGd5i
UH+6ONLh4LyCWh8BQDeLIkLPckIFG0yACVQwo7LxuDNIT/5GT/yikUPtQr91
4RdldqwUvUZLkBsfs/L5Psda4eSIuTV47EIPR3UgYLesGvU9p6HRyngGPwTR
v3dPHP8J4i3GcTiJrvEBDXKZ4AHZtT2NHZ+eOFN8/IhuefhUmufCaYW1OLoR
n9M6kV8ufxe/aFyrz+gvxiTweTofTDDNBR/+NuIXjcnH/vD+n8l+3x/LOptf
wItqBYzQ4nkJGVFPo1MAW2ZeH6aTjcXRKvOoT+Urfg0lzwNbYqLTl8m7+PNn
/zKaDNdRTzhgVi9DHNCwZyPAenVa2WPhnSQiNI0WNpwN5o/lUzaeCLl8C79o
a3asE79oRc7orxT+irYbjBdNHisT4zFDWRAWePzzdFybLerC0M78omaO0RRe
FLyOzLualwzsBdRldkbz1lukF/q87afE8RUbon98edGflfvzvMr/nndpeFzG
p5h3Pn+12+HKYgzGk8HKmiwaWX3VpTfORH95KXgaJ5ixwYaRIJ5tgnEynA3G
KfH1z+/lF+Uv53ypowRedFVtV4HuJslNahXxdoPRpCn/qj2a9Dhf7R8jzO1B
+kMG8gbK477sb7a9juy0UL6eWMjyU87zNAxISOu+j57VPNVnFy2DJSEnjuoK
+WSrrIaDgSzG23AyGa0tqx5BhK5Wgegv/D/2NE6YT88XWi9NjHsCn0yRDcaa
fiO/aJPT21TmaAqNcu6PiBddCFM34iY1pD9u0i6l779+fxx6yTo9tW+hZhg/
0ejzOsteR+aH6eKh1UKRGiP94PMTo8i30RLz+7eDom23S3TII4hQrU0FkAb3
gD/FfXUWRlM7ltKO71+zr8iRDZ4CXUqzwvTvEy/a0u2/mptUA3BGfzGxwBpL
W/NtZik7mSwlrr+X0X5sMkFxX3VBD7rr7QYLaNAB6RjcAtaKCZvozJ/OXP5P
CDJoRk8m0QyenUTrsl7++Oj+aO43I8LyZ5GFtstiFPi4tOITIjRH6RtTm2MI
TOp+imupUY8RpHpyTCEIwBGVivRkN9Rp4OjqCwERqmdhLsRLz9xfbZ49y9Wo
zvKbW6M6meczk7OBuUETiFC8E81wbrifAk+1F3/71E0HOfaa6bEkZU1Fu4OQ
Ak+eTLiJ1toc+Q1PG9CanXebTzkTOYX3786HNHjV3MU926PWg4xTanKDPshf
jxcNom5sDr/568RYtr5LetcBWQzNdFkPVfT87AZXzd9u45ZEBkH/rj/BUARG
cf03XKnrmPY6nLe2sGAhrNFTEkojVfRXiq0D+8WzCqtOTxOd0TYENuyvVuIJ
L+zcmt6CD3EwOzd4hoGzxSrVjo8ZRKGxwAWU4XKvD75srmt5LZkBkhGh3XX5
S9eOnT+PkOVUD+hPkTY8/NEMCkXBUFi53VtISKzW4haDHdaoC2+b4udlZ2cD
8shIB+CsTUrLxOb0TV5QB2Q62tgNztjFgCXOtTqu40WD+AtucJmdM863Tl2a
pbEQ1FjOalc6/SmTMHNUnLOtwQV59S0TawSLFNWBn5Ha4NIKrUQ+G2NepC4F
ftpSv5XvFqkIFoiRzbEQP1UJzsbHByNCOYRiziMvTM4QpA+7sTy8DnZqcHwm
MndWg4MYozf+/BmvZpP3mVVvEs/Qjl9UDvTTZmRVesk4HxN5IxDnKXVF7WrD
cLWYfpiNhTMaPgGE/g/MGGqvy/NYq3daIawoiPbU3XmJt9l2ns2t9jYU9YkV
DgqI0NMEDx7Ox0deKZ+eTIvnVuWwBrPM+ZPcyPeEeoevs8gaen4/U+qlkizH
S1WvZtBok87I8Ol2Y5NtcidynUWmWxJ63Q5XsFm8cL3JJHEtbs2on/NKYQq3
S4ZbjW8XUiQk6+UTq8StGRv+ehrch3i96sPo6ISs0J6fM2I9tDIGr4y2ew36
OfOT1IPEIt8f4QgtP3hBhGq/4ydmsdLJ1oyelVzKGlqjBSI00VifG6ULf6w1
+g07OUgLu8FnuKNslNc+yOJZIVrzi8JR0ej4zPV2yVZvoUmbNLa9B1WxV8Ub
fA3qTbKPwjz1pZF/P9X7YNYbiECj9QZnfjR8rfgejie8RvKZ1y5leHlZ/367
DO6v3ePLyyrv0hwMNnhZBUBphbEqzhFakAsiNBydnAnKmnRy9bKVtpOFgxvG
KVl4Uar3rANJXGULatlke5Nz/yxt/I1ltsxrX2RxK90lW72FJl1+zJP1fjqa
tEljGU3aCBmYyxmm0qRe3o+w1+fohWOlp3q93ZAjHX02pH62JqnGbu59j+iU
CbkGNKHU20Vja7VXP6uDz3OJc4SWq7sgQsN91e1lZVFFeaXRxlZ5PsuXUFoj
Qqnex0d95yfz2TaptyZgBzZjryHPi32z3xc/4PH9ebgff2Tx6X81xXez0sXi
1+PxaXScWPWWuEnjpc14TYuVZouX7OV5O9rZqE5GZiZzUl+eLZza5/Xu7bg9
I28Zb2a5WE67Hh6m2Wwyo4jQcvEGIdbge1yVGCW0d5bNrMGtixoIahZm36nn
397qOV/Wr/vRfmJVekKE5lLL/84RM3YYXrbj53q95xhXF8wnX1ocvMXqjUlP
+A3ef6WIuGl3RkjU8Xg3mXNuCJgpzLfZhROV0bN8e7F0s7VAdX4upX52ETBE
AE7G2lOY2qtRiJrooAOOVgIPzT8lrUl/4s+y/ezQxqRwVS2IB/LRCawnUD1P
rhq3Bh9n8G1l86azZ6tm9zWJ+UxcOG1wkhKkJ7vhXERabmwkRpdSeYnjMeNF
QRkYt9k6e3vWmeez5GbXgIJ8VMEZxtthOW4U+9dOJpN0pvikFPjngyRzs0LP
xzMOn2+xMfuc7AYgQvVVEGrj0or8ELxoELUcIdk/QW4aK/hXSUjFmEz6nJRa
Mo5e5Mb4ZvuwG1qXaedr+wNZRl5K5t0/rreepD4I29KQkccqZY5o5scDZ1VP
8cJhVrpYfEyICLcndHMuP8FuhOW7O7j0DOVl/wFewPdPT7GI2GIhDYFn/UUV
U6WZ45d5eoN8Pb9or7lWs0n8vg8nl0wkpcX4QxcGUYDuMCta9vvPam5+MNxU
dfcNMe4EvCh5z//VdsO1Qgt3LQqa+f2gdTYdz+txxpOzDsCpKJ+mXRChsVts
SVQw2A1imUNkdS598G8wR2WXXKt81OIo4JZri/mWI9itCco4TsUEkky1Sqch
0qenodUcnxTJtCrc/zJ0lpIHyr4spjMhuUzffk4TcVetlzuTq3C6eR9NKgcf
QZIcoVaKtEM06+JZuLeb5v/1WK9a5a15tt9nbYnvsj7zp3Tkv4LSBOOx7LOa
XM7ElEtHftHrWNYLAulumRSRuRQ+/jyuJjb6HU9wOCOYN7DxD9YsiPKLusDv
aqdB1xypz1kZnJBuvjv/cJ4EdlezqO5s10aGOFTDaJU9v0Td0UYcobVnAo3P
eGxa2pDVDqnPkLM6rDix+/h8Isk8M3xnyql6g2R5PcVFk/lS4dkroNdlOQHv
jYvPjIdhZrzvylZP9kqPPT4juVkiVS5nEYW7b9KB6E3McGw0Gr7WfQ/9Xl2k
/h+8rKbTrfok/zb9PsoRGlb/EAVSL52SznuisIqVtpCoubhT8tHCCmg04git
iFZ/n8SZT/Z5/9I0D3IsZNcTFXaWmpu59GQ3eF+fRsnau2zOVu/yTczmRWqm
okS4SUulLY+23TUiZlpui6vn/W/29LwYmvcm2MYmE7yC1xH4Rflyoqq2VvCQ
h0Xvb3Lqp4pkK+RJRhXG84R5H8OGp2oCvg2ndYRGEPY0TO93MPDBIPKNr0MC
W89ut66ua55lj51Deb3yizb52Xq1B0xCF1a9JJp0t9pYae/4WUZX9gfSu5pP
NZf9/uPxCdgL2Zvlu7qZ7XUEHXj1t0KsZ4PvwTlku4u+AQZU83o22Xy8DCze
rUYcoXUJBEGpOz4zxwhhNr+pOsUom3qCWydLi9IbXpQQcYxy5Gf5dOPElfHr
V/RgjJ/lWdaoXkM4Osr7XM6T4vh/n8egvQytl32Gi1eZQaOU68Ctc24EGKdB
lZYE42nIIh7X8RiIPR2I3bbYLRGhXi6OYg0eHCS50cBSenaA4YWi9If7SuA0
2paG643wrFtB7CzGfDadyDCbyF3bnueTjTyzgGa/I8H2XPo44/g7zmGlAOXb
qZ8jZ2god6wGBH6gUkzeekb5xo5fOZex57Vrr4dNkBtBfhReNBd5kgXK+h8u
12cr7ih/gQ5o9PtQgLkZOvt8kQmIHb/eiPSB35A/AB7scvEGphgONTJEk5b8
EE8bWCzd74jJ2eNFzTU958eLSsKRwHTDsIPgS2HV7xmNvhKEfNN2IwBBW9CP
p+RjF89zlKXum7C7aEYq1ITRCPRHygMREo9hMyuNHpfn8l34DUaydeEXvSLj
fPnQ7Xh8h5uhyfS+lE8zxSBqnUrwKQxHtl38qqhRUpEzEW44QbC0Qp/K4GSr
qCi3azfkZz4/H7exwfKzSGoJWAs4hpBKvz/GrzBk4VDbGGU+VSE80tPTZmYy
h2QpZDUnc4SjQ4695NKH3WAsRI940WIEu5D8Mci3ZJxn4AefHMEZvU/hWs6l
WOB/4P73KPT4a5fLnfVgAFwBL/GXiSNPntdcVg3tYKAum042VQ2ROdWe5TXB
Ecp0zdvnsXV57XMQoRXxqas5hy/oJJ+UdZmeufRhN1xAuC0mgdFZfGxRYniu
5Q5glvXqCl6W1Oi3TBCZzDkOlj/iIxWiwWyRoDknor/Y6qkX6mvVw3UdUO8B
71Zz0XTQEAeSrvoCIc9NX64+qaI31erHx+PK0QyWBsIzKbvUCVpfWyBC89LR
KpocLcOsdlnqpIy83NFoP1u2ZtFn8HMSLdzE7ewpLprcULRDrDGGqjoNKyEO
5Bflrcpbyl7BIHJpl7P4CLSjcIKQxA9YXkfw2K2v0r9LB+ob5AvPZyHze/iN
lokoIjScmuX8oppiGnr1cz3/jl6uxrqE1BW75Jm7neFe7at3LuQeSAGkrv/9
t11uYcngW0Jq1PufR+vmbBdEqInb8bdfZ8g+B+D2rFvG+YbUPT3ZjdmMMbQJ
NClYvCvQpLVoYeJoG61ZF27SBJoUS/nZ6vWHgFgolBIwCZ2oQDMe7RCXB+Hs
e0Sf1TTfvDob0gQRqorCChhlHgsXUcfjTUSdNhu5AR8rZ6ZKZkH709+/88RM
++GkDSL01JCPzfPYOkORHvKzjRChddH3T6ZdbniBx87t5WwCRenJbiRtONj/
RGlzJOr55lEu/UHpmLm6Cz6W3ZXIXrUQ6AgUwdazGXodmfey9Hjd8uQ64C6D
9owIVRUR4+Ztooz1+/7oNon5N8iS/PlTyub2+88rIkLVQDrdG6+tHUrWDUK8
hK3E09PrzGRfz5r4qPAsbmH4zUXpyW7sHQyeNgUQt+nybGm7UTuN5c1IshTq
5VhER05I3vTJK6jqZwEvFG64w8sZ6gP56L9Ntls3l8+RnMusn0xKFsP/eZsR
nZe6DvhG3A7l6bnIcF6Uz0GE1uUcEaWNRuraWutnmd+mKH3gN4JwVLZL6RVc
nbW7sfwsG9v+MJ+8areBcw8GlsJ3l2+zG2c3w0RDhYyuud3oCIc730OBzwFh
BI4Zu/DB7RTko70Od1lEgvSH37ghiXEX/BOimdUuJ3ID+R4d8IcmCTrQYDf0
Mx8O7QS2PN+Ub/+GFqLqfv/+6kpbSR92QzssGDEOvHApYCFk3iNxj/PNoN3u
HfwBgANl3kQjGSPRmMPCoQ+GXuLVqpFm6UfPz59/QePr7YaaIB9DC3Eqd/sp
E/Rm4+yGQReJ9RTeX3bYpB6UhnJLHLNIof9RcmJruWVBaeV1gJLIYweVZlQ2
lwa5NX7RRKZse++mf48fTHjaEw4j801YlzoWsRDtso1zVBwIYfTCaLgyiPr2
omyaceWk6h3xFUG+zm44ar9ZJY1aFm2FfiAj+e7ywzoUpc8KXflJwFpYVZU6
3GO8i6VwiscnYnxCUYVhlCl6Eqr1WXmHy8JxvFz6sBtd+EW7kG/EGa7ONPWt
M847ipu+GERJMQjBiFiUUi/JaBRMR0i7HDVl6jofJ/x8zM+1ckKErtbOVyyD
foPNrOqAjIYPZTA6lxGhFxuuOrRDKegKJwLjMwhO1VoCBuxL91/8EXzLo1h5
16AeW+kkcAziaWYuPeFFEZjdnq2oDURWa+6ZMIER7D3xi7bGi6Z8JFLm0iWg
4HWckUul3Otl0SNqS5R3YrXcaUzDGV9dB9wdPZ9LImSUyP9eN1CaRPpyT+u3
rntxARG6HC4/Hp/cil829HphFRGaed9Ae4qPD16t+FZUiYBuMqlEUXoaweqJ
TLlezh6YWF5TDKKErbplvGgKf2UVJVj1joZF8tl4k/l2E0RDwIeMTkUX/yqR
y57hxHWv46yW6kYg+lNXqBvrvocmcVjQpQMaXxnw7Tl3jP5RC5zeWflvqEKa
oO/U77WAjh1abFfMOB8kIEJno9WHjEAt/VnmcTsRFu7lMkB02NO4Ak20r156
7TJA1zG5lTEDnFM4cZzaFhHKTk5RerIb/Vm8JCNrxC08b1WYmzRFlESlEMfo
+Cw7ulNkai0tst7FLx4sBpJPiJOMve8RxX25fIJvR03VJohQzVn9Ur+P1nX0
PsZUAzcau41JjRAg4N4jzrPG1EcR2dPgS16HCuazHGFgd4LRvOx1V1fAMkax
S0aATtnq+8SLNjm9ZQvfpbQNmvS8iPBWhZGobVivz8It4rWS1SACNS9LNSJU
zqF88HsWsKXRTHafG9/Yb3Yfw5GzGLETkJALJrLyjk8XVLn3kojQUtCjdmqf
wHxiZINLq/e+y0CjLk5OJw+2AV60V/xGF87MLs+aO0qp5fHI+03m6PDLR1+Y
T76m5Kgs7dFUhzBMrqonu12R2aYFWODT7Ibs+dj7GEizE/nC4TB/hB2e5ZIQ
oXr28njIpViojB2VJF0860PpZLCW1zhB2o8nKWMs5Vgcn2YWpT/cVycmT1SG
NqVnOg5GdXbDfFLpdfxdfYun6nbhxFbojk+wG+EEpAUxl/fvLarhThLjTGOj
ypBsji6W3BhpZvnqXEIPsfTz505MfjheNJdavOsubvKqT+SZX4mrbK8Dqkh7
AS3rMlktiA1DBvk+8POxNCVfJz5u/221txLQgc3Y7WKeF/uGv88FeOoyzwvB
z1pFUjrOBgLW0vn5f8zRYULU9YoQobyDgCWJc4t8nQcSJvI11qON3ZCVkJ/w
65erqJbQuZHoqVjmsopwv5k+wNPTx47gl/nJUVRgn6jvAf2RDrwtfJLrmGw2
e7itrErhgxmzncybA6VBTB2Q1fBhhM24ZDka4sxhNjEvoj8+oOzP1vAlUXBv
L0j11hadBUhC5mdgkKqP18X7YbejK64N8+ZUJXBWyFdvsJo3tRuy0qvVyVzo
zddsLqqI4hxD7gfLGg5GhJo8sZ6lvCdEKAfM5/O343AcDQhnHeZCl7zDnNso
F0sH9ovn07vLhqOR3divB7vJaxb/8v74r4ar+fRjZtU7GSyjWWyyE2tUKu2s
Iavj68vb2KqUw9eQFCkcPlqKoSkwe1vPs3m9Xo27dXQrhZkii5TzCuSuh2m+
Xkc9kG22dbw9RnudrdCDk4nzvdXb+kvMXOgb9CXR5dJz+5URoZ7ycfvx6k7T
D0swtnAqbVKR+HDom3Eoo8aq0vF2kVgHE0ALq9Af48aSHajeWTZ/WZpXMjlm
2xrDrHqH+8l0ZyYPzcWyA2d342q7sck2Of3BOotY6S78ooAXTdbrNiOPT9GU
01mTJN0xH8lNonOl0anE/JPOIrVCsHO9wdDF07J7bhOXz73WHPkwg8HKkXSp
o5YeTiAP5L//3EKvzcVsdpwvX98WD+EgLntY7eaHxcoF9LRey87I2dY/y1yM
xrvxbDlZO1LPml8Uxtdird95o1ea+96UbQuDa5ks9nJN2I8Ph0ZPu5KDm7Xg
gC2+f3PYTJb1uEqTevnOVCJlgNEVTerNpYW/cZe73OUucYPSNr6xzJa51Vpk
cYenDzRpk3onozXwG0Cuk8yIYxQrnX3EgycZ5tfIKpcjauJcnVpvFOsd7U1v
VivaZGzGSVzaZUfdae7rQ+6Dos9wqveh2snhXqcFkQpxHohrhZwv1Q2d3Jgz
hHJymMPgstNO20yXZGdvxS5UUV6pdiv1H3ThhnVwoMG6gi1vWG+XTPcAYUrW
WxSwA63PU/QBTx/PL7vRRxZXyORtgnZ3DUK9g/3YqlfPHp7ME8B2KFZV+pK9
jKW585b+KsdPMgNqHuqdZbPV6xuEScO+HuySfnAVR6jTrocH1Wt1cl3cTTe7
ihDJqZ4ujS9BbKcty7e8vZV6k4hZs/mezosRocPdRBplNTaFCN3DScp6vdtN
l5Xb+rmM9pOnd7NezjGUrBee5fYWpYkdaPF7Pt3owrfZ5VmVzl/mlbwquXAU
OktjPin67RmA7VSSReBiTVSpxRwepOUZSlu5Vmeuk5BBqYAHA5bd7HQcaQ7K
ZmN0rL8s/74/wIFXA8wnXjtKoToBi8K6xKhOznjIp5n8bFF6shtZNzbO/lCd
rtRjzqOlvPJ2wXz+DdxvTaVHuxGQXUbs+jPlTN2cSitPxSkGUcSLbvbW6V6W
0uH+5k5DMvPs38GLFuUrs4r/ROlLB0Lyl344UUuiKgyo1ddJivT4xqUPu5G8
gQjPcq4BAH7ImwXcvqOPy+1/uMFUEAhrZIgGdMEBG9H3+SzltyG92I1wEaAB
lJT7DVZqDdbJCY/dcNFSC28GDZGq83XmuP54jhFto+CDfagZSBIiFAe58Cxj
cgB+NkgfdoMzv7TOOP+ZKLiAazrLckk8EtETjcInEZKQ8ztb/eCI8mxV5P3+
F8in2I2SS/zqsdbnxUZjYbUx4GEADgdG/hQgDYj3svA4MuXmppiVuCbxuSDP
yq9cSTIZTpZqFXEMkPMTcV6YXFrYDTq99cLHJa+YEpdj1JzzNJlT5qJv5azT
THPE5x18CrOYv1leENMLQx86or86Xd75nRbiK/s8D6c4+jbtz9E6yKgiQpfL
4kRm5XEoU2OicXK6C2NbbCuU0Lp2OeW9xM2RvwCrfmifzHH3Dve8ujDYMMI5
65N/oz9+0Y6Mx6UTqPIlRGZZZ0gJYCQC7Yw1uTjVNZxHB5sTHV/VpafU/3Xr
oRcOBit9j9ZHeVCVVdviCK1PigefV1of8PKyqh/qBaD7fBaHkVcRodrjF6hy
eHxbIkK9nNaUWD6d5PldF3WN00t628Xe0Ro5plp7yFm3/Mu59BQXZcxAMlEd
XNgBx4A3MlX1KKtQiiA6yT5qw4lxLvDyyqXSOpmdaE+Gu8Nqb916uKTPG+eL
ytGVkrhzTK9FUuMoR2j4AE2fYCsGg/WDzytd173gY+jN1vqrN5SycA4GRSbe
LhyhvGScSmtE5flXtSbI4gtTcX7RM1F2av4SldO38PcWpSe70QU/z/dPOZf9
FaU1kiXmNWU0KVt4bhH3FaPg5BXI2zGBmsePwBxutUsryytCR4qfoeUvrAV1
HQgIxpnhY2R1RGhIJ1dAL7B1ZavOLsFlLhTS5hZLAdWZdZtl8Wf9cZ5bxdpy
k/KzXe5/9cov2uRnXTI4p5fvtgt0td6yInX5Zr8fIdVlTOPMvhibpRrlycnp
lqvm6Odmja/rADONhF3VJS4RjkELQYZkA1siQr2cXILaIVoQjmw0cmMMMR0k
v0FmVCfHABNfhc8yXvTb89FnmMmINxRJ2D+jOqHerOLg1UjAktyMgOLTYMFJ
hyw5jKYaxRyhn5Jn7bOk03mKfIxyCrksBXPSNAFPTzYB/KVLsFRrxKJ6sYX5
E7LUdoC5OuPITKlcg00Kozo5TtsFEXoL/KJp3GbbUl49r+P5LB/l/zuYzy7S
3m6sViFH0qd+TgMxnI2sX7xoTA/PVKKsw/3NHeYmbX5h4V/EixZFRqN2mn8X
lpY6oBX/uxCSPVEZt5BYSqm/UfrAbyRud+KZF0c2wCNVEae6MFeWp6fXGZ3C
gBHWqtE6p/zfK1fbjXB0YrDh1YV5wmE49GCk9LwbdbehMUcVVAqhrQRIb3u4
RAyOx4rbs17voDl6LQXqeYeFe3meg8wv2h9+g7EQvLODQ9gECg5P0l9f7Wyq
m83+8RlOQ+BUi+P8cGx0PL4zExTPne+VhjpzMvIhxWR5uVe3rI14TrhWb20Q
fFZc4gmMqJZ3NjhoxpgiPtKSXjEV5GU5q+U74Hja0GYQ7Q8RusXG5tKH3eDw
OEd022ScP0sb5F6Qp6f50ORU5PMdzvIGoX6pk7XGhWhedKMaQnkW3k/T7dOv
vURxX9kZrREdjjD33TiGHE9lfGZrRCgfWsVz+J6Bwb0iQpEfuKB15U2Kw4va
XgGTEXXBuiQTrDeJcvSEF219vsx3AUwAnpdXvCmwgnXh9fXw+EyI0LYQHV49
4WxXKidjFR19FWncpZD6b0Vj1QRZFRXp2Y1zWiqJoeOI0Mpphd4p70s9qXYN
Buv6QY90ABChZ4T5RyWnZJAuiNAGTPi1fvZWK8nK0vreU4oBuKCQ5zspuSQz
ztPs7i3/MtOG5HKDeNGesmknDnAfHxejlVWYytVLbqHGiGEhnOm+lMC0LPI6
or5HSPq8XGjiOxuyOKMWpaiACA03N8Mj+uBoNCDYBOmA9UkydCffLBYFTWBv
tEp+LgvcOejdOWUqzV84oSjhamqbFGCzzzoiru0NToaOt5sjCGPIpSe7kRqL
vtCkaVpy61kpxx9yOXgp5FJeWXjNCibLalTwPUax2yj5DzienIvarp9BLpgc
ERrVgbC3clMscO/UoqBdEKHJvPDxueDoQ3dNEKEwyxgONBiYaw1vUq57tiw9
8YtmqVwwRenJbvDuLJX9gW578U3ALoBkuRyzoRnzd6jFNEbILF2iYWGvw+9Z
YjcdCtL32Y1mbu5jRHXglA8lHF7UCLuSiFC/mzNr57hWvG/PzkYXRKjfaNiU
L4kgQ+HZ2qWGLrDnLihWji4mL8Pm0sc5bBA4GcmSV29Sz7bm+ST3T+r1+ALx
sXBHwyqVYjPmE57NUkCgmxJz9AONRox7B+IS2emE1BzQPeanCxGkSME5HsuI
UL4+xojQFG6zUFpj90o51e3DF3ya2Z1ftL9z2CCfieq8ppQPFBLHDV/DU/eX
S1wHplOLnfsbpADn64II7YIXLZUOBhUKYtb/LnOHJ34XrGlR/nW8aEXu8NEG
UtWBgNBoDOv6Crkp+y/LFcuT0v2t3/JskD7sBrOgcNyDY+YQ2dZeEhxOiB5o
TSnt6cqYZH0SvJYt/0+Vkg4EhMaVDOS8UvM9NdCB7ebgVlvD+PsU7eZQwu1y
VUpAKYdho5ut+5mZJ0WfxDfUiIIDEaF4DZ8Q3Xz8l0sfdoP3fXxADHEPjmoy
tINPcErcGpoIBbLrRFJpd8huQrA07lZbtoh5vnHJdeBtOK0jNIJoOKxoTxdE
KPOcnJQn5mzwKQND+xhKwdruOLqHJTLb8gfTcSoc5fABU2cQVPoGzdfjRbsQ
KCVyfzNRWHMuuDIvBweomV54Ot1GPylwbFpxfn2MdaFGCvO5BkdfYr1QAxFl
DJMOfLx/7B5f3kfxe2pfigg9y2mYbGeji17BWQ+v7M4r0CYlNpa8JCVyUnfD
i8IE5JBsLn3YDUaPpDBUifNlWBeYWZrvEZS6q0YoB3hRd4Zox+S96TC9Dn3t
fBY3LGqLFFLfXFmPpE6OrO9lrdfWyfq0qgZeyrBE5n+vaEK4rKcmyyyMhus6
tsRZjOFamhltl8N9/frjctbHpD9EaCMolMdsVIpSDKLvcMLOdz1SaLT9Zrqy
8gOyG9MF48ReGTPXjfCwMpf+8KLtCd7ReSvRkpeFnYokdqhUWj44Y67sUAp3
3yyvIzuz+Fp9Jcugr4r6Hvvde04OLD0JWqS3Bbbq2n/32fnmplZAvTOsv/V+
Dj6GDwUYHzyeOx04xJW2yzrYOi/wpdRwNvgOUQO8aMuLLSp1LpkRMWaWtm4M
vS2RbL3yizY5vWU25m64X2JyZivNz1a/uUyAyezT1fwsZWGvI+z3gZreWY/h
Gr5cqtsEriPrtLWzCx0PjtMSgofvR+1NBseXoTX67Gkw2C9p1ZkqcGRHNrJk
ItcUi2/Ta2s1cYhQI6mopxb4K/lFe8Vv8N6tC6ozlVc6kYuKo9AlZ0bD7Snd
cuElgJF47HVkgWYQ95V936zXt8Eu3inc78f3hYNGR3WAPQ29mbP4JRChTTCf
hrPBjgrbui5Ut8730yalTETZsN4uaNLUbfT22eqL0h9+I5kFibN1QylfCOLM
71Iw0EA31kWnorZbYUQoL/qAYr11kaddYBKO6gBHa+u3bivPgrrK2vAiOAkZ
amrYqiCySJy9nXUJoFC8SdHkPYymjr3cKOXrTsBV2+XZLnmCitKf3egP1cmo
lU9mrzS08V+RQNVVzlV0i9i/GsV0Ll20pSuaVFtdA9nSBRFtnUYFSWFN2yNR
i9LTecrPEXnY2q38qCY1FhlMtb1mNm/Rbnwrg2hcOxrARLvYtP5Ku52n7BfP
jqClMhhJnUkiJeA26xsmC1ARWMv53AzocZaBg+OuMV/r3DYbfP6TzYk2aPI0
YiGPJnZDKyZESyAILA2BPYs88AjfxdnZkA7QJTW8p8+n/5wqLv7B63U2HnN2
DL/TIf66dqiwDFElfDjIuJFcUAdkOq62G5Lhaj55n75mcesBcQ8OqjMvoiOl
2axm2SxaL2zcOFZ/woQYqb4ciOJjM8/m66w6TA7zbG8Vu7P5bbNttN4WUm27
XGtNQ5+BUW2vlKpe6YDq3W4PFlomZI23EaEUuLOwB6G9T4tJZKTGY30tI0L5
pCBgXaxKR5t5AjMWjXLoq9ZrjuNZc1/1zrL586KayjYXZiHj0z1A5KrewW4y
3aWvGn263XB6pV/5P9EpnIKrUWQGmB65Xj5n4bC51prtZu/2qjVAkYwGVCpF
tfwcyKOq6Sabz55MspOLolqs8F1Aa5SCbLOZC4E6dyHw8JTmy6lepwQPmk1W
jYAIZSttLXbU3nNulATQYkore3Qta9jJ5rr/69dHikk7ejDdpN5ExnnEq1jQ
2auUqoXdKEr9mVE2ymsfZIP6D5K05HC+DND6ZL3EL5oC4LmJsPXZCcvOd7LS
QM0XtQ8hM3s9p+rx4G5RDULS5+VOXlZxlgVE6PNxkNf79P5SN8X+/pf6ait/
Vb1dN18RRGi4oeaTml04Qstyau+D2d4sRayXuM1h8F1QP3tXMJlTvgUTfnJw
M2D/9nzIfNfDwjg1qZf5RdtlnE/WW537m3Hp/z8vzo1p428ss2Ve+yKLk4T3
kYm7Sb28RVK9gPBx8IPN1m35jUrl0EafPXi1tJwoyOGuf5Hiae7Lhug3Ye7v
9w4ROt5P83pH+2kRESoDKFuhtiwXjiKsKSL07GZkRY7Qmpza+2B2MnOEtkaT
moOrgfE8Wl0YvC0HuIlGmfyi6s/FIkHsU8yZe2W9DHJIcRvGS5vUm0sf8Q1V
+vj+NNiPP7J405hvM2Gl7bS5yXqZ9i2R+X3v2QtfXysxUlX6kr1MPqbTuTmU
juhvtoW7MwFtDn0ig1BxwkO9s2xWbKw8BM1NuFAcQYSGaIaHGVw4Qg3Zvh0G
24l0oFJv/pEQcGuSjBV2Z0/rUb29Lujkz4j7QISqInXyr/2jKn3P4suciSb1
yaPbcZOq3jnWy2jS1vyiqnf6Pvt9oPbmAnbg5IZc3I/E74vCuSGSmaP52YT6
Iccg58JwKCB7F3xaLs+6WhF/cX4LqwDzh2SfESxNSsnH8EEfF7c5XzbR6gnI
gdxbiOpAEgrOfduSBfTPH7XiDS+G8y3a9LXTBHI+9qzPy8Zv5pAaf3Of7KOE
Ji1Kf7gvRmUzqlOdxkkbYXPnWUDNntFYW5nCsgZ54U/1ei+0XvoFE//TRN+v
NfE1Ef4qSt46Cy8KiNCw54KXJxChUb4Ofbznw6nHiIoyT6E6mecT0JXuMlR0
IfArC8d5zGdPpfxs+0hdohTRpEXpz270h0u5CfGnbN/9Ea0koLlk+tr28q3g
vpqRAXbBOLV81oPQumBNuZRvKnVCojamdrnzi7YXDxv47o+4RuQ/S6UHA+sW
fEO5CR0o07I1kf4g5dU3//6dbwj7q7QbBr69XQry6XaD2QvlMXKKXnApGQ1I
OX3274AJ4VuoiTV5MqlnJbtF8fxizs24EowdbX7QAa1NMByw3dM7OWsbBDqk
A6eTuBiwnE/EWC05ax7DmEsffM5IG6SnzLOZo3kw1yx3OGjHADl8/Rl40fjv
k7fvW2ec74KCY24NOLdiJCHcppTBcQqjzWyMY/NWEsr726QufhgLyGS+30wo
nRF/0+j3gQgNApPlwjshx6mcxihLkWpyPJBvmF6HOVFvF+7ADpi+wz5w6ZJx
PskgynlpORLVH/8GjxFHzjnqDvaZz1mYNCbwYlmvPWUii8ly8eYG6G1Xv/81
n28tTolA0/eJQVR/Slsba5/m7eP379encZTLKIoIzQWC9tKB1ohQxvU11ZwY
7L/jym4VZQl+4JrWFaIu/TGIckd1ofDlbsylp/uwyC/a/h4B569M8YtSBBsi
yeEeCngd7uRIXT0YuIhHYcKEs/L6/QVN2JzbM6x0RRticYRWNEEv92BUxzWq
WkqlYVcii/E4XC/j1/1On23sc/n8UTrw6YjQIMl0yae/ydkoG6YkXrT1/E3d
9SjP7vIdWMAaZSkPuUvGeT7KZH5R3hzl0lNctB1SLgi3OllKdEC2a83Pstfh
k8JsnQ6s13XHI2Srj/oemt9hWck5P7MziQ1whKpvtbedegRp9c7Fbuds169f
r8/j1aJ6JS0XVdSeTmpzAB3oQkXViEE0y6L4mQQsodV9jSal1etU5avTXTLO
c2m3XNjMQNjoaL4nu8E7rCQLNOgP34rl1YG3wGHPDrtRZo7SntF92PHdOR61
S3DBP4c+kfFpQrUUbr1FPk4m6/lZf5ZP4zoLerEWtRH2iU2yxls6kITkdUJ1
5jzbMcZyZuHmWcablOueLR+xccb51pnuOfSRylaPQdHvzkefdeAHyFKQY96r
8s1HZlFjlzV4HVD1hR84gLelRWWAwefjUlSRdzDcf/1s4io4q50MF2eND4EL
Swc4NsWbbnYYLujKbfWKUJYaNRPV2fnZ4EmW/qnAQszPMiK0C68pu20JNClu
rIrSn93Q9g0W0BViPtU62EFrrKF1SRZQLuWg0HUTXz6ArIfcgGtgmY1E5mIy
cdt8OTafBz9Lwo3CvjiqA9V0mTWBaZKFlAF27RdEaOz4lbMlMrqYS68j3j8c
wo3+/M2gw6sOiND+uElvgV/0LieRGzAanVwC6Xw7n0NPvfmrMZo4//3nzIX8
YeIf71G+TQfU3trxa0f5TDRpmcW6FyTqt5YWpQ/8xl+AEv96CSEIzXoZEK1K
siTzufsXWYMielNTQ/8ib1z/Val+IxOhyaKn9Jfp9BtZNHP5NrvhoBF0v7s/
8DY8q6KTwsd8IX5tlAcjlwSqE0uZfxjCdGoL19sTfoPzWa/Xe0QD0gUlOPev
XzMvCiNCv+EymrbA2rnIJoTrqI+PZ9qDh9PWI/yRf6LfyID06VfAu9WrUfUL
OiAvHWLItD3fHPh0w9x0/PkznxBZwdA+C0jyQWHOEaLvuBy4xPLAJjLPjijz
LCBC+UY5nzvvd+/A8ctnFrn0sU8BTsUUgyidhjAvB5xbcQwZjoyZJ/mmEsrD
ujZ3t+OvxmkEVJiVH5bPy5jsEU5VPIWCMR02m4/BEMaRFd6DYcyhTLK9Qfzk
hDkpw8tzASATH6k4pSXsNJ0qmixkXjjzIGc8zKUXvChGZbvg+sA+cypzViq4
tq+2xC9xe1UcDSPp2rNzkJDzXFwl7vq/seSFHLLRFTz0iTUjeJF1RAfG90sH
rD7JUla6PZZ4MHgdL1qDnXhlbw14uByJyjOspVhilDIf5SQYRG2Ec9aNwpcx
J7n0hBdtnb+SEaF8vpwA32KMGqyZulEfHC3NkZ/1CHYx6bOGuKjSFiJU/y0u
xPudowQML5GPXV8FQt7YlYHWkFkgGmfEaXBfBX/DKu2CCDVL/YWU1knDgeQq
a4D3bnTXI5ZiqVvGeZ7dGwLlpkwoUqyvvhEv6glP2Ka1bDU/O02SBdnPgtcR
Ug1aRklK6zCfo/jKHk6N1SgtWzNHCOZ+z4hQtfHleaX/6t+jxh/y1AfphAhN
pT0FHWDgQVNEaF2m08Nk3mX9xflLF6YaEPt4nYmlWPrrMs5zjKgoPdmNLph/
3rvxvo+dZNizB+E9lGYrJEd21mP+BrVnqSh3EL0fmNDCuPeNCIXa5cOADnRB
hJr3JvTMnz+T4Yo3sFTKaNJUKc5QvzobwY3WiFDOON8Tv2iWAlQXpT/8hvb+
sKPkOAaX8hKQzAvPU9tFEe3ZzRmQb0HWqz0jWhkR6gMX5suD82zpAPd8U0Ro
7MmPwRCwlwecC3ySws+ytlwQobH7uRE0afTZmCTQpLh16o99tCh94DfybwBE
HJP0qleZ+IVbBy5r1mzR/6mSpGeEs3uVhv24NfpwGTnDRJz+2Z3pZb28bKYr
8ANlrAAh6Y/+yZqxrQNdujwbYyxMP4uxuNbso6lnE2hSBi1kffJv3OVny5fq
wOHg8C3fJI1YcI380d+V97m/Z4tytxt3uVZ61YGqYpfps/qj5IU365OodPWa
DeJpx5OVsusLrGhZyHgOz2KIDOrl0lw+3W74dMNEyMa8HBB1hL2Jp88yP+mm
AFpfL6Dz6hm+ERbtVelAiIRYD+qdkLXNpWjHHIWlD/YZUvL/x8R6CZJJ+6Cn
C0Pd2/PwfWai3zlS14Eog3IMcVgmcdkWM+7l0hNelEBB9uDyWTmcWQeAExxK
Wnu6PcYJbycSwqvAha23Ju0QoRmOhXQgmf7bipNch+0pZ8fjkyAm1+JboowI
HeNhzfHXnzofSBBGhCZZyOBoowuyOskiCEYylz7sBn9Ya7yoOwS0sT27HQWo
IeATGPOilXpg1Wu0GwMGowkTYxNR03YO5RUfa/27Q4QaHKF9IELPByvxgQh4
Ueu1vJxxRrBlRWnLN8X4rgfP7p5W9o/ju7uebAjjRbscfHRhMGNsFZOK59IX
v2jb82V2sXjFSXJWWysOYB7UluXyLTptNZ0DZd/kRNl3GQu1ceqYRbeBXzT/
e5Flwt+MP66WO/WGg4TNthX0oL9B6xChFRxpLvrgnhChfF9DOsBpwVvDmUrz
t3xr3oMWgEH0HdYUZv/uctfjbbo8PkWQG0GsjPNBuJOZ9Z3xolbG+SCMV2ED
m0tPcdEuFo99YHZXeCySTJLWQhmiK9L5qG05nCiCT4njNZHDtuL851j8e3ZO
36wf62v1YHTiBx8DWNZlE1pnfk8iQsFhUOeDDnTh6K7eISrf+EgnNrUPPXl1
5mNN1pndy+g4rV5LyaULv2iSorkd8yFzhvfKL9rk9DaJ6oQQFt81CDlloNN4
OHifqykDLN/B94B2ZY1jsPyzoe1jZGeXDJS5OyKUdRJGn1c6ZtKuPvvnT5GZ
hJ9N4EU7oEn5vsbhvz+Qa5IvwifQ4InZ3fL+V3d+0b7xG7wbZbeBIyS8bIVw
H4w1n+kkMyB/u2hdRkToe3dEqFUabjpbOsAoR0ZIVvW5jNxmbeeTFA4/8rOJ
euU9/hdBbjR5tr9s9alLQBQyvQV+UR/oMyegxotRnfz9PLVvJVfaTQp3DsfS
w6BYOqDS49E0SVIGuHej0lL+mnLabkYXMzJZqwwgMzmHo0rh2f18BcENfnNT
JGpMVMSsp4QmxVKtOHd+0bv0JF+hA7XMSrcosWspDaU/NGl/pUX5dLtx+6N9
l47S8EzNklSq9HcH2xiNoqXgsWQpLnrYNeuTIOJ0OHzEv9lfS9FrobH8Sby4
81UReDYc1UEpnNTIHe12DrsZ++jH82Lf7PcnYUfoQmhfkwQp5ZY29bcD0PoW
geartykLwMJMKg0J3KUDfK+WdYCz9bnD1sGgkvMuCAfMuxzlNGUQLcr5WkqC
QRRvhXfhGeuUubItdDYXyw7sFwsf05H1KFmOpN3Q4L4s5rNs9ppF2sUtAqwa
I5ECa9Y229br1QoFD+p7OjpIqnSezddZ1yQmvArUMVp5vXB64jptbCJC242F
6pUOvKymcOpElLkptrelBjCW7ED1jg7T8dY89Gyd/zezMSehk9XYSB+eUzom
0ibahg5OFVXv5H06fDUby7yXDJ2FQwfV+/I2mh/MY6BcknZgM77Obji9OtNz
R01HAi9q80AG2IP14OxtbdV7sIn+pKhaEaLU3Br0kJQH1otkY3MJrqPF0AWI
UK9d1Y8v1jvatMEPBHfiWo7QU70P1N4udz0cLm46d3fZovViP/PK3iLjfKJS
H9zocmhiHXw0aWwCKz5/e7s+43xzZc7SdmBTMYkPZak/MMpGee2DrJqSL0uS
tCPLCrhYXC8T/Z1p96qJmINVHw3XKg2IsnyiuVzSk83j/iWv9M/huZJ9Xm8L
t/z0uPRWX16ZMmlE6GucFTnZyVkKEdruvsap3geqdzhsSXB3Wp2fnyPpX1Pt
ZbxQu7seiUp9cOPCLxqTdhnnmwzuFNHg7TLOJ+utzv1TJOMsBf/ivFspPWt9
T5BltsxrX2Txe4JsLXlJsp5tUi8T/alS6a3eX1d7/cspcfzIJY4PPq3LFPO+
yCudvs9zRGi4NqIBkm5YcIskIlSWyjpqTzY2hflsmTL1VO+DWW+XIIPLq6JN
SoxtI9neLvyiFiI0UakPbnS562EBFJtoMrMXcvIFy/VqUm8uYAf2i2dvQjaL
wkalSSxdlT5nz4+b4UdmZlHR6gCr0hhBtpajpXpfspfhYbJaE1pSsxVG09kW
RIRWPixUOstmlcYyTMJbDESEjjewH9++HQbbSbTezMcQGBHaJW330+tIOhCt
N0utdAzldSZ9OqtnEwjyrA2z0d5kve3ua6giDe7v/eM0m71n5c8+w9IYTdqO
X1T1zrPFr/3jrF6vF85H3/r+l+qdvs9+H8x6i2LZgaIPUpxGzc9t2W3gXTBz
M3KMNAvEcXiGdeOI0OKGqC4yepxRywcuzFK+cNGABfTN0gHe7Ccpo91cKORz
j5Tys19Zulw6ivUE+2h7ftEuByJd7n72yi/a8Jd+884soDR5YbXNviU5498j
3DmMGZDmwAK68bfwLB3Qs4Cv0CIC9kpf9bbwwY2Y6EEw9SHTBLz580uHQ7VW
pXxNrzUSdZNCk0JvcGkI9VulKywtyh0vepdrpS8d6AC//GqJpYL9p+SOF/2X
pR3qOOhAa0SoGVz6/VtPsjsEXiiDJPVJcPp/OBBeVB9cCvjsdu4w5fJJBAHi
+z6JUtxNw7PhIM8qVVugo1TahI3q0+3Gws56lvkDPqtI+0H2Y6HSH2+sdjtT
q/kC73LxBgBdhl9am2jpQBdKtzizhI80Mv8DxwQ+HxF6lmpzfHAj/39dGETh
or3jGUPM2KfjRoJ0xIvC7/n2PXNrMJIN4u0Q7Ql9aD2oFepGgiH6DFgjgMEp
gQh1TEHxtrP+cH5SOKHQ6AOMirOJmVAKfwG2QU75lsSYRVxNXVIpU8uHnoW7
ukyUwXOBU6cxCxnjRjjjPHcUEylkffJv8EkKzHEmjYEFJUBJozBjjY6WMD1Y
tx6BNcti3LpW9BK1Wt1eP8vwhD82XdjBcdxZHgUvo4AfaIcIDcIR++BvWKUt
k6H7C7CJux7NOQavKeWVPQJTLBz6dGEQ5XW/S07bNANh25zUufRhNxI3FBAv
2oVfVJ1paXvAdC1qKcMcY79n+Bx6hk8pfN5p+mWUI1R/zzXf24q9hkmPa+7X
6QsCWH00XFsr+wahaAmOUKdaLRm8293XCCIdAJ6NJMFd5F+3W01sdlSSMOMu
fnuCH7g4u8usp7yypzLOt+cX7ZJxnjkGYetUlJ7OU9pnHk+NY5IbExZZPTsa
mb5HsCGB+TOs/sARGjJ3h6Twb9tDfSByH8NafBkRmmwpz4XWiNAmpaADLfGi
DTYpXfhFk8z/xDpbuetxvs4WhL36JM6N5v4Q2Rpx7ndiILRdr6L0dw7L8SLe
bzJVLK/CYWGC0dQqPBkTkWDDKCv/TFoBuppGhDZoI3wYI0KBQzVLoSs1cKAD
zLNt4q7DJiWFym7N8ZvgJr0qW/1sJkOT/7/WGeezFPvo9/CL3kA+et4j+xsc
9IVaLkETNK0YoAJm5xZEAwS6KrPwvYhQqzRonaUDvFoFDy1ScN6kUJoSnEe8
LzbrbfDNkdKXF3f00+DZdC77TuyjLbPVJ/hFbwAvmqXg3Ey28+OPVrsIdw53
7Da2qyqWgpeo0r29T5E+g73a+2wRkQK/SYG0U5mfg6DPjBf95NIC4ovJi5jX
VKUJNKkdFPWltGWDuJZK+dLoHS96l57kk3Xgr6ASDbLfFxFf/7J8On7jLjcl
PCPTVJ8x0ejrQXiWWdRKK1qNSjQFsDRX4SRIEgIv8oVgUyw/6tTYxaKI+Mo/
GLqCXW6+osWl8GZGCqXwognIbk/4DThVND1VL8BQlP2Ui2xMYAuENsygxeBM
qLEdqvDB5ZUm3gk4ivV5pV+LP3Wm4ywNUCUtD1ySPGONIA3lfLVBmAqDjzWZ
QRTGbr97n7U9L/suvCj/gPNpzmbmuRU0NvB1WCP79na4EV5iZ+dtw1gEflSE
T088R6iJCIUAeGtEaOZPGeB+CkQpOeJXTXP/q5S3KPDEWs8y0BFUK/N92CWp
4ulvtWv+KSqMBAtZIvjZNuM8o7I74kWD9BHfSFpva4ycFTX6Sjo8nW6j4SBH
2TfdWFyagR4Q7nc0F6mBOlwvrEcOvwURmmWECGU61i4cDtKB9nc9HAPhuR/8
SUqxlM/uRzb3bNZbxvnLkbcshuxGWbrwm3VBpCRy2iK/aJcT7Vx6wosCXDzo
s1XKA6HOtJ4NK28dA6BO8EmfNyHpczFxvLNFBiI0j0hrRdbjsvyDwWo83mgF
312JCGVyQp6hvHD0weAdhFfnEN+wSoc2YKl6YFpOytaa/TvrM+P8ZWUvI76C
pBgviV80mT+9NaKsHb9okO/FiyZzmsM4gteReTdY3WIZzHBfwPsekT5XV2sm
6uWDl1VYE/UvhAgdrFWXdCM6gk0QoUCGnHVDhPLNiC77X34z40XTbkyxvf7i
/KVU++7bw4te0OAxepBkxnlkDzZTVGS9XcbpcgekKP2dwzL8nldSVuxwCRQ0
Ye8f7zuUqsnFiFAr+UKQJCKUs2OzXnXh2+SVTqWgA/xsCU1azhxdLa0/2wFN
yu1tiiYtIL5yYX7RVFC0ZbZ6DqqkQy64e03mow/Sn91I5oXXwhT1CoJoxeQj
uYYAle8STv/3CYhQu3M4YM6nErziBFSnpQNM6FE9SSkv34zqrD5bK+2EJm34
7H//VUq73NA84EW81tlAstT4fsphStYzfgNuTd6FhXEXsHpmKQaq3dsR3GOt
+LDoq0jm2uYlJgYhv0ks6GT5bEKfBBqr9i6XgH6n0o7PnuZgDPHVBYmqMYKT
ox2ynmruQ1yLSzVAsOIUo39RKeZLgZ9FH7zq93f5efIJOnA4RPOk3K6UOb7u
crcbf7twGIc9E1hc9Frr2QefVxrqhRUtC0DH+dzKkwInvHKiYCWVx8K3Y6Cx
Wv0hPLJ53X8MR8Wjn6KoOdAV7PbDloGfDZn+rFLGEWkXABGAvRzOL8dvaOyY
UAKe/fGI0AtcuSb6dwh3OIoPAGfa5568AeetLmAAXEodBlrYnwTJHLNUzpH+
GESZZ2ysD/ZZHaOliaMNvizf9miD+VX4ZCrJM9Yku9Cn+xtwZq29pBXtCYhQ
ywy+vR2aYNi+QBzk2+jzcMpzU4hQPt2Ac3xWaelAaw4Hl91jsakDqIJwTls+
obNy2gZJIkKhK0aDVQXXmgtjTrqxkO0h8ML8oslz59aw21z62KfAoXbAdloP
qkXRBeX93TXHmpWONcsT9HX3WPTZWrOiq4++IeSHja7CjCrpCRHahf+hy10P
6QDsRJIr+8csknE+yDjFD2wVdSlNruyr0bJyZFwobX8TpMu6n+IXxdPwyebA
Z9YN6HZ7wosCmBy8jsxPMU/QHXlWE0Fj5EARb5U7Au+BEPhM3PdWpJjQuvny
snp+Xum/L/6/4e/5oDhbsdrJ1unfpdX6e2X6hzPT0XBtTYcuiNDUbaz2iNAu
9zV4/qbwoujGaP7GgBBZ57seLTLOB2F+Qq0j+9HUMnRdVvbE7E4xp7XmF+2C
Ocmlp7ioGgXjyF5HgDxZXapS8D0CUbDmqbSX4R9BZGqcrZBuxCxw7mNYFuMb
EaHsTvAamuT4ZSQq8osmUpws59sir29RvotflO96yCv7eBnUr8EG6cIN/m38
om3Zz4rSH36jevOxLOx1ZN4a47H7u17eNz6EN9RJRKibCN+ECGU2bHZFeB1U
KYz+AntMzx7mqwrhRvGrmMEbQpeMJu2UrV5zsIyHL8q38IsmAqo984t+AX6D
acc40ViGp4S3IPp+RoTyKZsGCJxJRoSyG8O60WXFCc+CDiRXycpdtlKpPRcy
K4FCs2e73OaYDNeWg9QlvtQl4VriAn4HflEOuRTljt+4TUmmWIXpWc1nWhZp
LBhkrVawv9NXydQDzpwhB67016/o2u2vFZva3mspe8Wb8aJ+DTZIColKnKhc
Kn8PltQdljrKbriD8LqHmNirK220WN/txl2ulfY6sNs55MbfJTZE7V8WUwf2
i2e/i3le7Bv9/i7dhLc88CBznbXOPK4iq17pgNxd+GAzRDmbaQ7CGp0hSDJ4
O1apVnDOSw5dIRfL7Mbh8G26JETocgddscRS2GwGlgarVN8DIDcNHJSqpeBS
NsRK2XYjwOM247LhYLvhMbdm6aekYf12IXz11qSoZX9YkwWG8usRoRlG+6UD
aURoVJ6ejpstEezg3rw/BlECLfz6NR6siWcMDy4x4/zHuLeM83yy3PrsKZeE
/7BfLMrfzr8POVU32WaWzV6zUp8EUIf1wbJyTb6WZZtt6/VeK4G/KzopQhMq
i5oqlSO7ztYJRKg9DRlVuDbyC4d6h68zxoxZJwVJkLM191WvdOBlZV7yMpXW
Z1ZNUl9ae3PV+/I2nh+qzDm5MIPZcNiGBmf78Tpf/npemI3tKeO8Gjs6TMbb
RbQ065qX1jwvU73P29HimIZwgB047VTK3ZLcp2ykV/qV/1OfwiuPsIo+CNxZ
Uif1sBSSMrhhvbmE280azfrq0wIRWqx0tDF3wYwItXBumb12N2lsF0Soteic
6n2geh1aOMqkunaHKcmLLdGVvUl7W2ect1b2xp3c8p6IlXG+Sb0dM85HN2UN
Z1AQpwKbcfFafTmiobKS4XgoS/2Fo2yU1z7IBvUfqEUaxKgFsLg6tThqgGRF
J+PNYLAKiePzlXTkEaG/tk95vb/eHvUvOb9Bbiv0j3pWg1WpPYkItXhNk43N
GsxQ2Ipa6tGk3oRnzinLjdX5VO8D1WsemM5mH9s3cHJgg5Nsbxd+UeuuR5NO
5pU9eRMkildpUi9jTlJ40fgQJOtNzv2C7BfjK+IbkmW2zGufZ3FHi4n+kryd
b57VRF1XnHHFeheFevUzaZReFcXkJxGhbudl8KhDpbkwz2drzGey3k6IULv0
VO+DWe91/KJlgWhMsr198IsmK8364RdtUm8f/KJN6s3FsgNnH6RynNLoPEWV
vmQv02w2mdKmUqMJq0C4edqEkr1S7yybfWRNA7DhMotVGu5EECJ0exhsJ1al
SUQoO+2MQ37Zjp8/nq3Gsh+bQoTSs4O3iXSgj3oZxcrt7cLtb63Oqkga9Xv/
KE1+zyy8KN314NlthUxVrxbcX/vHmVFv6iJPS7yo6p2+z34fzHqL0it+Q6t5
l9TS3y76ftAKPinLfK4QMAt8hsILdxIRel2O9bJAIoPMhyBAB/jeBDPwd3zW
LEM0aRdEN/ekd/l64RdNJ21pm63+RvLR3wWEGUS1ahCi4/ABFomBGZxHlTm1
Mm/uAC8KnJmN0KQ9lGbeC7KKGE2aYD3tUMo5T7uUanABEepLiWMfni3K3W7c
5Vq568Bd7nbjLtfKXQfu0pPduKvWD5b74P5g6WmCN7x9/0+p1j/V2Owfa+8/
1disQXt75d/o0tt/3bN/3Qffn73xSm//2bvd6P7sX/fB92dvvNLbf7b1PuUu
d7nLvyytzNJd7nKXu9zlLne5y13ucpe73OUud7nLXe5yl7vcJSb7xbN9JfBn
yYl4oMo78LMkNPJnt/Es/8SAVuUmJqzv+e//jK+QMw+rmvxzFe3M/Vblqv6J
8k8MaFVuYsJuxuPNTZivL5UfPKcug/mDG1mTf6etNzFhN56z5Ns/46tlA1Qt
f7tcqGb/nbn0owe0JF8/YSO0xuekTT9yh2jTONeyRvwo+Qf9jZ89oAW5sQn7
L/kbaqvv8M3i27u9J/mX4hvZvzCgdbmRCXsjn9G/FH2QH9zif+c85R8Z0Kr8
MxP2Lne5y13ucpe73OUud7nLj5T/D+dKUEM=
    "], {{0, 277}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 277},
  PlotRange->{{0, 360}, {0, 277}}]], "Output",
 ImageSize->{364, 277},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->633915179]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "StreamScale",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->350769615],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1913058779],

Cell["\<\
StreamScale is an option to break the solution paths into arrows indicating \
the strength of the motion at the given points. The default is Full giving a \
single arrow for the curve.\
\>", "ExampleText",
 CellID->653735769],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DirectionFieldPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "2"}], "+", "x", "-", "y"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"StreamScale", "\[Rule]", " ", "Automatic"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->810731531],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS+UKj3T7c9d1xw58rEjRx45FjkSifww31qIK5BYJBKJRSKRWCQSiUUi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    "], {{0, 360}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 360},
  PlotRange->{{0, 360}, {0, 360}}]], "Output",
 ImageSize->{364, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->76350736]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "StreamPoints",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1903883900],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1921002737],

Cell["\<\
StreamPoints can be used to control the number of solution curves displayed. \
The default value is 5.\
\>", "ExampleText",
 CellID->1023851761],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DirectionFieldPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "2"}], "+", "x", "-", "y"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->90083716],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztvSF0Kr0X9vvedc2RR/7tkUceWYusRCI/zLdWxRXIWiQSiUUikVgkEolF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    "], {{0, 360}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 360},
  PlotRange->{{0, 360}, {0, 360}}]], "Output",
 ImageSize->{364, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->280567385]
}, Open  ]],

Cell["\<\
A specific number of curves can be specified and the program will try to find \
that many solutions.\
\>", "ExampleText",
 CellID->1611379720],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DirectionFieldPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", "2"}], "+", "x", "-", "y"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", 
     RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
   RowBox[{"StreamPoints", "\[Rule]", " ", "11"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->542681723],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS90Ik3T9u/vfGZl5NqVK1fGRkZGRr6Y9xzEJ5CxSCQSi0QisUgkEotE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    "], {{0, 360}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 360},
  PlotRange->{{0, 360}, {0, 360}}]], "Output",
 ImageSize->{364, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->471143167]
}, Open  ]],

Cell["\<\
Specific solutions can be displayed by giving initial values.\
\>", "ExampleText",
 CellID->1093375036],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"DirectionFieldPlot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], "+", "x", "-", "y"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y", ",", 
      RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
    RowBox[{"StreamPoints", "\[Rule]", " ", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "0"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", 
         RowBox[{"-", "2"}]}], "}"}]}], "}"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->336662673],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS9wIz3T7Z9blyxcGLpw4cLQwEDDwM/kqzK4wDDU0NDQ1NBwoKmh4UBT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    "], {{0, 360}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 360},
  PlotRange->{{0, 360}, {0, 360}}]], "Output",
 ImageSize->{364, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->32760547]
}, Open  ]],

Cell["\<\
Setting the number of solutions to zero (0) or None give no solution curves.\
\>", "ExampleText",
 CellID->1092561305],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"DirectionFieldPlot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], "+", "x", "-", "y"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y", ",", 
      RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
    RowBox[{"StreamPoints", "\[Rule]", " ", "0"}]}], "]"}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1692671285],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnSF3I72z5mfPfpL9GEMDAwMDr8meM2BBYKihoaGpoWFDU0PDhqYNDQO1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    "], {{0, 360}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 360},
  PlotRange->{{0, 360}, {0, 360}}]], "Output",
 ImageSize->{364, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[5]=",
 CellID->168061521]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "StreamStyle",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1070367000],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->766192216],

Cell["\<\
By default the solution curves are rendered as single continuous curves drawn \
in red. \
\>", "ExampleText",
 CellID->361388054],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"DirectionFieldPlot", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], "+", "x", "-", "y"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y", ",", 
      RowBox[{"-", "3"}], ",", "3"}], "}"}], ",", 
    RowBox[{"StreamStyle", "\[Rule]", " ", 
     RowBox[{"Directive", "[", 
      RowBox[{"Thick", ",", "Green"}], "]"}]}]}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->2104761750],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS9040jQ7fPOIwsHDg0cuDA0MDAw8DP5zgl4IDDU0NDQ1NDQ0NTQ0NBU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    "], {{0, 360}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 360},
  PlotRange->{{0, 360}, {0, 360}}]], "Output",
 ImageSize->{364, 360},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->413215218]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->70260614],

Cell[TextData[ButtonBox["Differentiation",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/Differentiation"]], "MoreAbout",
 CellID->887072231]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"DirectionFieldPlot - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 26, 8.1808624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "DirectionFieldPlot[y_prm, {x, x_min, x_max}, {y, y_min, y_max}] plots a \
direction field for the derivative y_prm including 5 solution curves", 
    "synonyms" -> {}, "title" -> "DirectionFieldPlot", "titlemodifier" -> "", 
    "windowtitle" -> "DirectionFieldPlot", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/DirectionFieldPlot"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5746, 176, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->93268675]},
 "RasterizedOutput"->{
  Cell[7171, 232, 37292, 619, 381, "Output",
   CellTags->"RasterizedOutput",
   CellID->61507767],
  Cell[45338, 889, 26944, 450, 381, "Output",
   CellTags->"RasterizedOutput",
   CellID->472824334],
  Cell[73540, 1390, 22557, 378, 381, "Output",
   CellTags->"RasterizedOutput",
   CellID->581505],
  Cell[97119, 1813, 36060, 599, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->90677503],
  Cell[133459, 2427, 36549, 607, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->633915179],
  Cell[171160, 3079, 39318, 653, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->76350736],
  Cell[211487, 3775, 36846, 612, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->280567385],
  Cell[248946, 4413, 42755, 709, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->471143167],
  Cell[292494, 5155, 32929, 548, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->32760547],
  Cell[326040, 5729, 27855, 465, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->168061521],
  Cell[355046, 6241, 38916, 646, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->413215218]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 396834, 6970},
 {"RasterizedOutput", 396976, 6974}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[611, 21, 2594, 59, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3230, 84, 61, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3294, 87, 1231, 39, 91, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[4562, 131, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->394872697],
Cell[5174, 151, 142, 4, 70, "Notes",
 CellID->1067943069],
Cell[5319, 157, 109, 3, 70, "Notes",
 CellID->763815093],
Cell[5431, 162, 115, 3, 70, "Notes",
 CellID->488935064],
Cell[5549, 167, 160, 4, 70, "Notes",
 CellID->2128863058]
}, Closed]],
Cell[CellGroupData[{
Cell[5746, 176, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->93268675],
Cell[CellGroupData[{
Cell[6260, 194, 195, 6, 31, "ExampleSection",
 CellID->331067006],
Cell[6458, 202, 128, 3, 28, "Input",
 CellID->1930509932],
Cell[6589, 207, 223, 8, 34, "ExampleText",
 CellID->1897488248],
Cell[CellGroupData[{
Cell[6837, 219, 331, 11, 28, "Input",
 CellID->952826186],
Cell[7171, 232, 37292, 619, 381, "Output",
 CellTags->"RasterizedOutput",
 CellID->61507767]
}, Open  ]],
Cell[44478, 854, 360, 13, 70, "ExampleText",
 CellID->352579191],
Cell[CellGroupData[{
Cell[44863, 871, 472, 16, 30, "Input",
 CellID->891081064],
Cell[45338, 889, 26944, 450, 381, "Output",
 CellTags->"RasterizedOutput",
 CellID->472824334]
}, Open  ]],
Cell[72297, 1342, 556, 20, 70, "ExampleText",
 CellID->1220482771],
Cell[CellGroupData[{
Cell[72878, 1366, 659, 22, 30, "Input",
 CellID->1056756723],
Cell[73540, 1390, 22557, 378, 381, "Output",
 CellTags->"RasterizedOutput",
 CellID->581505]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[96146, 1774, 269, 8, 70, "ExampleSection",
 CellID->326097713],
Cell[CellGroupData[{
Cell[96440, 1786, 281, 8, 70, "ExampleSubsection",
 CellID->345995247],
Cell[96724, 1796, 128, 3, 70, "Input",
 CellID->1133845624],
Cell[96855, 1801, 134, 4, 70, "ExampleText",
 CellID->187658081],
Cell[CellGroupData[{
Cell[97014, 1809, 102, 2, 70, "Input",
 CellID->1463373571],
Cell[97119, 1813, 36060, 599, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->90677503]
}, Open  ]],
Cell[133194, 2415, 86, 1, 70, "ExampleText",
 CellID->1624585645],
Cell[CellGroupData[{
Cell[133305, 2420, 151, 5, 70, "Input",
 CellID->1303847557],
Cell[133459, 2427, 36549, 607, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->633915179]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[170057, 3040, 282, 8, 70, "ExampleSubsection",
 CellID->350769615],
Cell[170342, 3050, 128, 3, 70, "Input",
 CellID->1913058779],
Cell[170473, 3055, 235, 5, 70, "ExampleText",
 CellID->653735769],
Cell[CellGroupData[{
Cell[170733, 3064, 424, 13, 70, "Input",
 CellID->810731531],
Cell[171160, 3079, 39318, 653, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->76350736]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[210527, 3738, 284, 8, 70, "ExampleSubsection",
 CellID->1903883900],
Cell[210814, 3748, 128, 3, 70, "Input",
 CellID->1921002737],
Cell[210945, 3753, 154, 4, 70, "ExampleText",
 CellID->1023851761],
Cell[CellGroupData[{
Cell[211124, 3761, 360, 12, 70, "Input",
 CellID->90083716],
Cell[211487, 3775, 36846, 612, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->280567385]
}, Open  ]],
Cell[248348, 4390, 152, 4, 70, "ExampleText",
 CellID->1611379720],
Cell[CellGroupData[{
Cell[248525, 4398, 418, 13, 70, "Input",
 CellID->542681723],
Cell[248946, 4413, 42755, 709, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->471143167]
}, Open  ]],
Cell[291716, 5125, 113, 3, 70, "ExampleText",
 CellID->1093375036],
Cell[CellGroupData[{
Cell[291854, 5132, 637, 21, 70, "Input",
 CellID->336662673],
Cell[292494, 5155, 32929, 548, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->32760547]
}, Open  ]],
Cell[325438, 5706, 128, 3, 70, "ExampleText",
 CellID->1092561305],
Cell[CellGroupData[{
Cell[325591, 5713, 446, 14, 70, "Input",
 CellID->1692671285],
Cell[326040, 5729, 27855, 465, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->168061521]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[353944, 6200, 283, 8, 70, "ExampleSubsection",
 CellID->1070367000],
Cell[354230, 6210, 127, 3, 70, "Input",
 CellID->766192216],
Cell[354360, 6215, 139, 4, 70, "ExampleText",
 CellID->361388054],
Cell[CellGroupData[{
Cell[354524, 6223, 519, 16, 70, "Input",
 CellID->2104761750],
Cell[355046, 6241, 38916, 646, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->413215218]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[394035, 6895, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[394486, 6910, 170, 4, 70, "MoreAbout",
 CellID->70260614],
Cell[394659, 6916, 161, 3, 70, "MoreAbout",
 CellID->887072231]
}, Open  ]],
Cell[394835, 6922, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

