(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     18223,        581]
NotebookOptionsPosition[     13776,        439]
NotebookOutlinePosition[     16069,        501]
CellTagsIndexPosition[     15949,        495]
WindowTitle->Distance - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Problems in Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/ProblemsInAnalyticGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/AnalyticGeometry"], "\<\"Classroom \
Utilities\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/Distance\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/Distance"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/Distance.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/Distance", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["Distance", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Distance", "[", 
       RowBox[{
        SubscriptBox[
         StyleBox["pt", "TI"], 
         StyleBox["1", "TR"]], ",", 
        SubscriptBox[
         StyleBox["pt", "TI"], 
         StyleBox["2", "TR"]]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]gives the Euclidean distance between ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula"],
     " when the points are given in Cartesian coordinates."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->290333433],

Cell["The given points can be symbolic or numeric.", "Notes",
 CellID->1067943069],

Cell["Distance does not work with complex numbers.", "Notes",
 CellID->1252618349],

Cell["Distance can be used with Solve.", "Notes",
 CellID->974400102]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->3475533],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->107275676],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->32222292],

Cell["This gives the distance between two fixed points.", "ExampleText",
 CellID->394182600],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Distance", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->39907205],

Cell[BoxData[
 SqrtBox["17"]], "Output",
 ImageSize->{35, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->705496571]
}, Open  ]],

Cell["\<\
This gives the distance between a fixed point and an arbitrary point.\
\>", "ExampleText",
 CellID->1023653710],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Distance", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1056407853],

Cell[BoxData[
 SqrtBox[
  RowBox[{
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"3", "-", "x"}], ")"}], "2"], "+", 
   SuperscriptBox[
    RowBox[{"(", 
     RowBox[{"1", "-", "y"}], ")"}], "2"]}]]], "Output",
 ImageSize->{129, 23},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1799475622]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Applications",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->258228157],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->774578253],

Cell["Using Distance with Solve to find a locus.", "ExampleText",
 CellID->290830057],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", 
  RowBox[{"Solve", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"Distance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"-", "1"}]}], "}"}]}], "]"}], "\[Equal]", 
     RowBox[{"Distance", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"0", ",", "1"}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "y"}], "}"}]}], "]"}]}], ",", "y"}], 
   "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->307987427],

Cell[BoxData[
 RowBox[{
  RowBox[{"Solve", "::", "\<\"ifun\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Inverse functions are being used by \
\\\\\\\"\\\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(Solve\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\", so some solutions may \
not be found; use Reduce for complete solution information.\\\\\\\"\\\", \
\\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/Solve/ifun\\\", ButtonNote -> \
\\\"Solve::ifun\\\"]\\)\"\>"}]], "Message", "MSG",
 CellLabel->"During evaluation of In[2]:=",
 CellID->22235638],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{"y", "\[Rule]", 
    FractionBox[
     SuperscriptBox["x", "2"], "4"]}], "}"}], "}"}]], "Output",
 ImageSize->{74, 35},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->52213288]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ParametricPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", "y"}], "}"}], "/.", "sol"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1375403440],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztXauSo0AUTdV+yX7GuK2RIyORg4xYgRyLREbGInHbEouMbIlFIpHZAz1k
ktDdAQL9ok/NpKbIg0cfzj339u3M78+/+89fu93uD37/4bf9++Lh4eHhcQea
vEEdQzJ4goTYvntLqIaD8jAFoMeAG2BGt42Enh1bBocbP5s8OTYNDjd62eBw
w/tzCY7Homl0H8SSmKYbux7Kjs8cZBkty1rygqpqoog4RI9pfmObrLh0xEiS
4unLqrI5HEhdu8APlo/0CcltMOHnKdsUjZYY8XNiMNT1BepRywTGTWyQGGk6
SjFuAd2AepSlC+oxHlvTDRAjPZ1nvJGpBxzI4oekDILYwWpinCc2R4x0DjGu
6NTDzugi8py9P/3xHz22oxuII/MU4wFQj/O5ev1zFEOcq36TgoSPKcxGiBHH
RZ6XS33a11dOyGKfpgaSGhcLNsOJFud1o2naO31BYjB0KmRThVmmG0w2BobD
bWKw/ILSVRwCrMvUfEcnRH6j3w7ybKdmDtOIO2LVzAJyhPhiS+H0Pk+5Bpk+
TxlEFVdjSlFUUAwFowZf6kzh9AFOEiPLKG5nZbuDNK0XuRaEpIeHaQd3rk3V
0anAMSlOS+Sqk8AcLzipeL8TIJ5TGzoNBpeIgQHC/asxuwQn41idXk2CME+5
2g13/QYTdu1FS+ZzDLQfovrGVTSGSawbxIBWmDMiYGkYZqbVTkW64XBvD+JI
EhdHw+oMOCqYYfW2RwZJfaPbMOz7sZcVl66CAblYvOa5FLKUmqNmF2F9o+/5
GRTN7RUNQmh0MH3SHIntISRFYSh75bCRGEyxj0eTFFsMHC2SF5uq6z2s0w3c
iUFgnNN7CgQ+GFS9aZRs/Rqvy9guYsDdRUoq4WuAZdnaZm9l69f4k/S26EZJ
W9uZpgYXHschTc9hqKHALslV20l6a3UDcnEw3naOR7vs5UAUZ7jC3h7WviHg
hsn06ObZM6PnKeYCJxXs03OhyDgJdOOnYs6da1NzbFNR1w28vUtyMQRLuPCj
4hzl6+XtiSmEUCidsUWtZYGcC9qoYO2tqPbVwgZuwKR1F+psaTIyG4SUwT7L
TWpRNocbXY2osH190ItAGA2CrFjHhAjqG/fLZG9gghcFK6CouCYbCSJywGjh
HoHRWri+J/AbNEnI99Nm9ZmDFWlKwyCzbrnH2kCCBo+64FzM0+/n4X7HghZ6
XLUCaf7WrMV4gCFxnMOAva6osrVLbKsBXhSaCasJ3wWt8KwYg6pso8x+n0Jj
Z18xuW70keUOKnt7kINAJ4M2gjhYy1obuKfSEwVDwJM5VuR5LzFJdNS+WL3C
0lXGpoEtmGIyMqlxiFvf+M5SeN09q4oGfBRI/vGRIohUlenLN+xCXbfTdhBh
1lq/RnfZGsSgtAIZOvXLfVq6NuBXkwRuZHmSLKgbiBdIPUCJKMoRRLzPVAzY
OVY6C7vs7/Xw/SIxqqoBDdrA8X7qvpXCKUporwrOAwaFrfp8fz/B5oEwUO8Z
LWdTdQNDT88V2zUkAixF+JhdnzH84s84vAXfIvmo8XsBJXJSgh54y/vbKToQ
BHqY2KKoWH/RjL2w7S0TaA01wKd9RW0RBsYSIYNJ1kNo03slZ7xFst3D4xZT
KecMmAIgg8AjIgL7xjw84ppc/0ZUYq/RvqrUw8PDw8PDw2MzEPZEqYLwn6y5
C72nPHbEJT1RCsFr83Uc2k55xohr/VdmnhsaMHrEOT1RCqH/QimH9lMejPht
K8NNyOH2RK1xONy9G3Ch1EPzKY8ccVFPlEJ4bqje95gRl/REKYP2TEk9NJ6y
CSPu4eHh4eE2/gNenHap
    "], {{0, 64}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 64},
  PlotRange->{{0, 180}, {0, 64}}]], "Output",
 ImageSize->{184, 64},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->232024016]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Problems in Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/ProblemsInAnalyticGeometry"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/AnalyticGeometry"]], "MoreAbout",
 CellID->45350398],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->657019844]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Distance - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 26, 13.6096624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "Distance[pt_1, pt_2] gives the Euclidean distance between pt_1 and pt_2 \
when the points are given in Cartesian coordinates.", "synonyms" -> {}, 
    "title" -> "Distance", "titlemodifier" -> "", "windowtitle" -> "Distance",
     "type" -> "Symbol", "uri" -> "ClassroomUtilities/ref/Distance"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5317, 157, 488, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->3475533]},
 "RasterizedOutput"->{
  Cell[9834, 331, 2369, 47, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->232024016]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15686, 484},
 {"RasterizedOutput", 15827, 488}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 2863, 65, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3489, 90, 51, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3543, 93, 849, 27, 89, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4429, 125, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->290333433],
Cell[5041, 145, 82, 1, 70, "Notes",
 CellID->1067943069],
Cell[5126, 148, 82, 1, 70, "Notes",
 CellID->1252618349],
Cell[5211, 151, 69, 1, 70, "Notes",
 CellID->974400102]
}, Closed]],
Cell[CellGroupData[{
Cell[5317, 157, 488, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->3475533],
Cell[CellGroupData[{
Cell[5830, 175, 195, 6, 31, "ExampleSection",
 CellID->107275676],
Cell[6028, 183, 126, 3, 28, "Input",
 CellID->32222292],
Cell[6157, 188, 92, 1, 32, "ExampleText",
 CellID->394182600],
Cell[CellGroupData[{
Cell[6274, 193, 224, 8, 28, "Input",
 CellID->39907205],
Cell[6501, 203, 170, 6, 39, "Output",
 CellID->705496571]
}, Open  ]],
Cell[6686, 212, 121, 3, 32, "ExampleText",
 CellID->1023653710],
Cell[CellGroupData[{
Cell[6832, 219, 226, 8, 28, "Input",
 CellID->1056407853],
Cell[7061, 229, 346, 13, 44, "Output",
 CellID->1799475622]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7456, 248, 274, 8, 31, "ExampleSection",
 CellID->258228157],
Cell[7733, 258, 127, 3, 70, "Input",
 CellID->774578253],
Cell[7863, 263, 85, 1, 70, "ExampleText",
 CellID->290830057],
Cell[CellGroupData[{
Cell[7973, 268, 569, 20, 70, "Input",
 CellID->307987427],
Cell[8545, 290, 672, 12, 70, "Message",
 CellID->22235638],
Cell[9220, 304, 282, 10, 56, "Output",
 CellID->52213288]
}, Open  ]],
Cell[CellGroupData[{
Cell[9539, 319, 292, 10, 70, "Input",
 CellID->1375403440],
Cell[9834, 331, 2369, 47, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->232024016]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12264, 385, 448, 13, 45, "TutorialsSection",
 CellID->250839057],
Cell[12715, 400, 194, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[12946, 410, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[13397, 425, 163, 3, 70, "MoreAbout",
 CellID->45350398],
Cell[13563, 430, 171, 4, 70, "MoreAbout",
 CellID->657019844]
}, Open  ]],
Cell[13749, 437, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

