(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     17101,        544]
NotebookOptionsPosition[     13238,        421]
NotebookOutlinePosition[     15311,        477]
CellTagsIndexPosition[     15226,        472]
WindowTitle->Equation - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Problems in Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/ProblemsInAnyalyticGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:UnderstandingFunctions/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/Equation\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/Equation"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/Equation.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/Equation", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["Equation", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["Equation"], "InlineFormula"],
     "\[LineSeparator]is an option value for ",
     Cell[BoxData[
      ButtonBox["VerticalLineRepresentation",
       BaseStyle->"Link",
       ButtonData->"paclet:AnalyticGeometry/ref/VerticalLineRepresentation"]],
       "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->166845743],

Cell["\<\
Equation causes vertical lines to be returned in the form x==3.\
\>", "Notes",
 CellID->1067943069],

Cell[TextData[{
 "Equations can be used in ",
 ButtonBox["ContourPlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/ContourPlot"],
 "."
}], "Notes",
 CellID->1200453737],

Cell[TextData[{
 "Equation is the default value for ",
 Cell[BoxData[
  ButtonBox["PerpendicularLine",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/PerpendicularLine"]], 
  "InlineFormula"],
 "."
}], "Notes",
 CellID->1559323697]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->10767559],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->189429141],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->417094194],

Cell["This returns a line passing through the point {1,2} ", "ExampleText",
 CellID->715494750],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ln", "=", 
  RowBox[{"PerpendicularLine", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], ",", 
    RowBox[{"y", "\[Equal]", "3"}], ",", "x"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1810431138],

Cell[BoxData[
 RowBox[{"x", "\[Equal]", "1"}]], "Output",
 ImageSize->{36, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->124742219]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData["ln"], "Input",
 CellLabel->"In[3]:=",
 CellID->1235512726],

Cell[BoxData[
 RowBox[{"x", "\[Equal]", "1"}]], "Output",
 ImageSize->{36, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1243003039]
}, Open  ]],

Cell[TextData[{
 "To have the ContourPlot function see the equation for the line we can use ",
 ButtonBox["Evaluate",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Evaluate"],
 " or ",
 ButtonBox["With",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/With"],
 "."
}], "ExampleText",
 CellID->48927310],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ContourPlot", "[", 
  RowBox[{
   RowBox[{"Evaluate", "[", 
    RowBox[{"{", 
     RowBox[{"ln", ",", 
      RowBox[{"y", "\[Equal]", "3"}]}], "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "0", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->731026333],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxd1M0uQ0EUB/C2iuO7j9AviYeQ9CzQVqw8gkSCtkgfwdKCuhILSw9ggZZY
WNjaCAnaigWJTRcaEfFZdK45k/Of3Gb6y507Z+7cOSc2szQ9GwoEAsW/X7v3
WzMVUK2Z8pLZv+s0pX0hrlcK7Qvu34v9248wviHG3n/+WWzovcB8r+KMeeBd
XDMDPsV5E/Bb3PoxDZ4PsvWGCRhiPV+HOGHWE2Y9f6e4bNbXJfbjdYvTJl6P
uGTi9YqrJl6fOG7i9YtzJt6A2N+PQbHfR/5tG3HE9Oej1kX1XYk98B54RX13
O955B3ymzgVxHdwAr6pzY+d33gbvqnNFXAGfgC/VubPrcX4Av5nv9iTW+0sc
Bq+pc2vX77wFjqpzTZwEj4D31Lm37+t8DB5TeUGcAU+Br1TeENfAd+A5lVfE
efAy+EPlHXELHPT/sPWEyku7fudJ8LrKW+IN8Cb4RuW1fV/nW3BM5T1xAjwM
XlB1we6P8yJ4X9UN4jL4EPyl6ordT2fsx1XdIU6Ds+A1VZeIS2APfK3qFnEV
XAdHVV0jjoOT4HlV94hz4AL4QNVFmy/OR2B//4Zg3yLiXzhI25A=
   "], {{}, {}, 
    TagBox[
     TooltipBox[
      {Hue[0.67, 0.6, 0.6], 
       LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
         19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29}]},
      RowBox[{"x", "\[Equal]", "1"}]],
     Annotation[#, $CellContext`x == 1, "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      {Hue[0.9060679774997897, 0.6, 0.6], 
       LineBox[{30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 
        45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 
        62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 
        79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 
        96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110,
         111, 112, 113, 114}]},
      RowBox[{"y", "\[Equal]", "3"}]],
     Annotation[#, $CellContext`y == 3, "Tooltip"]& ]}],
  AspectRatio->1,
  Frame->True,
  PlotRange->{{0, 4}, {0, 4}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 ImageSize->{184, 189},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1660005830]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"ln", "=", "ln"}], "}"}], ",", 
   RowBox[{"ContourPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"ln", ",", 
       RowBox[{"y", "\[Equal]", "3"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"y", ",", "0", ",", "4"}], "}"}]}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1757926633],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxd1M0uQ0EUB/C2iuO7j9AviYeQ9CzQVqw8gkSCtkgfwdKCuhILSw9ggZZY
WNjaCAnaigWJTRcaEfFZdK45k/Of3Gb6y507Z+7cOSc2szQ9GwoEAsW/X7v3
WzMVUK2Z8pLZv+s0pX0hrlcK7Qvu34v9248wviHG3n/+WWzovcB8r+KMeeBd
XDMDPsV5E/Bb3PoxDZ4PsvWGCRhiPV+HOGHWE2Y9f6e4bNbXJfbjdYvTJl6P
uGTi9YqrJl6fOG7i9YtzJt6A2N+PQbHfR/5tG3HE9Oej1kX1XYk98B54RX13
O955B3ymzgVxHdwAr6pzY+d33gbvqnNFXAGfgC/VubPrcX4Av5nv9iTW+0sc
Bq+pc2vX77wFjqpzTZwEj4D31Lm37+t8DB5TeUGcAU+Br1TeENfAd+A5lVfE
efAy+EPlHXELHPT/sPWEyku7fudJ8LrKW+IN8Cb4RuW1fV/nW3BM5T1xAjwM
XlB1we6P8yJ4X9UN4jL4EPyl6ordT2fsx1XdIU6Ds+A1VZeIS2APfK3qFnEV
XAdHVV0jjoOT4HlV94hz4AL4QNVFmy/OR2B//4Zg3yLiXzhI25A=
   "], {{}, {}, 
    TagBox[
     TooltipBox[
      {Hue[0.67, 0.6, 0.6], 
       LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
         19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29}]},
      RowBox[{"x", "\[Equal]", "1"}]],
     Annotation[#, $CellContext`x == 1, "Tooltip"]& ], 
    TagBox[
     TooltipBox[
      {Hue[0.9060679774997897, 0.6, 0.6], 
       LineBox[{30, 31, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42, 43, 44, 
        45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 58, 59, 60, 61, 
        62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73, 74, 75, 76, 77, 78, 
        79, 80, 81, 82, 83, 84, 85, 86, 87, 88, 89, 90, 91, 92, 93, 94, 95, 
        96, 97, 98, 99, 100, 101, 102, 103, 104, 105, 106, 107, 108, 109, 110,
         111, 112, 113, 114}]},
      RowBox[{"y", "\[Equal]", "3"}]],
     Annotation[#, $CellContext`y == 3, "Tooltip"]& ]}],
  AspectRatio->1,
  Frame->True,
  PlotRange->{{0, 4}, {0, 4}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 ImageSize->{184, 189},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->392905405]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Problems in Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/ProblemsInAnyalyticGeometry"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:UnderstandingFunctions/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->1665078683]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Equation - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 26, 17.0884624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "Equation is an option value for VerticalLineRepresentation.", 
    "synonyms" -> {}, "title" -> "Equation", "titlemodifier" -> "", 
    "windowtitle" -> "Equation", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/Equation"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5182, 160, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->10767559]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15084, 465}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 2768, 64, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3394, 89, 51, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3448, 92, 509, 15, 85, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3994, 112, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->166845743],
Cell[4606, 132, 109, 3, 70, "Notes",
 CellID->1067943069],
Cell[4718, 137, 172, 7, 70, "Notes",
 CellID->1200453737],
Cell[4893, 146, 252, 9, 70, "Notes",
 CellID->1559323697]
}, Closed]],
Cell[CellGroupData[{
Cell[5182, 160, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->10767559],
Cell[CellGroupData[{
Cell[5696, 178, 195, 6, 31, "ExampleSection",
 CellID->189429141],
Cell[5894, 186, 127, 3, 28, "Input",
 CellID->417094194],
Cell[6024, 191, 95, 1, 32, "ExampleText",
 CellID->715494750],
Cell[CellGroupData[{
Cell[6144, 196, 255, 8, 28, "Input",
 CellID->1810431138],
Cell[6402, 206, 187, 6, 36, "Output",
 CellID->124742219]
}, Open  ]],
Cell[CellGroupData[{
Cell[6626, 217, 72, 2, 28, "Input",
 CellID->1235512726],
Cell[6701, 221, 188, 6, 36, "Output",
 CellID->1243003039]
}, Open  ]],
Cell[6904, 230, 302, 11, 32, "ExampleText",
 CellID->48927310],
Cell[CellGroupData[{
Cell[7231, 245, 380, 12, 28, "Input",
 CellID->731026333],
Cell[7614, 259, 1854, 42, 210, "Output",
 CellID->1660005830]
}, Open  ]],
Cell[CellGroupData[{
Cell[9505, 306, 464, 15, 70, "Input",
 CellID->1757926633],
Cell[9972, 323, 1853, 42, 70, "Output",
 CellID->392905405]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11886, 372, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[12337, 387, 195, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[12569, 397, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[13020, 412, 176, 4, 70, "MoreAbout",
 CellID->1665078683]
}, Open  ]],
Cell[13211, 419, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

