(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     14565,        474]
NotebookOptionsPosition[     10856,        360]
NotebookOutlinePosition[     13024,        417]
CellTagsIndexPosition[     12939,        412]
WindowTitle->EulerEstimate - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"EulerSolve\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/EulerSolve"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Differentiation\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/Differentiation"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/EulerEstimate\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/EulerEstimate"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/EulerEstimate.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/EulerEstimate", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["EulerEstimate", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"EulerEstimate", "[", 
       RowBox[{
        StyleBox["der", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["2", "TR"]]}], "}"}], ",", 
        StyleBox["pt", "TI"], ",", 
        StyleBox["stp", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]estimates the value of the solution function for ",
     Cell[BoxData[
      RowBox[{
       RowBox[{
        StyleBox["y", "TI"], "'"}], "=", " ", 
       StyleBox["der", "TI"]}]], "InlineFormula"],
     " a distance ",
     Cell[BoxData[
      StyleBox["stp", "TI"]], "InlineFormula"],
     " units from ",
     Cell[BoxData[
      StyleBox["pt", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->319347588],

Cell[TextData[{
 "The argument der should be the right hand side of the differential equation \
",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{
     StyleBox["y", "TI"], "'"}], 
    RowBox[{"(", 
     StyleBox["x", "TI"], ")"}]}], " ", "=", " ", 
   RowBox[{
    StyleBox["f", "TI"], 
    RowBox[{"(", 
     RowBox[{
      StyleBox["x", "TI"], ",", 
      StyleBox["y", "TI"]}], ")"}]}]}]], "InlineFormula"]
}], "Notes",
 CellID->1067943069],

Cell["\<\
Any variables can be used as long as they are given as symbols.\
\>", "Notes",
 CellID->1783176495],

Cell["\<\
The step distance is taken in the direction of the tangent line.\
\>", "Notes",
 CellID->1713057580]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->739005640],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->613408132],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->45491731],

Cell["\<\
Find an approximation to the solution to the differential equation y\"= x+y \
.1 units from the point {0,1}.\
\>", "ExampleText",
 CellID->75344585],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"EulerEstimate", "[", 
  RowBox[{
   RowBox[{"x", "+", "y"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "y"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", ".1"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1448572012],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.07071067811865475`", ",", "1.0707106781186548`"}], 
  "}"}]], "Output",
 ImageSize->{141, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->127699645]
}, Open  ]],

Cell["\<\
Move ten steps from the starting point taking each estimate to be a new start \
point.\
\>", "ExampleText",
 CellID->911770162],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"NestList", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"EulerEstimate", "[", 
     RowBox[{
      RowBox[{"x", "+", "y"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "y"}], "}"}], ",", "#", ",", ".1"}], "]"}], "&"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", "10"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1825291389],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.07071067811865475`", ",", "1.0707106781186548`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.1366080147333933`", ",", "1.1459273054498762`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.19809675993648598`", ",", "1.2247887929665922`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.2555964878208662`", ",", "1.306604325069135`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.3095091807476489`", ",", "1.3908267777844439`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.3602037502421113`", ",", "1.4770245771981825`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.408010665897288`", ",", "1.5648567968874219`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.4532220321099224`", ",", "1.6540528302363722`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.49609428523908883`", ",", "1.7443964515476118`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5368519238387568`", ",", "1.835713563283468`"}], "}"}]}], 
  "}"}]], "Output",
 ImageSize->{565, 50},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->868477528]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["EulerSolve",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/EulerSolve"],
  FontFamily->"Verdana"]], "InlineFormula"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->37015492],

Cell[TextData[ButtonBox["Differentiation",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/Differentiation"]], "MoreAbout",
 CellID->80986576]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"EulerEstimate - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 26, 24.3268624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "EulerEstimate[der, {var_1, var_2}, pt, stp] estimates the value of the \
solution function for y' = der a distance stp units from pt.", 
    "synonyms" -> {}, "title" -> "EulerEstimate", "titlemodifier" -> "", 
    "windowtitle" -> "EulerEstimate", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/EulerEstimate"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5954, 184, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->739005640]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 12796, 405}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[606, 21, 2843, 65, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3474, 90, 56, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3533, 93, 1063, 34, 85, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4633, 132, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->319347588],
Cell[5245, 152, 447, 17, 70, "Notes",
 CellID->1067943069],
Cell[5695, 171, 109, 3, 70, "Notes",
 CellID->1783176495],
Cell[5807, 176, 110, 3, 70, "Notes",
 CellID->1713057580]
}, Closed]],
Cell[CellGroupData[{
Cell[5954, 184, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->739005640],
Cell[CellGroupData[{
Cell[6469, 202, 195, 6, 31, "ExampleSection",
 CellID->613408132],
Cell[6667, 210, 126, 3, 28, "Input",
 CellID->45491731],
Cell[6796, 215, 158, 4, 45, "ExampleText",
 CellID->75344585],
Cell[CellGroupData[{
Cell[6979, 223, 276, 9, 28, "Input",
 CellID->1448572012],
Cell[7258, 234, 244, 8, 36, "Output",
 CellID->127699645]
}, Open  ]],
Cell[7517, 245, 137, 4, 32, "ExampleText",
 CellID->911770162],
Cell[CellGroupData[{
Cell[7679, 253, 382, 13, 28, "Input",
 CellID->1825291389],
Cell[8064, 268, 1196, 30, 71, "Output",
 CellID->868477528]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9321, 305, 446, 13, 45, "SeeAlsoSection",
 CellID->1255426704],
Cell[9770, 320, 223, 6, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[10030, 331, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[10481, 346, 170, 4, 70, "MoreAbout",
 CellID->37015492],
Cell[10654, 352, 160, 3, 70, "MoreAbout",
 CellID->80986576]
}, Open  ]],
Cell[10829, 358, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

