(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     23696,        689]
NotebookOptionsPosition[     19715,        566]
NotebookOutlinePosition[     21927,        624]
CellTagsIndexPosition[     21842,        619]
WindowTitle->EulerSolve - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Differentiation\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/Differentiation"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/EulerSolve\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/EulerSolve"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/EulerSolve.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/EulerSolve", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["EulerSolve", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"EulerSolve", "[", 
       RowBox[{
        StyleBox["der", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["var", "TI"], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["pt", "TI"], ",", 
        StyleBox["stp", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]gives and Euler method approximation to the solution of \
the differential equation y'==der starting at ",
     Cell[BoxData[
      StyleBox["pt", "TI"]], "InlineFormula"],
     " and continuing to ",
     Cell[BoxData[
      RowBox[{
       StyleBox["var", "TI"], "=", 
       SubscriptBox[
        StyleBox["var", "TI"], 
        StyleBox["max", "TI"]]}]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->52469865],

Cell[TextData[{
 "EulerSolve uses ",
 Cell[BoxData[
  ButtonBox["EulerEstimate",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/EulerEstimate"]], 
  "InlineFormula"],
 " to provide an approximate solution to the differential equation."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The variable ",
 Cell[BoxData[
  StyleBox["var", "TI"]], "InlineFormula"],
 " should be the independent variable."
}], "Notes",
 CellID->55464437]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->278765259],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->398219237],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->182889861],

Cell["\<\
Generate an approximate solution to the differential equation y' = x- 2 y \
satisfying y(0) = -1 valid on the interval (0,2).\
\>", "ExampleText",
 CellID->780794970],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"eulrPts", "=", 
  RowBox[{"EulerSolve", "[", 
   RowBox[{
    RowBox[{"x", "-", 
     RowBox[{"2", "y"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"0", ",", 
      RowBox[{"-", "1"}]}], "}"}], ",", ".1"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1695977620],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"0", ",", 
     RowBox[{"-", "1"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.044721359549995794`", ",", 
     RowBox[{"-", "0.9105572809000084`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.09195983509454048`", ",", 
     RowBox[{"-", "0.8224180363591829`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.14185727634991335`", ",", 
     RowBox[{"-", "0.7357563645765164`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.19454022962810286`", ",", 
     RowBox[{"-", "0.6507592679561723`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.25011129381899416`", ",", 
     RowBox[{"-", "0.5676216902629785`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.30863980965688176`", ",", 
     RowBox[{"-", "0.48653893726448844`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.3701529406071692`", ",", 
     RowBox[{"-", "0.4076964695158646`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.4346285716317147`", ",", 
     RowBox[{"-", "0.3312576508175967`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5019915580214867`", ",", 
     RowBox[{"-", "0.25735076301509624`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.5721145295210079`", ",", 
     RowBox[{"-", "0.18605722285837992`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.6448236648156577`", ",", 
     RowBox[{"-", "0.11740315054868859`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7199087941639455`", ",", 
     RowBox[{"-", "0.05135602077947839`"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.7971362388713656`", ",", "0.012172884326483849`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.8762623195267772`", ",", "0.07332076540271824`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0.9570456046767029`", ",", "0.1322619296293079`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.039256587342753`", ",", "0.1891948228377371`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.1226842613496717`", ",", "0.24432941460910418`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.2071397372137578`", ",", "0.2978763341896997`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.2924574430642055`", ",", "0.3500384762892769`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.378494598841571`", ",", "0.40100520882866314`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.4651296114140997`", ",", "0.450948923113424`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.5522599075024743`", ",", "0.5000234735805671`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.6397995702281674`", ",", "0.5483640098816045`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.7276770120266924`", ",", "0.5960877484500237`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.8158328154799097`", ",", "0.6432953147664282`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.9042178041693778`", ",", "0.6900723793853479`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.9927913618869546`", ",", "0.7364913935201944`"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2.0815199932572845`", ",", "0.7826132969408919`"}], "}"}]}], 
  "}"}]], "Output",
 ImageSize->{565, 152},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1589814010]
}, Open  ]],

Cell["\<\
Visualize the approximation compared to the correct solution.\
\>", "ExampleText",
 CellID->1879287212],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sol", "=", " ", 
  RowBox[{"DSolve", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{
       RowBox[{
        RowBox[{"y", "'"}], "[", "x", "]"}], "\[Equal]", 
       RowBox[{"x", "-", 
        RowBox[{"2", 
         RowBox[{"y", "[", "x", "]"}]}]}]}], ",", 
      RowBox[{
       RowBox[{"y", "[", "0", "]"}], "\[Equal]", 
       RowBox[{"-", "1"}]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"y", "[", "x", "]"}], "}"}], ",", "x"}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->2138175655],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"y", "[", "x", "]"}], "\[Rule]", 
    RowBox[{
     FractionBox["1", "4"], " ", 
     SuperscriptBox["\[ExponentialE]", 
      RowBox[{
       RowBox[{"-", "2"}], " ", "x"}]], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "3"}], "-", 
       SuperscriptBox["\[ExponentialE]", 
        RowBox[{"2", " ", "x"}]], "+", 
       RowBox[{"2", " ", 
        SuperscriptBox["\[ExponentialE]", 
         RowBox[{"2", " ", "x"}]], " ", "x"}]}], ")"}]}]}], "}"}], 
  "}"}]], "Output",
 ImageSize->{235, 32},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1012530096]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"ListLinePlot", "[", 
     RowBox[{"eulrPts", ",", 
      RowBox[{"Mesh", "\[Rule]", " ", "All"}]}], "]"}], ",", 
    RowBox[{"Plot", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"y", "[", "x", "]"}], "/.", "sol"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", "2"}], "}"}]}], "]"}]}], "}"}], 
  "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->687765383],

Cell[BoxData[
 GraphicsBox[{GraphicsComplexBox[CompressedData["
1:eJwB4QEe/iFib1JlAgAAAB0AAAACAAAAAAAAAAAAAAAAAAAAAADwv+FXZtG3
5aY/BDXTBUkj7b+Mz0YEroq3Pw60OaE/Ueq/eq5PFWEowj98wnXuUIvnv/Yn
Abqx5sg/5RmuGQXT5L9bBdTM0gHQP2LAhfb0KeK/BhQuMMHA0z9NBfI1dCPf
v/JDm/WVsNc/qvrQ7rIX2r+lL0Rb9NDbP2rtM0pTM9W/fECSmVAQ4D/xB7BV
b3jQvzR+OyHDTuI/6T+uG7nQx79jPgI9ZaLkP8PRDQQiDr6/oC7hKn4J5z9K
r2YbVkuqvzIWjdsjguk/aFSk4BjuiD8htaJGVwrsP5e5hVEmxbI/VL6bGh6g
7j/vwSF79e3AP5Si7IPLoPA/Xo5UNIk3yD8usaPFg/bxP+g0ma4vRs8/3o/Q
wXFQ8z9UN2bmZxDTP7TrFtvnrfQ/b0MAyAdn1j+FyztaUA72P+12XMARqtk/
w8tWvytx9z+bETzfWNzcP4DXGXwO1vg/7lhIOjEA4D9S/2F5njz6P1LWF64y
jOE/UEqLppCk+z+5cySdJhPjP0jW17WmDf0/UPBSDuCV5D8C5ZUWrXf+P7mn
qqsSFeY/cOTwMXni/z/qjB5mVpHnP9gUSPTzpgBA6NN4CisL6T9Qwubf
    "], {{{}, {}, 
      {Hue[0.67, 0.6, 0.6], 
       LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
         19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29}]}}, {
      {Hue[0.67, 0.6, 0.6], 
       PointBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 
        18, 19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29}]}, {}, {}}}], {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVxX081HcAB3BK0Sx1qXRJjVwttLyIiton1BC2PLSePNw4aleEvCKz1S0n
D9mZeUVEysMyeWjueqJ91VkbPUhOR8N5uO5Hh1PdnSh+2/54v97mocf8wmfp
6Oj4/Of/d4UPtTUOh38e+4ONhKZVRM9tebSMuQNX2XZQa1TE/lLexTpmAKpE
J/WVShXxeiz9vZDJQaZxxzWZVEX2cibuZjPjYMua6/iyRkV6Npx1y2Qmwyth
dyGbrSLFS75KSWfmoMVDUGIsHiM8g7q1acxSxJm4RboKRsm+/Zdrxl8L0aEn
sznBUBJDmhfovpJgm+kUx6JviLB8x4bEGU1o9l9yiyNVkPgnW5CnbgZPmypf
cE9OTISMXl3dVqTnN+d2DQ2QGwNuj1q3PoONN6+vfHY/uc8tNN0/IkGVOMSP
cbqXaNZsW1AVKUXxxyYsx+B/yKzJyoWmrBc45lrqn23eSRxp9g3/6m5wqdXL
QtFBHiVvfPLASoaV3+k9901/RlZlKScrxvqgfSvWUR1vJcoJWW+H7QA0Q2tn
jnJbSOmr+hajnwYR1vMLp8z6T2Jk9qtKLpdDfLssunJzIzn3rSii2FIB/zt/
DUal3yTa7ZXyw6coVJzdHtMVdY3E2TUJl4qHwFJvsPS0zyWy6qaMNvNX8HkX
LdB3TcV7rqRgXaISex5uO+gkK4e1i/5MRP0ILEiij4tRHdyvmB+6bjKGKAcT
l4xl9Yg3C7HoD1ThRZ7Dgcsb78FmZI+h1Gcc6oDGlxGiJhgvGDdomhrH1iLB
h6Cjf0OPFNSsvvgalRI3TsfThziysb5rntcbeObapc0/0opKz9DiP7RvsJTt
XLE/pg0a5fKFivNvIQzsq5lj0A6Rv/vsnB1qKCbSvW7cluCUB/+SUKGGO78/
28HjOcx7dnWW8DUwcQoaC26WwmlTcg7TTgsG44FHSXgXAle2Tuq2a5Hhx7Zi
97+ApiVzIJo3ASuJKJOZ0I08veA4P8t3yDe34BWqemDcK7oyq+kdfPjPNxkH
yjDne17AlphJzK0Whz+M6YNORXDNwKIppBcmjErX9CM2vyZz0f0psPpK2r8Z
7sdd61QDRtR7HMt9dEdSPgDGrlibH40+YPcixhLPrwfRvf5p+8mGD2hfHXHI
xViO2iJYyoOnkTyaws++L0dQjSPDbGYa825zxEmRL3Gaf5nX/dsM2rrPM1Us
BaqGzAqMvGmsCN6ptG1TILWQz+79kobA/4zUWqIAx2+UVe1Lo+rsBeEaqQIr
GhpqffbSOKEOc1nRo0C64OCDc6E0Co7PKZ87rMBhxwuvPzpJQ5PGLO7UoWCR
vNhDv5yGPYeZFGNLYWZz0nzpVRqnQjIyufYUukYHn5VX0thxICkrzJFC1t66
oC+u0yi7puLu2UqBtvI7zm+gsVNTEbvZg0J3m6BodjsNUVNn2/sQCrdSJsLa
O2j4meRPvw2lkOMcsq6kk4Z4sbXpSDgFr7LPhK69NLZPt1p3H6FwJ+FxM2+Y
RmhRbUl9PIXz6x0EviM0bkUmBtclUogZuBhgrqIhzHE2rPyewqfeR2WNahrT
RTed8s9Q0NOVlGZN0Cjfl3T35xQKfSJnLnuKRu1Sb7u0NAoN3JINttM0tMT6
wulzFHJXGWpomkbhlk/exAso/At4Eofn
      "]]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0., 2.0815199932572845`}, {-1., 0.7826132969408919}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 ImageSize->{184, 103},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->932904644]
}, Open  ]],

Cell[TextData[{
 "Solve ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"y", "'"}], " ", "=", " ", 
   RowBox[{
    RowBox[{"5", " ", "t"}], " ", "-", 
    RowBox[{"3", " ", 
     SqrtBox["y"]}]}]}]], "InlineFormula"],
 " with ",
 Cell[BoxData[
  RowBox[{
   RowBox[{"y", 
    RowBox[{"(", "0", ")"}]}], "=", " ", "2"}]], "InlineFormula"],
 " using Euler's methed with a step size of .05 and visualize the results."
}], "ExampleText",
 CellID->156624144],

Cell[BoxData[
 RowBox[{
  RowBox[{"pts2", "=", 
   RowBox[{"EulerSolve", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"5", " ", "t"}], "-", 
      RowBox[{"3", " ", 
       SqrtBox["y"]}]}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "0", ",", "1.5"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"0", ",", "2"}], "}"}], ",", ".05"}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1714520633],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ListLinePlot", "[", 
  RowBox[{"pts2", ",", 
   RowBox[{"Mesh", "\[Rule]", " ", "All"}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->1012703385],

Cell[BoxData[
 GraphicsBox[GraphicsComplexBox[CompressedData["
1:eJxdxX0w2wcAh/FIWi+1a0+9dsq1Wi0VGzovs7Xfn9pGzBTjqKJhzGvndUyH
qx1aVbOrUh3XkWtFOBm5eVlxW9XLvFOEst5iNFEkIq/eItv+3XP3uedkZJJ/
NJlEIhH/+u//i+izbRDu59xC4lVmCctFDd5rU5r14APQML/yY8o+ajqdri/o
McCbPX9qoUEFu4SM6xfi61E1/N6V1OU9tHHcdFViNqjaxYI48z0Y+f5G/3ua
g6ZcRdNI8C5CMus6Q73bUF9pFMUs20F6gs1tz8VfoZV5WFNnfBu7HJ5jUEU3
th54R1B0txE6F3vcr/13HHEgRhs9tuAmW67ktfWgmEo+ebxAifYQtpl0uBeZ
lvL9tOcKlDKMXTW2+8GOeFE1T1bgkJ///A4xiL2GWNc8dzlGRPyBL5nDEPaW
tdYVyJClyuq4azcGobiHWT0ohfpUxz43eQLbwymm40ek4J9VvcviTeKLlSi/
iWAJ8i3Tj84lTOGCp+anCU82YUcX61QZz+Cp2zfcZwoxzAZnmVWrXPCHdCpy
fcToFdU+9RbOQR3pNfB5+AaSYg+07lkv4FGfDjX1fRGs7BXyrsZX8LlLe/zK
VQi6nbXD8oc8PJ4Pb+F8vQ4+4w1Xr38RdUMtOYvkdQhkNoE515bgG1Xu2aVY
g3P8DuezjWUQzf5uXZfXMePYQBdF8ZFgyS2pUK7DNpBuRO0W4O1rlrXfzwix
EGlgoLe7AtaIfs3LWRE0V/9Szlms4tzsUrWDdAOqYA8vmssa0nyH7rn/IEaZ
ZiE97uI6jhnmFzFsN1ES8F1upbMQ6vy33G0nNjFw+mwXx1IEEwfe9GSGBKsc
cyv7QxsgO9dODJ2Qgjqm53uJv4HUi9W/FIxKMW8ZcPqrMDEeDjhRyrJleGMV
thbVK4Z+c8vBals5kgN+1g2x2sT4iyBSKE8OjbEPpu8XbUI14l5adV+BiEAx
xX9lE/akxRhbLyUMKr2m+z6S4FGhSHOdtIV7jJvFZj9JwD9noW7v2MKxqfbW
m0oJ9o1o7Rkp23Ae6TQ96iNFMjcwU89mB0/io2+JGVJEm/iy01/vIEqQF+Gs
kEJ3SRRRWrOLrD8k9moPGZIeUrv9Q/cQmlOkHV4pQ8KkQ1uLiQq04ttTMQIZ
el4a9tfMqGDiWcR8x1GO8huX2YZl+6Bcrd/tyZND97nEU8tPjdRspz/Pj8ph
qMNqbtMiEWWjbMNSYwVcBE20EzEkgtIdeGWRrkBjLNWku59E2GtWhTqxFODK
NQzunNEgvg0+KasUK5DILr+RX6hBMO5Y2Og7KzEdVt3P4msQ9fLeIHa2Eh/X
HmYpPyETrLQFatozJczPmFESmWTCR5A2GHdwC1nbW7wD2hTiHzjnBiA=
   "], {{{}, {}, 
     {Hue[0.67, 0.6, 0.6], 
      LineBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 
       19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36,
        37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 
       54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64}]}}, {
     {Hue[0.67, 0.6, 0.6], 
      PointBox[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18,
        19, 20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 
       36, 37, 38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53,
        54, 55, 56, 57, 58, 59, 60, 61, 62, 63, 64}]}, {}, {}}}],
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 1.},
  PlotRange->{{0., 1.501321589398191}, {0.8738690774581617, 
   2.3789155555706967`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 ImageSize->{184, 114},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->1697889220]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->70076842],

Cell[TextData[ButtonBox["Differentiation",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/Differentiation"]], "MoreAbout",
 CellID->202093658]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"EulerSolve - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 26, 27.8368624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "EulerSolve[der, {var, var_min, var_max}, pt, stp] gives and Euler method \
approximation to the solution of the differential equation y'==der starting \
at pt and continuing to var = var_max.", "synonyms" -> {}, "title" -> 
    "EulerSolve", "titlemodifier" -> "", "windowtitle" -> "EulerSolve", 
    "type" -> "Symbol", "uri" -> "ClassroomUtilities/ref/EulerSolve"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5469, 166, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->278765259]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 21699, 612}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[603, 21, 2538, 57, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3166, 82, 53, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3222, 85, 1105, 34, 101, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4364, 124, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->52469865],
Cell[4975, 144, 290, 9, 70, "Notes",
 CellID->1067943069],
Cell[5268, 155, 164, 6, 70, "Notes",
 CellID->55464437]
}, Closed]],
Cell[CellGroupData[{
Cell[5469, 166, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->278765259],
Cell[CellGroupData[{
Cell[5984, 184, 195, 6, 31, "ExampleSection",
 CellID->398219237],
Cell[6182, 192, 127, 3, 28, "Input",
 CellID->182889861],
Cell[6312, 197, 176, 4, 45, "ExampleText",
 CellID->780794970],
Cell[CellGroupData[{
Cell[6513, 205, 361, 12, 28, "Input",
 CellID->1695977620],
Cell[6877, 219, 3195, 79, 173, "Output",
 CellID->1589814010]
}, Open  ]],
Cell[10087, 301, 113, 3, 70, "ExampleText",
 CellID->1879287212],
Cell[CellGroupData[{
Cell[10225, 308, 542, 18, 70, "Input",
 CellID->2138175655],
Cell[10770, 328, 688, 23, 53, "Output",
 CellID->1012530096]
}, Open  ]],
Cell[CellGroupData[{
Cell[11495, 356, 453, 15, 70, "Input",
 CellID->687765383],
Cell[11951, 373, 3248, 62, 124, "Output",
 CellID->932904644]
}, Open  ]],
Cell[15214, 438, 446, 16, 70, "ExampleText",
 CellID->156624144],
Cell[15663, 456, 414, 14, 70, "Input",
 CellID->1714520633],
Cell[CellGroupData[{
Cell[16102, 474, 175, 5, 70, "Input",
 CellID->1012703385],
Cell[16280, 481, 2547, 49, 135, "Output",
 CellID->1697889220]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18888, 537, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[19339, 552, 170, 4, 70, "MoreAbout",
 CellID->70076842],
Cell[19512, 558, 161, 3, 70, "MoreAbout",
 CellID->202093658]
}, Open  ]],
Cell[19688, 564, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

