(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     14038,        451]
NotebookOptionsPosition[     10584,        344]
NotebookOutlinePosition[     12679,        400]
CellTagsIndexPosition[     12594,        395]
WindowTitle->Exact - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Building an Understanding of Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
BuildingAnUnderstandingOfFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Understanding Functions\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/Exact\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/Exact"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/Exact.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]},
             Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/Exact", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["Exact", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["Exact"], "InlineFormula"],
     "\[LineSeparator]is a possible value for the option ",
     Cell[BoxData[
      ButtonBox["FunctionValues",
       BaseStyle->"Link",
       ButtonData->"paclet:UnderstandingFunctions/ref/FunctionValues"]], 
      "InlineFormula"],
     " giving function values as exact numbers."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->203403784],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"$Line", " ", "=", "0"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1318904010],

Cell[BoxData["0"], "Output",
 ImageSize->{11, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[0]=",
 CellID->493491736]
}, Open  ]],

Cell[TextData[{
 "To use the value Exact all arguments to ",
 Cell[BoxData[
  ButtonBox["FunctionTable",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/FunctionTable"]], 
  "InlineFormula"],
 " must be exact values."
}], "Notes",
 CellID->1067943069],

Cell["\<\
The default value for FunctionValues is Automatic and returns machine numbers \
for the function value.\
\>", "Notes",
 CellID->1829688383]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->63033050],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->38380114],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1754311688],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionTable", "[", 
  RowBox[{
   RowBox[{"x", " ", 
    RowBox[{"Cos", "[", "x", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", 
     RowBox[{"2", " ", "\[Pi]"}], ",", 
     RowBox[{"\[Pi]", "/", "3"}]}], "}"}], ",", 
   RowBox[{"FunctionValues", "\[Rule]", " ", "Exact"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1913550553],

Cell[BoxData[
 TagBox[GridBox[{
    {
     ItemBox["x",
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False], 
     ItemBox[
      InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`\\\"\\\\[\
ScriptF]\\\"\\), TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`\\(x\\\\ \\(\
\\(cos(x)\\)\\)\\)\\), TraditionalForm, Rule[Editable, True]]\\)\"\>",
       StringForm["`3`(`2`) = `1`", 
        TraditionalForm[$CellContext`x Cos[$CellContext`x]], 
        TraditionalForm[$CellContext`x], 
        TraditionalForm["\[ScriptF]"]],
       Editable->False],
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False]},
    {"0", "0"},
    {
     FractionBox["\[Pi]", "3"], 
     FractionBox["\[Pi]", "6"]},
    {
     FractionBox[
      RowBox[{"2", " ", "\[Pi]"}], "3"], 
     RowBox[{"-", 
      FractionBox["\[Pi]", "3"]}]},
    {"\[Pi]", 
     RowBox[{"-", "\[Pi]"}]},
    {
     FractionBox[
      RowBox[{"4", " ", "\[Pi]"}], "3"], 
     RowBox[{"-", 
      FractionBox[
       RowBox[{"2", " ", "\[Pi]"}], "3"]}]},
    {
     FractionBox[
      RowBox[{"5", " ", "\[Pi]"}], "3"], 
     FractionBox[
      RowBox[{"5", " ", "\[Pi]"}], "6"]},
    {
     RowBox[{"2", " ", "\[Pi]"}], 
     RowBox[{"2", " ", "\[Pi]"}]}
   },
   AutoDelete->False,
   BaseStyle->{"Menu"},
   GridBoxAlignment->{"Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       AbsoluteThickness[1.5], None, 
       AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
     "RowsIndexed" -> {2 -> Directive[
         AbsoluteThickness[1.5]], 1 -> Directive[
         AbsoluteThickness[1.5]], -1 -> Directive[
         AbsoluteThickness[1.5]]}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
  "Grid"]], "Output",
 ImageSize->{131, 200},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->533762238]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Building an Understanding of Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/BuildingAnUnderstandingOfFunctions"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->709637790],

Cell[TextData[ButtonBox["Understanding Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], "MoreAbout",
 CellID->1429126867]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Exact - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 26, 31.4248624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "Exact is a possible value for the option FunctionValues giving function \
values as exact numbers.", "synonyms" -> {}, "title" -> "Exact", 
    "titlemodifier" -> "", "windowtitle" -> "Exact", "type" -> "Symbol", 
    "uri" -> "ClassroomUtilities/ref/Exact"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5513, 170, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->63033050]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 12452, 388}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[598, 21, 2890, 67, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3513, 92, 48, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3564, 95, 540, 15, 85, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4141, 115, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->203403784],
Cell[CellGroupData[{
Cell[4775, 137, 102, 3, 70, "Input",
 CellID->1318904010],
Cell[4880, 142, 158, 5, 36, "Output",
 CellID->493491736]
}, Open  ]],
Cell[5053, 150, 271, 9, 70, "Notes",
 CellID->1067943069],
Cell[5327, 161, 149, 4, 70, "Notes",
 CellID->1829688383]
}, Closed]],
Cell[CellGroupData[{
Cell[5513, 170, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->63033050],
Cell[CellGroupData[{
Cell[6027, 188, 194, 6, 31, "ExampleSection",
 CellID->38380114],
Cell[6224, 196, 128, 3, 28, "Input",
 CellID->1754311688],
Cell[CellGroupData[{
Cell[6377, 203, 385, 11, 28, "Input",
 CellID->1913550553],
Cell[6765, 216, 2212, 66, 221, "Output",
 CellID->533762238]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9038, 289, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[9489, 304, 211, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[9737, 314, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[10188, 329, 171, 4, 70, "MoreAbout",
 CellID->709637790],
Cell[10362, 335, 180, 4, 70, "MoreAbout",
 CellID->1429126867]
}, Open  ]],
Cell[10557, 342, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

