(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     17176,        516]
NotebookOptionsPosition[     13629,        407]
NotebookOutlinePosition[     15764,        464]
CellTagsIndexPosition[     15679,        459]
WindowTitle->FiveNumberSummary - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Visualizing Statistical Concepts\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Classroom Utilities/ref/FiveNumberSummary\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/FiveNumberSummary"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/FiveNumberSummary.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/FiveNumberSummary", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["FiveNumberSummary", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FiveNumberSummary", "[", 
       StyleBox["lis", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]returns the list ",
     Cell[BoxData[
      RowBox[{"{", 
       RowBox[{
        StyleBox["min", "TI"], ",", " ", 
        StyleBox["quartiles", "TI"], ",", " ", 
        StyleBox["max", "TI"]}], "}"}]], "InlineFormula"],
     " for the vector ",
     Cell[BoxData[
      StyleBox["lis", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->23495257],

Cell["\<\
Quartiles are the twenty-fifth, and seventy-fifth quantiles together with the \
median.\
\>", "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The vector ",
 Cell[BoxData[
  StyleBox["lis", "TI"]], "InlineFormula"],
 " should contain at least five elements."
}], "Notes",
 CellID->144495242],

Cell["\<\
FiveNumberSummary[lis] is equivalent to Quantiles[lis, {0,1/4, 1/2 , 3/4, 1}].\
\>", "Notes",
 CellID->1875011184]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->157181877],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->200891834],

Cell["This loads the package.", "ExampleText",
 CellID->308019921],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1455222977],

Cell["Give a five number summary for a data set.", "ExampleText",
 CellID->241318756],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"ChiSquareDistribution", "[", "5", "]"}], ",", "50"}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1324139504],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FiveNumberSummary", "[", "data", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1904945335],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "0.12158943033926967`", ",", "3.219141213501596`", ",", 
   "4.1678436925362465`", ",", "5.456385404677993`", ",", 
   "18.872935278995868`"}], "}"}]], "Output",
 ImageSize->{314, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->439609867]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"BoxWhiskerChart", "[", "data", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1179288989],

Cell[BoxData[
 GraphicsBox[{
   {Opacity[0], 
    PointBox[{{0.4163731656936597, -0.8159778620935603}, {1.5836268343063402`,
      19.8105025714287}}]}, 
   {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
    EdgeForm[None], {}, 
    {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
     EdgeForm[None], 
     {RGBColor[0.798413061722744, 0.824719615472648, 0.968322270542458], 
      EdgeForm[None], 
      TagBox[
       TooltipBox[
        DynamicBox[{
          FEPrivate`If[
           CurrentValue["MouseOver"], 
           EdgeForm[{
             GrayLevel[0.5], 
             AbsoluteThickness[1.5], 
             Opacity[0.66]}], {}, {}], 
          GraphicsGroupBox[{Antialiasing -> False, 
            
            PolygonBox[{{0.8039430656936596, 5.456385404677993}, {
             1.1960569343063403`, 5.456385404677993}, {1.1960569343063403`, 
             3.219141213501596}, {0.8039430656936596, 
             3.219141213501596}}], {}, {{}, {}}, {}, {
             GrayLevel[0], 
             GrayLevel[1], 
             
             LineBox[{{1.1960569343063403`, 4.1678436925362465`}, {
              0.8039430656936597, 4.1678436925362465`}}]}, {}, {
             GrayLevel[0], 
             GrayLevel[0.5], 
             
             LineBox[{{{1., 3.219141213501596}, {1., 
              0.12158943033926967`}}, {{1., 5.456385404677993}, {1., 
              18.872935278995868`}}}]}, {
             GrayLevel[0], 
             GrayLevel[0.5], 
             
             LineBox[{{{1.0980284671531702`, 0.12158943033926967`}, {
              0.9019715328468298, 0.12158943033926967`}}, {{
              1.0980284671531702`, 18.872935278995868`}, {0.9019715328468298, 
              18.872935278995868`}}}]}, {}}]},
         ImageSizeCache->{{67.58578643762691, 
          124.4142135623731}, {-48.41421356237309, 44.41421356237309}}],
        TagBox[
         GridBox[{{
            StyleBox["\"max\"", Bold, StripOnInput -> False], 
            "18.872935278995868`"}, {
            StyleBox["\"75%\"", Bold, StripOnInput -> False], 
            "5.456385404677993`"}, {
            StyleBox["\"median\"", Bold, StripOnInput -> False], 
            "4.1678436925362465`"}, {
            StyleBox["\"25%\"", Bold, StripOnInput -> False], 
            "3.219141213501596`"}, {
            StyleBox["\"min\"", Bold, StripOnInput -> False], 
            "0.12158943033926967`"}}, 
          GridBoxAlignment -> {"Columns" -> {Center, ".", {Left}}}, 
          AutoDelete -> False, GridBoxDividers -> {"Columns" -> {
              Directive[
               GrayLevel[0.3]], {
               Directive[
                GrayLevel[0.3]]}, 
              Directive[
               GrayLevel[0.3]]}, "Rows" -> {
              Directive[
               GrayLevel[0.3]], {
               Directive[
                GrayLevel[0.3]]}, 
              Directive[
               GrayLevel[0.3]]}}, 
          GridBoxFrame -> {
           "ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> GrayLevel[0]}}, 
          GridBoxItemSize -> {
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, BaseStyle -> 
          Directive[
            AbsoluteThickness[1], 
            Dashing[{}]]], "Grid"]],
       Annotation[#, 
        Grid[{{
           Style["max", Bold], 18.872935278995868`}, {
           Style["75%", Bold], 5.456385404677993}, {
           Style["median", Bold], 4.1678436925362465`}, {
           Style["25%", Bold], 3.219141213501596}, {
           Style["min", Bold], 0.12158943033926967`}}, Dividers -> {{
            Directive[
             GrayLevel[0.3]], {
             Directive[
              GrayLevel[0.3]]}, 
            Directive[
             GrayLevel[0.3]]}, {
            Directive[
             GrayLevel[0.3]], {
             Directive[
              GrayLevel[0.3]]}, 
            Directive[
             GrayLevel[0.3]]}}, Alignment -> {{Center, ".", {Left}}}, Frame -> 
         GrayLevel[0], BaseStyle -> Directive[
           AbsoluteThickness[1], 
           Dashing[{}]]], 
        "Tooltip"]& ]}}, {}, {}}, {{{{{{}, {}}, {}}, {}}, {}}, {}}, {}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->{False, False},
  Frame->True,
  FrameTicks->{{Automatic, Automatic}, {{{0.8039430656936596, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[0]], TraditionalForm], {0, 0}}, {1.1960569343063403`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[0]], TraditionalForm], {0, 0}}, {1., 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[0]], TraditionalForm], {0.008, 0}}}, {{0.8039430656936596, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[0]], TraditionalForm], {0, 0}}, {1.1960569343063403`, 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[0]], TraditionalForm], {0, 0}}, {1., 
       FormBox[
        InterpretationBox[
         StyleBox[
          GraphicsBox[{}, ImageSize -> {0, 0}, BaselinePosition -> Baseline], 
          "CacheGraphics" -> False], 
         Spacer[0]], TraditionalForm], {0.008, 0}}}}},
  PlotRangePadding->Scaled[0.02],
  Ticks->{None, Automatic}]], "Output",
 ImageSize->{184, 112},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1183459960]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["RELATED DEMONSTRATIONS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "RelatedDemonstrationsSection",
 CellID->1268215905],

Cell[TextData[StyleBox[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"],
 FontWeight->"Bold"]], "Tutorials",
 CellID->1137933410]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"FiveNumberSummary - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 26, 38.8816624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "FiveNumberSummary[lis] returns the list {min, quartiles, max} for the \
vector lis.", "synonyms" -> {}, "title" -> "FiveNumberSummary", 
    "titlemodifier" -> "", "windowtitle" -> "FiveNumberSummary", "type" -> 
    "Symbol", "uri" -> "Classroom Utilities/ref/FiveNumberSummary"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5012, 154, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->157181877]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15536, 452}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[610, 21, 2508, 57, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3143, 82, 60, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3206, 85, 692, 22, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3935, 112, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->23495257],
Cell[4546, 132, 133, 4, 70, "Notes",
 CellID->1067943069],
Cell[4682, 138, 166, 6, 70, "Notes",
 CellID->144495242],
Cell[4851, 146, 124, 3, 70, "Notes",
 CellID->1875011184]
}, Closed]],
Cell[CellGroupData[{
Cell[5012, 154, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->157181877],
Cell[CellGroupData[{
Cell[5527, 172, 195, 6, 31, "ExampleSection",
 CellID->200891834],
Cell[5725, 180, 66, 1, 32, "ExampleText",
 CellID->308019921],
Cell[5794, 183, 128, 3, 28, "Input",
 CellID->1455222977],
Cell[5925, 188, 85, 1, 32, "ExampleText",
 CellID->241318756],
Cell[6013, 191, 235, 8, 28, "Input",
 CellID->1324139504],
Cell[CellGroupData[{
Cell[6273, 203, 117, 3, 28, "Input",
 CellID->1904945335],
Cell[6393, 208, 334, 10, 36, "Output",
 CellID->439609867]
}, Open  ]],
Cell[CellGroupData[{
Cell[6764, 223, 115, 3, 28, "Input",
 CellID->1179288989],
Cell[6882, 228, 5964, 148, 133, "Output",
 CellID->1183459960]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12907, 383, 445, 12, 70, "RelatedDemonstrationsSection",
 CellID->1268215905],
Cell[13355, 397, 232, 5, 70, "Tutorials",
 CellID->1137933410]
}, Open  ]],
Cell[13602, 405, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

