(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     51730,       1746]
NotebookOptionsPosition[     44970,       1532]
NotebookOutlinePosition[     47492,       1594]
CellTagsIndexPosition[     47406,       1589]
WindowTitle->FunctionTable - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Grid\"\>":>Documentation`HelpLookup[
       "paclet:ref/Grid"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Understanding Functions\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/FunctionTable\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/FunctionTable"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/FunctionTable.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/FunctionTable", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["FunctionTable", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FunctionTable", "[", 
       RowBox[{
        StyleBox["fun", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], 
          StyleBox[",", "TI"], 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min",
            FontSlant->"Italic"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]], ",", 
          StyleBox["incr", "TI"]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]creates a table of discrete values for the function fun \
with the independent variable x running from ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["min", "TI"]]], "InlineFormula"],
     " to ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["max", "TI"]]], "InlineFormula"],
     " in increments of incr. "
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FunctionTable", "[", 
       RowBox[{
        StyleBox["fun", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          RowBox[{"{", 
           RowBox[{
            SubscriptBox[
             StyleBox["val", "TI"], 
             StyleBox["1", "TR"]], ",", 
            SubscriptBox[
             StyleBox["val", "TI"], 
             StyleBox["2", "TR"]], ",", "\[Ellipsis]", ",", 
            StyleBox["valn", "TI"]}], "}"}]}], "}"}]}], "]"}]], 
      "InlineFormula"],
     "\[LineSeparator]creates a table of discrete values for the function fun \
with the independent variable x taking on the values ",
     Cell[BoxData[
      RowBox[{
       SubscriptBox[
        StyleBox["val", "TI"], 
        StyleBox["1", "TR"]], ",", " ", 
       SubscriptBox[
        StyleBox["val", "TI"], 
        StyleBox["2", "TR"]]}]], "InlineFormula"],
     ",\[Ellipsis],",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["val", "TI"], 
       StyleBox["n", "TI"]]], "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"FunctionTable", "[", 
       RowBox[{
        StyleBox["fun", "TI"], ",", 
        StyleBox["vals", "TI"], ",", 
        StyleBox["exclusions", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]creates a table in which the cells specified in \
exclusions are left empty."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->307950609],

Cell["\<\
The function can be given by name or as an algebraic expression.\
\>", "ExampleText",
 CellID->1536501403],

Cell["\<\
If exclusions are specified as a single list values are omitted in the second \
column of the table.\
\>", "ExampleText",
 CellID->63332935],

Cell["\<\
If exclusions are specified as a list of list values in both columns can be \
left out of the table.\
\>", "ExampleText",
 CellID->1432233280],

Cell["", "ExampleText",
 CellID->488225046],

Cell["\<\
FunctionTable will accept any options for Grid with the following additions: \
\>", "Notes"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["FunctionValues",
     BaseStyle->"Link",
     ButtonData->"paclet:UnderstandingFunctions/ref/FunctionValues"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[{
     "determine",
     " ",
     "how",
     " ",
     "the",
     " ",
     "function",
     " ",
     "values",
     " ",
     "are",
     " ",
     "rendered",
     " ",
     "in\nin",
     " ",
     "the",
     " ",
     "table.Permissible",
     " ",
     "values",
     " ",
     "are",
     " ",
     Cell[BoxData[
      ButtonBox["Automatice",
       BaseStyle->"Link",
       ButtonData->"paclet:ref/Automatice"]], "InlineFormula"],
     " ",
     "giving",
     " ",
     "machine",
     " ",
     "numbers",
     " ",
     "and",
     " ",
     Cell[BoxData[
      ButtonBox["Exact",
       BaseStyle->"Link",
       ButtonData->"paclet:UnderstandingFunctions/ref/Exact"]], 
      "InlineFormula"],
     " ",
     "giving",
     " ",
     "exact",
     " ",
     "values",
     " ",
     "for",
     " ",
     "the",
     " ",
     "function",
     " ",
     "values",
     " ",
     "in\nthe",
     " ",
     "table."
    }], "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["TableHeadings",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/TableHeadings"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[
    "set the headings for the table", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}},
 CellID->1801842428]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->409624630],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->87194519],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->400537737],

Cell["\<\
Define a function and create a table of values for that function.\
\>", "ExampleText",
 CellID->1623996061],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", " ", 
  RowBox[{
   SuperscriptBox["x", "2"], 
   RowBox[{"Sin", "[", 
    RowBox[{"2", " ", "x"}], "]"}]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->2132127504],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionTable", "[", 
  RowBox[{
   RowBox[{"f", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "10"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1754825886],

Cell[BoxData[
 TagBox[GridBox[{
    {
     ItemBox["x",
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False], 
     ItemBox[
      InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`f\\), \
TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`\\(x\\^2\\\\ \
\\(\\(sin(\\(\\(2\\\\ x\\)\\))\\)\\)\\)\\), TraditionalForm, Rule[Editable, \
True]]\\)\"\>",
       StringForm["`3`(`2`) = `1`", 
        TraditionalForm[$CellContext`x^2 Sin[2 $CellContext`x]], 
        TraditionalForm[$CellContext`x], 
        TraditionalForm[$CellContext`f]],
       Editable->False],
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False]},
    {"0", 
     TagBox[
      InterpretationBox["\<\"0.\"\>",
       0.,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"1", 
     TagBox[
      InterpretationBox["\<\"0.9093\"\>",
       0.9092974268256817,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"2", 
     TagBox[
      InterpretationBox["\<\"-3.0272\"\>",
       -3.027209981231713,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"3", 
     TagBox[
      InterpretationBox["\<\"-2.5147\"\>",
       -2.5147394837903327`,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"4", 
     TagBox[
      InterpretationBox["\<\"15.83\"\>",
       15.829731945974109`,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"5", 
     TagBox[
      InterpretationBox["\<\"-13.601\"\>",
       -13.600527772234248`,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"6", 
     TagBox[
      InterpretationBox["\<\"-19.317\"\>",
       -19.31662504801566,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"7", 
     TagBox[
      InterpretationBox["\<\"48.54\"\>",
       48.53976042904865,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"8", 
     TagBox[
      InterpretationBox["\<\"-18.426\"\>",
       -18.42581226656418,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"9", 
     TagBox[
      InterpretationBox["\<\"-60.83\"\>",
       -60.82996698850576,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"10", 
     TagBox[
      InterpretationBox["\<\"91.295\"\>",
       91.29452507276277,
       AutoDelete->True],
      NumberForm[#, 5]& ]}
   },
   AutoDelete->False,
   BaseStyle->{"Menu"},
   GridBoxAlignment->{"Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       AbsoluteThickness[1.5], None, 
       AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
     "RowsIndexed" -> {2 -> Directive[
         AbsoluteThickness[1.5]], 1 -> Directive[
         AbsoluteThickness[1.5]], -1 -> Directive[
         AbsoluteThickness[1.5]]}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
  "Grid"]], "Output",
 ImageSize->{164, 235},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->557320120]
}, Open  ]],

Cell["Specify the function explicitly.", "ExampleText",
 CellID->1561067059],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionTable", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sin", "[", "x", "]"}], "/", "x"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "\[Pi]", ",", 
     RowBox[{"\[Pi]", "/", "6"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1046345214],

Cell[BoxData[
 RowBox[{
  RowBox[{"Power", "::", "\<\"infy\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Infinite expression \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(1\\/0\\), \\\"MT\\\"]\\)\
\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" encountered.\\\\\\\"\\\", \
\\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", \
ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/infy\\\", ButtonNote -> \
\\\"Power::infy\\\"]\\)\"\>"}]], "Message", "MSG",
 CellLabel->"During evaluation of In[4]:=",
 CellID->1703072273],

Cell[BoxData[
 RowBox[{
  RowBox[{"\[Infinity]", "::", "\<\"indet\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"Indeterminate expression \\\\\\\"\\\
\", \\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(0\\\\ ComplexInfinity\\), \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" encountered.\\\\\\\"\\\
\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\[RightSkeleton]\\\", ButtonStyle->\
\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/General/indet\\\", ButtonNote -> \
\\\"Infinity::indet\\\"]\\)\"\>"}]], "Message", "MSG",
 CellLabel->"During evaluation of In[4]:=",
 CellID->1873645095],

Cell[BoxData[
 TagBox[GridBox[{
    {
     ItemBox["x",
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False], 
     ItemBox[
      InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`\\\"\\\\[\
ScriptF]\\\"\\), TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`\\(sin(x)\\)\
\\/x\\), TraditionalForm, Rule[Editable, True]]\\)\"\>",
       StringForm["`3`(`2`) = `1`", 
        TraditionalForm[$CellContext`x^(-1) Sin[$CellContext`x]], 
        TraditionalForm[$CellContext`x], 
        TraditionalForm["\[ScriptF]"]],
       Editable->False],
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False]},
    {"0", 
     TagBox["Indeterminate",
      NumberForm[#, 5]& ]},
    {
     FractionBox["\[Pi]", "6"], 
     TagBox[
      InterpretationBox["\<\"0.95493\"\>",
       0.954929658551372,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {
     FractionBox["\[Pi]", "3"], 
     TagBox[
      InterpretationBox["\<\"0.82699\"\>",
       0.8269933431326881,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {
     FractionBox["\[Pi]", "2"], 
     TagBox[
      InterpretationBox["\<\"0.63662\"\>",
       0.6366197723675814,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {
     FractionBox[
      RowBox[{"2", " ", "\[Pi]"}], "3"], 
     TagBox[
      InterpretationBox["\<\"0.4135\"\>",
       0.41349667156634407`,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {
     FractionBox[
      RowBox[{"5", " ", "\[Pi]"}], "6"], 
     TagBox[
      InterpretationBox["\<\"0.19099\"\>",
       0.19098593171027442`,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"\[Pi]", 
     TagBox[
      InterpretationBox["\<\"0.\"\>",
       0.,
       AutoDelete->True],
      NumberForm[#, 5]& ]}
   },
   AutoDelete->False,
   BaseStyle->{"Menu"},
   GridBoxAlignment->{"Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       AbsoluteThickness[1.5], None, 
       AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
     "RowsIndexed" -> {2 -> Directive[
         AbsoluteThickness[1.5]], 1 -> Directive[
         AbsoluteThickness[1.5]], -1 -> Directive[
         AbsoluteThickness[1.5]]}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
  "Grid"]], "Output",
 ImageSize->{153, 217},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1800395704]
}, Open  ]],

Cell["Give a list of values at which to evaluate the function.", "ExampleText",
 CellID->941821422],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionTable", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Sin", "[", "x", "]"}], "/", "x"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"\[Pi]", "/", "6"}], ",", 
       RowBox[{"\[Pi]", "/", "4"}], ",", 
       RowBox[{"\[Pi]", "/", "3"}], ",", 
       RowBox[{"\[Pi]", "/", "2"}]}], "}"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->90677517],

Cell[BoxData[
 TagBox[GridBox[{
    {
     ItemBox["x",
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False], 
     ItemBox[
      InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`\\\"\\\\[\
ScriptF]\\\"\\), TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`\\(sin(x)\\)\
\\/x\\), TraditionalForm, Rule[Editable, True]]\\)\"\>",
       StringForm["`3`(`2`) = `1`", 
        TraditionalForm[$CellContext`x^(-1) Sin[$CellContext`x]], 
        TraditionalForm[$CellContext`x], 
        TraditionalForm["\[ScriptF]"]],
       Editable->False],
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False]},
    {
     FractionBox["\[Pi]", "6"], 
     TagBox[
      InterpretationBox["\<\"0.95493\"\>",
       0.954929658551372,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {
     FractionBox["\[Pi]", "4"], 
     TagBox[
      InterpretationBox["\<\"0.90032\"\>",
       0.9003163161571062,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {
     FractionBox["\[Pi]", "3"], 
     TagBox[
      InterpretationBox["\<\"0.82699\"\>",
       0.8269933431326881,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {
     FractionBox["\[Pi]", "2"], 
     TagBox[
      InterpretationBox["\<\"0.63662\"\>",
       0.6366197723675814,
       AutoDelete->True],
      NumberForm[#, 5]& ]}
   },
   AutoDelete->False,
   BaseStyle->{"Menu"},
   GridBoxAlignment->{"Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       AbsoluteThickness[1.5], None, 
       AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
     "RowsIndexed" -> {2 -> Directive[
         AbsoluteThickness[1.5]], 1 -> Directive[
         AbsoluteThickness[1.5]], -1 -> Directive[
         AbsoluteThickness[1.5]]}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
  "Grid"]], "Output",
 ImageSize->{140, 147},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1206010898]
}, Open  ]],

Cell["Exclude values from the second column.", "ExampleText",
 CellID->1333183609],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionTable", "[", 
  RowBox[{
   RowBox[{"f", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "4", ",", "5", ",", "8"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->2120027312],

Cell[BoxData[
 TagBox[GridBox[{
    {
     ItemBox["x",
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False], 
     ItemBox[
      InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`f\\), \
TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`\\(x\\^2\\\\ \
\\(\\(sin(\\(\\(2\\\\ x\\)\\))\\)\\)\\)\\), TraditionalForm, Rule[Editable, \
True]]\\)\"\>",
       StringForm["`3`(`2`) = `1`", 
        TraditionalForm[$CellContext`x^2 Sin[2 $CellContext`x]], 
        TraditionalForm[$CellContext`x], 
        TraditionalForm[$CellContext`f]],
       Editable->False],
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False]},
    {"0", 
     TagBox[
      InterpretationBox["\<\"0.\"\>",
       0.,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"1", "\<\"   \"\>"},
    {"2", 
     TagBox[
      InterpretationBox["\<\"-3.0272\"\>",
       -3.027209981231713,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"3", "\<\"   \"\>"},
    {"4", "\<\"   \"\>"},
    {"5", 
     TagBox[
      InterpretationBox["\<\"-13.601\"\>",
       -13.600527772234248`,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"6", 
     TagBox[
      InterpretationBox["\<\"-19.317\"\>",
       -19.31662504801566,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"7", "\<\"   \"\>"},
    {"8", 
     TagBox[
      InterpretationBox["\<\"-18.426\"\>",
       -18.42581226656418,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"9", 
     TagBox[
      InterpretationBox["\<\"-60.83\"\>",
       -60.82996698850576,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"10", 
     TagBox[
      InterpretationBox["\<\"91.295\"\>",
       91.29452507276277,
       AutoDelete->True],
      NumberForm[#, 5]& ]}
   },
   AutoDelete->False,
   BaseStyle->{"Menu"},
   GridBoxAlignment->{"Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       AbsoluteThickness[1.5], None, 
       AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
     "RowsIndexed" -> {2 -> Directive[
         AbsoluteThickness[1.5]], 1 -> Directive[
         AbsoluteThickness[1.5]], -1 -> Directive[
         AbsoluteThickness[1.5]]}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
  "Grid"]], "Output",
 ImageSize->{164, 239},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->1474502300]
}, Open  ]],

Cell["Exclude values from the first and second columns.", "ExampleText",
 CellID->909635847],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionTable", "[", 
  RowBox[{
   RowBox[{"f", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "7"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"2", ",", "4", ",", "5", ",", "8"}], "}"}]}], "}"}]}], 
  "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->313597536],

Cell[BoxData[
 TagBox[GridBox[{
    {
     ItemBox["x",
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False], 
     ItemBox[
      InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`f\\), \
TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`\\(x\\^2\\\\ \
\\(\\(sin(\\(\\(2\\\\ x\\)\\))\\)\\)\\)\\), TraditionalForm, Rule[Editable, \
True]]\\)\"\>",
       StringForm["`3`(`2`) = `1`", 
        TraditionalForm[$CellContext`x^2 Sin[2 $CellContext`x]], 
        TraditionalForm[$CellContext`x], 
        TraditionalForm[$CellContext`f]],
       Editable->False],
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False]},
    {"\<\"   \"\>", 
     TagBox[
      InterpretationBox["\<\"0.\"\>",
       0.,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"1", "\<\"   \"\>"},
    {"\<\"   \"\>", 
     TagBox[
      InterpretationBox["\<\"-3.0272\"\>",
       -3.027209981231713,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"3", "\<\"   \"\>"},
    {"4", "\<\"   \"\>"},
    {"5", 
     TagBox[
      InterpretationBox["\<\"-13.601\"\>",
       -13.600527772234248`,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"\<\"   \"\>", 
     TagBox[
      InterpretationBox["\<\"-19.317\"\>",
       -19.31662504801566,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"7", "\<\"   \"\>"},
    {"8", 
     TagBox[
      InterpretationBox["\<\"-18.426\"\>",
       -18.42581226656418,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"9", 
     TagBox[
      InterpretationBox["\<\"-60.83\"\>",
       -60.82996698850576,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"10", 
     TagBox[
      InterpretationBox["\<\"91.295\"\>",
       91.29452507276277,
       AutoDelete->True],
      NumberForm[#, 5]& ]}
   },
   AutoDelete->False,
   BaseStyle->{"Menu"},
   GridBoxAlignment->{"Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       AbsoluteThickness[1.5], None, 
       AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
     "RowsIndexed" -> {2 -> Directive[
         AbsoluteThickness[1.5]], 1 -> Directive[
         AbsoluteThickness[1.5]], -1 -> Directive[
         AbsoluteThickness[1.5]]}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
  "Grid"]], "Output",
 ImageSize->{164, 242},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->2146353367]
}, Open  ]],

Cell["Exclude values from the first column.", "ExampleText",
 CellID->542426342],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionTable", "[", 
  RowBox[{
   RowBox[{"f", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "10"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "3", ",", "7"}], "}"}], ",", 
     RowBox[{"{", "}"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->491448479],

Cell[BoxData[
 TagBox[GridBox[{
    {
     ItemBox["x",
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False], 
     ItemBox[
      InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`f\\), \
TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`\\(x\\^2\\\\ \
\\(\\(sin(\\(\\(2\\\\ x\\)\\))\\)\\)\\)\\), TraditionalForm, Rule[Editable, \
True]]\\)\"\>",
       StringForm["`3`(`2`) = `1`", 
        TraditionalForm[$CellContext`x^2 Sin[2 $CellContext`x]], 
        TraditionalForm[$CellContext`x], 
        TraditionalForm[$CellContext`f]],
       Editable->False],
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False]},
    {"\<\"   \"\>", 
     TagBox[
      InterpretationBox["\<\"0.\"\>",
       0.,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"1", 
     TagBox[
      InterpretationBox["\<\"0.9093\"\>",
       0.9092974268256817,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"\<\"   \"\>", 
     TagBox[
      InterpretationBox["\<\"-3.0272\"\>",
       -3.027209981231713,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"3", 
     TagBox[
      InterpretationBox["\<\"-2.5147\"\>",
       -2.5147394837903327`,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"4", 
     TagBox[
      InterpretationBox["\<\"15.83\"\>",
       15.829731945974109`,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"5", 
     TagBox[
      InterpretationBox["\<\"-13.601\"\>",
       -13.600527772234248`,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"\<\"   \"\>", 
     TagBox[
      InterpretationBox["\<\"-19.317\"\>",
       -19.31662504801566,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"7", 
     TagBox[
      InterpretationBox["\<\"48.54\"\>",
       48.53976042904865,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"8", 
     TagBox[
      InterpretationBox["\<\"-18.426\"\>",
       -18.42581226656418,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"9", 
     TagBox[
      InterpretationBox["\<\"-60.83\"\>",
       -60.82996698850576,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"10", 
     TagBox[
      InterpretationBox["\<\"91.295\"\>",
       91.29452507276277,
       AutoDelete->True],
      NumberForm[#, 5]& ]}
   },
   AutoDelete->False,
   BaseStyle->{"Menu"},
   GridBoxAlignment->{"Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       AbsoluteThickness[1.5], None, 
       AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
     "RowsIndexed" -> {2 -> Directive[
         AbsoluteThickness[1.5]], 1 -> Directive[
         AbsoluteThickness[1.5]], -1 -> Directive[
         AbsoluteThickness[1.5]]}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
  "Grid"]], "Output",
 ImageSize->{164, 238},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->330736863]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(2)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->75393157],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "FunctionValues",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->725890576],

Cell["\<\
In some cases it is desirable to have the function values given as exact \
numbers and not in decimal form.\
\>", "ExampleText",
 CellID->44011293],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionTable", "[", 
  RowBox[{
   SuperscriptBox["x", "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1", ",", 
     RowBox[{"1", "/", "8"}]}], "}"}], ",", 
   RowBox[{"FunctionValues", "\[Rule]", " ", "Exact"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->963426883],

Cell[BoxData[
 TagBox[GridBox[{
    {
     ItemBox["x",
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False], 
     ItemBox[
      InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`\\\"\\\\[\
ScriptF]\\\"\\), TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`x\\^2\\), \
TraditionalForm, Rule[Editable, True]]\\)\"\>",
       StringForm["`3`(`2`) = `1`", 
        TraditionalForm[$CellContext`x^2], 
        TraditionalForm[$CellContext`x], 
        TraditionalForm["\[ScriptF]"]],
       Editable->False],
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False]},
    {"0", "0"},
    {
     FractionBox["1", "8"], 
     FractionBox["1", "64"]},
    {
     FractionBox["1", "4"], 
     FractionBox["1", "16"]},
    {
     FractionBox["3", "8"], 
     FractionBox["9", "64"]},
    {
     FractionBox["1", "2"], 
     FractionBox["1", "4"]},
    {
     FractionBox["5", "8"], 
     FractionBox["25", "64"]},
    {
     FractionBox["3", "4"], 
     FractionBox["9", "16"]},
    {
     FractionBox["7", "8"], 
     FractionBox["49", "64"]},
    {"1", "1"}
   },
   AutoDelete->False,
   BaseStyle->{"Menu"},
   GridBoxAlignment->{"Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       AbsoluteThickness[1.5], None, 
       AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
     "RowsIndexed" -> {2 -> Directive[
         AbsoluteThickness[1.5]], 1 -> Directive[
         AbsoluteThickness[1.5]], -1 -> Directive[
         AbsoluteThickness[1.5]]}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
  "Grid"]], "Output",
 ImageSize->{93, 274},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1006778005]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "TableHeadings",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->954317232],

Cell["\<\
Have students find the function rule based on the table entries. The value of \
the option should be given as a list with two elements.\
\>", "ExampleText",
 CellID->1898781049],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionTable", "[", 
  RowBox[{
   RowBox[{
    SuperscriptBox["x", "2"], "+", " ", "1"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", 
       RowBox[{"-", "1"}], ",", "0", ",", "2", ",", "4", ",", "6"}], "}"}]}], 
    "}"}], ",", 
   RowBox[{"FunctionValues", "\[Rule]", " ", "Exact"}], ",", 
   RowBox[{"TableHeadings", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Style", "[", 
       RowBox[{"\"\<\[ScriptX]\>\"", ",", "14", ",", "Bold"}], "]"}], ",", 
      "None"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1206096123],

Cell[BoxData[
 TagBox[GridBox[{
    {
     StyleBox["\<\"\[ScriptX]\"\>",
      StripOnInput->False,
      FontSize->14,
      FontWeight->Bold], "\<\"            \"\>"},
    {
     RowBox[{"-", "2"}], "5"},
    {
     RowBox[{"-", "1"}], "2"},
    {"0", "1"},
    {"2", "5"},
    {"4", "17"},
    {"6", "37"}
   },
   AutoDelete->False,
   BaseStyle->{"Menu"},
   GridBoxAlignment->{"Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       AbsoluteThickness[1.5], None, 
       AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
     "RowsIndexed" -> {2 -> Directive[
         AbsoluteThickness[1.5]], 1 -> Directive[
         AbsoluteThickness[1.5]], -1 -> Directive[
         AbsoluteThickness[1.5]]}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
  "Grid"]], "Output",
 ImageSize->{81, 139},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->660282875]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Possible Issues",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373],

Cell["\<\
If the function definition or the point values contain machine numbers the \
table will not list exact values.\
\>", "ExampleText",
 CellID->488520340],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionTable", "[", 
  RowBox[{
   SuperscriptBox["x", "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0.", ",", "1", ",", 
     RowBox[{"1", "/", "8"}]}], "}"}], ",", 
   RowBox[{"FunctionValues", "\[Rule]", " ", "Exact"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->731371899],

Cell[BoxData[
 TagBox[GridBox[{
    {
     ItemBox["x",
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False], 
     ItemBox[
      InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`\\\"\\\\[\
ScriptF]\\\"\\), TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`x\\^2\\), \
TraditionalForm, Rule[Editable, True]]\\)\"\>",
       StringForm["`3`(`2`) = `1`", 
        TraditionalForm[$CellContext`x^2], 
        TraditionalForm[$CellContext`x], 
        TraditionalForm["\[ScriptF]"]],
       Editable->False],
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False]},
    {"0.`", 
     TagBox[
      InterpretationBox["\<\"0.\"\>",
       0.,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"0.125`", 
     TagBox[
      InterpretationBox["\<\"0.015625\"\>",
       0.015625,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"0.25`", 
     TagBox[
      InterpretationBox["\<\"0.0625\"\>",
       0.0625,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"0.375`", 
     TagBox[
      InterpretationBox["\<\"0.14063\"\>",
       0.140625,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"0.5`", 
     TagBox[
      InterpretationBox["\<\"0.25\"\>",
       0.25,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"0.625`", 
     TagBox[
      InterpretationBox["\<\"0.39063\"\>",
       0.390625,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"0.75`", 
     TagBox[
      InterpretationBox["\<\"0.5625\"\>",
       0.5625,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"0.875`", 
     TagBox[
      InterpretationBox["\<\"0.76563\"\>",
       0.765625,
       AutoDelete->True],
      NumberForm[#, 5]& ]},
    {"1.`", 
     TagBox[
      InterpretationBox["\<\"1.\"\>",
       1.,
       AutoDelete->True],
      NumberForm[#, 5]& ]}
   },
   AutoDelete->False,
   BaseStyle->{"Menu"},
   GridBoxAlignment->{"Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       AbsoluteThickness[1.5], None, 
       AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
     "RowsIndexed" -> {2 -> Directive[
         AbsoluteThickness[1.5]], 1 -> Directive[
         AbsoluteThickness[1.5]], -1 -> Directive[
         AbsoluteThickness[1.5]]}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
  "Grid"]], "Output",
 ImageSize->{150, 197},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->894275322]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionTable", "[", 
  RowBox[{
   RowBox[{"2.0", " ", 
    SuperscriptBox["x", "2"]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1", ",", 
     RowBox[{"1", "/", "8"}]}], "}"}], ",", 
   RowBox[{"FunctionValues", "\[Rule]", " ", "Exact"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1942457324],

Cell[BoxData[
 TagBox[GridBox[{
    {
     ItemBox["x",
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False], 
     ItemBox[
      InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`\\\"\\\\[\
ScriptF]\\\"\\), TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`\\(2.`\\\\ x\
\\^2\\)\\), TraditionalForm, Rule[Editable, True]]\\)\"\>",
       StringForm["`3`(`2`) = `1`", 
        TraditionalForm[2. $CellContext`x^2], 
        TraditionalForm[$CellContext`x], 
        TraditionalForm["\[ScriptF]"]],
       Editable->False],
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False]},
    {"0", "0"},
    {
     FractionBox["1", "8"], "0.03125`"},
    {
     FractionBox["1", "4"], "0.125`"},
    {
     FractionBox["3", "8"], "0.28125`"},
    {
     FractionBox["1", "2"], "0.5`"},
    {
     FractionBox["5", "8"], "0.78125`"},
    {
     FractionBox["3", "4"], "1.125`"},
    {
     FractionBox["7", "8"], "1.53125`"},
    {"1", "2.`"}
   },
   AutoDelete->False,
   BaseStyle->{"Menu"},
   GridBoxAlignment->{"Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       AbsoluteThickness[1.5], None, 
       AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
     "RowsIndexed" -> {2 -> Directive[
         AbsoluteThickness[1.5]], 1 -> Directive[
         AbsoluteThickness[1.5]], -1 -> Directive[
         AbsoluteThickness[1.5]]}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
  "Grid"]], "Output",
 ImageSize->{138, 274},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1994775148]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[StyleBox[ButtonBox["Grid",
 BaseStyle->"Link",
 ButtonData->"paclet:ref/Grid"],
 FontFamily->"Verdana"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Building an Understanding of Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/BuildingAnUnderstandingOfFunctions"]], \
"ExampleText",
 CellID->444667396]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->434237547],

Cell[TextData[ButtonBox["Understanding Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], "MoreAbout",
 CellID->196858833]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"FunctionTable - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 27, 3.2800624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "FunctionTable[fun, {x, x_min, x_max, incr}] creates a table of discrete \
values for the function fun with the independent variable x running from \
x_min to x_max in increments of incr. FunctionTable[fun, {x, {val_1, val_2, \
..., valn}}] creates a table of discrete values for the function fun with the \
independent variable x taking on the values val_1, \
val_2,...,val_n.FunctionTable[fun, vals, exclusions] creates a table in which \
the cells specified in exclusions are left empty.", "synonyms" -> {}, "title" -> 
    "FunctionTable", "titlemodifier" -> "", "windowtitle" -> "FunctionTable", 
    "type" -> "Symbol", "uri" -> "ClassroomUtilities/ref/FunctionTable"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9142, 310, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->409624630]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 47263, 1582}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[606, 21, 2827, 65, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3458, 90, 56, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3517, 93, 2581, 80, 235, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[6135, 178, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->307950609],
Cell[6747, 198, 116, 3, 70, "ExampleText",
 CellID->1536501403],
Cell[6866, 203, 150, 4, 70, "ExampleText",
 CellID->63332935],
Cell[7019, 209, 152, 4, 70, "ExampleText",
 CellID->1432233280],
Cell[7174, 215, 43, 1, 70, "ExampleText",
 CellID->488225046],
Cell[7220, 218, 102, 2, 70, "Notes"],
Cell[7325, 222, 1780, 83, 70, "3ColumnTableMod",
 CellID->1801842428]
}, Closed]],
Cell[CellGroupData[{
Cell[9142, 310, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->409624630],
Cell[CellGroupData[{
Cell[9657, 328, 194, 6, 31, "ExampleSection",
 CellID->87194519],
Cell[9854, 336, 127, 3, 28, "Input",
 CellID->400537737],
Cell[9984, 341, 117, 3, 32, "ExampleText",
 CellID->1623996061],
Cell[10104, 346, 227, 8, 28, "Input",
 CellID->2132127504],
Cell[CellGroupData[{
Cell[10356, 358, 222, 7, 28, "Input",
 CellID->1754825886],
Cell[10581, 367, 3221, 108, 256, "Output",
 CellID->557320120]
}, Open  ]],
Cell[13817, 478, 76, 1, 70, "ExampleText",
 CellID->1561067059],
Cell[CellGroupData[{
Cell[13918, 483, 292, 9, 70, "Input",
 CellID->1046345214],
Cell[14213, 494, 588, 11, 70, "Message",
 CellID->1703072273],
Cell[14804, 507, 621, 11, 70, "Message",
 CellID->1873645095],
Cell[15428, 520, 2734, 87, 238, "Output",
 CellID->1800395704]
}, Open  ]],
Cell[18177, 610, 99, 1, 70, "ExampleText",
 CellID->941821422],
Cell[CellGroupData[{
Cell[18301, 615, 437, 14, 70, "Input",
 CellID->90677517],
Cell[18741, 631, 2302, 69, 168, "Output",
 CellID->1206010898]
}, Open  ]],
Cell[21058, 703, 82, 1, 70, "ExampleText",
 CellID->1333183609],
Cell[CellGroupData[{
Cell[21165, 708, 301, 9, 70, "Input",
 CellID->2120027312],
Cell[21469, 719, 2737, 88, 260, "Output",
 CellID->1474502300]
}, Open  ]],
Cell[24221, 810, 92, 1, 70, "ExampleText",
 CellID->909635847],
Cell[CellGroupData[{
Cell[24338, 815, 419, 14, 70, "Input",
 CellID->313597536],
Cell[24760, 831, 2767, 88, 263, "Output",
 CellID->2146353367]
}, Open  ]],
Cell[27542, 922, 80, 1, 70, "ExampleText",
 CellID->542426342],
Cell[CellGroupData[{
Cell[27647, 927, 364, 12, 70, "Input",
 CellID->491448479],
Cell[28014, 941, 3251, 108, 259, "Output",
 CellID->330736863]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31314, 1055, 268, 8, 70, "ExampleSection",
 CellID->75393157],
Cell[CellGroupData[{
Cell[31607, 1067, 285, 8, 70, "ExampleSubsection",
 CellID->725890576],
Cell[31895, 1077, 157, 4, 70, "ExampleText",
 CellID->44011293],
Cell[CellGroupData[{
Cell[32077, 1085, 314, 9, 70, "Input",
 CellID->963426883],
Cell[32394, 1096, 2052, 64, 295, "Output",
 CellID->1006778005]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[34495, 1166, 284, 8, 70, "ExampleSubsection",
 CellID->954317232],
Cell[34782, 1176, 187, 4, 70, "ExampleText",
 CellID->1898781049],
Cell[CellGroupData[{
Cell[34994, 1184, 656, 20, 70, "Input",
 CellID->1206096123],
Cell[35653, 1206, 1101, 35, 160, "Output",
 CellID->660282875]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[36815, 1248, 278, 8, 70, "ExampleSection",
 CellID->1305812373],
Cell[37096, 1258, 161, 4, 70, "ExampleText",
 CellID->488520340],
Cell[CellGroupData[{
Cell[37282, 1266, 315, 9, 70, "Input",
 CellID->731371899],
Cell[37600, 1277, 2807, 95, 218, "Output",
 CellID->894275322]
}, Open  ]],
Cell[CellGroupData[{
Cell[40444, 1377, 342, 10, 70, "Input",
 CellID->1942457324],
Cell[40789, 1389, 1937, 57, 295, "Output",
 CellID->1994775148]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[42787, 1453, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[43236, 1468, 150, 4, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[43423, 1477, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[43874, 1492, 213, 5, 70, "ExampleText",
 CellID->444667396]
}, Open  ]],
Cell[CellGroupData[{
Cell[44124, 1502, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[44575, 1517, 171, 4, 70, "MoreAbout",
 CellID->434237547],
Cell[44749, 1523, 179, 4, 70, "MoreAbout",
 CellID->196858833]
}, Open  ]],
Cell[44943, 1530, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

