(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     12167,        380]
NotebookOptionsPosition[      9050,        289]
NotebookOutlinePosition[     11327,        348]
CellTagsIndexPosition[     11242,        343]
WindowTitle->FunctionValues - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Understanding Functions\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/FunctionValues\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/FunctionValues"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/FunctionValues.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/FunctionValues", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["FunctionValues", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["FunctionValues"], "InlineFormula"],
     "\[LineSeparator]is an option for ",
     Cell[BoxData[
      ButtonBox["FunctionTable",
       BaseStyle->"Link",
       ButtonData->"paclet:UnderstandingFunctions/ref/FunctionTable"]], 
      "InlineFormula"],
     " that determines how the function values are rendered In the table. \
Permissible values are Automatic giving machine numbers and ",
     Cell[BoxData[
      ButtonBox["Exact",
       BaseStyle->"Link",
       ButtonData->"paclet:UnderstandingFunctions/ref/Exact"]], 
      "InlineFormula"],
     " giving exact values for the function values in the table."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->71970370],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->142791963],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->444701876],

Cell["Display a table of exact values for a function.", "ExampleText",
 CellID->861338372],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionTable", "[", 
  RowBox[{
   RowBox[{"Cos", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", 
     RowBox[{"2", " ", "\[Pi]"}], ",", 
     RowBox[{"\[Pi]", "/", "6"}]}], "}"}], ",", 
   RowBox[{"FunctionValues", "\[Rule]", " ", "Exact"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->326753777],

Cell[BoxData[
 TagBox[GridBox[{
    {
     ItemBox["x",
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False], 
     ItemBox[
      InterpretationBox["\<\"\\!\\(\\*TagBox[\\(TraditionalForm\\`\\\"\\\\[\
ScriptF]\\\"\\), TraditionalForm, Rule[Editable, \
True]]\\)(\\!\\(\\*TagBox[\\(TraditionalForm\\`x\\), TraditionalForm, \
Rule[Editable, True]]\\)) = \\!\\(\\*TagBox[\\(TraditionalForm\\`\\(cos(x)\\)\
\\), TraditionalForm, Rule[Editable, True]]\\)\"\>",
       StringForm["`3`(`2`) = `1`", 
        TraditionalForm[
         Cos[$CellContext`x]], 
        TraditionalForm[$CellContext`x], 
        TraditionalForm["\[ScriptF]"]],
       Editable->False],
      Alignment->Center,
      BaseStyle->{FontWeight -> "Bold"},
      StripOnInput->False]},
    {"0", "1"},
    {
     FractionBox["\[Pi]", "6"], 
     FractionBox[
      SqrtBox["3"], "2"]},
    {
     FractionBox["\[Pi]", "3"], 
     FractionBox["1", "2"]},
    {
     FractionBox["\[Pi]", "2"], "0"},
    {
     FractionBox[
      RowBox[{"2", " ", "\[Pi]"}], "3"], 
     RowBox[{"-", 
      FractionBox["1", "2"]}]},
    {
     FractionBox[
      RowBox[{"5", " ", "\[Pi]"}], "6"], 
     RowBox[{"-", 
      FractionBox[
       SqrtBox["3"], "2"]}]},
    {"\[Pi]", 
     RowBox[{"-", "1"}]},
    {
     FractionBox[
      RowBox[{"7", " ", "\[Pi]"}], "6"], 
     RowBox[{"-", 
      FractionBox[
       SqrtBox["3"], "2"]}]},
    {
     FractionBox[
      RowBox[{"4", " ", "\[Pi]"}], "3"], 
     RowBox[{"-", 
      FractionBox["1", "2"]}]},
    {
     FractionBox[
      RowBox[{"3", " ", "\[Pi]"}], "2"], "0"},
    {
     FractionBox[
      RowBox[{"5", " ", "\[Pi]"}], "3"], 
     FractionBox["1", "2"]},
    {
     FractionBox[
      RowBox[{"11", " ", "\[Pi]"}], "6"], 
     FractionBox[
      SqrtBox["3"], "2"]},
    {
     RowBox[{"2", " ", "\[Pi]"}], "1"}
   },
   AutoDelete->False,
   BaseStyle->{"Menu"},
   GridBoxAlignment->{"Columns" -> {Left, "."}, "Rows" -> {{Automatic}}},
   GridBoxBackground->{"Columns" -> {{
        RGBColor[1, 1, 0.85]}}},
   GridBoxDividers->{"Columns" -> {
       AbsoluteThickness[1.5], None, 
       AbsoluteThickness[1.5]}, "Rows" -> {{True}}, 
     "RowsIndexed" -> {2 -> Directive[
         AbsoluteThickness[1.5]], 1 -> Directive[
         AbsoluteThickness[1.5]], -1 -> Directive[
         AbsoluteThickness[1.5]]}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
   GridBoxSpacings->{"Columns" -> {{1}}, "Rows" -> {{0.62}}}],
  "Grid"]], "Output",
 ImageSize->{125, 408},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1818699119]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->2931318],

Cell[TextData[ButtonBox["Understanding Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], "MoreAbout",
 CellID->1711787989]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"FunctionValues - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 27, 6.8368624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "FunctionValues is an option for FunctionTable that determines how the \
function values are rendered In the table. Permissible values are Automatic \
giving machine numbers and Exact giving exact values for the function values \
in the table.", "synonyms" -> {}, "title" -> "FunctionValues", 
    "titlemodifier" -> "", "windowtitle" -> "FunctionValues", "type" -> 
    "Symbol", "uri" -> "ClassroomUtilities/ref/FunctionValues"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4166, 114, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->71970370]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 11100, 336}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[607, 21, 2593, 59, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3225, 84, 57, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3285, 87, 844, 22, 115, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4166, 114, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->71970370],
Cell[CellGroupData[{
Cell[4680, 132, 195, 6, 31, "ExampleSection",
 CellID->142791963],
Cell[4878, 140, 127, 3, 28, "Input",
 CellID->444701876],
Cell[5008, 145, 90, 1, 32, "ExampleText",
 CellID->861338372],
Cell[CellGroupData[{
Cell[5123, 150, 354, 10, 28, "Input",
 CellID->326753777],
Cell[5480, 162, 2664, 90, 429, "Output",
 CellID->1818699119]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8205, 259, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[8656, 274, 169, 4, 70, "MoreAbout",
 CellID->2931318],
Cell[8828, 280, 180, 4, 70, "MoreAbout",
 CellID->1711787989]
}, Open  ]],
Cell[9023, 287, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

