(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     18025,        583]
NotebookOptionsPosition[     13984,        457]
NotebookOutlinePosition[     16167,        515]
CellTagsIndexPosition[     16082,        510]
WindowTitle->GetColumns - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Elementary Matrix Operations\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/ElementaryMatrixOperations"], \
"\<\"Solving Linear Systems\"\>":>Documentation`HelpLookup[
       "paclet:tutorial/SolvingLinearSystems"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AddToRow\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/AddToRow"], "\<\"MultiplyARow\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/MultiplyARow"], "\<\"SwitchRows\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/SwitchRows"], "\<\"RowReduce\"\>":>
       Documentation`HelpLookup["paclet:ref/RowReduce"], "\<\"Inverse\"\>":>
       Documentation`HelpLookup["paclet:ref/Inverse"], "\<\"LinearSolve\"\>":>
       Documentation`HelpLookup[
       "paclet:ref/LinearSolve"], "\<\"NullSpace\"\>":>
       Documentation`HelpLookup["paclet:ref/NullSpace"], "\<\"Solve\"\>":>
       Documentation`HelpLookup["paclet:ref/Solve"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], "\<\"Matrix \
Operations\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/MatrixOperations"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/GetColumns\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/GetColumns"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/GetColumns.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/GetColumns", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["GetColumns", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"GetColumns", "[", 
       RowBox[{
        StyleBox["mat", "TI"], ",", 
        StyleBox["col", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]extract the column ",
     Cell[BoxData[
      StyleBox["col", "TI"]], "InlineFormula"],
     " from the matrix ",
     Cell[BoxData[
      StyleBox["mat", "TI"]], "InlineFormula"]
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"GetColumns", "[", 
       RowBox[{"mat", ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["col", "TI"], 
           StyleBox["i", "TI"]], ",", 
          SubscriptBox[
           StyleBox["col", "TI"], 
           StyleBox["j", "TI"]], ",", 
          StyleBox["\[Ellipsis]", "TR"]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]extract the columns ",
     Cell[BoxData[
      RowBox[{
       SubscriptBox[
        StyleBox["col", "TI"], 
        StyleBox["i", "TI"]], ",", " ", 
       SubscriptBox[
        StyleBox["col", "TI"], 
        StyleBox["j", "TI"]], ",", " ", 
       StyleBox["\[Ellipsis]", "TR"], " "}]], "InlineFormula"],
     "from the matrix mat"
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->143444557],

Cell["GetColumns works with any matrix", "Notes",
 CellID->1067943069],

Cell["\<\
The column specification can be an integer or a list of integers\
\>", "Notes",
 CellID->1184510786],

Cell["GetColumns is equivalent to mat[[All, col]]", "Notes",
 CellID->899372612]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->441651142],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->187040000],

Cell["This loads the package.", "ExampleText",
 CellID->1765582298],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->212648240],

Cell["\<\
Get the third and fifth columns from a 5\[Times]8 matrix.\
\>", "ExampleText",
 CellID->566181072],

Cell[BoxData[
 RowBox[{
  RowBox[{"mat", "=", " ", 
   RowBox[{"RandomInteger", "[", 
    RowBox[{"7", ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "8"}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->305237247],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MatrixForm", "[", "mat", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1298154885],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"2", "7", "0", "4", "3", "0", "3", "2"},
     {"4", "2", "7", "2", "5", "4", "0", "2"},
     {"6", "6", "7", "0", "2", "0", "3", "0"},
     {"2", "1", "3", "4", "2", "5", "7", "6"},
     {"6", "3", "3", "0", "5", "2", "0", "2"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{136, 72},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->1802782322]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"GetColumns", "[", 
   RowBox[{"mat", ",", 
    RowBox[{"{", 
     RowBox[{"3", ",", "5"}], "}"}]}], "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1931461293],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"0", "3"},
     {"7", "5"},
     {"7", "2"},
     {"3", "2"},
     {"3", "5"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{46, 72},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//MatrixForm=",
 CellID->299533825]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["AddToRow",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/AddToRow"],
   FontFamily->"Verdana"]], "InlineFormula",
  FontSize->10],
 StyleBox[" . ",
  FontSize->10],
 Cell[BoxData[
  StyleBox[
   ButtonBox["MultiplyARow",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/MultiplyARow"],
   FontFamily->"Verdana"]], "InlineFormula",
  FontSize->10],
 StyleBox[" . ",
  FontSize->10],
 Cell[BoxData[
  StyleBox[
   ButtonBox["SwitchRows",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/SwitchRows"],
   FontFamily->"Verdana"]], "InlineFormula",
  FontSize->10],
 " . ",
 StyleBox[ButtonBox["RowReduce",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/RowReduce"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["Inverse",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Inverse"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["LinearSolve",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/LinearSolve"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["NullSpace",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/NullSpace"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["Solve",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Solve"],
  FontFamily->"Verdana"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Elementary Matrix Operations",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/ElementaryMatrixOperations"]], \
"Tutorials",
 CellID->341631938],

Cell[TextData[ButtonBox["Solving Linear Systems",
 BaseStyle->"Link",
 ButtonData->"paclet:tutorial/SolvingLinearSystems"]], "Tutorials",
 CellID->234584586]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->453312724],

Cell[TextData[ButtonBox["Matrix Operations",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/MatrixOperations"]], "MoreAbout",
 CellID->781943908]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"GetColumns - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 27, 10.6432624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "GetColumns[mat, col] extract the column col from the matrix \
matGetColumns[mat, {col_i, col_j, ...}] extract the columns col_i, col_j, ... \
from the matrix mat", "synonyms" -> {}, "title" -> "GetColumns", 
    "titlemodifier" -> "", "windowtitle" -> "GetColumns", "type" -> "Symbol", 
    "uri" -> "ClassroomUtilities/ref/GetColumns"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7059, 199, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->441651142]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15939, 503}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[603, 21, 4033, 88, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4661, 113, 53, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[4717, 116, 1390, 44, 152, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[6144, 165, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->143444557],
Cell[6756, 185, 70, 1, 70, "Notes",
 CellID->1067943069],
Cell[6829, 188, 110, 3, 70, "Notes",
 CellID->1184510786],
Cell[6942, 193, 80, 1, 70, "Notes",
 CellID->899372612]
}, Closed]],
Cell[CellGroupData[{
Cell[7059, 199, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->441651142],
Cell[CellGroupData[{
Cell[7574, 217, 195, 6, 31, "ExampleSection",
 CellID->187040000],
Cell[7772, 225, 67, 1, 32, "ExampleText",
 CellID->1765582298],
Cell[7842, 228, 127, 3, 28, "Input",
 CellID->212648240],
Cell[7972, 233, 108, 3, 32, "ExampleText",
 CellID->566181072],
Cell[8083, 238, 236, 8, 28, "Input",
 CellID->305237247],
Cell[CellGroupData[{
Cell[8344, 250, 109, 3, 28, "Input",
 CellID->1298154885],
Cell[8456, 255, 930, 25, 107, "Output",
 CellID->1802782322]
}, Open  ]],
Cell[CellGroupData[{
Cell[9423, 285, 217, 7, 70, "Input",
 CellID->1931461293],
Cell[9643, 294, 778, 25, 107, "Output",
 CellID->299533825]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10482, 326, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[10931, 341, 1344, 52, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[12312, 398, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[12763, 413, 193, 5, 70, "Tutorials",
 CellID->341631938],
Cell[12959, 420, 157, 3, 70, "Tutorials",
 CellID->234584586]
}, Open  ]],
Cell[CellGroupData[{
Cell[13153, 428, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[13604, 443, 171, 4, 70, "MoreAbout",
 CellID->453312724],
Cell[13778, 449, 164, 3, 70, "MoreAbout",
 CellID->781943908]
}, Open  ]],
Cell[13957, 455, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

