(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     18440,        564]
NotebookOptionsPosition[     14243,        431]
NotebookOutlinePosition[     16374,        488]
CellTagsIndexPosition[     16289,        483]
WindowTitle->Grumpy - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Visualizing Statistical Concepts\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities/ref/Grumpy\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/Grumpy"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/Grumpy.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/Grumpy", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Grumpy", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Grumpy", "[", 
       StyleBox["col", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]create a happy face with a grumpy expression with face \
color ",
     Cell[BoxData[
      StyleBox["col", "TI"]], "InlineFormula"],
     ". If no color is given the default is yellow."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->467254723],

Cell["\<\
Given with no color specification the face will be rendered in the standard \
yellow.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
The face is rendered using a unit disk centered on the origin.\
\>", "Notes",
 CellID->341904801],

Cell[TextData[{
 "Size of the face used in ",
 ButtonBox["Inset",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Inset"],
 " is controlled by the size specifiction in ",
 ButtonBox["Inset",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Inset"],
 "."
}], "Notes",
 CellID->1875234682]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->100361481],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->30203216],

Cell["This loads the package.", "ExampleText",
 CellID->599297002],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->686408184],

Cell["Use Graphics to display the face.", "ExampleText",
 CellID->180196804],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"Grumpy", "[", "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->615742558],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
   {GrayLevel[0], Thickness[0.03], 
    DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
      0.4871392896287467, 0.28125}], NCache[
     Rational[1, 6], 0.16666666666666666`]], 
    DiskBox[NCache[{
      Rational[-9, 32] 3^Rational[1, 2], Rational[
       9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
     Rational[1, 6], 0.16666666666666666`]], 
    CircleBox[
     NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
      0.4871392896287467, 0.28125}], NCache[Rational[1, 4], 0.25], 
     NCache[{Rational[1, 2] Pi, Pi}, {1.5707963267948966`, 
      3.141592653589793}]], 
    CircleBox[
     NCache[{Rational[-9, 32] 3^Rational[1, 2], Rational[
       9, 32]}, {-0.4871392896287467, 0.28125}], NCache[Rational[1, 4], 0.25],
      NCache[{Rational[1, 2] Pi, 0}, {1.5707963267948966`, 0}]]}, 
   {RGBColor[1, 0, 0], Thickness[0.03], 
    CircleBox[NCache[{0, Rational[-7, 8]}, {0, -0.875}], NCache[
     Rational[5, 8], 0.625], 
     NCache[{Rational[1, 6] Pi, Rational[5, 6] Pi}, {0.5235987755982988, 
      2.6179938779914944`}]]}}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->61477413]
}, Open  ]],

Cell["Change the color of the face.", "ExampleText",
 CellID->311246084],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"Grumpy", "[", 
   RowBox[{"Lighter", "[", 
    RowBox[{"Red", ",", ".3"}], "]"}], "]"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1990253343],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[1., 0.3, 0.3], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
   {GrayLevel[0], Thickness[0.03], 
    DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
      0.4871392896287467, 0.28125}], NCache[
     Rational[1, 6], 0.16666666666666666`]], 
    DiskBox[NCache[{
      Rational[-9, 32] 3^Rational[1, 2], Rational[
       9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
     Rational[1, 6], 0.16666666666666666`]], 
    CircleBox[
     NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
      0.4871392896287467, 0.28125}], NCache[Rational[1, 4], 0.25], 
     NCache[{Rational[1, 2] Pi, Pi}, {1.5707963267948966`, 
      3.141592653589793}]], 
    CircleBox[
     NCache[{Rational[-9, 32] 3^Rational[1, 2], Rational[
       9, 32]}, {-0.4871392896287467, 0.28125}], NCache[Rational[1, 4], 0.25],
      NCache[{Rational[1, 2] Pi, 0}, {1.5707963267948966`, 0}]]}, 
   {RGBColor[1, 0, 0], Thickness[0.03], 
    CircleBox[NCache[{0, Rational[-7, 8]}, {0, -0.875}], NCache[
     Rational[5, 8], 0.625], 
     NCache[{Rational[1, 6] Pi, Rational[5, 6] Pi}, {0.5235987755982988, 
      2.6179938779914944`}]]}}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->982650129]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Scope",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell["This loads the package.", "ExampleText",
 CellID->1251472673],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1046376393],

Cell["Use Inset to include a face in a graphic.", "ExampleText",
 CellID->645199565],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Rectangle", "[", "]"}], ",", 
    RowBox[{"Inset", "[", 
     RowBox[{
      RowBox[{"Graphics", "[", 
       RowBox[{"Grumpy", "[", "]"}], "]"}], ",", "Center", ",", "Center"}], 
     "]"}]}], "}"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1224155252],

Cell[BoxData[
 GraphicsBox[{RectangleBox[{0, 0}], InsetBox[
    GraphicsBox[
     {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
      {GrayLevel[0], Thickness[0.03], 
       DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
         0.4871392896287467, 0.28125}], NCache[
        Rational[1, 6], 0.16666666666666666`]], 
       DiskBox[NCache[{
         Rational[-9, 32] 3^Rational[1, 2], Rational[
          9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
        Rational[1, 6], 0.16666666666666666`]], 
       CircleBox[
        NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
         0.4871392896287467, 0.28125}], NCache[Rational[1, 4], 0.25], 
        NCache[{Rational[1, 2] Pi, Pi}, {1.5707963267948966`, 
         3.141592653589793}]], 
       CircleBox[
        NCache[{Rational[-9, 32] 3^Rational[1, 2], Rational[
          9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
        Rational[1, 4], 0.25], 
        NCache[{Rational[1, 2] Pi, 0}, {1.5707963267948966`, 0}]]}, 
      {RGBColor[1, 0, 0], Thickness[0.03], 
       CircleBox[NCache[{0, Rational[-7, 8]}, {0, -0.875}], NCache[
        Rational[5, 8], 0.625], 
        NCache[{Rational[1, 6] Pi, Rational[5, 6] Pi}, {0.5235987755982988, 
         2.6179938779914944`}]]}}], Center, Center]}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->412145670]
}, Open  ]],

Cell["\<\
Scale the face using the scale specification in the Inset function.\
\>", "ExampleText",
 CellID->1297514115],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"{", 
   RowBox[{"Blue", ",", 
    RowBox[{"Rectangle", "[", "]"}], ",", 
    RowBox[{"Inset", "[", 
     RowBox[{
      RowBox[{"Graphics", "[", 
       RowBox[{"Grumpy", "[", "]"}], "]"}], ",", "Center", ",", "Center", ",", 
      RowBox[{"3", "/", "4"}]}], "]"}]}], "}"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1770779167],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0, 0, 1], RectangleBox[{0, 0}], InsetBox[
    GraphicsBox[
     {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
      {GrayLevel[0], Thickness[0.03], 
       DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
         0.4871392896287467, 0.28125}], NCache[
        Rational[1, 6], 0.16666666666666666`]], 
       DiskBox[NCache[{
         Rational[-9, 32] 3^Rational[1, 2], Rational[
          9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
        Rational[1, 6], 0.16666666666666666`]], 
       CircleBox[
        NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
         0.4871392896287467, 0.28125}], NCache[Rational[1, 4], 0.25], 
        NCache[{Rational[1, 2] Pi, Pi}, {1.5707963267948966`, 
         3.141592653589793}]], 
       CircleBox[
        NCache[{Rational[-9, 32] 3^Rational[1, 2], Rational[
          9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
        Rational[1, 4], 0.25], 
        NCache[{Rational[1, 2] Pi, 0}, {1.5707963267948966`, 0}]]}, 
      {RGBColor[1, 0, 0], Thickness[0.03], 
       CircleBox[NCache[{0, Rational[-7, 8]}, {0, -0.875}], NCache[
        Rational[5, 8], 0.625], 
        NCache[{Rational[1, 6] Pi, Rational[5, 6] Pi}, {0.5235987755982988, 
         2.6179938779914944`}]]}}], Center, Center, NCache[
    Rational[3, 4], 0.75]]}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1969625605]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[StyleBox[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"],
 FontWeight->"Bold"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Grumpy - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 27, 18.6928624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "Grumpy[col] create a happy face with a grumpy expression with face color \
col. If no color is given the default is yellow.", "synonyms" -> {}, "title" -> 
    "Grumpy", "titlemodifier" -> "", "windowtitle" -> "Grumpy", "type" -> 
    "Symbol", "uri" -> "Classroom Utilities/ref/Grumpy"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4872, 151, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->100361481]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 16146, 476}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[599, 21, 2440, 55, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3064, 80, 49, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3116, 83, 542, 16, 99, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3695, 104, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->467254723],
Cell[4307, 124, 131, 4, 70, "Notes",
 CellID->1067943069],
Cell[4441, 130, 107, 3, 70, "Notes",
 CellID->341904801],
Cell[4551, 135, 284, 11, 70, "Notes",
 CellID->1875234682]
}, Closed]],
Cell[CellGroupData[{
Cell[4872, 151, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->100361481],
Cell[CellGroupData[{
Cell[5387, 169, 194, 6, 31, "ExampleSection",
 CellID->30203216],
Cell[5584, 177, 66, 1, 32, "ExampleText",
 CellID->599297002],
Cell[5653, 180, 127, 3, 28, "Input",
 CellID->686408184],
Cell[5783, 185, 76, 1, 32, "ExampleText",
 CellID->180196804],
Cell[CellGroupData[{
Cell[5884, 190, 132, 4, 28, "Input",
 CellID->615742558],
Cell[6019, 196, 1310, 29, 201, "Output",
 CellID->61477413]
}, Open  ]],
Cell[7344, 228, 72, 1, 70, "ExampleText",
 CellID->311246084],
Cell[CellGroupData[{
Cell[7441, 233, 201, 6, 70, "Input",
 CellID->1990253343],
Cell[7645, 241, 1316, 29, 201, "Output",
 CellID->982650129]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9010, 276, 268, 8, 70, "ExampleSection",
 CellID->1293636265],
Cell[9281, 286, 67, 1, 70, "ExampleText",
 CellID->1251472673],
Cell[9351, 289, 128, 3, 70, "Input",
 CellID->1046376393],
Cell[9482, 294, 84, 1, 70, "ExampleText",
 CellID->645199565],
Cell[CellGroupData[{
Cell[9591, 299, 343, 11, 70, "Input",
 CellID->1224155252],
Cell[9937, 312, 1457, 31, 201, "Output",
 CellID->412145670]
}, Open  ]],
Cell[11409, 346, 119, 3, 70, "ExampleText",
 CellID->1297514115],
Cell[CellGroupData[{
Cell[11553, 353, 387, 11, 70, "Input",
 CellID->1770779167],
Cell[11943, 366, 1515, 33, 201, "Output",
 CellID->1969625605]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[13519, 406, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[13970, 421, 231, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[14216, 429, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

