(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     16294,        520]
NotebookOptionsPosition[     12137,        388]
NotebookOutlinePosition[     14234,        444]
CellTagsIndexPosition[     14149,        439]
WindowTitle->Happy - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Visualizing Statistical Concepts\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities/ref/Happy\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/Happy"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/Happy.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/Happy", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Happy", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Happy", "[", 
       StyleBox["col", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]create a happy face with face color ",
     Cell[BoxData[
      StyleBox["col", "TI"]], "InlineFormula"],
     ". If no color is given the default is yellow."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->112754323],

Cell["\<\
Given with no color specification the face will be rendered in the standard \
yellow.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
The face is rendered using a unit disk centered on the origin.\
\>", "Notes",
 CellID->341904801],

Cell[TextData[{
 "Size of the face used in ",
 ButtonBox["Inset",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Inset"],
 " is controlled by the size specification in ",
 ButtonBox["Inset",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Inset"],
 "."
}], "Notes",
 CellID->1875234682]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->36758737],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->48682725],

Cell["This loads the package.", "ExampleText",
 CellID->599297002],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->686408184],

Cell["Use Graphics to display the face.", "ExampleText",
 CellID->180196804],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"Happy", "[", "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->615742558],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
   {GrayLevel[0], Thickness[0.03], 
    DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
      0.4871392896287467, 0.28125}], NCache[
     Rational[1, 6], 0.16666666666666666`]], 
    DiskBox[NCache[{
      Rational[-9, 32] 3^Rational[1, 2], Rational[
       9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
     Rational[1, 6], 0.16666666666666666`]]}, 
   {RGBColor[1, 0, 0], Thickness[0.03], 
    CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
     NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
       Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->37124730]
}, Open  ]],

Cell["Change the color of the face.", "ExampleText",
 CellID->311246084],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"Happy", "[", "LightPink", "]"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1990253343],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[1, 0.925, 0.925], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
   {GrayLevel[0], Thickness[0.03], 
    DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
      0.4871392896287467, 0.28125}], NCache[
     Rational[1, 6], 0.16666666666666666`]], 
    DiskBox[NCache[{
      Rational[-9, 32] 3^Rational[1, 2], Rational[
       9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
     Rational[1, 6], 0.16666666666666666`]]}, 
   {RGBColor[1, 0, 0], Thickness[0.03], 
    CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
     NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
       Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1867478082]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Scope",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1230623269],

Cell["This loads the package.", "ExampleText",
 CellID->1251472673],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1046376393],

Cell["Use Inset to include a face in a graphic.", "ExampleText",
 CellID->645199565],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Rectangle", "[", "]"}], ",", 
    RowBox[{"Inset", "[", 
     RowBox[{
      RowBox[{"Graphics", "[", 
       RowBox[{"Happy", "[", "]"}], "]"}], ",", "Center", ",", "Center"}], 
     "]"}]}], "}"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1224155252],

Cell[BoxData[
 GraphicsBox[{RectangleBox[{0, 0}], InsetBox[
    GraphicsBox[
     {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
      {GrayLevel[0], Thickness[0.03], 
       DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
         0.4871392896287467, 0.28125}], NCache[
        Rational[1, 6], 0.16666666666666666`]], 
       DiskBox[NCache[{
         Rational[-9, 32] 3^Rational[1, 2], Rational[
          9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
        Rational[1, 6], 0.16666666666666666`]]}, 
      {RGBColor[1, 0, 0], Thickness[0.03], 
       CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
        NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
          Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], Center, 
    Center]}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->670277826]
}, Open  ]],

Cell["\<\
Scale the face using the scale specification in the Inset function.\
\>", "ExampleText",
 CellID->1297514115],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"{", 
   RowBox[{"Blue", ",", 
    RowBox[{"Rectangle", "[", "]"}], ",", 
    RowBox[{"Inset", "[", 
     RowBox[{
      RowBox[{"Graphics", "[", 
       RowBox[{"Happy", "[", "LightPink", "]"}], "]"}], ",", "Center", ",", 
      "Center", ",", 
      RowBox[{"3", "/", "4"}]}], "]"}]}], "}"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1770779167],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0, 0, 1], RectangleBox[{0, 0}], InsetBox[
    GraphicsBox[
     {RGBColor[1, 0.925, 0.925], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
      {GrayLevel[0], Thickness[0.03], 
       DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
         0.4871392896287467, 0.28125}], NCache[
        Rational[1, 6], 0.16666666666666666`]], 
       DiskBox[NCache[{
         Rational[-9, 32] 3^Rational[1, 2], Rational[
          9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
        Rational[1, 6], 0.16666666666666666`]]}, 
      {RGBColor[1, 0, 0], Thickness[0.03], 
       CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
        NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
          Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], Center, 
    Center, NCache[Rational[3, 4], 0.75]]}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1807693067]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[StyleBox[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"],
 FontWeight->"Bold"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Happy - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 27, 22.8268624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "Happy[col] create a happy face with face color col. If no color is given \
the default is yellow.", "synonyms" -> {}, "title" -> "Happy", 
    "titlemodifier" -> "", "windowtitle" -> "Happy", "type" -> "Symbol", 
    "uri" -> "Classroom Utilities/ref/Happy"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4839, 150, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->36758737]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 14007, 432}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[598, 21, 2436, 55, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3059, 80, 48, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3110, 83, 514, 15, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3661, 103, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->112754323],
Cell[4273, 123, 131, 4, 70, "Notes",
 CellID->1067943069],
Cell[4407, 129, 107, 3, 70, "Notes",
 CellID->341904801],
Cell[4517, 134, 285, 11, 70, "Notes",
 CellID->1875234682]
}, Closed]],
Cell[CellGroupData[{
Cell[4839, 150, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->36758737],
Cell[CellGroupData[{
Cell[5353, 168, 194, 6, 31, "ExampleSection",
 CellID->48682725],
Cell[5550, 176, 66, 1, 32, "ExampleText",
 CellID->599297002],
Cell[5619, 179, 127, 3, 28, "Input",
 CellID->686408184],
Cell[5749, 184, 76, 1, 32, "ExampleText",
 CellID->180196804],
Cell[CellGroupData[{
Cell[5850, 189, 131, 4, 28, "Input",
 CellID->615742558],
Cell[5984, 195, 817, 19, 201, "Output",
 CellID->37124730]
}, Open  ]],
Cell[6816, 217, 72, 1, 70, "ExampleText",
 CellID->311246084],
Cell[CellGroupData[{
Cell[6913, 222, 145, 4, 70, "Input",
 CellID->1990253343],
Cell[7061, 228, 827, 19, 201, "Output",
 CellID->1867478082]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7937, 253, 268, 8, 70, "ExampleSection",
 CellID->1230623269],
Cell[8208, 263, 67, 1, 70, "ExampleText",
 CellID->1251472673],
Cell[8278, 266, 128, 3, 70, "Input",
 CellID->1046376393],
Cell[8409, 271, 84, 1, 70, "ExampleText",
 CellID->645199565],
Cell[CellGroupData[{
Cell[8518, 276, 342, 11, 70, "Input",
 CellID->1224155252],
Cell[8863, 289, 930, 21, 201, "Output",
 CellID->670277826]
}, Open  ]],
Cell[9808, 313, 119, 3, 70, "ExampleText",
 CellID->1297514115],
Cell[CellGroupData[{
Cell[9952, 320, 406, 12, 70, "Input",
 CellID->1770779167],
Cell[10361, 334, 991, 22, 201, "Output",
 CellID->1807693067]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[11413, 363, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[11864, 378, 231, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[12110, 386, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

