(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     15246,        481]
NotebookOptionsPosition[     11508,        370]
NotebookOutlinePosition[     13885,        430]
CellTagsIndexPosition[     13800,        425]
WindowTitle->IntermediatePoint - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/AnalyticGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/IntermediatePoint\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/IntermediatePoint"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/IntermediatePoint.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/IntermediatePoint", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["IntermediatePoint", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"IntermediatePoint", "[", 
       RowBox[{
        SubscriptBox[
         StyleBox["pt", "TI"], 
         StyleBox["1", "TR"]], ",", 
        SubscriptBox[
         StyleBox["pt", "TI"], 
         StyleBox["2", "TR"]], ",", 
        StyleBox["pos", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]gives a point which is a weighted average of the two \
given points according to the formula ",
     Cell[BoxData[
      RowBox[{
       RowBox[{
        RowBox[{"(", 
         RowBox[{"1", "-", 
          StyleBox["pos", "TI"]}], ")"}], " ", 
        SubscriptBox[
         StyleBox["pt", "TI"], 
         StyleBox["1", "TR"]]}], " ", "+", " ", 
       RowBox[{
        StyleBox["pos", "TI"], " ", 
        SubscriptBox[
         StyleBox["pt", "TI"], 
         StyleBox["2", "TR"]]}]}]], "InlineFormula"],
     ". If pos is negative the order of the points will be ",
     Cell[BoxData[
      RowBox[{
       StyleBox["newpt1", "TI"], ",", " ", 
       SubscriptBox[
        StyleBox["pt", "TI"], 
        StyleBox["1", "TR"]], ",", 
       SubscriptBox[
        StyleBox["pt", "TI"], 
        StyleBox["2", "TR"]], ","}]], "InlineFormula"],
     " For 0 < pos < 1 the order will be ",
     Cell[BoxData[
      RowBox[{
       SubscriptBox[
        StyleBox["pt", "TI"], 
        StyleBox["1", "TR"]], ",", " ", 
       StyleBox["newpt", "TI"]}]], "InlineFormula"],
     ", ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula"],
     ". For 1 < pos the order is ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     ", ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula"],
     ", ",
     Cell[BoxData[
      StyleBox["newpt", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->372862423],

Cell[TextData[{
 "IntermediatePoint can be used to trace out line segments using ",
 ButtonBox["ParametricPlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/ParametricPlot"],
 "."
}], "Notes",
 CellID->1067943069]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->123725914],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->667283047],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->261057459],

Cell["\<\
Finding the point one third of the way between {1,1} and {3,2}\
\>", "ExampleText",
 CellID->283622592],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"IntermediatePoint", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"1", "/", "3"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1578691051],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   FractionBox["5", "3"], ",", 
   FractionBox["4", "3"]}], "}"}]], "Output",
 ImageSize->{52, 32},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->900035472]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Applications",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->258228157],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->21368436],

Cell["\<\
Using IntermediatePoint to place a circle at the center of a line segment.\
\>", "ExampleText",
 CellID->509534803],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ParametricPlot", "[", 
  RowBox[{
   RowBox[{"IntermediatePoint", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"5", ",", "3"}], "}"}], ",", "t"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"Epilog", "\[Rule]", " ", 
    RowBox[{"Circle", "[", 
     RowBox[{
      RowBox[{"IntermediatePoint", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"1", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"5", ",", "3"}], "}"}], ",", 
        RowBox[{"1", "/", "2"}]}], "]"}], ",", "1"}], "]"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1734133432],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF1H9Mk0cYwPG3LW+PQoW2xxi4iYDTgNOtQ7Yw2bgHMhmToVIBoxtCIegK
MhScGH8wCeAkwEDASfyVLWAluGDYGkR0yMShKLJBQYgmpHMNWKdbaYFS2sLY
29u45Mkn+f5xyXN/XEBajiKDzzBM3ML8q/MYyX/e3GBSClkj0QVa5UV8Iyko
03eJ3Ra7zbvnK1+vxW5ZW+25LshI7LS/+OS15bu2LPbHV2Mier9d7K05J4/U
RU7837dnujERF0xkzdsss3zzBJF8qR66+4eZnCDaTP3EBDmojdcbA6fIDUNQ
7sGTJtL7g9668ug02bXdZK+OMJPQ788oodNCliY9kPvrzKRUHvbbbj8r2eDz
6tN1lZOkclKfv+bALPnwkCncO3yKNA5o9j1stZEE1aOwrMdT5Er4ntwKmYMM
L3vnWnTpNOnpiP4leNscyUipf1L7uoXUFsrj00/Nk3tQ19hyz0LU44wpIZ+B
S5wzpPyVw/pMHx5UcFqJwUu1A93hgVMr8Wse3ZObywensyR5MCNoi0wAOzlt
RNaZultzUwBObaQ/LHtzmdIFBjjtRJj/ov2phAXE6SAvJU7d8vqJBacOsrbT
Y/+PyUJwOkfajWcbR9wRXOecJ4rm9cf3NiPYyjlPutyVzHCcK/xeIj/25yoG
mt6wObpmXSHxtGNOeZSBs6PqhhXnRBCXs3VA2scAP6G7TxTrBrzV6ePFK3kQ
pco+1THtBt9pWjemHOZBufsqduwbd+hma/h593nwcZ5ipuYDMajfDbZ/FMgH
78+qajVjYnAPjdm4I48PbfbEB/UlS+DTuaax/lt86E+qLPUN8QDV5Tu3xb4C
ML//6C+e1gOsftmWYyoBlD+rG95b6AnRX/RmtXUKwKdaExosk8DLnC4wVKCL
5aVJ4CGnC2za1N1wrk1CdYFYfahin0hKZYFNTo4UKaVUFpou9hS4XpVSWRjU
dEgikYwqhHZ1tv69nTK4ximEFSkXxblXZFQhHBr3L/KYl1GFUKZICv88EVMR
BBZ7xSA1piKQhUyuzrmEQcqJgKfTLhluxMDnRKALr9GqL2MqggtmaUp0C6Yi
WJrueaDkBgZfTgTSKLcGgRaDjHPhPqPheNYgpiIwnu9RaYcwFcGv1hNv1o9g
6ONEUNGCrkeNYviaE4EogB0oNGAqgpk+vcbwDFMRjB+5fTr+OYYxTgTdI0XJ
AX9jKoLiKr6hcxJTEeRFPLkfNI2pCNKf/9xcZcGQxokgKqZwf+ospiIImU7d
dteG4S1OBAENsF7uWHg/zoV9Ff7L6uYwFYHz3/KiusI/e/IYSA==
     "]]}},
  Axes->True,
  AxesOrigin->{1., 1.},
  Epilog->CircleBox[{3, 2}, 1],
  PlotRange->{{1., 5.}, {1., 3.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 ImageSize->{184, 102},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->2126863043]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/AnalyticGeometry"]], "MoreAbout",
 CellID->153743623]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"IntermediatePoint - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 27, 29.5972624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "IntermediatePoint[pt_1, pt_2, pos] gives a point which is a weighted \
average of the two given points according to the formula (1 - pos) pt_1 + pos \
pt_2. If pos is negative the order of the points will be newpt1, pt_1, pt_2, \
For 0 < pos < 1 the order will be pt_1, newpt, pt_2. For 1 < pos the order is \
pt_1, pt_2, newpt.", "synonyms" -> {}, "title" -> "IntermediatePoint", 
    "titlemodifier" -> "", "windowtitle" -> "IntermediatePoint", "type" -> 
    "Symbol", "uri" -> "ClassroomUtilities/ref/IntermediatePoint"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6185, 191, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->123725914]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13657, 418}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[610, 21, 2472, 57, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3107, 82, 60, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3170, 85, 2113, 69, 121, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5320, 159, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->372862423],
Cell[5932, 179, 216, 7, 70, "Notes",
 CellID->1067943069]
}, Closed]],
Cell[CellGroupData[{
Cell[6185, 191, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->123725914],
Cell[CellGroupData[{
Cell[6700, 209, 195, 6, 31, "ExampleSection",
 CellID->667283047],
Cell[6898, 217, 127, 3, 28, "Input",
 CellID->261057459],
Cell[7028, 222, 113, 3, 32, "ExampleText",
 CellID->283622592],
Cell[CellGroupData[{
Cell[7166, 229, 269, 9, 28, "Input",
 CellID->1578691051],
Cell[7438, 240, 247, 9, 53, "Output",
 CellID->900035472]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7734, 255, 274, 8, 31, "ExampleSection",
 CellID->258228157],
Cell[8011, 265, 126, 3, 70, "Input",
 CellID->21368436],
Cell[8140, 270, 125, 3, 70, "ExampleText",
 CellID->509534803],
Cell[CellGroupData[{
Cell[8290, 277, 726, 23, 70, "Input",
 CellID->1734133432],
Cell[9019, 302, 1771, 38, 123, "Output",
 CellID->2126863043]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10851, 347, 448, 13, 45, "MoreAboutSection",
 CellID->38303248],
Cell[11302, 362, 164, 3, 17, "MoreAbout",
 CellID->153743623]
}, Open  ]],
Cell[11481, 368, 23, 0, 41, "FooterCell"]
}
]
*)

(* End of internal cache information *)

