(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     13408,        409]
NotebookOptionsPosition[      9913,        302]
NotebookOutlinePosition[     12173,        363]
CellTagsIndexPosition[     12053,        357]
WindowTitle->KPH - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Falling Body Problems\"\>":>
       Documentation`HelpLookup[
       "paclet:CalculusApplications/tutorial/FallingBodyProblems"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Calculus Applications\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/CalculusApplications"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/KPH\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/KPH"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/KPH.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/KPH", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["KPH", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["KPH"], "InlineFormula"],
     "\[LineSeparator]gives the number of meters per second traveled at one \
kilometer per hour. It has a numerical value of ",
     "5/18",
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->273461135],

Cell[TextData[{
 "This is intended for use with the ",
 Cell[BoxData[
  ButtonBox["Trajectory",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/Trajectory"]], "InlineFormula"],
 " functions when using metric units."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "It assumes the value for gravitational acceleration will be given as 9.8 ",
 Cell[BoxData[
  RowBox[{"meters", "/", 
   SuperscriptBox["second", "2"]}]]],
 "."
}], "Notes",
 CellID->73282990]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->282459335],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->178601904],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1159083199],

Cell["\<\
Tracking a body with initial velocity 100KPH launched at an angle of 30\
\[Degree] to the horizontal.\
\>", "ExampleText",
 CellID->887163656],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ParametricPlot", "[", 
  RowBox[{
   RowBox[{"Trajectory", "[", 
    RowBox[{"t", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"100", " ", "KPH"}], ",", 
       RowBox[{"30", " ", "\[Degree]"}], ",", "9.8", ",", ".002"}], "}"}]}], 
    "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "2.8"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->580605271],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztXCGbozAQ5fvO3E84u/rUytrKysrKRa44UVlbiazERuIuEotERmKRlZW9
lwxQynZ7WxIgdOd9uy3lK8MwvMy8hKQvb3/Wbz+CIPiN/7/419tnBuNBfEPa
KFUqdaz/bmwXxXFqH71AYDC1F85QFqc8L9O0EHEeH/L3d7ndyjBMlst4sYjx
ulzE221K+7f69cY2Xpvvr9eC9u92KWwKobKseDryqGhheLCIVGvvrLmBli5l
cTjkuH2bNQggQANsR1GGm5gkirJBWZ56n+J0OlMyybISNoXI9/vUkEeAOTgX
PmI/vnCcL19AjVDiXYaBea8wI2LgFuuEIBRuzWol8IdbczhkmgN5eTz2J0Bv
4LzgTByDnHKz1myBb+BqKgtksPH96YuKFMiwLWr4njfQ6kGG3TZdr8Rmk0R7
JIQcjfTka+DhG7iKxIUMRuzFx0J5n1PAjuAqaZxrbnhFDwgGtESdt402wDb2
eEuG+7hcyzKGYtE88TGfUMIAP64EhyfEQL2AckD00NZ2pq0p/9vagyCeIJ9A
GiGxoBhN7VENU1JIj/5cXXLHtMRAfFCd0RcINzpcuT/hGhKQRhBOELG6IexS
bE+dFdX2FyWJ6fVGpiOTITJ4RbqYscK3BpIJGgVaB5FkGifqLuyE3ECW0HEw
lJgsDr5CB2dfBQeEGfPUoAbpjI7gGEGLQqVT4WBKfAUIkR6u2SSJUOPUmnp4
Q5Ojw42BzoiqCkkJSkClSznSZT4NIM4hXKlBDZ5GKF+o6PX1pTP25ZweSI80
UImr+85awgmgzSBFEEw0tOHalxneCIKXXXunQ27AcyFyJEMo8JEr5tMDSZjS
CATbECPAeoDjUloqOOGGUkcS2yZRcPEYEKksNqa/7/J5Hw193eKGjVWUD8gJ
oyhYZI4HMOQ91I+GnYyyNj3YzpPY3v0UlD8qH0/3wHo2QOEOQ9wCRznEuqag
ZAih0A1Ht5TLhw/IsiI0OcRmKoKGBTcgNcEH5AoITisfGANA5xCjQxw22K8Q
A6fTrFgLmaj/fpkxIaBDUGXQI3DS272fN5pckTAr5gOSgql17+AzLQpWUIea
WTFH4PaZ+UVSWQw03SQGDWElglkxb6D/QjNa+5WYDjGkLKArxFhPeRgjIMvK
fqqgyRtkAYnIK1b4MCftDmbkHk05e2g2HXGD1l+gP/LxYjt7Hvro2/fZPdxo
kOSOhXNLgjIYH+lxhzkMBoPBYDAYDMagoCmC16vqe4DWNlwe7tqZreYtNofb
OvnhxwMcXHXrWbYbay0b9gbJXrOmoI+1ejn99azz3u60gmVhVkWRrKyYw+2d
VKoKeRMs26tuLSp2EUMZtQ61NtisNLGx9tmShF64GHNllo525mTNOXuD7Tm3
Dtyrkoaj6F0vT+tt7fIrHE654chs9TsQTqy1w29r8HrOrbMYaherdew2BjvL
03pb8zlv1K3coZNVnCwNdubcOoyhikL7PNk5vL81L/XG+UJ+U4edOUmxd3TV
zeW6i2EnUfY0WMu0ykELa476Kd2uhY3ZylQQtOWejZO1wSuB5k8/pREITTfP
zfU67EYxGAwGg/EI/gHQvggC
    "], {{0, 43}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 43},
  PlotRange->{{0, 180}, {0, 43}}]], "Output",
 ImageSize->{184, 43},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->651127660]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Falling Body Problems",
 BaseStyle->"Link",
 ButtonData->
  "paclet:CalculusApplications/tutorial/FallingBodyProblems"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Calculus Applications",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/CalculusApplications"]], "MoreAbout",
 CellID->760638418]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"KPH - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 27, 33.2944624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "KPH gives the number of meters per second traveled at one kilometer per \
hour. It has a numerical value of 5/18.", "synonyms" -> {}, "title" -> "KPH", 
    "titlemodifier" -> "", "windowtitle" -> "KPH", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/KPH"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4955, 150, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->282459335]},
 "RasterizedOutput"->{
  Cell[6388, 204, 2129, 43, 64, "Output",
   CellTags->"RasterizedOutput",
   CellID->651127660]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 11788, 346},
 {"RasterizedOutput", 11931, 350}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[596, 21, 2715, 63, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3336, 88, 46, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3385, 91, 403, 12, 97, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3825, 108, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->273461135],
Cell[4437, 128, 269, 8, 70, "Notes",
 CellID->1067943069],
Cell[4709, 138, 209, 7, 70, "Notes",
 CellID->73282990]
}, Closed]],
Cell[CellGroupData[{
Cell[4955, 150, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->282459335],
Cell[CellGroupData[{
Cell[5470, 168, 195, 6, 31, "ExampleSection",
 CellID->178601904],
Cell[5668, 176, 128, 3, 28, "Input",
 CellID->1159083199],
Cell[5799, 181, 152, 4, 32, "ExampleText",
 CellID->887163656],
Cell[CellGroupData[{
Cell[5976, 189, 409, 13, 28, "Input",
 CellID->580605271],
Cell[6388, 204, 2129, 43, 64, "Output",
 CellTags->"RasterizedOutput",
 CellID->651127660]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8578, 254, 448, 13, 45, "TutorialsSection",
 CellID->250839057],
Cell[9029, 269, 179, 4, 17, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[9245, 278, 448, 13, 45, "MoreAboutSection",
 CellID->38303248],
Cell[9696, 293, 175, 4, 17, "MoreAbout",
 CellID->760638418]
}, Open  ]],
Cell[9886, 300, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

