(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     16987,        537]
NotebookOptionsPosition[     13014,        416]
NotebookOutlinePosition[     15312,        475]
CellTagsIndexPosition[     15227,        470]
WindowTitle->LinearEstimate - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Differentiation\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/Differentiation"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/LinearEstimate\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/LinearEstimate"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/LinearEstimate.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/LinearEstimate", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["LinearEstimate", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"LinearEstimate", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        StyleBox["x", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["2", "TR"]]}], "}"}]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]returns an estimate for {",
     Cell[BoxData[
      RowBox[{
       SubscriptBox[
        StyleBox["x", "TI"], 
        StyleBox["2", "TR"]], ",", 
       RowBox[{
        StyleBox["f", "TI"], 
        RowBox[{"(", 
         SubscriptBox[
          StyleBox["x", "TI"], 
          StyleBox["2", "TR"]], ")"}]}]}]], "InlineFormula"],
     "} based on the tangent line to ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " at ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"LinearEstimate", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        StyleBox["x", "TI"], ",", 
        StyleBox["pt", "TI"], ",", 
        StyleBox["stp", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns {",
     Cell[BoxData[
      RowBox[{
       SubscriptBox[
        StyleBox["x", "TI"], 
        StyleBox["stp", "TI"]], ",", 
       RowBox[{
        StyleBox["f", "TI"], 
        RowBox[{"(", 
         SubscriptBox[
          StyleBox["x", "TI"], 
          StyleBox["stp", "TI"]], ")"}]}]}]], "InlineFormula"],
     "} where ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["stp", "TI"]]], "InlineFormula"],
     " is determined by moving a distance ",
     Cell[BoxData[
      StyleBox["stp", "TI"]], "InlineFormula"],
     " from ",
     Cell[BoxData[
      StyleBox["pt", "TI"]], "InlineFormula"],
     " along the tangent to ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " at ",
     Cell[BoxData[
      StyleBox["pt", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->216179335],

Cell[TextData[{
 "In the second form ",
 Cell[BoxData[
  StyleBox["pt", "TI"]], "InlineFormula"],
 " can be given as a number or an ordered pair."
}], "Notes",
 CellID->1067943069],

Cell["LinearEstimate always returns an ordered pair.", "Notes",
 CellID->903656308],

Cell["\<\
The function should be differentiable in a neighborhood of the specified \
point.\
\>", "Notes",
 CellID->747216972]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->57359154],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->665653338],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2138764395],

Cell[TextData[{
 "Estimate a value for ",
 Cell[BoxData[
  SuperscriptBox["3", ".05"]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->1631903279],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"LinearEstimate", "[", 
  RowBox[{
   SuperscriptBox["3", "x"], ",", "x", ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", ".05"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1884754316],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.05`", ",", "1.0549306144334054`"}], "}"}]], "Output",
 ImageSize->{106, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1681995762]
}, Open  ]],

Cell["Campare the result with a high precision result.", "ExampleText",
 CellID->1975526473],

Cell[CellGroupData[{

Cell[BoxData[
 SuperscriptBox["3", ".05"]], "Input",
 CellLabel->"In[3]:=",
 CellID->428765444],

Cell[BoxData["1.056467308549538`"], "Output",
 ImageSize->{53, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1453181623]
}, Open  ]],

Cell["\<\
Use the Plot function to campare a number of results near zero.\
\>", "ExampleText",
 CellID->292020430],

Cell[BoxData[
 RowBox[{
  RowBox[{"pts", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"LinearEstimate", "[", 
      RowBox[{
       SuperscriptBox["3", "x"], ",", "x", ",", 
       RowBox[{"{", 
        RowBox[{"0", ",", "i"}], "}"}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"i", ",", 
       RowBox[{"-", ".5"}], ",", ".5", ",", ".05"}], "}"}]}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->987233615],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   SuperscriptBox["3", "x"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", ".6"}], ",", ".6"}], "}"}], ",", 
   RowBox[{"Epilog", "\[Rule]", " ", 
    RowBox[{"Point", "[", "pts", "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->976710583],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwt1Ps/1XcAx/FT8timTppjuSTVMpkmt4cuxLskSnIrqaRcIsWDKGJ4LCwh
ZcxZNSOnVrLCEMllnw6SnZwejlt0XI7vtyj3hAiftj0e++H1eP4HrzVeQc4+
Czkczt5/+88Vh7jaxsYssY50Lk27LIOlfoGTvgFLHrtOBuxOkeGUvFP0ej2W
7Lkr58RJlaGsML1l7TqWGIaGCgLTZdivoBGnvIIlXfGGx/dmyJBcoSubXMiS
zX7rQ3m5MtCVu34ta2JIs9CiT1grQy8Tu9QihCG653cq5s7JoNbXPM4V9JKA
lEl7r/BeRNzpvF3eJSOXo1/mfDXai0Bu7satmjJSUHDnYZwvg1ypIF4+s5vo
LphfxR9k8GS5p7mdWhexs71WrePP4onVi0GNUCmZ4okfbpxh8Y60uFxt7yCa
2iqbshNeIaBku/sz13byWZ17n7zSa4gyfY4klrYRg46wBKV7r3GOMzPNMWwl
GyPZmG7zPjj+yXP6uriZnBoo9EqW9GHJvtfZYuUmsoA7+GZlWD9UTmtfMUpr
JHsyYhRf8t6AyzHvs+wWk9/sbdziat5gR7nZurM5IhLra1bdcvYtVE6q3VK9
+5TQmYn4PzQHUDx/fKnkRC1RUXbly6QDGI5PeTB3VEgO83T8HVIHIR10SA/X
rSSijiORjm5DSKSZeVklJWTqSWzNjnXD6J/YF3HgWAE53xaYXjgwDGncWhfi
cJPEV4mT3WtHoMGvCG45l0DiBY11evxRNECPs/LwRZSKL/QIjMewdETcXfz8
JoxtEzzy7o6h6JFyGu9tPiL/ngnuVX0HjQ+SmlS5UjTYTss389+h6EhU4/iZ
SnhrBf01wRvHhYAHxaWmQhz6voPWJ49joLZS0SOqFsbPXi3w5r1HoU6fwS/x
T1F92HMsIv091oxzpOExImwI2vnCZfkERK15fJsqMQTBsR3cnAn4M1VJEo9G
WD9SbyeGk+D2DzuHyjXh2EMDu00Nk/AIzo8+ltQMpc+Ni/w9ppCQ3z9044tW
XOwZ9EuanELD9MnjB3Lb4OCqLsvP+ABhfZTFPr12ZBb/WPHRdBpNt9tX10k6
YLdY0nZwaBplJnk2KYFS3KrN3nLqxgwc9ihJskY7oR7jUzNr+xELAx97aaV2
gzOVyVVRmIXRpR/Why+WwVN1TYavcBbPN0ttEkUyLKun5ZKIOUwHuPm1Xu9F
yOpxE2ebeXxk15ZbuTHQUuN4711C8Tyx+czvRxn4ftiaUa9IcUs/Tm+RFwNl
iwpTKx6FXSSTXePHwEx2r2CrOkWWkuCiZRgDnbr7IUY6FJbbNV22pTKIUL9/
wtCKIilLdczsKYO6ZYxndBTFUav63AwRA/Za+nX58xTGA+e8Z8UMtnEVTK/E
UXSavGgrb2EwsiuwJDuJYoOYX7WFYRBicfqq6BpF06zSpU3zDOz3c3hGJRR3
BNVWVzkszprwOx+XUUTahNApORabewoUHSsptH6WBJcqsNAMzSkKqqEI0/3p
oIkqiwSXqaFiCYVtI5T4K1iINJYtsm6lWBU2+mxCk0XGzS8vtLdT1Avt8eAb
Fk2f5mppD0XmCTrN+5aF0OdTXBpLEcLNLzrzHYvdOep52v0U1sXuAc36LMwV
3bZVDFD8/y90vW0wdxyh+AcdhIki
     "]]}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0.6000000000000001},
  Epilog->PointBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQDQEP9r/6uZRL+8Yd+7NnQODOfgGvlDhhvQf2s2aC
wM39WtNLzQU/PLRPA4Nr+92etAnwb3psbwwGl/cnGM54yVPy1B5i3oX9VXUr
D3GZPbefAdZ/cv+007tmc/x4YW8EVn94/waJMyVsu15B5XfuP51615el5g2U
v3L/003v1Jjs3tkzoIAP9gsg8vZ9yzre/HsA4++0l/YVvPn34Ed7E4j59is+
zzz6Z9En+zkQ++3NZilt+t38GeY++8MOq+f9SvkCVX/ZPuC5cfdP16/2GRD/
2d/r3VP+Q+0bzP/22SauKd/Zv9ufg4SP/Y9bZwO+vfgONe+BfVtjmO3Xkz/s
ARnyo9c=
    "]],
  PlotRange->{{-0.6, 0.6}, {0.517281871889147, 1.933181992919905}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 ImageSize->{184, 113},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->209770813]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->103650820],

Cell[TextData[ButtonBox["Differentiation",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/Differentiation"]], "MoreAbout",
 CellID->227816789]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"LinearEstimate - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 27, 41.5312624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "LinearEstimate[f, x, {x_1, x_2}] returns an estimate for {x_2, f (x_2)} \
based on the tangent line to f at x_1.LinearEstimate[f, x, pt, stp] returns \
{x_stp, f (x_stp)} where x_stp is determined by moving a distance stp from pt \
along the tangent to f at pt.", "synonyms" -> {}, "title" -> "LinearEstimate",
     "titlemodifier" -> "", "windowtitle" -> "LinearEstimate", "type" -> 
    "Symbol", "uri" -> "ClassroomUtilities/ref/LinearEstimate"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6719, 213, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->57359154]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15085, 463}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[607, 21, 2578, 59, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3210, 84, 57, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3270, 87, 2368, 81, 165, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5675, 173, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->216179335],
Cell[6287, 193, 180, 6, 70, "Notes",
 CellID->1067943069],
Cell[6470, 201, 83, 1, 70, "Notes",
 CellID->903656308],
Cell[6556, 204, 126, 4, 70, "Notes",
 CellID->747216972]
}, Closed]],
Cell[CellGroupData[{
Cell[6719, 213, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->57359154],
Cell[CellGroupData[{
Cell[7233, 231, 195, 6, 31, "ExampleSection",
 CellID->665653338],
Cell[7431, 239, 128, 3, 28, "Input",
 CellID->2138764395],
Cell[7562, 244, 150, 6, 34, "ExampleText",
 CellID->1631903279],
Cell[CellGroupData[{
Cell[7737, 254, 220, 7, 30, "Input",
 CellID->1884754316],
Cell[7960, 263, 227, 7, 36, "Output",
 CellID->1681995762]
}, Open  ]],
Cell[8202, 273, 92, 1, 32, "ExampleText",
 CellID->1975526473],
Cell[CellGroupData[{
Cell[8319, 278, 95, 3, 28, "Input",
 CellID->428765444],
Cell[8417, 283, 176, 5, 36, "Output",
 CellID->1453181623]
}, Open  ]],
Cell[8608, 291, 114, 3, 70, "ExampleText",
 CellID->292020430],
Cell[8725, 296, 445, 15, 70, "Input",
 CellID->987233615],
Cell[CellGroupData[{
Cell[9195, 315, 316, 10, 70, "Input",
 CellID->976710583],
Cell[9514, 327, 2611, 53, 134, "Output",
 CellID->209770813]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12186, 387, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[12637, 402, 171, 4, 70, "MoreAbout",
 CellID->103650820],
Cell[12811, 408, 161, 3, 70, "MoreAbout",
 CellID->227816789]
}, Open  ]],
Cell[12987, 414, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

