(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     13425,        410]
NotebookOptionsPosition[      9941,        303]
NotebookOutlinePosition[     12194,        364]
CellTagsIndexPosition[     12074,        358]
WindowTitle->MPH - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Falling Body Problems\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/FallingBodyProblems"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Calculus Applications\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/CalculusApplications"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/MPH\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/MPH"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/MPH.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]}, 
            Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/MPH", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["MPH", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["MPH"], "InlineFormula"],
     "\[LineSeparator]gives the number of feet per second traveled at one \
mile per hour. It has a numerical value of ",
     "22/15",
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->81950741],

Cell[TextData[{
 "This is intended for use with the ",
 Cell[BoxData[
  ButtonBox["Trajectory",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/Trajectory"]], "InlineFormula"],
 " functions when using British units."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "It assumes the value for gravitational acceleration will be given as 32.2 ",
 Cell[BoxData[
  RowBox[{"feet", "/", 
   SuperscriptBox["second", "2"]}]]],
 "."
}], "Notes",
 CellID->8331755]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->127301225],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->123668081],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->445369230],

Cell["\<\
Tracking a body with initial velocity 62.14MPH at an angle 30\[Degree] to the \
horizontal.\
\>", "ExampleText",
 CellID->1340138815],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ParametricPlot", "[", 
  RowBox[{
   RowBox[{"Trajectory", "[", 
    RowBox[{"t", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"62.14", "MPH"}], ",", 
       RowBox[{"30", " ", "\[Degree]"}], ",", "32.17", ",", ".002"}], "}"}]}],
     "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "2.8"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->904573969],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztXCGXozAY5L0zK1ee7U+orK1EIis3csUJJBaJRNYicReJRSIjsUhkZW+S
QEu7pXtlQ5KWzOvuAtvCR5jMN/kIXX38CT5+eZ63xs9f/PDlo4ODg4ODgyqw
ZONxbBImN1ByseqwXDAmSECJZAOYQehg3WHxYElC5d+NoMY1OYS0LNG41nXL
WMNY27/4cs1a03FpQpdVOrnw7nDjxejBqqaqmv2+yjKWxGUYFp+fdLfLt5v9
drvfiN/YIreHIQ37ZbxO7/G32Wk739W+qsRuDwfTp6cA0l94715ApW6kkivv
v8PX0Y22PaC/9xygQZDjyuKCRmGBjVlWFUUtlQHvfHTnJ1URu2LYJ/bs+9kW
tAlpmnLusSeUmj6ZpGtvxbkApqwJ++I3no4buMRl2aAX4zKBBlCDUPRryYEJ
BJgGHItShuNCVaAwhORJUlJaN80TyEqnGt6GBIIMLFmJ9dWlE30KbqDB85wr
A5gAZYiiwrYOiwhBTtADEe6CPI4L8EQbUaeCks5nCHALMly312/AK9KcQbpl
r9ynXBmsb20OqWwdT3Y5Ug/8j+mgrtApx+qyvrH2A5tzSil6XxBk0Gq0alVZ
JA4TIBUP6Q9nxElih9bBb8B7bpKUeCsfhqMfqESrd2IZN+D8kbvjiPuHOC4L
Wr/EWOAC8hxBeJAELsWsLen9htCK9Ej9N7lMIlvqG217HPYp6LCRMDQDZw2z
hEQPniBLGo2l8xv36xs6A0IPAiU+Ce1k1rpcrAkwVNJdQ0aM+Kh+JPtNXVQP
PeAlYOClqKJlNBzRfsieIoY2pcaqLAv5qDWgR5okwm8ERNS+3vzBQEUDMZBb
oQ++z73EQhLHBJRlzYu0n1SDXx36DakY0frGfdhZuYExPoafSGpYmOkQLwYQ
g9fww4KxuTvROZNc3FwZYA5uQCjkOBS/m/rlhhzzAx5M3seZM/MOuHHaMGft
Cykjigqyy+krjkM1AxoCeiARz+BUpVKson59vtpXb6iyOCqqpY47ZgJ8CBFj
GdU7pv5bz415al9gBXymrAy3buQxG3jX2+UKnXxnR4X7VF774sNzmAo/Q9gu
fWgAGjmOC6TsplHSCYdVDWW1L1hNRGhBWW+JQMpGy2fZz6d1nrmhpPYFreBW
k+SVK1MYhZw38rObMoNxyshc4v8kxkkrXPHKEqCfopMioU/7+NBvHEeeQfiW
G4ghFlrhWGEhVAjIKO5wA+MOuE2nFZZDlkHm8H43/UbbHtK03AWZc5vPAvRi
jGLU7vMrMbKM1ysodQ84PRkg70j9CvPLkBtUFFhUjI8czACCrzC/SG4IyvH5
mUaqWKYmnl3BhjCmxXD1KeQXXEolwQDxrWrbnTjV/kvbgXT+y2wMsARhWKCn
TyCb57BgPESSR6nl8BSQ9mPynXHHjdeGvEM3zZ06biwB8lndRz/liOFgHbr5
q93tHb3fNyWPfZ4beXV0LcFcx2C0QeyCeC7itKL/+6bG71DrC+ZiNq/pBrEG
l5Pex+aWzBzB7aNrDGb0KQATDWIZ+knvY3PSZj727RlxGoMZfQrARINYB5YQ
nLrTjcEmUw1iHa4e5F6y3+hjMdUgtqD/WtyzTddsy+/PiNMTzDAG4w3i4ODg
4ODg4KAW/wDX77lx
    "], {{0, 49}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 49},
  PlotRange->{{0, 180}, {0, 49}}]], "Output",
 ImageSize->{184, 49},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->70734809]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Falling Body Problems",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/FallingBodyProblems"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Calculus Applications",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/CalculusApplications"]], "MoreAbout",
 CellID->38144746]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MPH - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 28, 23.8696624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "MPH gives the number of feet per second traveled at one mile per hour. \
It has a numerical value of 22/15.", "synonyms" -> {}, "title" -> "MPH", 
    "titlemodifier" -> "", "windowtitle" -> "MPH", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/MPH"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4945, 150, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->127301225]},
 "RasterizedOutput"->{
  Cell[6367, 204, 2181, 44, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->70734809]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 11810, 347},
 {"RasterizedOutput", 11953, 351}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[596, 21, 2713, 63, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3334, 88, 46, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3383, 91, 397, 12, 83, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3817, 108, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->81950741],
Cell[4428, 128, 270, 8, 70, "Notes",
 CellID->1067943069],
Cell[4701, 138, 207, 7, 70, "Notes",
 CellID->8331755]
}, Closed]],
Cell[CellGroupData[{
Cell[4945, 150, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->127301225],
Cell[CellGroupData[{
Cell[5460, 168, 195, 6, 31, "ExampleSection",
 CellID->123668081],
Cell[5658, 176, 127, 3, 28, "Input",
 CellID->445369230],
Cell[5788, 181, 143, 4, 32, "ExampleText",
 CellID->1340138815],
Cell[CellGroupData[{
Cell[5956, 189, 408, 13, 28, "Input",
 CellID->904573969],
Cell[6367, 204, 2181, 44, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->70734809]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8609, 255, 448, 13, 45, "TutorialsSection",
 CellID->250839057],
Cell[9060, 270, 177, 4, 17, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[9274, 279, 448, 13, 45, "MoreAboutSection",
 CellID->38303248],
Cell[9725, 294, 174, 4, 17, "MoreAbout",
 CellID->38144746]
}, Open  ]],
Cell[9914, 301, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

