(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     13621,        439]
NotebookOptionsPosition[      9976,        326]
NotebookOutlinePosition[     12127,        383]
CellTagsIndexPosition[     12042,        378]
WindowTitle->MakeColorList - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Visualizing Statistical Concepts\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ColorList\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/ColorList"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Classroom Utilities/ref/MakeColorList\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/MakeColorList"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/MakeColorList.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/MakeColorList", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["MakeColorList", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MakeColorList", "[", 
       RowBox[{"\"\<\!\(\*
StyleBox[\"name\", \"TI\"]\)\>\"", ",", 
        StyleBox["colorlist", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]creates a ColorListFunction to use in setting the \
colors of samples in SRSChart"
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->68169682],

Cell["The name should be given as a string.", "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The ColorListFunction can be called using ColorList[",
 Cell[BoxData["\"\<\!\(\*
StyleBox[\"name\", \"TI\"]\)\>\""], "InlineFormula"],
 "]"
}], "Notes",
 CellID->1139717294]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->60384267],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->483958410],

Cell["This loads the package.", "ExampleText",
 CellID->2064321729],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->309498371],

Cell["Create a ColorListFunction.", "ExampleText",
 CellID->533728363],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeColorList", "[", 
  RowBox[{"\"\<NiceColors\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"Red", ",", "Green", ",", "Yellow", ",", "Purple"}], "}"}]}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->333403422],

Cell[BoxData[
 RowBox[{"ColorListFunction", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "4", ",", "1"}], "}"}], ",", 
   PanelBox[
    StyleBox[
     GraphicsBox[{
       {RGBColor[1, 0, 0], EdgeForm[Opacity[0.1]], 
        RectangleBox[{1, 0}, Offset[{-1, -1}, {2, 1}]]}, 
       {RGBColor[0, 1, 0], EdgeForm[Opacity[0.1]], 
        RectangleBox[{2, 0}, Offset[{-1, -1}, {3, 1}]]}, 
       {RGBColor[1, 1, 0], EdgeForm[Opacity[0.1]], 
        RectangleBox[{3, 0}, Offset[{-1, -1}, {4, 1}]]}, 
       {RGBColor[0.5, 0, 0.5], EdgeForm[Opacity[0.1]], 
        RectangleBox[{4, 0}, Offset[{-1, -1}, {5, 1}]]}},
      AspectRatio->NCache[
        Rational[1, 10], 0.1],
      ImageSize->65,
      PlotRangePadding->None],
     StripOnInput->False,
     CacheGraphics->False],
    FrameMargins->5]}], "]"}]], "Output",
 ImageSize->{288, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->726478531]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Table", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"ColorList", "[", "\"\<NiceColors\>\"", "]"}], "[", "i", "]"}], 
   ",", 
   RowBox[{"{", 
    RowBox[{"i", ",", "7"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1480137322],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"RGBColor", "[", 
    RowBox[{"1", ",", "0", ",", "0"}], "]"}], ",", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"0", ",", "1", ",", "0"}], "]"}], ",", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"1", ",", "1", ",", "0"}], "]"}], ",", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"0.5`", ",", "0", ",", "0.5`"}], "]"}], ",", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"1", ",", "0", ",", "0"}], "]"}], ",", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"0", ",", "1", ",", "0"}], "]"}], ",", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"1", ",", "1", ",", "0"}], "]"}]}], "}"}]], "Output",
 ImageSize->{532, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->217404006]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["ColorList",
   BaseStyle->"Link",
   ButtonData->"paclet:Classroom Utilities/ref/ColorList"],
  FontFamily->"Verdana"]], "InlineFormula",
 FontWeight->"Bold"]], "SeeAlso",
 CellID->929782353],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["ColorListFunction",
   BaseStyle->"Link",
   ButtonData->"paclet:Classroom Utilities/ref/ColorListFunction"],
  FontFamily->"Verdana"]], "InlineFormula",
 FontWeight->"Bold"]], "SeeAlso",
 CellID->1821912665]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[StyleBox[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"],
 FontWeight->"Bold"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MakeColorList - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 27, 49.6120624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "MakeColorList[\"name\", colorlist] creates a ColorListFunction to use in \
setting the colors of samples in SRSChart", "synonyms" -> {}, "title" -> 
    "MakeColorList", "titlemodifier" -> "", "windowtitle" -> "MakeColorList", 
    "type" -> "Symbol", "uri" -> "Classroom Utilities/ref/MakeColorList"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4937, 146, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->60384267]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 11900, 371}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[606, 21, 2770, 64, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3401, 89, 56, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3460, 92, 523, 15, 83, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[4020, 112, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->68169682],
Cell[4631, 132, 75, 1, 70, "Notes",
 CellID->1067943069],
Cell[4709, 135, 191, 6, 70, "Notes",
 CellID->1139717294]
}, Closed]],
Cell[CellGroupData[{
Cell[4937, 146, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->60384267],
Cell[CellGroupData[{
Cell[5451, 164, 195, 6, 31, "ExampleSection",
 CellID->483958410],
Cell[5649, 172, 67, 1, 32, "ExampleText",
 CellID->2064321729],
Cell[5719, 175, 127, 3, 28, "Input",
 CellID->309498371],
Cell[5849, 180, 70, 1, 32, "ExampleText",
 CellID->533728363],
Cell[CellGroupData[{
Cell[5944, 185, 237, 7, 28, "Input",
 CellID->333403422],
Cell[6184, 194, 956, 27, 49, "Output",
 CellID->726478531]
}, Open  ]],
Cell[CellGroupData[{
Cell[7177, 226, 262, 9, 28, "Input",
 CellID->1480137322],
Cell[7442, 237, 757, 21, 54, "Output",
 CellID->217404006]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8260, 265, 446, 13, 45, "SeeAlsoSection",
 CellID->1255426704],
Cell[8709, 280, 243, 7, 70, "SeeAlso",
 CellID->929782353],
Cell[8955, 289, 260, 7, 70, "SeeAlso",
 CellID->1821912665]
}, Open  ]],
Cell[CellGroupData[{
Cell[9252, 301, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[9703, 316, 231, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[9949, 324, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

