(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     16877,        489]
NotebookOptionsPosition[     13030,        375]
NotebookOutlinePosition[     15452,        438]
CellTagsIndexPosition[     15332,        432]
WindowTitle->MakePlotBands - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[Cell[
    BoxData[
     ActionMenuBox[
      FrameBox["\<\"URL \[RightGuillemet]\"\>",
       StripOnInput->False], {"\<\"Classroom Utilities/ref/MakePlotBands\"\>":>
      None, "\<\"Copy Mathematica URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["Classroom Utilities/ref/MakePlotBands"]}, Visible -> 
           False]]; SelectionMove[
        DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/MakePlotBands.html"], StandardForm]], "Input", 
             TextClipboardType -> "PlainText"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
           "http://reference.wolfram.com/mathematica/", 
            "Classroom Utilities/ref/MakePlotBands", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic]],
     LineSpacing->{1.4, 0}]], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["MakePlotBands", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MakePlotBands", "[", 
       RowBox[{
        RowBox[{
         StyleBox["fm", "TI"], "[", "\"\<\!\(\*
StyleBox[\"bands\", \"TI\"]\)\>\"", "]"}], ",", 
        StyleBox["conflvl", "TI"], ",", 
        StyleBox["var", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]creates a pure function from the FittedModel ",
     Cell[BoxData[
      StyleBox["fm", "TI"]], "InlineFormula"],
     " for the specified confidence bands ",
     Cell[BoxData[
      StyleBox["bands", "TI"]], "InlineFormula"],
     " with the confidence level ",
     Cell[BoxData[
      StyleBox["conlvl", "TI"]], "InlineFormula"],
     " using the variable ",
     Cell[BoxData[
      StyleBox["var", "TI"]], "InlineFormula"],
     " used in creating the fitted model ",
     Cell[BoxData[
      StyleBox["fm", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->514155456],

Cell["\<\
The variable used must be the same as the variable used to create the fitted \
model.\
\>", "Notes",
 CellID->1067943069],

Cell[TextData[{
 "Use ",
 ButtonBox["Set",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Set"],
 " to assign a name to the created function."
}], "Notes",
 CellID->1355027925],

Cell["\<\
It is usually best to follow the Set statement with a semi-colon.\
\>", "Notes",
 CellID->2037742687]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->177551536],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->219364559],

Cell["This loads the package.", "ExampleText",
 CellID->272138053],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1831572308],

Cell["Generate some data.", "ExampleText",
 CellID->1205184458],

Cell[BoxData[
 RowBox[{
  RowBox[{"data", "=", 
   RowBox[{"BlockRandom", "[", 
    RowBox[{
     RowBox[{"SeedRandom", "[", "12345", "]"}], ";", 
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{
          RowBox[{"Exp", "[", 
           RowBox[{
            RowBox[{"-", "2.3"}], " ", 
            RowBox[{"x", "/", 
             RowBox[{"(", 
              RowBox[{"11", " ", "+", 
               RowBox[{".4", " ", "x"}], "+", 
               RowBox[{"x", "^", "2"}]}], ")"}]}]}], "]"}], "+", 
          RowBox[{"RandomReal", "[", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"-", ".5"}], ",", ".5"}], "}"}], "]"}]}]}], "}"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", 
         RowBox[{"RandomReal", "[", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"1", ",", "15"}], "}"}], ",", "20"}], "]"}]}], "}"}]}], 
      "]"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->469427102],

Cell[TextData[{
 "Crete a ",
 ButtonBox["FittedModel",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/FittedModel"],
 "."
}], "ExampleText",
 CellID->1953867883],

Cell[BoxData[
 RowBox[{
  RowBox[{"nlm", "=", 
   RowBox[{"NonlinearModelFit", "[", 
    RowBox[{"data", ",", 
     RowBox[{"Exp", "[", 
      RowBox[{"a", " ", 
       RowBox[{"x", "/", 
        RowBox[{"(", 
         RowBox[{"b", "+", 
          RowBox[{"c", " ", "x"}]}], ")"}]}]}], "]"}], ",", 
     RowBox[{"{", 
      RowBox[{"a", ",", "b", ",", "c"}], "}"}], ",", "x"}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1485063304],

Cell["\<\
Create a pure function to visualize the mean prediction bands.\
\>", "ExampleText",
 CellID->1404004894],

Cell[BoxData[
 RowBox[{
  RowBox[{"meanBnds", "=", 
   RowBox[{"MakePlotBands", "[", 
    RowBox[{
     RowBox[{"nlm", "[", "\"\<MeanPredictionBands\>\"", "]"}], ",", ".95", 
     ",", "x"}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->559940222],

Cell["Visualize the bands.", "ExampleText",
 CellID->641970000],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Show", "[", 
  RowBox[{
   RowBox[{"ListPlot", "[", "data", "]"}], ",", 
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"nlm", "[", "t", "]"}], ",", 
       RowBox[{"meanBnds", "[", "t", "]"}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"t", ",", "1", ",", "15"}], "}"}], ",", 
     RowBox[{"Filling", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"2", "\[Rule]", 
        RowBox[{"{", "1", "}"}]}], "}"}]}]}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->631947472],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztXS3Tq7oafWfuLzlyyytrKysrK09lxRGYM1OLRCKxkbgbGRsZGYlFVlb2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    "], {{0, 120}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 120},
  PlotRange->{{0, 180}, {0, 120}}]], "Output",
 ImageSize->{184, 120},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[5]=",
 CellID->506354439]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MakePlotBands - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 27, 53.8708624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "MakePlotBands[fm[\"bands\"], conflvl, var] creates a pure function from \
the FittedModel fm for the specified confidence bands bands with the \
confidence level conlvl using the variable var used in creating the fitted \
model fm.", "synonyms" -> {}, "title" -> "MakePlotBands", "titlemodifier" -> 
    "", "windowtitle" -> "MakePlotBands", "type" -> "Symbol", "uri" -> 
    "Classroom Utilities/ref/MakePlotBands"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4825, 151, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->177551536]},
 "RasterizedOutput"->{
  Cell[8452, 286, 4512, 82, 141, "Output",
   CellTags->"RasterizedOutput",
   CellID->506354439]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15066, 421},
 {"RasterizedOutput", 15209, 425}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[606, 21, 1939, 43, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[2570, 68, 56, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[2629, 71, 1086, 32, 101, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3752, 108, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->514155456],
Cell[4364, 128, 131, 4, 70, "Notes",
 CellID->1067943069],
Cell[4498, 134, 176, 7, 70, "Notes",
 CellID->1355027925],
Cell[4677, 143, 111, 3, 70, "Notes",
 CellID->2037742687]
}, Closed]],
Cell[CellGroupData[{
Cell[4825, 151, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->177551536],
Cell[CellGroupData[{
Cell[5340, 169, 195, 6, 31, "ExampleSection",
 CellID->219364559],
Cell[5538, 177, 66, 1, 32, "ExampleText",
 CellID->272138053],
Cell[5607, 180, 128, 3, 28, "Input",
 CellID->1831572308],
Cell[5738, 185, 63, 1, 32, "ExampleText",
 CellID->1205184458],
Cell[5804, 188, 1008, 31, 65, "Input",
 CellID->469427102],
Cell[6815, 221, 161, 7, 32, "ExampleText",
 CellID->1953867883],
Cell[6979, 230, 450, 15, 28, "Input",
 CellID->1485063304],
Cell[7432, 247, 114, 3, 32, "ExampleText",
 CellID->1404004894],
Cell[7549, 252, 260, 8, 28, "Input",
 CellID->559940222],
Cell[7812, 262, 63, 1, 70, "ExampleText",
 CellID->641970000],
Cell[CellGroupData[{
Cell[7900, 267, 549, 17, 28, "Input",
 CellID->631947472],
Cell[8452, 286, 4512, 82, 141, "Output",
 CellTags->"RasterizedOutput",
 CellID->506354439]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[13003, 373, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

