(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     31601,        922]
NotebookOptionsPosition[     26709,        766]
NotebookOutlinePosition[     29071,        829]
CellTagsIndexPosition[     28951,        823]
WindowTitle->MakeRadiusFunction - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Working with Riemann Sums\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/WorkingWithRiemannSums"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Classroom Utilities/ref/MakeRadiusFunction\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/MakeRadiusFunction"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/MakeRadiusFunction.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/MakeRadiusFunction", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["MakeRadiusFunction", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MakeRadiusFunction", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["f", "TI"], 
           StyleBox["1", "TR"]], ",", 
          RowBox[{
           SubscriptBox[
            StyleBox["f", "TI"], 
            StyleBox[
             RowBox[{"2", ",", ",", " "}], "TR"]], 
           StyleBox["\[Ellipsis]", "TR"]}]}], "}"}], ",", " ", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", " ", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]creates an piecewise function of interpolating \
functions from the list of functions."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->58172101],

Cell[TextData[{
 "The list {",
 Cell[BoxData[
  RowBox[{
   SubscriptBox[
    StyleBox["f", "TI"], 
    StyleBox["1", "TR"]], ",", 
   SubscriptBox[
    StyleBox["f", "TI"], 
    StyleBox["2", "TR"]], ",", " ", 
   StyleBox["\[Ellipsis]", "TR"]}]], "InlineFormula"],
 "} can contain functions or vertical segments."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The functions should be strictly increasing or strictly decreasing on the \
interval ",
 Cell[BoxData[
  RowBox[{"(", 
   RowBox[{
    SubscriptBox[
     StyleBox["x", "TI"], 
     StyleBox["min", "TI"]], ",", " ", 
    SubscriptBox[
     StyleBox["x", "TI"], 
     StyleBox["max", "TI"]]}], ")"}]], "InlineFormula"],
 "."
}], "Notes",
 CellID->1637376011],

Cell["The function list can include vertical segments.", "Notes",
 CellID->1288790957]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->539421571],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->120281064],

Cell["This loads the package.", "ExampleText",
 CellID->1189550657],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1852622276],

Cell[TextData[{
 "Combine x and ",
 Cell[BoxData[
  RowBox[{"2", "-", 
   SuperscriptBox["x", "2"]}]], "InlineFormula"],
 " into a single function."
}], "ExampleText",
 CellID->657194879],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"radFn", "=", 
  RowBox[{"MakeRadiusFunction", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"2", "-", 
       SuperscriptBox["x", "2"]}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", "1"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->965934832],

Cell[BoxData[
 RowBox[{
  TagBox[GridBox[{
     {"\[Piecewise]", GridBox[{
        {
         RowBox[{
          TagBox[
           RowBox[{"InterpolatingFunction", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
            "]"}],
           False,
           Editable->False], "[", "#1", "]"}], 
         RowBox[{"0", "\[LessEqual]", "#1", "<", "1"}]},
        {
         RowBox[{
          TagBox[
           RowBox[{"InterpolatingFunction", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"1", ",", "2"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
            "]"}],
           False,
           Editable->False], "[", "#1", "]"}], 
         RowBox[{"1", "\[LessEqual]", "#1", "<", "2"}]},
        {"0", 
         TagBox["True",
          "PiecewiseDefault",
          AutoDelete->True]}
       },
       AllowedDimensions->{2, Automatic},
       Editable->True,
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxItemSize->{
        "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
         "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}},
       Selectable->True]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxItemSize->{
     "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.35]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   "Piecewise",
   DeleteWithContents->True,
   Editable->False,
   SelectWithContents->True,
   Selectable->False], "&"}]], "Output",
 ImageSize->{366, 43},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->626465811]
}, Open  ]],

Cell["Visualize your function.", "ExampleText",
 CellID->2046047883],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ParametricPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"radFn", "[", "z", "]"}], ",", "z"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", "0", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->271130170],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxd1ns01VkbB3CXULkkmYqRed0KGcyUVNIXryJhXFO9RUicjK4uXYgmlaSi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     "]]}},
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0., 0.9999230508498433}, {0., 2.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 ImageSize->{125, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->2071951903]
}, Open  ]],

Cell["Vertical segments can be included.", "ExampleText",
 CellID->1848297616],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"radFn2", "=", " ", 
  RowBox[{"MakeRadiusFunction", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"x", ",", 
      RowBox[{"3", "-", 
       SuperscriptBox["x", "2"]}], ",", 
      RowBox[{"MakeVerticalSegment", "[", 
       RowBox[{"1", ",", 
        RowBox[{"{", 
         RowBox[{"z", ",", "1", ",", "2"}], "}"}]}], "]"}]}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "0", ",", "1"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->987078257],

Cell[BoxData[
 RowBox[{
  TagBox[GridBox[{
     {"\[Piecewise]", GridBox[{
        {
         RowBox[{
          TagBox[
           RowBox[{"InterpolatingFunction", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
            "]"}],
           False,
           Editable->False], "[", "#1", "]"}], 
         RowBox[{"0", "\[LessEqual]", "#1", "<", "1"}]},
        {
         RowBox[{
          TagBox[
           RowBox[{"InterpolatingFunction", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"2", ",", "3"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
            "]"}],
           False,
           Editable->False], "[", "#1", "]"}], 
         RowBox[{"2", "\[LessEqual]", "#1", "<", "3"}]},
        {"1", 
         RowBox[{"1", "\[LessEqual]", "#1", "<", "2"}]},
        {"0", 
         TagBox["True",
          "PiecewiseDefault",
          AutoDelete->True]}
       },
       AllowedDimensions->{2, Automatic},
       Editable->True,
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxItemSize->{
        "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
         "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}},
       Selectable->True]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxItemSize->{
     "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.35]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   "Piecewise",
   DeleteWithContents->True,
   Editable->False,
   SelectWithContents->True,
   Selectable->False], "&"}]], "Output",
 ImageSize->{366, 57},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->513092324]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ParametricPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"radFn2", "[", "z", "]"}], ",", "z"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", "0", ",", "3"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1395846763],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxd1gtUTPsewPFdav5OUmIkjkZIeqgjbkWl3z9yHOXRQaU0k16DJNJDdI4U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     "]]}},
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0., 1.}, {0., 3.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 ImageSize->{92, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1700417022]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Possible Issues",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373],

Cell["\<\
The function will fail if the list of functions fails the horizontal line \
test.\
\>", "ExampleText",
 CellID->196514478],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{
      RowBox[{"3", "/", "2"}], "-", 
      SuperscriptBox["x", "2"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2136466307],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS2Xq7wWx2et+0nuxzj2yJGVlQ+y4gokFolEYiNxNzIWiYzEIpGRfXYI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    "], {{0, 115}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 115},
  PlotRange->{{0, 180}, {0, 115}}]], "Output",
 ImageSize->{184, 115},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[1]=",
 CellID->288935145]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeRadiusFunction", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{
      RowBox[{"3", "/", "2"}], "-", 
      SuperscriptBox["x", "2"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->998963799],

Cell[BoxData[
 RowBox[{
  StyleBox[
   RowBox[{"MakeRadiusFunction", "::", "ovrlp"}], "MessageName"], ":", 
  " ", "\<\"Two or more of the inverse function support intervals for the \
\[NoBreak]\\!\\(\\\"radii\\\"\\)\[NoBreak] are not disjoint.\"\>"}]], \
"Message", "MSG",
 CellLabel->"During evaluation of In[2]:=",
 CellID->557417547],

Cell[BoxData[
 RowBox[{"MakeRadiusFunction", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{
      FractionBox["3", "2"], "-", 
      SuperscriptBox["x", "2"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Output",
 ImageSize->{282, 32},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1193044215]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Working with Riemann Sums",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/WorkingWithRiemannSums"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["RELATED LINKS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "RelatedLinksSection",
 WholeCellGroupOpener->True,
 CellID->1584193535],

Cell[TextData[ButtonBox["RiemannSumPlot3D",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/ref/RiemannSumPlot3D"]], "RelatedLinks",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MakeRadiusFunction - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 27, 58.0204624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "MakeRadiusFunction[{f_1, f 2, , ...}, {x, x_min, x_max}] creates an \
piecewise function of interpolating functions from the list of functions.", 
    "synonyms" -> {}, "title" -> "MakeRadiusFunction", "titlemodifier" -> "", 
    "windowtitle" -> "MakeRadiusFunction", "type" -> "Symbol", "uri" -> 
    "Classroom Utilities/ref/MakeRadiusFunction"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5786, 181, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->539421571]},
 "RasterizedOutput"->{
  Cell[20560, 602, 3625, 67, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->288935145]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 28685, 812},
 {"RasterizedOutput", 28828, 816}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[611, 21, 2509, 58, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3145, 83, 61, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3209, 86, 1077, 33, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[4323, 124, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->58172101],
Cell[4934, 144, 349, 13, 70, "Notes",
 CellID->1067943069],
Cell[5286, 159, 374, 14, 70, "Notes",
 CellID->1637376011],
Cell[5663, 175, 86, 1, 70, "Notes",
 CellID->1288790957]
}, Closed]],
Cell[CellGroupData[{
Cell[5786, 181, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->539421571],
Cell[CellGroupData[{
Cell[6301, 199, 195, 6, 31, "ExampleSection",
 CellID->120281064],
Cell[6499, 207, 67, 1, 32, "ExampleText",
 CellID->1189550657],
Cell[6569, 210, 128, 3, 28, "Input",
 CellID->1852622276],
Cell[6700, 215, 187, 7, 34, "ExampleText",
 CellID->657194879],
Cell[CellGroupData[{
Cell[6912, 226, 333, 11, 30, "Input",
 CellID->965934832],
Cell[7248, 239, 2414, 72, 64, "Output",
 CellID->626465811]
}, Open  ]],
Cell[9677, 314, 68, 1, 32, "ExampleText",
 CellID->2046047883],
Cell[CellGroupData[{
Cell[9770, 319, 276, 9, 28, "Input",
 CellID->271130170],
Cell[10049, 330, 3160, 60, 237, "Output",
 CellID->2071951903]
}, Open  ]],
Cell[13224, 393, 78, 1, 70, "ExampleText",
 CellID->1848297616],
Cell[CellGroupData[{
Cell[13327, 398, 496, 15, 70, "Input",
 CellID->987078257],
Cell[13826, 415, 2486, 74, 78, "Output",
 CellID->513092324]
}, Open  ]],
Cell[CellGroupData[{
Cell[16349, 494, 278, 9, 70, "Input",
 CellID->1395846763],
Cell[16630, 505, 3127, 60, 237, "Output",
 CellID->1700417022]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[19806, 571, 278, 8, 70, "ExampleSection",
 CellID->1305812373],
Cell[20087, 581, 132, 4, 70, "ExampleText",
 CellID->196514478],
Cell[CellGroupData[{
Cell[20244, 589, 313, 11, 70, "Input",
 CellID->2136466307],
Cell[20560, 602, 3625, 67, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->288935145]
}, Open  ]],
Cell[CellGroupData[{
Cell[24222, 674, 326, 11, 70, "Input",
 CellID->998963799],
Cell[24551, 687, 337, 8, 70, "Message",
 CellID->557417547],
Cell[24891, 697, 414, 14, 53, "Output",
 CellID->1193044215]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25366, 718, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[25817, 733, 185, 4, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[26039, 742, 456, 13, 70, "RelatedLinksSection",
 CellID->1584193535],
Cell[26498, 757, 169, 4, 70, "RelatedLinks",
 CellID->1038487239]
}, Open  ]],
Cell[26682, 764, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

