(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     17258,        544]
NotebookOptionsPosition[     13391,        424]
NotebookOutlinePosition[     15578,        482]
CellTagsIndexPosition[     15493,        477]
WindowTitle->MakeVerticalSegment - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Working with Riemann Sums\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/WorkingWithRiemannSums"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Classroom Utilities/ref/MakeVerticalSegment\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/MakeVerticalSegment"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/MakeVerticalSegment.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/MakeVerticalSegment", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["MakeVerticalSegment", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MakeVerticalSegment", "[", 
       RowBox[{
        StyleBox["val", "TI"], ",", " ", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["z", "TI"], ",", 
          SubscriptBox[
           StyleBox["z", "TI"], 
           StyleBox["min", "TI"]], ",", " ", 
          SubscriptBox[
           StyleBox["z", "TI"], 
           StyleBox["max", "TI"]]}], "}"}]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]creates a VerticalSegment for use in \
MakeRadiusFunction and RiemannSumPlot3D."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->264479827],

Cell[TextData[{
 "This creates a vertical line segment ",
 Cell[BoxData[
  StyleBox["val", "TI"]], "InlineFormula"],
 " units from the vertical axis for values between ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["z", "TI"], 
   StyleBox["min", "TI"]]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["z", "TI"], 
   StyleBox["max", "TI"]]], "InlineFormula"],
 "."
}], "Notes",
 CellID->1067943069]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->153846437],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->50247315],

Cell["This loads the package.", "ExampleText",
 CellID->1582839477],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1903154550],

Cell["\<\
Create a VerticalSegment with a value of 3/2 on the interval (1,2)\
\>", "ExampleText",
 CellID->1697083432],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"vrtSg1", "=", " ", 
  RowBox[{"MakeVerticalSegment", "[", 
   RowBox[{
    RowBox[{"3", "/", "2"}], ",", 
    RowBox[{"{", 
     RowBox[{"z", ",", "1", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->3442170],

Cell[BoxData[
 RowBox[{"VerticalSegment", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"1", ",", "2"}], "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
     FractionBox["3", "2"], ",", 
     RowBox[{"1", "\[LessEqual]", "z", "<", "2"}]}], "}"}]}], "]"}]], "Output",
 ImageSize->{276, 32},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->2017976368]
}, Open  ]],

Cell["\<\
Use the vertical segment in MakeRadiusFunction to create a piecewise \
interpolating function.\
\>", "ExampleText",
 CellID->919579905],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"fn1", "=", " ", 
  RowBox[{"MakeRadiusFunction", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"x", "-", "1"}], ",", "vrtSg1"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "1", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->2087139523],

Cell[BoxData[
 RowBox[{
  TagBox[GridBox[{
     {"\[Piecewise]", GridBox[{
        {
         RowBox[{
          TagBox[
           RowBox[{"InterpolatingFunction", "[", 
            RowBox[{
             RowBox[{"{", 
              RowBox[{"{", 
               RowBox[{"0", ",", "1"}], "}"}], "}"}], ",", "\<\"<>\"\>"}], 
            "]"}],
           False,
           Editable->False], "[", "#1", "]"}], 
         RowBox[{"0", "\[LessEqual]", "#1", "<", "1"}]},
        {
         FractionBox["3", "2"], 
         RowBox[{"1", "\[LessEqual]", "#1", "<", "2"}]},
        {"0", 
         TagBox["True",
          "PiecewiseDefault",
          AutoDelete->True]}
       },
       AllowedDimensions->{2, Automatic},
       Editable->True,
       GridBoxAlignment->{
        "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}},
          "RowsIndexed" -> {}},
       GridBoxItemSize->{
        "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
         "RowsIndexed" -> {}},
       GridBoxSpacings->{"Columns" -> {
           Offset[0.27999999999999997`], {
            Offset[0.84]}, 
           Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
           Offset[0.2], {
            Offset[0.4]}, 
           Offset[0.2]}, "RowsIndexed" -> {}},
       Selectable->True]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Left}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxItemSize->{
     "Columns" -> {{Automatic}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.35]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}],
   "Piecewise",
   DeleteWithContents->True,
   Editable->False,
   SelectWithContents->True,
   Selectable->False], "&"}]], "Output",
 ImageSize->{366, 53},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1556072963]
}, Open  ]],

Cell["Visualize the function.", "ExampleText",
 CellID->862435975],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ParametricPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"fn1", "[", "z", "]"}], ",", "z"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"z", ",", "0", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1594298222],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxF0300lHkUB/DBCikxR1PK29RUQ2VtSuntTiIqUkJvqFFhyCYZqs2WQoUy
pHQ2Z7M1HE3WZnO2mgrhCC02WjSkaI7QeB4zxngZ47ev8/zuOfd87+e/7z+X
GXLc96gujUbj/b3/5H8zBNqra8G440XdIQhRM+ouWbhBubuCO01faz9ISJNW
zZiu9RH4N8y1joWR5VmznNhaJ4HsAMsmdKfW2dDx2HPj73laC8FhlT7NxkcO
db67aUPyUkiFlgipXA4JY04/b7Euh2f97JhTmQro8vbIrEqrhtB9ismsjcPg
+Drrc46yDuYHNDjafhyGPx5GpOjoNMHmuZZ9ThlKoHOj85rWN4PHGcU6xroR
sO6vI/fK3oI/T7ImsmMEduXzPhVFtUGrlfPTLVdUEBzfLp23SAJHDt7ryV46
ClkJV1N3F3fCa86twpL6UWDrce/W2H+Ags80hV/8GHg36UjvEx/h6vzvpBFz
x8Fitar2T8ceGDDn7Td4NQ7Nds2lJtc+gW1x17GYmAlYH/jinVQqhQNvj7J3
0tUgLny9M4/VC2YVh8JKy9XAOv+yMfzcZ2hZE+WTxp2EuyckPzKq+sAoflDc
Z6qBmYSE/4Y5AAz/kUrzFxqwEw0k2535AssqTGIfBU3BvvNWfaHPZPBi6HZh
uzECfvfqXSVzCPg1km542ARBSBvLtMaSgMLey2GDpgh2NJg1SZgE3OzkL9Zl
IGA//eL11TICjtf6CJfaIugQ3PHcwyHAJk8v7/uVCDZxDDiacAKSfSJzWEEI
Zt5pddgqJuBsfbeq+CCCieyqwaByAvjuewNcQhD0pj4siqkmgLvOffaOMAQV
can2uY0EuCyxuR5/AsHJHRsXkz0EyKaar9UnI3inybe6YUyCb/HalOhiBPmB
/BndgSTUeSy0JR4iEGRs4XRySdjQbSyOfITgbOWc2LZQEuzN3w+GPkHgxxZ3
NESTQDtzzj+oEoGuckokTiLhF/dq1rZWBMFpl7dmF5HA+lBU9qodwbayfQkZ
JST8cOrGXvcOBKvk9iWpv5GQ8iA0nfMRwYw9DXMTK0gINDNSOg8gEC+g90W9
JaFZJL9aKkNQ4P9pPu8dCZ5ukiUrSASZl0t9jnSRsDL+wYHlSgThRMDj/X0k
PDDNHhGp/u7HZH/xHyTBVnQ2gz2OAPzGrXcpSLi5+ahdgRqB/aV6X69REozf
e1ctnELAEN9O8Zgk///LMTgf5xz0E/WnY6CaZTNqrYd97L5BZq4+do/rkP08
Q+xG/svg2TOxnxZmZZnSsQUmqyamWWKHxbZxNYuwZ3Msvxlwwa4y5tLavLGd
rRzOeQuxRQ5qTdUE9u2uAuHCXDllXb+aRqPtCsquvKgbZSrsdOPF+r03hyl7
nfQdu+6mpMwIF2SX9mI/mfRvuJc8QvlNQMYVixUqysMbJIROC3b6wK226MRR
yl+zeDxf1hjur6nI0a3Gzs1N3+pyYpxyTi1P2EOfoGwkFl+gV2L7bb+uMf1W
TbmQl8C8YDJJ+aR3R+3p59geZdsspMEaysrGTdOsprDn5BfFdYqmKBe3Rlzk
q7HdDO0EJl6IslONtWz6aewFSeaeBgXY8w7Pikt+jm3mOl2o14KdXmLwzLUL
25Cp35zYj13TfjGISWInCXT7K5TYh2UviwWj2K6eibGHJrCZQs5aR43W1HD+
AvScyrk=
     "]]}},
  Axes->True,
  AxesOrigin->{1., 0},
  PlotRange->{{0.9558652894965181, 1.9995458249157447`}, {0., 2.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 ImageSize->{125, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1216753535]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Working with Riemann Sums",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/WorkingWithRiemannSums"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["RELATED LINKS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "RelatedLinksSection",
 WholeCellGroupOpener->True,
 CellID->1584193535],

Cell[TextData[ButtonBox["MakeRadiusFunction",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/ref/MakeRadiusFunction"]], "RelatedLinks",
 CellID->1038487239]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MakeVerticalSegment - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 28, 5.7736624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "MakeVerticalSegment[val, {z, z_min, z_max}] creates a VerticalSegment \
for use in MakeRadiusFunction and RiemannSumPlot3D.", "synonyms" -> {}, 
    "title" -> "MakeVerticalSegment", "titlemodifier" -> "", "windowtitle" -> 
    "MakeVerticalSegment", "type" -> "Symbol", "uri" -> 
    "Classroom Utilities/ref/MakeVerticalSegment"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5085, 155, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->153846437]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15350, 470}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[612, 21, 2513, 58, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3150, 83, 62, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3215, 86, 761, 23, 83, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[4013, 114, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->264479827],
Cell[4625, 134, 423, 16, 70, "Notes",
 CellID->1067943069]
}, Closed]],
Cell[CellGroupData[{
Cell[5085, 155, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->153846437],
Cell[CellGroupData[{
Cell[5600, 173, 194, 6, 31, "ExampleSection",
 CellID->50247315],
Cell[5797, 181, 67, 1, 32, "ExampleText",
 CellID->1582839477],
Cell[5867, 184, 128, 3, 28, "Input",
 CellID->1903154550],
Cell[5998, 189, 118, 3, 32, "ExampleText",
 CellID->1697083432],
Cell[CellGroupData[{
Cell[6141, 196, 256, 8, 28, "Input",
 CellID->3442170],
Cell[6400, 206, 419, 14, 53, "Output",
 CellID->2017976368]
}, Open  ]],
Cell[6834, 223, 145, 4, 32, "ExampleText",
 CellID->919579905],
Cell[CellGroupData[{
Cell[7004, 231, 313, 10, 28, "Input",
 CellID->2087139523],
Cell[7320, 243, 2125, 63, 74, "Output",
 CellID->1556072963]
}, Open  ]],
Cell[9460, 309, 66, 1, 70, "ExampleText",
 CellID->862435975],
Cell[CellGroupData[{
Cell[9551, 314, 275, 9, 70, "Input",
 CellID->1594298222],
Cell[9829, 325, 2154, 44, 237, "Output",
 CellID->1216753535]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12044, 376, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[12495, 391, 185, 4, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[12717, 400, 456, 13, 70, "RelatedLinksSection",
 CellID->1584193535],
Cell[13176, 415, 173, 4, 70, "RelatedLinks",
 CellID->1038487239]
}, Open  ]],
Cell[13364, 422, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

