(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     25782,        690]
NotebookOptionsPosition[     20962,        538]
NotebookOutlinePosition[     24167,        629]
CellTagsIndexPosition[     24022,        622]
WindowTitle->Marker - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["APPLIED STATISTICS SYMBOL", "PacletNameCell"], Cell[TextData[Cell[
    BoxData[
     ActionMenuBox[
      FrameBox["\<\"URL \[RightGuillemet]\"\>",
       StripOnInput->False], {"\<\"AppliedStatistics/ref/Marker\"\>":>
      None, "\<\"Copy Mathematica URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["AppliedStatistics/ref/Marker"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/mathematica/AppliedStatistics/\
ref/Marker.html"], StandardForm]], "Input", TextClipboardType -> 
             "PlainText"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
           "http://reference.wolfram.com/mathematica/", 
            "AppliedStatistics/ref/Marker", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic]],
     LineSpacing->{1.4, 0}]], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Marker", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Marker", "[", 
       StyleBox["i", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]creates the ",
     Cell[BoxData[
      SuperscriptBox[
       StyleBox["i", "TI"], 
       StyleBox["th", "TI"]]], "InlineFormula"],
     " marker in the set of twenty built\[Hyphen]in markers."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Marker", "[", 
       RowBox[{
        StyleBox["i", "TI"], ",", 
        StyleBox["col", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]",
     "creates the ",
     Cell[BoxData[
      SuperscriptBox[
       StyleBox["i", "TI"], 
       StyleBox["th", "TI"]]], "InlineFormula"],
     " marker from the set of twenty and renders it with the color ",
     Cell[BoxData[
      StyleBox["col", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->226294060],

Cell[TextData[{
 "To use the ",
 Cell[BoxData["Marker"], "InlineFormula"],
 " function, you must first load the ",
 ButtonBox["Applied Statistics Package",
  BaseStyle->"Link",
  ButtonData->"paclet:AppliedStatistics/guide/AppliedStatistics"],
 " using ",
 Cell[BoxData[
  RowBox[{"Needs", "[", "\"\<AppliedStatistics`\>\"", "]"}]], "InlineFormula"],
 "."
}], "Notes",
 CellID->633225749],

Cell[TextData[{
 Cell[BoxData["Marker"], "InlineFormula"],
 " is an auxiliary function that defines a number of plot marker symbols."
}], "Notes",
 CellID->1067943069]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->1071902],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->119349883],

Cell["This loads the package.", "ExampleText",
 CellID->123283687],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AppliedStatistics`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1854691701],

Cell["\<\
Here is a table of the 20 built\[Hyphen]in markers.\
\>", "ExampleText",
 CellTags->"Marker",
 CellID->847491216],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GraphicsGrid", "[", 
  RowBox[{
   RowBox[{"Partition", "[", 
    RowBox[{
     RowBox[{"Table", "[", 
      RowBox[{
       RowBox[{"Marker", "[", "i", "]"}], ",", 
       RowBox[{"{", 
        RowBox[{"i", ",", "20"}], "}"}]}], "]"}], ",", "5"}], "]"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", "300"}]}], "]"}]], "Input",
 CellTags->"Marker",
 CellLabel->"In[2]:=",
 CellID->241535868],

Cell[BoxData[
 GraphicsBox[{{}, {{InsetBox[
      GraphicsBox[
       LineBox[{{1., 0.}, {-0.5, 
        0.8660254037844386}, {-0.5, -0.8660254037844386}, {1., 0.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {195., -194.4}, 
      ImageScaled[{0.5, 0.5}], {360., 360.00000000000006`}], InsetBox[
      GraphicsBox[
       LineBox[{{0.8660254037844386, 0.5}, {-0.8660254037844386, 0.5}, {
        0., -1.}, {0.8660254037844386, 0.5}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {585., -194.4}, 
      ImageScaled[{0.5, 0.5}], {360., 360.00000000000006`}], InsetBox[
      GraphicsBox[
       LineBox[{{0.5, 0.8660254037844386}, {-1., 0.}, {
        0.5, -0.8660254037844386}, {0.5, 0.8660254037844386}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {975., -194.4}, 
      ImageScaled[{0.5, 0.5}], {360., 360.00000000000006`}], InsetBox[
      GraphicsBox[
       LineBox[{{0., 1.}, {-0.8660254037844386, -0.5}, {
        0.8660254037844386, -0.5}, {0., 1.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {1365., -194.4}, 
      ImageScaled[{0.5, 0.5}], {360., 360.00000000000006`}], InsetBox[
      GraphicsBox[
       LineBox[{{1., 0.}, {0., 1.}, {-1., 0.}, {0., -1.}, {1., 0.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {1755., -194.4}, 
      ImageScaled[{0.5, 0.5}], {360., 360.00000000000006`}]}, {InsetBox[
      GraphicsBox[
       LineBox[{{0.7071067811865475, 
        0.7071067811865475}, {-0.7071067811865475, 
        0.7071067811865475}, {-0.7071067811865475, -0.7071067811865475}, {
        0.7071067811865475, -0.7071067811865475}, {0.7071067811865475, 
        0.7071067811865475}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {195., -583.2}, 
      ImageScaled[{0.5, 0.5}], {360., 360.00000000000006`}], InsetBox[
      GraphicsBox[
       LineBox[{{1., 0.}, {-0.8090169943749475, 0.5877852522924731}, {
        0.30901699437494745`, -0.9510565162951535}, {0.30901699437494745`, 
        0.9510565162951535}, {-0.8090169943749475, -0.5877852522924731}, {1., 
        0.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {585., -583.2}, 
      ImageScaled[{0.5, 0.5}], {360., 360.00000000000006`}], InsetBox[
      GraphicsBox[
       LineBox[{{0., 1.}, {-0.5877852522924731, -0.8090169943749475}, {
        0.9510565162951535, 0.30901699437494745`}, {-0.9510565162951535, 
        0.30901699437494745`}, {0.5877852522924731, -0.8090169943749475}, {0.,
         1.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {975., -583.2}, 
      ImageScaled[{0.5, 0.5}], {360., 360.00000000000006`}], InsetBox[
      GraphicsBox[
       LineBox[{{-1., 0.}, {
        0.8090169943749475, -0.5877852522924731}, {-0.30901699437494745`, 
        0.9510565162951535}, {-0.30901699437494745`, -0.9510565162951535}, {
        0.8090169943749475, 0.5877852522924731}, {-1., 0.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {1365., -583.2}, 
      ImageScaled[{0.5, 0.5}], {360., 360.00000000000006`}], InsetBox[
      GraphicsBox[
       LineBox[{{0., -1.}, {0.5877852522924731, 
        0.8090169943749475}, {-0.9510565162951535, -0.30901699437494745`}, {
        0.9510565162951535, -0.30901699437494745`}, {-0.5877852522924731, 
        0.8090169943749475}, {0., -1.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {1755., -583.2}, 
      ImageScaled[{0.5, 0.5}], {360., 360.00000000000006`}]}, {InsetBox[
      GraphicsBox[
       PolygonBox[{{0., -1.}, {0.5877852522924731, 
        0.8090169943749475}, {-0.9510565162951535, -0.30901699437494745`}, {
        0.9510565162951535, -0.30901699437494745`}, {-0.5877852522924731, 
        0.8090169943749475}, {0., -1.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {195., -972.}, 
      ImageScaled[{0.5, 0.5}], {360., 360.}], InsetBox[
      GraphicsBox[
       PolygonBox[{{-1., 0.}, {
        0.8090169943749475, -0.5877852522924731}, {-0.30901699437494745`, 
        0.9510565162951535}, {-0.30901699437494745`, -0.9510565162951535}, {
        0.8090169943749475, 0.5877852522924731}, {-1., 0.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {585., -972.}, 
      ImageScaled[{0.5, 0.5}], {360., 360.}], InsetBox[
      GraphicsBox[
       PolygonBox[{{0., 1.}, {-0.5877852522924731, -0.8090169943749475}, {
        0.9510565162951535, 0.30901699437494745`}, {-0.9510565162951535, 
        0.30901699437494745`}, {0.5877852522924731, -0.8090169943749475}, {0.,
         1.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {975., -972.}, 
      ImageScaled[{0.5, 0.5}], {360., 360.}], InsetBox[
      GraphicsBox[
       PolygonBox[{{1., 0.}, {-0.8090169943749475, 0.5877852522924731}, {
        0.30901699437494745`, -0.9510565162951535}, {0.30901699437494745`, 
        0.9510565162951535}, {-0.8090169943749475, -0.5877852522924731}, {1., 
        0.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {1365., -972.}, 
      ImageScaled[{0.5, 0.5}], {360., 360.}], InsetBox[
      GraphicsBox[
       PolygonBox[{{0.7071067811865475, 
        0.7071067811865475}, {-0.7071067811865475, 
        0.7071067811865475}, {-0.7071067811865475, -0.7071067811865475}, {
        0.7071067811865475, -0.7071067811865475}, {0.7071067811865475, 
        0.7071067811865475}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {1755., -972.}, 
      ImageScaled[{0.5, 0.5}], {360., 360.}]}, {InsetBox[
      GraphicsBox[
       PolygonBox[{{1., 0.}, {0., 1.}, {-1., 0.}, {0., -1.}, {1., 0.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {195., -1360.8000000000002`}, 
      ImageScaled[{0.5, 0.5}], {360., 359.9999999999998}], InsetBox[
      GraphicsBox[
       PolygonBox[{{0., 1.}, {-0.8660254037844386, -0.5}, {
        0.8660254037844386, -0.5}, {0., 1.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {585., -1360.8000000000002`}, 
      ImageScaled[{0.5, 0.5}], {360., 359.9999999999998}], InsetBox[
      GraphicsBox[
       PolygonBox[{{0.5, 0.8660254037844386}, {-1., 0.}, {
        0.5, -0.8660254037844386}, {0.5, 0.8660254037844386}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {975., -1360.8000000000002`}, 
      ImageScaled[{0.5, 0.5}], {360., 359.9999999999998}], InsetBox[
      GraphicsBox[
       PolygonBox[{{0.8660254037844386, 0.5}, {-0.8660254037844386, 0.5}, {
        0., -1.}, {0.8660254037844386, 0.5}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {1365., -1360.8000000000002`}, 
      ImageScaled[{0.5, 0.5}], {360., 359.9999999999998}], InsetBox[
      GraphicsBox[
       PolygonBox[{{1., 0.}, {-0.5, 
        0.8660254037844386}, {-0.5, -0.8660254037844386}, {1., 0.}}],
       PlotRange->{{-1, 1}, {-1, 1}}], {1755., -1360.8000000000002`}, 
      ImageScaled[{0.5, 0.5}], {360., 359.9999999999998}]}}, {}},
  ContentSelectable->True,
  ImageSize->300,
  PlotRangePadding->{6, 5}]], "Output",
 ImageSize->{304, 239},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"Marker",
 CellLabel->"Out[2]=",
 CellID->1703055399]
}, Open  ]],

Cell[TextData[{
 "The markers can be used as ",
 Cell[BoxData["DataMarkers"], "InlineFormula"],
 " option values, typically with a size specification."
}], "ExampleText",
 CellTags->"Marker",
 CellID->15401331],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ModelPlot", "[", 
  RowBox[{
   RowBox[{"Range", "[", "10", "]"}], ",", 
   RowBox[{"{", "x", "}"}], ",", 
   RowBox[{"DataMarkers", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Marker", "[", "17", "]"}], ",", ".05"}], "}"}]}]}], 
  "]"}]], "Input",
 CellTags->"Marker",
 CellLabel->"In[3]:=",
 CellID->1113530],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxFz20w0wEcwPF/C2dtWKzlKaLzME6Uwk5n6HS5Dl2m0DpSOydXO9fqVQ+Y
lZtmnkNaYqLS8nSnO9JyeYjUjrtdRZ5OO5N1tprHIr3w+7343uf11yWFf4pH
IggiarP/ftZHHSCIBfaWvZYvJdEUtNWbNlfFQPN5wzUsH/Tol9P0q4moQpm0
9L0NFUkzXg+m6cGDPqWR90cMoMt5XjNlxgh2SE2sc5TLoNzCzF+Wvwa65hTU
llasg09WBXeOvyJCtxT5aqYPhZNA6r1cZ8O77aCWVxTf7GMK0jqTWRNtZqBE
WsawcjUHW8R/R6xyyaALicm6TaWAmsWOyoXrVNCYaiNXbViAjUSVJCvLCuRS
elmVAhqYy6kmngfuBJO4ip5OHXq2RjZu2moNet+oT20X2IB19JmfaUw6GPGD
NBCrQwsy42pD5LtAxVPlfOEZBmigWYod7XeDUwFSt4ZPqLHSQE8vsQW/FV0R
lMXZgfxIp+Fusj3oEdIkdB9Cxfpr/nlCB1AZxImND3AEHbvofdxldB+JzEp5
sQeMyZlYl2U4ge492u4xT2dQVUFdyh5DT6pz2U0xe0FLdl32o2foeG8L38vC
BSwv/1CivYw2RBIsZj86YOd218TLFQx/f4GTLELl3YqEhXHUdnTOfPMCnB4O
DeyvRGWeJxjnqtCEW3FG/UNUxbzU6vAY7cos9uXXow/2azwYbShHnGd7cQil
TZYuLX9EBw9XqyUqNHyqraR9BPULGqdRvqJUjR+5RYP2BwfPHptFhYURfaNa
dPVIoshUh84WC7cl/ELlWsmk7jeaxC5/k72IqucabzauoEWh7dywNTS67G2w
+g+6Y37QPn0d7QlTr2xsoP8AzvUmaQ==
      "]]}}, GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGAQAWIQDQEf7FFpBgdUmgONFkCjRdBoCTRaBo1WQKOV0GgV
NHrwug8AV/8Slg==
    "], {
     {Hue[0.67, 0.6, 0.6], InsetBox[
       GraphicsBox[
        PolygonBox[{{0., 1.}, {-0.8660254037844386, -0.5}, {
         0.8660254037844386, -0.5}, {0., 1.}}],
        PlotRange->{{-1, 1}, {-1, 1}}], 11, Automatic, Scaled[{0.05, 0.05}]], 
      InsetBox[
       GraphicsBox[
        PolygonBox[{{0., 1.}, {-0.8660254037844386, -0.5}, {
         0.8660254037844386, -0.5}, {0., 1.}}],
        PlotRange->{{-1, 1}, {-1, 1}}], 12, Automatic, Scaled[{0.05, 0.05}]], 
      InsetBox[
       GraphicsBox[
        PolygonBox[{{0., 1.}, {-0.8660254037844386, -0.5}, {
         0.8660254037844386, -0.5}, {0., 1.}}],
        PlotRange->{{-1, 1}, {-1, 1}}], 13, Automatic, Scaled[{0.05, 0.05}]], 
      InsetBox[
       GraphicsBox[
        PolygonBox[{{0., 1.}, {-0.8660254037844386, -0.5}, {
         0.8660254037844386, -0.5}, {0., 1.}}],
        PlotRange->{{-1, 1}, {-1, 1}}], 14, Automatic, Scaled[{0.05, 0.05}]], 
      InsetBox[
       GraphicsBox[
        PolygonBox[{{0., 1.}, {-0.8660254037844386, -0.5}, {
         0.8660254037844386, -0.5}, {0., 1.}}],
        PlotRange->{{-1, 1}, {-1, 1}}], 15, Automatic, Scaled[{0.05, 0.05}]], 
      InsetBox[
       GraphicsBox[
        PolygonBox[{{0., 1.}, {-0.8660254037844386, -0.5}, {
         0.8660254037844386, -0.5}, {0., 1.}}],
        PlotRange->{{-1, 1}, {-1, 1}}], 16, Automatic, Scaled[{0.05, 0.05}]], 
      InsetBox[
       GraphicsBox[
        PolygonBox[{{0., 1.}, {-0.8660254037844386, -0.5}, {
         0.8660254037844386, -0.5}, {0., 1.}}],
        PlotRange->{{-1, 1}, {-1, 1}}], 17, Automatic, Scaled[{0.05, 0.05}]], 
      InsetBox[
       GraphicsBox[
        PolygonBox[{{0., 1.}, {-0.8660254037844386, -0.5}, {
         0.8660254037844386, -0.5}, {0., 1.}}],
        PlotRange->{{-1, 1}, {-1, 1}}], 18, Automatic, Scaled[{0.05, 0.05}]], 
      InsetBox[
       GraphicsBox[
        PolygonBox[{{0., 1.}, {-0.8660254037844386, -0.5}, {
         0.8660254037844386, -0.5}, {0., 1.}}],
        PlotRange->{{-1, 1}, {-1, 1}}], 19, Automatic, Scaled[{0.05, 0.05}]], 
      InsetBox[
       GraphicsBox[
        PolygonBox[{{0., 1.}, {-0.8660254037844386, -0.5}, {
         0.8660254037844386, -0.5}, {0., 1.}}],
        PlotRange->{{-1, 1}, {-1, 1}}], 20, Automatic, 
       Scaled[{0.05, 0.05}]]}, {}}]},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{2., 2.},
  PlotRange->All,
  PlotRangeClipping->True,
  PlotRangePadding->{Automatic, Automatic}]], "Output",
 ImageSize->{184, 113},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"Marker",
 CellLabel->"Out[3]=",
 CellID->1590043777]
}, Open  ]],

Cell["Here the second argument is used to color the markers blue.", \
"ExampleText",
 CellTags->"Marker",
 CellID->214659963],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ModelPlot", "[", 
  RowBox[{
   RowBox[{"Range", "[", "10", "]"}], ",", 
   RowBox[{"{", "x", "}"}], ",", 
   RowBox[{"DataMarkers", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Marker", "[", 
       RowBox[{"17", ",", "Red"}], "]"}], ",", ".05"}], "}"}]}]}], 
  "]"}]], "Input",
 CellTags->"Marker",
 CellLabel->"In[4]:=",
 CellID->446342696],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS2Qq0gUhVO1ZmRk7MiRkWMjIyMjF4nY2kJikUgkFonbllgkEhmLREay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    "], {{0, 113}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 113},
  PlotRange->{{0, 180}, {0, 113}}]], "Output",
 ImageSize->{184, 113},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->{"Marker", "RasterizedOutput"},
 CellLabel->"Out[4]=",
 CellID->469880208]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Marker - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 28, 9.7360624}", 
    "history" -> {"1.0", "", "", ""}, "context" -> "AppliedStatistics`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Applied Statistics Symbol", "language" -> "en", "paclet" -> 
    "AppliedStatistics", "status" -> "None", "summary" -> 
    "Marker[i] creates the i^th marker in the set of twenty built-in \
markers.Marker[i, col] creates the i^th marker from the set of twenty and \
renders it with the color col.", "synonyms" -> {}, "title" -> "Marker", 
    "titlemodifier" -> "", "windowtitle" -> "Marker", "type" -> "Symbol", 
    "uri" -> "AppliedStatistics/ref/Marker"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4869, 152, 488, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->1071902]},
 "Marker"->{
  Cell[5779, 186, 123, 4, 32, "ExampleText",
   CellTags->"Marker",
   CellID->847491216],
  Cell[5927, 194, 412, 13, 28, "Input",
   CellTags->"Marker",
   CellID->241535868],
  Cell[6342, 209, 6731, 130, 260, "Output",
   CellTags->"Marker",
   CellID->1703055399],
  Cell[13088, 342, 210, 6, 70, "ExampleText",
   CellTags->"Marker",
   CellID->15401331],
  Cell[13323, 352, 349, 12, 70, "Input",
   CellTags->"Marker",
   CellID->1113530],
  Cell[13675, 366, 3746, 84, 134, "Output",
   CellTags->"Marker",
   CellID->1590043777],
  Cell[17436, 453, 125, 3, 70, "ExampleText",
   CellTags->"Marker",
   CellID->214659963],
  Cell[17586, 460, 381, 13, 28, "Input",
   CellTags->"Marker",
   CellID->446342696],
  Cell[17970, 475, 2926, 56, 134, "Output",
   CellTags->{"Marker", "RasterizedOutput"},
   CellID->469880208]},
 "RasterizedOutput"->{
  Cell[17970, 475, 2926, 56, 134, "Output",
   CellTags->{"Marker", "RasterizedOutput"},
   CellID->469880208]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 22905, 583},
 {"Marker", 23036, 587},
 {"RasterizedOutput", 23886, 615}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[599, 21, 1889, 42, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[2513, 67, 49, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[2565, 70, 1060, 34, 146, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3662, 109, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->226294060],
Cell[4274, 129, 388, 12, 70, "Notes",
 CellID->633225749],
Cell[4665, 143, 167, 4, 70, "Notes",
 CellID->1067943069]
}, Closed]],
Cell[CellGroupData[{
Cell[4869, 152, 488, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->1071902],
Cell[CellGroupData[{
Cell[5382, 170, 195, 6, 31, "ExampleSection",
 CellID->119349883],
Cell[5580, 178, 66, 1, 32, "ExampleText",
 CellID->123283687],
Cell[5649, 181, 127, 3, 28, "Input",
 CellID->1854691701],
Cell[5779, 186, 123, 4, 32, "ExampleText",
 CellTags->"Marker",
 CellID->847491216],
Cell[CellGroupData[{
Cell[5927, 194, 412, 13, 28, "Input",
 CellTags->"Marker",
 CellID->241535868],
Cell[6342, 209, 6731, 130, 260, "Output",
 CellTags->"Marker",
 CellID->1703055399]
}, Open  ]],
Cell[13088, 342, 210, 6, 70, "ExampleText",
 CellTags->"Marker",
 CellID->15401331],
Cell[CellGroupData[{
Cell[13323, 352, 349, 12, 70, "Input",
 CellTags->"Marker",
 CellID->1113530],
Cell[13675, 366, 3746, 84, 134, "Output",
 CellTags->"Marker",
 CellID->1590043777]
}, Open  ]],
Cell[17436, 453, 125, 3, 70, "ExampleText",
 CellTags->"Marker",
 CellID->214659963],
Cell[CellGroupData[{
Cell[17586, 460, 381, 13, 28, "Input",
 CellTags->"Marker",
 CellID->446342696],
Cell[17970, 475, 2926, 56, 134, "Output",
 CellTags->{"Marker", "RasterizedOutput"},
 CellID->469880208]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[20935, 536, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

