(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     12140,        371]
NotebookOptionsPosition[      8833,        269]
NotebookOutlinePosition[     10917,        325]
CellTagsIndexPosition[     10832,        320]
WindowTitle->MatStyle - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Visualizing Statistical Concepts\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"SRSChart\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/SRSChart"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities/ref/MatStyle\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/MatStyle"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/MatStyle.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/MatStyle", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["MatStyle", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["MatStyle"], "InlineFormula"],
     "\[LineSeparator]an option for SRSChart to set the color of the \
background disk."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->355147667],

Cell["Any of GrayLevel, RGBColor or CMYKColor can be used.", "Notes",
 CellID->1067943069]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->357627],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->22277641],

Cell["This loads the package.", "ExampleText",
 CellID->1715663747],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->897667560],

Cell["Change the disk color to green.", "ExampleText",
 CellID->1026060745],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SRSChart", "[", 
  RowBox[{"7", ",", 
   RowBox[{"{", "2", "}"}], ",", 
   RowBox[{"MatStyle", "\[Rule]", " ", "Green"}], ",", 
   RowBox[{"Background", "\[Rule]", " ", 
    RowBox[{"GrayLevel", "[", ".5", "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->709255805],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0, 1, 0], DiskBox[{0, 0}, 2.6630281166371486`]}, 
   {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGBgBWJ2IGYC4plam3b9Nnm3X671deAOubv2q3wiXlRt+71f
Hsx/a898aPVPa02WAypQeRYoXxrC378aVf3+OVDz1KDys6B8eaj+hvfnJrF9
2bzf42GVyDr3//YrwfpfQ/nMDptiteutyn/t94TKw/g7wQ78YL8Gqh4s/fCR
/QSoedug8ujmV0D5OyDy+1ei6t8PM387VB7Gd4fo378G1X0HYPZ5QeUb0Mzf
nfdP9Jf5S3tYeJYXLeFq4Z9gAwvPnRD5/bDwhKrfDwvPTau/8buJr9gDC88d
UPNg4bkLyoeFJ9S99jD7IfHx2h7mP6j77GH+g/Fh/lsBVQ/z30aoeTD/oZsP
AFKtODM=
     "]], 
    {EdgeForm[{RGBColor[
     0.996078431372549, 0.3607843137254902, 0.027450980392156862`], Thickness[
      NCache[
       Rational[1, 24], 0.041666666666666664`]]}], 
     PolygonBox[{{{2.5201339250127166`, 0.45499999999999996`}, {
      1.7320508075688772`, 0.91}, {0.9439676901250381, 0.4550000000000003}, {
      0.9439676901250379, -0.4549999999999998}, {1.732050807568877, -0.91}, {
      2.520133925012716, -0.4550000000000004}, {2.5201339250127166`, 
      0.455}}, {{1.6541085212282778`, 1.955}, {0.8660254037844387, 2.41}, {
      0.07794228634059952, 1.9550000000000003`}, {0.0779422863405993, 
      1.0450000000000002`}, {0.8660254037844384, 0.59}, {1.6541085212282776`, 
      1.0449999999999995`}, {1.6541085212282778`, 1.955}}}]}}},
  Background->GrayLevel[0.5]]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->119663498]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["SRSChart",
   BaseStyle->"Link",
   ButtonData->"paclet:Classroom Utilities/ref/SRSChart"],
  FontFamily->"Verdana"]], "InlineFormula",
 FontWeight->"Bold"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[StyleBox[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"],
 FontWeight->"Bold"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MatStyle - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 28, 13.5892624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "MatStyle an option for SRSChart to set the color of the background \
disk.", "synonyms" -> {}, "title" -> "MatStyle", "titlemodifier" -> "", 
    "windowtitle" -> "MatStyle", "type" -> "Symbol", "uri" -> 
    "Classroom Utilities/ref/MatStyle"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4546, 132, 487, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->357627]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 10692, 313}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 2724, 62, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3350, 87, 51, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3404, 90, 366, 11, 83, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3807, 106, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->355147667],
Cell[4419, 126, 90, 1, 70, "Notes",
 CellID->1067943069]
}, Closed]],
Cell[CellGroupData[{
Cell[4546, 132, 487, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->357627],
Cell[CellGroupData[{
Cell[5058, 150, 194, 6, 31, "ExampleSection",
 CellID->22277641],
Cell[5255, 158, 67, 1, 32, "ExampleText",
 CellID->1715663747],
Cell[5325, 161, 127, 3, 28, "Input",
 CellID->897667560],
Cell[5455, 166, 75, 1, 32, "ExampleText",
 CellID->1026060745],
Cell[CellGroupData[{
Cell[5555, 171, 300, 8, 28, "Input",
 CellID->709255805],
Cell[5858, 181, 1463, 29, 201, "Output",
 CellID->119663498]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7382, 217, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[7831, 232, 241, 7, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[8109, 244, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[8560, 259, 231, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[8806, 267, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

