(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     14946,        422]
NotebookOptionsPosition[     11251,        311]
NotebookOutlinePosition[     13672,        375]
CellTagsIndexPosition[     13552,        369]
WindowTitle->MeanConfidenceChart - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Visualizing Statistical Concepts\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Classroom Utilities/ref/MeanConfidenceChart\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/MeanConfidenceChart"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/MeanConfidenceChart.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/MeanConfidenceChart", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["MeanConfidenceChart", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MeanConfidenceChart", "[", 
       RowBox[{
        StyleBox["data", "TI"], ",", 
        StyleBox["conflvl", "TI"], ",", 
        StyleBox["smplsz", "TI"], ",", 
        StyleBox["trls", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]plot ",
     Cell[BoxData[
      RowBox[{
       StyleBox["trls", "TI"], " ", 
       StyleBox["conflvl", "TI"]}]], "InlineFormula"],
     " confidence intervals of samples of size ",
     Cell[BoxData[
      StyleBox["smplsz", "TI"]], "InlineFormula"],
     " from the normally distributed ",
     Cell[BoxData[
      StyleBox["data", "TI"]], "InlineFormula"],
     " to visualize the concept of confidence level."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->821027454],

Cell["The distribution of the data is not checked.", "Notes",
 CellID->1067943069],

Cell["The confidence level conflvl must lie between 0 and 1.", "Notes",
 CellID->484556945],

Cell["The number of trial should probably not excede 50.", "Notes",
 CellID->690585191],

Cell["\<\
Some thought should be given when choosing sample sizes for best results.\
\>", "Notes",
 CellID->1663676749]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->130633984],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->573437967],

Cell["This loads the package", "ExampleText",
 CellID->1178036503],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1607764228],

Cell["\<\
Twenty-five samples of size fifty from a set of 1000 values and 90% \
confidence level.\
\>", "ExampleText",
 CellID->2054133442],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MeanConfidenceChart", "[", 
  RowBox[{
   RowBox[{"RandomVariate", "[", 
    RowBox[{
     RowBox[{"NormalDistribution", "[", "]"}], ",", "1000"}], "]"}], ",", 
   ".9", ",", "50", ",", "25"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->873650522],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnaGXozoUxuec9w+sXDty5ZNjKysrK7ey4r1zKrGVyEgsEveQWCQSiUUi
kXkXmO3QJCUhJOEy5DuzPS3LpAnz4+PjktL33/+cfv/19vb2L/z7D/51z6lp
pWkVhnl0uBlv2WvrIqQAPKIPHGwA/Bb499JTEGRFUWPxDc8GJp1PSdNQLGxQ
+v5O63rtTnhR2rb0dIzhCSo2qmrtTnhRCkcTOKbAEyx5w/sGGkVREcclReYb
ng0Mul7TsmyoZ8OL07EPGxQZGz5vPGmNc7dH2KA+b2BWz0aSsEusvmcY5mn6
uYui8g0JG/urgVwuNI5Hr/st0DQW3/F0iuEcdpBnA7NYNig9HGie23q7PK8e
BxSKjI3pvAFbCbbVrgTjjaKnJVbZuN/zLPv6G2wob+yTDWe+AYeS8+npzWb7
hhFjFzUiZQP2IM8GsJFlL9ZepiQpo6gYL1mRDYaEbfuGnSzk0jfupwhOYOu6
hZ+mf4xO4dMaCmM00j1+1NvOG9bYcJM38qQgx7Ct2qaqH4/sSquysV3fsNQ3
Z74RHoIiKXokGngcfph14FgG7/4lESqm2GD2iNl5Q29XtbODW8pCbvJGDknj
eH+A8XhkV8sFbNhA14Bv9H0ry5lvbIeNTfsGOd7hmDJ2jOE5sxrLRjc9DE57
J7untbWN5A2+b1LxAzQie2zYzht5XJBTyDiGkm909RAlNlouuUzLSN7g+yaV
DhsK8MvZMLQHGWeDHIIyLRnHUMobKmxoXSYzkDcwsSHPG+bYMJg3signJ8I7
hjHf0GVjM75B5X9VlWOKka1k1jc608hK3jGM5Q1zbKDNGyuyYS9vpGFKzkTo
GN431PX9fKNtWvIR/ClzsY7h84a6pGyo1DfYASokEHt5IzqT9J6+cgyLvqE1
6t35hi4by32jr5DfJxzDYt7QZWNXeQOew5JpWcobAEaRFhOOYc83FEe9c9/Q
20rL2UiCJLqQacewlzf09ogt5Q3OGDXyhjYbS/JGU7Vw3kobOu0Y3jfUJWVD
eK2HaQSDb4THex7lUsewlze02ZjOG/z2XitvQD+ZAQrZSNOndVbPGynJ4PRE
xTE25xs8G2v5Bj9A3tOkA3TsG11B4xCU+csqqM8bltjg+2aPDb28EV2iOEgU
HQOVbwyeMH0ijCdv2PINbsjCraThG1Veh4dA3TFQ5Y1h1E95Q4ENtm/8UYdb
4ihvmGNj7K7abHQFjaRUdwxUvqHSiNw3+m03DRhm31BpRCNvZFFGTuEsx0Ce
N1SO6Sp9Y/6smPMGw8bA9fK8oVgFXe4bQluby4Zw1AZ8Yz02+KOZPTZm+UYW
5eExnOsYenlDk43nbfeKjfHhQOWYrpKFbLDB980GG9REfQPOW+usnusYTvOG
LIGrNGLEN+SXAUVrbDRvpOQzacx1DHt5g9+6KnuEm7yhyMZ0I27yhrCRWXkD
wMjiTMMx7PmGIhto84a0kU34hl5Nw319Q3HTIckbTCM86pbqG2bzRnSN41ui
5xgu88amfYNnYxO+ASn0ceqKJ2/o7RF46hv8MX1zeaMuG2BD2zGEvqFyrXNv
vsE3gt834m5yV6TtGMK8wbAxvPzOeUN03iJtBH/e6KaRh/pnKCp5wzEbGmVD
I2xI983N+Ub45wNr+8wbZth4McDpvMGbDba8EfVnr1Z9g+4gbxgpoGHzjejj
tsQxTNU3+Gk5W8obPRvQzqxGjOQNveqxkI07o1sIJylhcB9+SBDqPWd0vSbv
7/V4yfFYHA75eMmvX/XlEj9eDmO83chX127k5892/CunU/rxUY6X/P13eT5n
4yU/frRBED1ewnNYMl4B1offmtW3oXvjl/C/sM54CbQA7YyXwBaA7TDRiErf
YLww6nELzFb6c0z8Ur+VqvESfivxfWNB6UU+bkscY3N5g9/T7B1TjNc3TLmr
ct647SpvuGRj6+cpBNgo1s8bpkYtzRu8Np037NY3TmFG7NY3KCrf4OR945XI
hYwvtOHJGypTxHXyBqcN5Q3qtr4xcfe/dX1DkQ0HvsGfJ7rxDb0JsSoTC2dc
oz/cEOaNYeBjrZU3FNkwnjcMsqE9f4Mcw+Fj0bh8g5ORqba8dpc3RPMVX6mb
YX7SnGFuMW9wUtkjlrMhnAPvJm9YmiwtZEPxNt1t94Xy3RQO5L7Bjlp09RMV
G3N9wxEbM7XwbIVpTZ43RLamx8bTt1u6qm8IC2jjvKECGN+3tmW3gKX6xiyB
dajfpceAb7yZ+cok/v7nbvKGtLiqwoZK3zD4Bu0/hpCGqbO8wUuDDWkjltgA
JpksYSZvcELCRlXWRPTdKJbyBq8NsaHTCGc1G2IDRM4k6VOHg/oGL1NsuMgb
nOT1DY4Nlb4ZYKN/3yV5Y1CXOsA6is36BhdjEPkGV8pz5BtvghvK6Sm5J4/b
2m8vb6zExqtJp5JrFqLZ6YyMHFMMKupu3TPvLhxMCyvmDT7+Gdnl9diQ1B43
yIbiPcxx5g1GKmw4yhuc4GSHKc7wwsYG7UJpmIXZFn2DEaq8oSGEbKh8ZwrG
vMFpXTaWf0cJQjZoF0ol37XkfWNuIxrCyQYdvg02LjadNxDVN7SElo0yrxQr
pcwvet8QNqIhtGzQ/v7VKpVS5rd83qCu8obKzEl7IodAWillf4fpcP9yh2w4
8I112RhuITgrbwjZkJZtfd7gJWeDk0s26OdNzqcqpUbeZR3fEHnalnyDk2M2
yqycrpQaeRfpqJWqnM9SZIP5I0ovofJaLW9wcswG7S/fDzN/VvQNK2yIZIqN
VXxDYyst1HSl1MhbSEfdtrQo5rWpkjd4afxZHeUN0VxKVs7ZAMW3OL5GtnxD
ZdTzZcY3FOTIN/qt1JjxacN69T1uBpq2Q/u6bNjIG8Z3H1N63HDSRt6wIR02
5nzs6yHhRPqlviH6AA5mPUphxvOGDenkDV02nvKGOTamv+4WleL+5uff2Tfg
nF3t84Bj8ccUAIP/+Mz3Vl014eFe5lVd1PBY9Y9FvDh12ZEeGxpSuWC0B4Vh
nmWfx5Fh14gOtzU79FqO2FC7YLQHVVVzvT5dHUHLhl59Y7Z6Npj6xm4FbFSj
mBF9IGXD2TEF/HNv6eKV4riMoq8aJVrfcMaG10NNQ8/nrwn0ng2vsS6Xr8MK
WjYc5Q2vZ8VxAUeW4bnPG15j1XX7OKyg9Q3PxloCNpqmS+eeDS9GQZAVeVcE
Q8uGzxtrKU0rQrozWZ83vBjBeQqcrVDEvuHZWFGHQ3e3IM+GF69rX+VAy4bP
GyuqvyZb+bzhxStJugsraH3Ds7GiwDTCe46WjVUm5HsNqqv2ckk8G15CHY8x
2rxBtSZ/eplSxwZa3/Dy8lqs/wFcc75D
    "], {{0, 112}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 112},
  PlotRange->{{0, 180}, {0, 112}}]], "Output",
 ImageSize->{184, 112},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->152771750]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MeanConfidenceChart - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 28, 17.3332624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "MeanConfidenceChart[data, conflvl, smplsz, trls] plot trls conflvl \
confidence intervals of samples of size smplsz from the normally distributed \
data to visualize the concept of confidence level.", "synonyms" -> {}, 
    "title" -> "MeanConfidenceChart", "titlemodifier" -> "", "windowtitle" -> 
    "MeanConfidenceChart", "type" -> "Symbol", "uri" -> 
    "Classroom Utilities/ref/MeanConfidenceChart"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5228, 155, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->130633984]},
 "RasterizedOutput"->{
  Cell[6585, 207, 3910, 72, 133, "Output",
   CellTags->"RasterizedOutput",
   CellID->152771750]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13286, 358},
 {"RasterizedOutput", 13429, 362}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[612, 21, 2528, 58, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3165, 83, 62, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3230, 86, 924, 27, 99, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[4191, 118, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->821027454],
Cell[4803, 138, 82, 1, 70, "Notes",
 CellID->1067943069],
Cell[4888, 141, 91, 1, 70, "Notes",
 CellID->484556945],
Cell[4982, 144, 87, 1, 70, "Notes",
 CellID->690585191],
Cell[5072, 147, 119, 3, 70, "Notes",
 CellID->1663676749]
}, Closed]],
Cell[CellGroupData[{
Cell[5228, 155, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->130633984],
Cell[CellGroupData[{
Cell[5743, 173, 195, 6, 31, "ExampleSection",
 CellID->573437967],
Cell[5941, 181, 66, 1, 32, "ExampleText",
 CellID->1178036503],
Cell[6010, 184, 128, 3, 28, "Input",
 CellID->1607764228],
Cell[6141, 189, 139, 4, 32, "ExampleText",
 CellID->2054133442],
Cell[CellGroupData[{
Cell[6305, 197, 277, 8, 28, "Input",
 CellID->873650522],
Cell[6585, 207, 3910, 72, 133, "Output",
 CellTags->"RasterizedOutput",
 CellID->152771750]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10556, 286, 448, 13, 45, "TutorialsSection",
 CellID->250839057],
Cell[11007, 301, 202, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[11224, 309, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

