(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     16095,        427]
NotebookOptionsPosition[     13232,        341]
NotebookOutlinePosition[     15356,        398]
CellTagsIndexPosition[     15271,        393]
WindowTitle->MonoColor - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/MonoColor\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/MonoColor"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/MonoColor.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/MonoColor", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["MonoColor", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["MonoColor"], "InlineFormula"],
     " \[LineSeparator]an option value for BarStyles in ",
     Cell[BoxData[
      ButtonBox["RiemannSumPlot",
       BaseStyle->"Link",
       ButtonData->"paclet:ClassroomUtilities/ref/RiemannSumPlot"]], 
      "InlineFormula"],
     " indicating all bars should have the same color."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->85018955],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->116204319],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1730717423],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot", "[", 
  RowBox[{
   RowBox[{"Cos", "[", "t", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", "\[Pi]"}], "}"}], ",", "17", ",", 
   "\"\<Center\>\"", ",", 
   RowBox[{"BarStyles", "\[Rule]", " ", "MonoColor"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->501729746],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
    AbsoluteThickness[0.4]}], 
    RectangleBox[{0., 0}, {0.18479956785822313`, 0.9957341762950345}], 
    RectangleBox[{0.18479956785822313`, 0}, \
{0.36959913571644626`, 0.961825643172819}], 
    RectangleBox[{0.36959913571644626`, 0}, \
{0.5543987035746694, 0.8951632913550623}], 
    RectangleBox[{0.5543987035746694, 0}, \
{0.7391982714328925, 0.7980172272802395}], 
    RectangleBox[{0.7391982714328925, 0}, \
{0.9239978392911157, 0.6736956436465572}], 
    RectangleBox[{0.9239978392911157, 0}, \
{1.1087974071493387`, 0.5264321628773558}], 
    RectangleBox[{1.1087974071493387`, 0}, \
{1.2935969750075618`, 0.36124166618715303`}], 
    RectangleBox[{1.2935969750075618`, 0}, \
{1.478396542865785, 0.1837495178165703}], 
    RectangleBox[{1.478396542865785, 0}, \
{1.663196110724008, 6.123233995736766*^-17}], 
    RectangleBox[{1.663196110724008, 0}, \
{1.8479956785822313`, -0.1837495178165702}], 
    RectangleBox[{1.8479956785822313`, 0}, \
{2.0327952464404544`, -0.3612416661871529}], 
    RectangleBox[{2.0327952464404544`, 0}, \
{2.2175948142986774`, -0.5264321628773558}], 
    RectangleBox[{2.2175948142986774`, 0}, \
{2.4023943821569005`, -0.6736956436465569}], 
    RectangleBox[{2.4023943821569005`, 0}, \
{2.5871939500151235`, -0.7980172272802395}], 
    RectangleBox[{2.5871939500151235`, 0}, \
{2.7719935178733466`, -0.895163291355062}], 
    RectangleBox[{2.7719935178733466`, 0}, \
{2.95679308573157, -0.961825643172819}], 
    RectangleBox[{2.95679308573157, 0}, \
{3.141592653589793, -0.9957341762950346}]}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwt1wkw180fB3BXv9/310lPVBSiQ64OJKHPkpxPQkm5KYWKqPQU6YnQJXIU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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 224},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->166551261]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->1568334398]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MonoColor - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 28, 20.6560624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "MonoColor an option value for BarStyles in RiemannSumPlot indicating all \
bars should have the same color.", "synonyms" -> {}, "title" -> "MonoColor", 
    "titlemodifier" -> "", "windowtitle" -> "MonoColor", "type" -> "Symbol", 
    "uri" -> "ClassroomUtilities/ref/MonoColor"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[3705, 104, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->85018955]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15129, 386}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[602, 21, 2420, 55, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3047, 80, 52, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3102, 83, 566, 16, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3705, 104, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->85018955],
Cell[CellGroupData[{
Cell[4219, 122, 195, 6, 31, "ExampleSection",
 CellID->116204319],
Cell[4417, 130, 128, 3, 28, "Input",
 CellID->1730717423],
Cell[CellGroupData[{
Cell[4570, 137, 326, 9, 28, "Input",
 CellID->501729746],
Cell[4899, 148, 7607, 162, 245, "Output",
 CellID->166551261]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12567, 317, 448, 13, 45, "MoreAboutSection",
 CellID->38303248],
Cell[13018, 332, 172, 4, 70, "MoreAbout",
 CellID->1568334398]
}, Open  ]],
Cell[13205, 339, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

