(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     17904,        590]
NotebookOptionsPosition[     13770,        460]
NotebookOutlinePosition[     15872,        516]
CellTagsIndexPosition[     15787,        511]
WindowTitle->MultiplyARow - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Elementary Matrix Operations\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/ElementaryMatrixOperations"], \
"\<\"Solving Linear Systems\"\>":>Documentation`HelpLookup[
       "paclet:tutorial/SolvingLinearSystems"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AddToRow\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/AddToRow"], "\<\"SwitchRows\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/SwitchRows"], "\<\"RowReduce\"\>":>
       Documentation`HelpLookup["paclet:ref/RowReduce"], "\<\"Inverse\"\>":>
       Documentation`HelpLookup["paclet:ref/Inverse"], "\<\"LinearSolve\"\>":>
       Documentation`HelpLookup[
       "paclet:ref/LinearSolve"], "\<\"NullSpace\"\>":>
       Documentation`HelpLookup["paclet:ref/NullSpace"], "\<\"Solve\"\>":>
       Documentation`HelpLookup["paclet:ref/Solve"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], "\<\"Matrix \
Operations\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/MatrixOperations"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/MultiplyARow\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/MultiplyARow"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/MultiplyARow.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/MultiplyARow", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["MultiplyARow", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"MultiplyARow", "[", 
       RowBox[{
        StyleBox["mat", "TI"], " ", ",", 
        SubscriptBox[
         StyleBox["row", "TI"], 
         StyleBox["n", "TI"]], " ", ",", 
        StyleBox["coef", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]multiply ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["row", "TI"], 
       StyleBox["n", "TI"]]], "InlineFormula"],
     " in the matrix ",
     Cell[BoxData[
      StyleBox["mat", "TI"]], "InlineFormula"],
     " by ",
     Cell[BoxData[
      StyleBox["coef", "TI"]], "InlineFormula"]
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->327851433],

Cell["MultiplyARow works with symbolic and numeric matrices", "Notes",
 CellID->1067943069],

Cell["The coef can be any expression", "Notes",
 CellID->1749259073],

Cell["The row specification should be a positive integer", "Notes",
 CellID->746112481],

Cell["The matrix need not be square", "Notes",
 CellID->755453334]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->476880002],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->249650990],

Cell["This loads the package.", "ExampleText",
 CellID->980863474],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1287933146],

Cell[TextData[{
 "Multiply the first row in a matrix by ",
 Cell[BoxData[
  FractionBox["1", "a"]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->646627935],

Cell[BoxData[
 RowBox[{
  RowBox[{"mat", "=", " ", 
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {"a", "b", "c"},
      {"d", "e", "f"},
      {"g", "h", "i"}
     }], "\[NoBreak]", ")"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1608449725],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MultiplyARow", "[", 
   RowBox[{"mat", ",", "1", ",", 
    RowBox[{"1", "/", "a"}]}], "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->690379639],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", 
      FractionBox["b", "a"], 
      FractionBox["c", "a"]},
     {"d", "e", "f"},
     {"g", "h", "i"}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{67, 52},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]//MatrixForm=",
 CellID->1488501641]
}, Open  ]],

Cell["Work with a numeric matrix.", "ExampleText",
 CellID->1210076384],

Cell[BoxData[
 RowBox[{
  RowBox[{"nmat", " ", "=", " ", 
   RowBox[{"(", "\[NoBreak]", GridBox[{
      {"5", "4", 
       RowBox[{"-", "6"}], 
       RowBox[{"-", "10"}]},
      {
       RowBox[{"-", "4"}], "0", "4", "4"},
      {"7", "8", "4", 
       RowBox[{"-", "6"}]}
     }], "\[NoBreak]", ")"}]}], ";"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1083648798],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"MultiplyARow", "[", 
   RowBox[{"nmat", ",", "1", ",", 
    RowBox[{"1", "/", "5"}]}], "]"}], "//", "MatrixForm"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->76537779],

Cell[BoxData[
 TagBox[
  RowBox[{"(", "\[NoBreak]", GridBox[{
     {"1", 
      FractionBox["4", "5"], 
      RowBox[{"-", 
       FractionBox["6", "5"]}], 
      RowBox[{"-", "2"}]},
     {
      RowBox[{"-", "4"}], "0", "4", "4"},
     {"7", "8", "4", 
      RowBox[{"-", "6"}]}
    },
    GridBoxAlignment->{
     "Columns" -> {{Center}}, "ColumnsIndexed" -> {}, "Rows" -> {{Baseline}}, 
      "RowsIndexed" -> {}},
    GridBoxSpacings->{"Columns" -> {
        Offset[0.27999999999999997`], {
         Offset[0.7]}, 
        Offset[0.27999999999999997`]}, "ColumnsIndexed" -> {}, "Rows" -> {
        Offset[0.2], {
         Offset[0.4]}, 
        Offset[0.2]}, "RowsIndexed" -> {}}], "\[NoBreak]", ")"}],
  Function[BoxForm`e$, 
   MatrixForm[BoxForm`e$]]]], "Output",
 ImageSize->{106, 52},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]//MatrixForm=",
 CellID->341558301]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["AddToRow",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/AddToRow"],
   FontFamily->"Verdana"]], "InlineFormula",
  FontSize->10],
 StyleBox[" . ",
  FontSize->10],
 Cell[BoxData[
  StyleBox[
   ButtonBox["SwitchRows",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/SwitchRows"],
   FontFamily->"Verdana"]], "InlineFormula",
  FontSize->10],
 StyleBox[" ",
  FontSize->10],
 ". ",
 StyleBox[ButtonBox["RowReduce",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/RowReduce"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["Inverse",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Inverse"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["LinearSolve",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/LinearSolve"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["NullSpace",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/NullSpace"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["Solve",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Solve"],
  FontFamily->"Verdana"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Elementary Matrix Operations",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/ElementaryMatrixOperations"]], \
"Tutorials",
 CellID->341631938],

Cell[TextData[ButtonBox["Solving Linear Systems",
 BaseStyle->"Link",
 ButtonData->"paclet:tutorial/SolvingLinearSystems"]], "Tutorials",
 CellID->563328207]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->465398716],

Cell[TextData[ButtonBox["Matrix Operations",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/MatrixOperations"]], "MoreAbout",
 CellID->444349181]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"MultiplyARow - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 28, 27.8320624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "MultiplyARow[mat , row_n , coef] multiply row_n in the matrix mat by \
coef", "synonyms" -> {}, "title" -> "MultiplyARow", "titlemodifier" -> "", 
    "windowtitle" -> "MultiplyARow", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/MultiplyARow"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6446, 181, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->476880002]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 15644, 504}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[605, 21, 3929, 86, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4559, 111, 55, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[4617, 114, 822, 27, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5476, 146, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->327851433],
Cell[6088, 166, 91, 1, 70, "Notes",
 CellID->1067943069],
Cell[6182, 169, 68, 1, 70, "Notes",
 CellID->1749259073],
Cell[6253, 172, 87, 1, 70, "Notes",
 CellID->746112481],
Cell[6343, 175, 66, 1, 70, "Notes",
 CellID->755453334]
}, Closed]],
Cell[CellGroupData[{
Cell[6446, 181, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->476880002],
Cell[CellGroupData[{
Cell[6961, 199, 195, 6, 31, "ExampleSection",
 CellID->249650990],
Cell[7159, 207, 66, 1, 32, "ExampleText",
 CellID->980863474],
Cell[7228, 210, 128, 3, 28, "Input",
 CellID->1287933146],
Cell[7359, 215, 161, 6, 43, "ExampleText",
 CellID->646627935],
Cell[7523, 223, 252, 9, 54, "Input",
 CellID->1608449725],
Cell[CellGroupData[{
Cell[7800, 236, 202, 6, 28, "Input",
 CellID->690379639],
Cell[8005, 244, 810, 25, 87, "Output",
 CellID->1488501641]
}, Open  ]],
Cell[8830, 272, 71, 1, 32, "ExampleText",
 CellID->1210076384],
Cell[8904, 275, 366, 13, 70, "Input",
 CellID->1083648798],
Cell[CellGroupData[{
Cell[9295, 292, 202, 6, 70, "Input",
 CellID->76537779],
Cell[9500, 300, 914, 29, 87, "Output",
 CellID->341558301]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10475, 336, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[10924, 351, 1137, 45, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[12098, 401, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[12549, 416, 193, 5, 70, "Tutorials",
 CellID->341631938],
Cell[12745, 423, 157, 3, 70, "Tutorials",
 CellID->563328207]
}, Open  ]],
Cell[CellGroupData[{
Cell[12939, 431, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[13390, 446, 171, 4, 70, "MoreAbout",
 CellID->465398716],
Cell[13564, 452, 164, 3, 70, "MoreAbout",
 CellID->444349181]
}, Open  ]],
Cell[13743, 458, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

