(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     23277,        612]
NotebookOptionsPosition[     19205,        488]
NotebookOutlinePosition[     21785,        557]
CellTagsIndexPosition[     21665,        551]
WindowTitle->OddRootPlot - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[Cell[
    BoxData[
     ActionMenuBox[
      FrameBox["\<\"URL \[RightGuillemet]\"\>",
       StripOnInput->False], {"\<\"Classroom Utilities/ref/OddRootPlot\"\>":>
      None, "\<\"Copy Mathematica URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["Classroom Utilities/ref/OddRootPlot"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/OddRootPlot.html"], StandardForm]], "Input", TextClipboardType -> 
             "PlainText"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
           "http://reference.wolfram.com/mathematica/", 
            "Classroom Utilities/ref/OddRootPlot", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic]],
     LineSpacing->{1.4, 0}]], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["OddRootPlot", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OddRootPlot", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]plots expressions containing odd roots for all real \
values"
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"OddRootPlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["f", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["f", "TI"], 
           StyleBox["2", "TR"]], ",", 
          StyleBox["\[Ellipsis]", "TR"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]plot a list of expressions some containing odd roots"
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->86338370],

Cell[TextData[{
 "OddRootPlot will take any options used with ",
 ButtonBox["Plot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Plot"]
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "OddRootPlot constructs a piecewise representation of expressions containing \
odd roots using ",
 ButtonBox["If",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/If"]
}], "Notes",
 CellID->1489484883]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->11658397],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->13116673],

Cell["This loads the package", "ExampleText",
 CellID->555555502],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2109908605],

Cell["Plot the cube root of x from -3 to 4.", "ExampleText",
 CellID->1983944971],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OddRootPlot", "[", 
  RowBox[{
   RadicalBox["x", "3"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "4"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->184540628],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnSGXozoYhuec+0vuz1i7shJZuUjEFT1XjUVWVmKRcTcSi0QisUhkJfel
Kd1OSVg6pJCS9zkzs53OLE3hmS9fIHz5+9c/wa+/Pj4+/sXnf/jsHreEkLbl
3wIxQTe8oTz+wNEOpeknHz+O5Zen6YaWuj5nWXU85oeDbJrz2s2xBSTQuCGP
D1JcoRuKqmqkLE+nPIrkz59JGAqIkckKz6/dNIvo3LgGDY0z3rpRlpChOp2K
iwwpvuIx9NiWDA/o48b1JwM9PnoWaNm6oGtAN9HLkFxkyLcuwwNmN7qfhV7l
GwgOaVoiZwiCdL8XcZwL4ZUMD4y5IUNN3Hh5ixbkfG7zvO7ShrALDrAiTQoY
ct5MOjkDGX7cDUfwXSfDNd3QJRwbcAPHXXUW4V4Eu/TzM5NbyyHX4U3dUMkD
+ojOhyDFA2QOGHiu3a5N8V5u5Jf4gMwBH90YM6vow+tw342iqJOkQP6w2yWM
D0vi5gC26zJkhcxht0sPh8zvwcVqOCUGBhT3XQZGHGu3yGtccENduUCIiCKJ
ELGh6xfvzYpuqIEGlLhkERVPQbjG8m4gt1RRAkpAj4VfnUxnMTeQTJ5OeRBc
z00xSrjPq91A8oAUArklcgkMP6nEehjn9qhz6Y8ze145hsWgI46zIBBJUjC9
dAPdtbbrdRX8u8S8L3QZYSgOB8lBqGNo3Pj91EAOi24gOCBEIKNAXsFTl06i
caMPG3o35uvRNC2GHkgqRKqdeEgcYdG4gfjQWRGk6EfmbIcswkL5BkYc6vw2
z1G8C9q5Pe3oOOUbr6KGpfg6s7XEZZ7NN4qihhXIOV/XJOII08VAJxLH2edn
xpMVnjDRjTzvwgXPV3jFlD4FIxFEjGXaQ9xhXAwMUQ+HjCMRPxlxo6qaKJJl
ycl4nmJyA+MRRAxeNvUZbb4BMTAeoRieMxSjKhtEjFUaQ5ziwY267nIMRoxN
Yjo3PlK3516PMBQ8tbVNzNfUptTtUZVqXtpAshbGa/ET6vao/HOJVpI1GJnD
02Go26Me7PfsTbbMyBye/hc0dXuAECUvrW4cc77R/1wfNxg0fODrOGVS3Z48
r3kpjQxRzvCiCRkCMYJdunYriIvADQ5diRa4wdsHiBa4URSc6Uc0wA1eWSND
YIULNZ2IgzSNo3UCyepUVUMxiJaypBtED0YodINoyXO6MRdbO9C17WSycq1J
b7edh1+Y/u23/+Mym82y6o1au8xmx1/l/nlC7tF6skke4gYhNyzmG2RjqLhB
PcgQybhhhX7OpX6S7hN8rdY2t0HG5T6nYCPfsNCMC5Z2i7XD1G9tyjsry2vl
vXmvWh6PUm3HQvMnNt1ImhQ24sbcZrQWd4ulw9ReG/OM9f17mI+N1s92Iy1t
5BsW3Lhh5aBaOUzd/RqT35n5xsFvvvLsjcw9KHGcOxI3eizsFjuHSTVk+M6u
XV/PF5F/31Y4Zfum7TzntXE7cw9KFEmn3LAZlefJ0d/Q81TqMrxr8GmwKy8v
Z7q1/aktzdoDu13qTp9ib7e0Vg7TtU0T3ln/tzu3N7yPAbPD3qwWNc15vxfz
44aVAYat3WLrMF2xmUm9E2qZRZ7fIEPUeu50wx+m13QKglTNM6ceXjC5ptOt
Sg/F8ITpNZ0OB6luZ6MbnjCxppMqRq2eu40OFm0oeSm6E2ITazrdVymnFb4w
oaZTnFUYodyeoRv+8IeaTqIr7XV/czTdIAqkoA/lm+gGaS9XXYer5NANkqZF
qlv0mW54TpLoxWgtrTlO3pTTMTeJ0TJueAySz/FSb3TDQ6qqCUNRFH8oKks3
fEOIMorklBLldMMfEC4OkZy+qAHd8AQoEYXPrehKNzZPt158IISQprvMTHN+
OIbdMEVRI7WI49tyrrr5r+ZrcBRjk5TdQq7ycMi+diIaN0au3dONjVFeFgQ3
LBavcWNkzg/7lM2AvCIMRRcrTvvpN7sxbmwY5BJpWuz3AnlFXY2ftWC+4Qtl
WR/jPAhSjE+nnMv6epfZfWdiHKdYbzN5KQgUUlYIFOg+hpMuLMJ8441Qqy4G
u/R4zBdYl5NiuA+U6PqOXQox8Hix16UbzlIUNeIDlPj8fG3fYYJ9imvcooRS
YsVVsSiGCyB5uJQ1yFTHsa4SN+jGiqDXOJ2KMBRBIOI4XzKXmALdWJi6PgtR
woTdzwS9Bh7jmbUbpYf5xgKgy+iyiGO+3wt8JKciz99gTV6K8TryrEKX0fnQ
dRmZlNUCJyUsQjcsggQS8eF0yqNQ7nYJOg4p3ekyzBWkB3V7FOxTZtI0LQRA
fxHuhRp4Ij5U1RNT7xZEX9vOVJmRYswEUQIdB3xwJj6MoHPDXKuXbviEuSZm
X7fnHrqxQb5VyHpYrpf5hk+MuWGlwj55U7Rze37X7aEZhBBCCCFu8z8zotHw

    "], {{0, 117}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 117},
  PlotRange->{{0, 180}, {0, 117}}]], "Output",
 ImageSize->{184, 117},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->884307869]
}, Open  ]],

Cell["Color the curve.", "ExampleText",
 CellID->63717670],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OddRootPlot", "[", 
  RowBox[{
   RadicalBox["x", "3"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "3"}], ",", "4"}], "}"}], ",", 
   RowBox[{"ColorFunction", "\[Rule]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{
       RowBox[{"ColorData", "[", "\"\<Rainbow\>\"", "]"}], "[", "#2", "]"}], 
      "&"}], ")"}]}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", " ", "Thick"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1456023484],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnKGXskochj3n/hNWIpFIJRKJxM9IuMFzk9VoNFqNtEukGokbrfwZfjMD
IuIwgjvwG5n3Oe/u2R3Z4d3lERVYnT//Rn/+Wa1W/7GP/9kH//oGgPXgjgD6
gBsKro5ThbqINlaCgTfBjYar69RxuqGuphPpFh8+aA9Xz3ko8eIGdbtJ6NPg
dVyxk1kkXIZOWlZQt5sDxea27THl6jtPeRaDuh0BlrtxDZw6fjfU1eix0I0y
dK8sQZUnN6irGcTqTvPt62B74bn76YP50E7jBnWvhfB1bpSR+5S7GNS9FshX
uFHG7iMtMah7LRyT3Sg3Lk/8FOpSFmGaG2Xi1ko0gQ9EGOJGmXgibh1hBXUp
26F1o9x6de5uEJYBHUjcKHcez/aR+TuAt8zpRq1EEyhhNjO4Ue69R4QVU68R
aGFSN8qD1xZjuhWBgfSddp/zmDm3ogmsMAmFA5OeayuPXh1hhcaZgS7md6M8
+iK1G1rmBFMwyo1f6lGe/DrCjd9MBWZgnv3GwwqRj+cBczK1G+XZ54EV34b0
2p6bvtcp10qMM6xYOKPcYFY0ma4SMIThblxTnwdWWMMQN2orRGaoBAzhrRs/
sMJW1G78ZP4PxLAVhRs/WcDdyCCGpfS5IcQIZi4DjELqRpEFBcSwnlc3ihxi
AE7HjQsTQ4SqD5iUj9+3h4lRZdp+gIi+c2rSkZvMjem6AVrUbiiEyfOQZep6
gBCFG9LxSphKDLixbD5wg33O8jCDGEsHbgAFnecVb9+3J80jiAFeqdxgoS4C
jIO5cYYbQEblBnULYCLCjZi6BTAR5sYJbgAZcAP0wdw45hvqFsBE4Abog7lx
gBtAhnAjoW4BTIS5sYcbQIZwY0vd4rvR9f42Bs6z0+GGab+XxqkUb54GQIUW
074I9ivvsh11C2AizI1ttqduAUwEboA+mBtJdqBuAYyDWWHhU6wp0Ph81ZB5
kuxoQg298+h9WTF2nl+ud/XuUvDZymxSPW78skZnBqMqjZpE407YADdO5mwI
vVPNvx/TewyE/I+wVDd0PTb1lVEcEBu7n5HO88EDmZZ52sTp2TQ3zHHssyOi
kzr52VSfEZ/NckPjn0XXPAMn0fUE+DMhp6gUn1ONj8sk99OJyrRn0zLPdxGd
U11ugIURnbLoBDfsQrFHbd8k3Mjghj0021r98io65UwM6WJgqajdaAbDI3Mj
ly4GlorCjWacicHSfAs9Fsnr675Bbhwu4fGiXgwsj4FuvC4PbKDzMNEcbKzg
Ow24AZ4J9oXIpT0IN0CwK3j2RWccblgOs6L53AFu2EywLXhkYtzghsUESVG5
0bcA3LATLkaiEuMGN+wj2BQ8wg31knDDKvxN4Qs3hiwMNyzBj4s6w8S4wQ07
8KOicWP4T8GNZcOtqCKs6Du1Kh2HG0vFDwseIUZ7XOFA5ya4sTz8oKjFCAcd
7YQbNuAHFy6GSN8yo9yAHt9O4F/qcDceV+ZI/x0D+w1LCLzLQwz/8v4H4IYF
BF4uMsKK28s/drW/wOuUbydw87sVPJOuC258BaGbsQQ8eaXHDCuFGyYTOhmP
mzVuzLl2uGEgoZPeU7tBUgNumEO0TsN12hIjpe0DN2iJ1udW0mhNr0QD3CAh
Xp9EznHLDepSXeDGbGzWpyrxI9wN6l69wI1JSdZHlk2dhxvUvQYBN7SzXR8S
nmOTyg3qXqOBG1pgPrTTuEHdq4vi1OqQs3JgFLv1nqUtBnWjN/Rd9zVwEAyn
coO6xQhwTSDoQ7HFcW2PJQy/tmfITcAG4AaQIr22R7p7AQAAAAAABvIX72X+
vw==
    "], {{0, 117}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 117},
  PlotRange->{{0, 180}, {0, 117}}]], "Output",
 ImageSize->{184, 117},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->78407759]
}, Open  ]],

Cell["Plot several functions together.", "ExampleText",
 CellID->1223779640],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"OddRootPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Sin", "[", 
       SuperscriptBox["x", 
        FractionBox["1", "5"]], "]"}], "+", 
      RowBox[{"Sin", "[", 
       SuperscriptBox["x", 
        FractionBox["2", "5"]], "]"}]}], ",", 
     RowBox[{
      RowBox[{"Sin", "[", 
       SuperscriptBox["x", 
        FractionBox["3", "5"]], "]"}], "+", 
      RowBox[{"Sin", "[", 
       SuperscriptBox["x", 
        FractionBox["4", "5"]], "]"}]}], ",", 
     RowBox[{"Sin", "[", "x", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{
      RowBox[{"-", "2"}], " ", "\[Pi]"}], ",", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1613522161],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztXS3Xq7oSfte6f+DIa7c88sjXVlZWVp7KiitYV9UikUhsJO5GxiKRkVgk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    "], {{0, 117}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 117},
  PlotRange->{{0, 180}, {0, 117}}]], "Output",
 ImageSize->{184, 117},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->173248438]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"OddRootPlot - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 28, 35.0704624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "OddRootPlot[f, {x, x_min, x_max}] plots expressions containing odd roots \
for all real valuesOddRootPlot[{f_1, f_2, ...}, {x, x_min, x_max}] plot a \
list of expressions some containing odd roots", "synonyms" -> {}, "title" -> 
    "OddRootPlot", "titlemodifier" -> "", "windowtitle" -> "OddRootPlot", 
    "type" -> "Symbol", "uri" -> "Classroom Utilities/ref/OddRootPlot"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5180, 162, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->11658397]},
 "RasterizedOutput"->{
  Cell[6430, 211, 2963, 57, 138, "Output",
   CellTags->"RasterizedOutput",
   CellID->884307869],
  Cell[9981, 293, 2356, 47, 138, "Output",
   CellTags->"RasterizedOutput",
   CellID->78407759],
  Cell[13232, 376, 5907, 105, 138, "Output",
   CellTags->"RasterizedOutput",
   CellID->173248438]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 21201, 534},
 {"RasterizedOutput", 21343, 538}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 1918, 42, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[2547, 67, 54, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[2604, 70, 1500, 47, 142, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[4141, 122, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->86338370],
Cell[4752, 142, 171, 6, 70, "Notes",
 CellID->1067943069],
Cell[4926, 150, 217, 7, 70, "Notes",
 CellID->1489484883]
}, Closed]],
Cell[CellGroupData[{
Cell[5180, 162, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->11658397],
Cell[CellGroupData[{
Cell[5694, 180, 194, 6, 31, "ExampleSection",
 CellID->13116673],
Cell[5891, 188, 65, 1, 32, "ExampleText",
 CellID->555555502],
Cell[5959, 191, 128, 3, 28, "Input",
 CellID->2109908605],
Cell[6090, 196, 81, 1, 32, "ExampleText",
 CellID->1983944971],
Cell[CellGroupData[{
Cell[6196, 201, 231, 8, 38, "Input",
 CellID->184540628],
Cell[6430, 211, 2963, 57, 138, "Output",
 CellTags->"RasterizedOutput",
 CellID->884307869]
}, Open  ]],
Cell[9408, 271, 58, 1, 70, "ExampleText",
 CellID->63717670],
Cell[CellGroupData[{
Cell[9491, 276, 487, 15, 61, "Input",
 CellID->1456023484],
Cell[9981, 293, 2356, 47, 138, "Output",
 CellTags->"RasterizedOutput",
 CellID->78407759]
}, Open  ]],
Cell[12352, 343, 76, 1, 70, "ExampleText",
 CellID->1223779640],
Cell[CellGroupData[{
Cell[12453, 348, 776, 26, 41, "Input",
 CellID->1613522161],
Cell[13232, 376, 5907, 105, 138, "Output",
 CellTags->"RasterizedOutput",
 CellID->173248438]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[19178, 486, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

