(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     19445,        585]
NotebookOptionsPosition[     15264,        453]
NotebookOutlinePosition[     17374,        509]
CellTagsIndexPosition[     17289,        504]
WindowTitle->Oh - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Visualizing Statistical Concepts\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities/ref/Oh\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/Oh"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/Oh.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/Oh", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Oh", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Oh", "[", 
       StyleBox["col", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]create a happy face with a startled expression with \
face color ",
     Cell[BoxData[
      StyleBox["col", "TI"]], "InlineFormula"],
     ". If no color is given the default is yellow."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->268957683],

Cell["\<\
Given with no color specification the face will be rendered in the standard \
yellow.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
The face is rendered using a unit disk centered on the origin.\
\>", "Notes",
 CellID->341904801],

Cell[TextData[{
 "Size of the face used in ",
 ButtonBox["Inset",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Inset"],
 " is controlled by the size specification in ",
 ButtonBox["Inset",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Inset"],
 "."
}], "Notes",
 CellID->1875234682]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->218388381],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->231869068],

Cell["This loads the package.", "ExampleText",
 CellID->599297002],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->686408184],

Cell["Use Graphics to display the face.", "ExampleText",
 CellID->180196804],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"Oh", "[", "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->615742558],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
   {GrayLevel[0], Thickness[0.02], 
    DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
      0.4871392896287467, 0.28125}], 
     NCache[{Rational[1, 9], Rational[1, 6]}, {0.1111111111111111, 
      0.16666666666666666`}]], 
    DiskBox[NCache[{
      Rational[-9, 32] 3^Rational[1, 2], Rational[
       9, 32]}, {-0.4871392896287467, 0.28125}], 
     NCache[{Rational[1, 9], Rational[1, 6]}, {0.1111111111111111, 
      0.16666666666666666`}]], 
    CircleBox[
     NCache[{Rational[-9, 32] 3^Rational[1, 2], Rational[
       9, 32]}, {-0.4871392896287467, 0.28125}], 
     NCache[{Rational[1, 8], Rational[1, 4]}, {0.125, 0.25}], 
     NCache[{Rational[1, 3] Pi, Rational[2, 3] Pi}, {1.0471975511965976`, 
      2.0943951023931953`}]], 
    CircleBox[
     NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
      0.4871392896287467, 0.28125}], 
     NCache[{Rational[1, 8], Rational[1, 4]}, {0.125, 0.25}], 
     NCache[{Rational[1, 3] Pi, Rational[2, 3] Pi}, {1.0471975511965976`, 
      2.0943951023931953`}]]}, 
   {RGBColor[1, 0, 0], Thickness[0.02], 
    CircleBox[NCache[{0, Rational[-1, 2]}, {0, -0.5}], 
     NCache[{Rational[1, 5], Rational[1, 3]}, {0.2, 0.3333333333333333}]], 
    {GrayLevel[0], 
     DiskBox[NCache[{0, Rational[-1, 2]}, {
       0, -0.5}], {0.1923076923076923, 0.3125}]}}}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1446222960]
}, Open  ]],

Cell["Change the color of the face.", "ExampleText",
 CellID->311246084],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"Oh", "[", "LightBlue", "]"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1990253343],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.87, 0.94, 1], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
   {GrayLevel[0], Thickness[0.02], 
    DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
      0.4871392896287467, 0.28125}], 
     NCache[{Rational[1, 9], Rational[1, 6]}, {0.1111111111111111, 
      0.16666666666666666`}]], 
    DiskBox[NCache[{
      Rational[-9, 32] 3^Rational[1, 2], Rational[
       9, 32]}, {-0.4871392896287467, 0.28125}], 
     NCache[{Rational[1, 9], Rational[1, 6]}, {0.1111111111111111, 
      0.16666666666666666`}]], 
    CircleBox[
     NCache[{Rational[-9, 32] 3^Rational[1, 2], Rational[
       9, 32]}, {-0.4871392896287467, 0.28125}], 
     NCache[{Rational[1, 8], Rational[1, 4]}, {0.125, 0.25}], 
     NCache[{Rational[1, 3] Pi, Rational[2, 3] Pi}, {1.0471975511965976`, 
      2.0943951023931953`}]], 
    CircleBox[
     NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
      0.4871392896287467, 0.28125}], 
     NCache[{Rational[1, 8], Rational[1, 4]}, {0.125, 0.25}], 
     NCache[{Rational[1, 3] Pi, Rational[2, 3] Pi}, {1.0471975511965976`, 
      2.0943951023931953`}]]}, 
   {RGBColor[1, 0, 0], Thickness[0.02], 
    CircleBox[NCache[{0, Rational[-1, 2]}, {0, -0.5}], 
     NCache[{Rational[1, 5], Rational[1, 3]}, {0.2, 0.3333333333333333}]], 
    {GrayLevel[0], 
     DiskBox[NCache[{0, Rational[-1, 2]}, {
       0, -0.5}], {0.1923076923076923, 0.3125}]}}}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->687759097]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Scope",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell["This loads the package.", "ExampleText",
 CellID->1251472673],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1046376393],

Cell["Use Inset to include a face in a graphic.", "ExampleText",
 CellID->645199565],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"Rectangle", "[", "]"}], ",", 
    RowBox[{"Inset", "[", 
     RowBox[{
      RowBox[{"Graphics", "[", 
       RowBox[{"Oh", "[", "]"}], "]"}], ",", "Center", ",", "Center"}], 
     "]"}]}], "}"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1224155252],

Cell[BoxData[
 GraphicsBox[{RectangleBox[{0, 0}], InsetBox[
    GraphicsBox[
     {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
      {GrayLevel[0], Thickness[0.02], 
       DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
         0.4871392896287467, 0.28125}], 
        NCache[{Rational[1, 9], Rational[1, 6]}, {0.1111111111111111, 
         0.16666666666666666`}]], 
       DiskBox[NCache[{
         Rational[-9, 32] 3^Rational[1, 2], Rational[
          9, 32]}, {-0.4871392896287467, 0.28125}], 
        NCache[{Rational[1, 9], Rational[1, 6]}, {0.1111111111111111, 
         0.16666666666666666`}]], 
       CircleBox[
        NCache[{Rational[-9, 32] 3^Rational[1, 2], Rational[
          9, 32]}, {-0.4871392896287467, 0.28125}], 
        NCache[{Rational[1, 8], Rational[1, 4]}, {0.125, 0.25}], 
        NCache[{Rational[1, 3] Pi, Rational[2, 3] Pi}, {1.0471975511965976`, 
         2.0943951023931953`}]], 
       CircleBox[
        NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
         0.4871392896287467, 0.28125}], 
        NCache[{Rational[1, 8], Rational[1, 4]}, {0.125, 0.25}], 
        NCache[{Rational[1, 3] Pi, Rational[2, 3] Pi}, {1.0471975511965976`, 
         2.0943951023931953`}]]}, 
      {RGBColor[1, 0, 0], Thickness[0.02], 
       CircleBox[NCache[{0, Rational[-1, 2]}, {0, -0.5}], 
        NCache[{Rational[1, 5], Rational[1, 3]}, {0.2, 0.3333333333333333}]], 
       {GrayLevel[0], 
        DiskBox[NCache[{0, Rational[-1, 2]}, {
          0, -0.5}], {0.1923076923076923, 0.3125}]}}}], Center, 
    Center]}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1410155125]
}, Open  ]],

Cell["\<\
Scale the face using the scale specification in the Inset function.\
\>", "ExampleText",
 CellID->1297514115],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics", "[", 
  RowBox[{"{", 
   RowBox[{"Orange", ",", 
    RowBox[{"Rectangle", "[", "]"}], ",", 
    RowBox[{"Inset", "[", 
     RowBox[{
      RowBox[{"Graphics", "[", 
       RowBox[{"Oh", "[", "LightBlue", "]"}], "]"}], ",", "Center", ",", 
      "Center", ",", 
      RowBox[{"3", "/", "4"}]}], "]"}]}], "}"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1770779167],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[1, 0.5, 0], RectangleBox[{0, 0}], InsetBox[
    GraphicsBox[
     {RGBColor[0.87, 0.94, 1], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
      {GrayLevel[0], Thickness[0.02], 
       DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
         0.4871392896287467, 0.28125}], 
        NCache[{Rational[1, 9], Rational[1, 6]}, {0.1111111111111111, 
         0.16666666666666666`}]], 
       DiskBox[NCache[{
         Rational[-9, 32] 3^Rational[1, 2], Rational[
          9, 32]}, {-0.4871392896287467, 0.28125}], 
        NCache[{Rational[1, 9], Rational[1, 6]}, {0.1111111111111111, 
         0.16666666666666666`}]], 
       CircleBox[
        NCache[{Rational[-9, 32] 3^Rational[1, 2], Rational[
          9, 32]}, {-0.4871392896287467, 0.28125}], 
        NCache[{Rational[1, 8], Rational[1, 4]}, {0.125, 0.25}], 
        NCache[{Rational[1, 3] Pi, Rational[2, 3] Pi}, {1.0471975511965976`, 
         2.0943951023931953`}]], 
       CircleBox[
        NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
         0.4871392896287467, 0.28125}], 
        NCache[{Rational[1, 8], Rational[1, 4]}, {0.125, 0.25}], 
        NCache[{Rational[1, 3] Pi, Rational[2, 3] Pi}, {1.0471975511965976`, 
         2.0943951023931953`}]]}, 
      {RGBColor[1, 0, 0], Thickness[0.02], 
       CircleBox[NCache[{0, Rational[-1, 2]}, {0, -0.5}], 
        NCache[{Rational[1, 5], Rational[1, 3]}, {0.2, 0.3333333333333333}]], 
       {GrayLevel[0], 
        DiskBox[NCache[{0, Rational[-1, 2]}, {
          0, -0.5}], {0.1923076923076923, 0.3125}]}}}], Center, Center, 
    NCache[Rational[3, 4], 0.75]]}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->174483283]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[StyleBox[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"],
 FontWeight->"Bold"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Oh - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 28, 39.1108624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "Oh[col] create a happy face with a startled expression with face color \
col. If no color is given the default is yellow.", "synonyms" -> {}, "title" -> 
    "Oh", "titlemodifier" -> "", "windowtitle" -> "Oh", "type" -> "Symbol", 
    "uri" -> "Classroom Utilities/ref/Oh"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4847, 151, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->218388381]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 17146, 497}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[595, 21, 2424, 55, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3044, 80, 45, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3092, 83, 540, 16, 99, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3669, 104, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->268957683],
Cell[4281, 124, 131, 4, 70, "Notes",
 CellID->1067943069],
Cell[4415, 130, 107, 3, 70, "Notes",
 CellID->341904801],
Cell[4525, 135, 285, 11, 70, "Notes",
 CellID->1875234682]
}, Closed]],
Cell[CellGroupData[{
Cell[4847, 151, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->218388381],
Cell[CellGroupData[{
Cell[5362, 169, 195, 6, 31, "ExampleSection",
 CellID->231869068],
Cell[5560, 177, 66, 1, 32, "ExampleText",
 CellID->599297002],
Cell[5629, 180, 127, 3, 28, "Input",
 CellID->686408184],
Cell[5759, 185, 76, 1, 32, "ExampleText",
 CellID->180196804],
Cell[CellGroupData[{
Cell[5860, 190, 128, 4, 28, "Input",
 CellID->615742558],
Cell[5991, 196, 1577, 35, 201, "Output",
 CellID->1446222960]
}, Open  ]],
Cell[7583, 234, 72, 1, 70, "ExampleText",
 CellID->311246084],
Cell[CellGroupData[{
Cell[7680, 239, 142, 4, 70, "Input",
 CellID->1990253343],
Cell[7825, 245, 1582, 35, 201, "Output",
 CellID->687759097]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9456, 286, 268, 8, 70, "ExampleSection",
 CellID->1293636265],
Cell[9727, 296, 67, 1, 70, "ExampleText",
 CellID->1251472673],
Cell[9797, 299, 128, 3, 70, "Input",
 CellID->1046376393],
Cell[9928, 304, 84, 1, 70, "ExampleText",
 CellID->645199565],
Cell[CellGroupData[{
Cell[10037, 309, 339, 11, 70, "Input",
 CellID->1224155252],
Cell[10379, 322, 1737, 37, 201, "Output",
 CellID->1410155125]
}, Open  ]],
Cell[12131, 362, 119, 3, 70, "ExampleText",
 CellID->1297514115],
Cell[CellGroupData[{
Cell[12275, 369, 405, 12, 70, "Input",
 CellID->1770779167],
Cell[12683, 383, 1796, 38, 201, "Output",
 CellID->174483283]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14540, 428, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[14991, 443, 231, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[15237, 451, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

