(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     27104,        903]
NotebookOptionsPosition[     21936,        736]
NotebookOutlinePosition[     24122,        793]
CellTagsIndexPosition[     24037,        788]
WindowTitle->PartsIntegrate - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Using Integration Techniques Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
UsingIntegrationTechniquesFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Integration Techniques\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/IntegrationTechniques"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/PartsIntegrate\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PartsIntegrate"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PartsIntegrate.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PartsIntegrate", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PartsIntegrate", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PartsIntegrate", "[", 
       RowBox[{
        StyleBox["intgrnd", "TI"], ",", 
        StyleBox["var", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["u", "TI"], ",", 
          RowBox[{"\[DifferentialD]", 
           StyleBox["v", "TI"]}]}], "}"}]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]returns ",
     Cell[BoxData[
      RowBox[{
       StyleBox["u", "TI"], " ", 
       StyleBox["v", "TI"]}]], "InlineFormula"],
     " - Integrate[",
     Cell[BoxData[
      RowBox[{
       StyleBox["v", "TI"], ",", 
       StyleBox["var", "TI"]}]], "InlineFormula"],
     "] as would happen when using the method of integration by parts."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->97136129],

Cell[TextData[{
 "The variable ",
 Cell[BoxData[
  StyleBox["var", "TI"]], "InlineFormula"],
 " should match the variable of integration in ",
 Cell[BoxData[
  StyleBox["intgrnd", "TI"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The arguments ",
 Cell[BoxData[
  StyleBox["u", "TI"]], "InlineFormula"],
 " and",
 Cell[BoxData[
  RowBox[{" ", 
   RowBox[{"\[DifferentialD]", 
    StyleBox["v", "TI"]}]}]], "InlineFormula"],
 " should not include any differentials."
}], "Notes",
 CellID->1233248679]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->104610601],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->28638276],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1845870756],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PartsIntegrate", "[", 
  RowBox[{
   RowBox[{"x", " ", 
    RowBox[{"Exp", "[", "x", "]"}]}], ",", "x", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"Exp", "[", "x", "]"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1001031530],

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["\[ExponentialE]", "x"], " ", "x"}], "-", 
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", "x"], 
    RowBox[{"\[DifferentialD]", "x"}]}]}]}]], "Output",
 ImageSize->{83, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1834531301]
}, Open  ]],

Cell["\<\
The above expression can be evaluated to get the final result.\
\>", "ExampleText",
 CellID->682404939],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   SuperscriptBox["\[ExponentialE]", "x"], " ", "x"}], "-", 
  RowBox[{"\[Integral]", 
   RowBox[{
    SuperscriptBox["\[ExponentialE]", "x"], 
    RowBox[{"\[DifferentialD]", "x"}]}]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1617134793],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", 
   SuperscriptBox["\[ExponentialE]", "x"]}], "+", 
  RowBox[{
   SuperscriptBox["\[ExponentialE]", "x"], " ", "x"}]}]], "Output",
 ImageSize->{61, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1544855928]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Generalizations & Extensions",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1020263627],

Cell["\<\
The result reveals we may need to use PartsIntegrate a second time.\
\>", "ExampleText",
 CellID->1719226006],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->316646152],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PartsIntegrate", "[", 
  RowBox[{
   RowBox[{
    SuperscriptBox["x", "2"], 
    RowBox[{"Sin", "[", "x", "]"}]}], ",", "x", ",", 
   RowBox[{"{", 
    RowBox[{
     SuperscriptBox["x", "2"], ",", 
     RowBox[{"Sin", "[", "x", "]"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->407399398],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    SuperscriptBox["x", "2"]}], " ", 
   RowBox[{"Cos", "[", "x", "]"}]}], "-", 
  RowBox[{"\[Integral]", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "2"}], " ", "x", " ", 
     RowBox[{"Cos", "[", "x", "]"}]}], 
    RowBox[{"\[DifferentialD]", "x"}]}]}]}]], "Output",
 ImageSize->{183, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1316289666]
}, Open  ]],

Cell["\<\
Copying the result down PartsIntegrate can be used on the integrand in the \
integral.\
\>", "ExampleText",
 CellID->1511350597],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    SuperscriptBox["x", "2"]}], " ", 
   RowBox[{"Cos", "[", "x", "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"PartsIntegrate", "[", 
    RowBox[{
     RowBox[{"x", " ", 
      RowBox[{"Cos", "[", "x", "]"}]}], ",", "x", ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"Cos", "[", "x", "]"}]}], "}"}]}], "]"}]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->832907063],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    SuperscriptBox["x", "2"]}], " ", 
   RowBox[{"Cos", "[", "x", "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"\[Integral]", 
       RowBox[{
        RowBox[{"Sin", "[", "x", "]"}], 
        RowBox[{"\[DifferentialD]", "x"}]}]}]}], "+", 
     RowBox[{"x", " ", 
      RowBox[{"Sin", "[", "x", "]"}]}]}], ")"}]}]}]], "Output",
 ImageSize->{252, 29},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1651368715]
}, Open  ]],

Cell["Copy the results down and evaluate.", "ExampleText",
 CellID->1709055143],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    SuperscriptBox["x", "2"]}], " ", 
   RowBox[{"Cos", "[", "x", "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"-", 
      RowBox[{"\[Integral]", 
       RowBox[{
        RowBox[{"Sin", "[", "x", "]"}], 
        RowBox[{"\[DifferentialD]", "x"}]}]}]}], "+", 
     RowBox[{"x", " ", 
      RowBox[{"Sin", "[", "x", "]"}]}]}], ")"}]}]}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1496009776],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    SuperscriptBox["x", "2"]}], " ", 
   RowBox[{"Cos", "[", "x", "]"}]}], "+", 
  RowBox[{"2", " ", 
   RowBox[{"(", 
    RowBox[{
     RowBox[{"Cos", "[", "x", "]"}], "+", 
     RowBox[{"x", " ", 
      RowBox[{"Sin", "[", "x", "]"}]}]}], ")"}]}]}]], "Output",
 ImageSize->{214, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->475339177]
}, Open  ]],

Cell[TextData[{
 "Check your answer using ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "'s built in functions."
}], "ExampleText",
 CellID->386380999],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{
   SuperscriptBox["x", "2"], 
   RowBox[{"Sin", "[", "x", "]"}], 
   RowBox[{"\[DifferentialD]", "x"}]}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->2062385312],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", 
      SuperscriptBox["x", "2"]}], ")"}]}], " ", 
   RowBox[{"Cos", "[", "x", "]"}]}], "+", 
  RowBox[{"2", " ", "x", " ", 
   RowBox[{"Sin", "[", "x", "]"}]}]}]], "Output",
 ImageSize->{187, 18},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->2123876204]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Expand", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"-", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "2"}], "+", 
       SuperscriptBox["x", "2"]}], ")"}]}], " ", 
    RowBox[{"Cos", "[", "x", "]"}]}], "+", 
   RowBox[{"2", " ", "x", " ", 
    RowBox[{"Sin", "[", "x", "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->514180194],

Cell[BoxData[
 RowBox[{
  RowBox[{"2", " ", 
   RowBox[{"Cos", "[", "x", "]"}]}], "-", 
  RowBox[{
   SuperscriptBox["x", "2"], " ", 
   RowBox[{"Cos", "[", "x", "]"}]}], "+", 
  RowBox[{"2", " ", "x", " ", 
   RowBox[{"Sin", "[", "x", "]"}]}]}]], "Output",
 ImageSize->{202, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->352325030]
}, Open  ]],

Cell[TextData[{
 StyleBox["Combining the PartsIntegrate function with ", "Text"],
 StyleBox["Mathematica", "Text",
  FontSlant->"Italic"],
 StyleBox["'s ", "Text"],
 StyleBox[ButtonBox["Interpretation",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Interpretation"], "Text"],
 StyleBox[" function gives a more intuitive interface for use in the \
classroom. Because ", "Text"],
 StyleBox[ButtonBox["Interpretation",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Interpretation"], "Text"],
 StyleBox[" needs to take information from the constructed interface and \
convert to ", "Text"],
 StyleBox[ButtonBox["InputForm",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/InputForm"], "Text"],
 StyleBox[" you should use full function names for any package functions. ", 
  "Text"]
}], "ExampleText",
 CellID->643896452],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Interpretation", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"intgrnd", "=", 
      RowBox[{"(", 
       RowBox[{"x", " ", 
        RowBox[{"Cos", "[", "x", "]"}]}], ")"}]}], ",", 
     RowBox[{"var", "=", "x"}], ",", 
     RowBox[{"u", "=", 
      RowBox[{"(", "x", ")"}]}], ",", 
     RowBox[{"dvar", "=", 
      RowBox[{"Cos", "[", "x", "]"}]}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Framed", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Panel", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Item", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<\[Integral]u \[DifferentialD]v = u v -\[Integral]v\
\[DifferentialD]u\>\"", ",", "\"\<Subsection\>\""}], "]"}], ",", 
               RowBox[{"Alignment", "\[Rule]", " ", "Center"}]}], "]"}], ",", 
             "SpanFromLeft"}], "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Integrand\>\"", ",", "\"\<Text\>\""}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{"Dynamic", "[", "intgrnd", "]"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Variable\>\"", ",", "\"\<Text\>\""}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{"Dynamic", "[", "var", "]"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<u\>\"", ",", "\"\<Text\>\""}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "u", "]"}], ",", 
               RowBox[{"FieldSize", "\[Rule]", "6"}]}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<dv\>\"", ",", "\"\<Text\>\""}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "dvar", "]"}], ",", 
               RowBox[{"FieldSize", "\[Rule]", " ", "6"}]}], "]"}]}], "}"}]}],
           "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"Alignment", "\[Rule]", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Right", ",", 
              RowBox[{"{", "Left", "}"}]}], "}"}], ",", "Automatic"}], 
           "}"}]}]}], "]"}], ",", 
       RowBox[{"Background", "\[Rule]", " ", "LightBrown"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"RoundingRadius", "\[Rule]", " ", "8"}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", " ", 
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "18", "]"}], ",", "Brown"}], 
       "]"}]}], ",", 
     RowBox[{"Background", "\[Rule]", " ", "Brown"}]}], "]"}], ",", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"ClassroomUtilities`PartsIntegrate", "[", 
    RowBox[{"intgrnd", ",", "var", ",", 
     RowBox[{"{", 
      RowBox[{"u", ",", "dvar"}], "}"}]}], "]"}]}], "\[IndentingNewLine]", 
  "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->1857349092],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{$CellContext`intgrnd$$ = $CellContext`x 
   Cos[$CellContext`x], $CellContext`var$$ = $CellContext`x, $CellContext`u$$ \
= $CellContext`x, $CellContext`dvar$$ = Cos[$CellContext`x]}, 
   InterpretationBox[
    FrameBox[
     PanelBox[
      TagBox[GridBox[{
         {
          ItemBox[
           
           StyleBox["\<\"\[Integral]u \[DifferentialD]v = u v -\[Integral]v\
\[DifferentialD]u\"\>", "Subsection",
            StripOnInput->False],
           Alignment->Center,
           StripOnInput->False], "\[SpanFromLeft]"},
         {
          StyleBox["\<\"Integrand\"\>", "Text",
           StripOnInput->False], 
          InputFieldBox[Dynamic[$CellContext`intgrnd$$]]},
         {
          StyleBox["\<\"Variable\"\>", "Text",
           StripOnInput->False], 
          InputFieldBox[Dynamic[$CellContext`var$$]]},
         {
          StyleBox["\<\"u\"\>", "Text",
           StripOnInput->False], 
          InputFieldBox[Dynamic[$CellContext`u$$],
           FieldSize->6]},
         {
          StyleBox["\<\"dv\"\>", "Text",
           StripOnInput->False], 
          InputFieldBox[Dynamic[$CellContext`dvar$$],
           FieldSize->6]}
        },
        AutoDelete->False,
        GridBoxAlignment->{
         "Columns" -> {Right, {Left}}, "Rows" -> {{Automatic}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"],
      Background->RGBColor[0.94, 0.91, 0.88]],
     Background->RGBColor[0.6, 0.4, 0.2],
     FrameStyle->Directive[
       AbsoluteThickness[18], 
       RGBColor[0.6, 0.4, 0.2]],
     RoundingRadius->8,
     StripOnInput->False],
    ClassroomUtilities`PartsIntegrate[$CellContext`intgrnd$$, \
$CellContext`var$$, {$CellContext`u$$, $CellContext`dvar$$}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]], "Output",
 ImageSize->{335, 152},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->797571531]
}, Open  ]],

Cell[TextData[{
 "The output of the Interpretation function is an input cell that can be \
evaluated after the input fields have been appropriately updated. The cell \
can be copied and used in other notebooks without including the input that \
constructed it. For an example of a notebook intended for use in the \
classroom see the tutorial ",
 ButtonBox["Integration By Parts",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/tutorial/IntegrationByParts"],
 "."
}], "ExampleText",
 CellID->191796943],

Cell[BoxData[""], "Input",
 CellLabel->"In[8]:=",
 CellID->639012457]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Using Integration Techniques Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/UsingIntegrationTechniquesFunctions"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->330105493],

Cell[TextData[ButtonBox["Integration Techniques",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/IntegrationTechniques"]], "MoreAbout",
 CellID->11512207]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PartsIntegrate - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 28, 46.3648624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PartsIntegrate[intgrnd, var, {u, \\[DifferentialD]v}] returns u v - \
Integrate[v, var] as would happen when using the method of integration by \
parts.", "synonyms" -> {}, "title" -> "PartsIntegrate", "titlemodifier" -> "",
     "windowtitle" -> "PartsIntegrate", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/PartsIntegrate"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5792, 178, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->104610601]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 23894, 781}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[607, 21, 2951, 69, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3583, 94, 57, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3643, 97, 930, 29, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[4610, 131, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->97136129],
Cell[5221, 151, 244, 9, 70, "Notes",
 CellID->1067943069],
Cell[5468, 162, 287, 11, 70, "Notes",
 CellID->1233248679]
}, Closed]],
Cell[CellGroupData[{
Cell[5792, 178, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->104610601],
Cell[CellGroupData[{
Cell[6307, 196, 194, 6, 31, "ExampleSection",
 CellID->28638276],
Cell[6504, 204, 128, 3, 28, "Input",
 CellID->1845870756],
Cell[CellGroupData[{
Cell[6657, 211, 282, 9, 28, "Input",
 CellID->1001031530],
Cell[6942, 222, 365, 12, 49, "Output",
 CellID->1834531301]
}, Open  ]],
Cell[7322, 237, 113, 3, 32, "ExampleText",
 CellID->682404939],
Cell[CellGroupData[{
Cell[7460, 244, 277, 9, 40, "Input",
 CellID->1617134793],
Cell[7740, 255, 300, 10, 36, "Output",
 CellID->1544855928]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8089, 271, 291, 8, 31, "ExampleSection",
 CellID->1020263627],
Cell[8383, 281, 119, 3, 70, "ExampleText",
 CellID->1719226006],
Cell[8505, 286, 127, 3, 70, "Input",
 CellID->316646152],
Cell[CellGroupData[{
Cell[8657, 293, 329, 11, 70, "Input",
 CellID->407399398],
Cell[8989, 306, 452, 16, 49, "Output",
 CellID->1316289666]
}, Open  ]],
Cell[9456, 325, 138, 4, 70, "ExampleText",
 CellID->1511350597],
Cell[CellGroupData[{
Cell[9619, 333, 439, 15, 70, "Input",
 CellID->832907063],
Cell[10061, 350, 564, 20, 50, "Output",
 CellID->1651368715]
}, Open  ]],
Cell[10640, 373, 79, 1, 70, "ExampleText",
 CellID->1709055143],
Cell[CellGroupData[{
Cell[10744, 378, 475, 17, 70, "Input",
 CellID->1496009776],
Cell[11222, 397, 445, 16, 36, "Output",
 CellID->475339177]
}, Open  ]],
Cell[11682, 416, 158, 6, 70, "ExampleText",
 CellID->386380999],
Cell[CellGroupData[{
Cell[11865, 426, 211, 7, 70, "Input",
 CellID->2062385312],
Cell[12079, 435, 420, 15, 39, "Output",
 CellID->2123876204]
}, Open  ]],
Cell[CellGroupData[{
Cell[12536, 455, 372, 13, 70, "Input",
 CellID->514180194],
Cell[12911, 470, 388, 13, 36, "Output",
 CellID->352325030]
}, Open  ]],
Cell[13314, 486, 817, 21, 70, "ExampleText",
 CellID->643896452],
Cell[CellGroupData[{
Cell[14156, 511, 3587, 87, 70, "Input",
 CellID->1857349092],
Cell[17746, 600, 1993, 57, 70, "Output",
 CellID->797571531]
}, Open  ]],
Cell[19754, 660, 518, 11, 70, "ExampleText",
 CellID->191796943],
Cell[20275, 673, 69, 2, 70, "Input",
 CellID->639012457]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[20393, 681, 448, 13, 45, "TutorialsSection",
 CellID->250839057],
Cell[20844, 696, 212, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[21093, 706, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[21544, 721, 171, 4, 70, "MoreAbout",
 CellID->330105493],
Cell[21718, 727, 176, 4, 70, "MoreAbout",
 CellID->11512207]
}, Open  ]],
Cell[21909, 734, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

