(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     15429,        511]
NotebookOptionsPosition[     11352,        385]
NotebookOutlinePosition[     13538,        442]
CellTagsIndexPosition[     13453,        437]
WindowTitle->PerpendicularLine - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Problems in Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/ProblemsInAnalyticGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/AnalyticGeometry"], "\<\"Classroom \
Utilities\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/PerpendicularLine\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PerpendicularLine"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PerpendicularLine.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PerpendicularLine", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PerpendicularLine", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PerpendicularLine", "[", 
       RowBox[{
        SubscriptBox[
         StyleBox["pt", "TI"], 
         StyleBox["1", "TR"]], ",", 
        StyleBox["m", "TI"], ",", 
        StyleBox["var", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]gives the slope-intercept form of the line through ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["pt", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     " with slope -1/m in terms of the variable var."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->226119155],

Cell["\<\
If the resulting line is vertical it will be given as an equation of the form \
x=3.\
\>", "Notes",
 CellID->375838630],

Cell["The following options can be given: ", "Notes"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["VerticalLineRepresentation",
     BaseStyle->"Link",
     ButtonData->"paclet:AnalyticGeometry/ref/VerticalLineRepresentation"], 
    ButtonBox["Equation",
     BaseStyle->"Link",
     ButtonData->"paclet:AnalyticGeometry/ref/Equation"], Cell[TextData[{
     Cell[BoxData[
      ButtonBox["VerticalLineRepresentation",
       BaseStyle->"Link",
       ButtonData->"paclet:AnalyticGeometry/ref/VerticalLineRepresentation"]],
       "InlineFormula"],
     " is a option for PerpendicularLineand ",
     Cell[BoxData[
      ButtonBox["TwoPointLine",
       BaseStyle->"Link",
       ButtonData->"paclet:AnalyticGeometry/ref/TwoPointLine"]], 
      "InlineFormula"],
     " that takes the values ",
     "None",
     " or ",
     "Automatic",
     "."
    }], "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True}}}}]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->354602371],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->163620685],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->970448583],

Cell["\<\
This finds a line through the point {1,7} perpendicular to a line with slope \
1/5.\
\>", "ExampleText",
 CellID->191035516],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PerpendicularLine", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "7"}], "}"}], ",", 
   RowBox[{"y", "\[Equal]", " ", 
    RowBox[{"x", "/", "5"}]}], ",", "x"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->245865147],

Cell[BoxData[
 RowBox[{"12", "-", 
  RowBox[{"5", " ", "x"}]}]], "Output",
 ImageSize->{48, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1100877934]
}, Open  ]],

Cell["With given slope of zero an equation is returned.", "ExampleText",
 CellID->1326875224],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PerpendicularLine", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "7"}], "}"}], ",", 
   RowBox[{"y", "\[Equal]", "3"}], ",", "x"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1321699320],

Cell[BoxData[
 RowBox[{"x", "\[Equal]", "1"}]], "Output",
 ImageSize->{36, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1883817833]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True],

Cell[CellGroupData[{

Cell[BoxData[
 ButtonBox[
  InterpretationBox[Cell[TextData[{
    "VerticalLineRepresentation",
    "\[NonBreakingSpace]\[NonBreakingSpace]",
    Cell["(1)", "ExampleCount"]
   }], "ExampleSubsection"],
   $Line = 0; Null],
  BaseStyle->"Link",
  ButtonData->"paclet:AnalyticGeometry/ref/"]], "ExampleSubsection", \
"ExampleSubsection",
 WholeCellGroupOpener->True],

Cell[TextData[{
 "Setting VerticalLineRepresentation to Automatic will return an ordered pair \
that can be used in ",
 ButtonBox["ParametricPlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/ParametricPlot"],
 "."
}], "ExampleText",
 CellID->307362645],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PerpendicularLine", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "7"}], "}"}], ",", 
   RowBox[{"y", "\[Equal]", "0"}], ",", "x", ",", 
   RowBox[{"VerticalLineRepresentation", "\[Rule]", " ", "Automatic"}]}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1145803480],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", ",", "1"}], "}"}]], "Output",
 ImageSize->{43, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->974911510]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Problems in Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/ProblemsInAnalyticGeometry"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/AnalyticGeometry"]], "MoreAbout",
 CellID->128559309],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->57480031]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PerpendicularLine - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 28, 50.0308624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PerpendicularLine[pt_1, m, var] gives the slope-intercept form of the \
line through pt_1 with slope -1/m in terms of the variable var.", 
    "synonyms" -> {}, "title" -> "PerpendicularLine", "titlemodifier" -> "", 
    "windowtitle" -> "PerpendicularLine", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/PerpendicularLine"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6264, 184, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->354602371]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13310, 430}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[610, 21, 2923, 67, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3558, 92, 60, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3621, 95, 716, 21, 89, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4374, 121, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->226119155],
Cell[4986, 141, 129, 4, 70, "Notes",
 CellID->375838630],
Cell[5118, 147, 53, 0, 70, "Notes"],
Cell[5174, 149, 1053, 30, 70, "3ColumnTableMod"]
}, Closed]],
Cell[CellGroupData[{
Cell[6264, 184, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->354602371],
Cell[CellGroupData[{
Cell[6779, 202, 195, 6, 31, "ExampleSection",
 CellID->163620685],
Cell[6977, 210, 127, 3, 28, "Input",
 CellID->970448583],
Cell[7107, 215, 134, 4, 32, "ExampleText",
 CellID->191035516],
Cell[CellGroupData[{
Cell[7266, 223, 256, 8, 28, "Input",
 CellID->245865147],
Cell[7525, 233, 205, 7, 36, "Output",
 CellID->1100877934]
}, Open  ]],
Cell[7745, 243, 93, 1, 32, "ExampleText",
 CellID->1326875224],
Cell[CellGroupData[{
Cell[7863, 248, 227, 7, 28, "Input",
 CellID->1321699320],
Cell[8093, 257, 188, 6, 36, "Output",
 CellID->1883817833]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[8330, 269, 249, 7, 31, "ExampleSection"],
Cell[CellGroupData[{
Cell[8604, 280, 365, 11, 70, "ExampleSubsection"],
Cell[8972, 293, 256, 8, 70, "ExampleText",
 CellID->307362645],
Cell[CellGroupData[{
Cell[9253, 305, 308, 9, 70, "Input",
 CellID->1145803480],
Cell[9564, 316, 203, 7, 36, "Output",
 CellID->974911510]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9840, 331, 448, 13, 45, "TutorialsSection",
 CellID->250839057],
Cell[10291, 346, 194, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[10522, 356, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[10973, 371, 164, 3, 70, "MoreAbout",
 CellID->128559309],
Cell[11140, 376, 170, 4, 70, "MoreAbout",
 CellID->57480031]
}, Open  ]],
Cell[11325, 383, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

