(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     55447,       1488]
NotebookOptionsPosition[     48041,       1253]
NotebookOutlinePosition[     51140,       1334]
CellTagsIndexPosition[     51018,       1328]
WindowTitle->PiecewisePlot - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"PiecewisePolarPlot\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/PiecewisePolarPlot"], "\<\"Plot\"\>":>
       Documentation`HelpLookup["paclet:ref/Plot"], "\<\"PolarPlot\"\>":>
       Documentation`HelpLookup["paclet:ref/PolarPlot"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Understanding Functions\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingFunctions"], \
"\<\"Visualizing Piecewise Continuous Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/\
VisualizingPiecewiseContinuousFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/PiecewisePlot\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PiecewisePlot"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PiecewisePlot.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PiecewisePlot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PiecewisePlot", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PiecewisePlot", "[", 
       RowBox[{
        StyleBox["fn", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["var", "TI"], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["opts", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]creates a textbook style plot of a piecewise \
continuous function with filled circles at the point of discontinuity where \
the function is defined and open circles where the function is not defined."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PiecewisePlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["fn", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["fn", "TI"], 
           StyleBox["2", "TR"]], ",", 
          StyleBox["\[Ellipsis]", "TR"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["var", "TI"], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["opts", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]creates a textbook style plot of several functions both \
continuous and piecewise continuous."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->235899589],

Cell[TextData[{
 "Functions such as ",
 ButtonBox["Floor",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Floor"],
 " and ",
 ButtonBox["Ceiling",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Ceiling"],
 " can be used in PiecewisePlot."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 ButtonBox["Piecewise",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Piecewise"],
 " can be entered directly as an argument to PiecewisePlot."
}], "Notes",
 CellID->1016346046],

Cell["\<\
Functions with many continuous segments may take a while to render fully.\
\>", "Notes",
 CellID->643066884],

Cell["\<\
PiecewisePlot will take the option PointStyle as well as any option that can \
be used with Plot. \
\>", "Notes",
 CellID->1887407684],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["PointStyle",
     BaseStyle->"Link",
     ButtonData->"paclet:PiecewisePlot/ref/PointStyle"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell[
    "determines how endpoints of segments are rendered", "TableText"]], 
     "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True}}}},
 CellID->1179995151]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->284258124],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->350001402],

Cell["This loads the package.", "ExampleText",
 CellID->1251137568],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1247373048],

Cell["Plot the Floor function:", "ExampleText",
 CellID->391274655],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePlot", "[", 
  RowBox[{
   RowBox[{"Floor", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->558199471],

Cell[BoxData[
 GraphicsBox[{{{{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGAwAmIQPbcuic0wpdqOAQqOXFbwCVeItIfx/x/b16ygkAnn
zz3QK8+qUAnn59iW5n6X74TzL//OmPJBfiacz377kfpb+ZVw/sJT8wtfy++E
89et77ydo3cKzk+3vzjzTdFlOD/vqebjLetuwvlcii3q9y0ewPl9Aqe1FiY8
hvOTbofsZz7zDM4vPNqSlK/+Cs6Xe+LG9s0YwT/NxLmqxgHBV3Xo/dgZieDf
3DW1YUk3gu+4Ydm8m+8RfMHZJ24573gN5+/b2VV36giCn33DRynwIoJ/VPRi
ZtwrBL9yws0fFTJv4PyHra/E1jUg+BsLeIIlPN/C+WdmCVeuDUPwnx2Rmu+U
guBLSWq+zqlH8FsOujYf3IrghwnVb85SegfnF9i03fyvj+B3pfX+n2KL4O/f
Ndt7fwSCr5G847FwP4L/a/NH4b2/EXyRez8sgzjfw/l6HAwJz8UQ/OQYvjWC
Rgj+GRZtl7QMBP+ZnlHW71IEnyHScsKEZgTfdK37nV3zEPyA635MAWsQ/CzG
MI2nOxH8eaEpJfxXEfwd9dmzljxC8C+vLDpg+QHBn9s0PfjDJwQfAPFqzSk=

       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQvcnO5Fo72wd7BjD4YC+30l3HXRjBt7jsF3RHAcHP
UY+dx2aD4C+szn5lEI7gT+I1mSek9BHOb5r/J/DLGwSf4fIDhz1Vn+F8tZK0
ihCtr3D+k6/Tw7j3foPzvZ5m1U4q/AHn+z2ZoC0n9wvOf3U4qeHE2t9wvp7g
NVnn+L9wvsyKp/v7Nf/B+Vz2XxPvfEbwX6eqHi1L/A/nn+kJ1RA8j+CvmLi7
5MgdBL9lmuLB8lcI/qcZIemBHxH8hNntvNo/EHy/g6c1K34i+ADLJHug
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQAWIQHSkv9dqZmcGBAQIcfl2JqVwkgOBfu3noaKgcgt/3
uC9ujyWC7/426rtSKIIvcCO+Zt8BBP/GoRTGKB1GOH9rx5E4ha8Ifhpr6YNz
55jg/OSi6q08s5jhfP107XM+iSxw/nkhHe5SS1Y4f/e6ptk6zGxwfjWjVsCZ
uwj+obwgH1lPdjif606VR94WBD9t6/vCkrMI/sG+lNlVzxD8vN9yG/5+QvCX
P3gqsucPgg8AKTtIdA==
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQAmIQHSkv9dqZmcOBAQw4HIrnmfkfYkXw51mmijzmQPBP
XZl8k5kHwVfk/pjsKoTgVzj6vWuTQPD1vpg7TvZC8J8uU5wyvwbB35Mu66Pz
EsGfoiHJsjOUE86fMCvteKICF5wfNSX2HM9zBP+Hy9Kf8/dxw/mPnzpVHGrn
gfMX2RpKn03khfPXtpYKpuvywfntocnezF8R/HszmqpcE/nhfNM7C1e2n0Xw
lyjvfqJxC8EXyb4if+oZgn+GL3Gv1FsEv2XT26jszwh+AsuWlZO/Ifg2YVU/
dv9E8Jc/eCqy5w+CDwBPhl1u
       "]], 
      LineBox[{{4.001594387755102, 4.}, {4.012357802873433, 4.}, {
       4.024691599773143, 4.}, {4.049359193572563, 4.}, {4.074026787371984, 
       4.}, {4.127489612697229, 4.}, {4.180952438022472, 4.}, {
       4.285929282493112, 4.}, {4.383855279967578, 4.}, {4.490036552894849, 
       4.}, {4.589166978825947, 4.}, {4.686348598577197, 4.}, {
       4.791785493781253, 4.}, {4.890171541989135, 4.}, {4.945085719974159, 
       4.}, {4.999999897959183, 4.}}]}, {}}, {{}, {}, {}}}, {
    {RGBColor[0.24720000000000014`, 0.24, 0.6], AbsolutePointSize[6], 
     PointBox[{{0., -1.}, {0., 0.}, {1., 0.}, {1., 1.}, {2., 1.}, {2., 2.}, {
      3., 2.}, {3., 3.}, {4., 3.}, {4., 4.}, {5., 4.}, {5., 5.}}]}, 
    {RGBColor[1, 1, 1], AbsolutePointSize[4], 
     PointBox[{{0., -1.}, {1., 0.}, {2., 1.}, {3., 2.}, {4., 3.}, {5., 
      4.}}]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 5}, {0., 4.}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 ImageSize->{184, 125},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->607718362]
}, Open  ]],

Cell["Plot several functions together.", "ExampleText",
 CellID->287874706],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", " ", 
  RowBox[{"\[Piecewise]", GridBox[{
     {"x", 
      RowBox[{"0", "\[LessEqual]", " ", "x", "<", "1"}]},
     {
      RowBox[{"2", "-", "x"}], 
      RowBox[{"1", "\[LessEqual]", "x", "<", "3"}]},
     {
      RowBox[{"-", "1"}], 
      RowBox[{"3", "\[LessEqual]", " ", "x", "<", "4"}]}
    }]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1627847298],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f", "[", "x", "]"}], ",", 
     RowBox[{
      RowBox[{"Floor", "[", "x", "]"}], "/", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "1"}], ",", "5"}], "}"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", " ", "Automatic"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->29527051],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnau3qzgUxrvW/BNjrxx5ZW1lZWXlrTxiBLK2EonERuImEotERmKRSGRn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    "], {{0, 98}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 98},
  PlotRange->{{0, 180}, {0, 98}}]], "Output",
 ImageSize->{184, 98},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->352198679]
}, Open  ]],

Cell["Plot a mix of continuous and piecewise continuous functions.", \
"ExampleText",
 CellID->1552303910],

Cell[BoxData[
 RowBox[{
  RowBox[{"g", "[", "x_", "]"}], ":=", " ", 
  RowBox[{"\[Piecewise]", GridBox[{
     {
      RowBox[{"1", " ", "-", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"x", "-", "1"}], ")"}], "2"]}], 
      RowBox[{"0", "\[LessEqual]", "x", "<", "2"}]},
     {
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"x", "-", "3"}], ")"}], "2"], "-", "1"}], 
      RowBox[{"2", "\[LessEqual]", " ", "x", "<", "3"}]},
     {
      RowBox[{"-", "1"}], 
      RowBox[{"3", "\[LessEqual]", " ", "x", "<", "4"}]}
    }]}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1940471614],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"g", "[", "x", "]"}], ",", 
     RowBox[{
      RowBox[{"Cos", "[", "x", "]"}], "/", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "\[Pi]"}], ",", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->1819753156],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztna23qzgXxu9a719y5cgraysrKysHWTECMQKLRCKxSNxEYpFIJBaJRPI+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    "], {{0, 119}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 119},
  PlotRange->{{0, 180}, {0, 119}}]], "Output",
 ImageSize->{184, 119},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[6]=",
 CellID->47977747]
}, Open  ]],

Cell["Visualize removable singularities.", "ExampleText",
 CellID->604632851],

Cell[BoxData[
 RowBox[{
  RowBox[{"h", "[", "x_", "]"}], ":=", " ", 
  RowBox[{"\[Piecewise]", GridBox[{
     {
      FractionBox[
       RowBox[{
        RowBox[{"(", 
         RowBox[{"x", "-", "2"}], ")"}], " ", 
        RowBox[{"(", 
         RowBox[{"x", "-", "1"}], ")"}]}], 
       RowBox[{"(", 
        RowBox[{"x", "-", "2"}], ")"}]], 
      RowBox[{"x", "!=", "2"}]},
     {"Indeterminate", 
      RowBox[{"x", "\[Equal]", "2"}]}
    }]}]}]], "Input",
 CellLabel->"In[7]:=",
 CellID->171709153],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePlot", "[", 
  RowBox[{
   RowBox[{"h", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "1"}], ",", "4"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->1845196550],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwtxXs01XcAAPDrXu5Xl/Y9OpOpbWHl2LhnQyFdfb8qc9MQ5VF0RIzZDh1E
m8fhDHdOHSOvvGJbyKPlNPIaXwcl5HYzj1OJ8nbJxXW73OG37ez7x+d8DAPC
3YPYLBbL+V//LS+27mEYGVGJC6cYhiG5snOD4XIZ6VOaSRs2GGJjHzc+PiMj
RQZtsnA5QxKm2hWkX0ZQxGvV+AxDeKZORomFMpKie0CnvZ8hRo2+sSxrGdHx
/d0usZAhpweS+GphS8Rkvj2XZc2QGu6TTPboIvHkzAjVwraJbvZHPYFR84TX
mx5o0bxJnC/q/ZH25Qwxrr32/MQnfxOnnd+ml5lMkrLUQ93u2Rvkbauy1j59
nMTK7L7LmFSS6bFvqlqPPidNMQWh91zfEcFJz6T14AHiesPDYDt/jdhKF68c
C+gmjsWtLsLFVRL5Q1GwXUM9qej+fjjSZ4UI5sYKbJ/koDbNT01vucmI3nrP
PoenbWirneurZ7xItvK4YGKoD6mdP5og4s2TPEn+G7fKQVSnZwm9qqdJ5ojf
ef7aC2TzvsR9PmWC5PYOqfZPvkaDoWd5Dw6PkVuPDb0EginUFfanm0g0QkZE
D1mZPrPIfTlq+5XwGbloVHMktU2KEqNddWY1HpI9CdLOxtm36AtY8/pwRy25
8aJ+yaFqGWH3luFWYRmqS+lh13mvolL+V7tLH3agMJ20ViyVo8vXhIsa7k+R
hCdtLy5WIGx6hxMTPYz6pt6F6h9UIrOsl9VBklEUKPYsyu9YR4+L7tpYprxB
tw9475ZGqJDwVK3Z4PQUir+gYX2Ou4lUzbyw+9pziGGfLb3ZsoW2Ne5g85gF
9HGjImM0hEGCywuGTc+WkLTcMLskjoUHnY+boI1llG+ir97koYYt3Cw0I6pX
UU7B193+Bmz82aH+9E68hvyyL4i1Z9m4zaSlSF+sQFsnyjZK2jhYleYkR/FK
NDd97GqHSB1L+lKWk+EGqrAz39vvr4FdYgOsCjpV6H7KFZ1gPhcHai0Yic9v
ousel05xFFz8QfWjXK50C9mO/lIp6gc4qvH4GVjIoINnrHwK8zTx/7MwO2mv
eV7EDroaLrGqcso5yaOz8U+j6Q1Gu7ToHOxwuEt4c0GLzsEuqa784gfadHVs
7JPscTt+J10DD8zs+DXL4z06F/cGTNvv2gfpAL9Sr1jPMYJ0gJfLQ+7pG0M6
wLoLCx8a8iEd4IuRq8rPj0A6wMofmbvOXpAO8P4y/T1pP0M6wNaOLyXaWZAO
sNN8kSgjF9IBDucbKPKKIR3g5npjSXk1pAN8+pFlalc3pAN8KUQhEPZBOsDR
vAZ5nxjSAS50sfX/awjSAZ4ZxoKJSUgHeOMqWx40C+kAa+/tqpyXQjrAFn6O
eisrkA6wg9oOcZQC0gH2/q03eX0d0gEOdbh+JG4T0gGOn3VeZRhIB/gfp3xg
Wg==
      "]]}}, {
    {RGBColor[0.24720000000000014`, 0.24, 0.6], AbsolutePointSize[6], 
     PointBox[{{2., 1.}}]}, 
    {RGBColor[1, 1, 1], AbsolutePointSize[4], PointBox[{{2., 1.}}]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{-1, 4}, {-1.9999998979591838`, 2.9999998979591838`}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 ImageSize->{184, 118},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->407069523]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2061341341],

Cell[CellGroupData[{

Cell[TextData[{
 "PointStyle",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1757724783],

Cell["Change the color of the points.", "ExampleText",
 CellID->1620939045],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->863455722],

Cell[BoxData[
 RowBox[{
  RowBox[{"g", "[", "x_", "]"}], ":=", " ", 
  RowBox[{"\[Piecewise]", GridBox[{
     {
      RowBox[{"1", " ", "-", " ", 
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"x", "-", "1"}], ")"}], "2"]}], 
      RowBox[{"0", "\[LessEqual]", "x", "<", "2"}]},
     {
      RowBox[{
       SuperscriptBox[
        RowBox[{"(", 
         RowBox[{"x", "-", "3"}], ")"}], "2"], "-", "1"}], 
      RowBox[{"2", "\[LessEqual]", " ", "x", "<", "3"}]},
     {
      RowBox[{"-", "1"}], 
      RowBox[{"3", "\[LessEqual]", " ", "x", "<", "4"}]}
    }]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1490775013],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePlot", "[", 
  RowBox[{
   RowBox[{"g", "[", "\[Theta]", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", 
     RowBox[{"-", "1"}], ",", "5"}], "}"}], ",", 
   RowBox[{"PointStyle", "\[Rule]", " ", "Red"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->763933942],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnSuzo0oQx1O1Zj/C2v0YsSsjkZEbGXEFVdfEIpGRWCTuIrFIJBIbiYyc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    "], {{0, 118}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 118},
  PlotRange->{{0, 180}, {0, 118}}]], "Output",
 ImageSize->{184, 118},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->53064139]
}, Open  ]],

Cell["Change the color and size of the points.", "ExampleText",
 CellID->39019451],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePlot", "[", 
  RowBox[{
   RowBox[{"g", "[", "\[Theta]", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", 
     RowBox[{"-", "1"}], ",", "5"}], "}"}], ",", 
   RowBox[{"PointStyle", "\[Rule]", 
    RowBox[{"{", " ", 
     RowBox[{"Red", ",", 
      RowBox[{"PointSize", "[", ".04", "]"}]}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->817400622],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnSuUo0oQhnPONStXjh155crYlSORkRsZcQXnXBOLREbGIuMuMhaJRMYi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    "], {{0, 118}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 118},
  PlotRange->{{0, 180}, {0, 118}}]], "Output",
 ImageSize->{184, 118},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->201769080]
}, Open  ]],

Cell["\<\
When plotting two or more functions specifications for each curve should be \
given in a list or Directive.\
\>", "ExampleText",
 CellID->519538123],

Cell[BoxData[
 RowBox[{
  RowBox[{"f", "[", "x_", "]"}], ":=", " ", 
  RowBox[{"\[Piecewise]", GridBox[{
     {"x", 
      RowBox[{"0", "\[LessEqual]", " ", "x", "<", "1"}]},
     {
      RowBox[{"2", "-", "x"}], 
      RowBox[{"1", "\[LessEqual]", "x", "<", "3"}]},
     {
      RowBox[{"-", "1"}], 
      RowBox[{"3", "\[LessEqual]", " ", "x", "<", "4"}]}
    }]}]}]], "Input",
 CellLabel->"In[5]:=",
 CellID->208724559],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f", "[", "x", "]"}], ",", 
     RowBox[{
      RowBox[{"Floor", "[", "x", "]"}], "/", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "1"}], ",", "5"}], "}"}], ",", 
   RowBox[{"PointStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"PointSize", "[", "Large", "]"}]}], "}"}], ",", 
      RowBox[{"Directive", "[", 
       RowBox[{"Green", ",", 
        RowBox[{"PointSize", "[", "Medium", "]"}]}], "]"}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->1192867562],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnSuUqzoUhlnrmpEjx44cWVlbWVmJPJUjjmCta7BIJLIWWXeR2EokEotE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    "], {{0, 118}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 118},
  PlotRange->{{0, 180}, {0, 118}}]], "Output",
 ImageSize->{184, 118},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[6]=",
 CellID->10046140]
}, Open  ]],

Cell["\<\
When PlotStyle is used without PointStyle points will take values from \
PlotStyle.\
\>", "ExampleText",
 CellID->1457074788],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"f", "[", "x", "]"}], ",", 
     RowBox[{
      RowBox[{"Floor", "[", "x", "]"}], "/", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "1"}], ",", "5"}], "}"}], ",", 
   RowBox[{"PlotStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Directive", "[", 
       RowBox[{"Red", ",", "Dashed"}], "]"}], ",", 
      RowBox[{"{", 
       RowBox[{"Green", ",", "Thick"}], "}"}]}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->1299935175],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS2U8joQhnvONciVWGQlsrYSuRL5IRGf4JxrsMhKJBaJu5VY5MpK7Eok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    "], {{0, 118}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 118},
  PlotRange->{{0, 180}, {0, 118}}]], "Output",
 ImageSize->{184, 118},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[7]=",
 CellID->740198836]
}, Open  ]],

Cell["Control the interior of the empty circles. ", "ExampleText",
 CellID->1588070137],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePlot", "[", 
  RowBox[{
   RowBox[{"Floor", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "5.2"}], "}"}], ",", 
   RowBox[{"PointStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Green", ",", 
        RowBox[{"AbsolutePointSize", "[", "12", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Orange", ",", 
        RowBox[{"AbsolutePointSize", "[", "9", "]"}]}], "}"}]}], "}"}]}], ",", 
   RowBox[{"PlotRangePadding", "\[Rule]", " ", "1.2"}]}], "]"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->1768027643],

Cell[BoxData[
 GraphicsBox[{{{{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGDQBWIQ7SG77u7amho7Bih4q6xUsUgxyh7Gn5hxrC5TMQvO
f9wlweSrWAXn88w5eNhOsQvOX6AybYm54iw4/1UGg6iJ4io4n7/b1NdIcRec
f6BXbmOr1Wk4/7fEuxMiVlfg/A1zmB5t3HoLzp+tU9//594DOP9uYzczn/oT
OL+9uLuzZOtzOP+f7bPFDsav4XyWx0u73R0QfK6O1GI/XwRf7NITp5h0BF83
7fHD8tkIfkzfA/n1zG/g/J33bs2WvYLg72ue1azyEME/ohGVrf0Owb9QdNPK
kuMtnP+C7cbNEBsEX0z/qnjPEgS/pP785F8l7+D8N5+unZdqRvCT0+5xW09E
8IN83zZXr0XwDaS5S/48RfBX9AltkPmC4MszSb2xYXoP5/O91EiplUPw32xz
C/kXhuCnaPlNkEtF8G/PDT1jV4zgn2pJcanvR/CdfmQ3zJ+L4O/MLt6zfzWC
vyKoyYThBIKvcKyzQOEagj/dcuIahydI7ls740XCJwS/QDFhShYSHwC7TLOZ

       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBWIQ7fH+/NZTbB/sGcDgg/2u5vBzCXwIvtH3OK5GGQT/
3aRZr5p6EfyVetdOtfxD8B8wb2RoufgRzhe/2W3WvOQTnP/mfV6OidMXOP/r
FW9tAeZvcH7t1/dXHi39DudbPullf5D9E86PsY9kmaD5G87/d/X1a7OTf+D8
TA6jJfNX/YXzr1hVxHD0/IPzXyn5Flt9RfD/cyl15cT9h/O56numsk5G8EU+
f1sw7ziCL6W7Ru31QwR/h4CBl+lPBB8AbBN0Hg==
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQBmIQveT786hUZgYHBghwEGSa930dC4IftDKk4wc7gj8p
gFvSiRvBF5lfYXVVEMGf+vZpdIYEgm/h+VMktQvBv7WE51ziHyTzhbyWmtxh
hPO7ZF9/ZFrLBOff4edsTutnhvPfze/qPJrEAucbP1P6+teQFeE+YYulp4XY
4PyN9zacmvIEwT+3ffV/5zB2OP/VhGUmn48j+D9kO/RuPUbwYzgkls76g+AD
ANvlRRk=
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQveT786hUZg4HBjDgcPDge/RsFxuC/8pe7pg5F4Lf
Uxi1dAsvgn/+yqXkdSIIvpCFt9IKaQR/5j/r+bM1EXyFozoy/eYIvvX99/yx
+Qh+2M9NzNrLEfycP6+WuvBzwvlN/5U84soR/BNv+C+qRXLB+efKE86/0uaG
89l3Hjfq+IXgRz1cfWvXLR44P3f55+8vVvPC+bNCdkSu6eOD8wWqfI52/0Dw
2+c/MMhO4kfYF//BPnAagi+mwOBvfgrBt2LoCNN6guDHcEgsnfUHwQcAEQRW
cQ==
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQfel38dpNjAIODGAg4GDy5ge/LxOCb5ZV6PCGGcG3
ePGyoJsVwbd5cuviSQ4E3/HBaSMOHgTf68baLy1CCH7whf5tjJIIftKpfWK+
gQh+wZG3ZTM6Efzc9r8f13xC8L/v9ebvSRGE82f7q94Pv4Lgy2/YkLnQRgjO
N2ipmrZ1LYKvqP6t1l1cGM7XVv0rfqwOwf92V37bq20I/qFpTiH87xH8U1yb
Ds/+iuBfrFM01viD4F+K/ut3+i+Cf8XiZlbef9x8AFP4XRQ=
       "]], 
      LineBox[{{5.001043419649667, 5.}, {5.002642192933045, 5.}, {
       5.005839739499802, 5.}, {5.009037286066558, 5.}, {5.021827472333583, 
       5.}, {5.034617658600608, 5.}, {5.060198031134657, 5.}, {
       5.085778403668706, 5.}, {5.142889148773129, 5.}, {5.199999893877552, 
       5.}}]}, {}}, {{}, {}, {}}}, {
    {RGBColor[0, 1, 0], AbsolutePointSize[12], 
     PointBox[{{0., -1.}, {0., 0.}, {1., 0.}, {1., 1.}, {2., 1.}, {2., 2.}, {
      3., 2.}, {3., 3.}, {4., 3.}, {4., 4.}, {5., 4.}, {5., 5.}}]}, 
    {RGBColor[1, 0.5, 0], AbsolutePointSize[9], 
     PointBox[{{0., -1.}, {1., 0.}, {2., 1.}, {3., 2.}, {4., 3.}, {5., 
      4.}}]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 5.2}, {0., 5.}},
  PlotRangeClipping->True,
  PlotRangePadding->1.2]], "Output",
 ImageSize->{184, 117},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->1801180827]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["PiecewisePolarPlot",
    BaseStyle->"Link",
    ButtonData->"paclet:Classroom Utilities/ref/PiecewisePolarPlot"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 StyleBox[ButtonBox["Plot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Plot"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["PolarPlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/PolarPlot"],
  FontFamily->"Verdana"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Plotting Piecewise Continuous Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/PlottingPiecewiseContinuousFunctions"]],\
 "ExampleText",
 CellID->1934432443]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->147977247],

Cell[TextData[ButtonBox["Understanding Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], "MoreAbout",
 CellID->48130759],

Cell[TextData[ButtonBox["Visualizing Piecewise Continuous Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/VisualizingPiecewiseContinuousFunctions"]],\
 "MoreAbout",
 CellID->199550353]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PiecewisePlot - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 28, 54.7264624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PiecewisePlot[fn, {var, var_min, var_max}, opts] creates a textbook \
style plot of a piecewise continuous function with filled circles at the \
point of discontinuity where the function is defined and open circles where \
the function is not defined.PiecewisePlot[{fn_1, fn_2, ...}, {var, var_min, \
var_max}, opts] creates a textbook style plot of several functions both \
continuous and piecewise continuous.", "synonyms" -> {}, "title" -> 
    "PiecewisePlot", "titlemodifier" -> "", "windowtitle" -> "PiecewisePlot", 
    "type" -> "Symbol", "uri" -> "ClassroomUtilities/ref/PiecewisePlot"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7703, 229, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->284258124]},
 "RasterizedOutput"->{
  Cell[12827, 375, 3251, 61, 119, "Output",
   CellTags->"RasterizedOutput",
   CellID->352198679],
  Cell[17253, 483, 4243, 78, 140, "Output",
   CellTags->"RasterizedOutput",
   CellID->47977747],
  Cell[26235, 713, 3023, 58, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->53064139],
  Cell[29787, 793, 3048, 58, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->201769080],
  Cell[34146, 902, 3303, 62, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->10046140],
  Cell[38224, 996, 3320, 62, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->740198836]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 50258, 1302},
 {"RasterizedOutput", 50401, 1306}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[606, 21, 3206, 72, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3837, 97, 56, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3896, 100, 1777, 51, 158, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5710, 156, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->235899589],
Cell[6322, 176, 272, 11, 70, "Notes",
 CellID->1067943069],
Cell[6597, 189, 194, 6, 70, "Notes",
 CellID->1016346046],
Cell[6794, 197, 118, 3, 70, "Notes",
 CellID->643066884],
Cell[6915, 202, 144, 4, 70, "Notes",
 CellID->1887407684],
Cell[7062, 208, 604, 16, 70, "3ColumnTableMod",
 CellID->1179995151]
}, Closed]],
Cell[CellGroupData[{
Cell[7703, 229, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->284258124],
Cell[CellGroupData[{
Cell[8218, 247, 195, 6, 31, "ExampleSection",
 CellID->350001402],
Cell[8416, 255, 67, 1, 32, "ExampleText",
 CellID->1251137568],
Cell[8486, 258, 128, 3, 28, "Input",
 CellID->1247373048],
Cell[8617, 263, 67, 1, 32, "ExampleText",
 CellID->391274655],
Cell[CellGroupData[{
Cell[8709, 268, 224, 7, 28, "Input",
 CellID->558199471],
Cell[8936, 277, 2931, 59, 146, "Output",
 CellID->607718362]
}, Open  ]],
Cell[11882, 339, 75, 1, 70, "ExampleText",
 CellID->287874706],
Cell[11960, 342, 423, 14, 70, "Input",
 CellID->1627847298],
Cell[CellGroupData[{
Cell[12408, 360, 416, 13, 28, "Input",
 CellID->29527051],
Cell[12827, 375, 3251, 61, 119, "Output",
 CellTags->"RasterizedOutput",
 CellID->352198679]
}, Open  ]],
Cell[16093, 439, 106, 2, 70, "ExampleText",
 CellID->1552303910],
Cell[16202, 443, 636, 21, 70, "Input",
 CellID->1940471614],
Cell[CellGroupData[{
Cell[16863, 468, 387, 13, 28, "Input",
 CellID->1819753156],
Cell[17253, 483, 4243, 78, 140, "Output",
 CellTags->"RasterizedOutput",
 CellID->47977747]
}, Open  ]],
Cell[21511, 564, 77, 1, 70, "ExampleText",
 CellID->604632851],
Cell[21591, 567, 504, 18, 70, "Input",
 CellID->171709153],
Cell[CellGroupData[{
Cell[22120, 589, 242, 8, 70, "Input",
 CellID->1845196550],
Cell[22365, 599, 2142, 44, 139, "Output",
 CellID->407069523]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[24556, 649, 270, 8, 70, "ExampleSection",
 CellID->2061341341],
Cell[CellGroupData[{
Cell[24851, 661, 198, 6, 70, "ExampleSubsection",
 CellID->1757724783],
Cell[25052, 669, 75, 1, 70, "ExampleText",
 CellID->1620939045],
Cell[25130, 672, 127, 3, 70, "Input",
 CellID->863455722],
Cell[25260, 677, 636, 21, 70, "Input",
 CellID->1490775013],
Cell[CellGroupData[{
Cell[25921, 702, 311, 9, 70, "Input",
 CellID->763933942],
Cell[26235, 713, 3023, 58, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->53064139]
}, Open  ]],
Cell[29273, 774, 82, 1, 70, "ExampleText",
 CellID->39019451],
Cell[CellGroupData[{
Cell[29380, 779, 404, 12, 70, "Input",
 CellID->817400622],
Cell[29787, 793, 3048, 58, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->201769080]
}, Open  ]],
Cell[32850, 854, 158, 4, 70, "ExampleText",
 CellID->519538123],
Cell[33011, 860, 422, 14, 70, "Input",
 CellID->208724559],
Cell[CellGroupData[{
Cell[33458, 878, 685, 22, 70, "Input",
 CellID->1192867562],
Cell[34146, 902, 3303, 62, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->10046140]
}, Open  ]],
Cell[37464, 967, 135, 4, 70, "ExampleText",
 CellID->1457074788],
Cell[CellGroupData[{
Cell[37624, 975, 597, 19, 70, "Input",
 CellID->1299935175],
Cell[38224, 996, 3320, 62, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->740198836]
}, Open  ]],
Cell[41559, 1061, 87, 1, 70, "ExampleText",
 CellID->1588070137],
Cell[CellGroupData[{
Cell[41671, 1066, 609, 17, 70, "Input",
 CellID->1768027643],
Cell[42283, 1085, 2935, 60, 138, "Output",
 CellID->1801180827]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[45291, 1153, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[45740, 1168, 494, 18, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[46271, 1191, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[46722, 1206, 217, 5, 70, "ExampleText",
 CellID->1934432443]
}, Open  ]],
Cell[CellGroupData[{
Cell[46976, 1216, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[47427, 1231, 171, 4, 70, "MoreAbout",
 CellID->147977247],
Cell[47601, 1237, 178, 4, 70, "MoreAbout",
 CellID->48130759],
Cell[47782, 1243, 217, 5, 70, "MoreAbout",
 CellID->199550353]
}, Open  ]],
Cell[48014, 1251, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

