(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     76900,       1815]
NotebookOptionsPosition[     69338,       1577]
NotebookOutlinePosition[     72701,       1665]
CellTagsIndexPosition[     72579,       1659]
WindowTitle->PiecewisePolarPlot - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Plotting Piecewise Continuous Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
PlottingPiecewiseContinuousFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"PiecewisePlot\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/PiecewisePlot"], "\<\"Plot\"\>":>
       Documentation`HelpLookup["paclet:ref/Plot"], "\<\"PolarPlot\"\>":>
       Documentation`HelpLookup["paclet:ref/PolarPlot"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Understanding Functions\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingFunctions"], \
"\<\"Visualizing Piecewise Continuous Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/\
VisualizingPiecewiseContinuousFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/PiecewisePolarPlot\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PiecewisePolarPlot"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PiecewisePolarPlot.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PiecewisePolarPlot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PiecewisePolarPlot", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PiecewisePolarPlot", "[", 
       RowBox[{
        StyleBox["fn", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["var", "TI"], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["opts", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]creates a textbook style plot using polar coordinates \
of a piecewise continuous function with filled circles at the point of \
discontinuity where the function is defined and open circles where the \
function is not defined."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PiecewisePlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["fn", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["fn", "TI"], 
           StyleBox["2", "TR"]], ",", 
          StyleBox["\[Ellipsis]", "TR"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["var", "TI"], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["opts", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]",
     "creates a textbook style polar plot of several functions both \
continuous and piecewise continuous."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->482332357],

Cell[TextData[{
 "Functions such as ",
 ButtonBox["Floor",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Floor"],
 " and ",
 ButtonBox["Ceiling",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Ceiling"],
 " can be used in PiecewisePolarPlot."
}], "Notes",
 CellID->1117119649],

Cell[TextData[{
 ButtonBox["Piecewise",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Piecewise"],
 " can be entered directly as an argument to PiecewisePolarPlot."
}], "Notes",
 CellID->1016346046],

Cell["\<\
Functions with many continuous segments may take a while to render fully.\
\>", "Notes",
 CellID->643066884],

Cell[TextData[{
 "PiecewisePolarPlot will take the option ",
 Cell[BoxData[
  ButtonBox["PointStyle",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/PointStyle"]], "InlineFormula"],
 " as well as any option that can be used with ",
 ButtonBox["Plot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Plot"],
 ". "
}], "Notes",
 CellID->1887407684],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["PointStyle",
     BaseStyle->"Link",
     ButtonData->"paclet:PiecewisePlot/ref/PointStyle"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[TextData[Cell[
    "determines how endpoints of segments are rendered", "TableText"]], 
     "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True}}}},
 CellID->1179995151]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->89112473],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->164918782],

Cell["This loads the package.", "ExampleText",
 CellID->1856717599],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1729491316],

Cell["Plot the Floor function in polar coordinates.", "ExampleText",
 CellID->2127898669],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePolarPlot", "[", 
  RowBox[{
   RowBox[{"Floor", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", 
     RowBox[{"3", " ", "\[Pi]"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->672264233],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnaGXq7oWxmet+w88+ezII5+sraxEIi9yxBPI2srKSp5E4i4Si0Qiaysr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    "], {{0, 157}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 157},
  PlotRange->{{0, 180}, {0, 157}}]], "Output",
 ImageSize->{184, 157},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->472964747]
}, Open  ]],

Cell["Visualize a user defined piecewise continuous function.", "ExampleText",
 CellID->551005967],

Cell[BoxData[
 RowBox[{
  RowBox[{"p", "[", "x_", "]"}], ":=", 
  RowBox[{"\[Piecewise]", GridBox[{
     {
      RowBox[{"2", " ", 
       RowBox[{"Sin", "[", 
        RowBox[{"5", " ", "x"}], "]"}]}], 
      RowBox[{"0", "\[LessEqual]", "x", "<", 
       RowBox[{"\[Pi]", "/", "3"}]}]},
     {
      RowBox[{"Sin", "[", 
       RowBox[{"7", " ", "x"}], "]"}], 
      RowBox[{
       RowBox[{"\[Pi]", "/", "3"}], "\[LessEqual]", "x", "<", 
       RowBox[{"2", " ", 
        RowBox[{"\[Pi]", "/", "3"}]}]}]},
     {
      RowBox[{"1", "-", 
       RowBox[{"2", 
        RowBox[{"Cos", "[", " ", "x", "]"}]}]}], 
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{"\[Pi]", "/", "3"}]}], "\[LessEqual]", " ", "x", "<", 
       RowBox[{"2", " ", "\[Pi]"}]}]}
    }]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->807801505],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePolarPlot", "[", 
  RowBox[{
   RowBox[{"p", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->328278201],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztXSu3s7oW3WOcP3Ht9xOurK1EIpGnsuIKZMe4CllZWYvEnUgsEonEIpGV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    "], {{0, 126}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 126},
  PlotRange->{{0, 180}, {0, 126}}]], "Output",
 ImageSize->{184, 126},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->484955633]
}, Open  ]],

Cell["Include grid lines.", "ExampleText",
 CellID->1795749188],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePolarPlot", "[", 
  RowBox[{
   RowBox[{"p", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", 
   RowBox[{"PolarGridLines", "\[Rule]", " ", "Automatic"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->486235064],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztXa9367yyPWu9v+TAAy8sDQwMDLyBBQ8ElgYGBpoGhr1A08BAw9LAwEK/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    "], {{0, 180}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 180},
  PlotRange->{{0, 180}, {0, 180}}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[5]=",
 CellID->214243773]
}, Open  ]],

Cell["\<\
Plot several functions together and change the style of the points.\
\>", "ExampleText",
 CellID->787987115],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePolarPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"Floor", "[", "x", "]"}], "+", 
      RowBox[{"1", "/", "2"}]}], ",", 
     RowBox[{
      RowBox[{"Ceiling", "[", "x", "]"}], "+", 
      RowBox[{
       RowBox[{"Sin", "[", 
        RowBox[{"3", " ", "x"}], "]"}], "/", "3"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "5.5"}], "}"}], ",", 
   RowBox[{"PointStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Red", ",", "Green"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->167790756],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztna+Xq0wShnPOmvsnjL1y5MrYyEhk5IccsQKJRSKRWCRukX3OKiSyJRaJ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    "], {{0, 192}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 192},
  PlotRange->{{0, 180}, {0, 192}}]], "Output",
 ImageSize->{184, 192},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[6]=",
 CellID->219089963]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2061341341],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "PointStyle",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1965183116],

Cell["Change the color of the points.", "ExampleText",
 CellID->805167404],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1369385867],

Cell[BoxData[
 RowBox[{
  RowBox[{"p", "[", "x_", "]"}], ":=", 
  RowBox[{"\[Piecewise]", GridBox[{
     {
      RowBox[{"2", " ", 
       RowBox[{"Sin", "[", 
        RowBox[{"5", " ", "x"}], "]"}]}], 
      RowBox[{"0", "\[LessEqual]", "x", "<", 
       RowBox[{"\[Pi]", "/", "3"}]}]},
     {
      RowBox[{"Sin", "[", 
       RowBox[{"7", " ", "x"}], "]"}], 
      RowBox[{
       RowBox[{"\[Pi]", "/", "3"}], "\[LessEqual]", "x", "<", 
       RowBox[{"2", " ", 
        RowBox[{"\[Pi]", "/", "3"}]}]}]},
     {
      RowBox[{"1", "-", 
       RowBox[{"2", 
        RowBox[{"Cos", "[", " ", "x", "]"}]}]}], 
      RowBox[{
       RowBox[{"2", " ", 
        RowBox[{"\[Pi]", "/", "3"}]}], "\[LessEqual]", " ", "x", "<", 
       RowBox[{"2", " ", "\[Pi]"}]}]}
    }]}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1154099281],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePolarPlot", "[", 
  RowBox[{
   RowBox[{"p", "[", "\[Theta]", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", "0", ",", " ", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", 
   RowBox[{"PointStyle", "\[Rule]", " ", "Red"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->874316063],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztXSuwq8gWPVXPjBx57ZUjR8YikUjkREaMQFL1FBKJxCJxD4lFIpHYSGRk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    "], {{0, 126}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 126},
  PlotRange->{{0, 180}, {0, 126}}]], "Output",
 ImageSize->{184, 126},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->656022838]
}, Open  ]],

Cell["Modify the style of the empty points.", "ExampleText",
 CellID->1038110709],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePolarPlot", "[", 
  RowBox[{
   RowBox[{"p", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", 
   RowBox[{"PointStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Red", ",", 
        RowBox[{"AbsolutePointSize", "[", "12", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Blue", ",", 
        RowBox[{"AbsolutePointSize", "[", "9", "]"}]}], "}"}]}], "}"}]}], ",", 
   RowBox[{"PlotRangePadding", "\[Rule]", " ", "1.2"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1369537935],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS2U8jgUhnvOmpEjx4785EgsEolEbiViRSUWidlzkFhk3UbWVlZG1lZW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    "], {{0, 145}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 145},
  PlotRange->{{0, 180}, {0, 145}}]], "Output",
 ImageSize->{184, 145},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->1843241]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Possible Issues",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373],

Cell["\<\
PiecewiseExpand may not catch all possible cases and the points may not be \
rendered.\
\>", "ExampleText",
 CellID->1606445285],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->686021770],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePolarPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"Floor", "[", 
     RowBox[{"Sin", "[", 
      RowBox[{"2", " ", "x"}], "]"}], "]"}], "+", 
    RowBox[{"1", "/", "3"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", 
     RowBox[{"2", "\[Pi]"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1206710392],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS+Xq0wSh+ec/SQr9yPERkYiI19kxApkLBKJjEXitiUWiURikchIthqS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    "], {{0, 180}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 180},
  PlotRange->{{0, 180}, {0, 180}}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->96206064]
}, Open  ]],

Cell["\<\
Defining the function as a piecewise functions creates the expected plot.\
\>", "ExampleText",
 CellID->1917816903],

Cell[BoxData[
 RowBox[{
  RowBox[{"fs", "[", "x_", "]"}], ":=", 
  RowBox[{"\[Piecewise]", GridBox[{
     {
      RowBox[{"1", "/", "3"}], 
      RowBox[{"0", "\[LessEqual]", " ", "x", "<", 
       RowBox[{"\[Pi]", "/", "2"}]}]},
     {
      RowBox[{
       RowBox[{"-", "2"}], "/", "3"}], 
      RowBox[{
       RowBox[{"\[Pi]", "/", "2"}], "\[LessEqual]", " ", "x", "<", "\[Pi]"}]},
     {
      RowBox[{"1", "/", "3"}], 
      RowBox[{"\[Pi]", "\[LessEqual]", " ", "x", "<", 
       RowBox[{"3", " ", 
        RowBox[{"\[Pi]", "/", "2"}]}]}]},
     {
      RowBox[{
       RowBox[{"-", "2"}], "/", "3"}], 
      RowBox[{
       RowBox[{"3", " ", 
        RowBox[{"\[Pi]", "/", "2"}]}], "\[LessEqual]", " ", "x", "<", 
       RowBox[{"2", " ", "\[Pi]"}]}]}
    }]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1166630898],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePolarPlot", "[", 
  RowBox[{
   RowBox[{"fs", "[", "\[Theta]", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", "0", ",", " ", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1039805576],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS+Xq0wSxuec/SQr9yPERkZGRr7IiBXIWGQkEovEbUssEonERiIjs0/T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    "], {{0, 180}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 180},
  PlotRange->{{0, 180}, {0, 180}}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->677361569]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["PiecewisePlot",
    BaseStyle->"Link",
    ButtonData->"paclet:Classroom Utilities/ref/PiecewisePlot"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 StyleBox[ButtonBox["Plot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Plot"],
  FontFamily->"Verdana"],
 " . ",
 StyleBox[ButtonBox["PolarPlot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/PolarPlot"],
  FontFamily->"Verdana"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Plotting Piecewise Continuous Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/PlottingPiecewiseContinuousFunctions"]],\
 "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->447398784],

Cell[TextData[ButtonBox["Understanding Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], "MoreAbout",
 CellID->457354169],

Cell[TextData[ButtonBox["Visualizing Piecewise Continuous Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/VisualizingPiecewiseContinuousFunctions"]],\
 "MoreAbout",
 CellID->306372286]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PiecewisePolarPlot - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 28, 59.7496624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PiecewisePolarPlot[fn, {var, var_min, var_max}, opts] creates a textbook \
style plot using polar coordinates of a piecewise continuous function with \
filled circles at the point of discontinuity where the function is defined \
and open circles where the function is not defined.PiecewisePlot[{fn_1, fn_2, \
...}, {var, var_min, var_max}, opts] creates a textbook style polar plot of \
several functions both continuous and piecewise continuous.", 
    "synonyms" -> {}, "title" -> "PiecewisePolarPlot", "titlemodifier" -> "", 
    "windowtitle" -> "PiecewisePolarPlot", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/PiecewisePolarPlot"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[8536, 254, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->89112473]},
 "RasterizedOutput"->{
  Cell[9824, 303, 5354, 96, 178, "Output",
   CellTags->"RasterizedOutput",
   CellID->472964747],
  Cell[16407, 446, 5508, 98, 147, "Output",
   CellTags->"RasterizedOutput",
   CellID->484955633],
  Cell[22347, 563, 11763, 201, 201, "Output",
   CellTags->"RasterizedOutput",
   CellID->214243773],
  Cell[34873, 795, 6989, 123, 213, "Output",
   CellTags->"RasterizedOutput",
   CellID->219089963],
  Cell[43883, 996, 5492, 98, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->656022838],
  Cell[50133, 1122, 4587, 83, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->1843241],
  Cell[55728, 1249, 4531, 82, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->96206064],
  Cell[61531, 1380, 5008, 90, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->677361569]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 71615, 1627},
 {"RasterizedOutput", 71757, 1631}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[611, 21, 3751, 87, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4387, 112, 61, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[4451, 115, 1823, 53, 172, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[6311, 173, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->482332357],
Cell[6923, 193, 277, 11, 70, "Notes",
 CellID->1117119649],
Cell[7203, 206, 199, 6, 70, "Notes",
 CellID->1016346046],
Cell[7405, 214, 118, 3, 70, "Notes",
 CellID->643066884],
Cell[7526, 219, 366, 12, 70, "Notes",
 CellID->1887407684],
Cell[7895, 233, 604, 16, 70, "3ColumnTableMod",
 CellID->1179995151]
}, Closed]],
Cell[CellGroupData[{
Cell[8536, 254, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->89112473],
Cell[CellGroupData[{
Cell[9050, 272, 195, 6, 31, "ExampleSection",
 CellID->164918782],
Cell[9248, 280, 67, 1, 32, "ExampleText",
 CellID->1856717599],
Cell[9318, 283, 127, 3, 28, "Input",
 CellID->1729491316],
Cell[9448, 288, 89, 1, 32, "ExampleText",
 CellID->2127898669],
Cell[CellGroupData[{
Cell[9562, 293, 259, 8, 28, "Input",
 CellID->672264233],
Cell[9824, 303, 5354, 96, 178, "Output",
 CellTags->"RasterizedOutput",
 CellID->472964747]
}, Open  ]],
Cell[15193, 402, 98, 1, 70, "ExampleText",
 CellID->551005967],
Cell[15294, 405, 825, 27, 70, "Input",
 CellID->807801505],
Cell[CellGroupData[{
Cell[16144, 436, 260, 8, 28, "Input",
 CellID->328278201],
Cell[16407, 446, 5508, 98, 147, "Output",
 CellTags->"RasterizedOutput",
 CellID->484955633]
}, Open  ]],
Cell[21930, 547, 63, 1, 70, "ExampleText",
 CellID->1795749188],
Cell[CellGroupData[{
Cell[22018, 552, 326, 9, 28, "Input",
 CellID->486235064],
Cell[22347, 563, 11763, 201, 201, "Output",
 CellTags->"RasterizedOutput",
 CellID->214243773]
}, Open  ]],
Cell[34125, 767, 118, 3, 70, "ExampleText",
 CellID->787987115],
Cell[CellGroupData[{
Cell[34268, 774, 602, 19, 47, "Input",
 CellID->167790756],
Cell[34873, 795, 6989, 123, 213, "Output",
 CellTags->"RasterizedOutput",
 CellID->219089963]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[41911, 924, 270, 8, 70, "ExampleSection",
 CellID->2061341341],
Cell[CellGroupData[{
Cell[42206, 936, 282, 8, 70, "ExampleSubsection",
 CellID->1965183116],
Cell[42491, 946, 74, 1, 70, "ExampleText",
 CellID->805167404],
Cell[42568, 949, 128, 3, 70, "Input",
 CellID->1369385867],
Cell[42699, 954, 826, 27, 70, "Input",
 CellID->1154099281],
Cell[CellGroupData[{
Cell[43550, 985, 330, 9, 70, "Input",
 CellID->874316063],
Cell[43883, 996, 5492, 98, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->656022838]
}, Open  ]],
Cell[49390, 1097, 81, 1, 70, "ExampleText",
 CellID->1038110709],
Cell[CellGroupData[{
Cell[49496, 1102, 634, 18, 70, "Input",
 CellID->1369537935],
Cell[50133, 1122, 4587, 83, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->1843241]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[54781, 1212, 278, 8, 70, "ExampleSection",
 CellID->1305812373],
Cell[55062, 1222, 138, 4, 70, "ExampleText",
 CellID->1606445285],
Cell[55203, 1228, 127, 3, 70, "Input",
 CellID->686021770],
Cell[CellGroupData[{
Cell[55355, 1235, 370, 12, 70, "Input",
 CellID->1206710392],
Cell[55728, 1249, 4531, 82, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->96206064]
}, Open  ]],
Cell[60274, 1334, 125, 3, 70, "ExampleText",
 CellID->1917816903],
Cell[60402, 1339, 825, 27, 70, "Input",
 CellID->1166630898],
Cell[CellGroupData[{
Cell[61252, 1370, 276, 8, 70, "Input",
 CellID->1039805576],
Cell[61531, 1380, 5008, 90, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->677361569]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[66600, 1477, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[67049, 1492, 484, 18, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[67570, 1515, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[68021, 1530, 214, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[68272, 1540, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[68723, 1555, 171, 4, 70, "MoreAbout",
 CellID->447398784],
Cell[68897, 1561, 179, 4, 70, "MoreAbout",
 CellID->457354169],
Cell[69079, 1567, 217, 5, 70, "MoreAbout",
 CellID->306372286]
}, Open  ]],
Cell[69311, 1575, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

