(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     39318,       1160]
NotebookOptionsPosition[     33740,        983]
NotebookOutlinePosition[     36131,       1046]
CellTagsIndexPosition[     36009,       1040]
WindowTitle->PlotGrid - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Building an Understanding of Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
BuildingAnUnderstandingOfFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"PointGrid\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PointGrid"], "\<\"XGrid\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/XGrid"], "\<\"PolarPlotGrid\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PolarPlotGrid"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Understanding Functions\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/PlotGrid\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PlotGrid"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PlotGrid.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PlotGrid", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PlotGrid", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PlotGrid", "[", 
       RowBox[{
        StyleBox["quad", "TI"], ",", 
        StyleBox["opts", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]creates an empty grid to use in plotting exercises \
including the quadrants specified in quad."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PlotGrid", "[", 
       RowBox[{"{", 
        RowBox[{
         StyleBox["dom", "TI"], ",", 
         StyleBox["rng", "TI"]}], "}"}], "]"}]], "InlineFormula"],
     "\[LineSeparator]creates an empty grid to use in plotting on the \
interval ",
     Cell[BoxData[
      StyleBox["dom", "TI"]], "InlineFormula"],
     " with range ",
     Cell[BoxData[
      StyleBox["rng", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->42778269],

Cell["\<\
Quadrants are specified using QuadrantI, QuadrantII, QuadrantIII, QuadrantIV \
or All\
\>", "ExampleText",
 CellID->2064705943],

Cell["{First,Third} or {Second, Fourth} will give the same as All.", \
"ExampleText",
 CellID->324532128],

Cell["\<\
PlotGrid takes the same options as Graphics with the following modifications: \
\>", "Notes"],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["GridLines",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/GridLines"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], 
    RowBox[{
    "Automatic", " ", "produces", " ", "grid", " ", "lines", " ", "evenly", 
     " ", "spaced", " ", "at", " ", "unit", " ", "intervals"}]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["GridLinesStyle",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/GridLinesStyle"], 
    RowBox[{"{", "}"}], Cell["\<\
GridLinesStyle will accept the values PointGrid and XGrid in addition to the \
usual values\
\>", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}}],

Cell["\<\
With GridLInesStyle \[Rule] XGrid the grid lines will be rendered as an \
integer lattice of +\
\>", "ExampleText",
 CellID->1950495563],

Cell["\<\
With GridLinesStyle \[Rule] PointGrid the grid lines will be an integer \
lattice of points.\
\>", "ExampleText",
 CellID->641055886]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->139388780],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->327352521],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->300819003],

Cell["A basic plot grid going from -10 to 10 in both directions.", \
"ExampleText",
 CellID->688478383],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PlotGrid", "[", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->614293045],

Cell[BoxData[
 FormBox[
  GraphicsBox[{},
   AlignmentPoint->Center,
   AspectRatio->Automatic,
   Axes->True,
   AxesLabel->None,
   AxesOrigin->Automatic,
   AxesStyle->{},
   Background->None,
   BaseStyle->{14, Italic},
   BaselinePosition->Automatic,
   ColorOutput->Automatic,
   ContentSelectable->Automatic,
   CoordinatesToolOptions:>Automatic,
   DisplayFunction:>$DisplayFunction,
   Epilog->{},
   FormatType:>TraditionalForm,
   Frame->False,
   FrameLabel->None,
   FrameStyle->{},
   FrameTicks->Automatic,
   FrameTicksStyle->{},
   GridLines->{{-10, -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 6, 
    7, 8, 9, 10}, {-10, -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 
    6, 7, 8, 9, 10}},
   GridLinesStyle->{},
   ImageMargins->0.,
   ImagePadding->All,
   ImageSize->432,
   ImageSizeRaw->Automatic,
   LabelStyle->{},
   Method->Automatic,
   PlotLabel->None,
   PlotRange->{{-10, 10}, {-10, 10}},
   PlotRangeClipping->False,
   PlotRangePadding->Automatic,
   PlotRegion->Automatic,
   PreserveImageOptions->Automatic,
   Prolog->{},
   RotateLabel->True,
   Ticks->Automatic,
   TicksStyle->{}], TraditionalForm]], "Output",
 ImageSize->{436, 429},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1532529101]
}, Open  ]],

Cell["Additional elements can be added using Epilog.", "ExampleText",
 CellID->882681249],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PlotGrid", "[", 
  RowBox[{"All", ",", 
   RowBox[{"Epilog", "\[Rule]", " ", 
    RowBox[{"Circle", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", "0"}], "}"}], ",", "3"}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->406718467],

Cell[BoxData[
 FormBox[
  GraphicsBox[{},
   AlignmentPoint->Center,
   AspectRatio->Automatic,
   Axes->True,
   AxesLabel->None,
   AxesOrigin->Automatic,
   AxesStyle->{},
   Background->None,
   BaseStyle->{14, Italic},
   BaselinePosition->Automatic,
   ColorOutput->Automatic,
   ContentSelectable->Automatic,
   CoordinatesToolOptions:>Automatic,
   DisplayFunction:>$DisplayFunction,
   Epilog->CircleBox[{0, 0}, 3],
   FormatType:>TraditionalForm,
   Frame->False,
   FrameLabel->None,
   FrameStyle->{},
   FrameTicks->Automatic,
   FrameTicksStyle->{},
   GridLines->{{-10, -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 6, 
    7, 8, 9, 10}, {-10, -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 
    6, 7, 8, 9, 10}},
   GridLinesStyle->{},
   ImageMargins->0.,
   ImagePadding->All,
   ImageSize->432,
   ImageSizeRaw->Automatic,
   LabelStyle->{},
   Method->Automatic,
   PlotLabel->None,
   PlotRange->{{-10, 10}, {-10, 10}},
   PlotRangeClipping->False,
   PlotRangePadding->Automatic,
   PlotRegion->Automatic,
   PreserveImageOptions->Automatic,
   Prolog->{},
   RotateLabel->True,
   Ticks->Automatic,
   TicksStyle->{}], TraditionalForm]], "Output",
 ImageSize->{436, 429},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->297738389]
}, Open  ]],

Cell["Single quadrants can be selected.", "ExampleText",
 CellID->644685305],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PlotGrid", "[", "QuadrantI", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1170922020],

Cell[BoxData[
 GraphicsBox[{},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{14, Italic},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  GridLines->{{-10, -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 6, 
   7, 8, 9, 10}, {-10, -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 
   6, 7, 8, 9, 10}},
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->216,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->{{0, 10}, {0, 10}},
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{220, 219},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->2065014111]
}, Open  ]],

Cell["Adjacent quadrants can be specified.", "ExampleText",
 CellID->1286188656],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PlotGrid", "[", 
  RowBox[{"{", 
   RowBox[{"QuadrantI", ",", "QuadrantII"}], "}"}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->402350690],

Cell[BoxData[
 FormBox[
  GraphicsBox[{},
   AlignmentPoint->Center,
   AspectRatio->Automatic,
   Axes->True,
   AxesLabel->None,
   AxesOrigin->Automatic,
   AxesStyle->{},
   Background->None,
   BaseStyle->{14, Italic},
   BaselinePosition->Automatic,
   ColorOutput->Automatic,
   ContentSelectable->Automatic,
   CoordinatesToolOptions:>Automatic,
   DisplayFunction:>$DisplayFunction,
   Epilog->{},
   FormatType:>TraditionalForm,
   Frame->False,
   FrameLabel->None,
   FrameStyle->{},
   FrameTicks->Automatic,
   FrameTicksStyle->{},
   GridLines->{{-10, -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 6, 
    7, 8, 9, 10}, {-10, -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 
    6, 7, 8, 9, 10}},
   GridLinesStyle->{},
   ImageMargins->0.,
   ImagePadding->All,
   ImageSize->432,
   ImageSizeRaw->Automatic,
   LabelStyle->{},
   Method->Automatic,
   PlotLabel->None,
   PlotRange->{{-10, 10}, {0, 10}},
   PlotRangeClipping->False,
   PlotRangePadding->Automatic,
   PlotRegion->Automatic,
   PreserveImageOptions->Automatic,
   Prolog->{},
   RotateLabel->True,
   Ticks->Automatic,
   TicksStyle->{}], TraditionalForm]], "Output",
 ImageSize->{436, 234},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->288556558]
}, Open  ]],

Cell["The domain and range can be given explicitly.", "ExampleText",
 CellID->1269293597],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PlotGrid", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "4"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"-", "3"}], ",", "5"}], "}"}]}], "}"}], ",", 
   RowBox[{"ImageSize", "\[Rule]", " ", "Medium"}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->2062419128],

Cell[BoxData[
 FormBox[
  GraphicsBox[{},
   AlignmentPoint->Center,
   AspectRatio->Automatic,
   Axes->True,
   AxesLabel->None,
   AxesOrigin->Automatic,
   AxesStyle->{},
   Background->None,
   BaseStyle->{14, Italic},
   BaselinePosition->Automatic,
   ColorOutput->Automatic,
   ContentSelectable->Automatic,
   CoordinatesToolOptions:>Automatic,
   DisplayFunction:>$DisplayFunction,
   Epilog->{},
   FormatType:>TraditionalForm,
   Frame->False,
   FrameLabel->None,
   FrameStyle->{},
   FrameTicks->Automatic,
   FrameTicksStyle->{},
   GridLines->{{-2, -1, 0, 1, 2, 3, 4}, {-3, -2, -1, 0, 1, 2, 3, 4, 5}},
   GridLinesStyle->{},
   ImageMargins->0.,
   ImagePadding->All,
   ImageSize->Medium,
   ImageSizeRaw->Automatic,
   LabelStyle->{},
   Method->Automatic,
   PlotLabel->None,
   PlotRange->{{-2, 4}, {-3, 5}},
   PlotRangeClipping->False,
   PlotRangePadding->Automatic,
   PlotRegion->Automatic,
   PreserveImageOptions->Automatic,
   Prolog->{},
   RotateLabel->True,
   Ticks->Automatic,
   TicksStyle->{}], TraditionalForm]], "Output",
 ImageSize->{341, 432},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->751995380]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "GridLinesStyle",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True],

Cell["\<\
With GridLinesStyle \[Rule] XGrid the grid lines are rendered as an integer \
lattice of +'s.\
\>", "ExampleText",
 CellID->1761960417],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PlotGrid", "[", 
  RowBox[{"All", ",", 
   RowBox[{"GridLinesStyle", "\[Rule]", " ", "XGrid"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1616720036],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3SFUI8uXx3H2rEEiY0ciI7GRSCRyIxErIseujIzEovbknDWRschIZOxI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    "], {{0, 427}, {432, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{432, 427},
  PlotRange->{{0, 432}, {0, 427}}]], "Output",
 ImageSize->{436, 427},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[1]=",
 CellID->570319867]
}, Open  ]],

Cell["Styles for the special grids can be included.", "ExampleText",
 CellID->1250222245],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PlotGrid", "[", 
  RowBox[{"All", ",", 
   RowBox[{"GridLinesStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Red", ",", 
      RowBox[{"PointSize", "[", "Large", "]"}], ",", "PointGrid"}], "}"}]}]}],
   "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1505269467],

Cell[BoxData[
 FormBox[
  GraphicsBox[
   {RGBColor[1, 0, 0], PointSize[Large], PointBox[CompressedData["
1:eJxN14lt3DAQQNGReKuLtJQSUkBSXxpLvLs6EgH/QzRAPMMHPSA5h7/9+PX9
5xoRv5eI2z/Xdbn+4he+8I0f3PHAEy8M9l3Qv5MwY8GKDTsO3P5rbH+n9YUv
fOMHdzzwxAuDfRdcMWHGghUbdhx4x+nZGdvXtF74xg/ueOCJFwb7LrhiwowF
KzbsOPCO07v17IztNa03fnDHA0+8MNh3wRUTZixYsWHHgXecvj3v1rMztve0
PrjjgSdeGOy74IoJMxas2LDjwDtOc8O35916dsb2mdaOB554YbDvgismzFiw
YsOOA+84zV1zw7fn3Xp2xrZP68ATLwz2XXDFhBkLVmzYceAdp7XF3DU3fHve
rWdnbMe0Trww2HfBFRNmLFixYceBd5zWPmuLuWtu+Pa8W8/O2M5pXRjsu+CK
CTMWrNiw48A7zut6arQ10BpjDpsjvkHv2DM0Rj+CfRdcMWHGghUbdhx4x2nv
sDZb+6wt5q654dvzbj07Y4vpY8EVE2YsWLFhx4Ebe9nj7CHWaGugNcYcNkd8
g96xZ2iMrhUTZixYsWHHgVs8Pd7eZu+wNlv7rC3mrrnh2/NuPTtjW6eVMGPB
ig07Dtz4XWcEe7A9zh5ijbYGWmPMYXPEN+gdL1NsaVoZC1Zs2HHgxu84wzgj
2IPtcfYQa7Q10BpjDpsjMd2tZ2dseVoFKzbsOHDjZ52xnGGcEezB9jh7iDXa
GmiNMYcjnrfn3Xp2xlamVbFhx4EbP+MM6IzlDOOMYA+2x9lDrNHWQGtMxJMb
vj3v1rMztjqthh0HbnzPGdUZ0BnLGcYZwR5sj7OHWKOtgRFP7pobvj3v1rMz
tjatjgM3vuYM7YzqDOiM5QzjjGAPtsfZQ6zREU9tMXfNDd+ed+vZGVuf1sCN
z53xnaGdUZ0BnbGcYZwR7MH2OHtIxFP7rC3mrrnh2/NuPTtjG9PaWPP/IM74
ztDOqM6AzljOMM4I9mB7nD3EGm0NtMaYw+aIb9A79gyN8R9Emo3f
     "]]},
   AlignmentPoint->Center,
   AspectRatio->Automatic,
   Axes->True,
   AxesLabel->None,
   AxesOrigin->Automatic,
   AxesStyle->{},
   Background->None,
   BaseStyle->{14, Italic},
   BaselinePosition->Automatic,
   ColorOutput->Automatic,
   ContentSelectable->Automatic,
   CoordinatesToolOptions:>Automatic,
   DisplayFunction:>$DisplayFunction,
   Epilog->{},
   FormatType:>TraditionalForm,
   Frame->False,
   FrameLabel->None,
   FrameStyle->{},
   FrameTicks->Automatic,
   FrameTicksStyle->{},
   GridLines->None,
   GridLinesStyle->Automatic,
   ImageMargins->0.,
   ImagePadding->All,
   ImageSize->432,
   ImageSizeRaw->Automatic,
   LabelStyle->{},
   Method->Automatic,
   PlotLabel->None,
   PlotRange->Automatic,
   PlotRangeClipping->False,
   PlotRangePadding->Automatic,
   PlotRegion->Automatic,
   PreserveImageOptions->Automatic,
   Prolog->{},
   RotateLabel->True,
   Ticks->Automatic,
   TicksStyle->{}], TraditionalForm]], "Output",
 ImageSize->{436, 427},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->2102557844]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["PointGrid",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/PointGrid"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["XGrid",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/XGrid"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["PolarPlotGrid",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/PolarPlotGrid"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Building an Understanding of Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/BuildingAnUnderstandingOfFunctions"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->33843119],

Cell[TextData[ButtonBox["Understanding Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], "MoreAbout",
 CellID->138993493]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PlotGrid - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 29, 9.2032624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PlotGrid[quad, opts] creates an empty grid to use in plotting exercises \
including the quadrants specified in quad.PlotGrid[{dom, rng}] creates an \
empty grid to use in plotting on the interval dom with range rng.", 
    "synonyms" -> {}, "title" -> "PlotGrid", "titlemodifier" -> "", 
    "windowtitle" -> "PlotGrid", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/PlotGrid"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7454, 220, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->139388780]},
 "RasterizedOutput"->{
  Cell[17254, 605, 11104, 190, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->570319867]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 35741, 1029},
 {"RasterizedOutput", 35884, 1033}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 3556, 82, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4182, 107, 51, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[4236, 110, 974, 30, 144, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5247, 145, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->42778269],
Cell[5858, 165, 137, 4, 70, "ExampleText",
 CellID->2064705943],
Cell[5998, 171, 105, 2, 70, "ExampleText",
 CellID->324532128],
Cell[6106, 175, 103, 2, 70, "Notes"],
Cell[6212, 179, 910, 24, 70, "3ColumnTableMod"],
Cell[7125, 205, 146, 4, 70, "ExampleText",
 CellID->1950495563],
Cell[7274, 211, 143, 4, 70, "ExampleText",
 CellID->641055886]
}, Closed]],
Cell[CellGroupData[{
Cell[7454, 220, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->139388780],
Cell[CellGroupData[{
Cell[7969, 238, 195, 6, 31, "ExampleSection",
 CellID->327352521],
Cell[8167, 246, 127, 3, 28, "Input",
 CellID->300819003],
Cell[8297, 251, 103, 2, 32, "ExampleText",
 CellID->688478383],
Cell[CellGroupData[{
Cell[8425, 257, 99, 3, 28, "Input",
 CellID->614293045],
Cell[8527, 262, 1300, 47, 450, "Output",
 CellID->1532529101]
}, Open  ]],
Cell[9842, 312, 89, 1, 70, "ExampleText",
 CellID->882681249],
Cell[CellGroupData[{
Cell[9956, 317, 285, 9, 70, "Input",
 CellID->406718467],
Cell[10244, 328, 1317, 47, 450, "Output",
 CellID->297738389]
}, Open  ]],
Cell[11576, 378, 76, 1, 70, "ExampleText",
 CellID->644685305],
Cell[CellGroupData[{
Cell[11677, 383, 113, 3, 70, "Input",
 CellID->1170922020],
Cell[11793, 388, 1227, 46, 240, "Output",
 CellID->2065014111]
}, Open  ]],
Cell[13035, 437, 80, 1, 70, "ExampleText",
 CellID->1286188656],
Cell[CellGroupData[{
Cell[13140, 442, 168, 5, 70, "Input",
 CellID->402350690],
Cell[13311, 449, 1297, 47, 255, "Output",
 CellID->288556558]
}, Open  ]],
Cell[14623, 499, 89, 1, 70, "ExampleText",
 CellID->1269293597],
Cell[CellGroupData[{
Cell[14737, 504, 377, 13, 70, "Input",
 CellID->2062419128],
Cell[15117, 519, 1191, 45, 453, "Output",
 CellID->751995380]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[16357, 570, 249, 7, 70, "ExampleSection"],
Cell[CellGroupData[{
Cell[16631, 581, 265, 7, 70, "ExampleSubsection"],
Cell[16899, 590, 145, 4, 70, "ExampleText",
 CellID->1761960417],
Cell[CellGroupData[{
Cell[17069, 598, 182, 5, 70, "Input",
 CellID->1616720036],
Cell[17254, 605, 11104, 190, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->570319867]
}, Open  ]],
Cell[28373, 798, 89, 1, 70, "ExampleText",
 CellID->1250222245],
Cell[CellGroupData[{
Cell[28487, 803, 296, 9, 70, "Input",
 CellID->1505269467],
Cell[28786, 814, 2240, 64, 448, "Output",
 CellID->2102557844]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31099, 886, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[31548, 901, 611, 22, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[32196, 928, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[32647, 943, 211, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[32895, 953, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[33346, 968, 170, 4, 70, "MoreAbout",
 CellID->33843119],
Cell[33519, 974, 179, 4, 70, "MoreAbout",
 CellID->138993493]
}, Open  ]],
Cell[33713, 981, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

