(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     32405,        931]
NotebookOptionsPosition[     26947,        757]
NotebookOutlinePosition[     29440,        822]
CellTagsIndexPosition[     29320,        816]
WindowTitle->PointCurveDistance - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Calculus and Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/CalculusandAnalyticGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"PointCurvePlot\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PointCurvePlot"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/PointCurveDistance\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PointCurveDistance"]}, Visible -> 
            False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PointCurveDistance.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PointCurveDistance", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PointCurveDistance", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PointCurveDistance", "[", 
       RowBox[{
        StyleBox["pt", "TI"], ",", 
        StyleBox["expr", "TI"], ",", 
        StyleBox["var", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]gives the shortest distance from the point ",
     Cell[BoxData[
      StyleBox["pt", "TI"]], "InlineFormula"],
     " to the curve defined by ",
     Cell[BoxData[
      StyleBox["expr", "TI"]], "InlineFormula"],
     " together with the coordinates of the point on the curve"
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PointCurveDistance", "[", 
       RowBox[{
        StyleBox["pt", "TI"], ",", 
        StyleBox["expr", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["var", "TI"], ",", 
          StyleBox["strt", "TI"]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]begins the search for the point on the curve using ",
     Cell[BoxData[
      RowBox[{
       StyleBox["var", "TI"], " ", "=", " ", 
       StyleBox["strt", "TI"]}]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->257758531],

Cell[TextData[{
 "The PointCurveDistance uses ",
 ButtonBox["FindMinimum",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/FindMinimum"],
 " to locate the nearest point."
}], "Notes",
 CellID->1067943069],

Cell["\<\
For some expressions a careful choice of start values is essential for good \
results.\
\>", "Notes",
 CellID->2106112476],

Cell["The point needs to be given as a numerical vector.", "Notes",
 CellID->459430631],

Cell["\<\
The expression should evaluate to a real value in the region of interest.\
\>", "Notes",
 CellID->1446904252]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->244702596],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->16457435],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->14944736],

Cell["Find the distance from a point to a parabola.", "ExampleText",
 CellID->2068074900],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PointCurveDistance", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1.2", ",", "3.7"}], "}"}], ",", 
   RowBox[{
    SuperscriptBox["x", "2"], "+", " ", 
    RowBox[{"2", " ", "x"}], " ", "-", "1"}], ",", "x"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1112017605],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0.1834738280741259`", ",", 
   RowBox[{"{", 
    RowBox[{"1.3795528313948413`", ",", "3.662271677399206`"}], "}"}]}], 
  "}"}]], "Output",
 ImageSize->{208, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->129707394]
}, Open  ]],

Cell["Visualize the solution.", "ExampleText",
 CellID->296269253],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PointCurvePlot", "[", 
  RowBox[{
   RowBox[{
    SuperscriptBox["x", "2"], "+", 
    RowBox[{"2", " ", "x"}], " ", "-", "1"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0.5", ",", "2.1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.2", ",", "3.7"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1530241425],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVxX081HccAPAvobjLY2LpfslDUXnKptXi80HDyKT0YAozKaLQpFrRZJU4
L1luaWqG1sPlXpRQrmIk56lTvWLOcri4Ooc7eb47W3+8X++VEUe271cnhPj/
79NJbecNCBFCB98+mhA+oGbZOk0NIUgtq3XNTflAd+3y1lkkBFZf2EN3Rz6U
3LVJWaIvhJMFOlRmOB9eZ/I+2JgLIUu/zcqljg+f+9IaAlEIb2WaNtK0DpA3
Zh8rPiOE1fnemr0LX8Hh2jyBl1ofpJzUMXtp8gYsubZsJ9N+YKWHLwjp7IGA
qKPcwuUDMEhWTgQX94H2vxFz42YiePNEGSLrFsGZvV0gcXwHlaVK2q4YMcRe
XNAY5TwILCe7uLY2CSytqwg85zcEK6zKpgOyRuHbBhrtYqgYnvBUG5U3ZKBI
MtUyDHsPLk8igt7FjcMBR7aWW9IHyGlc5rx7/wR8kz/uM3JcAhoDGZ0Czyl4
2N5XnZY8DKnDHV9/NJ+BQfou+5pMKXjXXRhgOszBhZnUd8nMEdBqfaUWaKkE
8YhDUVfJKIT3xJg6+87DoS6PxuyQMYgI1DlrWU3wWo7P3qOCMeBZOJY+56qh
vb/BhG2UDFqJ9QOFQB1nhRWcoiEZGMf74tbhBWh1wuyQ9Kgc+PekpxQmmpg3
FeR2RymHg6KpX0UeWujuH73eNmUcuGHiNMm+hbj1Jtqe1P4IWQtD2DvzFmFu
lxyZmR+h37byQChXG1eMJR8xpE3ArYJTx6736SCNXlsYnTcBoX/XiVyt6Lh+
vl+etnQS3spJ57mdi7Fqssn7cNEkCNbkHFSV6OLZ1z/fb1k7BcGX9Y4p5Hp4
McMYJewpYMXlnwv6TR/HPGJf9LhMg5ZDr079FgO89Opaak71NGzacbu3SWyA
J3yLvCo3zEDkcb52bqYh1j6L1ufUzUDu8H2rBDcj9DClzx3wmIWyK9fD44aM
0OJIgni8bRYm02FgsHAJul4rn3TfNgcWkWwf123G+Ed5g5k6fw6m32oMrFIZ
Y3jzVc/L3ykgJ9FXj/54Ke595JclFiigGx+E7UgwwSrO007dg0oQ2f2lp3Ix
xeAMrU03ZUqIsq65+sOcKbp8ZfNYLVEFGbVmrNKKzzBBRve0V6pAf42XYU/q
MhxKaX2/PHUeRP5OIxwwwxvy0JunVfOQcXtNOldpht9/0e28ZwtBWb5d5rr2
5Ujfl1jyMp1gcv6zzMZcBqrc1JnyXwiWjbVobmQxcNQ8N8nwPME/y/xusfMZ
+FJU7rU9gyA3pirqUiEDr8TKxB1Mgs+eAy+Uw0DrU/F2HSyCFtZLrNWaGej2
++HKF7cIasS1bIhUo9DxtOr66G2C9QJVrUCDwpVh2ef12AQ332cn7lhEoYYl
Z09AKcHIgoQATz0Km+9IZ9vLCV7YzRmxYlC4+1EstD8iyEiQ1I9+SaFPgWL1
SA3BgkMPXkdvpnBTSpa+7mOCgvbpxSKgkPK42+f/lGD2C8lMlxeFIp7kbFs9
wacP06oagih8w/4pVtpA0HLWhI57KHzOpO1c3EjQvXhVRk0IhXcC167ybyJY
4VCmuBdBYYFzjW4cj6C20dpx+ygKmcZ+U1nNBE3CVhiyoylMmeruvdtCsN+I
Gbw6jsL4f2KaWlsJxjr9yCuOp/A/A+BDNw==
      "]]}}, 
   {RGBColor[1, 0.5, 0], PointSize[Medium], 
    PointBox[{{1.2, 3.7}, {1.3795528313948413`, 3.662271677399206}}], 
    CircleBox[{1.2, 3.7}, 0.1834738280741259]}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->True,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{108, 432},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->2090171117]
}, Open  ]],

Cell["\<\
Find the distance from a point to a trigonometric expression giving a strart \
value.\
\>", "ExampleText",
 CellID->968465793],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PointCurveDistance", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3.5", ",", "1.2"}], "}"}], ",", " ", 
   RowBox[{"x", " ", 
    RowBox[{
     RowBox[{"Cos", "[", "x", "]"}], "/", "4"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1226022338],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.69955974554802`", ",", 
   RowBox[{"{", 
    RowBox[{"4.815874075537446`", ",", "0.12437053498162112`"}], "}"}]}], 
  "}"}]], "Output",
 ImageSize->{208, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1885987892]
}, Open  ]],

Cell["Visualize the solution.", "ExampleText",
 CellID->1191066060],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PointCurvePlot", "[", 
  RowBox[{
   RowBox[{"x", " ", 
    RowBox[{
     RowBox[{"Cos", "[", "x", "]"}], "/", "4"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3.5", ",", "1.2"}], "}"}], ",", 
   RowBox[{"StartValue", "\[Rule]", " ", "4"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1552196733],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS2U6kqzhueua448cuyWI7fEIpFI5BfzrYW4AolFRkbGRkZGxkZGRsZG
RkbmVnUHBhgYIPRv8j6LM3sOMNCE5O366a7685//W//nfz+I//n4+C/9x7/3
AAAAAABWqMIF2yUfi7C6eiQLbt8PAJg7VSV0IQuuBIJUI8huPQAAAIIqDLOr
OxaBvAfCAQD4weCpBBfCcTQ3oBsAgHt864Tknr3xcYnhUQIAXKIKg6fiG9AK
AIBMmpylTc4dlBv5FOgGAOBVoBsAgFeBbgAAXgW6AQB4FWRSgBu0fZ33TTHc
rn7vGtvDAxdAMYAhWAHSvjj02aZPln38tz98fN/CT77z3i36c/Hk+IvvTNf8
alXCrwzMAt0A6iHzgK7lIuzznbjqP/li5yt9I670VBgS5fjXbyuhQplQoYBf
+fBPH/7Lv+RbvpMebWt1nwdcA90AiuhYEOiyjb5YKOgSLvZ9GfEl3LWGBkDv
VcasG9JEoRupChkkvZkBzAjoBniDjid9MirI6aDpnhwQEgp3Jnoye0hGSDrI
CSLXJtuyshkSsYkD3QAvQ8pw0op0LbTC+R1PNOYqZkeJbCGyiMguesdRmj3Q
DfAsNFPTpUdyQXO3F1pxD9IQskOSBQtIESJZMwLkYcFj6pTtCpqpydT3Vy5+
0pHhtOcwSLIUYZDO9oC8AYoB7tKWHBwguSDzvs4eP99fmuLsk+a2R+MB0A1w
A5p8aRaOF7ObhcmySlYsIOSIgftAN8AFUjFo8nUnLWKeruHALx0HVo85yebT
QDfAAF0jUjEQJxxohXp88oIQqMcl0A0wKAZdI1CMG3SsG3R86CfWfhxBPmXW
FOGgGFhR+YCjevCxgu0Be2Ou1DmvxCj2sDFeoRtsMw4XzxroxuwgYztdc9ag
m3Hk8y06sZluMamlLC8C3ZgX0tie9mIMMzQlG2z5fp5uC3RjLjSFWFa9tz2O
aVGGfFTnp8PQjelDjokslTPnJRkaEX5fuprV4UU+ZeLQVBh/8f5xoBUZZy5j
2+MwBBRjyuQ7ngqx6sAQHW/PTzdziHhAN6ZJ17Bjgk0W5qlT3tfjX6pl6Nh2
o3n00HAafR6nDvsmf3k3K7BCW4stgT75LFUYitguqce1cmThjT700I2pIX2T
GZjKrpNtffwirvpHH42N4CpjBN2YDjTNwTdxCmn4+dSmIQuuFULA6nHxAHRj
IshlSKiZ6Roy0OTJuvSjt3LzoeAqvnGOkdEB1dC8RienbybxjMgC3kLoNmRT
CBflZjzj2hCBVngPzWXpyvYgwCPynViU7ihDNuXjFMugO/jfIbzxI8AB3fAb
2bAMeEEZTubLgm54DE1h2G/iF2QcJlMwDqEbvkIzF1InPtLkEwhGQTe8JF37
EqIHN2hLlg6fKyYhk+If8QI9PrynrbyWDiiGZ5Cl0UA0JkEnlqP76bBAN3wi
C+CeTAqyOlg6/AO64Q35DoHQCULWI29j8Qzohh8UB6RcJwvZkL6t64BueICH
5xV4DbIkuTOLNyCf4jp1hmXks4DsSW4o6QdQDKdpRKIfzAR/4t7QDXfhslF/
Pc3TgZHQNOHD4hzohrvQKYR6GnOja3mycL6UNHTDUZB1nS1N4b5zCt1wEY6F
+pfTB8rgtLvTMVLohnN0DcIaQHip7hYmRR7WObghI8IaQAQ6ekcDHVAMt0BY
A5xwONAB3XAIhDXAFa4GOqAbrsAJuC/3E3DANE4GOqAbrkCWRn2veQWYMVzh
x7m99tANJ+Cak9iEAu6Q711rv4J8ihPwEsHa9iCAw0R/nMqtQDHsg9oa4CGO
xcyhG5bhVV5ftgcBfCBd6dzyNnRsW/xo8igfuLofumEZhEPBk+jcH33sKE0i
cakQQ79H+ndx1VdaxzDAUzhmfALX0b+c40ofqnAxdIa9fAC6YZPoy98OGsAO
es+Zq7bzJ3Pjhm6co2084AdFiHAoeBmdNurRWzm/B/aGY0R/YGyAMcR/eTGY
akgihDJk4bmjgviGU/hWvxo4hAaTY8imCAad+HZQkE9xBjY2HFrGAzxDj8nx
PNANC8DYAG9iOxMH3TBOB2MDKMBqfAy6YRoYG0AJVk8kZGBN49gGJeAx9s4l
KIZRYGwAhdg7naAbRok+sWYDqMNarAy6YQ4U5wHKyfd9aaGkD3TDHOmmr1Lb
gwDToqt5x4pxoBvmCP+1PQIwRWysAUM+xRBV0meB7UGAKWIjOgrFMIST1ezB
JGhFQtYo0A0TdI35bxbMCL0lBG8A3TBBGXLcGwBNVGmfbUy+IXTDBNEXF4cE
QB/hp6bSozeBbminKR3stwWmRr7ty9jYuyGfoh2zXyiYKWab10MxtIN6gMAM
vEDIkKsC3dALMinAGAZ78UA39ILlXsAYBheAQTf0QqJB0gGAAdpKNHQzAXRD
LwhuAJOYCnFANzSC4AYwjKkQB/KwGkFwAxjGVIgDiqEREg2s3AAmacqxIY4q
XBx7Lt185AP92kyB4AYwz/gQx3cz2HMu+z4OQDd00dYIbgALpOuxZeVu6cZg
bFzfD93QRZ1yYUAADFOEfTFu8/Vte2N45FI6oBu6GP/1AfAG41tA3tcNfiy4
im+cM+rtwC0yVCEGNhi/+us33cgC2BtGiBcc3AbAPId/RvxRFnycpU3o/1go
hvDGjwAHdEMXBjcnAnBBrL1OFHRDC10r6i8BYINkxU2+dALd0ILZIioAXJDv
eOGoTqAbWqjiPtvaHgSYK7zaXO/ph0yKFvQLPgB30d+JGIqhBYOVlwC4pmv7
SG94DbqhheiLG/4CYItRqdjngW5ogdQeO9qARTTvqYRuaOGAowqsAt3wEegG
sEuy1NoxFrqhASz6ArYh3WgKfS+PPKx6UFYUWEdzRg+KoZ6u5nwKABbR3IAD
uqEe8iuxyBzYRXNtW+iGerA5BVinOPBNG9AN9VQpF+0BoyGDjc75GlWP3gC6
4R1om/IOTc5ZbHmDdIxGcyMV5FPUo3834pRJN9+6oXlz1pTRPHlBMdQDe+Md
SHVPulGGtkfjLWWsdfKCbqgHuvEWHZeCT5ZcDb5rbQ/GWxDf8A7kU4B1oBve
gfUbwDrkpOisHAXdUM/4BhYAKEL/elHkUxSD/SnAOprbfkEx1APdANbRvx9W
34vPF9TfAHZ5uf6G7Mx2o8+j7OO2OO8OC93QBHQD2GVMhdtb/WGHfo/07+Kq
r/SbAwQ3CP/F2gNgkzF1Am/oxvddl8IB3dCC5uqOADxgTHviG7pxNDegG0ZI
V1qrOwLwK53QjVd5zd44552xgm+yLbd6BMAKbdnHi9f/DPEN22jexQzAb5Tx
iB1SMm9yTJycOyjIp5iCnJQUe8CBJYo97w3UCXRDCy1KEwN76G9PDN3QRai3
QScAd4n/8iYpnUA3dKH/uwPgNpqbSvfY16YP/bYiADcgHznW7iNDMXSR71Hm
DliAy79oj8lDN3SBaoHACkbWAEA3dNGUqN4DLKC5U5sEuqGRMXsEAHgPI3uj
oBsaSddaay4BcA0vHDJRMwr5FI1gtTkwjKmoGhRDIyhQDAyjuRzxCeiGXhDi
ACYxVfgFuqEXrP4CxjBYEBu6oReEOIAxDC4Zgm7oBSEOYAxTwY0eumEAhDiA
GQxWtUUeVjuaO2cBwBjZznYCiqGdOuPoKABa0dyA/grohgnYgEQ7FaATs603
oBsmyHecWAFAE03BjR0NAt0wQVP2yYi69AA8h8FMigS6YYgx/ToBeI7w03DO
DvkUQxQhVwADQDlVyjk7s0AxDNG1ffRpexBgithoKgrdMEey5PgVACpphZOi
gJt92ZgqXPx4BLphDlQcBcpRtQHqTh9Yvif8KSXQDbNgzTlQi6I2Pff6zh+N
jet+09ANo2AhB1CIuqXI522k77gqF9LxcYmSMYC7cHTUUIUEMH3U9QS8a298
PyFAfMMmMDmAEtTue7of3zg+fm1vKHtr8AwGizKBKcPpV5Wl5C7zKYOODOGN
HwEO6IYFYHKAN7FdDwq6YQNEOcB72K5bC92wA0wOMBrbxkYP3bCFA1898BXb
xkaPfW0WceDbB/7hxowDxbAGJ1bMFYQEEyFZ9Y3pXWw/gW7YpMTmevAKYs1G
29rfqgDdsEonlvyhng94DlFENAiyprEsHdANy9Q5L+AB4CEiBxeGRZ7bn2ig
G/ZJ0WAFPILDoYssq6LIiRIuyKc4AJaBgUfEi6Ysdjv7EVEJFMMJ0H4a/EIZ
876yIO3sB0QHoBuuoG5PNJgUXUvnxmGX1LVDrbugG66AHivgJvk2D3dZZj8W
eg50wyHMtvgEHlBnbbQKQydioedAN9wCNc/BCbGi+LB3cTMC8imO0YrdBw55
ssAa8TLaRe7EQs+BYjiH8R7BwEXyXbbfVpWjMwh0w0UQ6Jg5ddaESxfWhd4D
uuEoyYIzLGBu1Hlf7PvwTxy5GNY4YVE3yAaTtyQpk6Sin4dDvttlu93wc71O
lku6xXxbxJtNev4oPVn+Ff2Ur+PCPkFldI0IdEzoE4GHNHl/+OjDD/5ZO731
wIBuNI0Qh5gv8O02oxuJAEkB/cIKsM3o/lg8WhQNPbMs+WdVNlcRoabp5P3y
OfRk+Zr0t/J1SFgWizggedlmcVSmKeuJm2Glp6hSlYXugfukG1YMeUuc3u2o
XDfoOhUmRMWGAUnEMg4CthOkbSANA7XveIWUFxINqSdktJCe7Pe5fHetb60e
BDpmRb791o0ytD2a33g/D0tCQbO/EApWifUqYZWIS2k2KBzqaMh/kSMkC2e1
TEjHyBopitoPUwQVjGdCk1f7RZvtOZtW7Hl5ucOMU4yTRbFZpzShD7N56fQn
PUEGCVkjhwPHT0hJYpY4t0dO5qvb3i54l7Zqw79Z5s0GpSd1o67bLKvDQ0GT
NRkVJ4vCbijyfSeLPhdpCH2c1SohJTGc+Xph/FzE2JU91BKvM3FuDb5ruvAr
Cp/9fl0Y/C9joGuKjIrDoaBriuZlWWjo/QJlCj/1ky/15NOKoqHPSB+WzCf6
pAa8mNcORbxwasOsC2fvaBwaPCfOFuH+BXvShcFfjUFGFHn+XQ42vIwDPDNU
tVexxXdkATkUa2GB0O8G3vG554hipF3z6GkK39HQ09x8KSPv2LFo7KKT3W7+
M46DXpxt9aSiSZYdkDv+/hS/ssdPI9Eg6dis0ygspKFl+TOSaCTLm9Lh0VH1
5aVMvGOyinbheWENB3XjAwAwe1SJiZLXmQN11YZhsV4nUVTaLEQvStTec1iA
D3RkaeRxnCQOBaxeAroxgiyrArHovSwtXbxyFbpLYVLwNC05m1WWhgePC61A
N0ZTle1+lwdBamnfYieK/LiVnAUPENmTuij3e7+/OOjGm5DDIp0XsjmNL0Dt
eF0Heq/4gmgJ3VT1buv0Xtdn8FM3qnBBAw/cOfqkGElSbjYp/Xzi6VkgIlSL
UIWjwW2bYgWv8yTy2KsavBXoI5g/d8gyTJZd22232fj5ZTj49o+92iirQax8
9w8Q6lFtHtkeVRiKkZN6KDoBsq257W9VJYacBfZP3nEI0TZ87tRia3PHovFO
RD0LXTnmHiqGxEXdOPGk7aHy2iPdyAJFr/UER+3zjiwIMsPnDn01ZBP2/W6X
v7XTczA2nDjtoRuakLbHep2k6T1p4FNY5VuWsZnu9i6dvy8iD7mxc6fj1Emf
7+nXn2uPR8JH3/6hh27oJo7Z9vipHlpmbBINko4qUf7CPyBr34/jf84QmjET
n6lz/i5EV4soKhU2TqrCwLq7At0wQNt2dOaQepwytjR6cd7qcFg7dli0+ywu
nLxjMXDukI2RruTaPFmVTuFrq7ZTx+CpbihNSBiibfsw5EIE4ep71tN1BpDJ
wZvg1Pssw5H369BfoVc3Wl7Ne6zWlWUVTRlKXveYyHLCzvNUN/ylabrDPt9u
s7rWvNrDnM8CjpBvEn317SAUZF4efF4U+gve5mH9pqpaNjwOhfbCR+yzbBwv
OjcJOq7oyMWEhy+0LJupikYPe8MqNB8FmzSONfdJqdI+/kJ9Y42wV/h1XgaW
5oXdzu+V5L8D3bBOmvIuOYXx9lt0XOqWs7To5aSUruZM66VFV9csGn5UvR4L
dMMF6BwLw2K7zfRWgJcb8MlzgduiBCnFzYUzMgfR6KEbLlFXLUnH4aD5rBuM
aoNbWqYHxz//9MV1i5OZiEYP3XCPomhurhNTCdkb+ZZtj2aygTtdcKnG1Wlt
xjnzEY0e+RRXieOSbA+9dYHakn1zLuIB9XgC8vLIxSMz41bNk1mJRg97w2Ga
pt3vc7rpPRtJNKAev0OKka5/WQwzN9HooRvOQyaHdrelP6oHXRq1A4sR3YEO
i1SM+4dlhqLRQzc8gdyWIEi1lzNtyoeXyVw4mWG/llObp2j00A1/aNuOfBY6
S1vdSdTBLJcLmeaWse0405QsnnHcSMZ37xTv8hnohl9It0X7EtNebG/Jd334
ybmDOZQwJRMr2/Thv5xpah4fXt574nlt4XdAPsVHuBrhJlVTB+YhdS4uqE/O
JkwvdkrGFQkFy+MLFZ5JNLzuYvA+UAxPGdyW9+pVvkLH2QSy3nm90977rk80
/jLkvavxX7EE7gV3LInLMJy1aPTQDc/hfbXCbTHnZdMVV4SsHnQjC4TExBsN
admiIOuC5IIGn+9H1CchxfC3ydrvyMoqN+qq3CqiDt2YAHQmB4HunXE/ILkg
0ZBLoaSG1KlzGtIJrci2HOZlV2vD1sXYckZk4Jk+yMY41n38WSv7Zk066MY0
OO2MO29ubvDthYakmz765Nmc5vQy4mCIhQ10Hb8viUO+Yx8k/HfoL/Neuea2
7bUv37XKdwm0K+G4U4QaujElSDTEzjj95YB+gWZzEg0uYrNkGTl88C908RYH
nvqfSFW8QFtxHkT2gKB3OfzDQsElxLfsTCnqn0tHlcy5Rnd9Nqt8l5m+2Zzj
RxF1HT3ugV3yvH66c5wRyAAgF4bbiKx5Mx0pCfk1clWVvNFVT4+ebiwvxSAI
pxtJwfmf0CvQ65BFka7EnySacj3kmOx201oFdywRe17Y/a69ceSqDjW0YqrI
znGGcrWvQn4NXeYsDjn/pKuelWE/SES2ESbK+qgY4n5yPU7PZw/IxOeKomIu
qZP78Y3j49f2hqGBAeN0Hbf7EeWAnFQPh6FDt9vlWTbN1MlNLvMpg47cK6IO
3Zg8stblfp+bWunhPWXZcDfI6UZB3we6MRPkAvUoMrjSw0/iuCSNtRlY9gHo
xqwgwzvYpImB7S0eQlpBPp32kgWTALoxN2TD6432CuqeURTkm6R2Vr94CDKw
84TUI4oKExWBnEcumdNeDnpaQDHmDF0p5M5v1t8Nr+eGDIHO9uOPBroByK8/
HNj2yOfkuYhMa4YQ6DigG0BClw+Z6zLuMXmLXSyKS6sS0YyRQDfAOae4h9G9
+QYhVURG6X2gG+AnMueyXidRVE5mtRiHMjYp2VRwTN4H+RTwC3K9x26bObrP
5TmqssGKWbVAMcBDqqo9HPL1mp0X7dXUlUJyt91mJBp6G3bPD+gGeBIy79OU
nReauN1PXNJQN5uU5A5LuXQA3QCvQpN4eChWqyQMC9cEhOwKmRUSphG8El1A
N8Bo8qw+sIDE9DO3mr1tmlYsYEvIK5lDHtk60A3wPtxPJCzW4rJNktJYMIEs
H5aLTRoEaZJUfsVevAb5FKCQum7p+iX1WC1ZQ+KopNlfYYSBXI9SaMVul5Gj
dNjnaVrBHzEPFANoguSCLmpZZX25TMgq2O1yskboTjJIxO1ubpccDfkcsihI
iGTVsuUi3qzTvdAKVDCzC3QDmIGsgqpkEZDWwk6kRxeLeLmMl+Ln+e/rVSKf
QxYFPZ/UA4lUp4BuAABeBboBAHgV6AYA4FWgGwCAV0EeFgDwKlAMAAAAAPzC
/wP2XjBM
    "], {{0, 256}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 256},
  PlotRange->{{0, 360}, {0, 256}}]], "Output",
 ImageSize->{364, 256},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[5]=",
 CellID->762607685]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Possible Issues",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373],

Cell["\<\
Automatic selection of the start values can lead to incorrect answers. \
\>", "ExampleText",
 CellID->1018778575],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PointCurveDistance", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3.5", ",", "1.2"}], "}"}], ",", " ", 
   RowBox[{"x", " ", 
    RowBox[{
     RowBox[{"Cos", "[", "x", "]"}], "/", "4"}]}], ",", "x"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->724392494],

Cell[BoxData[
 RowBox[{
  RowBox[{"FindMinimum", "::", "\<\"lstol\"\>"}], ":", 
  " ", "\<\"\\!\\(\\*StyleBox[\\\"\\\\\\\"The line search decreased the step \
size to within the tolerance specified by AccuracyGoal and PrecisionGoal but \
was unable to find a sufficient decrease in the function. You may need more \
than \\\\\\\"\\\", \
\\\"MT\\\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\!\\(MachinePrecision\\), \\\"MT\\\
\"]\\)\[NoBreak]\\!\\(\\*StyleBox[\\\"\\\\\\\" digits of working precision to \
meet these tolerances.\\\\\\\"\\\", \\\"MT\\\"]\\) \\!\\(\\*ButtonBox[\\\"\
\[RightSkeleton]\\\", ButtonStyle->\\\"Link\\\", ButtonFrame->None, \
ButtonData:>\\\"paclet:ref/message/FindMinimum/lstol\\\", ButtonNote -> \
\\\"FindMinimum::lstol\\\"]\\)\"\>"}]], "Message", "MSG",
 CellLabel->"During evaluation of In[1]:=",
 CellID->876757064],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.9727835960072286`", ",", 
   RowBox[{"{", 
    RowBox[{"2.5241244108038576`", ",", 
     RowBox[{"-", "0.5145092449696195`"}]}], "}"}]}], "}"}]], "Output",
 ImageSize->{216, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1770672581]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PointCurveDistance", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"3.5", ",", "1.2"}], "}"}], ",", " ", 
   RowBox[{"x", " ", 
    RowBox[{
     RowBox[{"Cos", "[", "x", "]"}], "/", "4"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "4"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->779851815],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.69955974554802`", ",", 
   RowBox[{"{", 
    RowBox[{"4.815874075537446`", ",", "0.12437053498162112`"}], "}"}]}], 
  "}"}]], "Output",
 ImageSize->{208, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->2013172388]
}, Open  ]],

Cell["\<\
For some expressions messages about convergence will be issued. These can be \
surpressed using Quiet.\
\>", "ExampleText",
 CellID->1783466631],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Quiet", "[", 
  RowBox[{"PointCurveDistance", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"3.5", ",", "1.2"}], "}"}], ",", " ", 
    RowBox[{"x", " ", 
     RowBox[{
      RowBox[{"Cos", "[", "x", "]"}], "/", "4"}]}], ",", "x"}], "]"}], 
  "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->146922391],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"1.9727835960072286`", ",", 
   RowBox[{"{", 
    RowBox[{"2.5241244108038576`", ",", 
     RowBox[{"-", "0.5145092449696195`"}]}], "}"}]}], "}"}]], "Output",
 ImageSize->{216, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1865915134]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["PointCurvePlot",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/PointCurvePlot"],
  FontFamily->"Verdana"]], "InlineFormula"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Calculus and Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/CalculusandAnalyticGeometry"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->523685188]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PointCurveDistance - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 29, 13.9456624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PointCurveDistance[pt, expr, var] gives the shortest distance from the \
point pt to the curve defined by expr together with the coordinates of the \
point on the curvePointCurveDistance[pt, expr, {var, strt}] begins the search \
for the point on the curve using var = strt.", "synonyms" -> {}, "title" -> 
    "PointCurveDistance", "titlemodifier" -> "", "windowtitle" -> 
    "PointCurveDistance", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/PointCurveDistance"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6502, 194, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->244702596]},
 "RasterizedOutput"->{
  Cell[12823, 405, 8522, 148, 277, "Output",
   CellTags->"RasterizedOutput",
   CellID->762607685]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 29052, 805},
 {"RasterizedOutput", 29195, 809}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[611, 21, 3269, 77, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3905, 102, 61, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3969, 105, 1297, 38, 160, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5303, 148, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->257758531],
Cell[5915, 168, 203, 7, 70, "Notes",
 CellID->1067943069],
Cell[6121, 177, 132, 4, 70, "Notes",
 CellID->2106112476],
Cell[6256, 183, 87, 1, 70, "Notes",
 CellID->459430631],
Cell[6346, 186, 119, 3, 70, "Notes",
 CellID->1446904252]
}, Closed]],
Cell[CellGroupData[{
Cell[6502, 194, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->244702596],
Cell[CellGroupData[{
Cell[7017, 212, 194, 6, 31, "ExampleSection",
 CellID->16457435],
Cell[7214, 220, 126, 3, 28, "Input",
 CellID->14944736],
Cell[7343, 225, 89, 1, 32, "ExampleText",
 CellID->2068074900],
Cell[CellGroupData[{
Cell[7457, 230, 296, 9, 30, "Input",
 CellID->1112017605],
Cell[7756, 241, 309, 10, 36, "Output",
 CellID->129707394]
}, Open  ]],
Cell[8080, 254, 66, 1, 32, "ExampleText",
 CellID->296269253],
Cell[CellGroupData[{
Cell[8171, 259, 350, 11, 30, "Input",
 CellID->1530241425],
Cell[8524, 272, 2972, 77, 453, "Output",
 CellID->2090171117]
}, Open  ]],
Cell[11511, 352, 136, 4, 70, "ExampleText",
 CellID->968465793],
Cell[CellGroupData[{
Cell[11672, 360, 337, 11, 70, "Input",
 CellID->1226022338],
Cell[12012, 373, 309, 10, 36, "Output",
 CellID->1885987892]
}, Open  ]],
Cell[12336, 386, 67, 1, 70, "ExampleText",
 CellID->1191066060],
Cell[CellGroupData[{
Cell[12428, 391, 392, 12, 28, "Input",
 CellID->1552196733],
Cell[12823, 405, 8522, 148, 277, "Output",
 CellTags->"RasterizedOutput",
 CellID->762607685]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[21394, 559, 278, 8, 70, "ExampleSection",
 CellID->1305812373],
Cell[21675, 569, 123, 3, 70, "ExampleText",
 CellID->1018778575],
Cell[CellGroupData[{
Cell[21823, 576, 287, 9, 70, "Input",
 CellID->724392494],
Cell[22113, 587, 837, 14, 70, "Message",
 CellID->876757064],
Cell[22953, 603, 329, 10, 36, "Output",
 CellID->1770672581]
}, Open  ]],
Cell[CellGroupData[{
Cell[23319, 618, 336, 11, 70, "Input",
 CellID->779851815],
Cell[23658, 631, 309, 10, 36, "Output",
 CellID->2013172388]
}, Open  ]],
Cell[23982, 644, 154, 4, 70, "ExampleText",
 CellID->1783466631],
Cell[CellGroupData[{
Cell[24161, 652, 328, 11, 70, "Input",
 CellID->146922391],
Cell[24492, 665, 329, 10, 36, "Output",
 CellID->1865915134]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[24882, 682, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[25331, 697, 231, 6, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[25599, 708, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[26050, 723, 196, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[26283, 733, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[26734, 748, 171, 4, 70, "MoreAbout",
 CellID->523685188]
}, Open  ]],
Cell[26920, 755, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

