(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     63368,       1504]
NotebookOptionsPosition[     58368,       1345]
NotebookOutlinePosition[     60557,       1402]
CellTagsIndexPosition[     60471,       1397]
WindowTitle->PointCurvePlot - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Calculus and Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/CalculusandAnalyticGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/PointCurvePlot\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PointCurvePlot"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PointCurvePlot.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PointCurvePlot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PointCurvePlot", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PointCurvePlot", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["pt", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]generates a plot of ",
     Cell[BoxData[
      RowBox[{
       StyleBox["f", "TI"], " "}]], "InlineFormula"],
     "on the interval ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["min", "TI"]]], "InlineFormula"],
     " to ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["max", "TI"]]], "InlineFormula"],
     " and draws a circle centered at ",
     Cell[BoxData[
      StyleBox["pt", "TI"]], "InlineFormula"],
     " tangent to the curve."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->150262931],

Cell[TextData[{
 "The function ",
 Cell[BoxData[
  StyleBox["f", "TI"]], "InlineFormula"],
 " must evalute to real numbers on the plot interval."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The point ",
 Cell[BoxData[
  StyleBox["pt", "TI"]], "InlineFormula"],
 " must be given as a numeric ordered pair."
}], "Notes",
 CellID->602546437],

Cell["\<\
For some expressions incorrect results might be obtained unless a start value \
is given.\
\>", "Notes",
 CellID->1612571054],

Cell[TextData[{
 "PointCurvePlot takes the option ",
 Cell[BoxData[
  ButtonBox["StartValue",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/StartValue"]], "InlineFormula"],
 " in addition to the options for ",
 ButtonBox["Plot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Plot"],
 "."
}], "Notes",
 CellID->1238079438]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->545769726],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->72794500],

Cell["This loads the package.", "ExampleText",
 CellID->1432058683],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1761053252],

Cell["Visualize the point on x Cos[x] closest to {2.9, 1.4}.", "ExampleText",
 CellID->297120355],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PointCurvePlot", "[", 
  RowBox[{
   RowBox[{"x", " ", 
    RowBox[{"Cos", "[", "x", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2.9", ",", "1.42"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->802327210],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwllnk8VP/3x+0zc2cs2WYkFSJp5SNFOO8kEiFKIpIkW5aiki0UooQiZEsI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      "]]}}, 
   {RGBColor[1, 0.5, 0], PointSize[Medium], 
    PointBox[{{2.9, 1.42}, {1.4136899392263769`, 0.2211871867485854}}], 
    CircleBox[{2.9, 1.42}, 1.9095208189419308`]}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->True,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{301, 432},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->663598957]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2061341341],

Cell[CellGroupData[{

Cell[TextData[{
 "StartValue",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1757724783],

Cell["\<\
PointCurvePlot uses FindMinimum to determine the point on the curve nearest \
the given point. FindMinimum is sensitive to start values and can return \
unexpected results with a poor choice of start values.\
\>", "ExampleText",
 CellID->1746423669],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->336117687],

Cell["\<\
Visualize the point on x Cos[x] closest to {3.05, 1.4}. Note the wrong point \
is found.\
\>", "ExampleText",
 CellID->1402383410],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PointCurvePlot", "[", 
  RowBox[{
   RowBox[{"x", " ", 
    RowBox[{"Cos", "[", "x", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3.05", ",", "1.42"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1224946045],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwllnk8VP/3x+0zc2cs2WYkFSJp5SNFOO8kEiFKIpIkW5aiki0UooQiZEsI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      "]]}}, 
   {RGBColor[1, 0.5, 0], PointSize[Medium], 
    PointBox[{{3.05, 1.42}, {1.4421450953757602`, 0.18502236664392063`}}], 
    CircleBox[{3.05, 1.42}, 2.0274040419250436`]}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->True,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{301, 432},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->8067388]
}, Open  ]],

Cell["Specifying the start value corrects the solution.", "ExampleText",
 CellID->1225091428],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PointCurvePlot", "[", 
  RowBox[{
   RowBox[{"x", " ", 
    RowBox[{"Cos", "[", "x", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3.05", ",", "1.42"}], "}"}], ",", 
   RowBox[{"StartValue", "\[Rule]", " ", "4"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->38422960],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwllnk8VP/3x+0zc2cs2WYkFSJp5SNFOO8kEiFKIpIkW5aiki0UooQiZEsI
hVAqiVtRkSyRfZmx70uWJMvvfh+/v87jee/MmfN+nXNe85a0cTW+wMHGxoaz
s7H9L3KWY7V9ewM0Osr+P8qMlB3Y+OAseJpSbNcTcenlbtu2aFfg7S7jribi
gLD9YnG0P1j88PH3ImK79q1PGdH3wT7ZjJUfdR9+nY3emhSdAnH+K68qI1LA
2FmsPS46HzofneVWC8qHqN9nimKjyyGr97C14slyOFB5FNO8Ug/yd5Z/NTTU
gdsNg3NFbq2w7a5ZJnteMxx1UcsiR7aCctwdmUdfmkHaRn7KMr8VypeNC8V7
mqFZl8eXPNkKjTFBGTP8LaAuVhZn6dQGHVl5VbVuLYC93VlPsmuHuI5n7Wq7
WyFjngZnLDqhsCZW2jq5DfxGlm4X3OiEdYppgQWv2sCsa7iGJ6EThpMfBk1V
twGtssK8oLUTXjzK26Twpw0uP/S5ymPaBRtZUwXfDNoB/Tee+9KoGx6qRPXu
X2qHS28vRHBIM8HDORgSD3bCLt3jm9mVmMAbIXKfcqoTptvUCte0mMBzaZ+V
pXMnePwTal62Y4JEmdzmt7GdcEPjk8SfHCZIm0u/3TfaCcEVG3PHFFlgybfu
rt7dLkitb/nepNkLl2xU/8iXdoPNuc+WjSa9UCDARlOv7Qbp33lTDba9oKzD
y1RkdkOmULBQXTDxnt/avYqzB3JNlSyqqnuhcm/4WIpuD5R0Ro5+MO4DG1Ea
G7OuB5qGdSnPbPohs+rEd77zTJiKlzscdLkf2LWYzpUOTMD0SAFnA/thNXAh
w8WNCSi3YpGe1g9/59TK43yZ8NwdhkNZ/eAkixcefcSEwCWlr47WA3BC4EXT
xm9MSHouxKnjNgDnLnQc+feDCW/P/NaQvjkAm9z52qoamTBRll/ckTIAH7CL
u9V7mGAWJJ+p3zMACwU+vd7zTNhN23x7l9UgeJaajhpvYsHRD6s45jIIsnFc
6ce2sMDWpWt50HcQUh1XOVW3sSChPsEjJWkQZpz3JwwROvLEiNgKdA1CVFCV
WcxhFnRKUA/9thiCr0NuS0r2LPhTO+JX6zQEr/YtVWs7s0Dw5reSHO8hOPVc
/KeuGwuO9N5WPP94CDjd1zlIX2dBUSabVFP7EDiNRKxIh7AgbPcCW/HpYVgr
T5w9kcaCG9d0tw86DsM2Pv7b7zJY4FCeeFLUZxgmzf9To2UT+QwP5VxNHgZ1
t83/vPNZQHKNNNnXNww2D2zag96zYKG4z/fi3DCEyK+8MStjweCqctYj7hGw
qTnmLf6RBV8iupb/bB2BzeOlDxy/sOBWnnzmW+cRaO70UdxVzwKPBd/6Yd8R
CLX+z9b9JwvOazQsMe6PwL45lnpaEws0a68ZehWMQMe9ueqaVhYoin73yv40
AlZcpq5f2lkgZbUxva1xBI575CTldrKAfbJiUWVhBApbw29oMVkwvZch7Uga
Bbbos+vnWCxg+jodS2CMQkFzkWxUHwtwXsG0JdVRqP5Tf/HBIAtenrxQI68/
CmFu8hGLQyxISXq7YG45Cq6vZbj0Rljgt/Os3nv/UTBaCv30ZowFLp6FnmOR
o2A59X25YZzYgw/cqeJpo5CdZufYNsECfe7T1XpFo2A1aslVO8kCtWMv5rwr
RiH5X/nn/CkW7IhZ2/ji1yi4uKQ/8ZtmwYYuY93OwVFIO7jjkeoMC2gymVdo
i6OAdwck9RH8z/lvkhplDAYl2nK9frNg9JX+N+f1Y/BU1/XjMsHtyym/E7eP
QbNUeIPzLAuqtWY3/FAbg4B+n5YqgkvuauusHBuDBJ3kGqE5FuQ0xbvvPDsG
vcHGOUcJjt8w8djSbQzSbHgcXQgOtUVf7gWMwc0te7j9Cb7+4sH0h+gxUH5q
6OlDsP3c4PrJp2Ngpj1ZZEfwKTXVwxtfjwENSylRJ1j71j1Xgy9jUBG4GshO
sHINM96vZQzGmYU8hUQ9ssJKFXnDY5A45wSGBIucCZns/jsG2gp9sm3EebjS
2xn81HEwK+goNiR4bmznIdgwDv0qUiOFhB79/wVcct05Dioa995wENzo3fQo
RWMcbvUtiwOh56fPWz/VGY6DA5eFgD2hdyHVe3zNehzuKz2O8CX6kWZSK7rn
8jgoVZRE+hP9in4sedA6aBzefsYFXIh+um//FoNnjMOrbT8uC4wSv3eh/2Zq
8TisBX68VT3MAtNUNuebX8dhbuFuoTsxL6oiKppoZBxaL9bphfSz4IXhyZ2b
l8YJv3R7Md/Lgo1h7gw26gQIm6kJHSfmkWMte7J8xwRw7+Drru0i9kHlS1uK
+gSEngjZN9NB7NOV3gp/gwlo/k8wkI2Y9+rh9Y/BbQJe82b/GvhF1PszXKe8
aAJ0feeGqmsIvXizFFMqiPz7m1RPVLPgqk6FhP+vCYhSMzCt/soC89LlWY0/
xPue240+n4j9ybyUWqY6CbgTWC8Vs+Ah8054st4kdKuOu40UEX4knnnV78wk
tDfxb6l8Sczb/W59Db9JKPhlcVYzh9DTy/Dvh4+TIFTk9dwkkQVbXjn1J/2c
hC2VvMefxbEgdjKkzrdvEsZ/GHgOPST85jyeoc49BbovMuV23iP2+5iC8Ycj
U+Dq4ljxw4cFr0KOqSedngKHAubwLcK/ZD85yPk6ToGlZryjnAcLsH1pq2p3
p+DluQZPJSei35uFnpfWTQG39DV1azNi3ix2xyYyp+D0teYuLxMWvI3RC/CZ
mYJSpnupvwELDLg/bU+mTMPBj5EyRlqEn9xYYrfaPg1LpQsHOXezYOm8U16X
yzRwmHs+ymdjgfW62eulV6fhnJjOh/klJlSW3Tj02G8aZCZbAuUJv48UC2s1
i5iG8wPb+s6OMGFrXRZHU+402Oo3Ff2tZ8IJ1UHT6vFp2HG8I2QokQklQ5ck
s+emgb0oIFw0lgmbYubHQpanYfS6EKZ0nwmjU1wBh2kzECxQ7aoawISADOnn
+PYZCL3XneFhy4Q8gXNrxY4zYCuwj5G0lQnCZcNVMZdnYFQjo79wExO8nNwe
etyYgbGSF3xv6EzQ+uK/TTFsBpyYBzzDSEzo8E42yc2egScZ/Z9LanqAPNTx
7OnwDKHX5KrtwR6w+WBqFGn3G0Ia4oWkBbpBsZghKOb6G/ImY1a2LXUBR357
45Nrv6HscM96Un8XpKVanSoK/Q3NMRtGDr3pgt4gO6vmnN9gkHIo96tFF9gc
veq8Yeo3sMwe9C4kdoJNS0xo1rVZUBapb59eawfF+lNHFW7OQuxs/4fS/nbg
qBKjlYTOghJN97tVVTuklSTd/x4/C4eUghxkotuhNykjdvL9LPTJibWWSraD
je3rdCW2ORBzzxkSUWmD8zNNOB46B8+jV6NuHmkB6xuRp95GzkGOo5CmhnwL
nOHUn8yPm4OPva/LW6gtYCryWTwlaw6eMjfsSa5thiMqBVd9v80BGrFGXsbN
sCvg3g5V8jz4mrjscDL5BYsC2nFFIfMQZyLKZa7aCHf3vHHNDF6AmEDT39Oq
P6BasWXQM2IB7qfKKW6ZrAHy3j+Wh2MX4OpSsKnwkxq4pbJPvz9jAUaS/IK2
89SAt+YbOanKBVA8RZ9V/lENjifesJI4/4CK7aHCWoNvoHP9jUnMzT/gUem5
y3nzZ+DA3+y7dWMRGvd8jt3O8RJyeAUzVwIXod0y0MzILQ+MLZyFr4UvQro6
55Rkxwt4urB5xiFxEdiiWHxGudmgtTMsx7BsEcxGBvj7Dz2F4IQzEuIcf4HO
u9ftv5FQwDzZOQvv/AV2usVK3sv08nXyerU9cUswNSdf9PDy5/IjKZpPp6OX
4egXne1vbFvL6VM12v5vViHsqKoxF8dAecLXEnZOBzbUmT0YMWA6Wa4mcXBt
sy07qldSnncrmS3fzhTo9/XgQEuNPaMLXxfLc7ME7V9f5kSJ9XKc4d4r5T7d
lo3bg7lQ1dmG0zuU2XF3tf16yQ+5kWCln/qADye+lKJlMxbJg25Kxo5uceTG
Nf6oRyvE8KDiQinNVXduPMBg36dr8Two4d6/4Z9e3Dh5ZZsUVxoP8o85I+hy
hxsXMefv3VDEgwaEE044ZXHje4Tbzxn84kFnRqVSfQe48QuhrucKxEjouHhL
A8uCB693S7C+lkZCpwW5VV7uJ+HykQL/PDJJ6O77I6bfNUh4UH5wzOUcEmpZ
l2DH0iLhypOXqy8VktAFZqjxqhEJT3LSU7L9RELFflULS/Yk3NFumXS8l4T8
W0guy49IONcZq3x5KTK6+DFMjfybhFt5N+nKyZLRw44MMe8/JPxNwtF+GXky
4jwg4Du8THy/TVlMUpGMdiSEVRWSyHiDKX8QXZOMriTbbOCWIOPJx3FTLhsy
ulW061uSNhlX0ZFa7XpCRour/W6hMWRc6Wl16NcMMtqHSSzvTCDju9YuCxVk
k5Fr2DXmj2QyLvXms9ytAjJijuRnLT8j49StF0zkP5KRvvqBfpESMt7Fk5V1
lUlGGj5eHkpdZDzgy04T/k0U5Cqilsm7iYL7SDV3LUpRkMPj4BdExK/6+dn3
ylKQQYxtfpcsBXdUrvN9vYuCFO0yU2J2UXCTTLcsCw0K2i0o3VmqTsFlgotW
nllSkGhOq9mgOQWvOqyShRIpKGdMyCA6koJf/+q3yz+VgiKxr8n/HlBwOd2K
Vx/SKUj3sb6n5SMKHqxv+FE1l4IcK65nYskUXMvkQrtSGQWx83iUYs8pOG4d
RdvGpKAjbxVakj9TcLfe5uiL/RSUdiXwb8QXCr7JdoNY5jAF8bQdu3StioL7
XXwmIz1DQfW376kp1FFwNZcPGhIcGGrYXL75SDsFf+M94rZuC4ZuDBM7NkXB
7VZ2/TGUw9C1Ebu1KzMUXNTfwzdiB4bc2FB3zywF9whcu0Pdi6Ga7+yTKYsU
XPGOyFNubQxZqE+yfWTH8F7MYpvWUQxlF9fazXNieNTd1PxAAwzlnphvlOTB
8On720vXTDHkbrPnrQ2G4XmxB3/9vYghf1LmyVuCGG7FCLHY74yhY38m064L
YzhvQg3rqhuGlGznemxFMdw56dTk7HUM3X2SLCGzHsPl0y+RJu9gqOoQy1RL
EsMzCuJVep9jyM69XevfTgx3/Gch35qPoRB+z08ndmP4nsMbxWuLMPSJa6fQ
sz0YXtqatvzuPZG/jCaj/B+GN649L4/6jiFBrZSalX0YHqfr8jKkjtCrUz5D
QoWo78GeJ76NGDJDyqCsiuGjsq8DHTow9IxDOv+4GoazG5QdPjiGoeoKSU0F
hOFfHt1U3jeFoUfKTqOiBzH8Lktz685ZDCmeFjk0TzDD8ytZ7B+GlsSlVh4f
wvDusjt/+dYwdOnvCXNbLQxPJ+uPcnFSkQLXnbMyhzF8d2L992mMilRNnp+O
0sbwuYHo0kE+Kipiv3FUTQfDS3afzO0UpKKOIqyjh2Dtz20R39ZTkeZp3UYB
XQyn8Sb6l22koiccw8rJBP80tXJ7JUVFzRLyiluOYrjlaO/xVHkqGn0SOSSm
h+FSShmasbuoKGB7cdIdgod9L/53V5GKdB0D+mYIzvu6bUugMhXdpS8WG+tj
uMe6ceHrqlSUvSop+oJgVYs8bhcNKmJbJa+tEMyW4bZwXpOKRkjvXI8cI/SZ
VBw6rU1FqdLILpzg8P3zLYZHqWifSx7zC8FGgW++HTagoiBx0a4lgkVrvN4d
MKYivmvhp7caYHiniFqOgimRf2DLCX2C086uJmw1pyKBvqVqB4Lts/FwCSsq
cqHIEfcnDN81G+gjZENFr6lVMhEEz6kdvkSxo6Lad8vcMQS/CyZZrTlQUS9b
v/lDgv3qqwzmLxH6jT+Rukuw1vq7MOZORQaZFhY+BGO2BntYnlRk67Wf8wLB
9bkCki1eVPSl/hxDm+DYPz/X/fClIn8VzvhNBJ85GMPxOYCKjM4fDZohziMV
fmr27W0qeiB58dd7goeaxPrz7lCRlHP4PT+CX2zsbEq/R0XIeixbheDL9smV
CVFUdP3gB7kJQs/9hdbFkTFUFHxDhRxP8Oo/qWfB8VR0IDlBW53gisMDj3yS
qMjaXqK3jehX2P1noZefUNHDMrY2F4JFpHc4WmVTEfhMNQQQ/Y+MDjfNziX0
z++LmiPmA+MY05wrIM6jvdPQimA2VrZ4WAkVuVvzvhM9guHeRhTyrzIqcvh+
/NwFYt4Wyu3nNn0m9HHVWc0h5nM8eeuP19+pqNj3M684Mb8X+ULesdVT0X1e
AZ/DxHz3+g5m6DVRUaR0QrMdMf+tZzL8WJ1UpJcvfCSC2I+K9dJ7eCeJ8+zj
73NVx3AIC9xg9puKPsYne/1v30r+sshPF6goo1Z0fNsBDH/Zmsrav0ZFyT8b
zpTvx/DE2I0PbAVoKO1DpLIPsd90Hj//fGEaSo119RRWxPBozy6nJQYNsdSy
bj4l/CD0RKJWpCQN6T9LmMsg/MNDcP3Ce0UaqnxouVFtK4ZPBXj18uyjocNJ
teFhMoS/zLTWHj9AQ8cjfxbXSWO4df2jZ0OHaGjTKycNjc0Yrh8hclroJA0Z
b7zZ+5yB4V9XPA5bnaYhCOWnviT8TPNSk0K2JQ15++/tyyH8br/+AwzsaMgj
NOjxLQEMl8bWlTpeo6H5vsiVryQMT/Zyy3rtTUML+7Z6BHAT/jFS95DtJg2V
PNhyT4HwW75vEZdiQ2kod+JviucqBV+6Tdv0KZ6Gap7rSdybo+A/2cmBYqU0
dFR7s/RiNwWfzI23MsJpyPX2lptynRScYr79QEgFDYkPHyw3bKPgqNBgbq6G
hm6OhHUHNlLwPJsYu/ouGjrUfNLX+ysFD/8spReyRkNrWdMyr3MpeKbrq61l
nLwoNqqM1ySHgn8S1+aaJ/EieX16xVAmUc8Vhw82AryIdvn3o/kUCm6/5eVu
DUle9C+s/ENaFPF/d1tdeF6TFzkM3KZrXqHg1gp109t1eFHVnVh7fVcK7t1l
/cNGjxfV1H++dsyJghfuvRVcb0Lkv/K15r/zFHzzYPXic1tedCPDaX+UMQVf
1jbrsgnmRWvL9mYRuyn4a/KVzPoqXpT1hPvq3V4yPugTMFH2gxelrz8YXEnc
Bxgz95VyG3jRwrs7HgutZNyn7cWnO228SE41ZgTqyLhWzmC35ggvUms7L+/+
noz/1DOnvybzobuhvq/1o8n4dMTB0HgdPqReUDIyoELcRziN6kL0+FDFldr1
65XI+IlrVqJXDfmQUdYRSe1dZPztWe9041N8iEeSK++2FBn33/Map17kQ0Nn
d1ekYWSc76fcX99gPiRhcqn1RBsJ3yEi4GhTyYceBdLq4txIuFD++xcZVXxo
JGh88D8HEr505OLU8A8+9P7PxIXKcyT8m0+Zh2szH0o94ZLw3ZiE2/Y7+/sM
8SHuC50DtkrE/a6o6mEshR91V7FOfp/nwfmMg8qrj/GjL7oKPx3defCpiAXh
/5r5kX+D2FcxfW58fHrjp53t/Ggi/WrjX01ufNRYx1Wumx/Zj6XmNKhw4/2i
cVUSg/xoGNvzwX4rN96erOJHXuBHq6XREUoc3LjNqbLZSUwABQ8f/XKomAs/
dpHdskJeAElfT1Q5wuDCpUNCdrs6CiCtFN1Puys48MvNSn42zgKIY91pDq13
HDgu01tz0kUAVQql5hnlceBWFWqOapcF0CNZsrFJHAeewP47nXJDABldUp5e
ceLABX3OrE+/I0DMu+DvkXUcOIe7AndblgDinNNqkDNjx3vNO9o1hwSQ9WzS
hFHSWvmRgca/r13WoWFD4c2JexbLr1++YC86sQ5Jyyrw7rCfLjcofnxU9Kog
etvfaZCa2lk+uezow7kgiB6uP7KcP4jDk5aAVy5XhBDXvA8XMhiCJXt1a69/
QuilYl2xz8kFkFiJsnC/IYxeW2g66OxnQ4M64dVkLhEkZO1V5p7DjT7L1sDG
cBEUzytTE9WDIUdyJpckRRTd49njiQXyozepW9Q/R4ki/swHss50QVR7QK3S
eB0dfVG7OZnDL4zC3nr+0xaio0phe85xUWGkszdf4YAIHdlBqPq2jcII3yWV
LC1GR2lxuvS4HcKoSJJ8bW4zHbWv9ojp6AqjOFKTXOweOtJ+t0t2OEAYnW90
uttmSEc3Rg1bt0wLo0XHxybWEXT04GSHwFq5CLp/4ynJP5KOjpFEOku/iCDZ
sOfvk6LpiGyndcHzhwg6mf1euiOWjt4NRmY0t4ugwqGO2ZMpdMRR6x92el4E
OdtueKj3ko7kQ34YWG0TRUzLpCbln3RUEHD1mOE9UXTtUkboySY6Uu5Mljn7
QBTx+eaqeTTTkTB/rJVDvChST/yQXtBOR52OGUPOGaIoob3LY0cfHe28f4u0
54MoOnFqo4jUHB2l1OC09DFR9M0o5SSvKAMJ3P89tluLTtyzB8pIDAbyWc3U
365LR7z7d8hxrGegx3m8PpIGdGS86d3SggQDmQeZa6yeoqOOiZ8pTBkGynbj
F/FyoqPJMJ7Ror0M9FMnbfflKDoSqbzkZ36SgYKaD/meb6Ojt/tfDZ04RXze
SOzJqy46Mn+xZGR4moHIurLH2XrpKPlBiLSWJQP1egwfCxmlIzmbJ992XmCg
j6/OBpr8oyO1tSZBdk8GKsC+SvSJM5CNitqzZw8ZiFqYEttgxkAOEz/mO2OJ
+u89Geo4w0BuT85qCcYz0ElDm8091gzkTwli+SQx0PawYY16ewZKbKsSN85k
oAtTs8NnrjNQs9epyOU3DMQ7o1EuQeTp2jnSrVDCQJZSU5aviTz9rBs7L5Yy
EFe4W+lhIs+sbnJ1A85ANaF7843SCR3XD3A9q2Igq4kLcvyFDHS05LLX8Q4G
Mntsc3JHDQMdd+H6FtzFQGyNdT8N6ojnUrGipT0MFLakOerwk4Euhr0rku1n
ILu3wt13Whnoljnb5L9xBko/+CvejXhetnTPJnOVgfL2PnRuWWKgyrxNBR1s
Ygjv8/YJXCHqsClYE+AUQ7te/uSQJZ53VDclepPEUNU3ZUdTbjG0mCDeYiQg
hpbf77c/wy+G1gxyZYIFxVCv+shU9ToxxMMJHu+FxZB+nGiXAhGFnWzWyYqJ
ocjTCT3DDDEkvmnurIW4GHKoqpveT0Spxtt5kRJiqE0GnQ0gonwIfaVykxhK
LGfKfSKiwoFsvX+SYuiP6v/H/wMDRSiy
      "]]}}, 
   {RGBColor[1, 0.5, 0], PointSize[Medium], 
    PointBox[{{3.05, 1.42}, {4.926480685516256, 1.0466798784073676`}}], 
    CircleBox[{3.05, 1.42}, 1.9132557791109623`]}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->True,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{301, 432},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1529594620]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Possible Issues",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1192204336],

Cell["\<\
Where several points are all the same distance from the curve only one will \
be found.\
\>", "ExampleText",
 CellID->1355848642],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PointCurvePlot", "[", 
  RowBox[{
   SuperscriptBox["x", "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "1.2"}], ",", "1.2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->799147777],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw1mPk3FXqgRw03t4SQulIoSeWKLg0qzgcJDYhQJBGSSMhchpB5zlCZSSgz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      "]]}}, 
   {RGBColor[1, 0.5, 0], PointSize[Medium], 
    PointBox[{{0, 1}, {0.7071067753972272, 0.49999999181266475`}}], 
    CircleBox[{0, 1}, 0.8660254037844386]}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->True,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 291},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->2117651363]
}, Open  ]],

Cell["The second point can be found using a different start value.", \
"ExampleText",
 CellID->1119976210],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PointCurvePlot", "[", 
  RowBox[{
   SuperscriptBox["x", "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "1.2"}], ",", "1.2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"0", ",", "1"}], "}"}], ",", 
   RowBox[{"StartValue", "\[Rule]", " ", 
    RowBox[{"-", ".3"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->745995515],

Cell[BoxData[
 GraphicsBox[{{{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJw1mPk3FXqgRw03t4SQulIoSeWKLg0qzgcJDYhQJBGSSMhchpB5zlCZSSgz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      "]]}}, 
   {RGBColor[1, 0.5, 0], PointSize[Medium], 
    PointBox[{{0, 1}, {-0.7071067873389112, 0.5000000087007562}}], 
    CircleBox[{0, 1}, 0.8660254037844387]}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->True,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 291},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->937089419]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Calculus and Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/CalculusandAnalyticGeometry"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->1188969310]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PointCurvePlot - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 29, 18.2044624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PointCurvePlot[f, {x, x_min, x_max}, pt] generates a plot of f on the \
interval x_min to x_max and draws a circle centered at pt tangent to the \
curve.", "synonyms" -> {}, "title" -> "PointCurvePlot", "titlemodifier" -> "",
     "windowtitle" -> "PointCurvePlot", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/PointCurvePlot"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6228, 197, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->545769726]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 60328, 1390}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[607, 21, 2796, 65, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3428, 90, 57, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3488, 93, 1221, 40, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[4746, 138, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->150262931],
Cell[5358, 158, 179, 6, 70, "Notes",
 CellID->1067943069],
Cell[5540, 166, 166, 6, 70, "Notes",
 CellID->602546437],
Cell[5709, 174, 135, 4, 70, "Notes",
 CellID->1612571054],
Cell[5847, 180, 344, 12, 70, "Notes",
 CellID->1238079438]
}, Closed]],
Cell[CellGroupData[{
Cell[6228, 197, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->545769726],
Cell[CellGroupData[{
Cell[6743, 215, 194, 6, 31, "ExampleSection",
 CellID->72794500],
Cell[6940, 223, 67, 1, 32, "ExampleText",
 CellID->1432058683],
Cell[7010, 226, 128, 3, 28, "Input",
 CellID->1761053252],
Cell[7141, 231, 97, 1, 32, "ExampleText",
 CellID->297120355],
Cell[CellGroupData[{
Cell[7263, 236, 347, 11, 28, "Input",
 CellID->802327210],
Cell[7613, 249, 10596, 202, 453, "Output",
 CellID->663598957]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18258, 457, 270, 8, 70, "ExampleSection",
 CellID->2061341341],
Cell[CellGroupData[{
Cell[18553, 469, 198, 6, 70, "ExampleSubsection",
 CellID->1757724783],
Cell[18754, 477, 259, 5, 70, "ExampleText",
 CellID->1746423669],
Cell[19016, 484, 127, 3, 70, "Input",
 CellID->336117687],
Cell[19146, 489, 140, 4, 70, "ExampleText",
 CellID->1402383410],
Cell[CellGroupData[{
Cell[19311, 497, 349, 11, 70, "Input",
 CellID->1224946045],
Cell[19663, 510, 10598, 202, 453, "Output",
 CellID->8067388]
}, Open  ]],
Cell[30276, 715, 93, 1, 70, "ExampleText",
 CellID->1225091428],
Cell[CellGroupData[{
Cell[30394, 720, 401, 12, 70, "Input",
 CellID->38422960],
Cell[30798, 734, 10598, 202, 453, "Output",
 CellID->1529594620]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[41457, 943, 278, 8, 70, "ExampleSection",
 CellID->1305812373],
Cell[41738, 953, 128, 3, 70, "Input",
 CellID->1192204336],
Cell[41869, 958, 139, 4, 70, "ExampleText",
 CellID->1355848642],
Cell[CellGroupData[{
Cell[42033, 966, 301, 10, 70, "Input",
 CellID->799147777],
Cell[42337, 978, 7049, 144, 312, "Output",
 CellID->2117651363]
}, Open  ]],
Cell[49401, 1125, 106, 2, 70, "ExampleText",
 CellID->1119976210],
Cell[CellGroupData[{
Cell[49532, 1131, 376, 12, 70, "Input",
 CellID->745995515],
Cell[49911, 1145, 7047, 144, 312, "Output",
 CellID->937089419]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[57019, 1296, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[57470, 1311, 196, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[57703, 1321, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[58154, 1336, 172, 4, 70, "MoreAbout",
 CellID->1188969310]
}, Open  ]],
Cell[58341, 1343, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

