(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     15025,        473]
NotebookOptionsPosition[     11531,        365]
NotebookOutlinePosition[     13643,        422]
CellTagsIndexPosition[     13558,        417]
WindowTitle->PointGrid - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Building an Understanding of Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
BuildingAnUnderstandingOfFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"PlotGrid\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PlotGrid"], "\<\"XGrid\"\>":>
       Documentation`HelpLookup["paclet:ClassroomUtilities/ref/XGrid"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Understanding Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingFunctions"], \
"\<\"Classroom Utilities\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/PointGrid\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PointGrid"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PointGrid.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PointGrid", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PointGrid", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["PointGrid"], "InlineFormula"],
     "\[LineSeparator]is an option value for GridLineStyle in ",
     Cell[BoxData[
      ButtonBox["PlotGrid",
       BaseStyle->"Link",
       ButtonData->"paclet:UnderstandingFunctions/ref/PlotGrid"]], 
      "InlineFormula"],
     " to have the grid rendered as points."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->277046565],

Cell["\<\
PointGrid can be given in a list with graphics directive specifying how the \
points should be rendered\
\>", "Notes",
 CellID->1067943069]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->7781742],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->224917212],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1659968461],

Cell["A plot grid with the grid lines rendered as a set of points.", \
"ExampleText",
 CellID->1129865850],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PlotGrid", "[", 
  RowBox[{"QuadrantI", ",", 
   RowBox[{"GridLinesStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Green", ",", 
      RowBox[{"AbsolutePointSize", "[", "6", "]"}], ",", "PointGrid"}], 
     "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1604934176],

Cell[BoxData[
 FormBox[
  GraphicsBox[
   {RGBColor[0, 1, 0], AbsolutePointSize[6], PointBox[CompressedData["
1:eJxN14lt3DAQQNGReKuLtJQSUkBSXxpLvLs6EgH/QzRAPMMHPSA5h7/9+PX9
5xoRv5eI2z/Xdbn+4he+8I0f3PHAEy8M9l3Qv5MwY8GKDTsO3P5rbH+n9YUv
fOMHdzzwxAuDfRdcMWHGghUbdhx4x+nZGdvXtF74xg/ueOCJFwb7LrhiwowF
KzbsOPCO07v17IztNa03fnDHA0+8MNh3wRUTZixYsWHHgXecvj3v1rMztve0
PrjjgSdeGOy74IoJMxas2LDjwDtOc8O35916dsb2mdaOB554YbDvgismzFiw
YsOOA+84zV1zw7fn3Xp2xrZP68ATLwz2XXDFhBkLVmzYceAdp7XF3DU3fHve
rWdnbMe0Trww2HfBFRNmLFixYceBd5zWPmuLuWtu+Pa8W8/O2M5pXRjsu+CK
CTMWrNiw48A7zut6arQ10BpjDpsjvkHv2DM0Rj+CfRdcMWHGghUbdhx4x2nv
sDZb+6wt5q654dvzbj07Y4vpY8EVE2YsWLFhx4Ebe9nj7CHWaGugNcYcNkd8
g96xZ2iMrhUTZixYsWHHgVs8Pd7eZu+wNlv7rC3mrrnh2/NuPTtjW6eVMGPB
ig07Dtz4XWcEe7A9zh5ijbYGWmPMYXPEN+gdL1NsaVoZC1Zs2HHgxu84wzgj
2IPtcfYQa7Q10BpjDpsjMd2tZ2dseVoFKzbsOHDjZ52xnGGcEezB9jh7iDXa
GmiNMYcjnrfn3Xp2xlamVbFhx4EbP+MM6IzlDOOMYA+2x9lDrNHWQGtMxJMb
vj3v1rMztjqthh0HbnzPGdUZ0BnLGcYZwR5sj7OHWKOtgRFP7pobvj3v1rMz
tjatjgM3vuYM7YzqDOiM5QzjjGAPtsfZQ6zREU9tMXfNDd+ed+vZGVuf1sCN
z53xnaGdUZ0BnbGcYZwR7MH2OHtIxFP7rC3mrrnh2/NuPTtjG9PaWPP/IM74
ztDOqM6AzljOMM4I9mB7nD3EGm0NtMaYw+aIb9A79gyN8R9Emo3f
     "]]},
   AlignmentPoint->Center,
   AspectRatio->Automatic,
   Axes->True,
   AxesLabel->None,
   AxesOrigin->Automatic,
   AxesStyle->{},
   Background->None,
   BaseStyle->{14, Italic},
   BaselinePosition->Automatic,
   ColorOutput->Automatic,
   ContentSelectable->Automatic,
   CoordinatesToolOptions:>Automatic,
   DisplayFunction:>$DisplayFunction,
   Epilog->{},
   FormatType:>TraditionalForm,
   Frame->False,
   FrameLabel->None,
   FrameStyle->{},
   FrameTicks->Automatic,
   FrameTicksStyle->{},
   GridLines->None,
   GridLinesStyle->Automatic,
   ImageMargins->0.,
   ImagePadding->All,
   ImageSize->432,
   ImageSizeRaw->Automatic,
   LabelStyle->{},
   Method->Automatic,
   PlotLabel->None,
   PlotRange->{{0, 10}, {0, 10}},
   PlotRangeClipping->False,
   PlotRangePadding->Automatic,
   PlotRegion->Automatic,
   PreserveImageOptions->Automatic,
   Prolog->{},
   RotateLabel->True,
   Ticks->Automatic,
   TicksStyle->{}], TraditionalForm]], "Output",
 ImageSize->{436, 435},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1248146540]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["PlotGrid",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/PlotGrid"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["XGrid",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/XGrid"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Building an Understanding of Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/BuildingAnUnderstandingOfFunctions"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Understanding Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], "MoreAbout",
 CellID->1810540426],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->1409936882]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PointGrid - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 29, 21.8548624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PointGrid is an option value for GridLineStyle in PlotGrid to have the \
grid rendered as points.", "synonyms" -> {}, "title" -> "PointGrid", 
    "titlemodifier" -> "", "windowtitle" -> "PointGrid", "type" -> "Symbol", 
    "uri" -> "ClassroomUtilities/ref/PointGrid"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5486, 156, 488, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->7781742]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13417, 410}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[602, 21, 3436, 79, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4063, 104, 52, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[4118, 107, 533, 15, 85, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4688, 127, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->277046565],
Cell[5300, 147, 149, 4, 70, "Notes",
 CellID->1067943069]
}, Closed]],
Cell[CellGroupData[{
Cell[5486, 156, 488, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->7781742],
Cell[CellGroupData[{
Cell[5999, 174, 195, 6, 31, "ExampleSection",
 CellID->224917212],
Cell[6197, 182, 128, 3, 28, "Input",
 CellID->1659968461],
Cell[6328, 187, 106, 2, 32, "ExampleText",
 CellID->1129865850],
Cell[CellGroupData[{
Cell[6459, 193, 311, 9, 28, "Input",
 CellID->1604934176],
Cell[6773, 204, 2253, 64, 456, "Output",
 CellID->1248146540]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9087, 275, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[9536, 290, 411, 15, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[9984, 310, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[10435, 325, 211, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[10683, 335, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[11134, 350, 180, 4, 70, "MoreAbout",
 CellID->1810540426],
Cell[11317, 356, 172, 4, 70, "MoreAbout",
 CellID->1409936882]
}, Open  ]],
Cell[11504, 363, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

