(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     21113,        614]
NotebookOptionsPosition[     17433,        502]
NotebookOutlinePosition[     19610,        559]
CellTagsIndexPosition[     19525,        554]
WindowTitle->PointLabelOffset - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Building an Understanding of Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
BuildingAnUnderstandingOfFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"FunctionArrowDiagram\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/FunctionArrowDiagram"], \
"\<\"PointLabels\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PointLabels"], \
"\<\"PointLabelStyle\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PointLabelStyle"], "\<\"Offset\"\>":>
       Documentation`HelpLookup["paclet:ref/Offset"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Understanding Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingFunctions"], \
"\<\"Classroom Utilities\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/PointLabelOffset\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PointLabelOffset"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PointLabelOffset.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PointLabelOffset", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PointLabelOffset", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["PointLabelOffset"], "InlineFormula"],
     "\[LineSeparator]is an option for ",
     Cell[BoxData[
      ButtonBox["FunctionArrowDiagram",
       BaseStyle->"Link",
       ButtonData->"paclet:UnderstandingFunctions/ref/FunctionArrowDiagram"]],
       "InlineFormula"],
     " controlling the amount of offset from the point used by the point \
labels."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->901822946],

Cell["The point label offset should be given as a list of lists", "Notes",
 CellID->1067943069],

Cell["\<\
The first list specifies the offset for the domain labels in printers points\
\>", "Notes",
 CellID->544512977],

Cell["\<\
The second list specifies the offset for the range labels in printers points\
\>", "Notes",
 CellID->1201784572]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->469270135],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->464972960],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1309601569],

Cell["Placing the labels beneath the points.", "ExampleText",
 CellID->913672080],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionArrowDiagram", "[", 
  RowBox[{"5", ",", "7", ",", "\"\<OneToOne\>\"", ",", 
   RowBox[{"PointLabels", "\[Rule]", " ", "Automatic"}], ",", 
   RowBox[{"PointLabelOffset", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"0", ",", 
        RowBox[{"-", "10"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"2", ",", 
        RowBox[{"-", "10"}]}], "}"}]}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1578572510],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.986419, 0.970581, 0.342397], Opacity[0.2], EdgeForm[GrayLevel[
   0]], DiskBox[{0, 0}, {1.1, 1.6500000000000001`}], 
   {RGBColor[0.0692454, 0.645548, 0.968322], 
    DiskBox[{3, 0}, {1.1, 1.6500000000000001`}]}, 
   {GrayLevel[0], PointSize[Medium], Opacity[1], 
    PointBox[{{0, 1.3856406460551018`}, {0.6000000000000001, 
      0.6928203230275509}, {0, -1.0392304845413265`}, {
      0.30000000000000004`, -0.17320508075688773`}, {-0.4, 0}, {2.8, 
      0.34641016151377546`}, {3.3, 1.2124355652982142`}, {2.9, 
      0.8660254037844386}, {2.6, -0.34641016151377546`}, {
      2.3, -0.8660254037844386}, {3.4, 0.}, {3.6, 0.6928203230275509}}], 
    {RGBColor[0.5, 0, 0.5], Arrowheads[Medium], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAAAAAAAAAAACaxwElsKDwvx7Jw85f
i7Y/vtoztNZs77+UV0xWr93GP2QcFj2fue2/wmnOvetg0T/OM5zRoCjsvzRa
oI7sddc//7AdNrC66r/cdZ/4n6rdP+75cpWPcOm/Z/6agt394T9c4u4Z7kro
v3i/vdXxMuU/AmBtkGdK57/UTr1L2XLoP8+rqBWEb+a/kTpCfNq76z8yrQDO
t7rlvyQvzio3DO8/mgHbp2Is5b9+38CZFjHxP5xSvCjQxOS/nzf6vPvd8j8g
/TVFN4Tkvz0n0Gzni/Q/aky9Q7pq5L86wrCL9Tn2P9zBe6pmeOS/rtvE6UHn
9z/nDyI4Na3kvzhqA77okvk/lJbB5wkJ5b8IYA4fBzz7PyRXqv+zi+W/LtWY
e7vh/D/6ekUr7jTmv1GiFhImg/4/Sbben14E578W9bqztA8AQIQBSUyX+ee/
iclRXtXaAEAWYkUTFhTpv/sqTkGJogFAa8WMEEVT6r9lZmZmZmYCQKpMWOh6
tuu/HMPP4Q==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAANDMzMzMz0z8iCq2GlSvGv4cO9Vsc
Utk/Ju1+J76ewL8YGthzu4/fP6a/wmQERLe/3F5HZGD04j8gdr9ZHOCsv4zu
BQ/nLOY/2IQ1JiMZm7/UiAE8vG/pPwCw4TBJsVK/InMW9SS77D/YX1bgMPyT
P14vltuwBvA/7Di37rkooj/qvdSvV7LxP7ijr+gE5qc/XtfoDaRf8z9ohBTD
7TKrP1xyySyyDfU/iNv7LrQNrD/5YZ/cnbv2PyjQcBfkdao/G7rY/4Jo+D9w
eAvfVWymPwaCMgR+E/o/CBFB2lvmnz9QfHhbrLv7P0A8FytuN4w/LvK68yxg
/T8Aa+i+o/uAv9u5uq4gAP8/8F0FnCDtob8zDSZsVU0AQMbBDprE+rC/Ed64
zXgXAUBUfi920Ce6v4bB+DoP3gFAcJvCvWo8wr+U/xJVr6ACQK6mvCst9Me/
VAdo1/FeA0AESaTZJjjOv4SuVs5xGARANqENW4KC0r/MzMzMzMwEQCIKrYaV
K9a/JxS/Vw==
      "]], ArrowBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQPWsmCNzczwAFHyMFf/YfO7/fQ3r/16fOW+2nlFVK
JB7bvv/Cx1df98cdsV+y9bvh7hsb7G8FzXO2MTxr31JVNzVY9qy9oZvy0Ziu
S/bffi7IiRa6aX978hv5FqZr9hmNqvuu331of3Wi40eb/zfsA9U+PK1zem6/
Pj+h7GPdbfv+759muW15Y2/5/JejX8Nd+7Zdq1aqSny0f7XP/4MT0337AE5X
7ks3P9unG92MZmR6YG8n4M2yae43+5CfM7OanB7YH3q/5bdv0k84f923XV90
1f7A1Ve5hobdev4Pbp6Mk3Pku0sMDjD7sr81uyXoMznA3LNsfplAVwezA8y9
Bx9kT9pyl8UB5p9wiRXHtPTYHGD+DXYqULOqZHeAhcfW04c5jPdxOMDCa77o
xP8ZfzgdYOFpDAbcDrDwBgDbtrvB
      "]], ArrowBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQbWIMAo/tlbjWtk3VfmbPsZPLaQnHc3v7qY3Tzru8
sL/09MSElq+v7JepLpp/3uCVvciBre/3fX9nz9zLOmXCu9f2TEfSc2e2fbTf
c7vgvWrtW3s/vuizt2Z+tmcz/2ay5/Y7+xu/67d2bvlqf+bP1PVnWD7YZ3qt
C+q4+t3exatgIV/zB/u8o0UVW3//tJ+Zwf0p4cUH+xmb66zeqv6xl1vXd6/X
5KP9i9097ZzB/+y7Ppz9nZP+0V66c0vSRwcGh5Adu70fN3y0rxd4arYighHO
X2Z9+apIAZMDTP05+6g/i9qYHWDmPTFLuLtvNosDzL7UEqeCq+tYHWDuWTf7
5r6Q/WwOMPcWC70xWnOG3QHmn5nbnz7yucbhAPPvVM01d1fe5nSAhYdaQnqp
xR0uB1h4RbwW6yy4zu0AC8+zZ0CAxwEW3gAHe8gK
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAAAAAAAAAAAAiCq2GlSv2Pxdp+A9p
WsE/8eTgH7o29z9Oswh/vojRPwIECqBRKPg/GpOyveqN2j/bGu7W2//4PzZx
oAL42+E/QngKZ+a8+T+x5+jE+IDmPyClQgINX/o/scVrw4Az6z/OLBmf+eX6
PwM7S+4R8e8/lFFWpmRR+z8PVVAtlFvyP1x0BBkVofs/PBMTzJ3B9D/jB66u
4NT7P1MGowRgKfc/awPN66vs+z+2Em0elJH5P6jtXzBq6Ps/xG9xJPP4+z/r
wpy+Hcj7P3VUv5I2Xv4/0yi+udeL+z9sU9qBDGAAQDiS6xy4M/s/ueBSbquO
AUBoJkGq7b/6Pw/ZyHxXugJA3WwA0rUw+j/C68OrceIDQDPn9pFchvk/jDmy
3lwGBUCn5StNPMH4Pw5URTF+JQZA5/rqm73h9z8cuKFJPT8HQLaBRBRX6PY/
YCc1qQRTCEDcpiELjdX1P/f8CPxBYAlASFoNTvGp9D9mZmZmZmYKQN5o19Ui
ZvM/x8+8pw==
      "]], 
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`a\\_1\\)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{0, -10}, {0, -1.0392304845413265`}]], InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`b\\_1\\)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{0, -10}, {0.30000000000000004`, -0.17320508075688773`}]], 
      InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`c\\_1\\)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], Offset[{0, -10}, {-0.4, 0}]], InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`d\\_1\\)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{0, -10}, {0.6000000000000001, 0.6928203230275509}]], InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`e\\_1\\)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], Offset[{0, -10}, {0, 1.3856406460551018`}]],
       InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`a\\_1\\))\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{2, -10}, {2.3, -0.8660254037844386}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`b\\_1\\))\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{2, -10}, {2.6, -0.34641016151377546`}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`c\\_1\\))\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], Offset[{2, -10}, {3.4, 0.}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`d\\_1\\))\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{2, -10}, {3.6, 0.6928203230275509}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`e\\_1\\))\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{2, -10}, {3.3, 1.2124355652982142`}]]}}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->False,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->True,
  FrameLabel->FormBox[
    StyleBox[
    "\"\[ScriptX] \[RightTeeArrow] \[ScriptF](\[ScriptX])\"", 18, Bold, 
     StripOnInput -> False], TraditionalForm],
  FrameStyle->{},
  FrameTicks->None,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 266},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1307719056]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["FunctionArrowDiagram",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/FunctionArrowDiagram"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["PointLabels",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/PointLabels"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["PointLabelStyle",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/PointLabelStyle"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 StyleBox[ButtonBox["Offset",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Offset"],
  FontFamily->"Verdana"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Building an Understanding of Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/BuildingAnUnderstandingOfFunctions"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Understanding Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], "MoreAbout",
 CellID->2057145439],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->1474614776]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PointLabelOffset - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 29, 25.3960624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PointLabelOffset is an option for FunctionArrowDiagram controlling the \
amount of offset from the point used by the point labels.", "synonyms" -> {}, 
    "title" -> "PointLabelOffset", "titlemodifier" -> "", "windowtitle" -> 
    "PointLabelOffset", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/PointLabelOffset"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6025, 171, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->469270135]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 19382, 547}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[609, 21, 3719, 86, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4353, 111, 59, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[4415, 114, 580, 16, 99, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5032, 135, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->901822946],
Cell[5644, 155, 95, 1, 70, "Notes",
 CellID->1067943069],
Cell[5742, 158, 121, 3, 70, "Notes",
 CellID->544512977],
Cell[5866, 163, 122, 3, 70, "Notes",
 CellID->1201784572]
}, Closed]],
Cell[CellGroupData[{
Cell[6025, 171, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->469270135],
Cell[CellGroupData[{
Cell[6540, 189, 195, 6, 31, "ExampleSection",
 CellID->464972960],
Cell[6738, 197, 128, 3, 28, "Input",
 CellID->1309601569],
Cell[6869, 202, 81, 1, 32, "ExampleText",
 CellID->913672080],
Cell[CellGroupData[{
Cell[6975, 207, 499, 14, 47, "Input",
 CellID->1578572510],
Cell[7477, 223, 7092, 170, 287, "Output",
 CellID->1307719056]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[14630, 400, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[15079, 415, 770, 27, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[15886, 447, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[16337, 462, 211, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[16585, 472, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[17036, 487, 180, 4, 70, "MoreAbout",
 CellID->2057145439],
Cell[17219, 493, 172, 4, 70, "MoreAbout",
 CellID->1474614776]
}, Open  ]],
Cell[17406, 500, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

