(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     20460,        575]
NotebookOptionsPosition[     17105,        473]
NotebookOutlinePosition[     19241,        530]
CellTagsIndexPosition[     19156,        525]
WindowTitle->PointLabelStyle - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Building an Understanding of Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
BuildingAnUnderstandingOfFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Understanding Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingFunctions"], \
"\<\"Classroom Utilities\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/PointLabelStyle\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PointLabelStyle"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PointLabelStyle.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PointLabelStyle", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PointLabelStyle", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["PointLabelStyle"], "InlineFormula"],
     "\[LineSeparator]is an option for ",
     Cell[BoxData[
      ButtonBox["FunctionArrowDiagram",
       BaseStyle->"Link",
       ButtonData->"paclet:UnderstandingFunctions/ref/FunctionArrowDiagram"]],
       "InlineFormula"],
     " allowing the point labels to be styled."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->610437112],

Cell[TextData[{
 "PointLabelStyle will accept any values that can be used in ",
 ButtonBox["Style",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Style"],
 "."
}], "Notes",
 CellID->1067943069]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->874518540],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->251467429],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2036950597],

Cell["Rendering the point labels in red.", "ExampleText",
 CellID->1991866952],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionArrowDiagram", "[", 
  RowBox[{"5", ",", "9", ",", "\"\<OneToOne\>\"", ",", 
   RowBox[{"PointLabels", "\[Rule]", " ", "Automatic"}], ",", " ", 
   RowBox[{"PointLabelStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Red", ",", "Italic", ",", "14"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->185289181],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.986419, 0.970581, 0.342397], Opacity[0.2], EdgeForm[GrayLevel[
   0]], DiskBox[{0, 0}, {1.1, 1.6500000000000001`}], 
   {RGBColor[0.0692454, 0.645548, 0.968322], 
    DiskBox[{3, 0}, {1.1, 1.6500000000000001`}]}, 
   {GrayLevel[0], PointSize[Medium], Opacity[1], 
    PointBox[{{0.5, 0.5196152422706632}, {-0.9, 0.17320508075688773`}, {
     0.2, -0.34641016151377546`}, {-0.5000000000000001, 0.5196152422706632}, {
     0.6000000000000001, -1.0392304845413265`}, {3.8, 0.34641016151377546`}, {
     2.8, -0.6928203230275509}, {2.8, 0.6928203230275509}, {
     3.5, -0.8660254037844386}, {3.1, -0.17320508075688773`}, {2.4, 0.}, {3.2,
      1.0392304845413265`}, {3.7, -0.17320508075688773`}, {2.1, 
     0.5196152422706632}}], 
    {RGBColor[0.5, 0, 0.5], Arrowheads[Medium], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAANDMzMzMz4z+axwElsKDwvwVU0efj
xOU/LC8OKxVG77/nnOH5/GzoP2SMud0/ae2/EPlljRUq6z/qDeJj3avrv5BJ
I6K5+u0/RkehD9oO6r/4w4FstW7wP8S76QURk+i/akl8n1Do8T/iwT/KSznn
v9T+eQ5mafM/JDnN00EC5r9gxUJmKfH0PxDOCCyY7uS/Yb9XyMp+9j9EcyQX
4f7jv4DgPjl3Efg/XYZxxpsz47+AXnUQWaj5P3DO4xQ0jeK/iZzNaZhC+z95
I9dNAgziv+1p/Jdb3/w//Bs2/kqw4b90zBiYx33+P5qcGtA+euG/0IboQoAO
AEBBlvtw+mnhv/SwCwgV3gBASKZ1goZ/4b/uIAT3M60BQHOrtpXXuuG/ETfm
KW97AkDevY4xzhviv+RMnDNZSANA2lEj4zai4r++bPZZhRMEQFapO1nKTeO/
Mx1bz4fcBEDLFxiKLR7kv++j+uv1ogVAiATA4/ES5b9mZmZmZmYGQCIKrYaV
K+a/bfnKZQ==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAmpmZmZmZyT8iCq2GlSvWv9AnB2A4
+NM/xJy4VJ6r0b+j2S5qK1bbPzRmEyzFAMu/QYQ0nl5x4T8ucQ8hMVjDv3ik
ojX2TOU/7E2yoCHDuL+e6Wl30DvpPzigQVhYgqi/GoxdJ9c77T+AkDqUTRJz
v4BpSXZ1pfA/UMPSVyvOoD9i49Y4crPyP+z9mB1sgrA/r1W1xMrG9D+sN7BP
kRy3P9WEZCtl3vY/+GgOeAQyvD83kR08Jfn4PwgtYwoTwL8/5oWdGu0V+z9y
7EoTbeLAP/q50tadM/0/PAl+zKMfwT/UiRwFGFH/PyzJ6zWNl8A/3E9mK562
AEAo3c0J45S+PztwTBl2wwFAFK1H8QJyuj+YjFYmhc4CQLSw4PiryLQ/7d4F
nz3XA0DwTpZKvjerP1Kzdg0T3QRAAB8WRay9kz8+oeeDet8FQEBAFV5Y4JS/
z7Nw5urdBkAE+qAJQdWwv0pkwzPd1wdAhMipNezhvb/NzMzMzMwIQCIKrYaV
K8a/h6K+OA==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAzczMzMzM7L8iCq2GlSvGP3rxCqTj
rea/DqKEIqKi0D/o5SeMRHDgv2Evohden9U/kITibn4u1L+ssZMzWQnaP0AX
oQ+PMb2/mt485Tve3T84jRjAw/u2P+rl0Nv+jeA/isxZ1JPs0j+YLQczc+Dh
P329WG7DGuA/t67YYsfl4j+t91K/XsnmPxK8F8JwneM/e12jN5B+7T8oWGTd
DQfkP7rkkllkG/I/DEPhqmYi5D/0wz65O3f1P6Dh76ds7+M/OHSx/wXR+D+o
NuPgOm7jPxAEZQj8Jvw/qtil4hWf4j+i+PC2WHf/P32BWpZrguE/MPK68yxg
AUBChAoH0xjgP925uq4gAANAtzcCIxjG3D9nGkzYqpoEQFEu/Pz9w9g/JLxx
m/EuBkAL0OsOeC3UPw2D8XUevAdAiOeBGOsJzj8r/yWqXkEJQArRjTxmmsI/
qQ7QruO9CkB8MfqCy0moPwldrZzjMAxAyJm9YCMdrr+bmZmZmZkNQCIKrYaV
K8a/ivXFmw==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAAQAAAAAA4L+axwElsKDgPz5yyRiA
xNS/l6sFsgxq4z+WACeFFpbCv4bEYrU78eU/YN1MMD8yoz9Wv/bJ5TToP+w1
Uj+Kksw/uOn9Xdcz6j9QwNPOnVfaP+JhRVYB7es/17FaK3ZF4z/FXASeeV/t
P9+wA79bbuk/Si8Qo3uK7j/9cTHvOqPvP74zKb5obe8/5BsKV2Tw8j/nmZRD
5APwPxZnSanaEfY/P1ZziqQs8D8+kActVzT5PxSDVZTfMPA/OPLWFTBW/D9W
WJIikxDwP7DzGO67df8/TvfIsKCX7z8Xz148qUgBQHlIpGN3xe4/v64uyabT
AkDXl6LgGavtP5e7mggFWwRA3GVk+h1J7D+3MMhR9N0FQI3Rv4M/oOo/bvsR
VqdbB0Dv4hfsX7HoP/tM+I1T0whAAu++x4V95j8I15akMUQKQAyNo0TcBeQ/
061o4X2tC0A5CpKLskvhP86xIZB4Dg1Aiiy9HPag3D9mZmZmZmYOQCIKrYaV
K9Y/DQG78A==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAAAAAAAAA4D+axwElsKDgP918KD8/
FuM/bVVH0C4u4z8Irucwa0nmPx+TDFwIl+U/0j9lLtGX6T8qvIh79dnnP5QQ
fB6w/+w/YtY6AcP16T9rWwKynD/wP/yu5oFS6es/E/Sl6UgK8j9+GI7smrPt
P0hBGVfp3vM/oMYVF6lT7z/muDhThbz1P/STpR9QZPA/ejO8ch+i9z/AYwNA
3QjxP0ywrQy2jvk/JIgWnSSX8T/WKCDDQ4H7P1TdqrjaDvI/VundDcB4/T+N
XfQNwG/yP/TYxMYfdP8/7BdDM6G58j/yG8PbKrkAQMDESvVW7PI/nE4/lCm5
AUDPfe9rxgfzP7c0LTiEuQJAdZGMCOEL8z85Ox3CsrkDQBLdrZ2k+PI/rkQG
RC25BEDqlTdgG87yP5R3ZS9stwVAQuP74VuM8j9fXSud6LMGQIQpwQWJM/I/
7ydQlRyuB0ACYb/s0cPxP/8i6VWDpQhAskqe3XE98T+bmZmZmZkJQJrHASWw
oPA/eU+9Xg==
      "]], 
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`a\\_1\\)\"\>",
        StripOnInput->False,
        LineColor->RGBColor[1, 0, 0],
        FrontFaceColor->RGBColor[1, 0, 0],
        BackFaceColor->RGBColor[1, 0, 0],
        GraphicsColor->RGBColor[1, 0, 0],
        FontSize->14,
        FontSlant->Italic,
        FontColor->RGBColor[1, 0, 0]], 
       Offset[{-6, 6}, {0.6000000000000001, -1.0392304845413265`}]], InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`b\\_1\\)\"\>",
        StripOnInput->False,
        LineColor->RGBColor[1, 0, 0],
        FrontFaceColor->RGBColor[1, 0, 0],
        BackFaceColor->RGBColor[1, 0, 0],
        GraphicsColor->RGBColor[1, 0, 0],
        FontSize->14,
        FontSlant->Italic,
        FontColor->RGBColor[1, 0, 0]], 
       Offset[{-6, 6}, {0.2, -0.34641016151377546`}]], InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`c\\_1\\)\"\>",
        StripOnInput->False,
        LineColor->RGBColor[1, 0, 0],
        FrontFaceColor->RGBColor[1, 0, 0],
        BackFaceColor->RGBColor[1, 0, 0],
        GraphicsColor->RGBColor[1, 0, 0],
        FontSize->14,
        FontSlant->Italic,
        FontColor->RGBColor[1, 0, 0]], 
       Offset[{-6, 6}, {-0.9, 0.17320508075688773`}]], InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`d\\_1\\)\"\>",
        StripOnInput->False,
        LineColor->RGBColor[1, 0, 0],
        FrontFaceColor->RGBColor[1, 0, 0],
        BackFaceColor->RGBColor[1, 0, 0],
        GraphicsColor->RGBColor[1, 0, 0],
        FontSize->14,
        FontSlant->Italic,
        FontColor->RGBColor[1, 0, 0]], 
       Offset[{-6, 6}, {-0.5000000000000001, 0.5196152422706632}]], InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`e\\_1\\)\"\>",
        StripOnInput->False,
        LineColor->RGBColor[1, 0, 0],
        FrontFaceColor->RGBColor[1, 0, 0],
        BackFaceColor->RGBColor[1, 0, 0],
        GraphicsColor->RGBColor[1, 0, 0],
        FontSize->14,
        FontSlant->Italic,
        FontColor->RGBColor[1, 0, 0]], 
       Offset[{-6, 6}, {0.5, 0.5196152422706632}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`a\\_1\\))\"\>",
        StripOnInput->False,
        LineColor->RGBColor[1, 0, 0],
        FrontFaceColor->RGBColor[1, 0, 0],
        BackFaceColor->RGBColor[1, 0, 0],
        GraphicsColor->RGBColor[1, 0, 0],
        FontSize->14,
        FontSlant->Italic,
        FontColor->RGBColor[1, 0, 0]], 
       Offset[{10, 6}, {2.8, -0.6928203230275509}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`b\\_1\\))\"\>",
        StripOnInput->False,
        LineColor->RGBColor[1, 0, 0],
        FrontFaceColor->RGBColor[1, 0, 0],
        BackFaceColor->RGBColor[1, 0, 0],
        GraphicsColor->RGBColor[1, 0, 0],
        FontSize->14,
        FontSlant->Italic,
        FontColor->RGBColor[1, 0, 0]], 
       Offset[{10, 6}, {3.1, -0.17320508075688773`}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`c\\_1\\))\"\>",
        StripOnInput->False,
        LineColor->RGBColor[1, 0, 0],
        FrontFaceColor->RGBColor[1, 0, 0],
        BackFaceColor->RGBColor[1, 0, 0],
        GraphicsColor->RGBColor[1, 0, 0],
        FontSize->14,
        FontSlant->Italic,
        FontColor->RGBColor[1, 0, 0]], 
       Offset[{10, 6}, {3.7, -0.17320508075688773`}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`d\\_1\\))\"\>",
        StripOnInput->False,
        LineColor->RGBColor[1, 0, 0],
        FrontFaceColor->RGBColor[1, 0, 0],
        BackFaceColor->RGBColor[1, 0, 0],
        GraphicsColor->RGBColor[1, 0, 0],
        FontSize->14,
        FontSlant->Italic,
        FontColor->RGBColor[1, 0, 0]], 
       Offset[{10, 6}, {3.8, 0.34641016151377546`}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`e\\_1\\))\"\>",
        StripOnInput->False,
        LineColor->RGBColor[1, 0, 0],
        FrontFaceColor->RGBColor[1, 0, 0],
        BackFaceColor->RGBColor[1, 0, 0],
        GraphicsColor->RGBColor[1, 0, 0],
        FontSize->14,
        FontSlant->Italic,
        FontColor->RGBColor[1, 0, 0]], 
       Offset[{10, 6}, {3.2, 1.0392304845413265`}]]}}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->False,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->True,
  FrameLabel->FormBox[
    StyleBox[
    "\"\[ScriptX] \[RightTeeArrow] \[ScriptF](\[ScriptX])\"", 18, Bold, 
     StripOnInput -> False], TraditionalForm],
  FrameStyle->{},
  FrameTicks->None,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 259},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1728972331]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Building an Understanding of Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/BuildingAnUnderstandingOfFunctions"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Understanding Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], "MoreAbout",
 CellID->2007602391],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->2143769669]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PointLabelStyle - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 29, 32.2288624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PointLabelStyle is an option for FunctionArrowDiagram allowing the point \
labels to be styled.", "synonyms" -> {}, "title" -> "PointLabelStyle", 
    "titlemodifier" -> "", "windowtitle" -> "PointLabelStyle", "type" -> 
    "Symbol", "uri" -> "ClassroomUtilities/ref/PointLabelStyle"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5073, 149, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->874518540]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 19013, 518}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[608, 21, 2956, 69, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3589, 94, 58, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3650, 97, 543, 15, 85, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4230, 117, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->610437112],
Cell[4842, 137, 194, 7, 70, "Notes",
 CellID->1067943069]
}, Closed]],
Cell[CellGroupData[{
Cell[5073, 149, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->874518540],
Cell[CellGroupData[{
Cell[5588, 167, 195, 6, 31, "ExampleSection",
 CellID->251467429],
Cell[5786, 175, 128, 3, 28, "Input",
 CellID->2036950597],
Cell[5917, 180, 78, 1, 32, "ExampleText",
 CellID->1991866952],
Cell[CellGroupData[{
Cell[6020, 185, 360, 8, 47, "Input",
 CellID->185289181],
Cell[6383, 195, 9114, 216, 280, "Output",
 CellID->1728972331]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[15558, 418, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[16009, 433, 211, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[16257, 443, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[16708, 458, 180, 4, 70, "MoreAbout",
 CellID->2007602391],
Cell[16891, 464, 172, 4, 70, "MoreAbout",
 CellID->2143769669]
}, Open  ]],
Cell[17078, 471, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

