(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     29036,        827]
NotebookOptionsPosition[     25173,        707]
NotebookOutlinePosition[     27310,        764]
CellTagsIndexPosition[     27225,        759]
WindowTitle->PointLabels - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Building an Understanding of Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
BuildingAnUnderstandingOfFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"FunctionArrowDiagram\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/FunctionArrowDiagram"], \
"\<\"PointLabelStyle\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PointLabelStyle"], \
"\<\"PointLabelOffset\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PointLabelOffset"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Understanding Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingFunctions"], \
"\<\"Classroom Utilities\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/PointLabels\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PointLabels"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PointLabels.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PointLabels", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PointLabels", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["PointLabels"], "InlineFormula"],
     "\[LineSeparator]is an option for FunctionDiagramPlot allowing labeling \
of the points in the domain and range sets."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->334210761],

Cell[TextData[{
 "Specific labels can be specified using {",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      SubscriptBox[
       StyleBox["lbl", "TI"], 
       StyleBox["1", "TR"]], ",", " ", 
      SubscriptBox[
       StyleBox["lbl", "TI"], 
       StyleBox["2", "TR"]], ",", " ", 
      StyleBox["\[Ellipsis]", "TR"]}], "}"}], ",", "\"\<\!\(\*SubscriptBox[
StyleBox[\"f\", \"TI\"], 
StyleBox[\"lbl\", \"TI\"]]\)\>\""}], "}"}]], "InlineFormula"]
}], "Notes",
 CellID->1067943069],

Cell["The function name should be given as a string", "Notes",
 CellID->1247908406],

Cell["\<\
If more labels than points are specified the extra labels will be ignored\
\>", "Notes",
 CellID->1271283040]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->180152514],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->221147226],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->398401887],

Cell[TextData[{
 "Using Automatic for the option value will give ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox[
    StyleBox["a", "TI"], 
    StyleBox["1", "TR"]], ",", " ", 
   SubscriptBox[
    StyleBox["b", "TI"], 
    StyleBox["1", "TR"]], ",", " ", 
   SubscriptBox[
    StyleBox["c", "TI"], 
    StyleBox["1", "TR"]], ",", " ", 
   StyleBox["\[Ellipsis]", "TR"]}]], "InlineFormula"],
 " for the points and ",
 Cell[BoxData["\[ScriptF]"], "InlineFormula"],
 " for the function."
}], "ExampleText",
 CellID->1139249277],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionArrowDiagram", "[", 
  RowBox[{"5", ",", "6", ",", "\"\<OneToOne\>\"", ",", 
   RowBox[{"PointLabels", "\[Rule]", " ", "Automatic"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->86503463],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.986419, 0.970581, 0.342397], Opacity[0.2], EdgeForm[GrayLevel[
   0]], DiskBox[{0, 0}, {1.1, 1.6500000000000001`}], 
   {RGBColor[0.0692454, 0.645548, 0.968322], 
    DiskBox[{3, 0}, {1.1, 1.6500000000000001`}]}, 
   {GrayLevel[0], PointSize[Medium], Opacity[1], 
    PointBox[{{0.4, 1.0392304845413265`}, {
     0.6000000000000001, -0.6928203230275509}, {-0.6000000000000001, \
-0.34641016151377546`}, {0.30000000000000004`, -1.2124355652982142`}, {0.9, 
     0.5196152422706632}, {2.5, 1.2124355652982142`}, {
     2.5, -0.5196152422706632}, {3.6, -0.6928203230275509}, {3.4, 
     1.0392304845413265`}, {2.8, -1.0392304845413265`}, {
     3.5, -0.17320508075688773`}}], 
    {RGBColor[0.5, 0, 0.5], Arrowheads[Medium], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAANDMzMzMz0z/eaNfVImbzv7qdvAbn
WNk/miMTtfVp8r+uVG2E4qrfP1j7z5Lzf/G/JBwjluUS4z/w2DGZmKjwv1zM
jWMYY+Y/KH9VGa7I77+h7M+cR8TpPzP1sh4uZ+6/cPr9MKg07T+HrpHTbC3t
v7oevn8zWfA/L3dZshAc7L/OIe3n1B3yPzQDb8aqM+u/0uu4Jkjn8z9jDD5f
tnTqv7r3IYOatPU/Rq3Lzpjf6b/OK0Y214T3P3Gw8zOhdOm/HrhB7QdX+T/2
Wm1QCDTpv+MT4ks1Kvs/FvitavAd6b9/wOVvZ/38Pw4huTtlMum/GS6DdKbP
/j9MZ+joW3HpvwV8+Hr9TwBAwq2tCbPa6b9p11RKtzYBQFAjTbkybuq/ksQS
PIYbAkBBdoW0jCvrv8BPYujw/QJAc4QWg1wS7L+sYVIsf90DQJh/EK0nIu2/
1EqPabq5BEBkPM/7XVruv/QbU8UtkgVA4jF/xlm6779mZmZmZmYGQJrHASWw
oPC/yenL+Q==
      "]], ArrowBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQbWIMAo/tlbjWtk3VfrafYyeX0xKO5/as9TfKooWe
7L/09MSElq+v7Oe9254brfZov8iBre/3fX9n79geUjkr48F+piPpuTPbPtoL
FF6y5tpyd78fX/TZWzM/29fsOr7h7rdb+2/8rt/aueWrfYRpTIzy7Bv7M73W
BXVc/W5f9v/TFOlF1/bnHS2q2Pr7p71KW1vQJZ6r+2dsrrN6q/rHXqigcoHc
ncv7X+zuaecM/mcfl1ajvUjg8n7pzi1JHx0YHCzcj74+serS/nqBp2YrIhjh
/GXWl6+KFDA5wNSfs4/6s6iN2QFm3hOzhLv7ZrM4wOxLLXEquLqO1QHmnnWz
b+4L2c/mAHNvsdAbozVn2B1g/pm5/ekjn2scDjD/TtVcc3flbU4HWHioJaSX
WtzhcoCFV8Rrsc6C69wOsPA8ewYEeBxg4Q0AtlTKkA==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAANDMzMzMz478iCq2GlSvWvxqqQr4N
PN6/DEtPeaRG0r/IqHGNf+bVvzXm9ybAg82/Pt3wx0/Uyr9SoOCOTD7HvyA9
tpkdLrO/wnQ8BELAwb9gxvGseIavP7iytCQVGbq/PMC87XGMyT+ksDXUSUuy
v+BG5lUGsNU/kBgyPIw2qL98N9R5fKnePwB4k/FJMZ6/zO9cLezW4z/AnE14
aIOSv8CyNpQoXOg/4FZK9EzTir828zVqDeLsPwCuKJlxzY2/eSJdJxqz8D9g
Bl891fmWvwOb4OYb8/I/uOjtflnPor/I27JS2i/1P7iDdXTGZq2/PKIahSVo
9z88vZloyZ61v4JX1/TPmvk/uFd3YzMmvr/wux8Vr8b7PzEFLVONIsS/WPIK
9Jvq/T8oVRA7EPvJvxLvh+u5AgBAzC+cLsRM0L8g5aNqDAsBQL20FlI5/dO/
sD+RN7kNAkC0Zx1n8gzYv5ilnRE3CgNAsHWdwMd53L8AAAAAAAAEQJrHASWw
oOC/rQfE9g==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAzczMzMzM7D+axwElsKDgP7dhbpi5
TfA/I0xcYaGP4T9rouaM+znyPy0C/9v2UeI/j+/LEicq9D8ToeJ3SefiP/6y
rOU0HfY/zyAG+klP4z9Od1k5HBL4P87eeDPBieM/VkFlRtMH+j+0W6IekJbj
P384K9dP/fs/FAm476914z9yyg7Vh/H9PyFrWBgyJ+M/fFer1XHj/z+gpEk+
QKviP/s+1NMC6QBAIlZgJRwC4j+tJXRvHt4BQJ+KmowfLOE/4Xjir4nQAkCy
NIH+uyngPy8QivTDvwNAxQLTKfX23T8EYlNOTqsEQJXua2D3Q9s/X2H+wquS
BUAJ93tE7TvYP52cco9hdQZAu8YRmnLg1D+obeJo91IHQK9dIGtPM9E/16ue
vPcqCEAQjAsr7mzKP4oBee7v/AhA6tcohA7YwT/Ny5OVcMgJQHC/rhQbWbE/
ij9/tw2NCkCAwPnQcguBv912hAFfSgtAEEkAaim1tr////////8LQBgKrYaV
K8a/hPO/vg==
      "]], ArrowBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQPWsmCNy0n3WcUXXDgg/2C4OW3LZd9MBeg/eNju/a
j/ZZ9Ulacv1P7GNCawx9F3+yXxPp3xkx8YU9F+e61bpNn+3nKWaWnFn2xj59
Q3JkhecXe6nb6rOWp32w54lTqzn844v9khM+TWGNn+xD7R0FN/V/tTcTr5YP
XfTF/lyPNPMX3m/2VpPsXZtOfLNXWr0t2K34m31Kgzf7rk8/7Jd9sHQo3v/N
fktHZMg1+d/2IsaVsUGfvtkz3TedtN7vr/3dX2lrT3B/tz/1dpqVbN1/OJ9n
kaVN9TUGB5h6k2UHkjjfMjrAzPOae8xZlYnZAWbf6VsrrlmLsjjA3CPC5KC6
W5XVAebemxVBM4WM2Rxg/vkv6+O52YbdAebf3/1CLgJOHA6w8Og5dvb2PCdO
B1h47QusfX/NlssBFp7GYMDtAAtvAIWPsLo=
      "]], 
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`a\\_1\\)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{-6, 6}, {0.30000000000000004`, -1.2124355652982142`}]], 
      InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`b\\_1\\)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{-6, 6}, {0.6000000000000001, -0.6928203230275509}]], InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`c\\_1\\)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{-6, 6}, {-0.6000000000000001, -0.34641016151377546`}]], 
      InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`d\\_1\\)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], Offset[{-6, 6}, {0.9, 0.5196152422706632}]],
       InsetBox[
       StyleBox["\<\"\\!\\(TraditionalForm\\`e\\_1\\)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{-6, 6}, {0.4, 1.0392304845413265`}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`a\\_1\\))\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{10, 6}, {2.8, -1.0392304845413265`}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`b\\_1\\))\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{10, 6}, {3.6, -0.6928203230275509}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`c\\_1\\))\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{10, 6}, {2.5, -0.5196152422706632}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`d\\_1\\))\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{10, 6}, {3.5, -0.17320508075688773`}]], InsetBox[
       StyleBox["\<\"f(\\!\\(TraditionalForm\\`e\\_1\\))\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{10, 6}, {3.4, 1.0392304845413265`}]]}}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->False,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->True,
  FrameLabel->FormBox[
    StyleBox[
    "\"\[ScriptX] \[RightTeeArrow] \[ScriptF](\[ScriptX])\"", 18, Bold, 
     StripOnInput -> False], TraditionalForm],
  FrameStyle->{},
  FrameTicks->None,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 259},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->968668609]
}, Open  ]],

Cell["Labels can be words.", "ExampleText",
 CellID->1117091226],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionArrowDiagram", "[", 
  RowBox[{"5", ",", "7", ",", "\"\<OneToOne\>\"", ",", 
   RowBox[{"PointLabels", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"cat", ",", "dog", ",", "pig", ",", "cow", ",", "goat"}], 
       "}"}], ",", "\"\<\[ScriptCapitalA]\>\""}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1650193308],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.986419, 0.970581, 0.342397], Opacity[0.2], EdgeForm[GrayLevel[
   0]], DiskBox[{0, 0}, {1.1, 1.6500000000000001`}], 
   {RGBColor[0.0692454, 0.645548, 0.968322], 
    DiskBox[{3, 0}, {1.1, 1.6500000000000001`}]}, 
   {GrayLevel[0], PointSize[Medium], Opacity[1], 
    PointBox[{{-0.2, 1.0392304845413265`}, {-0.4, 0.34641016151377546`}, {
     0.30000000000000004`, -0.17320508075688773`}, {-0.5000000000000001, \
-0.8660254037844386}, {0.6000000000000001, -1.0392304845413265`}, {2.8, 
     0.6928203230275509}, {3.4, -1.0392304845413265`}, {
     2.1, -0.17320508075688773`}, {3.9, 0.17320508075688773`}, {3.1, 
     1.2124355652982142`}, {3.6, -0.34641016151377546`}, {3.3, 
     0.5196152422706632}}], 
    {RGBColor[0.5, 0, 0.5], Arrowheads[Medium], ArrowBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQbWIMAo/tZx1nVN2w4MP+lzVyQWbHn9lr3Xr+9Jv3
+/2/Xu3bK1H4yv7Nbf1Vhxve7s8uEr70Qu+d/YkLfba7Hrzer3dQVCf0/wf7
X4ab47fnvNrvdOj5Se33n+wnrVQtaVB9uX+Bl7T2x6df7GXEeiUPc7/Yb3lj
dtesR9/stQz6z4ooPN9/XdyQWerJD3uPzXVzPyU9239n42a5+Je/7IsUGJ8c
uPJ0f++KeWnhH//Yy/mfFz5d+nT/lkkbvr779c8+iXdtv7Pb0/3Ltqm3djQx
OMD4u1Zv8AlpZ3SAqRdSX1YQ0M3kADNPtCT936deZgeYfY+FN+3a1MfiAHPP
hqiiLPZeVgeYe+/L8UhndbA5wPyTIf81M7SB3QHm3zTl6tOuJRwOsPBwcp1w
YWcypwMsvI4lVGQb+XE5wMITHNzG3A6w8AYACOjH6w==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAAQAAAAAA4L+qTFjoerbrv5S8w2J+
P9a/UuQEi0cu6L9Y2EkniF7Iv4GnY2HU3+S/gBJURYBKnb/k+JaL4szhv6Dg
4MOulcE/ih7uLSfu3b/6vqUol6nTP+7kCEHRv9i/WjKbydLB3j9yfiERgxHU
vzPBNJ/TBuU/fHgo4HDLz78L8AgQi8PqP5T5Md9Pfci/nD9JNQJK8D+QVUhp
gzzCv8g3MPOUOvM/kB+XwLkYur9kpStx7jH2P5jFyPY537G/MtM4xnsu+T8Q
hGFEyaGnv+K3qEanLvw/QIw4d8HDn78qkl9b2TD/P4BsavitBZm/QaIMrbwZ
AUDAVRXn6wybv0LYHy93mgJAYB1s4DPsor8sAvAQ0BkEQCDZMZwzsay/t+0l
6/uWBUD4rN8PI2i1v+Og+X0wEQdAIPnQofagvr+siIIcpYcIQByIde4X/8S/
K+QxF5P5CUBw4sWP47zLv/3sPiU2ZgtAukgfQCXD0b/QzMzMzMwMQCAKrYaV
K9a/Y3LKDg==
      "]], ArrowBox[CompressedData["
1:eJxTTMoPSmViYGCQAGIQbWIMApftlbjWtk3VPrY/Lfe84Lsz1+3L3q9LsFU6
uD/i2jPOE0137FMOf/n9gGvn/rYQvyUKKx/Y21/2Ouu0fsP+ujOxhmkyj+0P
bDr0Uy5n0f6iT1uuP5/51H6DT0HlR8nW/XX860KCFV7YT1hvuWKhbof9zwVP
VwWue2W/omxFozT7fHujc+Y32p3e2rtIC6S9lVluf3rH/d7pt9/bZ+yQVq6/
vMb+T5X2V36bj/ZPIhXKZYM22Md5eErFd3+yd7Czc+5122jPKSfrw377M5yf
/dqqMEzrK1w9U1fZ/FkV3+Dm+dd7VSkd/Q6379XUzxNs+X/C3bMijn+PTdgv
uHv13nZXFc38DfePRsN2X+Mbf+D+VbGxF7km+A8eHpc2vEne4vofHl7trj8L
ployOMDC8+wZEGBwgIU3AKYLvso=
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAmpmZmZmZ2b8iCq2GlSvWP8D+ItHs
59G/8CbQeVKI2z+W87Gbn/PDvw2RR43+ROA/wFTQzXs3nb+m3Oqt9pbiP6Au
u3ohG7o/3hL6dda45D+gARLuAyHOP828iEF8qeY/+P3OTS3F1z81okSL4Gfo
P4dzrO0VUOA/7rNIeBbz6T+hUhZhZc7kP+XdyVVMSus/FZCdpiJb6T+0EVsI
zGzsP4uCyrvj8+0/OYCNbPtZ7T8K3A8fHEvxP1e9uahcEe4/AB8zW9Wf8z9O
aMZvjpLuPygJVvPg9vU/merINEzd7j/KwyENAU/4P1/oZE9u8e4/sKmIO/em
+j+0FdcQ6s7uP/gmuyeF/fw/ykagydF17j/IyxA6bVH/P6S4zb9U5u0/8/hF
obnQAECzuuMVvyDtP9JFT5Au9gFASAh4onkl7D+si+u0eRgDQDlBkbgJ9eo/
pqOOBwE3BECmBengEJDpP8lYE4AsUQVAHD42hEz35z9mZmZmZmYGQCIKrYaV
K+Y/LIzI+g==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAmpmZmZmZyb+axwElsKDwPzYFhuel
brK/BLk3nX7k8T9AW+nlCHKuP5gFTFoaEPM/GEuxMvjYyD9y4G5j5CL0P/XF
O9x0OtU/pFkV60oc9T8DmtRwfzPeP2REVpzJ+/U/LIQjhGyp4z/vRSHh6cD2
P/TOD0DVSeg/mcsqIUNr9z9UsOd5hfjsPyWFa/l6+vc/wfLklYDZ8D/18BVs
RW74PyRF2gZjO/M/j4foCGXG+D/WKSh1pqD1P6chxw2rAvk/5IYsewUI+D9l
TIp/9yL5P0iT9pQ5cPo/KGL3Ojkn+T9fhobN+9f8P6Bm2P1tD/k/i0RJbAU+
/z8Y0y5ootv4Pwz+OVGI0ABAULCA9fGL+D9h2/Gb7P8BQIuLQ+6GIPg/4ZKS
m44sA0DcA21Rmpn3P36wJMzOVQRA/tY0tnP39j9qehZ1D3sFQJd5GCZpOvY/
Y7br/LSbBkC+YjTv3mL1PzxGzTsmtwdArUMLb0dx9D/NzMzMzMwIQN5o19Ui
ZvM/3T3GYg==
      "]], 
     {GrayLevel[0], InsetBox[
       StyleBox["\<\"cat\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{-6, 6}, {0.6000000000000001, -1.0392304845413265`}]], InsetBox[
       StyleBox["\<\"dog\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{-6, 6}, {-0.5000000000000001, -0.8660254037844386}]], InsetBox[
       StyleBox["\<\"pig\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{-6, 6}, {0.30000000000000004`, -0.17320508075688773`}]], 
      InsetBox[
       StyleBox["\<\"cow\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{-6, 6}, {-0.4, 0.34641016151377546`}]], InsetBox[
       StyleBox["\<\"goat\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{-6, 6}, {-0.2, 1.0392304845413265`}]], InsetBox[
       StyleBox["\<\"\[ScriptCapitalA](cat)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{10, 6}, {3.4, -1.0392304845413265`}]], InsetBox[
       StyleBox["\<\"\[ScriptCapitalA](dog)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{10, 6}, {3.6, -0.34641016151377546`}]], InsetBox[
       StyleBox["\<\"\[ScriptCapitalA](pig)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{10, 6}, {2.1, -0.17320508075688773`}]], InsetBox[
       StyleBox["\<\"\[ScriptCapitalA](cow)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], Offset[{10, 6}, {2.8, 0.6928203230275509}]],
       InsetBox[
       StyleBox["\<\"\[ScriptCapitalA](goat)\"\>",
        StripOnInput->False,
        FontSize->14,
        FontSlant->Italic,
        FontColor->GrayLevel[0]], 
       Offset[{10, 6}, {3.1, 1.2124355652982142`}]]}}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->False,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->True,
  FrameLabel->FormBox[
    StyleBox[
    "\"\[ScriptX] \[RightTeeArrow] \[ScriptF](\[ScriptX])\"", 18, Bold, 
     StripOnInput -> False], TraditionalForm],
  FrameStyle->{},
  FrameTicks->None,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 259},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->339783556]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["FunctionArrowDiagram",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/FunctionArrowDiagram"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["PointLabelStyle",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/PointLabelStyle"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["PointLabelOffset",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/PointLabelOffset"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Building an Understanding of Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/BuildingAnUnderstandingOfFunctions"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Understanding Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], "MoreAbout",
 CellID->2104160220],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->1889253852]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PointLabels - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 29, 28.7656624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PointLabels is an option for FunctionDiagramPlot allowing labeling of \
the points in the domain and range sets.", "synonyms" -> {}, "title" -> 
    "PointLabels", "titlemodifier" -> "", "windowtitle" -> "PointLabels", 
    "type" -> "Symbol", "uri" -> "ClassroomUtilities/ref/PointLabels"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6086, 176, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->180152514]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 27082, 752}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 3612, 83, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4241, 108, 54, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[4298, 111, 384, 10, 83, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4719, 126, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->334210761],
Cell[5331, 146, 510, 17, 70, "Notes",
 CellID->1067943069],
Cell[5844, 165, 83, 1, 70, "Notes",
 CellID->1247908406],
Cell[5930, 168, 119, 3, 70, "Notes",
 CellID->1271283040]
}, Closed]],
Cell[CellGroupData[{
Cell[6086, 176, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->180152514],
Cell[CellGroupData[{
Cell[6601, 194, 195, 6, 31, "ExampleSection",
 CellID->221147226],
Cell[6799, 202, 127, 3, 28, "Input",
 CellID->398401887],
Cell[6929, 207, 522, 18, 34, "ExampleText",
 CellID->1139249277],
Cell[CellGroupData[{
Cell[7476, 229, 226, 5, 28, "Input",
 CellID->86503463],
Cell[7705, 236, 7197, 174, 280, "Output",
 CellID->968668609]
}, Open  ]],
Cell[14917, 413, 64, 1, 70, "ExampleText",
 CellID->1117091226],
Cell[CellGroupData[{
Cell[15006, 418, 399, 10, 70, "Input",
 CellID->1650193308],
Cell[15408, 430, 7012, 173, 280, "Output",
 CellID->339783556]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[22481, 610, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[22930, 625, 659, 22, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[23626, 652, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[24077, 667, 211, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[24325, 677, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[24776, 692, 180, 4, 70, "MoreAbout",
 CellID->2104160220],
Cell[24959, 698, 172, 4, 70, "MoreAbout",
 CellID->1889253852]
}, Open  ]],
Cell[25146, 705, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

