(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     13893,        436]
NotebookOptionsPosition[     10355,        327]
NotebookOutlinePosition[     12517,        384]
CellTagsIndexPosition[     12432,        379]
WindowTitle->PointLineSegment - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Problems in Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/ProblemsInAnalyticGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/PointLineSegment\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PointLineSegment"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PointLineSegment.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PointLineSegment", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PointLineSegment", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PointLineSegment", "[", 
       RowBox[{
        StyleBox["pt", "TI"], ",", 
        StyleBox["eq", "TI"], ",", 
        StyleBox["var", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]returns a graphics primitive for the shortest line \
from the point ",
     Cell[BoxData[
      StyleBox["pt", "TI"]], "InlineFormula"],
     " to the line ",
     Cell[BoxData[
      StyleBox["eq", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->82479999],

Cell["The second argument should be given as an equation.", "Notes",
 CellID->1067943069],

Cell["\<\
The right side of the equation should be the slope intercept form of the line.\
\>", "Notes",
 CellID->79316355]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->9324062],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->86201500],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1630117345],

Cell["The line from the point {5,2} to the line y== 2 x +1.", "ExampleText",
 CellID->1933332636],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ln", "=", 
  RowBox[{"PointLineSegment", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"5", ",", "2"}], "}"}], ",", 
    RowBox[{"y", "\[Equal]", 
     RowBox[{
      RowBox[{"2", " ", "x"}], "+", "1"}]}], ",", "x"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->2094034142],

Cell[BoxData[
 RowBox[{"Line", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"5", ",", "2"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{
      FractionBox["7", "5"], ",", 
      FractionBox["19", "5"]}], "}"}]}], "}"}], "]"}]], "Output",
 ImageSize->{165, 32},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1188224092]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"2", " ", "x"}], "+", "1"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "6"}], "}"}], ",", 
   RowBox[{"Epilog", "\[Rule]", " ", "ln"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", " ", "Automatic"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->719305865],

Cell[BoxData[
 GraphicsBox[{{}, {}, 
   {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwtxX1Q02UcAPAB4hCBbWzsQd7iZfzYg3V4mOUqeb5gh4fJYXUMHEryvogA
KQEhCDDUdON4sUsieTnllAZdjBMOFBRDnKfiVVweHWAuewE6N5yBc+HK4/vH
5z5B6QXvZDnyeLz4/z3/yVv5p3cXVEUVxwxH83hmdiQzTH6HS2V68ckcscDM
bj98kKvl8pnpeQFmZu7brsnjKpn6qPfUrjfMrEZq8dvL1THVrY8Km0vN7Ob1
nb+/y7WyKGV4W+SimRW0F99I4L5l/Nwv/800LrJRjeZiPDfCTjUcGLgxZmHO
a4v4c7l3WHX1dPTQL8ss7tO02gvKu+zs5e+uqnQ2NnAoa6bzh1k2fUn/8Ee1
nU2pPogoKvmN5fVcIIMXHUC0Q5s9Cn+yY2di+/a3O4FwMkv/asoCc5mPnGrp
cYaQwLyu2nQT8xT2T8b08mHrzIc3oxsX2errYPRp1a7JFgtbfT2oLxsMIzX/
sNXdoTnjnI/X/mW2ugBeSr6/9CzLyqTdheV2vRBmLQkTEGdjJmtYTvtZETy6
t2GTNHGFWU1u3ie+8YR6XVlOUpKdGRKH+3Q6MXACl/jSFh4ugf7CKl1dmwPu
BZOhTfy3Gx1xKcgO/yTf1+yEE1DsvvdyW8sa3BtmCmujtBpnfAPoFXvcrzWs
xX1Aqrw+db6Wj/sCM/Iarn7sgvtBs1TtzpWuw/2hpvX9o1tyXfEAOD1xaryu
cD3+AlTkN5n9i9wgaiDuiYciEBbS5N570t1haZNE82JvIJxYmV8zm+0B45UH
HQs2B8HQ3ztMHioB7Fs6U8LvCYKfQ7caX5MJ8WBQ04yIpk4hHgyjypTy6AAR
HgKbk+e7JB0iPATyDsfe3ebricvgWLbLU4cmT1wGw/5p9nmJGA+FwWdHnMLr
xHgoTPRtn9eKJDgH1wKzxzWNEpyDzwYSO+67euFhsDd4OjVF64WHga0/wncj
X4rL4ROnuVtfVEpxOUhlirRQHsEplOQrH7seIjgFv1cyDVw5wSlcWTnwdUwF
wSm4arVvllUTnEKrbuzk3OcEpzD+V+QWw1cEpyDJEBTXXiI4hcFw/50dIwSn
kPooPGD4CsEpnK+OHX88RnAKr7dXSDNvE5xC+sxCf8wswSnwO63HU38lOIXu
PP57ZUaCU1iyBfP1fxCcwnEfVVKQieAUIow5G7ctEpzCZNdBe7KF4BQCFA3n
6pcJTuF7Xlt5t5XgFNSG7gSDjeAU3OqHQh6sEJxCb5Jh2W4nOIX/ACKEHBI=

     "]]}},
  Axes->True,
  AxesOrigin->{0, 0},
  Epilog->LineBox[
    NCache[{{5, 2}, {
       Rational[7, 5], 
       Rational[19, 5]}}, {{5, 2}, {1.4, 3.8}}]],
  PlotRange->{{0, 6}, {0., 12.99999975510204}},
  PlotRangeClipping->True,
  PlotRangePadding->{
    Scaled[0.02], 
    Scaled[0.02]}]], "Output",
 ImageSize->{111, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1890004812]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Problems in Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/ProblemsInAnalyticGeometry"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->23149646]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PointLineSegment - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 29, 39.0304624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PointLineSegment[pt, eq, var] returns a graphics primitive for the \
shortest line from the point pt to the line eq.", "synonyms" -> {}, "title" -> 
    "PointLineSegment", "titlemodifier" -> "", "windowtitle" -> 
    "PointLineSegment", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/PointLineSegment"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5088, 151, 488, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->9324062]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 12291, 372}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[609, 21, 2802, 65, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3436, 90, 59, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3498, 93, 691, 22, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[4226, 120, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->82479999],
Cell[4837, 140, 89, 1, 70, "Notes",
 CellID->1067943069],
Cell[4929, 143, 122, 3, 70, "Notes",
 CellID->79316355]
}, Closed]],
Cell[CellGroupData[{
Cell[5088, 151, 488, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->9324062],
Cell[CellGroupData[{
Cell[5601, 169, 194, 6, 31, "ExampleSection",
 CellID->86201500],
Cell[5798, 177, 128, 3, 28, "Input",
 CellID->1630117345],
Cell[5929, 182, 97, 1, 32, "ExampleText",
 CellID->1933332636],
Cell[CellGroupData[{
Cell[6051, 187, 307, 10, 28, "Input",
 CellID->2094034142],
Cell[6361, 199, 390, 14, 53, "Output",
 CellID->1188224092]
}, Open  ]],
Cell[CellGroupData[{
Cell[6788, 218, 345, 10, 28, "Input",
 CellID->719305865],
Cell[7136, 230, 1813, 41, 237, "Output",
 CellID->1890004812]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9010, 278, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[9461, 293, 194, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[9692, 303, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[10143, 318, 170, 4, 70, "MoreAbout",
 CellID->23149646]
}, Open  ]],
Cell[10328, 325, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

