(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     11172,        323]
NotebookOptionsPosition[      8267,        236]
NotebookOutlinePosition[     10374,        292]
CellTagsIndexPosition[     10289,        287]
WindowTitle->PointStyle - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/PointStyle\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PointStyle"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PointStyle.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PointStyle", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["PointStyle", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["PointStyle"], "InlineFormula"],
     "\[LineSeparator]an option for PiecewisePlot and similar functions to \
set the style of points"
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->272930591],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->84390186],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->942461603],

Cell["\<\
Make the endpoints of continuous segments large and green and the centers of \
empty points orange.\
\>", "ExampleText",
 CellID->63262649],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PiecewisePlot", "[", 
  RowBox[{
   RowBox[{"Ceiling", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "4.2"}], "}"}], ",", 
   RowBox[{"PointStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Green", ",", 
        RowBox[{"AbsolutePointSize", "[", "12", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Orange", ",", 
        RowBox[{"AbsolutePointSize", "[", "9", "]"}]}], "}"}]}], "}"}]}], ",", 
   RowBox[{"PlotRangePadding", "\[Rule]", " ", "1.2"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->250936478],

Cell[BoxData[
 GraphicsBox[{{{{}, {}, 
     {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQA2IQ/ZXZZKUtU7kdAxh8sG9YnFN8UWqpPYz/9oQH8wWp
rXB+lrlZK+e/o3C+5M3Yu95hF+D8NI7jzw9MugrnT3+qz3/Z4TacH+l98vhb
twdw/o2qqmkOao/hfJ/H/2K0fjyF87eaMgT0z3wB5wvEN148VPwazt+R0aAx
68QbOD+hqL6+UPYdnF949POLpiMIfpNERtCU7Pdwvpvu0TURUxF8bicldtn9
CH7emQCT/5cR/Ath9YkPXyD4jHPEKoI+I/gB7KUB7F8RfABwWHLd
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQA2IQHVFzNLyG9YM9AwQ4nDJ9dzeIE8Hv8/K2EDdG8IPi
V0y6HYPgK6zYM19B6COc//bDhTWpxxH8pu/msWslP8P5E17eC4np+ALnS1Tk
nwj78BXOn11td4nP4TucPz3LV1lvzQ+Ee87N4uJm+AXn/5XVsPQv+A3nP+Oc
//jezT8I/2SFqOho/4Pzfwj4Z7A9QvDVt3uueTDjP8J/+gIf+g4j+DXLrxnb
vkPwm8r8/0z6jOC3u5448uIHgr+i2WpF8y8EHwDb8WN8
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGAQB2IQrbPvkfY+JgYHBjDgcDh3IPSzPDuCf6X/3O5SHgT/
nu4BH0VxBP/l6Y13zygi+CIuFYrVPgi+/R67VM1yBH+L8LHTN04h+BrZvkYd
cowI+/n/LJK6guB/fHfyXnctE5x/8bD5PgNTZjj/Xdqs6OqXCH6Hi8yRJRNZ
EO4Vt7vA6MEK529SrV9u+wnBP8y41UZ+JhucP+FyV6mJHzucvy2ytXzdIgT/
9v36So3vCP4TYzkJ1l8I/pv2Pdse/kHwrzjKXnH8i+ADAHdpVUU=
       "]], LineBox[CompressedData["
1:eJxTTMoPSmViYGCQBWIQrbPvkfY+Jg4HBjAQcOC5YWoYwoHgyzQU5fHyIfg2
F16/qJdE8GMUUpM/qSD4cw+ER1y3RvDvJXj57glC8BMW6pu3NSD4jx6KKAas
Q/BVGPKjLjNzwvlpcicnh0Ui+BqaRUeYGLng/GWau2c82obgL0xRtliYwA3n
R07Vrp4swQPn+03RqNE+i+AfOOvisaiUF85//4dhh48OH5w/O+3Op6vXEPwJ
TS75uVr8cH7LvDWvWeoQ/LcrT0yKXY3gh219YrntBoJvsGN1Ms8TBJ97d1Fv
0nsEv8ImbBHvVwT/2V7L7Tt+Ifhz61Y79v1F8FufF6al/UPwAbCRZ3o=
       "]], 
      LineBox[{{4.000781249665178, 5.}, {4.001574207533854, 5.}, {
       4.002958066783407, 5.}, {4.014028940779832, 5.}, {4.025099814776258, 
       5.}, {4.066421955023568, 5.}, {4.107744095270879, 5.}, {
       4.153872004778297, 5.}, {4.199999914285715, 
       5.}}]}, {}}, {{}, {}, {}}}, {
    {RGBColor[0, 1, 0], AbsolutePointSize[12], 
     PointBox[{{0., 0.}, {0., 1.}, {1., 1.}, {1., 2.}, {2., 2.}, {2., 3.}, {
      3., 3.}, {3., 4.}, {4., 4.}, {4., 5.}}]}, 
    {RGBColor[1, 0.5, 0], AbsolutePointSize[9], 
     PointBox[{{0., 1.}, {1., 2.}, {2., 3.}, {3., 4.}, {4., 5.}}]}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  PlotRange->{{0, 4.2}, {1., 5.}},
  PlotRangeClipping->True,
  PlotRangePadding->1.2]], "Output",
 ImageSize->{184, 125},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1978986685]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->1074470275]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PointStyle - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 29, 45.6292624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PointStyle an option for PiecewisePlot and similar functions to set the \
style of points", "synonyms" -> {}, "title" -> "PointStyle", "titlemodifier" -> 
    "", "windowtitle" -> "PointStyle", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/PointStyle"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[3526, 99, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->272930591]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 10147, 280}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[603, 21, 2424, 55, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3052, 80, 53, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3108, 83, 381, 11, 83, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3526, 99, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->272930591],
Cell[CellGroupData[{
Cell[4041, 117, 194, 6, 31, "ExampleSection",
 CellID->84390186],
Cell[4238, 125, 127, 3, 28, "Input",
 CellID->942461603],
Cell[4368, 130, 149, 4, 45, "ExampleText",
 CellID->63262649],
Cell[CellGroupData[{
Cell[4542, 138, 610, 17, 65, "Input",
 CellID->250936478],
Cell[5155, 157, 2386, 48, 146, "Output",
 CellID->1978986685]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[7602, 212, 448, 13, 45, "MoreAboutSection",
 CellID->38303248],
Cell[8053, 227, 172, 4, 70, "MoreAbout",
 CellID->1074470275]
}, Open  ]],
Cell[8240, 234, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

