(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    111096,       2703]
NotebookOptionsPosition[    106194,       2550]
NotebookOutlinePosition[    108499,       2609]
CellTagsIndexPosition[    108412,       2604]
WindowTitle->PolarPlotGrid - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Building an Understanding of Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
BuildingAnUnderstandingOfFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"PlotGrid\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PlotGrid"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Understanding Functions\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/PolarPlotGrid\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/PolarPlotGrid"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/PolarPlotGrid.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/PolarPlotGrid", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["PolarPlotGrid", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PolarPlotGrid", "[", "]"}]], "InlineFormula"],
     " \[LineSeparator]creates a plot grid using polar coordinates with ",
     Cell[BoxData[
      RowBox[{"0", "\[LessEqual]", " ", "\[Rho]", "\[LessEqual]", "5"}]], 
      "InlineFormula"]
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PolarPlotGrid", "[", 
       StyleBox["r", "TI"], "]"}]], "InlineFormula"],
     "\[LineSeparator]creates a plot grid using polar coordinates with 0<= \
\[Rho]<=r"
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"PolarPlotGrid", "[", 
       RowBox[{
        StyleBox["r", "TI"], ",", "\"\<Radians\>\""}], "]"}]], 
      "InlineFormula"],
     "\[LineSeparator]creates a plot grid using polar coordinates with angle \
given in radians."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->32812561],

Cell["\<\
PolarPlotGrid takes the same options as Graphics with the following \
modifications:\
\>", "Notes",
 CellID->1067943069],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["GridLinesStyle",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/GridLinesStyle"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[
    "sets the styles for the lines in the grid", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["TicksStyle",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/TicksStyle"], 
    RowBox[{"{", "}"}], Cell[
    "sets the styles for the tick labels in the grid", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}},
 CellID->1167331938]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->49504613],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->418293097],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->920275790],

Cell["Create a basic plot grid using polar coordinates.", "ExampleText",
 CellID->897976836],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PolarPlotGrid", "[", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1929095183],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.2472, 0.24, 0.6], Thickness[
   Tiny], {CircleBox[{0, 0}], CircleBox[{0, 0}, 2], CircleBox[{0, 0}, 3], 
    CircleBox[{0, 0}, 4], CircleBox[{0, 0}, 5]}, 
   LineBox[NCache[{{{-5, 0}, {5, 
      0}}, {{Rational[-5, 2] 3^Rational[1, 2], Rational[-5, 2]}, {
       Rational[5, 2] 3^Rational[1, 2], Rational[5, 2]}}, {{
       Rational[-5, 2], Rational[-5, 2] 3^Rational[1, 2]}, {
       Rational[5, 2], Rational[5, 2] 3^Rational[1, 2]}}, {{0, -5}, {0, 
      5}}, {{Rational[5, 2], Rational[-5, 2] 3^Rational[1, 2]}, {
       Rational[-5, 2], Rational[5, 2] 3^Rational[1, 2]}}, {{
       Rational[5, 2] 3^Rational[1, 2], Rational[-5, 2]}, {
       Rational[-5, 2] 3^Rational[1, 2], Rational[5, 2]}}}, {{{-5, 0}, {5, 
      0}}, {{-4.330127018922193, -2.5}, {4.330127018922193, 
      2.5}}, {{-2.5, -4.330127018922193}, {2.5, 4.330127018922193}}, {{
      0, -5}, {0, 5}}, {{2.5, -4.330127018922193}, {-2.5, 
      4.330127018922193}}, {{4.330127018922193, -2.5}, {-4.330127018922193, 
      2.5}}}]], 
   LineBox[NCache[{{{(Rational[1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}, {(Rational[5, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[5, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}}, {{2^Rational[-1, 2], 2^Rational[-1, 2]}, {
       5 2^Rational[-1, 2], 5 
        2^Rational[-1, 2]}}, {{(Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2])}, {(Rational[5, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2]), (Rational[5, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2])}}, {{(Rational[-1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2])}, {(Rational[-5, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2]), (Rational[5, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2])}}, {{-2^Rational[-1, 2], 2^Rational[-1, 2]}, {(-5) 
        2^Rational[-1, 2], 5 
        2^Rational[-1, 2]}}, {{(Rational[-1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}, {(Rational[-5, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[5, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}}, {{(Rational[-1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[-1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}, {(Rational[-5, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[-5, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}}, {{-2^Rational[-1, 2], -2^Rational[-1, 2]}, {(-5)
          2^Rational[-1, 2], (-5) 
        2^Rational[-1, 2]}}, {{(Rational[-1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2]), (Rational[-1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2])}, {(Rational[-5, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2]), (Rational[-5, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2])}}, {{(Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2]), (Rational[-1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2])}, {(Rational[5, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2]), (Rational[-5, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2])}}, {{2^Rational[-1, 2], -2^Rational[-1, 2]}, {
       5 2^Rational[-1, 2], (-5) 
        2^Rational[-1, 2]}}, {{(Rational[1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[-1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}, {(Rational[5, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[-5, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}}}, CompressedData["
1:eJxTTMoPSmVmYGDgAWImKBbZ7+F+98U7+362yQdrJ1ywzynv9ekKFHYwPvHd
cO6WL/ZnrOvT5i14Bqf3c8kzHPPgcYDRMH0wc2D6YOZA5fejye+HyUPN3Y9m
/gGY+VB9+9HcdwBmD5r8fjT5/Wjm70cz/wCa+/ajue8Amv/2o/nvAFr47EcL
nwNo4bsfLXz3AwBMp8GV
     "]]], 
   {Thickness[Small], Dashing[{0, Small}], 
    LineBox[NCache[{{{Cos[Rational[1, 36] Pi], Sin[Rational[1, 36] Pi]}, {
        5 Cos[Rational[1, 36] Pi], 5 Sin[Rational[1, 36] Pi]}}, {{
        Cos[Rational[1, 18] Pi], Sin[Rational[1, 18] Pi]}, {
        5 Cos[Rational[1, 18] Pi], 5 Sin[Rational[1, 18] Pi]}}, {{
        Cos[Rational[1, 9] Pi], Sin[Rational[1, 9] Pi]}, {
        5 Cos[Rational[1, 9] Pi], 5 Sin[Rational[1, 9] Pi]}}, {{
        Cos[Rational[5, 36] Pi], Sin[Rational[5, 36] Pi]}, {
        5 Cos[Rational[5, 36] Pi], 5 Sin[Rational[5, 36] Pi]}}, {{
        Cos[Rational[7, 36] Pi], Sin[Rational[7, 36] Pi]}, {
        5 Cos[Rational[7, 36] Pi], 5 Sin[Rational[7, 36] Pi]}}, {{
        Cos[Rational[2, 9] Pi], Sin[Rational[2, 9] Pi]}, {
        5 Cos[Rational[2, 9] Pi], 5 Sin[Rational[2, 9] Pi]}}, {{
        Sin[Rational[2, 9] Pi], Cos[Rational[2, 9] Pi]}, {
        5 Sin[Rational[2, 9] Pi], 5 Cos[Rational[2, 9] Pi]}}, {{
        Sin[Rational[7, 36] Pi], Cos[Rational[7, 36] Pi]}, {
        5 Sin[Rational[7, 36] Pi], 5 Cos[Rational[7, 36] Pi]}}, {{
        Sin[Rational[5, 36] Pi], Cos[Rational[5, 36] Pi]}, {
        5 Sin[Rational[5, 36] Pi], 5 Cos[Rational[5, 36] Pi]}}, {{
        Sin[Rational[1, 9] Pi], Cos[Rational[1, 9] Pi]}, {
        5 Sin[Rational[1, 9] Pi], 5 Cos[Rational[1, 9] Pi]}}, {{
        Sin[Rational[1, 18] Pi], Cos[Rational[1, 18] Pi]}, {
        5 Sin[Rational[1, 18] Pi], 5 Cos[Rational[1, 18] Pi]}}, {{
        Sin[Rational[1, 36] Pi], Cos[Rational[1, 36] Pi]}, {
        5 Sin[Rational[1, 36] Pi], 5 Cos[Rational[1, 36] Pi]}}, {{-
         Sin[Rational[1, 36] Pi], Cos[Rational[1, 36] Pi]}, {(-5) 
         Sin[Rational[1, 36] Pi], 5 Cos[Rational[1, 36] Pi]}}, {{-
         Sin[Rational[1, 18] Pi], Cos[Rational[1, 18] Pi]}, {(-5) 
         Sin[Rational[1, 18] Pi], 5 Cos[Rational[1, 18] Pi]}}, {{-
         Sin[Rational[1, 9] Pi], Cos[Rational[1, 9] Pi]}, {(-5) 
         Sin[Rational[1, 9] Pi], 5 Cos[Rational[1, 9] Pi]}}, {{-
         Sin[Rational[5, 36] Pi], Cos[Rational[5, 36] Pi]}, {(-5) 
         Sin[Rational[5, 36] Pi], 5 Cos[Rational[5, 36] Pi]}}, {{-
         Sin[Rational[7, 36] Pi], Cos[Rational[7, 36] Pi]}, {(-5) 
         Sin[Rational[7, 36] Pi], 5 Cos[Rational[7, 36] Pi]}}, {{-
         Sin[Rational[2, 9] Pi], Cos[Rational[2, 9] Pi]}, {(-5) 
         Sin[Rational[2, 9] Pi], 5 Cos[Rational[2, 9] Pi]}}, {{-
         Cos[Rational[2, 9] Pi], Sin[Rational[2, 9] Pi]}, {(-5) 
         Cos[Rational[2, 9] Pi], 5 Sin[Rational[2, 9] Pi]}}, {{-
         Cos[Rational[7, 36] Pi], Sin[Rational[7, 36] Pi]}, {(-5) 
         Cos[Rational[7, 36] Pi], 5 Sin[Rational[7, 36] Pi]}}, {{-
         Cos[Rational[5, 36] Pi], Sin[Rational[5, 36] Pi]}, {(-5) 
         Cos[Rational[5, 36] Pi], 5 Sin[Rational[5, 36] Pi]}}, {{-
         Cos[Rational[1, 9] Pi], Sin[Rational[1, 9] Pi]}, {(-5) 
         Cos[Rational[1, 9] Pi], 5 Sin[Rational[1, 9] Pi]}}, {{-
         Cos[Rational[1, 18] Pi], Sin[Rational[1, 18] Pi]}, {(-5) 
         Cos[Rational[1, 18] Pi], 5 Sin[Rational[1, 18] Pi]}}, {{-
         Cos[Rational[1, 36] Pi], Sin[Rational[1, 36] Pi]}, {(-5) 
         Cos[Rational[1, 36] Pi], 5 Sin[Rational[1, 36] Pi]}}, {{-
         Cos[Rational[1, 36] Pi], -Sin[Rational[1, 36] Pi]}, {(-5) 
         Cos[Rational[1, 36] Pi], (-5) Sin[Rational[1, 36] Pi]}}, {{-
         Cos[Rational[1, 18] Pi], -Sin[Rational[1, 18] Pi]}, {(-5) 
         Cos[Rational[1, 18] Pi], (-5) Sin[Rational[1, 18] Pi]}}, {{-
         Cos[Rational[1, 9] Pi], -Sin[Rational[1, 9] Pi]}, {(-5) 
         Cos[Rational[1, 9] Pi], (-5) Sin[Rational[1, 9] Pi]}}, {{-
         Cos[Rational[5, 36] Pi], -Sin[Rational[5, 36] Pi]}, {(-5) 
         Cos[Rational[5, 36] Pi], (-5) Sin[Rational[5, 36] Pi]}}, {{-
         Cos[Rational[7, 36] Pi], -Sin[Rational[7, 36] Pi]}, {(-5) 
         Cos[Rational[7, 36] Pi], (-5) Sin[Rational[7, 36] Pi]}}, {{-
         Cos[Rational[2, 9] Pi], -Sin[Rational[2, 9] Pi]}, {(-5) 
         Cos[Rational[2, 9] Pi], (-5) Sin[Rational[2, 9] Pi]}}, {{-
         Sin[Rational[2, 9] Pi], -Cos[Rational[2, 9] Pi]}, {(-5) 
         Sin[Rational[2, 9] Pi], (-5) Cos[Rational[2, 9] Pi]}}, {{-
         Sin[Rational[7, 36] Pi], -Cos[Rational[7, 36] Pi]}, {(-5) 
         Sin[Rational[7, 36] Pi], (-5) Cos[Rational[7, 36] Pi]}}, {{-
         Sin[Rational[5, 36] Pi], -Cos[Rational[5, 36] Pi]}, {(-5) 
         Sin[Rational[5, 36] Pi], (-5) Cos[Rational[5, 36] Pi]}}, {{-
         Sin[Rational[1, 9] Pi], -Cos[Rational[1, 9] Pi]}, {(-5) 
         Sin[Rational[1, 9] Pi], (-5) Cos[Rational[1, 9] Pi]}}, {{-
         Sin[Rational[1, 18] Pi], -Cos[Rational[1, 18] Pi]}, {(-5) 
         Sin[Rational[1, 18] Pi], (-5) Cos[Rational[1, 18] Pi]}}, {{-
         Sin[Rational[1, 36] Pi], -Cos[Rational[1, 36] Pi]}, {(-5) 
         Sin[Rational[1, 36] Pi], (-5) Cos[Rational[1, 36] Pi]}}, {{
        Sin[Rational[1, 36] Pi], -Cos[Rational[1, 36] Pi]}, {
        5 Sin[Rational[1, 36] Pi], (-5) Cos[Rational[1, 36] Pi]}}, {{
        Sin[Rational[1, 18] Pi], -Cos[Rational[1, 18] Pi]}, {
        5 Sin[Rational[1, 18] Pi], (-5) Cos[Rational[1, 18] Pi]}}, {{
        Sin[Rational[1, 9] Pi], -Cos[Rational[1, 9] Pi]}, {
        5 Sin[Rational[1, 9] Pi], (-5) Cos[Rational[1, 9] Pi]}}, {{
        Sin[Rational[5, 36] Pi], -Cos[Rational[5, 36] Pi]}, {
        5 Sin[Rational[5, 36] Pi], (-5) Cos[Rational[5, 36] Pi]}}, {{
        Sin[Rational[7, 36] Pi], -Cos[Rational[7, 36] Pi]}, {
        5 Sin[Rational[7, 36] Pi], (-5) Cos[Rational[7, 36] Pi]}}, {{
        Sin[Rational[2, 9] Pi], -Cos[Rational[2, 9] Pi]}, {
        5 Sin[Rational[2, 9] Pi], (-5) Cos[Rational[2, 9] Pi]}}, {{
        Cos[Rational[2, 9] Pi], -Sin[Rational[2, 9] Pi]}, {
        5 Cos[Rational[2, 9] Pi], (-5) Sin[Rational[2, 9] Pi]}}, {{
        Cos[Rational[7, 36] Pi], -Sin[Rational[7, 36] Pi]}, {
        5 Cos[Rational[7, 36] Pi], (-5) Sin[Rational[7, 36] Pi]}}, {{
        Cos[Rational[5, 36] Pi], -Sin[Rational[5, 36] Pi]}, {
        5 Cos[Rational[5, 36] Pi], (-5) Sin[Rational[5, 36] Pi]}}, {{
        Cos[Rational[1, 9] Pi], -Sin[Rational[1, 9] Pi]}, {
        5 Cos[Rational[1, 9] Pi], (-5) Sin[Rational[1, 9] Pi]}}, {{
        Cos[Rational[1, 18] Pi], -Sin[Rational[1, 18] Pi]}, {
        5 Cos[Rational[1, 18] Pi], (-5) Sin[Rational[1, 18] Pi]}}, {{
        Cos[Rational[1, 36] Pi], -Sin[Rational[1, 36] Pi]}, {
        5 Cos[Rational[1, 36] Pi], (-5) 
         Sin[Rational[1, 36] Pi]}}}, CompressedData["
1:eJxdVD1IlVEY/lAIQpNS/EGvoFBtF0TCiyKcg4uKg5fblDkJKljgoFCCCHoT
SeWKToEN+UM46FCEOUTPi4MECgaiDS6igVqpVFRCSw3nWZ7hW845vN/z9z6V
Hb2pzuwoiqr+f1nhmy8sebNzcOGyhtfX9lpX3ei1qeSTbwW+ofJn19bRviuO
DU9OpC/c076codK6DZd59TGReF3gHyQz5XMfvrpYPNXw+8a5+5Uz3r90tOuq
2/tOazfz/Y/M8vRM+1/X/SleNRCdubvPEo/iufvuxcvY+5aKfH8HIz3PjyPf
OFZ4b6jmi3vcPHj5ru3QTfav/MnruO737s/WPPx+xdclt+d70ycuVlSfejv9
2TXdTE+0LOb5hbLN27dWr3qe8x3P+Y5z+R/O5X+IiziJizjJizzJizypC3Wi
LtSJulJn6kqdwz3kHrwP8yHzwfkBHwQfiC/wg/Az8gv6QPQx6hP0hehr1Dec
Q/wx+hDmQvw1+hBwQfJh9CHwguTL6EPQBZJPow9BV0i+jT7IPeQeMh8yH4IP
gg/CD8LPRB+IPib6QvQ18Qfij4m/EH9N8gHJh0m+IPkyyScknyb5huTbZD8g
+2GyX5D9MtlPyH6a7Ddkv036AdIPJv0C6ReTfoL0k0m/QfrNpB8h/WjSr5B+
hfQzpJ8h/Q7pd/wDwMPg7w==
      "]]]}, 
   {Thickness[Small], Dashing[{}], {InsetBox[
      TagBox[GridBox[{
         {
          StyleBox["\<\"0\"\>",
           StripOnInput->False,
           LineColor->GrayLevel[0.2],
           FrontFaceColor->GrayLevel[0.2],
           BackFaceColor->GrayLevel[0.2],
           GraphicsColor->GrayLevel[0.2],
           FontSize->10,
           FontSlant->Italic,
           FontColor->GrayLevel[0.2]]},
         {
          StyleBox["\<\"360\"\>",
           StripOnInput->False,
           LineColor->GrayLevel[0.2],
           FrontFaceColor->GrayLevel[0.2],
           BackFaceColor->GrayLevel[0.2],
           GraphicsColor->GrayLevel[0.2],
           FontSize->10,
           FontSlant->Italic,
           FontColor->GrayLevel[0.2]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Column"], {5, 0}, NCache[{-2., Rational[1, 5]}, {-2., 0.2}]], InsetBox[
      StyleBox["15",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{(Rational[5, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2]), (
         Rational[5, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}, {
       4.829629131445341, 
       1.2940952255126035`}], {-1.9318516525781364`, -0.5176380902050414}], 
     InsetBox[
      StyleBox["30",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{Rational[5, 2] 3^Rational[1, 2], Rational[5, 2]}, {
       4.330127018922193, 2.5}], {-1.7320508075688772`, -1.}], InsetBox[
      StyleBox["45",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{5 2^Rational[-1, 2], 5 2^Rational[-1, 2]}, {3.5355339059327373`,
        3.5355339059327373`}], {-1.414213562373095, -1.414213562373095}], 
     InsetBox[
      StyleBox["60",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{Rational[5, 2], Rational[5, 2] 3^Rational[1, 2]}, {2.5, 
       4.330127018922193}], {-1., -1.7320508075688772`}], InsetBox[
      StyleBox["75",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{(Rational[5, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2]), (
         Rational[5, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {
       1.2940952255126035`, 
       4.829629131445341}], {-0.5176380902050414, -1.9318516525781364`}], 
     InsetBox[
      StyleBox["90",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], {0, 5}, {0, -2.}], InsetBox[
      StyleBox["105",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{(Rational[-5, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2]), (
         Rational[5, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2])}, {-1.2940952255126035`, 
       4.829629131445341}], {0.5176380902050414, -1.9318516525781364`}], 
     InsetBox[
      StyleBox["120",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{Rational[-5, 2], Rational[5, 2] 3^Rational[1, 2]}, {-2.5, 
       4.330127018922193}], {1., -1.7320508075688772`}], InsetBox[
      StyleBox["135",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{(-5) 2^Rational[-1, 2], 5 
        2^Rational[-1, 2]}, {-3.5355339059327373`, 
       3.5355339059327373`}], {1.414213562373095, -1.414213562373095}], 
     InsetBox[
      StyleBox["150",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{Rational[-5, 2] 3^Rational[1, 2], Rational[
        5, 2]}, {-4.330127018922193, 2.5}], {1.7320508075688772`, -1.}], 
     InsetBox[
      StyleBox["165",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{(Rational[-5, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2]), (
         Rational[5, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}, {-4.829629131445341, 
       1.2940952255126035`}], {1.9318516525781364`, -0.5176380902050414}], 
     InsetBox[
      StyleBox["180",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], {-5, 0}, {2., 0}], InsetBox[
      StyleBox["195",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{(Rational[-5, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2]), (
         Rational[-5, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[
           1, 2])}, {-4.829629131445341, -1.2940952255126035`}], \
{1.9318516525781364`, 0.5176380902050414}], InsetBox[
      StyleBox["210",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{Rational[-5, 2] 3^Rational[1, 2], 
        Rational[-5, 
         2]}, {-4.330127018922193, -2.5}], {1.7320508075688772`, 1.}], 
     InsetBox[
      StyleBox["225",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{(-5) 2^Rational[-1, 2], (-5) 
        2^Rational[-1, 
           2]}, {-3.5355339059327373`, -3.5355339059327373`}], \
{1.414213562373095, 1.414213562373095}], InsetBox[
      StyleBox["240",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{Rational[-5, 2], Rational[-5, 2] 
        3^Rational[
          1, 2]}, {-2.5, -4.330127018922193}], {1., 1.7320508075688772`}], 
     InsetBox[
      StyleBox["255",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{(Rational[-5, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2]), (
         Rational[-5, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[
           1, 2])}, {-1.2940952255126035`, -4.829629131445341}], \
{0.5176380902050414, 1.9318516525781364`}], InsetBox[
      StyleBox["270",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], {0, -5}, {0, 2.}], InsetBox[
      StyleBox["285",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{(Rational[5, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2]), (
         Rational[-5, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {
       1.2940952255126035`, -4.829629131445341}], \
{-0.5176380902050414, 1.9318516525781364`}], InsetBox[
      StyleBox["300",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{Rational[5, 2], Rational[-5, 2] 3^Rational[1, 2]}, {
       2.5, -4.330127018922193}], {-1., 1.7320508075688772`}], InsetBox[
      StyleBox["315",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{5 2^Rational[-1, 2], (-5) 2^Rational[-1, 2]}, {
       3.5355339059327373`, -3.5355339059327373`}], \
{-1.414213562373095, 1.414213562373095}], InsetBox[
      StyleBox["330",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{Rational[5, 2] 3^Rational[1, 2], Rational[-5, 2]}, {
       4.330127018922193, -2.5}], {-1.7320508075688772`, 1.}], InsetBox[
      StyleBox["345",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      NCache[{(Rational[5, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2]), (
         Rational[-5, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}, {
       4.829629131445341, -1.2940952255126035`}], \
{-1.9318516525781364`, 0.5176380902050414}]}, {InsetBox[
      StyleBox["1",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {1, 0}]], InsetBox[
      StyleBox["2",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {2, 0}]], InsetBox[
      StyleBox["3",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {3, 0}]], InsetBox[
      StyleBox["4",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {4, 0}]], InsetBox[
      StyleBox["5",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {5, 0}]]}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->False,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 351},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->44859106]
}, Open  ]],

Cell["Using radians for the angles.", "ExampleText",
 CellID->2084766621],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PolarPlotGrid", "[", 
  RowBox[{"4", ",", "\"\<Radians\>\""}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->329414695],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.2472, 0.24, 0.6], Thickness[
   Tiny], {CircleBox[{0, 0}], CircleBox[{0, 0}, 2], CircleBox[{0, 0}, 3], 
    CircleBox[{0, 0}, 4]}, 
   LineBox[NCache[{{{-4, 0}, {4, 
      0}}, {{(-2) 3^Rational[1, 2], -2}, {
       2 3^Rational[1, 2], 2}}, {{-2, (-2) 3^Rational[1, 2]}, {
       2, 2 3^Rational[1, 2]}}, {{0, -4}, {0, 
      4}}, {{2, (-2) 3^Rational[1, 2]}, {-2, 2 3^Rational[1, 2]}}, {{
       2 3^Rational[1, 2], -2}, {(-2) 3^Rational[1, 2], 2}}}, {{{-4, 0}, {4, 
      0}}, {{-3.4641016151377544`, -2}, {
       3.4641016151377544`, 2}}, {{-2, -3.4641016151377544`}, {
       2, 3.4641016151377544`}}, {{0, -4}, {0, 
      4}}, {{2, -3.4641016151377544`}, {-2, 3.4641016151377544`}}, {{
       3.4641016151377544`, -2}, {-3.4641016151377544`, 2}}}]], 
   LineBox[NCache[{{{(Rational[1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}, {
       2^Rational[1, 2] (1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (-1 + 3^Rational[1, 2])}}, {{
       2^Rational[-1, 2], 2^Rational[-1, 2]}, {
       2 2^Rational[1, 2], 2 
        2^Rational[1, 2]}}, {{(Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2])}, {
       2^Rational[1, 2] (-1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (1 + 3^Rational[1, 2])}}, {{(Rational[-1, 2] 
         2^Rational[-1, 2]) (-1 + 3^Rational[1, 2]), (Rational[1, 2] 
         2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {(-2^Rational[1, 2]) (-1 + 
         3^Rational[1, 2]), 
        2^Rational[1, 2] (1 + 3^Rational[1, 2])}}, {{-2^Rational[-1, 2], 2^
        Rational[-1, 2]}, {(-2) 2^Rational[1, 2], 2 
        2^Rational[1, 2]}}, {{(Rational[-1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}, {(-2^Rational[1, 2]) (1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (-1 + 3^Rational[1, 2])}}, {{(Rational[-1, 2] 
         2^Rational[-1, 2]) (1 + 3^Rational[1, 2]), (Rational[-1, 2] 
         2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}, {(-2^Rational[1, 2]) (1 + 
         3^Rational[1, 2]), (-2^Rational[1, 2]) (-1 + 
         3^Rational[1, 2])}}, {{-2^Rational[-1, 2], -2^Rational[-1, 2]}, {(-2)
          2^Rational[1, 2], (-2) 
        2^Rational[1, 2]}}, {{(Rational[-1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2]), (Rational[-1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2])}, {(-2^Rational[1, 2]) (-1 + 
         3^Rational[1, 2]), (-2^Rational[1, 2]) (1 + 3^Rational[1, 2])}}, {{(
         Rational[1, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2]), (
         Rational[-1, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {
       2^Rational[1, 2] (-1 + 3^Rational[1, 2]), (-2^Rational[1, 2]) (1 + 
         3^Rational[1, 2])}}, {{2^Rational[-1, 2], -2^Rational[-1, 2]}, {
       2 2^Rational[1, 2], (-2) 
        2^Rational[1, 2]}}, {{(Rational[1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[-1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}, {
       2^Rational[1, 2] (1 + 3^Rational[1, 2]), (-2^Rational[1, 2]) (-1 + 
         3^Rational[1, 2])}}}, CompressedData["
1:eJxTTMoPSmVmYGDgAWImKBbZ7+F+98U7+362yQdrJ1ywFwXz+RwmgPkf7M9Y
16fNW/AMTp8F02wOMBqmD2YOTB/MHKj8fjT5/TB5qLn70cw/ADMfqm8/mvsO
wOxBk9+PJr8fzfz9aOYfQHPffjT3HUDz3340/x1AC5/9aOFzAC1896OF734A
U8jLZQ==
     "]]], 
   {Thickness[Small], Dashing[{0, Small}], 
    LineBox[NCache[{{{Cos[Rational[1, 36] Pi], Sin[Rational[1, 36] Pi]}, {
        4 Cos[Rational[1, 36] Pi], 4 Sin[Rational[1, 36] Pi]}}, {{
        Cos[Rational[1, 18] Pi], Sin[Rational[1, 18] Pi]}, {
        4 Cos[Rational[1, 18] Pi], 4 Sin[Rational[1, 18] Pi]}}, {{
        Cos[Rational[1, 9] Pi], Sin[Rational[1, 9] Pi]}, {
        4 Cos[Rational[1, 9] Pi], 4 Sin[Rational[1, 9] Pi]}}, {{
        Cos[Rational[5, 36] Pi], Sin[Rational[5, 36] Pi]}, {
        4 Cos[Rational[5, 36] Pi], 4 Sin[Rational[5, 36] Pi]}}, {{
        Cos[Rational[7, 36] Pi], Sin[Rational[7, 36] Pi]}, {
        4 Cos[Rational[7, 36] Pi], 4 Sin[Rational[7, 36] Pi]}}, {{
        Cos[Rational[2, 9] Pi], Sin[Rational[2, 9] Pi]}, {
        4 Cos[Rational[2, 9] Pi], 4 Sin[Rational[2, 9] Pi]}}, {{
        Sin[Rational[2, 9] Pi], Cos[Rational[2, 9] Pi]}, {
        4 Sin[Rational[2, 9] Pi], 4 Cos[Rational[2, 9] Pi]}}, {{
        Sin[Rational[7, 36] Pi], Cos[Rational[7, 36] Pi]}, {
        4 Sin[Rational[7, 36] Pi], 4 Cos[Rational[7, 36] Pi]}}, {{
        Sin[Rational[5, 36] Pi], Cos[Rational[5, 36] Pi]}, {
        4 Sin[Rational[5, 36] Pi], 4 Cos[Rational[5, 36] Pi]}}, {{
        Sin[Rational[1, 9] Pi], Cos[Rational[1, 9] Pi]}, {
        4 Sin[Rational[1, 9] Pi], 4 Cos[Rational[1, 9] Pi]}}, {{
        Sin[Rational[1, 18] Pi], Cos[Rational[1, 18] Pi]}, {
        4 Sin[Rational[1, 18] Pi], 4 Cos[Rational[1, 18] Pi]}}, {{
        Sin[Rational[1, 36] Pi], Cos[Rational[1, 36] Pi]}, {
        4 Sin[Rational[1, 36] Pi], 4 Cos[Rational[1, 36] Pi]}}, {{-
         Sin[Rational[1, 36] Pi], Cos[Rational[1, 36] Pi]}, {(-4) 
         Sin[Rational[1, 36] Pi], 4 Cos[Rational[1, 36] Pi]}}, {{-
         Sin[Rational[1, 18] Pi], Cos[Rational[1, 18] Pi]}, {(-4) 
         Sin[Rational[1, 18] Pi], 4 Cos[Rational[1, 18] Pi]}}, {{-
         Sin[Rational[1, 9] Pi], Cos[Rational[1, 9] Pi]}, {(-4) 
         Sin[Rational[1, 9] Pi], 4 Cos[Rational[1, 9] Pi]}}, {{-
         Sin[Rational[5, 36] Pi], Cos[Rational[5, 36] Pi]}, {(-4) 
         Sin[Rational[5, 36] Pi], 4 Cos[Rational[5, 36] Pi]}}, {{-
         Sin[Rational[7, 36] Pi], Cos[Rational[7, 36] Pi]}, {(-4) 
         Sin[Rational[7, 36] Pi], 4 Cos[Rational[7, 36] Pi]}}, {{-
         Sin[Rational[2, 9] Pi], Cos[Rational[2, 9] Pi]}, {(-4) 
         Sin[Rational[2, 9] Pi], 4 Cos[Rational[2, 9] Pi]}}, {{-
         Cos[Rational[2, 9] Pi], Sin[Rational[2, 9] Pi]}, {(-4) 
         Cos[Rational[2, 9] Pi], 4 Sin[Rational[2, 9] Pi]}}, {{-
         Cos[Rational[7, 36] Pi], Sin[Rational[7, 36] Pi]}, {(-4) 
         Cos[Rational[7, 36] Pi], 4 Sin[Rational[7, 36] Pi]}}, {{-
         Cos[Rational[5, 36] Pi], Sin[Rational[5, 36] Pi]}, {(-4) 
         Cos[Rational[5, 36] Pi], 4 Sin[Rational[5, 36] Pi]}}, {{-
         Cos[Rational[1, 9] Pi], Sin[Rational[1, 9] Pi]}, {(-4) 
         Cos[Rational[1, 9] Pi], 4 Sin[Rational[1, 9] Pi]}}, {{-
         Cos[Rational[1, 18] Pi], Sin[Rational[1, 18] Pi]}, {(-4) 
         Cos[Rational[1, 18] Pi], 4 Sin[Rational[1, 18] Pi]}}, {{-
         Cos[Rational[1, 36] Pi], Sin[Rational[1, 36] Pi]}, {(-4) 
         Cos[Rational[1, 36] Pi], 4 Sin[Rational[1, 36] Pi]}}, {{-
         Cos[Rational[1, 36] Pi], -Sin[Rational[1, 36] Pi]}, {(-4) 
         Cos[Rational[1, 36] Pi], (-4) Sin[Rational[1, 36] Pi]}}, {{-
         Cos[Rational[1, 18] Pi], -Sin[Rational[1, 18] Pi]}, {(-4) 
         Cos[Rational[1, 18] Pi], (-4) Sin[Rational[1, 18] Pi]}}, {{-
         Cos[Rational[1, 9] Pi], -Sin[Rational[1, 9] Pi]}, {(-4) 
         Cos[Rational[1, 9] Pi], (-4) Sin[Rational[1, 9] Pi]}}, {{-
         Cos[Rational[5, 36] Pi], -Sin[Rational[5, 36] Pi]}, {(-4) 
         Cos[Rational[5, 36] Pi], (-4) Sin[Rational[5, 36] Pi]}}, {{-
         Cos[Rational[7, 36] Pi], -Sin[Rational[7, 36] Pi]}, {(-4) 
         Cos[Rational[7, 36] Pi], (-4) Sin[Rational[7, 36] Pi]}}, {{-
         Cos[Rational[2, 9] Pi], -Sin[Rational[2, 9] Pi]}, {(-4) 
         Cos[Rational[2, 9] Pi], (-4) Sin[Rational[2, 9] Pi]}}, {{-
         Sin[Rational[2, 9] Pi], -Cos[Rational[2, 9] Pi]}, {(-4) 
         Sin[Rational[2, 9] Pi], (-4) Cos[Rational[2, 9] Pi]}}, {{-
         Sin[Rational[7, 36] Pi], -Cos[Rational[7, 36] Pi]}, {(-4) 
         Sin[Rational[7, 36] Pi], (-4) Cos[Rational[7, 36] Pi]}}, {{-
         Sin[Rational[5, 36] Pi], -Cos[Rational[5, 36] Pi]}, {(-4) 
         Sin[Rational[5, 36] Pi], (-4) Cos[Rational[5, 36] Pi]}}, {{-
         Sin[Rational[1, 9] Pi], -Cos[Rational[1, 9] Pi]}, {(-4) 
         Sin[Rational[1, 9] Pi], (-4) Cos[Rational[1, 9] Pi]}}, {{-
         Sin[Rational[1, 18] Pi], -Cos[Rational[1, 18] Pi]}, {(-4) 
         Sin[Rational[1, 18] Pi], (-4) Cos[Rational[1, 18] Pi]}}, {{-
         Sin[Rational[1, 36] Pi], -Cos[Rational[1, 36] Pi]}, {(-4) 
         Sin[Rational[1, 36] Pi], (-4) Cos[Rational[1, 36] Pi]}}, {{
        Sin[Rational[1, 36] Pi], -Cos[Rational[1, 36] Pi]}, {
        4 Sin[Rational[1, 36] Pi], (-4) Cos[Rational[1, 36] Pi]}}, {{
        Sin[Rational[1, 18] Pi], -Cos[Rational[1, 18] Pi]}, {
        4 Sin[Rational[1, 18] Pi], (-4) Cos[Rational[1, 18] Pi]}}, {{
        Sin[Rational[1, 9] Pi], -Cos[Rational[1, 9] Pi]}, {
        4 Sin[Rational[1, 9] Pi], (-4) Cos[Rational[1, 9] Pi]}}, {{
        Sin[Rational[5, 36] Pi], -Cos[Rational[5, 36] Pi]}, {
        4 Sin[Rational[5, 36] Pi], (-4) Cos[Rational[5, 36] Pi]}}, {{
        Sin[Rational[7, 36] Pi], -Cos[Rational[7, 36] Pi]}, {
        4 Sin[Rational[7, 36] Pi], (-4) Cos[Rational[7, 36] Pi]}}, {{
        Sin[Rational[2, 9] Pi], -Cos[Rational[2, 9] Pi]}, {
        4 Sin[Rational[2, 9] Pi], (-4) Cos[Rational[2, 9] Pi]}}, {{
        Cos[Rational[2, 9] Pi], -Sin[Rational[2, 9] Pi]}, {
        4 Cos[Rational[2, 9] Pi], (-4) Sin[Rational[2, 9] Pi]}}, {{
        Cos[Rational[7, 36] Pi], -Sin[Rational[7, 36] Pi]}, {
        4 Cos[Rational[7, 36] Pi], (-4) Sin[Rational[7, 36] Pi]}}, {{
        Cos[Rational[5, 36] Pi], -Sin[Rational[5, 36] Pi]}, {
        4 Cos[Rational[5, 36] Pi], (-4) Sin[Rational[5, 36] Pi]}}, {{
        Cos[Rational[1, 9] Pi], -Sin[Rational[1, 9] Pi]}, {
        4 Cos[Rational[1, 9] Pi], (-4) Sin[Rational[1, 9] Pi]}}, {{
        Cos[Rational[1, 18] Pi], -Sin[Rational[1, 18] Pi]}, {
        4 Cos[Rational[1, 18] Pi], (-4) Sin[Rational[1, 18] Pi]}}, {{
        Cos[Rational[1, 36] Pi], -Sin[Rational[1, 36] Pi]}, {
        4 Cos[Rational[1, 36] Pi], (-4) 
         Sin[Rational[1, 36] Pi]}}}, CompressedData["
1:eJxdVD1LQ0EQfDxTiFGDRVQkjT8gkEohCHfYiJUhVloKYplCQQUJhBTiR2Nn
ncofINFCmMXC1kKMhY2oBBE0VURIo3C7D94Ur5h3x97uzOzMbtSqm0NRFJX+
v1i/Vn768uGl5+LG7XVnpe0CzvmAO26q0Dg9afbc0Xa2PlO+U5zzAXddoVhd
/Jn4dv3s8c7F26PicR9w3209FUv70ZdbPZ/fLY4+Kx7zAQ/c0mF+rT736faW
D35v1l8Vj/iAY1+u3LdqzQ9XmFyoXp29u4CHfcAZn/5v9zLe7qXr2juxt3fS
fVmfg6TP9Fw2Zz+ZM82L8dRNeErzajx3iOc26Bx2rvVB9WH1tT9Qf7D+dD7Q
fLD5lB8QP2L8KL8gfsX41f8gfcR00LogfcV00L5A/hDTQecC+UtMB+UF5E8x
HZRXkL8lrUNyDjoH1QfVB/UH6g80H2g+ED8gfoT4BfErpA9IHyF9QfoK+QPk
DyF/gfwl5E+QP4X8DfK30H6A9kNov0D7JbSfoP0U2m/QfgvlAygfhPIFlC9C
+QTKJ6F8A+WbUD6C8pH2OvGX5SvlQuJPy2fKlcTflu/4AzHstW8=
      "]]]}, 
   {Thickness[Small], Dashing[{}], {InsetBox[
      TagBox[GridBox[{
         {
          StyleBox["\<\"0\"\>",
           StripOnInput->False,
           FontSize->10]},
         {
          StyleBox["\<\"\\!\\(TraditionalForm\\`\\(2\\\\ \[Pi]\\)\\)\"\>",
           StripOnInput->False,
           LineColor->GrayLevel[0.2],
           FrontFaceColor->GrayLevel[0.2],
           BackFaceColor->GrayLevel[0.2],
           GraphicsColor->GrayLevel[0.2],
           FontSize->10,
           FontSlant->Italic,
           FontColor->GrayLevel[0.2]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Column"], {4, 0}, NCache[{-3.5, Rational[1, 5]}, {-3.5, 0.2}]], 
     InsetBox[
      StyleBox[
       FractionBox["\[Pi]", "12"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{0.04829629131445341, 0.012940952255126037`}, {
       2^Rational[1, 2] (1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (-1 + 3^Rational[1, 2])}]], InsetBox[
      StyleBox[
       FractionBox["\[Pi]", "6"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{0.04330127018922193, 0.025}, {2 3^Rational[1, 2], 2}]], InsetBox[
      StyleBox[
       FractionBox["\[Pi]", "4"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{0.035355339059327376`, 0.035355339059327376`}, {
       2 2^Rational[1, 2], 2 2^Rational[1, 2]}]], InsetBox[
      StyleBox[
       FractionBox["\[Pi]", "3"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{0.025, 0.04330127018922193}, {2, 2 3^Rational[1, 2]}]], InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "12"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{0.012940952255126037`, 0.04829629131445341}, {
       2^Rational[1, 2] (-1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (1 + 3^Rational[1, 2])}]], InsetBox[
      StyleBox[
       FractionBox["\[Pi]", "2"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], Scaled[{0, 0.05}, {0, 4}]], InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "12"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{-0.012940952255126037`, 
       0.04829629131445341}, {(-2^Rational[1, 2]) (-1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (1 + 3^Rational[1, 2])}]], InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"2", " ", "\[Pi]"}], "3"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{-0.025, 0.04330127018922193}, {-2, 2 3^Rational[1, 2]}]], 
     InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "4"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{-0.035355339059327376`, 
       0.035355339059327376`}, {(-2) 2^Rational[1, 2], 2 2^Rational[1, 2]}]], 
     InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "6"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{-0.04330127018922193, 0.025}, {(-2) 3^Rational[1, 2], 2}]], 
     InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"11", " ", "\[Pi]"}], "12"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{-0.04829629131445341, 
       0.012940952255126037`}, {(-2^Rational[1, 2]) (1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (-1 + 3^Rational[1, 2])}]], InsetBox[
      StyleBox["\[Pi]",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], Scaled[{-0.05, 0}, {-4, 0}]], InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"13", " ", "\[Pi]"}], "12"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{-0.04829629131445341, -0.012940952255126037`}, {(-2^
          Rational[1, 2]) (1 + 3^Rational[1, 2]), (-2^Rational[1, 2]) (-1 + 
         3^Rational[1, 2])}]], InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "6"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{-0.04330127018922193, -0.025}, {(-2) 3^Rational[1, 2], -2}]], 
     InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "4"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{-0.035355339059327376`, -0.035355339059327376`}, {(-2) 
        2^Rational[1, 2], (-2) 2^Rational[1, 2]}]], InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"4", " ", "\[Pi]"}], "3"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{-0.025, -0.04330127018922193}, {-2, (-2) 3^Rational[1, 2]}]], 
     InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"17", " ", "\[Pi]"}], "12"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{-0.012940952255126037`, -0.04829629131445341}, {(-2^
          Rational[1, 2]) (-1 + 3^Rational[1, 2]), (-2^Rational[1, 2]) (1 + 
         3^Rational[1, 2])}]], InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"3", " ", "\[Pi]"}], "2"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], Scaled[{0, -0.05}, {0, -4}]], InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"19", " ", "\[Pi]"}], "12"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{0.012940952255126037`, -0.04829629131445341}, {
       2^Rational[1, 2] (-1 + 3^Rational[1, 2]), (-2^Rational[1, 2]) (1 + 
         3^Rational[1, 2])}]], InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"5", " ", "\[Pi]"}], "3"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{0.025, -0.04330127018922193}, {2, (-2) 3^Rational[1, 2]}]], 
     InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"7", " ", "\[Pi]"}], "4"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{0.035355339059327376`, -0.035355339059327376`}, {
       2 2^Rational[1, 2], (-2) 2^Rational[1, 2]}]], InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"11", " ", "\[Pi]"}], "6"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{0.04330127018922193, -0.025}, {2 3^Rational[1, 2], -2}]], 
     InsetBox[
      StyleBox[
       FractionBox[
        RowBox[{"23", " ", "\[Pi]"}], "12"],
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], 
      Scaled[{0.04829629131445341, -0.012940952255126037`}, {
       2^Rational[1, 2] (1 + 3^Rational[1, 2]), (-2^Rational[1, 2]) (-1 + 
         3^Rational[1, 2])}]]}, 
    {GrayLevel[0.45], InsetBox[
      StyleBox["1",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {1, 0}]], InsetBox[
      StyleBox["2",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {2, 0}]], InsetBox[
      StyleBox["3",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {3, 0}]], InsetBox[
      StyleBox["4",
       StripOnInput->False,
       LineColor->GrayLevel[0.2],
       FrontFaceColor->GrayLevel[0.2],
       BackFaceColor->GrayLevel[0.2],
       GraphicsColor->GrayLevel[0.2],
       FontSize->10,
       FontSlant->Italic,
       FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {4, 0}]]}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->False,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 369},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->259936899]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(2)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1495629065],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "GridLinesStyle",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->741607320],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1674979948],

Cell["\<\
GridLinesStyle sets the style for the lines in the grid. There are two levels \
of styles, those with spacings of 15\[Degree] and a second set with spacings \
of 5\[Degree]. The options should be given as a list containing two Directive \
expressions.\
\>", "ExampleText",
 CellID->24857513],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PolarPlotGrid", "[", 
  RowBox[{"6", ",", "\"\<Degrees\>\"", ",", 
   RowBox[{"GridLinesStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Directive", "[", 
       RowBox[{"Red", ",", 
        RowBox[{"Thickness", "[", "Small", "]"}]}], "]"}], ",", 
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"Thickness", "[", "Medium", "]"}], ",", "Green", ",", 
        "Dotted"}], "]"}]}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1168393473],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[1, 0, 0], Thickness[
    Small], {CircleBox[{0, 0}], CircleBox[{0, 0}, 2], CircleBox[{0, 0}, 3], 
     CircleBox[{0, 0}, 4], CircleBox[{0, 0}, 5], CircleBox[{0, 0}, 6]}, 
    LineBox[NCache[{{{-6, 0}, {6, 
       0}}, {{(-3) 3^Rational[1, 2], -3}, {
        3 3^Rational[1, 2], 3}}, {{-3, (-3) 3^Rational[1, 2]}, {
        3, 3 3^Rational[1, 2]}}, {{0, -6}, {0, 
       6}}, {{3, (-3) 3^Rational[1, 2]}, {-3, 3 3^Rational[1, 2]}}, {{
        3 3^Rational[1, 2], -3}, {(-3) 3^Rational[1, 2], 3}}}, {{{-6, 0}, {6, 
       0}}, {{-5.196152422706632, -3}, {
        5.196152422706632, 3}}, {{-3, -5.196152422706632}, {
        3, 5.196152422706632}}, {{0, -6}, {0, 
       6}}, {{3, -5.196152422706632}, {-3, 5.196152422706632}}, {{
        5.196152422706632, -3}, {-5.196152422706632, 3}}}]], 
    LineBox[NCache[{{{(Rational[1, 2] 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2])}, {(3 2^Rational[-1, 2]) (1 + 3^Rational[1, 2]), (
          3 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}}, {{
        2^Rational[-1, 2], 2^Rational[-1, 2]}, {
        3 2^Rational[1, 2], 3 
         2^Rational[1, 2]}}, {{(Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2])}, {(3 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2]), (3 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2])}}, {{(Rational[-1, 2] 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2])}, {((-3) 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2]), (3 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2])}}, {{-2^Rational[-1, 2], 2^
         Rational[-1, 2]}, {(-3) 2^Rational[1, 2], 3 
         2^Rational[1, 2]}}, {{(Rational[-1, 2] 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2])}, {((-3) 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2]), (3 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2])}}, {{(Rational[-1, 2] 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2]), (Rational[-1, 2] 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2])}, {((-3) 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2]), ((-3) 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2])}}, {{-2^Rational[-1, 2], -2^
          Rational[-1, 2]}, {(-3) 2^Rational[1, 2], (-3) 
         2^Rational[1, 2]}}, {{(Rational[-1, 2] 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2]), (Rational[-1, 2] 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2])}, {((-3) 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2]), ((-3) 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2])}}, {{(Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2]), (Rational[-1, 2] 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2])}, {(3 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2]), ((-3) 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2])}}, {{2^Rational[-1, 2], -2^Rational[-1, 2]}, {
        3 2^Rational[1, 2], (-3) 
         2^Rational[1, 2]}}, {{(Rational[1, 2] 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2]), (Rational[-1, 2] 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2])}, {(3 2^Rational[-1, 2]) (1 + 
          3^Rational[1, 2]), ((-3) 2^Rational[-1, 2]) (-1 + 
          3^Rational[1, 2])}}}, CompressedData["
1:eJxTTMoPSmVmYGDgAWImKBbZ7+F+98U7+362yQdrJ1yw9+8v+7pUT9zhemfM
oj03ftifsa5Pm7fgGZy+lXP/TNkPAQcYDdMHMwemD2YOVH4/mvx+mDzU3P1o
5h+AmQ/Vtx/NfQdg9qDJ70eT349m/n408w+guW8/mvsOoPlvP5r/DqCFz360
8DmAFr770cJ3PwBjY91V
      "]]]}, 
   {RGBColor[0, 1, 0], Thickness[Medium], Dashing[{0, Small}], 
    LineBox[NCache[{{{Cos[Rational[1, 36] Pi], Sin[Rational[1, 36] Pi]}, {
        6 Cos[Rational[1, 36] Pi], 6 Sin[Rational[1, 36] Pi]}}, {{
        Cos[Rational[1, 18] Pi], Sin[Rational[1, 18] Pi]}, {
        6 Cos[Rational[1, 18] Pi], 6 Sin[Rational[1, 18] Pi]}}, {{
        Cos[Rational[1, 9] Pi], Sin[Rational[1, 9] Pi]}, {
        6 Cos[Rational[1, 9] Pi], 6 Sin[Rational[1, 9] Pi]}}, {{
        Cos[Rational[5, 36] Pi], Sin[Rational[5, 36] Pi]}, {
        6 Cos[Rational[5, 36] Pi], 6 Sin[Rational[5, 36] Pi]}}, {{
        Cos[Rational[7, 36] Pi], Sin[Rational[7, 36] Pi]}, {
        6 Cos[Rational[7, 36] Pi], 6 Sin[Rational[7, 36] Pi]}}, {{
        Cos[Rational[2, 9] Pi], Sin[Rational[2, 9] Pi]}, {
        6 Cos[Rational[2, 9] Pi], 6 Sin[Rational[2, 9] Pi]}}, {{
        Sin[Rational[2, 9] Pi], Cos[Rational[2, 9] Pi]}, {
        6 Sin[Rational[2, 9] Pi], 6 Cos[Rational[2, 9] Pi]}}, {{
        Sin[Rational[7, 36] Pi], Cos[Rational[7, 36] Pi]}, {
        6 Sin[Rational[7, 36] Pi], 6 Cos[Rational[7, 36] Pi]}}, {{
        Sin[Rational[5, 36] Pi], Cos[Rational[5, 36] Pi]}, {
        6 Sin[Rational[5, 36] Pi], 6 Cos[Rational[5, 36] Pi]}}, {{
        Sin[Rational[1, 9] Pi], Cos[Rational[1, 9] Pi]}, {
        6 Sin[Rational[1, 9] Pi], 6 Cos[Rational[1, 9] Pi]}}, {{
        Sin[Rational[1, 18] Pi], Cos[Rational[1, 18] Pi]}, {
        6 Sin[Rational[1, 18] Pi], 6 Cos[Rational[1, 18] Pi]}}, {{
        Sin[Rational[1, 36] Pi], Cos[Rational[1, 36] Pi]}, {
        6 Sin[Rational[1, 36] Pi], 6 Cos[Rational[1, 36] Pi]}}, {{-
         Sin[Rational[1, 36] Pi], Cos[Rational[1, 36] Pi]}, {(-6) 
         Sin[Rational[1, 36] Pi], 6 Cos[Rational[1, 36] Pi]}}, {{-
         Sin[Rational[1, 18] Pi], Cos[Rational[1, 18] Pi]}, {(-6) 
         Sin[Rational[1, 18] Pi], 6 Cos[Rational[1, 18] Pi]}}, {{-
         Sin[Rational[1, 9] Pi], Cos[Rational[1, 9] Pi]}, {(-6) 
         Sin[Rational[1, 9] Pi], 6 Cos[Rational[1, 9] Pi]}}, {{-
         Sin[Rational[5, 36] Pi], Cos[Rational[5, 36] Pi]}, {(-6) 
         Sin[Rational[5, 36] Pi], 6 Cos[Rational[5, 36] Pi]}}, {{-
         Sin[Rational[7, 36] Pi], Cos[Rational[7, 36] Pi]}, {(-6) 
         Sin[Rational[7, 36] Pi], 6 Cos[Rational[7, 36] Pi]}}, {{-
         Sin[Rational[2, 9] Pi], Cos[Rational[2, 9] Pi]}, {(-6) 
         Sin[Rational[2, 9] Pi], 6 Cos[Rational[2, 9] Pi]}}, {{-
         Cos[Rational[2, 9] Pi], Sin[Rational[2, 9] Pi]}, {(-6) 
         Cos[Rational[2, 9] Pi], 6 Sin[Rational[2, 9] Pi]}}, {{-
         Cos[Rational[7, 36] Pi], Sin[Rational[7, 36] Pi]}, {(-6) 
         Cos[Rational[7, 36] Pi], 6 Sin[Rational[7, 36] Pi]}}, {{-
         Cos[Rational[5, 36] Pi], Sin[Rational[5, 36] Pi]}, {(-6) 
         Cos[Rational[5, 36] Pi], 6 Sin[Rational[5, 36] Pi]}}, {{-
         Cos[Rational[1, 9] Pi], Sin[Rational[1, 9] Pi]}, {(-6) 
         Cos[Rational[1, 9] Pi], 6 Sin[Rational[1, 9] Pi]}}, {{-
         Cos[Rational[1, 18] Pi], Sin[Rational[1, 18] Pi]}, {(-6) 
         Cos[Rational[1, 18] Pi], 6 Sin[Rational[1, 18] Pi]}}, {{-
         Cos[Rational[1, 36] Pi], Sin[Rational[1, 36] Pi]}, {(-6) 
         Cos[Rational[1, 36] Pi], 6 Sin[Rational[1, 36] Pi]}}, {{-
         Cos[Rational[1, 36] Pi], -Sin[Rational[1, 36] Pi]}, {(-6) 
         Cos[Rational[1, 36] Pi], (-6) Sin[Rational[1, 36] Pi]}}, {{-
         Cos[Rational[1, 18] Pi], -Sin[Rational[1, 18] Pi]}, {(-6) 
         Cos[Rational[1, 18] Pi], (-6) Sin[Rational[1, 18] Pi]}}, {{-
         Cos[Rational[1, 9] Pi], -Sin[Rational[1, 9] Pi]}, {(-6) 
         Cos[Rational[1, 9] Pi], (-6) Sin[Rational[1, 9] Pi]}}, {{-
         Cos[Rational[5, 36] Pi], -Sin[Rational[5, 36] Pi]}, {(-6) 
         Cos[Rational[5, 36] Pi], (-6) Sin[Rational[5, 36] Pi]}}, {{-
         Cos[Rational[7, 36] Pi], -Sin[Rational[7, 36] Pi]}, {(-6) 
         Cos[Rational[7, 36] Pi], (-6) Sin[Rational[7, 36] Pi]}}, {{-
         Cos[Rational[2, 9] Pi], -Sin[Rational[2, 9] Pi]}, {(-6) 
         Cos[Rational[2, 9] Pi], (-6) Sin[Rational[2, 9] Pi]}}, {{-
         Sin[Rational[2, 9] Pi], -Cos[Rational[2, 9] Pi]}, {(-6) 
         Sin[Rational[2, 9] Pi], (-6) Cos[Rational[2, 9] Pi]}}, {{-
         Sin[Rational[7, 36] Pi], -Cos[Rational[7, 36] Pi]}, {(-6) 
         Sin[Rational[7, 36] Pi], (-6) Cos[Rational[7, 36] Pi]}}, {{-
         Sin[Rational[5, 36] Pi], -Cos[Rational[5, 36] Pi]}, {(-6) 
         Sin[Rational[5, 36] Pi], (-6) Cos[Rational[5, 36] Pi]}}, {{-
         Sin[Rational[1, 9] Pi], -Cos[Rational[1, 9] Pi]}, {(-6) 
         Sin[Rational[1, 9] Pi], (-6) Cos[Rational[1, 9] Pi]}}, {{-
         Sin[Rational[1, 18] Pi], -Cos[Rational[1, 18] Pi]}, {(-6) 
         Sin[Rational[1, 18] Pi], (-6) Cos[Rational[1, 18] Pi]}}, {{-
         Sin[Rational[1, 36] Pi], -Cos[Rational[1, 36] Pi]}, {(-6) 
         Sin[Rational[1, 36] Pi], (-6) Cos[Rational[1, 36] Pi]}}, {{
        Sin[Rational[1, 36] Pi], -Cos[Rational[1, 36] Pi]}, {
        6 Sin[Rational[1, 36] Pi], (-6) Cos[Rational[1, 36] Pi]}}, {{
        Sin[Rational[1, 18] Pi], -Cos[Rational[1, 18] Pi]}, {
        6 Sin[Rational[1, 18] Pi], (-6) Cos[Rational[1, 18] Pi]}}, {{
        Sin[Rational[1, 9] Pi], -Cos[Rational[1, 9] Pi]}, {
        6 Sin[Rational[1, 9] Pi], (-6) Cos[Rational[1, 9] Pi]}}, {{
        Sin[Rational[5, 36] Pi], -Cos[Rational[5, 36] Pi]}, {
        6 Sin[Rational[5, 36] Pi], (-6) Cos[Rational[5, 36] Pi]}}, {{
        Sin[Rational[7, 36] Pi], -Cos[Rational[7, 36] Pi]}, {
        6 Sin[Rational[7, 36] Pi], (-6) Cos[Rational[7, 36] Pi]}}, {{
        Sin[Rational[2, 9] Pi], -Cos[Rational[2, 9] Pi]}, {
        6 Sin[Rational[2, 9] Pi], (-6) Cos[Rational[2, 9] Pi]}}, {{
        Cos[Rational[2, 9] Pi], -Sin[Rational[2, 9] Pi]}, {
        6 Cos[Rational[2, 9] Pi], (-6) Sin[Rational[2, 9] Pi]}}, {{
        Cos[Rational[7, 36] Pi], -Sin[Rational[7, 36] Pi]}, {
        6 Cos[Rational[7, 36] Pi], (-6) Sin[Rational[7, 36] Pi]}}, {{
        Cos[Rational[5, 36] Pi], -Sin[Rational[5, 36] Pi]}, {
        6 Cos[Rational[5, 36] Pi], (-6) Sin[Rational[5, 36] Pi]}}, {{
        Cos[Rational[1, 9] Pi], -Sin[Rational[1, 9] Pi]}, {
        6 Cos[Rational[1, 9] Pi], (-6) Sin[Rational[1, 9] Pi]}}, {{
        Cos[Rational[1, 18] Pi], -Sin[Rational[1, 18] Pi]}, {
        6 Cos[Rational[1, 18] Pi], (-6) Sin[Rational[1, 18] Pi]}}, {{
        Cos[Rational[1, 36] Pi], -Sin[Rational[1, 36] Pi]}, {
        6 Cos[Rational[1, 36] Pi], (-6) 
         Sin[Rational[1, 36] Pi]}}}, CompressedData["
1:eJxdVD1oU1EYfVSnRsRWkqjJ0oCLGOhQWgjFe3GRTEo6iJk0IEUHO5hihFIo
GZq2ZqgFcRLMYsRJKSqx9XxkqKOCREGhRNuhFDQulUAXHe5ZzvCWey/fO3/f
GSnNFG4eiaJo9P83EL5G/NT6527PDSy03365/NrlTgx/eLKX9O3u6uCPd12X
TC88WKn23NLd2PyZ3JYb6lx/3mwk/bNHte21F39cOlu4+HfotzuILZebOx3X
ebr5slJP+H5t+ur725Gf/podvR/9clOPJ+5lj3139RuZ3aLF/YVXt05n8kf9
pcX4tfnxfVfJz/U3ij/d7NlP7e3mST92p1VO1WI+d+VjY6a659KJycKb1V13
fi7VWisN+3MjxcOH3457nvMdz/mOc/kfzuV/iIs4iYs4yYs8yYs8qQt1oi7U
ibpSZ+pKncM95B68D/Mh88H5AR8EnxFf4AfhZ+QX9IHoY9Qn6AvR16hvOIf4
Y/QhzIX4a/Qh4ILkw+hD4AXJl9GHoAskn0Yfgq6QfBt9kHvIPWQ+ZD4EHwSf
CT8IPxN9IPqY6AvR18QfiD8m/kL8NckHJB8m+YLkyySfkHya5BuSb5P9gOyH
yX5B9stkPyH7abLfkP026QdIP5j0C6RfTPoJ0k8m/QbpN5N+hPSjSb9C+tWk
nyH9DOl3SL/jH9M45Kc=
      "]]], 
    {Thickness[Small], Dashing[{}], {InsetBox[
       TagBox[GridBox[{
          {
           StyleBox["\<\"0\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[0.2],
            FrontFaceColor->GrayLevel[0.2],
            BackFaceColor->GrayLevel[0.2],
            GraphicsColor->GrayLevel[0.2],
            FontSize->10,
            FontSlant->Italic,
            FontColor->GrayLevel[0.2]]},
          {
           StyleBox["\<\"360\"\>",
            StripOnInput->False,
            LineColor->GrayLevel[0.2],
            FrontFaceColor->GrayLevel[0.2],
            BackFaceColor->GrayLevel[0.2],
            GraphicsColor->GrayLevel[0.2],
            FontSize->10,
            FontSlant->Italic,
            FontColor->GrayLevel[0.2]]}
         },
         GridBoxAlignment->{"Columns" -> {{Center}}},
         GridBoxItemSize->{
          "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
        "Column"], {6, 0}, NCache[{-2., Rational[1, 5]}, {-2., 0.2}]], 
      InsetBox[
       StyleBox["15",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{(3 2^Rational[-1, 2]) (1 + 3^Rational[1, 2]), (3 
          2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}, {5.795554957734409, 
        1.5529142706151242`}], {-1.9318516525781364`, -0.5176380902050414}], 
      InsetBox[
       StyleBox["30",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{3 3^Rational[1, 2], 3}, {
        5.196152422706632, 3}], {-1.7320508075688772`, -1.}], InsetBox[
       StyleBox["45",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{3 2^Rational[1, 2], 3 2^Rational[1, 2]}, {4.242640687119286, 
        4.242640687119286}], {-1.414213562373095, -1.414213562373095}], 
      InsetBox[
       StyleBox["60",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{3, 3 3^Rational[1, 2]}, {
        3, 5.196152422706632}], {-1., -1.7320508075688772`}], InsetBox[
       StyleBox["75",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{(3 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2]), (3 
          2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {1.5529142706151242`, 
        5.795554957734409}], {-0.5176380902050414, -1.9318516525781364`}], 
      InsetBox[
       StyleBox["90",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], {0, 6}, {0, -2.}], InsetBox[
       StyleBox["105",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{((-3) 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2]), (3 
          2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {-1.5529142706151242`, 
        5.795554957734409}], {0.5176380902050414, -1.9318516525781364`}], 
      InsetBox[
       StyleBox["120",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{-3, 3 3^Rational[1, 2]}, {-3, 
         5.196152422706632}], {1., -1.7320508075688772`}], InsetBox[
       StyleBox["135",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{(-3) 2^Rational[1, 2], 3 
         2^Rational[1, 2]}, {-4.242640687119286, 
        4.242640687119286}], {1.414213562373095, -1.414213562373095}], 
      InsetBox[
       StyleBox["150",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{(-3) 3^Rational[1, 2], 3}, {-5.196152422706632, 
         3}], {1.7320508075688772`, -1.}], InsetBox[
       StyleBox["165",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{((-3) 2^Rational[-1, 2]) (1 + 3^Rational[1, 2]), (3 
          2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}, {-5.795554957734409, 
        1.5529142706151242`}], {1.9318516525781364`, -0.5176380902050414}], 
      InsetBox[
       StyleBox["180",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], {-6, 0}, {2., 0}], InsetBox[
       StyleBox["195",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{((-3) 2^Rational[-1, 2]) (1 + 3^Rational[1, 2]), ((-3) 
          2^Rational[-1, 2]) (-1 + 
          3^Rational[
            1, 2])}, {-5.795554957734409, -1.5529142706151242`}], \
{1.9318516525781364`, 0.5176380902050414}], InsetBox[
       StyleBox["210",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{(-3) 
         3^Rational[
           1, 2], -3}, {-5.196152422706632, -3}], {1.7320508075688772`, 1.}], 
      InsetBox[
       StyleBox["225",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{(-3) 2^Rational[1, 2], (-3) 
         2^Rational[
           1, 2]}, {-4.242640687119286, -4.242640687119286}], \
{1.414213562373095, 1.414213562373095}], InsetBox[
       StyleBox["240",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{-3, (-3) 
         3^Rational[
           1, 2]}, {-3, -5.196152422706632}], {1., 1.7320508075688772`}], 
      InsetBox[
       StyleBox["255",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{((-3) 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2]), ((-3) 
          2^Rational[-1, 2]) (1 + 
          3^Rational[
            1, 2])}, {-1.5529142706151242`, -5.795554957734409}], \
{0.5176380902050414, 1.9318516525781364`}], InsetBox[
       StyleBox["270",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], {0, -6}, {0, 2.}], InsetBox[
       StyleBox["285",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{(3 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2]), ((-3) 
          2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {
        1.5529142706151242`, -5.795554957734409}], \
{-0.5176380902050414, 1.9318516525781364`}], InsetBox[
       StyleBox["300",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{3, (-3) 3^Rational[1, 2]}, {
        3, -5.196152422706632}], {-1., 1.7320508075688772`}], InsetBox[
       StyleBox["315",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{3 2^Rational[1, 2], (-3) 2^Rational[1, 2]}, {
        4.242640687119286, -4.242640687119286}], \
{-1.414213562373095, 1.414213562373095}], InsetBox[
       StyleBox["330",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{3 3^Rational[1, 2], -3}, {
        5.196152422706632, -3}], {-1.7320508075688772`, 1.}], InsetBox[
       StyleBox["345",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], 
       NCache[{(3 2^Rational[-1, 2]) (1 + 3^Rational[1, 2]), ((-3) 
          2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}, {
        5.795554957734409, -1.5529142706151242`}], \
{-1.9318516525781364`, 0.5176380902050414}]}, {InsetBox[
       StyleBox["1",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {1, 0}]], InsetBox[
       StyleBox["2",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {2, 0}]], InsetBox[
       StyleBox["3",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {3, 0}]], InsetBox[
       StyleBox["4",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {4, 0}]], InsetBox[
       StyleBox["5",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {5, 0}]], InsetBox[
       StyleBox["6",
        StripOnInput->False,
        LineColor->GrayLevel[0.2],
        FrontFaceColor->GrayLevel[0.2],
        BackFaceColor->GrayLevel[0.2],
        GraphicsColor->GrayLevel[0.2],
        FontSize->10,
        FontSlant->Italic,
        FontColor->GrayLevel[0.2]], Scaled[{-0.01, -0.015}, {6, 0}]]}}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->False,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 351},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1112992433]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "TicksStyle",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->199140052],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1454001512],

Cell["\<\
Ticks style sets the styles for the tick labels in the grid. Any option \
values used in Style will work.\
\>", "ExampleText",
 CellID->858541283],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PolarPlotGrid", "[", 
  RowBox[{"4", ",", "\"\<Degrees\>\"", ",", 
   RowBox[{"TicksStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"FontColor", "\[Rule]", " ", "Red"}], ",", "18"}], "]"}], ",", 
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"FontColor", "\[Rule]", " ", "Blue"}], ",", "14"}], "]"}]}], 
     "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->560719188],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[0.2472, 0.24, 0.6], Thickness[
   Tiny], {CircleBox[{0, 0}], CircleBox[{0, 0}, 2], CircleBox[{0, 0}, 3], 
    CircleBox[{0, 0}, 4]}, 
   LineBox[NCache[{{{-4, 0}, {4, 
      0}}, {{(-2) 3^Rational[1, 2], -2}, {
       2 3^Rational[1, 2], 2}}, {{-2, (-2) 3^Rational[1, 2]}, {
       2, 2 3^Rational[1, 2]}}, {{0, -4}, {0, 
      4}}, {{2, (-2) 3^Rational[1, 2]}, {-2, 2 3^Rational[1, 2]}}, {{
       2 3^Rational[1, 2], -2}, {(-2) 3^Rational[1, 2], 2}}}, {{{-4, 0}, {4, 
      0}}, {{-3.4641016151377544`, -2}, {
       3.4641016151377544`, 2}}, {{-2, -3.4641016151377544`}, {
       2, 3.4641016151377544`}}, {{0, -4}, {0, 
      4}}, {{2, -3.4641016151377544`}, {-2, 3.4641016151377544`}}, {{
       3.4641016151377544`, -2}, {-3.4641016151377544`, 2}}}]], 
   LineBox[NCache[{{{(Rational[1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}, {
       2^Rational[1, 2] (1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (-1 + 3^Rational[1, 2])}}, {{
       2^Rational[-1, 2], 2^Rational[-1, 2]}, {
       2 2^Rational[1, 2], 2 
        2^Rational[1, 2]}}, {{(Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2])}, {
       2^Rational[1, 2] (-1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (1 + 3^Rational[1, 2])}}, {{(Rational[-1, 2] 
         2^Rational[-1, 2]) (-1 + 3^Rational[1, 2]), (Rational[1, 2] 
         2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {(-2^Rational[1, 2]) (-1 + 
         3^Rational[1, 2]), 
        2^Rational[1, 2] (1 + 3^Rational[1, 2])}}, {{-2^Rational[-1, 2], 2^
        Rational[-1, 2]}, {(-2) 2^Rational[1, 2], 2 
        2^Rational[1, 2]}}, {{(Rational[-1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}, {(-2^Rational[1, 2]) (1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (-1 + 3^Rational[1, 2])}}, {{(Rational[-1, 2] 
         2^Rational[-1, 2]) (1 + 3^Rational[1, 2]), (Rational[-1, 2] 
         2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}, {(-2^Rational[1, 2]) (1 + 
         3^Rational[1, 2]), (-2^Rational[1, 2]) (-1 + 
         3^Rational[1, 2])}}, {{-2^Rational[-1, 2], -2^Rational[-1, 2]}, {(-2)
          2^Rational[1, 2], (-2) 
        2^Rational[1, 2]}}, {{(Rational[-1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2]), (Rational[-1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2])}, {(-2^Rational[1, 2]) (-1 + 
         3^Rational[1, 2]), (-2^Rational[1, 2]) (1 + 3^Rational[1, 2])}}, {{(
         Rational[1, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2]), (
         Rational[-1, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {
       2^Rational[1, 2] (-1 + 3^Rational[1, 2]), (-2^Rational[1, 2]) (1 + 
         3^Rational[1, 2])}}, {{2^Rational[-1, 2], -2^Rational[-1, 2]}, {
       2 2^Rational[1, 2], (-2) 
        2^Rational[1, 2]}}, {{(Rational[1, 2] 2^Rational[-1, 2]) (1 + 
         3^Rational[1, 2]), (Rational[-1, 2] 2^Rational[-1, 2]) (-1 + 
         3^Rational[1, 2])}, {
       2^Rational[1, 2] (1 + 3^Rational[1, 2]), (-2^Rational[1, 2]) (-1 + 
         3^Rational[1, 2])}}}, CompressedData["
1:eJxTTMoPSmVmYGDgAWImKBbZ7+F+98U7+362yQdrJ1ywFwXz+RwmgPkf7M9Y
16fNW/AMTp8F02wOMBqmD2YOTB/MHKj8fjT5/TB5qLn70cw/ADMfqm8/mvsO
wOxBk9+PJr8fzfz9aOYfQHPffjT3HUDz3340/x1AC5/9aOFzAC1896OF734A
U8jLZQ==
     "]]], 
   {Thickness[Small], Dashing[{0, Small}], 
    LineBox[NCache[{{{Cos[Rational[1, 36] Pi], Sin[Rational[1, 36] Pi]}, {
        4 Cos[Rational[1, 36] Pi], 4 Sin[Rational[1, 36] Pi]}}, {{
        Cos[Rational[1, 18] Pi], Sin[Rational[1, 18] Pi]}, {
        4 Cos[Rational[1, 18] Pi], 4 Sin[Rational[1, 18] Pi]}}, {{
        Cos[Rational[1, 9] Pi], Sin[Rational[1, 9] Pi]}, {
        4 Cos[Rational[1, 9] Pi], 4 Sin[Rational[1, 9] Pi]}}, {{
        Cos[Rational[5, 36] Pi], Sin[Rational[5, 36] Pi]}, {
        4 Cos[Rational[5, 36] Pi], 4 Sin[Rational[5, 36] Pi]}}, {{
        Cos[Rational[7, 36] Pi], Sin[Rational[7, 36] Pi]}, {
        4 Cos[Rational[7, 36] Pi], 4 Sin[Rational[7, 36] Pi]}}, {{
        Cos[Rational[2, 9] Pi], Sin[Rational[2, 9] Pi]}, {
        4 Cos[Rational[2, 9] Pi], 4 Sin[Rational[2, 9] Pi]}}, {{
        Sin[Rational[2, 9] Pi], Cos[Rational[2, 9] Pi]}, {
        4 Sin[Rational[2, 9] Pi], 4 Cos[Rational[2, 9] Pi]}}, {{
        Sin[Rational[7, 36] Pi], Cos[Rational[7, 36] Pi]}, {
        4 Sin[Rational[7, 36] Pi], 4 Cos[Rational[7, 36] Pi]}}, {{
        Sin[Rational[5, 36] Pi], Cos[Rational[5, 36] Pi]}, {
        4 Sin[Rational[5, 36] Pi], 4 Cos[Rational[5, 36] Pi]}}, {{
        Sin[Rational[1, 9] Pi], Cos[Rational[1, 9] Pi]}, {
        4 Sin[Rational[1, 9] Pi], 4 Cos[Rational[1, 9] Pi]}}, {{
        Sin[Rational[1, 18] Pi], Cos[Rational[1, 18] Pi]}, {
        4 Sin[Rational[1, 18] Pi], 4 Cos[Rational[1, 18] Pi]}}, {{
        Sin[Rational[1, 36] Pi], Cos[Rational[1, 36] Pi]}, {
        4 Sin[Rational[1, 36] Pi], 4 Cos[Rational[1, 36] Pi]}}, {{-
         Sin[Rational[1, 36] Pi], Cos[Rational[1, 36] Pi]}, {(-4) 
         Sin[Rational[1, 36] Pi], 4 Cos[Rational[1, 36] Pi]}}, {{-
         Sin[Rational[1, 18] Pi], Cos[Rational[1, 18] Pi]}, {(-4) 
         Sin[Rational[1, 18] Pi], 4 Cos[Rational[1, 18] Pi]}}, {{-
         Sin[Rational[1, 9] Pi], Cos[Rational[1, 9] Pi]}, {(-4) 
         Sin[Rational[1, 9] Pi], 4 Cos[Rational[1, 9] Pi]}}, {{-
         Sin[Rational[5, 36] Pi], Cos[Rational[5, 36] Pi]}, {(-4) 
         Sin[Rational[5, 36] Pi], 4 Cos[Rational[5, 36] Pi]}}, {{-
         Sin[Rational[7, 36] Pi], Cos[Rational[7, 36] Pi]}, {(-4) 
         Sin[Rational[7, 36] Pi], 4 Cos[Rational[7, 36] Pi]}}, {{-
         Sin[Rational[2, 9] Pi], Cos[Rational[2, 9] Pi]}, {(-4) 
         Sin[Rational[2, 9] Pi], 4 Cos[Rational[2, 9] Pi]}}, {{-
         Cos[Rational[2, 9] Pi], Sin[Rational[2, 9] Pi]}, {(-4) 
         Cos[Rational[2, 9] Pi], 4 Sin[Rational[2, 9] Pi]}}, {{-
         Cos[Rational[7, 36] Pi], Sin[Rational[7, 36] Pi]}, {(-4) 
         Cos[Rational[7, 36] Pi], 4 Sin[Rational[7, 36] Pi]}}, {{-
         Cos[Rational[5, 36] Pi], Sin[Rational[5, 36] Pi]}, {(-4) 
         Cos[Rational[5, 36] Pi], 4 Sin[Rational[5, 36] Pi]}}, {{-
         Cos[Rational[1, 9] Pi], Sin[Rational[1, 9] Pi]}, {(-4) 
         Cos[Rational[1, 9] Pi], 4 Sin[Rational[1, 9] Pi]}}, {{-
         Cos[Rational[1, 18] Pi], Sin[Rational[1, 18] Pi]}, {(-4) 
         Cos[Rational[1, 18] Pi], 4 Sin[Rational[1, 18] Pi]}}, {{-
         Cos[Rational[1, 36] Pi], Sin[Rational[1, 36] Pi]}, {(-4) 
         Cos[Rational[1, 36] Pi], 4 Sin[Rational[1, 36] Pi]}}, {{-
         Cos[Rational[1, 36] Pi], -Sin[Rational[1, 36] Pi]}, {(-4) 
         Cos[Rational[1, 36] Pi], (-4) Sin[Rational[1, 36] Pi]}}, {{-
         Cos[Rational[1, 18] Pi], -Sin[Rational[1, 18] Pi]}, {(-4) 
         Cos[Rational[1, 18] Pi], (-4) Sin[Rational[1, 18] Pi]}}, {{-
         Cos[Rational[1, 9] Pi], -Sin[Rational[1, 9] Pi]}, {(-4) 
         Cos[Rational[1, 9] Pi], (-4) Sin[Rational[1, 9] Pi]}}, {{-
         Cos[Rational[5, 36] Pi], -Sin[Rational[5, 36] Pi]}, {(-4) 
         Cos[Rational[5, 36] Pi], (-4) Sin[Rational[5, 36] Pi]}}, {{-
         Cos[Rational[7, 36] Pi], -Sin[Rational[7, 36] Pi]}, {(-4) 
         Cos[Rational[7, 36] Pi], (-4) Sin[Rational[7, 36] Pi]}}, {{-
         Cos[Rational[2, 9] Pi], -Sin[Rational[2, 9] Pi]}, {(-4) 
         Cos[Rational[2, 9] Pi], (-4) Sin[Rational[2, 9] Pi]}}, {{-
         Sin[Rational[2, 9] Pi], -Cos[Rational[2, 9] Pi]}, {(-4) 
         Sin[Rational[2, 9] Pi], (-4) Cos[Rational[2, 9] Pi]}}, {{-
         Sin[Rational[7, 36] Pi], -Cos[Rational[7, 36] Pi]}, {(-4) 
         Sin[Rational[7, 36] Pi], (-4) Cos[Rational[7, 36] Pi]}}, {{-
         Sin[Rational[5, 36] Pi], -Cos[Rational[5, 36] Pi]}, {(-4) 
         Sin[Rational[5, 36] Pi], (-4) Cos[Rational[5, 36] Pi]}}, {{-
         Sin[Rational[1, 9] Pi], -Cos[Rational[1, 9] Pi]}, {(-4) 
         Sin[Rational[1, 9] Pi], (-4) Cos[Rational[1, 9] Pi]}}, {{-
         Sin[Rational[1, 18] Pi], -Cos[Rational[1, 18] Pi]}, {(-4) 
         Sin[Rational[1, 18] Pi], (-4) Cos[Rational[1, 18] Pi]}}, {{-
         Sin[Rational[1, 36] Pi], -Cos[Rational[1, 36] Pi]}, {(-4) 
         Sin[Rational[1, 36] Pi], (-4) Cos[Rational[1, 36] Pi]}}, {{
        Sin[Rational[1, 36] Pi], -Cos[Rational[1, 36] Pi]}, {
        4 Sin[Rational[1, 36] Pi], (-4) Cos[Rational[1, 36] Pi]}}, {{
        Sin[Rational[1, 18] Pi], -Cos[Rational[1, 18] Pi]}, {
        4 Sin[Rational[1, 18] Pi], (-4) Cos[Rational[1, 18] Pi]}}, {{
        Sin[Rational[1, 9] Pi], -Cos[Rational[1, 9] Pi]}, {
        4 Sin[Rational[1, 9] Pi], (-4) Cos[Rational[1, 9] Pi]}}, {{
        Sin[Rational[5, 36] Pi], -Cos[Rational[5, 36] Pi]}, {
        4 Sin[Rational[5, 36] Pi], (-4) Cos[Rational[5, 36] Pi]}}, {{
        Sin[Rational[7, 36] Pi], -Cos[Rational[7, 36] Pi]}, {
        4 Sin[Rational[7, 36] Pi], (-4) Cos[Rational[7, 36] Pi]}}, {{
        Sin[Rational[2, 9] Pi], -Cos[Rational[2, 9] Pi]}, {
        4 Sin[Rational[2, 9] Pi], (-4) Cos[Rational[2, 9] Pi]}}, {{
        Cos[Rational[2, 9] Pi], -Sin[Rational[2, 9] Pi]}, {
        4 Cos[Rational[2, 9] Pi], (-4) Sin[Rational[2, 9] Pi]}}, {{
        Cos[Rational[7, 36] Pi], -Sin[Rational[7, 36] Pi]}, {
        4 Cos[Rational[7, 36] Pi], (-4) Sin[Rational[7, 36] Pi]}}, {{
        Cos[Rational[5, 36] Pi], -Sin[Rational[5, 36] Pi]}, {
        4 Cos[Rational[5, 36] Pi], (-4) Sin[Rational[5, 36] Pi]}}, {{
        Cos[Rational[1, 9] Pi], -Sin[Rational[1, 9] Pi]}, {
        4 Cos[Rational[1, 9] Pi], (-4) Sin[Rational[1, 9] Pi]}}, {{
        Cos[Rational[1, 18] Pi], -Sin[Rational[1, 18] Pi]}, {
        4 Cos[Rational[1, 18] Pi], (-4) Sin[Rational[1, 18] Pi]}}, {{
        Cos[Rational[1, 36] Pi], -Sin[Rational[1, 36] Pi]}, {
        4 Cos[Rational[1, 36] Pi], (-4) 
         Sin[Rational[1, 36] Pi]}}}, CompressedData["
1:eJxdVD1LQ0EQfDxTiFGDRVQkjT8gkEohCHfYiJUhVloKYplCQQUJhBTiR2Nn
ncofINFCmMXC1kKMhY2oBBE0VURIo3C7D94Ur5h3x97uzOzMbtSqm0NRFJX+
v1i/Vn768uGl5+LG7XVnpe0CzvmAO26q0Dg9afbc0Xa2PlO+U5zzAXddoVhd
/Jn4dv3s8c7F26PicR9w3209FUv70ZdbPZ/fLY4+Kx7zAQ/c0mF+rT736faW
D35v1l8Vj/iAY1+u3LdqzQ9XmFyoXp29u4CHfcAZn/5v9zLe7qXr2juxt3fS
fVmfg6TP9Fw2Zz+ZM82L8dRNeErzajx3iOc26Bx2rvVB9WH1tT9Qf7D+dD7Q
fLD5lB8QP2L8KL8gfsX41f8gfcR00LogfcV00L5A/hDTQecC+UtMB+UF5E8x
HZRXkL8lrUNyDjoH1QfVB/UH6g80H2g+ED8gfoT4BfErpA9IHyF9QfoK+QPk
DyF/gfwl5E+QP4X8DfK30H6A9kNov0D7JbSfoP0U2m/QfgvlAygfhPIFlC9C
+QTKJ6F8A+WbUD6C8pH2OvGX5SvlQuJPy2fKlcTflu/4AzHstW8=
      "]]]}, 
   {Thickness[Small], Dashing[{}], {InsetBox[
      TagBox[GridBox[{
         {
          StyleBox["\<\"0\"\>",
           StripOnInput->False,
           FontSize->18,
           FontColor->RGBColor[1, 0, 0]]},
         {
          StyleBox["\<\"360\"\>",
           StripOnInput->False,
           FontSize->18,
           FontColor->RGBColor[1, 0, 0]]}
        },
        GridBoxAlignment->{"Columns" -> {{Center}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Column"], {4, 0}, NCache[{-2., Rational[1, 5]}, {-2., 0.2}]], InsetBox[
      StyleBox["15",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{2^Rational[1, 2] (1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (-1 + 3^Rational[1, 2])}, {3.8637033051562732`, 
       1.035276180410083}], {-1.9318516525781364`, -0.5176380902050414}], 
     InsetBox[
      StyleBox["30",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{2 3^Rational[1, 2], 2}, {
       3.4641016151377544`, 2}], {-1.7320508075688772`, -1.}], InsetBox[
      StyleBox["45",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{2 2^Rational[1, 2], 2 2^Rational[1, 2]}, {2.8284271247461903`, 
       2.8284271247461903`}], {-1.414213562373095, -1.414213562373095}], 
     InsetBox[
      StyleBox["60",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{2, 2 3^Rational[1, 2]}, {
       2, 3.4641016151377544`}], {-1., -1.7320508075688772`}], InsetBox[
      StyleBox["75",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{2^Rational[1, 2] (-1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (1 + 3^Rational[1, 2])}, {1.035276180410083, 
       3.8637033051562732`}], {-0.5176380902050414, -1.9318516525781364`}], 
     InsetBox[
      StyleBox["90",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], {0, 4}, {0, -2.}], InsetBox[
      StyleBox["105",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{(-2^Rational[1, 2]) (-1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (1 + 3^Rational[1, 2])}, {-1.035276180410083, 
       3.8637033051562732`}], {0.5176380902050414, -1.9318516525781364`}], 
     InsetBox[
      StyleBox["120",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{-2, 2 3^Rational[1, 2]}, {-2, 
        3.4641016151377544`}], {1., -1.7320508075688772`}], InsetBox[
      StyleBox["135",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{(-2) 2^Rational[1, 2], 2 
        2^Rational[1, 2]}, {-2.8284271247461903`, 
       2.8284271247461903`}], {1.414213562373095, -1.414213562373095}], 
     InsetBox[
      StyleBox["150",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{(-2) 3^Rational[1, 2], 2}, {-3.4641016151377544`, 
        2}], {1.7320508075688772`, -1.}], InsetBox[
      StyleBox["165",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{(-2^Rational[1, 2]) (1 + 3^Rational[1, 2]), 
        2^Rational[1, 2] (-1 + 3^Rational[1, 2])}, {-3.8637033051562732`, 
       1.035276180410083}], {1.9318516525781364`, -0.5176380902050414}], 
     InsetBox[
      StyleBox["180",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], {-4, 0}, {2., 0}], InsetBox[
      StyleBox["195",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{(-2^Rational[1, 2]) (1 + 
         3^Rational[1, 2]), (-2^Rational[1, 2]) (-1 + 
         3^Rational[
           1, 2])}, {-3.8637033051562732`, -1.035276180410083}], \
{1.9318516525781364`, 0.5176380902050414}], InsetBox[
      StyleBox["210",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{(-2) 
        3^Rational[
          1, 2], -2}, {-3.4641016151377544`, -2}], {1.7320508075688772`, 1.}],
      InsetBox[
      StyleBox["225",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{(-2) 2^Rational[1, 2], (-2) 
        2^Rational[
          1, 2]}, {-2.8284271247461903`, -2.8284271247461903`}], \
{1.414213562373095, 1.414213562373095}], InsetBox[
      StyleBox["240",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{-2, (-2) 
        3^Rational[
          1, 2]}, {-2, -3.4641016151377544`}], {1., 1.7320508075688772`}], 
     InsetBox[
      StyleBox["255",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{(-2^Rational[1, 2]) (-1 + 
         3^Rational[1, 2]), (-2^Rational[1, 2]) (1 + 
         3^Rational[
           1, 2])}, {-1.035276180410083, -3.8637033051562732`}], \
{0.5176380902050414, 1.9318516525781364`}], InsetBox[
      StyleBox["270",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], {0, -4}, {0, 2.}], InsetBox[
      StyleBox["285",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{2^Rational[1, 2] (-1 + 3^Rational[1, 2]), (-2^Rational[1, 2]) (
         1 + 3^Rational[1, 2])}, {
       1.035276180410083, -3.8637033051562732`}], \
{-0.5176380902050414, 1.9318516525781364`}], InsetBox[
      StyleBox["300",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{2, (-2) 3^Rational[1, 2]}, {
       2, -3.4641016151377544`}], {-1., 1.7320508075688772`}], InsetBox[
      StyleBox["315",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{2 2^Rational[1, 2], (-2) 2^Rational[1, 2]}, {
       2.8284271247461903`, -2.8284271247461903`}], \
{-1.414213562373095, 1.414213562373095}], InsetBox[
      StyleBox["330",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{2 3^Rational[1, 2], -2}, {3.4641016151377544`, -2}], 
      {-1.7320508075688772`, 1.}], InsetBox[
      StyleBox["345",
       StripOnInput->False,
       FontSize->18,
       FontColor->RGBColor[1, 0, 0]], 
      NCache[{2^Rational[1, 2] (1 + 
         3^Rational[1, 2]), (-2^Rational[1, 2]) (-1 + 3^Rational[1, 2])}, {
       3.8637033051562732`, -1.035276180410083}], \
{-1.9318516525781364`, 0.5176380902050414}]}, {InsetBox[
      StyleBox["1",
       StripOnInput->False,
       FontSize->14,
       FontColor->RGBColor[0, 0, 1]], Scaled[{-0.01, -0.015}, {1, 0}]], 
     InsetBox[
      StyleBox["2",
       StripOnInput->False,
       FontSize->14,
       FontColor->RGBColor[0, 0, 1]], Scaled[{-0.01, -0.015}, {2, 0}]], 
     InsetBox[
      StyleBox["3",
       StripOnInput->False,
       FontSize->14,
       FontColor->RGBColor[0, 0, 1]], Scaled[{-0.01, -0.015}, {3, 0}]], 
     InsetBox[
      StyleBox["4",
       StripOnInput->False,
       FontSize->14,
       FontColor->RGBColor[0, 0, 1]], Scaled[{-0.01, -0.015}, {4, 0}]]}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->False,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{
    Directive[FontColor -> RGBColor[1, 0, 0], 18], 
    Directive[FontColor -> RGBColor[0, 0, 1], 14]}]], "Output",
 ImageSize->{364, 339},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1629837445]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["PlotGrid",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/PlotGrid"],
  FontFamily->"Verdana"]], "InlineFormula"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Building an Understanding of Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/BuildingAnUnderstandingOfFunctions"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->90711618],

Cell[TextData[ButtonBox["Understanding Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], "MoreAbout",
 CellID->302252219]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"PolarPlotGrid - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 29, 50.7460624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "PolarPlotGrid[] creates a plot grid using polar coordinates with 0 <= \
\\[Rho] <= 5PolarPlotGrid[r] creates a plot grid using polar coordinates with \
0<= \\[Rho]<=rPolarPlotGrid[r, \"Radians\"] creates a plot grid using polar \
coordinates with angle given in radians.", "synonyms" -> {}, "title" -> 
    "PolarPlotGrid", "titlemodifier" -> "", "windowtitle" -> "PolarPlotGrid", 
    "type" -> "Symbol", "uri" -> "ClassroomUtilities/ref/PolarPlotGrid"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6721, 194, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->49504613]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 108270, 2597}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[606, 21, 3376, 79, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4007, 104, 56, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[4066, 107, 1037, 30, 203, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5140, 142, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->32812561],
Cell[5751, 162, 130, 4, 70, "Notes",
 CellID->1067943069],
Cell[5884, 168, 800, 21, 70, "3ColumnTableMod",
 CellID->1167331938]
}, Closed]],
Cell[CellGroupData[{
Cell[6721, 194, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->49504613],
Cell[CellGroupData[{
Cell[7235, 212, 195, 6, 31, "ExampleSection",
 CellID->418293097],
Cell[7433, 220, 127, 3, 28, "Input",
 CellID->920275790],
Cell[7563, 225, 92, 1, 32, "ExampleText",
 CellID->897976836],
Cell[CellGroupData[{
Cell[7680, 230, 105, 3, 28, "Input",
 CellID->1929095183],
Cell[7788, 235, 25233, 568, 372, "Output",
 CellID->44859106]
}, Open  ]],
Cell[33036, 806, 73, 1, 70, "ExampleText",
 CellID->2084766621],
Cell[CellGroupData[{
Cell[33134, 811, 146, 4, 70, "Input",
 CellID->329414695],
Cell[33283, 817, 23923, 562, 390, "Output",
 CellID->259936899]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[57255, 1385, 270, 8, 70, "ExampleSection",
 CellID->1495629065],
Cell[CellGroupData[{
Cell[57550, 1397, 285, 8, 70, "ExampleSubsection",
 CellID->741607320],
Cell[57838, 1407, 128, 3, 70, "Input",
 CellID->1674979948],
Cell[57969, 1412, 301, 6, 70, "ExampleText",
 CellID->24857513],
Cell[CellGroupData[{
Cell[58295, 1422, 515, 14, 70, "Input",
 CellID->1168393473],
Cell[58813, 1438, 25090, 570, 372, "Output",
 CellID->1112992433]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[83952, 2014, 281, 8, 70, "ExampleSubsection",
 CellID->199140052],
Cell[84236, 2024, 128, 3, 70, "Input",
 CellID->1454001512],
Cell[84367, 2029, 156, 4, 70, "ExampleText",
 CellID->858541283],
Cell[CellGroupData[{
Cell[84548, 2037, 496, 14, 70, "Input",
 CellID->560719188],
Cell[85047, 2053, 18825, 408, 360, "Output",
 CellID->1629837445]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[103945, 2469, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[104394, 2484, 219, 6, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[104650, 2495, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[105101, 2510, 211, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[105349, 2520, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[105800, 2535, 170, 4, 70, "MoreAbout",
 CellID->90711618],
Cell[105973, 2541, 179, 4, 70, "MoreAbout",
 CellID->302252219]
}, Open  ]],
Cell[106167, 2548, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

