(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     30292,        718]
NotebookOptionsPosition[     26635,        606]
NotebookOutlinePosition[     28935,        668]
CellTagsIndexPosition[     28815,        662]
WindowTitle->ReferenceLine - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/ReferenceLine\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/ReferenceLine"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/ReferenceLine.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/ReferenceLine", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["ReferenceLine", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["ReferenceLine"], "InlineFormula"],
     "\[LineSeparator]and option for ",
     Cell[BoxData[
      ButtonBox["TimeIntervalPlot",
       BaseStyle->"Link",
       ButtonData->"paclet:Differentiation/ref/TimeIntervalPlot"]], 
      "InlineFormula"],
     " that determines the vertical location of the reference line."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->323339556],

Cell["\<\
The defaults the smallest of the function values specified by the intervals.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
For oscillatory functions the function may drop below the reference line. \
\>", "Notes",
 CellID->1610525103],

Cell["\<\
The reference line provides the starting point for the lines defining the \
partitions.\
\>", "Notes",
 CellID->1211519333]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->146435313],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->315499139],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1712972524],

Cell["This uses the default location for the reference line.", "ExampleText",
 CellID->763439186],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   RowBox[{"Cos", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "\[Pi]"}], "}"}], ",", "6"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->2055091924],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0., 1.}], 
        Scaled[{-0.04, 0}, {0., 0.8660254037844386}], 
        Scaled[{0, 0}, {0., 0.8660254037844386}], Scaled[{0, 0}, {0., 1.}]}, {
       Scaled[{-0.04, 0}, {0., 0.5}], Scaled[{-0.04, 0}, {0., 0.}], 
        Scaled[{0, 0}, {0., 0.}], Scaled[{0, 0}, {0., 0.5}]}, {
       Scaled[{-0.04, 0}, {0., -0.5}], 
        Scaled[{-0.04, 0}, {0., -0.8660254037844386}], 
        Scaled[{0, 0}, {0., -0.8660254037844386}], 
        Scaled[{0, 0}, {0., -0.5}]}}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0., 0.8660254037844386}], 
        Scaled[{-0.04, 0}, {0., 0.5}], Scaled[{0, 0}, {0., 0.5}], 
        Scaled[{0, 0}, {0., 0.8660254037844386}]}, {
       Scaled[{-0.04, 0}, {0., 0.}], Scaled[{-0.04, 0}, {0., -0.5}], 
        Scaled[{0, 0}, {0., -0.5}], Scaled[{0, 0}, {0., 0.}]}, {
       Scaled[{-0.04, 0}, {0., -0.8660254037844386}], 
        Scaled[{-0.04, 0}, {0., -1.}], Scaled[{0, 0}, {0., -1.}], 
        Scaled[{0, 0}, {0., -0.8660254037844386}]}}], 
     {RGBColor[0.9, 0, 1.], Thickness[Medium], Opacity[0.95], Arrowheads[
      Small], ArrowBox[{
       Scaled[{-0.02, 0}, {0., -0.5915063509461096}], 
        Scaled[{-0.02, 0}, {0., -0.774519052838329}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 0.375}], Scaled[{-0.02, 0}, {0., 0.125}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0., 0.9665063509461096}], 
        Scaled[{-0.02, 0}, {0., 0.899519052838329}]}], 
      {RGBColor[1, 0.95, 0], Thickness[Large], Opacity[0.95], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., -0.899519052838329}], 
         Scaled[{-0.02, 0}, {0., -0.9665063509461096}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., -0.125}], Scaled[{-0.02, 0}, {0., -0.375}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0., 0.774519052838329}], 
         Scaled[{-0.02, 0}, {0., 0.5915063509461096}]}]}, 
      {GrayLevel[0.4], Thickness[Small], Opacity[1], 
       LineBox[
        NCache[{{
          Scaled[{-0.04, 0}, {0., 0.8660254037844386}], {
           Rational[1, 6] Pi, Rational[1, 2] 3^Rational[1, 2]}, {
           Rational[1, 6] Pi, -1}}, {
          Scaled[{-0.04, 0}, {0., 0.5}], {
           Rational[1, 3] Pi, Rational[1, 2]}, {Rational[1, 3] Pi, -1}}, {
          Scaled[{-0.04, 0}, {0., 0.}], {Rational[1, 2] Pi, 0}, {
           Rational[1, 2] Pi, -1}}, {
          Scaled[{-0.04, 0}, {0., -0.5}], {
           Rational[2, 3] Pi, Rational[-1, 2]}, {Rational[2, 3] Pi, -1}}, {
          Scaled[{-0.04, 0}, {0., -0.8660254037844386}], {
           Rational[5, 6] Pi, Rational[-1, 2] 3^Rational[1, 2]}, {
           Rational[5, 6] Pi, -1}}, {
          Scaled[{-0.04, 0}, {0., -1.}], {Pi, -1}, {Pi, -1}}}, {{
          Scaled[{-0.04, 0}, {0., 0.8660254037844386}], {0.5235987755982988, 
           0.8660254037844386}, {0.5235987755982988, -1}}, {
          Scaled[{-0.04, 0}, {0., 0.5}], {1.0471975511965976`, 0.5}, {
           1.0471975511965976`, -1}}, {
          Scaled[{-0.04, 0}, {0., 0.}], {1.5707963267948966`, 0}, {
           1.5707963267948966`, -1}}, {
          Scaled[{-0.04, 0}, {0., -0.5}], {2.0943951023931953`, -0.5}, {
           2.0943951023931953`, -1}}, {
          Scaled[{-0.04, 0}, {0., -0.8660254037844386}], {
           2.6179938779914944`, -0.8660254037844386}, {
           2.6179938779914944`, -1}}, {
          Scaled[{-0.04, 0}, {0., -1.}], {3.141592653589793, -1}, {
           3.141592653589793, -1}}}]], 
       LineBox[NCache[{{0, -1}, {Pi, -1}}, {{0, -1}, {
          3.141592653589793, -1}}]], 
       {RGBColor[1, 0, 0], PointSize[Medium], 
        PointBox[
         NCache[{{0, 1}, {
           Rational[1, 6] Pi, Rational[1, 2] 3^Rational[1, 2]}, {
           Rational[1, 3] Pi, Rational[1, 2]}, {Rational[1, 2] Pi, 0}, {
           Rational[2, 3] Pi, Rational[-1, 2]}, {
           Rational[5, 6] Pi, Rational[-1, 2] 3^Rational[1, 2]}, {Pi, -1}}, {{
           0, 1}, {0.5235987755982988, 0.8660254037844386}, {
           1.0471975511965976`, 0.5}, {1.5707963267948966`, 0}, {
           2.0943951023931953`, -0.5}, {
           2.6179938779914944`, -0.8660254037844386}, {
           3.141592653589793, -1}}]]}}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwt1wkw180fB3BXv9/310lPVBSiQ64OJKHPkpxPQkm5KYWKqPQU6YnQJXIU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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 353},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1950471967]
}, Open  ]],

Cell["This makes the axis the reference line.", "ExampleText",
 CellID->244477914],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   RowBox[{"Cos", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "\[Pi]"}], "}"}], ",", "6", ",", 
   RowBox[{"ReferenceLine", "\[Rule]", " ", "0"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->804083887],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3S90o96fxvHZs6aycuzIysqxlZWVcfvD7DmIFUgsEonEIpFILBKJxCKR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    "], {{0, 353}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 353},
  PlotRange->{{0, 360}, {0, 353}}]], "Output",
 ImageSize->{364, 353},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->455610014]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->709444749]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"ReferenceLine - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 30, 2.2900624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "ReferenceLine and option for TimeIntervalPlot that determines the \
vertical location of the reference line.", "synonyms" -> {}, "title" -> 
    "ReferenceLine", "titlemodifier" -> "", "windowtitle" -> "ReferenceLine", 
    "type" -> "Symbol", "uri" -> "ClassroomUtilities/ref/ReferenceLine"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4752, 143, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->146435313]},
 "RasterizedOutput"->{
  Cell[16762, 417, 9148, 158, 374, "Output",
   CellTags->"RasterizedOutput",
   CellID->455610014]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 28547, 651},
 {"RasterizedOutput", 28690, 655}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[606, 21, 2450, 56, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3081, 81, 56, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3140, 84, 545, 15, 85, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[3722, 104, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->323339556],
Cell[4334, 124, 122, 3, 70, "Notes",
 CellID->1067943069],
Cell[4459, 129, 120, 3, 70, "Notes",
 CellID->1610525103],
Cell[4582, 134, 133, 4, 70, "Notes",
 CellID->1211519333]
}, Closed]],
Cell[CellGroupData[{
Cell[4752, 143, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->146435313],
Cell[CellGroupData[{
Cell[5267, 161, 195, 6, 31, "ExampleSection",
 CellID->315499139],
Cell[5465, 169, 128, 3, 28, "Input",
 CellID->1712972524],
Cell[5596, 174, 97, 1, 32, "ExampleText",
 CellID->763439186],
Cell[CellGroupData[{
Cell[5718, 179, 240, 7, 28, "Input",
 CellID->2055091924],
Cell[5961, 188, 10380, 211, 374, "Output",
 CellID->1950471967]
}, Open  ]],
Cell[16356, 402, 82, 1, 70, "ExampleText",
 CellID->244477914],
Cell[CellGroupData[{
Cell[16463, 407, 296, 8, 28, "Input",
 CellID->804083887],
Cell[16762, 417, 9148, 158, 374, "Output",
 CellTags->"RasterizedOutput",
 CellID->455610014]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[25971, 582, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[26422, 597, 171, 4, 70, "MoreAbout",
 CellID->709444749]
}, Open  ]],
Cell[26608, 604, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

