(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     29512,        972]
NotebookOptionsPosition[     23882,        788]
NotebookOutlinePosition[     26233,        851]
CellTagsIndexPosition[     26113,        845]
WindowTitle->RiemannSum - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ntegrals as Limits\"\>":>
       Documentation`HelpLookup[
       "paclet:IntegrationTechniques/tutorial/IntegralsAsLimits"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Integration Techniques\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/IntegrationTechniques"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/RiemannSum\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/RiemannSum"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/RiemannSum.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/RiemannSum", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["RiemannSum", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"RiemannSum", "[", 
       RowBox[{
        StyleBox["fn", "TI"], ",", " ", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["var", "TI"], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["n", "TI"], ",", "\"\<\!\(\*
StyleBox[\"type\", \"TI\"]\)\>\"", ",", 
        StyleBox["opts", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]plot fn on the interval v",
     Cell[BoxData[
      RowBox[{
       SubscriptBox[
        StyleBox["ar", "TI"], 
        StyleBox["min", "TI"]], " "}]], "InlineFormula"],
     "to ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["var", "TI"], 
       StyleBox["max", "TI"]]], "InlineFormula"],
     " with ",
     Cell[BoxData[
      StyleBox["n", "TI"]], "InlineFormula"],
     " bars of ",
     Cell[BoxData["\"\<\!\(\*
StyleBox[\"type\", \"TI\"]\)\>\""], "InlineFormula"],
     " approximating the area under the curve."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->409930598],

Cell[TextData[{
 "RiemannSum would normally be used with ",
 Cell[BoxData[
  ButtonBox["RiemannSumPlot",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/RiemannSumPlot"]], 
  "InlineFormula"],
 " to illustrate approximating area under a curve."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The ",
 Cell[BoxData["\"\<\!\(\*
StyleBox[\"type\", \"TI\"]\)\>\""], "InlineFormula"],
 " can be any of \"Left\", \"Center\", \"Right\" or \"Trapezoid\"."
}], "Notes",
 CellID->1869072931],

Cell["RiemannSum can return both exact and machine numbers.", "Notes",
 CellID->106122025],

Cell[TextData[{
 "If ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["var", "TI"], 
   StyleBox["min", "TI"]]], "InlineFormula"],
 " is a machine number the answer will be a machine number."
}], "Notes",
 CellID->1181447165],

Cell["\<\
RiemannSum will allow one or both ends of the interval to be given as symbols.\
\>", "Notes",
 CellID->507294052]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->430275966],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->381413614],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->948701993],

Cell[TextData[{
 "Approximate the area under ",
 Cell[BoxData[
  RowBox[{
   RowBox[{
    StyleBox["f", "TI"], 
    RowBox[{"(", 
     StyleBox["x", "TI"], ")"}]}], " ", "=", 
   StyleBox["x", "TI"], " "}]], "InlineFormula"],
 "using 5 rectangles."
}], "ExampleText",
 CellID->1645474090],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSum", "[", 
  RowBox[{"x", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "4"}], "}"}], ",", "5", ",", 
   "\"\<Center\>\""}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->188624564],

Cell[BoxData["8"], "Output",
 ImageSize->{11, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->299926378]
}, Open  ]],

Cell["Getting an answer as a machine number.", "ExampleText",
 CellID->2014402157],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSum", "[", 
  RowBox[{
   SuperscriptBox["x", "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0.", ",", "4"}], "}"}], ",", "5", ",", 
   "\"\<Center\>\""}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->977357744],

Cell[BoxData["21.12`"], "Output",
 ImageSize->{39, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->718515537]
}, Open  ]],

Cell["The ends of the interval can be specified as symbols.", "ExampleText",
 CellID->1155913909],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSum", "[", 
  RowBox[{
   SuperscriptBox["x", "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "\[Alpha]", ",", "\[Beta]"}], "}"}], ",", "5", ",", 
   "\"\<Center\>\""}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1307997801],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "5"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"\[Alpha]", "+", 
       RowBox[{
        FractionBox["1", "10"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}]}]}], ")"}], "2"],
     "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"\[Alpha]", "+", 
       RowBox[{
        FractionBox["3", "10"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}]}]}], ")"}], "2"],
     "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"\[Alpha]", "+", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}]}]}], ")"}], "2"],
     "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"\[Alpha]", "+", 
       RowBox[{
        FractionBox["7", "10"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}]}]}], ")"}], "2"],
     "+", 
    SuperscriptBox[
     RowBox[{"(", 
      RowBox[{"\[Alpha]", "+", 
       RowBox[{
        FractionBox["9", "10"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}]}]}], ")"}], 
     "2"]}], ")"}]}]], "Output",
 ImageSize->{383, 65},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1876430715]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(2)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2104452952],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Estimate",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->485098174],

Cell["\<\
Using Area for the value of the estimate option will give the total area of \
the polygons.\
\>", "ExampleText",
 CellID->132053688],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSum", "[", 
  RowBox[{
   RowBox[{"Cos", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "\[Alpha]", ",", "5"}], "}"}], ",", "6", ",", 
   "\"\<Right\>\"", ",", 
   RowBox[{"Estimate", "\[Rule]", " ", "Area"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1075726865],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "6"], " ", 
  RowBox[{"(", 
   RowBox[{"5", "-", "\[Alpha]"}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Abs", "[", 
     RowBox[{"Cos", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"5", "-", "\[Alpha]"}], "6"], "+", "\[Alpha]"}], "]"}], "]"}],
     "+", 
    RowBox[{"Abs", "[", 
     RowBox[{"Cos", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"5", "-", "\[Alpha]"}], "3"], "+", "\[Alpha]"}], "]"}], "]"}],
     "+", 
    RowBox[{"Abs", "[", 
     RowBox[{"Cos", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"5", "-", "\[Alpha]"}], "2"], "+", "\[Alpha]"}], "]"}], "]"}],
     "+", 
    RowBox[{"Abs", "[", 
     RowBox[{"Cos", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"2", " ", 
         RowBox[{"(", 
          RowBox[{"5", "-", "\[Alpha]"}], ")"}]}], "3"], "+", "\[Alpha]"}], 
      "]"}], "]"}], "+", 
    RowBox[{"Abs", "[", 
     RowBox[{"Cos", "[", 
      RowBox[{
       FractionBox[
        RowBox[{"5", " ", 
         RowBox[{"(", 
          RowBox[{"5", "-", "\[Alpha]"}], ")"}]}], "6"], "+", "\[Alpha]"}], 
      "]"}], "]"}], "+", 
    RowBox[{"Cos", "[", "5", "]"}]}], ")"}]}]], "Output",
 ImageSize->{527, 63},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->76595962]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "\nFormBox[\"Subintervals\", TextForm]",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1804420546],

Cell[TextData[{
 "Setting ",
 Cell[BoxData[
  ButtonBox["Subintervals",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/Subintervals"]], 
  "InlineFormula"],
 " to ",
 Cell[BoxData[
  ButtonBox["Nonuniform",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/Nonuniform"]], "InlineFormula"],
 " will partition the interval into sub-intervals of random length."
}], "ExampleText",
 CellID->476751626],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Grid", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"BlockRandom", "[", 
      RowBox[{"RiemannSum", "[", 
       RowBox[{
        RowBox[{
         SuperscriptBox["x", "2"], "/", "2"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "0.", ",", "4"}], "}"}], ",", "5", ",", 
        "\"\<Center\>\"", ",", 
        RowBox[{"Subintervals", "\[Rule]", " ", "Nonuniform"}]}], "]"}], 
      "]"}], "}"}], ",", 
    RowBox[{"{", 
     RowBox[{"RiemannSumPlot", "[", 
      RowBox[{
       RowBox[{
        SuperscriptBox["x", "2"], "/", "2"}], ",", 
       RowBox[{"{", 
        RowBox[{"x", ",", "0.", ",", "4"}], "}"}], ",", "5", ",", 
       "\"\<Center\>\"", ",", 
       RowBox[{"Subintervals", "\[Rule]", " ", "Nonuniform"}]}], "]"}], 
     "}"}]}], "}"}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->503091225],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnSGzq7oChffM+yX3Z2x7ZGUl8iCZN09UYpFIJDYSicRWIiOxzFVIJC+Q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    "], {{0, 233}, {109, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{109, 233},
  PlotRange->{{0, 109}, {0, 233}}]], "Output",
 ImageSize->{113, 233},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[1]=",
 CellID->501808989]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Possible Issues",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->448360343],

Cell["In some cases terms may be automatically combined.", "ExampleText",
 CellID->1160259849],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSum", "[", 
  RowBox[{"x", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "\[Alpha]", ",", "\[Beta]"}], "}"}], ",", "5", ",", 
   "\"\<Center\>\""}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1335767383],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "5"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"5", " ", "\[Alpha]"}], "+", 
    RowBox[{
     FractionBox["5", "2"], " ", 
     RowBox[{"(", 
      RowBox[{
       RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}]}]}], 
   ")"}]}]], "Output",
 ImageSize->{178, 32},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->72167478]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->689148279],

Cell[TextData[{
 "With the option ",
 Cell[BoxData[
  ButtonBox["Estimate",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/Estimate"]], "InlineFormula"],
 " \[Rule] ",
 Cell[BoxData[
  ButtonBox["Area",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/Area"]], "InlineFormula"],
 " and a symbolic interval the answer can be difficult to read."
}], "ExampleText",
 CellID->1373670810],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSum", "[", 
  RowBox[{
   RowBox[{"Sin", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "\[Alpha]", ",", "\[Beta]"}], "}"}], ",", "6", ",", 
   "\"\<Left\>\"", ",", 
   RowBox[{"Estimate", "\[Rule]", " ", "Area"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1836098420],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "6"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{"Abs", "[", 
     RowBox[{"Sin", "[", "\[Alpha]", "]"}], "]"}], "+", 
    RowBox[{"Abs", "[", 
     RowBox[{"Sin", "[", 
      RowBox[{"\[Alpha]", "+", 
       RowBox[{
        FractionBox["1", "6"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}]}]}], "]"}], 
     "]"}], "+", 
    RowBox[{"Abs", "[", 
     RowBox[{"Sin", "[", 
      RowBox[{"\[Alpha]", "+", 
       RowBox[{
        FractionBox["1", "3"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}]}]}], "]"}], 
     "]"}], "+", 
    RowBox[{"Abs", "[", 
     RowBox[{"Sin", "[", 
      RowBox[{"\[Alpha]", "+", 
       RowBox[{
        FractionBox["1", "2"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}]}]}], "]"}], 
     "]"}], "+", 
    RowBox[{"Abs", "[", 
     RowBox[{"Sin", "[", 
      RowBox[{"\[Alpha]", "+", 
       RowBox[{
        FractionBox["2", "3"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}]}]}], "]"}], 
     "]"}], "+", 
    RowBox[{"Abs", "[", 
     RowBox[{"Sin", "[", 
      RowBox[{"\[Alpha]", "+", 
       RowBox[{
        FractionBox["5", "6"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{"-", "\[Alpha]"}], "+", "\[Beta]"}], ")"}]}]}], "]"}], 
     "]"}]}], ")"}]}]], "Output",
 ImageSize->{520, 63},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->2113621197]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[{
 "I",
 ButtonBox["ntegrals as Limits",
  BaseStyle->"Link",
  ButtonData->"paclet:IntegrationTechniques/tutorial/IntegralsAsLimits"]
}], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Integration Techniques",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/IntegrationTechniques"]], "MoreAbout",
 CellID->284577990]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"RiemannSum - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 30, 11.0104624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "RiemannSum[fn, {var, var_min, var_max}, n, \" type\", opts] plot fn on \
the interval var_min to var_max with n bars of \" type\" approximating the \
area under the curve.", "synonyms" -> {}, "title" -> "RiemannSum", 
    "titlemodifier" -> "", "windowtitle" -> "RiemannSum", "type" -> "Symbol", 
    "uri" -> "ClassroomUtilities/ref/RiemannSum"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6394, 198, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->430275966]},
 "RasterizedOutput"->{
  Cell[14538, 509, 3934, 72, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->501808989]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 25847, 834},
 {"RasterizedOutput", 25990, 838}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[603, 21, 2743, 63, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3371, 88, 53, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3427, 91, 1330, 42, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[4794, 138, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->409930598],
Cell[5406, 158, 298, 9, 70, "Notes",
 CellID->1067943069],
Cell[5707, 169, 206, 6, 70, "Notes",
 CellID->1869072931],
Cell[5916, 177, 90, 1, 70, "Notes",
 CellID->106122025],
Cell[6009, 180, 222, 8, 70, "Notes",
 CellID->1181447165],
Cell[6234, 190, 123, 3, 70, "Notes",
 CellID->507294052]
}, Closed]],
Cell[CellGroupData[{
Cell[6394, 198, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->430275966],
Cell[CellGroupData[{
Cell[6909, 216, 195, 6, 31, "ExampleSection",
 CellID->381413614],
Cell[7107, 224, 127, 3, 28, "Input",
 CellID->948701993],
Cell[7237, 229, 288, 11, 34, "ExampleText",
 CellID->1645474090],
Cell[CellGroupData[{
Cell[7550, 244, 225, 7, 28, "Input",
 CellID->188624564],
Cell[7778, 253, 158, 5, 36, "Output",
 CellID->299926378]
}, Open  ]],
Cell[7951, 261, 82, 1, 32, "ExampleText",
 CellID->2014402157],
Cell[CellGroupData[{
Cell[8058, 266, 251, 8, 30, "Input",
 CellID->977357744],
Cell[8312, 276, 163, 5, 36, "Output",
 CellID->718515537]
}, Open  ]],
Cell[8490, 284, 97, 1, 32, "ExampleText",
 CellID->1155913909],
Cell[CellGroupData[{
Cell[8612, 289, 264, 8, 30, "Input",
 CellID->1307997801],
Cell[8879, 299, 1595, 57, 86, "Output",
 CellID->1876430715]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10523, 362, 270, 8, 70, "ExampleSection",
 CellID->2104452952],
Cell[CellGroupData[{
Cell[10818, 374, 279, 8, 70, "ExampleSubsection",
 CellID->485098174],
Cell[11100, 384, 142, 4, 70, "ExampleText",
 CellID->132053688],
Cell[CellGroupData[{
Cell[11267, 392, 318, 9, 70, "Input",
 CellID->1075726865],
Cell[11588, 403, 1340, 46, 84, "Output",
 CellID->76595962]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[12977, 455, 225, 6, 70, "ExampleSubsection",
 CellID->1804420546],
Cell[13205, 463, 436, 14, 70, "ExampleText",
 CellID->476751626],
Cell[CellGroupData[{
Cell[13666, 481, 869, 26, 70, "Input",
 CellID->503091225],
Cell[14538, 509, 3934, 72, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->501808989]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[18533, 588, 278, 8, 70, "ExampleSection",
 CellID->1305812373],
Cell[18814, 598, 127, 3, 70, "Input",
 CellID->448360343],
Cell[18944, 603, 94, 1, 70, "ExampleText",
 CellID->1160259849],
Cell[CellGroupData[{
Cell[19063, 608, 239, 7, 70, "Input",
 CellID->1335767383],
Cell[19305, 617, 512, 19, 53, "Output",
 CellID->72167478]
}, Open  ]],
Cell[19832, 639, 127, 3, 70, "Input",
 CellID->689148279],
Cell[19962, 644, 423, 13, 70, "ExampleText",
 CellID->1373670810],
Cell[CellGroupData[{
Cell[20410, 661, 323, 9, 70, "Input",
 CellID->1836098420],
Cell[20736, 672, 1742, 59, 84, "Output",
 CellID->2113621197]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[22539, 738, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[22990, 753, 185, 6, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[23212, 764, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[23663, 779, 177, 4, 70, "MoreAbout",
 CellID->284577990]
}, Open  ]],
Cell[23855, 786, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

