(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     39067,       1009]
NotebookOptionsPosition[     33693,        842]
NotebookOutlinePosition[     36452,        914]
CellTagsIndexPosition[     36332,        908]
WindowTitle->RiemannSum3D - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Working with Riemann Sums\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/WorkingWithRiemannSums"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"RiemannSumPlot3D\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/RiemannSumPlot3D"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities/ref/RiemannSum3D\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/RiemannSum3D"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/RiemannSum3D.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/RiemannSum3D", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["RiemannSum3D", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"RiemannSum3D", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["n", "TI"], ",", "\"\<Disk\>\""}], "]"}]], "InlineFormula"],
     " \[LineSeparator]returns the volume of the disks used genrated by \
RiemannSumPlot3D."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"RiemannSum3D", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["n", "TI"], ",", "\"\<Shell\>\""}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns the volume of the shells created by \
RiemannSumPlot3D."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"RiemannSum3D", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{"f$1", ",", "f$2"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "x$min", ",", "x$max"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"z", ",", "z$min", ",", " ", "x$max"}], "}"}], ",", "n", 
        ",", "\"\<Washer\>\""}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns the volume of the washers created by \
RiemannSumPlot3D"
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->314400113],

Cell["\<\
For disks and washers the numercal value of the sum is returned.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
For shells the full list of terms in the sum can be obtained if exact values \
are used.\
\>", "Notes",
 CellID->1174439591]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->586185000],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(4)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->283260817],

Cell["This loads the package.", "ExampleText",
 CellID->1284006360],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->231723817],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Disks",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->280223111],

Cell[TextData[{
 "Give the volume for four disks and the function ",
 Cell[BoxData[
  RowBox[{"1", "-", 
   RowBox[{
    SuperscriptBox["x", "2"], "."}]}]], "InlineFormula"]
}], "ExampleText",
 CellID->278188706],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot3D", "[", 
  RowBox[{
   RowBox[{"1", "-", 
    SuperscriptBox["x", "2"]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "4", ",", "\"\<Disk\>\"", 
   ",", 
   RowBox[{"PlotLabel", "\[Rule]", " ", 
    RowBox[{"RiemannSum3D", "[", 
     RowBox[{
      RowBox[{"1", "-", 
       SuperscriptBox["x", "2"]}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "4", ",", 
      "\"\<Disk\>\""}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->445682223],

Cell[BoxData[
 Graphics3DBox[{{}, 
   CylinderBox[
    NCache[{{{0, 0, 0}, {0, 0, Rational[1, 4]}}, {{0, 0, Rational[1, 4]}, {
       0, 0, Rational[1, 2]}}, {{0, 0, Rational[1, 2]}, {
       0, 0, Rational[3, 4]}}, {{0, 0, Rational[3, 4]}, {0, 0, 1}}}, {{{0, 0, 
       0}, {0, 0, 0.25}}, {{0, 0, 0.25}, {0, 0, 0.5}}, {{0, 0, 0.5}, {
       0, 0, 0.75}}, {{0, 0, 0.75}, {0, 0, 1}}}], {0.9354143471647448, 
    0.7905694150680643, 0.6123724365159088, 0.3535533974754966}]},
  PlotLabel->FormBox["1.570796332130581`", TraditionalForm]]], "Output",
 ImageSize->{184, 173},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->279469202,
 ImageCache->GraphicsData["CompressedBitmap", "\<\
eJy9W/1SHDcSl6WZ3eV7ARsMxF9xziE2hMXxV1wkcXK+xMk5B1e4LkmlXBzn
ohLuivLHxXeF67K8gE38IlTlj7yGyT5CHoE38HW3pJmfNDsLxOBMbRhrNN2/
llrqX0ujL5d/+H5lbfmH1XvLpz97tPzg+9V7/z796f1HVGSOKKV+od9WXdH9
/5T5TZ36ZeOlUusbL/Xs0/f59r9yq8zGy9mn9Pcal/2w8dLMPjXyRAoeyW2F
bqmca6qrXHxf6tXoNuFifnCFy9ekek+h/J9Sv49uU1suoi7zo+/llbrXQH81
3F/kKivy9lCnKv+QKseg2MD9LFf5uygaK5EiVe6KlIkSKQ2u8q1IOQnFCdzP
cJWvRcrpTlX+JlLOQnEK9+9ylUWR8gcorsD9NFf5q0iZ7FTlLyLlPBRX4X6K
q9wWKdNQXIP7C1zlc5Ey06nKZyLlIhR3wT0DUDdFCvX0kFLYmd1w/w5X/ERk
9W68rCqlv94xd+sqXa4vN/haaSizsqBXF5RZfbBGl0qV6usk7SNRS2iool5o
6TstZe7sfE1XO+F6ZcGQ8MQKX3ug157rh8/pVbS4B+65+dWc6KiKDpXcat2W
y+yqzZmC2szD5yp5+PNjuRIV+E5B73U/PKmiMjdaN+lS5lbLvIJyY5UrTT/z
uLVOlzIsnscsKcXGfptBXBXjEwGh51oEQ99sHSCIxIJYb+n1HUYiKPoBxTlG
cVmagoaR5i641Lom16HjSX7coZlMhT4ogC5KszhAptG6RJcyrwvSjzvNOinu
BVQ8l/AkZj1GUE21GnQpfamlr7XMofedBaaMQENnfouhTftBpMiRJn+d+nWq
pRut14NNM6zZp816s87w6NdQKprnBOQFab+aczOLMsSpb7TMa8OZNBvNGXY/
BMpxhecHO+2pCrcmX4zVHCZSP11o+iXrOz/ucIenHiZf1GoYgN5kpOcy0mAs
UqXpZxgt++YrAtarhHQXsJlzClTpfQarNP1Mc57bNwjQAvusNHCPeEK6B8CK
EIukMZa29vyhvbh/9wqGsRj2y4iZnGE8Z6QZ+6AZGVViUTVaJsSkb7UoVk0s
LnGM7QhANxumOZOUqGaao05KU/SD6kqZakW6pRWo1d5eXKL6SYnGtDmvVVHX
GzlfdLqqRV00x9Ic8u7iEoekMuHN+8wdMjYqjTgmlgyC9BpKdx2r1BWBzsh4
opUZzcs1JDexcmefitAREToMQru4d7zQSxJf5xaXWJxSkbgExUkLHJUWOAbi
utH9iPFYUfR/aWYWRz5EAyITiHafYpmDAnEEZPZYmdJXo4tLo0oNe7H0Vy8u
yQToxzXJTRGoCB3IGffktgdKrx2z/WIHcGIH8Dd1XWRiON88p2msDxAkgkBn
qtPmplfO/iihj+qOO5O2fTMRs+bXBwUDcyVmaiqaTdqwQqSclhRmswkJ6gJk
Fb6nfpyhIZNYcMaCCzIOTjOYrVITvZGB3GbXILvqtolk7tCFyW5v8DIWqR/T
q+vZsEsBa1Va0aLUBDLrwBOMDik8j7vJ7ZqgGxDv1zKgDw5jPvUIUgMwu1xn
M0yDMLnlOPZpi9g3YsXDFPe3ZPCQ8HJE5hCn2LHI9/pc78/zcLBocbRNOMBZ
Pj3h+M42Xyl4aJ9D75ijndX2b0Dq4/UaOyyGwNwAYTxMrK1awX9f3PZ+gq2d
gc+y+3FEnwD6Xoc+YJiHZoDEScvDAwO0NQA7gBEHHATH5Aj4EHm7AYN6nEGW
RuVR/kBsSr1bPfYR2BlFEywFrhnlvEFLp/zU3CSjdGTYWGwYhs5joWE6NCyk
iK/BNB4wKRsmzCbss7jDCnZhRjwMdhn5/cpmud5K4jB7CDaZnOvaLqt4u5g4
5oZtsmFJ5GuBXcgwh2K7XGd1W3kSTPdkHZnWurNzp2ytY9/WJd46ihm9zjj2
Rprn0sjfAuMqMkcPhW7Y1qyASwNzfF1WxaCywebpr+5kJ+ZhA8J8XhSsrYlz
1nazk/KEfQGnyaGnBDJOBUdjyBjlffrwogg5YMSFlQMLnPmUpxlji0sVnjAZ
eJgTFqEbCz210JubT7aC0SCQcW0T1w54iSO1kAmwCnypqx1UXijzIM86Gki5
D8FSuggtsdASB+0ZwhiOcfVGGBFXV4QrSipIwQUHhlMKQqGLSHiYeULkOvpZ
0JdDMaJ4adQFa9dMjpa3SUfec/GmTqPWgPqfGMDe1eMyXReq962xXUxfrhK7
5I0JzlrorxbtGYtG7RvhcvZgrH0gHpis0LoIOTdmOFdEp3ExvjkjQTenxX4Y
VEEzjvR6rLkea2a9dhzRrU2DLotON7JAIZnpfLiwYF/QMxhOsTzdeD05L7Ok
ncbjkLQ778RYbk0kdZ4XOBxPjax8stVmPgvG5XAcvXLtyeR2FUjGsHPt260F
uhTFXM3h9pv6XbqUXm6odKWxsrCysLqwymT7gTI0b0sawGkmM2u+BrMkeZ6z
gUToXRfAxbmsP4Z7NCYRob1+nk6luYZshp/wovqtlkzINmPdDXjilnZ+JlXa
Zs2JhewBx4oLgaOAvLCx5QRUALkJCTjmaLzowjao/RhhWzzaBahba3hpgXq0
eT/Nmr9tKAmMGIF7XW4Eku5+OwtZcjNHl9q3NdwLkLjFWeZAbhAP/Ngg3E3q
jQ0a3YD9TF6DDf1IYxKaTrVsIpclopEZKmVKY5dClL5bZzsM28FTINmAnhUu
2MmKP0cMWVbv8waxSVoMautvXZ0sO+72hqMeehGx7H5nm80bGkGauot5qrrc
sB7WbuhEBvoUlRfl6T/mnak30S39tDMRO68nNnG8jQe+iNi2TWJNHqwhLepk
H09RFSaj3gv3Zpxd5rWh2dknfin2Pdna3T5MLyZK7NOhfRklcVY2OlspvNt5
pPXR0ulvFzOBaNcie2WKbBbtRdbX/Xvs7Ymyp8jebAdVy3SvkoWWmwQly3gF
a42sZXdFdkrMbT4r2Ikssms3O5Fi9kVpVAf7hGEttLg71YGYx/wMxiDaqX+P
nW+Edko32rATdGOlzEznpNZtEz8492Jn6vfb1iUhiAw1YGglXBHPKDFGECTg
tb0Y2SYlrkZGqnTOeWbmrAdsZRJZGXUnGogUv7qLgRkP7oXsw1rncg/2y2Su
ZR314E1LXAe6NIq9sZKb1tysgWEDsWGYRZ8Aw2RBXSYbiU3Uiza/87NHYfAx
D5ZIRoQ8ICec3xubJKsibNfweejbVBFeuzUdIj0JSBOL1I8iIySdGRJlXrBM
nmXI9N5Rm8b7Teh46GfIgm6GNn2yFQ154z86a9esBbDRaOB5LrWQ0Wvsptyp
xSX+/ib1bIjogvbLCyZCmDXiky0fLvw8lMjHLEFatVeMlr7ydyiw8GD8Tidv
P9pms5iSCJPjoU+2EFAl+9SuFNApAGQAUBcmgfxpBTWcUtN+46wIournM+V2
iRyGRDDgdJ12wqCjjqNc0I4Em4he9HuHM5wS5SBo4lRtQCR+LZgKBzpB4M3R
1KqVl7ttTj+5bXeDrvg9pEhfbdHllHnryQeROvzkUNTh0t+ZSF3VLVvwPyyP
xN2cay48zNtdCVWxq/gSLqx3h3GkkLAW9PNHCImTzn5I5UmYgGA6eN3ph12R
wE38cBjdTWXqVVrMVT/3Yc7zod+siNVI21JbHe+k5aw1zLpMdyg/Sz0+zuzZ
tDzK8eNMCwnBbz2TNt1nfIrjVw3brNWOLi4NKjWeBXe3rppr0/YzgCwhLFV4
0n8m5xm+1SZRY9TKGbKLDbxIYuPd3TovbNs4t/aA45t8Ezi6GK6Vdtv2BmUj
nZBM+A+tHJLEE8gRC+M459p7gSIxgWKVllf9GumTLVy+ilfLA1RZIBj3H9OE
K84uqB6zuManJH/eJzbJio/5DqTWQvJS2CNri240n3xwpnTohm3rk2OON34n
QPkw6qjFxa4VxHUMRvESVo7xaP6RdIhRHHwI2OSrIpVcxgnkLC3g9PHyeHuw
wecmQA4t2EEAa14dLFDZOkQmDLLVEtQmQN0vqMdi1KHsLLk8ANSOpSJqDMu1
PaHuEdQFvpovE2br8OlBocZeRJpUWHgaKkVdyz+ib0O16sKyKweBF6nrAKgw
ABkXHgaLkPNARrdvlZCxvKGFwaoJzuf2D10VsDsaU4YdWVu9FLsW7JMlJG5A
mO1ho0bm07c7akvRpiIWVkfO+zoRYxo8ECMmoA2ka4eCElOcfssQsmYZKkGn
g0HX8P3friFrMcQ6bpyGOAbtyyIoiFn9sW4tSWtDuEhBZZqrdJsPRsWqbOFI
Jx3x8RtoJM/S3TagJTLG7gHK7limJOtoJHl9sar4GE+oykgCdsLvMs67j6w2
B0A8ktbeWHx8vicUj1/1nAa+H2kYByE9sYaq9AdC780ZIqlQ6i27KM7O9ugZ
LqvmCz5thB/ZiL4nvNBeBXV/ziT/86xvr6K7S0T3oOh3gAX2gmQ8ztUdS+4p
kZxlDEp27jPqhq1xCt7tigX3SlNPgcguIEEoEvn0GRBTi0Wi658HwTWYtKbg
Hmnmm50ED4SCtSoVWRH3OAf1q7GwekmLpiUikfO8HQo+MvuURIrUQd+cWpVK
shv8F0BGJZAxHCLTKgjhU35W40srNV0qB6e8KXfWZtHmzNM4NTagXhpIwGRk
WiRMy8T0HpQnwRsjfuRS3SlosUvwhgneOF5AeR7eu1z63lj4XrZ6MglvX2n3
tgrmnqwbqCHOSYNeD2cj/9KEWIa9RnXflDc+2AiPlEr9E1BzMhSpZZUwQ9n2
dZwN0N3wk4Ex6YyPN+BTWHkXBzyOAercinIfnf/Jl3uFp8U+rN4jh+mqsvT6
Rdb23Mw4SvH86ICcllwI6uJzfO87u7srB5pwNSt+jodP8TjrPVkjlXBhz+7g
wyV5KGuU2PbYJ99KFdnBeweKcX7/SqrIdxB4eBWP5i5KFfniyB7Kwofz8lA+
scRRih5/OzsfYCN1mzWcWyJFPoXHw69INm5KFTnmYY/W4cMb8lDO3eHJWJxl
5qSKHFTFoY187ZpUkeO8OJYxEbkkVeQMsz0HiQ9nxVA5bH0VijFWTMv7cuL7
GhQj/zgvVea4yvuhp6LDU5UbXOV6fqYrd0B6eJMfzkExRpqTUuUWV/kAijF+
jEuV21zlQyhGXmQXaxa4ykfh6XXb9LzUyQ8/hmJcBhqQKl9xlU+gGNexeqTK
t1zljxvhDGL3D5b40U04YL8h0wc9ucdPPg2P3tP9d1xsz1D/i29/Cf9Hc4BR
/ssfLpBzHP6fFp2tYORAt1J/hofVsGL+dbUKZRqo93kspBYJccvyByWh4v/B
v4IFHV9Fc77sZLvZn1J7dDcTsFtjfRFWd0irObj9tXdF+lLbU9Vx7+aeoY78
H1LTF0I=\
\>"]]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Shells",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->492142025],

Cell[TextData[{
 "Give the volume for four disks and the function ",
 Cell[BoxData[
  RowBox[{"1", "-", 
   RowBox[{
    SuperscriptBox["x", "2"], "."}]}]], "InlineFormula"]
}], "ExampleText",
 CellID->1471489578],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot3D", "[", 
  RowBox[{
   SuperscriptBox["x", "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "4", ",", "\"\<Shell\>\"", 
   ",", 
   RowBox[{"PlotLabel", "\[Rule]", " ", 
    RowBox[{"RiemannSum3D", "[", 
     RowBox[{
      SuperscriptBox["x", "2"], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "4", ",", 
      "\"\<Shell\>\""}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->903658594],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3T1y4zYUB3DP5CQ5gsu0ewSVW65LFSlcqlXp0qVblttkkiukzBHSptxy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    "], {{0, 178}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 178},
  PlotRange->{{0, 180}, {0, 178}}]], "Output",
 ImageSize->{184, 178},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[1]=",
 CellID->119368905]
}, Open  ]],

Cell["Get decimal results using inexact input.", "ExampleText",
 CellID->1484605862],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot3D", "[", 
  RowBox[{
   SuperscriptBox["x", "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "4", ",", "\"\<Shell\>\"", 
   ",", 
   RowBox[{"PlotLabel", "\[Rule]", " ", 
    RowBox[{"RiemannSum3D", "[", 
     RowBox[{
      SuperscriptBox["x", "2"], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0.", ",", "1"}], "}"}], ",", "4", ",", 
      "\"\<Shell\>\""}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->158228141],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3a2W4zYUB/A5p0/SRxhYuo8QuHAHBhQMDA0cOHBAieGy9hUK+wilhQsX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    "], {{0, 160}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 160},
  PlotRange->{{0, 180}, {0, 160}}]], "Output",
 ImageSize->{184, 160},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->71900510]
}, Open  ]],

Cell["\<\
Give a symbolic form for the function and get a symbolic sum.\
\>", "ExampleText",
 CellID->1479927696],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSum3D", "[", 
  RowBox[{
   RowBox[{"f", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "4", ",", 
   "\"\<Shell\>\""}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->989187118],

Cell[BoxData[
 RowBox[{
  FractionBox["1", "4"], " ", "\[Pi]", " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     FractionBox["1", "4"], " ", 
     RowBox[{"f", "[", 
      FractionBox["1", "8"], "]"}]}], "+", 
    RowBox[{
     FractionBox["3", "4"], " ", 
     RowBox[{"f", "[", 
      FractionBox["3", "8"], "]"}]}], "+", 
    RowBox[{
     FractionBox["5", "4"], " ", 
     RowBox[{"f", "[", 
      FractionBox["5", "8"], "]"}]}], "+", 
    RowBox[{
     FractionBox["7", "4"], " ", 
     RowBox[{"f", "[", 
      FractionBox["7", "8"], "]"}]}]}], ")"}]}]], "Output",
 ImageSize->{267, 32},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1205668587]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Washers",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->16248617],

Cell["Four washers determined by two functions.", "ExampleText",
 CellID->360082750],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot3D", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Sin", "[", "x", "]"}], ",", 
     SuperscriptBox[
      RowBox[{"(", 
       RowBox[{"2", 
        RowBox[{"x", "/", 
         RowBox[{"(", "\[Pi]", ")"}]}]}], ")"}], "2"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", 
     RowBox[{"\[Pi]", "/", "2"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"y", ",", "0", ",", "1"}], "}"}], ",", "4", ",", "\"\<Washer\>\"",
    ",", 
   RowBox[{"PlotLabel", "\[Rule]", " ", 
    RowBox[{"RiemannSum3D", "[", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Sin", "[", "x", "]"}], ",", 
        SuperscriptBox[
         RowBox[{"(", 
          RowBox[{"2", 
           RowBox[{"x", "/", 
            RowBox[{"(", "\[Pi]", ")"}]}]}], ")"}], "2"]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", 
        RowBox[{"\[Pi]", "/", "2"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"y", ",", "0", ",", "1"}], "}"}], ",", "4", ",", 
      "\"\<Washer\>\""}], "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->301862004],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3Tty40YQBmBV+SQ+gkKnOoLCDVehAgcKmTJUqFApQmf2FRzuEZxuuKFC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    "], {{0, 156}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 156},
  PlotRange->{{0, 180}, {0, 156}}]], "Output",
 ImageSize->{184, 156},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[1]=",
 CellID->545672578]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["RiemannSumPlot3D",
   BaseStyle->"Link",
   ButtonData->"paclet:Classroom Utilities/ref/RiemannSumPlot3D"],
  FontFamily->"Verdana"]], "InlineFormula"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Working with Riemann Sums",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/WorkingWithRiemannSums"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"RiemannSum3D - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 30, 7.0012624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "RiemannSum3D[f, {x, x_min, x_max}, n, \"Disk\"] returns the volume of \
the disks used genrated by RiemannSumPlot3D.RiemannSum3D[f, {x, x_min, \
x_max}, n, \"Shell\"] returns the volume of the shells created by \
RiemannSumPlot3D.RiemannSum3D[{f$1, f$2}, {x, x$min, x$max}, {z, z$min, \
x$max}, n, \"Washer\"] returns the volume of the washers created by \
RiemannSumPlot3D", "synonyms" -> {}, "title" -> "RiemannSum3D", 
    "titlemodifier" -> "", "windowtitle" -> "RiemannSum3D", "type" -> 
    "Symbol", "uri" -> "Classroom Utilities/ref/RiemannSum3D"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6279, 187, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->586185000]},
 "RasterizedOutput"->{
  Cell[15542, 413, 4516, 82, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->119368905],
  Cell[20693, 520, 4458, 81, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->71900510],
  Cell[27838, 704, 4382, 80, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->545672578]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 35869, 891},
 {"RasterizedOutput", 36012, 895}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[605, 21, 2763, 64, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3393, 89, 55, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3451, 92, 1895, 56, 201, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5383, 153, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->314400113],
Cell[5995, 173, 110, 3, 70, "Notes",
 CellID->1067943069],
Cell[6108, 178, 134, 4, 70, "Notes",
 CellID->1174439591]
}, Closed]],
Cell[CellGroupData[{
Cell[6279, 187, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->586185000],
Cell[CellGroupData[{
Cell[6794, 205, 195, 6, 31, "ExampleSection",
 CellID->283260817],
Cell[6992, 213, 67, 1, 32, "ExampleText",
 CellID->1284006360],
Cell[7062, 216, 127, 3, 28, "Input",
 CellID->231723817],
Cell[CellGroupData[{
Cell[7214, 223, 276, 8, 20, "ExampleSubsection",
 CellID->280223111],
Cell[7493, 233, 212, 7, 70, "ExampleText",
 CellID->278188706],
Cell[CellGroupData[{
Cell[7730, 244, 558, 17, 70, "Input",
 CellID->445682223],
Cell[8291, 263, 6174, 106, 194, 546, 9, "CachedBoxData", "BoxData", "Output",
 CellID->279469202]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[14514, 375, 277, 8, 18, "ExampleSubsection",
 CellID->492142025],
Cell[14794, 385, 213, 7, 70, "ExampleText",
 CellID->1471489578],
Cell[CellGroupData[{
Cell[15032, 396, 507, 15, 70, "Input",
 CellID->903658594],
Cell[15542, 413, 4516, 82, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->119368905]
}, Open  ]],
Cell[20073, 498, 84, 1, 70, "ExampleText",
 CellID->1484605862],
Cell[CellGroupData[{
Cell[20182, 503, 508, 15, 70, "Input",
 CellID->158228141],
Cell[20693, 520, 4458, 81, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->71900510]
}, Open  ]],
Cell[25166, 604, 113, 3, 70, "ExampleText",
 CellID->1479927696],
Cell[CellGroupData[{
Cell[25304, 611, 255, 8, 70, "Input",
 CellID->989187118],
Cell[25562, 621, 704, 25, 53, "Output",
 CellID->1205668587]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[26315, 652, 277, 8, 18, "ExampleSubsection",
 CellID->16248617],
Cell[26595, 662, 84, 1, 70, "ExampleText",
 CellID->360082750],
Cell[CellGroupData[{
Cell[26704, 667, 1131, 35, 70, "Input",
 CellID->301862004],
Cell[27838, 704, 4382, 80, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->545672578]
}, Open  ]]
}, Closed]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[32293, 792, 446, 13, 45, "SeeAlsoSection",
 CellID->1255426704],
Cell[32742, 807, 236, 6, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[33015, 818, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[33466, 833, 185, 4, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[33666, 840, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

