(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    118462,       2684]
NotebookOptionsPosition[    110584,       2432]
NotebookOutlinePosition[    113665,       2512]
CellTagsIndexPosition[    113541,       2506]
WindowTitle->RiemannSumPlot - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Integrals as Limits\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/IntegralsAsLimits"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Integration Techniques\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/IntegrationTechniques"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/RiemannSumPlot\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/RiemannSumPlot"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/RiemannSumPlot.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/RiemannSumPlot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["RiemannSumPlot", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"RiemannSumPlot", "[", 
       RowBox[{
        StyleBox["fun", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["var", "TI"], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["n", "TI"], ",", "\"\<\!\(\*
StyleBox[\"type\", \"TI\"]\)\>\"", ",", 
        StyleBox["opts", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]generate a plot of ",
     Cell[BoxData[
      StyleBox["fun", "TI"]], "InlineFormula"],
     " on the interval (",
     Cell[BoxData[
      RowBox[{
       SubscriptBox[
        StyleBox["var", "TI"], 
        StyleBox["min", "TI"]], ",", 
       SubscriptBox[
        StyleBox["var", "TI"], 
        StyleBox["max", "TI"]]}]], "InlineFormula"],
     ") and approximates the area under the curve using ",
     Cell[BoxData[
      StyleBox["n", "TI"]], "InlineFormula"],
     " polygons of ",
     Cell[BoxData["\"\<\!\(\*
StyleBox[\"type\", \"TI\"]\)\>\""], "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData["RiemannSumPlot"], "InlineFormula"],
     "[{",
     Cell[BoxData[
      RowBox[{
       SubscriptBox[
        StyleBox["f", "TI"], 
        StyleBox["1", "TR"]], ",", 
       SubscriptBox[
        StyleBox["f", "TI"], 
        StyleBox["2", "TR"]]}]], "InlineFormula"],
     "},{",
     Cell[BoxData[
      RowBox[{
       StyleBox["var", "TI"], ",", 
       SubscriptBox[
        StyleBox["var", "TI"], 
        StyleBox["min", "TI"]], ",", 
       SubscriptBox[
        StyleBox["var", "TI"], 
        StyleBox["max", "TI"]]}]], "InlineFormula"],
     "}",
     Cell[BoxData[
      RowBox[{",", 
       StyleBox["n", "TI"], ",", "\"\<\!\(\*
StyleBox[\"type\", \"TI\"]\)\>\"", ",", " ", 
       StyleBox["opts", "TI"]}]], "InlineFormula"],
     "]\[LineSeparator]generate a plot of two functions ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["f", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["f", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula"],
     " and fill between the curves with ",
     Cell[BoxData[
      StyleBox["n", "TI"]], "InlineFormula"],
     " polygons of ",
     Cell[BoxData["\"\<\!\(\*
StyleBox[\"type\", \"TI\"]\)\>\""], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->19823374],

Cell[TextData[{
 "The default for ",
 Cell[BoxData[
  RowBox[{"\"\<\!\(\*
StyleBox[\"type\", \"TI\"]\)\>\"", " "}]], "InlineFormula"],
 "is ",
 Cell[BoxData["\"\<Left\>\""], "InlineFormula"]
}], "Notes",
 CellID->769486016],

Cell[TextData[{
 "Any of ",
 Cell[BoxData[
  RowBox[{
  "\"\<Left\>\"", ",", " ", "\"\<Center\>\"", ",", " ", "\"\<Right\>\""}]], 
  "InlineFormula"],
 " or ",
 Cell[BoxData[
  RowBox[{"\"\<Trapezoid\>\"", " "}]], "InlineFormula"],
 "can be used for",
 Cell[BoxData[
  RowBox[{" ", "\"\<\!\(\*
StyleBox[\"type\", \"TI\"]\)\>\""}]], "InlineFormula"],
 "."
}], "Notes",
 CellID->675350009],

Cell[TextData[{
 "With two functions ",
 Cell[BoxData["\"\<LeftRight\>\""], "InlineFormula"],
 " and ",
 Cell[BoxData["\"\<RightLeft\>\""], "InlineFormula"],
 " can also be used for ",
 Cell[BoxData["\"\<\!\(\*
StyleBox[\"type\", \"TI\"]\)\>\""], "InlineFormula"],
 "."
}], "Notes",
 CellID->975693726],

Cell[TextData[{
 "The ",
 Cell[BoxData["\"\<\!\(\*
StyleBox[\"type\", \"TI\"]\)\>\""], "InlineFormula"],
 " determines how the height of the polygon is determined."
}], "Notes",
 CellID->1524285436],

Cell[TextData[{
 Cell[BoxData["RiemannSumPlot"], "InlineFormula"],
 " has the same options as ",
 Cell[BoxData[
  ButtonBox["Plot",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/Plot"]], "InlineFormula"],
 ", with the following additions and changes: "
}], "Notes",
 CellID->1332897789],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["AspectRatio",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/AspectRatio"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[
    "set unit on both axes to have equal size", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["BarStyles",
     BaseStyle->"Link",
     ButtonData->"paclet:IntegrationTechniques/ref/BarStyles"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[
    "set the styles of the polygons", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["Subintervals",
     BaseStyle->"Link",
     ButtonData->"paclet:IntegrationTechniques/ref/Subintervals"], 
    ButtonBox["Uniform",
     BaseStyle->"Link",
     ButtonData->"paclet:IntegrationTechniques/ref/Uniform"], Cell[
    "set the subintervals to be of equal size", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True}}}},
 CellID->976286479]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->128594038],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->336924786],

Cell["\<\
The syntax of RiemannSumPlot parallels that of Plot, but requires two \
additional arguments.\
\>", "ExampleText",
 CellID->1997212051],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1973538547],

Cell[TextData[{
 "Approximating the area under ",
 StyleBox["f(x) = ",
  FontSlant->"Italic"],
 Cell[BoxData[
  SuperscriptBox[
   StyleBox["x", "TI"], "2"]]],
 "/2 using 12 rectangles on the interval (0, 3/2)."
}], "ExampleText",
 CellID->969458538],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot", "[", 
  RowBox[{
   RowBox[{
    SuperscriptBox["x", "2"], "/", "2"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", 
     RowBox[{"3", "/", "2"}]}], "}"}], ",", "12", ",", "\"\<Left\>\""}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->617741138],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], RectangleBox[{0., 0}, {0.125, 0.}], 
     RectangleBox[{0.125, 0}, {0.25, 0.0078125}], 
     RectangleBox[{0.25, 0}, {0.375, 0.03125}], 
     RectangleBox[{0.375, 0}, {0.5, 0.0703125}], 
     RectangleBox[{0.5, 0}, {0.625, 0.125}], 
     RectangleBox[{0.625, 0}, {0.75, 0.1953125}], 
     RectangleBox[{0.75, 0}, {0.875, 0.28125}], 
     RectangleBox[{0.875, 0}, {1., 0.3828125}], 
     RectangleBox[{1., 0}, {1.125, 0.5}], 
     RectangleBox[{1.125, 0}, {1.25, 0.6328125}], 
     RectangleBox[{1.25, 0}, {1.375, 0.78125}], 
     RectangleBox[{1.375, 0}, {1.5, 0.9453125}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV0Hk81AkDx3GK2MqjEiLHuibHllR0mm9Jrq1tRAiVQZpkGZT72pwNgyjl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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 275},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1797491740]
}, Open  ]],

Cell["\<\
The height of the rectangles can be determined by the value of the function \
at the left, center or right end of the interval.\
\>", "ExampleText",
 CellID->731218377],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot", "[", 
  RowBox[{
   RowBox[{
    SuperscriptBox["x", "2"], "/", "2"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", 
     RowBox[{"3", "/", "2"}]}], "}"}], ",", "12", ",", "\"\<Right\>\""}], 
  "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->2014057424],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], RectangleBox[{0., 0}, {0.125, 0.0078125}], 
     RectangleBox[{0.125, 0}, {0.25, 0.03125}], 
     RectangleBox[{0.25, 0}, {0.375, 0.0703125}], 
     RectangleBox[{0.375, 0}, {0.5, 0.125}], 
     RectangleBox[{0.5, 0}, {0.625, 0.1953125}], 
     RectangleBox[{0.625, 0}, {0.75, 0.28125}], 
     RectangleBox[{0.75, 0}, {0.875, 0.3828125}], 
     RectangleBox[{0.875, 0}, {1., 0.5}], 
     RectangleBox[{1., 0}, {1.125, 0.6328125}], 
     RectangleBox[{1.125, 0}, {1.25, 0.78125}], 
     RectangleBox[{1.25, 0}, {1.375, 0.9453125}], 
     RectangleBox[{1.375, 0}, {1.5, 1.125}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwV0Hk81AkDx3GK2MqjEiLHuibHllR0mm9Jrq1tRAiVQZpkGZT72pwNgyjl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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 275},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1791211831]
}, Open  ]],

Cell["\<\
Different colors are used when the rectangles would subtract from the total \
area.\
\>", "ExampleText",
 CellID->1685834105],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot", "[", 
  RowBox[{
   SuperscriptBox["x", "3"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", "13", ",", 
   "\"\<Center\>\""}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1676795276],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3S2Tq9yaxvGemi8x9nyEI9s+MhKJHGqqpgoxAolFIpFYJBKJRSKRWCQS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    "], {{0, 357}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 357},
  PlotRange->{{0, 360}, {0, 357}}]], "Output",
 ImageSize->{364, 357},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->172938552]
}, Open  ]],

Cell["\<\
With two functions the area between the curves is filled with rectangles with \
the color being set by whether the first function is larger or smaller than \
the second.\
\>", "ExampleText",
 CellID->2062047864],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Sin", "[", "t", "]"}], ",", 
      RowBox[{"Cos", "[", 
       RowBox[{"2", " ", "t"}], "]"}]}], "}"}], "/", "2"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", 
     RowBox[{"\[Pi]", "/", "3"}]}], "}"}], ",", "17", ",", "\"\<Center\>\""}],
   "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1183525861],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     RectangleBox[{0.4927988476219283, 0.24999999999999997`}, \
{0.5543987035746694, 0.25000000000000006`}], 
     RectangleBox[{0.5543987035746694, 0.2761824864802529}, \
{0.6159985595274104, 0.1948929366463397}], 
     RectangleBox[{0.6159985595274104, 0.3013173181896282}, \
{0.6775984154801515, 0.1368314950360414}], 
     RectangleBox[{0.6775984154801515, 0.325309150102121}, \
{0.7391982714328925, 0.07669582743934271}], 
     RectangleBox[{0.7391982714328925, 0.34806697298146333`}, \
{0.8007981273856335, 0.015397529278085164`}], 
     RectangleBox[{0.8007981273856335, 0.36950445861032954`}, \
{0.8623979833383747, -0.04613417973165106}], 
     RectangleBox[{0.8623979833383747, 0.38954028726283524`}, \
{0.9239978392911157, -0.10696654160324882`}], 
     RectangleBox[{0.9239978392911157, 0.4080984561781108}, \
{0.9855976952438567, -0.16617739973982976`}], 
     RectangleBox[{0.9855976952438567, 0.42510856786480705`}, \
{1.0471975511965976`, -0.22286917788826913`}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     RectangleBox[{0., 0.015397529278085176`}, \
{0.06159985595274104, 0.49905166436852205`}], 
     RectangleBox[{0.06159985595274104, 0.046134179731650994`}, \
{0.12319971190548208`, 0.4914865498419509}], 
     RectangleBox[{0.12319971190548208`, 0.07669582743934268}, \
{0.18479956785822313`, 0.4764710002135783}], 
     RectangleBox[{0.18479956785822313`, 0.10696654160324871`}, \
{0.24639942381096416`, 0.4542326359097618}], 
     RectangleBox[{0.24639942381096416`, 0.13683149503604142`}, \
{0.3079992797637052, 0.4251085678648071}], 
     RectangleBox[{0.3079992797637052, 0.16617739973982984`}, \
{0.36959913571644626`, 0.3895402872628352}], 
     RectangleBox[{0.36959913571644626`, 0.1948929366463397}, \
{0.43119899166918735`, 0.34806697298146333`}], 
     RectangleBox[{0.43119899166918735`, 0.22286917788826913`}, 
      {0.4927988476219283, 0.3013173181896282}]}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwl0Ws01AkYBvBm0lnsLJtuqy2bCK0UHVS25jFtTWmWIk1H6RTGZXFMG7aM
bGZdIqXWxFZMTHG6zGSMWZeaKOUSImGG8Zc1ZOxk8O+yqY3a2bMf3vOc8/vw
PB9e62CuXyh11qxZ3ob7L6Ufqy3SXrHp/yeTbsk80VlLc4NFQ/TjWtoKXFsW
P36OthWHFY7Kcwaf+IL8J4G2B2uqWi8mGDwn9RY/hhYKH7HVTLTBn4PWEEGL
R5q7qjzY4GeECm0oLQ3p8tdCb4MH/SA4yqHlgh2o959t8GJZSDV1sgQ83ydf
scZzwZoe8FzOKoOnaOqY7/Yi5BSdjJidWgH/b6jvTyaVoDErmOa6WgGPSQ83
G2sxAlt8xO3f3Yc1+71e4lwG1pE0M0fLh3D6UuNK+0wOUd8Ggb2uAc3yUre2
tgr0+FpF3c94BOdgns+B4Gqk6L+mUIJaEW+0aXapowLmeV4vnhm3wwm+DvwH
NaAk83i3fDvAO7bg+Rnb+6hs7B+A4imoyu/zwvh16JvfE11E60LY7XfRZP0D
3HnzTO3P60b5rlOJbOt6tP1xdW+ARolKt4asgbgG7DpO+eTo3IPp9iXsFdJG
ZCuj0vzyeyHkMOdtoTzCRvcYt20TarguXh9h49GMEoek+rMHCJiKOxTGp1qw
+cMOjkNjPzpmxsJ+6WiFj7LM6ezCAaw1afd7OfMYCxg2Kq+UP6HbyivayGiH
fd9Cf13UILgFSZcKo56gPyWxQWmhQbcxozCE2QHuz2F2+iYNWLIrMqamA3ei
lxboDg+B7tVcreM+xZB4H2WuwzBWPe4X7TfuhO3+qZhBYhjnVrIFjfmdsDI7
9DIv5TnsRPY73Wy68NZkZ8jRDSOoaKEk18m7kG5i+oI+PAJ+f3LkkfXdWJNg
m1CaqUX2ad67A9XdqHRpmNpGH0Uhq/yZzFOJv8ddsh5pR9G0dB3Jr1Fi7mtb
s1jhX5gnnZdgt1mFkQ/DJUbbdYa/L6iKVajQFUdl0id1yIvzZ4+v6UGh+zWl
qPgFBj+pVh8T92D59CKe3nsMc+zukIuW9CLF1NwsaI4ejg47FCsFvfiYEXoz
6bYevZOeez4aqeHyecZ+ftA4pCs4P4VEq8FQOU+XLpoA48pgcbhaDZOSEtnD
uglcvux112NjH8aGE7jJEZO4UCe39b7UB5VbZLbcjERGapLlqpk+5CQmcReH
kDhYMbeFwyag357pI+CQeKtNjNfvJcBcmOtECyMhLLg6EhtA4EOZZGwmggRz
t9X8XwMJcLREuCaGxJItnBv5wQTcfT0OXeeR0JzyKX8YQ0BtN7XLPcfQ13rR
bjSdgOsbqrNUQCL9vF9IeAaB7Dozc4dcEjVPDnJGMwlsDrRrs7xAolYYKdee
JnDztz1eM0ISfJk2dSiHwPFpOaP+BomiVVdftV8moGq+t2yTmMT5b6xiWUUE
nH9v/VQhIbGp9nZVk4jAiMtwzTUpCakV88y9YgI+4RYeWRUk9kUE/Ci5SeC6
q5WlUZVhT3bC1F5CgEr99t3xahKUNxKu6BaBqgJGZYyCRKDAPD23jIBFpHfu
6F0Sqkz6OvNyAtHrAuIO1ZIgxeGSDDmBRqPQ3ep7JK40nRyhVBBY1nl4rV8d
iRBx/hCvksC/yM9lnw==
      "]]}, 
    {Hue[0.9060679774997897, 0.6, 0.6], LineBox[CompressedData["
1:eJwV1Hk01tsaB3AcOdGb0qCMV45Q4qaiy8E3Q0kDpXSiOkVJV1IoTiJDRBR6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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 250},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->742193745]
}, Open  ]],

Cell["Trapezoids can also be used to approximate the area.", "ExampleText",
 CellID->747354962],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot", "[", 
  RowBox[{
   SuperscriptBox["x", "4"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "3", ",", 
   "\"\<Trapezoid\>\""}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->609960649],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
    AbsoluteThickness[0.4]}], 
    PolygonBox[{{{0., 0}, {0.3333333333333333, 0.012345679012345678`}, {
       0.3333333333333333, 0}}, {{0.3333333333333333, 0}, {0.3333333333333333,
        0.012345679012345678`}, {0.6666666666666666, 0.19753086419753085`}, {
       0.6666666666666666, 0}}, {{0.6666666666666666, 0}, {0.6666666666666666,
        0.19753086419753085`}, {1., 1.}, {1., 0}}}]}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVVWc4Fn4XRgMpSouQFFIJiZ6o53dbRUbKKBJRKCQjCYlshSiylZ2RyN57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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->Automatic,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 359},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->1465250439]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(2)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2061341341],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "BarStyles",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1757724783],

Cell["\<\
BarStyles allows for various ways of styling the bars. There are three values \
available, Automatic, MonoColor and None.\
\>", "ExampleText",
 CellID->645002374],

Cell["Making positive and negative bars the default color.", "ExampleText",
 CellID->162995031],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot", "[", 
  RowBox[{
   RowBox[{"Sin", "[", "\[Theta]", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"\[Theta]", ",", "0", ",", " ", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", "19", ",", "\"\<Center\>\"", 
   ",", 
   RowBox[{"BarStyles", "\[Rule]", " ", "MonoColor"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1337992431],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS+Xq7wWxueu+yVe+36EI8eOrEQiX8xdK+IKxBVYZCQyNhKJxCKRSCwS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    "], {{0, 119}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 119},
  PlotRange->{{0, 360}, {0, 119}}]], "Output",
 ImageSize->{364, 119},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[1]=",
 CellID->265214609]
}, Open  ]],

Cell["Display outlines with no color for the bars.", "ExampleText",
 CellID->1415836092],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SuperscriptBox["x", "2"], ",", 
     SuperscriptBox["x", "4"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "15", ",", "\"\<Left\>\"", 
   ",", 
   RowBox[{"BarStyles", "\[Rule]", " ", "None"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1976266416],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS2XpD6bh2fPfpL9GGNHtiyJXMTuOYgVSCwSicQikZHYSGQkFolEsknR
XU3xVgESKkn9rjNPP/2v7s7cTHeuzut9/9d//9/tv//zz58///Mff/78L/+f
eL/fyYEvAQB8OPAGAGAv8AYAoO9Z8pfLwCezDxCfv/7nb8LGL8IbAIA7XB0z
b3Br3F8j/pM54A0AwJ0Fb/y+9CwOeAMAcGfBGz/DDXgDALDIvvHGmCujBABc
Sdt2mZeufxzrGwCAKXlcZl6y9tFh3+Rn42Q8QcF+CgAfStf10VfK8lJJa/AG
AJ9AmtLcS5qqVtIavAGA8/DBhu+R7F+oqkF4AwDnSdOqSMsyzFQ1CG8A4DZ8
sOHdCpaXlaLFjR7eAMB10pSSghV+0tWtqjbhDQAcpm07zyv6rs+/YoXNwhsA
OEyWVkXBGsrKSNniRg9vAOAuYmWDDzb6vkpJTajCluENAFwlTSkfbPTizGfa
1o3CluENAJzkMdjg5F+R2sbhDQCcJL2vbPB3arG4kattHN4AwD2GMxvD+1VG
WKFycaOHNwBwkeHMxvC+2pMbA/AGAI7xfWZjoOvzm8qTGwPI2AOAY8RRSen3
vde6rGiseHGjx3gDALdoms73i8d/0qTg6lD+t8AbALhEJAYbv0c1Ci/uWsWL
Gz28AYBD1HUbBKMUoW1XaFjc6OENABxiMthgBa3SeQU2BcAbALjBZGWDQ+O8
oWzt888AbwDgBnywUdGnSyjZV9R3Wv4ueAMAB6iqhntj/EpbNyTYqJZyCngD
AAcIfFI/HwplBaV6Fjd6eAMA+5kPNjhlmLWKqh7MgTcAsB3fL+p6upCh/O78
GHgDAKuhtInj6WBD6+JGD28AYDn+bGWjF3fnS1UlHReBNwCwF0LqJFnIrcEH
Gy1TmRhwArwBgL14t7ybn9Do9C5u9PAGANZSFCzLFu661iWjcTF/XSHIvwGA
pXhe0bYL50HF3Xmi/u78GBgDABshpE7TZTkUXtwv+UQh8AYA1jHUOFhY2Rh2
YH2NO7AD8AYA1sFHGny8sfihmui6Oz8G3gDALp7SDs8gYdZoO17+AN4AwC6y
7Lug0iI6spfPgTcAsIh7QaXV/OQt03u8/AG8AYBFiOQ81epBUOV159eANwCw
BZF22N9a81Red34NeAMAW4hjSum6FrRlL58DbwBgBYy1t680XicJotSLNj5h
QEkw8AYAVuD7RRQlG59A46IuX2QvhzcA+BworaOo3O71MtnL4Q0APgc+2Gjb
bqPXSyb4gjcA+BCKgqWp2F3d6PUsL6vsdYIveAOAD8G7fV9h2+j1JJRK8AVv
APAJ8JEG+TlVvtrrO9kdWIXeQN4eAMxkcoVtrdc3VV1Gq4fPx2C8AYDzZOnT
Fba1Xi+f4AveAMBt5vXl13p94SVdOy2FsAi8AYDbRFE5OVW+2Ou7tpO/Ow9v
AOAwNWuDYHqFbbHXs4JWmWyCL3gDAIdZrMK22OvLPQm+4A0AXGWxvny/0ut3
lViCNwBwFd8vmmbhqsm819eUSe7ArrVwDHgDAKNYq8LWL/V6sQNb7iixBG8A
4CRrVdj6pV6f36J+sYzKCvAGAO6xnat80usl78ButHAYeAMAQ+ADh9t6rvJ+
1usl78ButHAYeAMAQ0gTulaFbWDS6/lgY28W4q0btb64p/Y3mYx2WPL3z/wD
8AYAJlDXrb+Zq7yf9Pqu27UDu9DCGG6N+99O/GdBcG18v/5nHB28AYAJxPH0
VPnS5/z2+rqsaLJa7VGmhTE/epiL41sY5Flq8AYAb4exNpydKp8z7vVlnDf0
RRbi7RbG/A4npt74nsBMhkLwBgBvZ+2g14Rxrxd32XZswC60MGZrvDEMN54X
OP48szsOAMA5SlIniVRxxkevP1wHdvf6xs/rXCzjD8AVALwXzyskj249en2V
EVYcqQMrvZ/ymLj87Kf8wfoGAKaQ56unyuc8er1I1NNIJepZa+Ek8AYA74IP
M8bpQ1/y3etP1IGFNwCwnTimZSmbOqP/6fWM0CqVTdSz2MJ54A0A3kJdL2T0
2mbo9WWUyyfqWWzhPPAGAG8hDAmrjpwSz/YfE520cB54A4DrWcvotQ3v9fdS
KdnhvxfeAMBe+AylqXcf2+K9nqYFI0d2YB8tHP7aMfAGABezkdFrG97rxU7K
SlYfyRYOf+0YeAOAK+k6cap8LaPXNkkYE//IMdEH8AYANrKd0WubNIirfPeq
yBh4AwDraOpu797rmPQr7GZFVXYBbwBgHVFYVtXBjt+13Zkd2AF4AwC7oLQ+
sPf6gBU09aL4NEqeBd4A4BoOL4cOkDBt2b5zYvqANwC4gKJgvpeeGSdk/8J3
P8QvyNgDgG66rv/6On7IsxfZRBlNClWzjPPAGADoJolpcCg91wNyLzoPbwDw
IQz3Xk92+fxLfDm8AcCHEPiEq+NMl28oK2NRxw3eAOATKMvvnMNnuvy96Dw7
2Yha4A0A9HG75UPO4TNdXtxlu7cCbwDgPGlaPeq9Hu7youRBmJ1sRDnwBgA6
mKQBPNzlxSSFVCcbUQ68AYAOoqisRmkAD3d5UfKgbU82ohx4AwDlUDpNA3is
y7f1U102eAMAh/G8on2+9nqsy0/qssEbALjKYgm2Y12+8JN2VJcN3gDASdq2
WyzBdqDLd21XeMnJRjQBbwCgkLUSbAe6fJWXVaZgkUQH8AYAqmCsDcPlNIAH
ujwJpgk34A0A3MP3i3qlKsreLs8nKfmseDS8AYBjbFdF2dvlWV6ybJpU0Chv
IG8PACdp2873yUYawL1dfj5JOdCIPmAMAM5zv4qyVRVlX5cXOykLnw9vAOAM
k6soi+zq8vOdlAONaAXeAOAkvl80zYtE5bu6/OIkZW8jWoE3ADiDWA5NXxeJ
lu/yizspexvRDbwBwGGG5dBOoiiKfJdf3EnZ24hu4A0ADpMk9JGZZxv5Lr82
SdnViG7gDQCOsXE6dI5sl1/ZSdnXiH7gDQCOEQRk7XToHMkuv7aTsquRC4A3
ADjA9unQOZJdfmOSIt/IBcAbAOxl7bL8BjJdfmMnRb6Ra4A3ANjL2mX5zS95
3eU3dlLkG7kGeAOAXVRVI78c+kCmy29PUiQbuQZ4A4Bd+H6xcX9tjdddfnMn
RbaRq4A3AJAnz6o837q/tsbLLr+9kyLZyGXAGwBI0jTdy/tra7zs8i8nKTKN
XAbybwAgSRg+lVLaxXaXf7mTItPIlcAYAMjwqCx/jO0u/3InRaaRK4E3AJDB
8wqZ+2trbHd54qdt/XokA28AYBGp9P21NTa6/LxOyoFGLgbeAGAbxtrbLYtP
s9b+pJjjBvAGALYQBCSKpMYDG2x0+XHF+cONXAy8AcAGw/218x12rYWW1eOK
88cauR54A4A1+ChguL+mzxs0KWoie68W3gDAfMKAMCZmEPq8UdziXnqfBt4A
wHDGBzY0eaOp6jLKTzbyFuANAOa0bReM6q9p8kYZ5w3dcdsF3gDAZJKY0lGG
DS3e6O6TlJONvAl4A4AJ8wwbOrxRlxWN1ScNuwZ4A4AJ8yPlOrxBwtcXYF82
ohDii/utf5OFeRNL/k4+BG8AMGaxJIpyb4iz5TsnKUrCWIVbwyf3/5+ag0tj
LhN4A4AHNVuuEK3cG6ygVaYl2eAxuBz8IZyJOIahhsAfhwtvAPDgXhJl4ci3
cm8UftIt/UW7GlHIz3Bj6o3HYIN/wmSeMkZTVACYT56zPF8+uqnWG13Tcm+c
bEQta+ONtdfhCgD6ew5A31/d3VDrjSorWf46S4+OMFZZW9/4GWf8CuQOvAFA
vz5DGVDrDbEiuj8jupIwNnjeTxlPXObLG/AGAGKGsl20UaE3xNnyMDvZyNuB
N8CHI5OlXKE3xAXYckdhWbVhqALeAB+OTJZyhd7IvqLzjbwdeAN8MiWpU4ks
5aq8UZOqSg9WYFEShirgDfCxyJeVV+UNmeJKWsNQBbwBPpYw/E7L8xIl3hDH
NuTylusLQxXwBvhMCNlRR0mJN2gqm7dcXxiqgDfAB9J1oqy8fB0lJd4Qg40z
pZvgDQDeShTtq/R6vsOmYVxGB49tKAxDFfAG+DQOVHpV4I1bxNVxnpNhqALe
AB8FnyhI7qGMOdlhu7bL/oVnWjANeAN8FPJ7KGNOeoMVNPWPH/cyEHgDfA6E
sDQ9csb7pDfyW5wYM8VQArwBPoS27Xz/4FnNM95omLjIZs7ShBKQsQd8CDL3
UNY40+tpnNelggqzRgFjgE9A8h7KGmd6fX7PPwxvAGAX8vdQ1jjc60X+4ftF
NngDALs4tocy5nCvFxfZ6uZMC2YCbwC3yfPK99O3HLjq6t/8w/AGALbQNN3t
dvZ0d3+014vUXqQ604KxwBvAYfgMJQxPXV0fONLru6eKbPAGAFYw1ENR0mEP
NFITOk7tBW8AYD513YaBso2MA41MKrLBGwCYj+8X7b1GyVu80bJpsQN4AwDD
SVNKiu+qY2/xxnBG9EwLhgNvAMdgrAnD3yqKb/BG149XRBWGYQ7wBnCJrusD
nzTNbzq+673B8rLKpuVf4Q0AjCVJaFnW41eu90bhJd2s/Cu8AYCZVLSJIi2/
6OUbaShbzCMKbwBgICJF+dLltYu9UUZ5U9Xz1+ENAAwkCJYvr13pDT49yWcr
ogrDMAfk7QEOUOQsy5YTAF7pjSorWT6dKCkMwxxgDGA7fJgRhqsJAK/0hhhs
rFRWgjcAMAo+QxlvvE64zBsNZTTOtYZhDvAGsBqx8UoW1iEfXOaNMswWV0QV
hmEO8Aawl6pa2HidcI03RK15f+vCPrwBgAlIVl67xhvjFD36wjAHeANYimTW
0Cu80XWi1rz+MMwB3gA2kmdVnjOZz7zAG4sXUnSEYQ7wBrAOsfEayFZeu8Ab
4vbr6n6OyjDMAd4AdjG/8bqNbm+w53yAWsMwB3gD2EUcU0p3lGvU7Y1HhZQL
wjAHeANYRFnW3Bu7vkSrN9Zuv2oKwxzgDWAL94Lyu8s1avXG2u1XTWGYA7wB
bIFLQ35Z44E+b/DpCfHTK8MwB3gDWEGaULJ5nnwNfd6oUsKI7KQJ3gDgYiit
X54nX0OXN7rVVBv6wjAHeAMYTtt2QUBWrqe/RpM3qnw11Ya+MMwBeXuA4Uie
J19DkzcWkw/rDsMcYAxgMr6fBn4Sn+N8GJNGalLRZN/ODrwBwDVQ2txushsW
a+jwxqT262VhmAO8AcykbcXGaxy/uGf6EuXeEGe91vN6aQ3DHOANYCZhQOq6
Pd/dlHtDHCxnOw66KwzDHOANYCBpWg2nNUzzxsu8XlrDMAd4A5gGpU38c1rD
NG+UUcbnKe8KwxzgDWAUk9MaRnlDHCwPDq7TwhsA6CO4L2s8/tMob5RRXh8a
bKgKwxzgDWAOOqrJq/LG4ZUNhWGYA7wBDIGQmntj8qI53ji8sqEwDHOAN4AJ
8LnJYq1GQ7yRxPHLjOUXhGEO8AZ4OyJlaEDapesehngj9SNW7MszpiMMrRBf
3FP7myyNqVjy13+yOrwB3s7GzTUjvNH12VeYJO+/JqMRbo27GYg/N8fdKPAG
MIksq4pidd3ABG/QlKSB2b3+NL8Dipk4iO8TjDeASYgjXvFWFou3e6NrRS22
xPDRwml+hhszbwhrLM9TxlwaK/hsmqZ9mZDn7d4QyQALavos4zQr4w3+8q8c
xj6BK8C74NJ4mWf4zd7o+sKLlYRhOlvrG1gXBaYQRaVM+aT3eoPeBxtKwjCf
5/2U34mLAN4ABlAULMsqmc98pzdGVeY/wRu7gDfAxVRVs3jEa5E3eqP6GWwo
CcMx4A1wJUMWL/nPf5s3unuVeXVhOAa8Aa5kb821d3mDjgYbSsJwDHgDXEYc
S62FPn/JG7wxnNlQG4ZjwBvgGsRaaCq1FjrmLd6Y59mANybAG+ACqqo5Vqjx
em8s5tmANybAG0A3TXO8UOP13ljMswFvTIA3gFY27sjLcLE31jKIwhsT4A2g
FT494ZOUw19+sTfKKF9M6gVvTIA3gD4eZVAOc6U3NjKIwhsT4A2gCVIwz0tP
5rq50hskzJpq2XLwxgR4A+hg2EB5+y14+Rb49ISuV32FNybAG0A5TS02UPp3
32bd1QLx07ZeXYeBNyYgYw9Qy88GinjfFm/UhFbp1lU7eGMCjAHUMi64Zos3
8lvcb54vgTcmwBtAIZNdVyu8wUcafLyhOwzHgDeAKuaZyc33xv0K2+u/At6Y
AG8AJZSloVUat1so4+WDXsrDcAx4A5xn7dqa4d7oatlS0fDGBHgDnKRtV6+t
Ge4NLo2uWa4TpzwMx4A3wBm4Lnx/9dqayd7g05MyWj3opTwMx4A3wBn49IQx
jcel9LUgMnpJ3+2HNybAG+AwcUzLcuvamrHeYAWtMtmc6krCcAx4Axxjux70
gKHe+KnCdmUYjgFvgANIFk4y0xuLGb10h+EY8AbYy+JRjUUM9EZT1dwb14fh
GPAG2MWuDMMGeqPwkq6V2ntVG4ZjwBtAniHDsPznm+YNlpdV/p606o4BbwBJ
2rbbVaKxN8wb82pKV4bhGPAGkGGcVUMeo7xRhlm7kgbwgjAcA3l7wEu4NMKA
NPXuWgbmeGPX6VAdYTgGjAFeEoYlY7vXEnuTvLHrdKiOMBwD3gDbhCE5XADF
EG9Uz8Xl3xKGY8AbYIMkeXGSfBsTvJFE8WIJtovDcAx4A6yRppS8Okm+jQne
SL9Cro6TnIzBPeANsIjvp0FgU9WkRVhepj56vXrgDTCnJLXnnR3b9+8eb7RN
S/wUowUdwBtgwnD9REl3e683yjBrWA1v6ADeAGMe109s90ZNKpoUSmIAc+AN
8IBLI46/9yvt9sboSDm8oQN4AwwIaYwuulrtDRKk7U/2QnhDB/AG4NR1Gz5f
dLXXG3X5PUNRFQOYA28AIY2wnJzCttQb4tKr/3SkHN7QAbzx4SxKo7fWG2WU
N8+XXuENHcAbn8yaNHo7vSFmKPH00iu8oQN442PZkEZvozeGGYqGGMAceOMz
2ZZGb6E3xB5KvXBvF97QAfL2fCAvpdHb5o0qL9lK4lB4QwcwxqchI43eKm80
VU3C1dIG8IYO4I2PQlIavUXe6O5l5VcKWyuJAcyBNz4HeWn09nhDbLxuFl+D
N3QAb3wIu6TRW+KNx+U1rTGAOfDGJ1BVzS5p9DZ4o2vaxY1X5TGAOfCG8wy3
XPcm8zbfG9vLGgpjAHPgDbeZ3HKVx3Bv0Lioy+qaGMAceMNhxvk09mKyNxih
VSpbphbe0AG84SplWR8baQwY642WNeX6aQ0dMYA58IaTiByhR0caA2Z6o2s7
EqQyyxoKYwBz4A33yLPK895fwqDX4A2RanhnbWh4QwfwhmMkCc1zdn3iC02N
jFuosiPlGuENSYgv7qn9TdjSy9PX4Q2XiOOSkLp/dwEChY08WrgXlN+xrKEw
ho+A68En9/9/MgRLEvL94afX4Q1niKKSUmXJeI3yRreSW+OaGD4Blvz1hx2q
iTh+mLwMbzhA1/Vh8FQ13jFviLXQpn1XDJ/Az3BjzRvE9582vuEN22nbPghI
0zxtMTjjjSRJyihvd66Fqo3hE9geb/zMVn7588w1QQJV1HXn+8VEGr1D3ki9
KA3evzHkPivrG/1dKfeXSDL6AFxhL3xiEgTLxybd8AYrKKrJX8bzfsq3R753
U+6MZyrwhqUQUkfrx0Ed8EYtNlByjBbMBN6wkSyrkmTrJIPt3mjrhgSpqjCA
cuAN64hjWhRbGa56y73RNe3jMDm8YSbwhkWI/dawLMvXmwtWe2Nc0QDeMBN4
wxbquvV9wpjUMQZ7vTEp1AhvmAm8YQVDor9W+h6opd4o42mSYXjDTOAN8ykK
FkVXZwe93hs0KWoyTeEFb5gJvGE4aUKzTCoh3hjrvFGlhJGFHSJ4w0zgDZMJ
AjLcb92LXd5geVllqNJoE/CGmTSNOEAuuQo6xyJvCGmslHZVFQZQDrxhIJSK
A+Tyq6BzbPHGy8JJ8IaZwBum4fup56VJkrz3MtcF3qhLVFuzFXjDHIZjXf7R
BDVjzPeGkEb8QhqqwgDKgTcMgbGWz03427dfKFPVwkYjLC9fjjQUhgGUg8wb
JkAI4yONIY2G897Y2D3RFAZQDozxdpKEpunvCQ23vbG9e6IpDKAceOON8AEG
n5tM7qk57I1dIw2FYQDlwBvvYths1ZHiT0kjysPgxtg10lAYBlAOvPEW+MQk
jjWekDTNGzTO2X5pqAoDKAfeuJi27cKw3Ei845o3OlGcsS5fJBrSGgZQDrxx
JYTUL3NoOOWNKBZJeFjz+lN1hgGUA29cRpJQ/ufldXhnvMF1kd2iJDp57hXe
MBF44wLuqboKmfx+vSveqMuKhBl6vavAG7rJM3a/pCb7+Q54gxV0OEMOb7gK
vKGP4XhGnu/LumO7N8o4r1KiKgxgJvCGJvJcDDPq/Qk07PXGUDV+nCAU3nAV
eEM5wzDjQHK/AUu9wXUxrxoPb7gKvKGWIEi/vtIoOpU943wYF3uD5WUZ5TrC
AGYCb6iiacRFeN9LT7ZjmTe6jhsD2UE/DXhDCcV9NUNJ9gyLvNEyUcV1UvFE
bRjATOCNkwxnMx6rGZ/jDT7GEGdBG+1nX4GBIG/PGYazGeM7rZ/gjaHus8w9
NXjDVWCMY1RV43nF/GyG894QB0FHdZ91hwHMBN7YS9fx7lCuFV502RtdX0aZ
ZF5QVWEAM4E3dlEUjA8zKF39beuqN/gwo/CScaX4a8IAZgJvSMInJjKnuRz0
xj2BBo2Lbn8dKHjDVeCNl9wz7RA+MZnn9JvjmDdYQfNbvHeYoTAMYCbwxjZ5
znyvqCrZaybOeCMJRcqdKiPvDQOYCbyxBiFiKWPvNRMXvNH1NCUi5U545rC8
mgPzwEzgjTnDHmuaVi9zc82x3Rs1ocUt5m/R68EG8MYYxlr5pYxF7PVGTVnh
xRSpM4AE8MZA2/ZcF7dbFobuF4KfIM5/hlkZ590oKxm8ATaAN9q2SxJ6u+WU
Nib0+iu9wUVBk6Lwk5ZNd0zgDbDBJ3uD/3blxvC834zBJvT6i7zRdsIYXlKX
ywu/8AbY4DO90TRijOHdcuW1WU1oYbsRPivhxshv8ZoxFIYBXOXTvPFtDG+5
KoEJvV6fNwZjbIwxlIcBXOVzvMGqJo7K7TomJvR6Hd5oKCvDrPCljKEwDOAq
n+CNqmrCkIRhuXEfbcCEXq/WGzWpiltM43y+8nlBGMBV3M7bQ4g4JR5F5XZJ
1gcm9HolHTaJ4yojOTdGcuQ+mqowgKs4aYy27bKsut3yNK12neAyodefbGHI
q5N9hWkQnzyJcvJBgMM45g0+JeGjC88rioJZekr8WAtt09K0yG8RH2C0TMFB
FAA2cMMbXBFFzr6+ststDcP0jb9kL26ha1txo8RP+B9GqMIwANjAdm+UZR1H
5e0r9/20PTSRH2OLN7qmZcVdF15CU9LV09UbeANoxVJvNM33CkYS02GXRElP
MdwbXBffowsvqbgu1msQwBtAK3Z5g+siz0VaDH+2guGwN5qKcUvkt5gbY3F0
oSMMADawwht8AkJILXThkzxf3iJxzRttV5cVjYv8KyqjjM9K+j2zMHgDaMVk
b9R1K9L0+cU9iw7d3lF1wBtikbOsUi/KvqLsX8jfSYLjBapPPggAGxjojapq
0rTybkUQrI4u5ljqjbZualKJayN8GuIl/J00iMd5MAAwEEO8weVQFCyOyq+v
LIpKQtjezRFbvNHVLRdFlRJxOutfyN/StOCvPE51YqgAzOeN3uBmELuocXm7
FVwXvp/ec20dP+R4PiQd3mhZwwpaZYSEaf4vEmubScFf4a9rigEA3Vzsjbpu
xbgiFvm1PK+I77uoXCAmLEieb4SPGZIw5k6gfDgRZvktGkYUfHSxIQq1MQBw
Abq9wZ1AyzrLqjAk//7lQ8kzPsyYHAI/31mUPIhkGNwPXAJNVbO85E4Yrqhz
RRS3OLtFqR+JuyEhHzkdGTsZMnNUgjPPggfR1M5A03SMtdwMaUrDgHx9fQ8q
+Bhj+0bqW7wx/5JxGNwM/E9NKiGHrORy4COHnJvhr/ADf7+MMv46H0hwgTzO
VBgiwI/6W/ai5EfFUt7ojeFLuAf4nzyv8pzdbuntK/v3N7vdb4gEfhoESRSl
j8UK/iW7Vic0fWcHFTSsHtYc+JdUecm1QJNCaCFMs/vMQvz5G4qRA/9PbzR+
iHY/yIFnuean2swvMTOqa77EzKg22qkIo0U1f1ukNItJntA8JklIQi+PgyL4
yviX3P6l/P3Iz3M+rvBi/vmsZMPQvWX1/e3T+/xLFl9/vM975cbn12UlfrPf
f+/P3w57E/xL0tu9s3/9vB26//itUMH3R7kNxJf4cfLQgvgTKf9nd+bnB8+u
9UvMjKofpegBAIAxF/gHAPDhwBsAgL3AGwCAvcAbAIC9WOoN4ovFnL8JW3p5
/rq5rDzIHZb89cnlER1n41n4o1j0fVl5kOEh7HmM74AXfoa2furksNIb/LHv
/xjEf3p0liTk+8OWfGtXHuTnY4vfc1NZfxb+42vJ9+PO2oP8aPzn41aw9Ltn
66fOZX7/LVae3JZ/kI0HIb5PrBpvrD7Lz29pWyS4/k357m/iW/Oe0A6w8DP0
svu4yq/wlx/cmm/s6oMMT2CVN9ae5THYsGUUuPXTZdsYcPFn6FX3cZZtYf7M
Vixg5UF+f0NbNJle+6ZY99tta7wxDDes+Z70GG888XoqTRIr/kG2Z5pWjTdW
n+Wnn1nzNBsPcn/dquUarG888bwg/Jh4/v6atuNHdOVBvrGmp32z9izf3xd7
nmXlQR7jQGue5Hl/cfod+ThrAAAAAAAAAAAAwGn+H+yIBYM=
    "], {{0, 359}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 359},
  PlotRange->{{0, 360}, {0, 359}}]], "Output",
 ImageSize->{364, 359},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->91372612]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[{
 "Subintervals",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1295379749],

Cell[BoxData["Subintervals"], "Output",
 ImageSize->{88, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->122425637],

Cell[TextData[{
 "The bars do not have to be of equal width. The option Subintervals will \
accept ",
 Cell[BoxData[
  ButtonBox["Uniform",
   BaseStyle->"Link",
   ButtonData->"paclet:IntegrationTechniques/ref/Uniform"]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  ButtonBox["Nonuniform",
   BaseStyle->"Link",
   ButtonData->"paclet:IntegrationTechniques/ref/Nonuniform"]], 
  "InlineFormula"],
 " for values."
}], "ExampleText",
 CellID->189117827],

Cell["Bars of unequal widths.", "MathCaption",
 CellID->227520829],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SuperscriptBox["x", "2"], ",", 
     SuperscriptBox["x", "8"]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "15", ",", "\"\<Left\>\"", 
   ",", 
   RowBox[{"Subintervals", "\[Rule]", " ", "Nonuniform"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1421681343],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS23sz6bxc+s+STzMY69ZWVl5SBm1kKMQGIjIyOxSGQkNhKJxCKRyE4C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    "], {{0, 359}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 359},
  PlotRange->{{0, 360}, {0, 359}}]], "Output",
 ImageSize->{364, 359},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->33983253]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Possible Issues",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373],

Cell["\<\
If the number of bars used is small in relation to the geometry of the plot \
the results may be confusing.\
\>", "ExampleText",
 CellID->507198156],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"RiemannSumPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox["x", "2"], ",", 
       SuperscriptBox["x", "4"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "6", ",", 
     "\"\<Center\>\""}], "]"}], ",", 
   RowBox[{"RiemannSumPlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox["x", "2"], ",", 
       SuperscriptBox["x", "4"]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "47", ",", 
     "\"\<Center\>\""}], "]"}]}], "}"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1116812949],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS3Xq7yXxs+s+STzMY49shKJ/CMRI5BRs1ZkZGRsJDISi4xEYpFIZGcH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    "], {{0, 181}, {385, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{385, 181},
  PlotRange->{{0, 385}, {0, 181}}]], "Output",
 ImageSize->{389, 181},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[1]=",
 CellID->85142015]
}, Open  ]],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellLabel->"In[2]:=",
 CellID->1527565598]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Interactive Examples",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1653164318],

Cell["\<\
The RiemannSum function can be used with RiemannSumPlot in a Manipulate to \
illustrate how the approximation approaches a value.\
\>", "ExampleText",
 CellID->2139058553],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Grid", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"RiemannSum", "[", 
        RowBox[{
         SqrtBox["x"], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "0.", ",", "4"}], "}"}], ",", "n", ",", 
         "\"\<Center\>\""}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"RiemannSumPlot", "[", 
        RowBox[{
         SqrtBox["x"], ",", 
         RowBox[{"{", 
          RowBox[{"x", ",", "0", ",", "4"}], "}"}], ",", "n", ",", 
         "\"\<Center\>\""}], "]"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"StringForm", "[", 
        RowBox[{"\"\<The value of the integral is `1`\>\"", ",", 
         RowBox[{"Integrate", "[", 
          RowBox[{
           SqrtBox["x"], ",", 
           RowBox[{"{", 
            RowBox[{"x", ",", "0", ",", "4"}], "}"}]}], "]"}]}], "]"}], 
       "}"}]}], "}"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "8", ",", "75", ",", "1"}], "}"}], ",", 
   RowBox[{"SaveDefinitions", "\[Rule]", " ", "True"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->133365844],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`n$$ = 8, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`n$$], 8, 75, 1}}, Typeset`size$$ = {
    224., {67.84375, 73.15625}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`n$2237$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`n$$ = 8}, 
      "ControllerVariables" :> {
        Hold[$CellContext`n$$, $CellContext`n$2237$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Grid[{{
          
          ClassroomUtilities`RiemannSum[$CellContext`x^
           Rational[1, 2], {$CellContext`x, 0., 4}, $CellContext`n$$, 
           "Center"]}, {
          
          ClassroomUtilities`RiemannSumPlot[$CellContext`x^
           Rational[1, 2], {$CellContext`x, 0, 4}, $CellContext`n$$, 
           "Center"]}, {
          StringForm["The value of the integral is `1`", 
           
           Integrate[$CellContext`x^
            Rational[1, 2], {$CellContext`x, 0, 4}]]}}], 
      "Specifications" :> {{$CellContext`n$$, 8, 75, 1}}, "Options" :> {}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{503., {99., 104.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 ImageSize->{507, 205},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->317225161]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Neat Examples",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->589267740],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"Sin", "[", "t", "]"}], ",", 
     RowBox[{
      RowBox[{"Sin", "[", "t", "]"}], "+", 
      RowBox[{
       RowBox[{"Cos", "[", 
        RowBox[{"8", " ", "t"}], "]"}], "/", "3"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"t", ",", "0", ",", " ", "\[Pi]"}], "}"}], ",", "77", ",", 
   "\"\<Center\>\"", ",", 
   RowBox[{"Ticks", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Range", "[", 
      RowBox[{"0", ",", 
       RowBox[{"2", " ", "\[Pi]"}], ",", 
       RowBox[{"\[Pi]", "/", "3"}]}], "]"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->196484965],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnSuztLyz6J9d55Ocj/G3S45EIjdmVyGOiIyNjIyMRWJOFRKLRCKxSCRy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    "], {{0, 178}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 178},
  PlotRange->{{0, 360}, {0, 178}}]], "Output",
 ImageSize->{364, 178},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[1]=",
 CellID->32096501]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Integrals as Limits",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/IntegralsAsLimits"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Integration Techniques",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/IntegrationTechniques"]], "MoreAbout",
 CellID->64077868]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"RiemannSumPlot - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 30, 22.8820624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "RiemannSumPlot[fun, {var, var_min, var_max}, n, \" type\", opts] \
generate a plot of fun on the interval (var_min, var_max) and approximates \
the area under the curve using n polygons of \" type\".RiemannSumPlot[{f_1, \
f_2},{var, var_min, var_max}, n, \" type\", opts] generate a plot of two \
functions f_1 and f_2 and fill between the curves with n polygons of \" \
type\".", "synonyms" -> {}, "title" -> "RiemannSumPlot", "titlemodifier" -> 
    "", "windowtitle" -> "RiemannSumPlot", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/RiemannSumPlot"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9514, 301, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->128594038]},
 "RasterizedOutput"->{
  Cell[22497, 640, 8831, 153, 378, "Output",
   CellTags->"RasterizedOutput",
   CellID->172938552],
  Cell[50701, 1230, 5569, 99, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->265214609],
  Cell[56789, 1351, 11489, 196, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->91372612],
  Cell[69649, 1604, 11920, 203, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->33983253],
  Cell[82774, 1856, 10530, 181, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->85142015],
  Cell[98171, 2188, 11022, 189, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->32096501]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 112769, 2480},
 {"RasterizedOutput", 112912, 2484}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[607, 21, 2798, 66, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3430, 91, 57, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3490, 94, 2710, 88, 162, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[6237, 187, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->19823374],
Cell[6848, 207, 223, 8, 70, "Notes",
 CellID->769486016],
Cell[7074, 217, 387, 15, 70, "Notes",
 CellID->675350009],
Cell[7464, 234, 302, 10, 70, "Notes",
 CellID->975693726],
Cell[7769, 246, 198, 6, 70, "Notes",
 CellID->1524285436],
Cell[7970, 254, 289, 9, 70, "Notes",
 CellID->1332897789],
Cell[8262, 265, 1215, 31, 70, "3ColumnTableMod",
 CellID->976286479]
}, Closed]],
Cell[CellGroupData[{
Cell[9514, 301, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->128594038],
Cell[CellGroupData[{
Cell[10029, 319, 195, 6, 31, "ExampleSection",
 CellID->336924786],
Cell[10227, 327, 145, 4, 32, "ExampleText",
 CellID->1997212051],
Cell[10375, 333, 128, 3, 28, "Input",
 CellID->1973538547],
Cell[10506, 338, 250, 9, 34, "ExampleText",
 CellID->969458538],
Cell[CellGroupData[{
Cell[10781, 351, 303, 10, 30, "Input",
 CellID->617741138],
Cell[11087, 363, 5213, 116, 296, "Output",
 CellID->1797491740]
}, Open  ]],
Cell[16315, 482, 178, 4, 70, "ExampleText",
 CellID->731218377],
Cell[CellGroupData[{
Cell[16518, 490, 305, 10, 70, "Input",
 CellID->2014057424],
Cell[16826, 502, 5216, 116, 296, "Output",
 CellID->1791211831]
}, Open  ]],
Cell[22057, 621, 135, 4, 70, "ExampleText",
 CellID->1685834105],
Cell[CellGroupData[{
Cell[22217, 629, 277, 9, 30, "Input",
 CellID->1676795276],
Cell[22497, 640, 8831, 153, 378, "Output",
 CellTags->"RasterizedOutput",
 CellID->172938552]
}, Open  ]],
Cell[31343, 796, 221, 5, 70, "ExampleText",
 CellID->2062047864],
Cell[CellGroupData[{
Cell[31589, 805, 431, 14, 70, "Input",
 CellID->1183525861],
Cell[32023, 821, 8188, 168, 271, "Output",
 CellID->742193745]
}, Open  ]],
Cell[40226, 992, 95, 1, 70, "ExampleText",
 CellID->747354962],
Cell[CellGroupData[{
Cell[40346, 997, 257, 8, 70, "Input",
 CellID->609960649],
Cell[40606, 1007, 8797, 172, 380, "Output",
 CellID->1465250439]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[49452, 1185, 270, 8, 70, "ExampleSection",
 CellID->2061341341],
Cell[CellGroupData[{
Cell[49747, 1197, 281, 8, 70, "ExampleSubsection",
 CellID->1757724783],
Cell[50031, 1207, 172, 4, 70, "ExampleText",
 CellID->645002374],
Cell[50206, 1213, 95, 1, 70, "ExampleText",
 CellID->162995031],
Cell[CellGroupData[{
Cell[50326, 1218, 372, 10, 70, "Input",
 CellID->1337992431],
Cell[50701, 1230, 5569, 99, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->265214609]
}, Open  ]],
Cell[56285, 1332, 88, 1, 70, "ExampleText",
 CellID->1415836092],
Cell[CellGroupData[{
Cell[56398, 1337, 388, 12, 70, "Input",
 CellID->1976266416],
Cell[56789, 1351, 11489, 196, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->91372612]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[68327, 1553, 200, 6, 70, "ExampleSubsection",
 CellID->1295379749],
Cell[68530, 1561, 169, 5, 35, "Output",
 CellID->122425637],
Cell[68702, 1568, 453, 15, 70, "ExampleText",
 CellID->189117827],
Cell[69158, 1585, 66, 1, 70, "MathCaption",
 CellID->227520829],
Cell[CellGroupData[{
Cell[69249, 1590, 397, 12, 70, "Input",
 CellID->1421681343],
Cell[69649, 1604, 11920, 203, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->33983253]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[81630, 1814, 278, 8, 70, "ExampleSection",
 CellID->1305812373],
Cell[81911, 1824, 158, 4, 70, "ExampleText",
 CellID->507198156],
Cell[CellGroupData[{
Cell[82094, 1832, 677, 22, 70, "Input",
 CellID->1116812949],
Cell[82774, 1856, 10530, 181, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->85142015]
}, Open  ]],
Cell[93319, 2040, 89, 2, 70, "Input",
 CellID->1527565598]
}, Closed]],
Cell[CellGroupData[{
Cell[93445, 2047, 283, 8, 70, "ExampleSection",
 CellID->1653164318],
Cell[93731, 2057, 181, 4, 70, "ExampleText",
 CellID->2139058553],
Cell[CellGroupData[{
Cell[93937, 2065, 1136, 33, 70, "Input",
 CellID->133365844],
Cell[95076, 2100, 2061, 47, 70, "Output",
 CellID->317225161]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[97186, 2153, 275, 8, 70, "ExampleSection",
 CellID->589267740],
Cell[CellGroupData[{
Cell[97486, 2165, 682, 21, 70, "Input",
 CellID->196484965],
Cell[98171, 2188, 11022, 189, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->32096501]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[109254, 2384, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[109705, 2399, 173, 4, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[109915, 2408, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[110366, 2423, 176, 4, 70, "MoreAbout",
 CellID->64077868]
}, Open  ]],
Cell[110557, 2430, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

