(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     44320,       1456]
NotebookOptionsPosition[     37582,       1237]
NotebookOutlinePosition[     40020,       1298]
CellTagsIndexPosition[     39934,       1293]
WindowTitle->RollTheDice - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Visualizing Statistical Concepts\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities/ref/RollTheDice\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/RollTheDice"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/RollTheDice.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/RollTheDice", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["RollTheDice", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"RollTheDice", "[", 
       RowBox[{
        StyleBox["dice", "TI"], ",", " ", "\"\<\!\(\*
StyleBox[\"property\", \"TI\"]\)\>\""}], "]"}]], "InlineFormula"],
     " \[LineSeparator]returns the requested property for the list of ",
     Cell[BoxData[
      StyleBox["dice", "TI"]], "InlineFormula"],
     " specified."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"RollTheDice", "[", 
       RowBox[{
        StyleBox["dice", "TI"], ",", 
        StyleBox["n", "TI"], ",", "\"\<\!\(\*
StyleBox[\"property\", \"TI\"]\)\>\""}], "]"}]], "InlineFormula"],
     "\[LineSeparator]roll the ",
     Cell[BoxData[
      StyleBox["dice", "TI"]], "InlineFormula"],
     " ",
     Cell[BoxData[
      StyleBox["n", "TI"]], "InlineFormula"],
     " times and return an ",
     ButtonBox["EmpiricalDistribution",
      BaseStyle->"Link",
      ButtonData->"paclet:ref/EmpiricalDistribution"],
     " based on the result."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"RollTheDice", "[", 
       RowBox[{
        StyleBox["dice", "TI"], ",", " ", "\"\<\!\(\*
StyleBox[\"dice\", \"TI\"]\)\>\""}], "]"}]], "InlineFormula"],
     "\[LineSeparator]gives images of the polyhedra for the listed dice."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"RollTheDice", "[", 
       RowBox[{"dice", ",", " ", 
        RowBox[{"{", 
         RowBox[{"\"\<\!\(\*
StyleBox[\"dice\", \"TI\"]\)\>\"", ",", " ", "\"\<\!\(\*
StyleBox[\"property\", \"TI\"]\)\>\""}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns the information for the polyhedron as in \
PolyhedronData."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->386047661],

Cell[TextData[{
 "The argument ",
 Cell[BoxData[
  StyleBox["dice", "TI"]], "InlineFormula"],
 " is a list containing some combination of the values 4, 6, 8, 10, 12 and 20."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The length of ",
 Cell[BoxData[
  StyleBox["dice", "TI"]], "InlineFormula"],
 " should be less than or equal 6."
}], "Notes",
 CellID->1693171005],

Cell["\<\
Individual dice are assumed to be fair dice with the indicated number of \
sides.\
\>", "Notes",
 CellID->819274638],

Cell["Properties that can be requested include the following.", "Notes",
 CellID->1065943087],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], Cell["\"Outcomes\"\t", "TableText"], Cell[
    "a list of all possible outcomes.\t", "TableText"]},
   {Cell["      ", "TableRowIcon"], Cell["\"OutcomesTable\"", "TableText"], 
    Cell["a formatted table of the outcomes.", "TableText"]},
   {Cell["      ", "TableRowIcon"], Cell["\"Totals\"", "TableText"], Cell[
    "a list of the total points showing on each roll.", "TableText"]},
   {Cell["      ", "TableRowIcon"], Cell[
    "\"TotalsFrequencies\"", "TableText"], Cell[
    "a list of the frequencies for each total.", "TableText"]},
   {Cell["      ", "TableRowIcon"], Cell["\"Distribution\"", "TableText"], 
    Cell["a theoretical distribution for the specified dice.", "TableText"]},
   {Cell["      ", "TableRowIcon"], Cell[
    "\"TotalsDistribution\"", "TableText"], Cell[
    "a theoretical distribution for the totals of the dice.", "TableText"]},
   {Cell["      ", "TableRowIcon"], Cell[
    "\"SimulatedDistribution\"", "TableText"], Cell[
    "a distribution based on the specified number of rolls.", "TableText"]},
   {Cell["      ", "TableRowIcon"], Cell[
    "\"SimulatedTotalsDistribution\"", "TableText"], Cell[
    "a distribution based on the totals for the specified rolls.", 
     "TableText"]},
   {Cell["      ", "TableRowIcon"], Cell["\"Dice\"", "TableText"], Cell[
    "an image of the polyhedron corresponding to the die.", "TableText"]},
   {Cell["      ", "TableRowIcon"], Cell[
    "{\"Dice\",\"property\"}", "TableText"], Cell[
    "see TenSidedDie for the associated properties.", "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, None, None, None, None, None, None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Rows" -> {{
     True, True, True, True, True, True, True, True, True, True, True}}}},
 CellID->996879935]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->776859127],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->243147355],

Cell["This loads the package.", "ExampleText",
 CellID->1309149583],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1907077966],

Cell["\<\
Get the list of possible outcomes for rolling two six sided dice.\
\>", "ExampleText",
 CellID->1490790308],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RollTheDice", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"6", ",", "6"}], "}"}], ",", "\"\<Outcomes\>\""}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1020997007],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "6"}], "}"}]}], "}"}]], "Output",
 ImageSize->{458, 67},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1502357119]
}, Open  ]],

Cell["Format the outcomes in a table.", "ExampleText",
 CellID->3377607],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RollTheDice", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"6", ",", "6"}], "}"}], ",", "\"\<OutcomesTable\>\""}], 
  "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->932866027],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "6"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "6"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"3", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "6"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"5", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "6"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"6", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "6"}], "}"}]}
   },
   AutoDelete->False,
   FrameStyle->Thickness[Large],
   GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 ImageSize->{292, 97},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->2048692689]
}, Open  ]],

Cell["Get a list of the outcome totals.", "ExampleText",
 CellID->1772711672],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RollTheDice", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"6", ",", "6"}], "}"}], ",", "\"\<Totals\>\""}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1924436473],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "2", ",", "3", ",", "4", ",", "5", ",", "6", ",", "7", ",", "3", ",", "4", 
   ",", "5", ",", "6", ",", "7", ",", "8", ",", "4", ",", "5", ",", "6", ",", 
   "7", ",", "8", ",", "9", ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", 
   ",", "10", ",", "6", ",", "7", ",", "8", ",", "9", ",", "10", ",", "11", 
   ",", "7", ",", "8", ",", "9", ",", "10", ",", "11", ",", "12"}], 
  "}"}]], "Output",
 ImageSize->{392, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->752594244]
}, Open  ]],

Cell["Get a list of the frequency with which each total appears.", \
"ExampleText",
 CellID->172778078],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RollTheDice", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"6", ",", "6"}], "}"}], ",", "\"\<TotalsFrequencies\>\""}], 
  "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->483266202],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", "1"}], "}"}]}], "}"}]], "Output",
 ImageSize->{578, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->471904060]
}, Open  ]],

Cell["Multiple uses of the same die can be given in a list.", "ExampleText",
 CellID->634428049],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RollTheDice", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"6", ",", "2"}], "}"}], "}"}], ",", 
   "\"\<TotalsFrequencies\>\""}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->575912188],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"2", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"5", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"6", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"7", ",", "6"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"8", ",", "5"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"9", ",", "4"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"10", ",", "3"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"11", ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"12", ",", "1"}], "}"}]}], "}"}]], "Output",
 ImageSize->{578, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->647346687]
}, Open  ]],

Cell["\<\
Create a theoretical distribution based on rolling two six sided dice.\
\>", "ExampleText",
 CellID->1069212378],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"dist66", "=", 
  RowBox[{"RollTheDice", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"6", ",", "2"}], "}"}], "}"}], ",", 
    "\"\<TotalsDistribution\>\""}], "]"}]}]], "Input",
 CellLabel->"In[7]:=",
 CellID->109278950],

Cell[BoxData[
 RowBox[{"DataDistribution", "[", 
  RowBox[{
   RowBox[{"\[LeftSkeleton]", "\<\"Empirical\"\>", "\[RightSkeleton]"}], ",", 
   RowBox[{"{", "11", "}"}]}], "]"}]], "Output",
 ImageSize->{260, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[7]=",
 CellID->1516249447]
}, Open  ]],

Cell["Visualize the pdf of the distribution.", "ExampleText",
 CellID->2093341437],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DiscretePlot", "[", 
  RowBox[{
   RowBox[{"PDF", "[", 
    RowBox[{"dist66", ",", "x"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "14"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->564942858],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.24720000000000014`, 0.24, 0.6], 
    {Opacity[0.2], 
     LineBox[{{{0., 0.}, {0., 0}}, {{1., 0.}, {1., 0}}, {{13., 0.}, {
        13., 0}}, {{14., 0.}, {14., 0}}},
      VertexColors->None]}, 
    {Opacity[0.2], 
     LineBox[{{{2., 0.027777777777777776`}, {2., 0}}, {{3., 
        0.05555555555555555}, {3., 0}}, {{4., 0.08333333333333333}, {
        4., 0}}, {{5., 0.1111111111111111}, {5., 0}}, {{6., 
        0.1388888888888889}, {6., 0}}, {{7., 0.16666666666666666`}, {
        7., 0}}, {{8., 0.1388888888888889}, {8., 0}}, {{9., 
        0.1111111111111111}, {9., 0}}, {{10., 0.08333333333333333}, {
        10., 0}}, {{11., 0.05555555555555555}, {11., 0}}, {{12., 
        0.027777777777777776`}, {12., 0}}},
      VertexColors->None]}}, 
   {RGBColor[0.24720000000000014`, 0.24, 0.6], {}, 
    PointBox[{{0., 0.}, {1., 0.}, {2., 0.027777777777777776`}, {3., 
     0.05555555555555555}, {4., 0.08333333333333333}, {5., 
     0.1111111111111111}, {6., 0.1388888888888889}, {7., 
     0.16666666666666666`}, {8., 0.1388888888888889}, {9., 
     0.1111111111111111}, {10., 0.08333333333333333}, {11., 
     0.05555555555555555}, {12., 0.027777777777777776`}, {13., 0.}, {14., 
     0.}}], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  Method->{"MessagesHead" -> DiscretePlot},
  PlotRange->{{0, 14}, {0, 0.16666666666666666`}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}}]], "Output",
 ImageSize->{184, 113},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[8]=",
 CellID->1141771897]
}, Open  ]],

Cell["Simulate the distribution by rolling the dice 50 times.", "ExampleText",
 CellID->915874986],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"simDist", "=", 
  RowBox[{"RollTheDice", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"6", ",", "2"}], "}"}], "}"}], ",", "50", ",", 
    "\"\<SimulatedTotalsDistribution\>\""}], "]"}]}]], "Input",
 CellLabel->"In[9]:=",
 CellID->2095591653],

Cell[BoxData[
 RowBox[{"DataDistribution", "[", 
  RowBox[{
   RowBox[{"\[LeftSkeleton]", "\<\"Empirical\"\>", "\[RightSkeleton]"}], ",", 
   RowBox[{"{", "10", "}"}]}], "]"}]], "Output",
 ImageSize->{260, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[9]=",
 CellID->1877101171]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DiscretePlot", "[", 
  RowBox[{
   RowBox[{"PDF", "[", 
    RowBox[{"simDist", ",", "n"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "0", ",", "14"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[10]:=",
 CellID->1904606567],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.24720000000000014`, 0.24, 0.6], 
    {Opacity[0.2], 
     LineBox[{{{0., 0.}, {0., 0}}, {{1., 0.}, {1., 0}}, {{2., 0.}, {
        2., 0}}, {{13., 0.}, {13., 0}}, {{14., 0.}, {14., 0}}},
      VertexColors->None]}, 
    {Opacity[0.2], 
     LineBox[{{{3., 0.08}, {3., 0}}, {{4., 0.04}, {4., 0}}, {{5., 0.08}, {
        5., 0}}, {{6., 0.12}, {6., 0}}, {{7., 0.24}, {7., 0}}, {{8., 0.18}, {
        8., 0}}, {{9., 0.04}, {9., 0}}, {{10., 0.08}, {10., 0}}, {{11., 
        0.08}, {11., 0}}, {{12., 0.06}, {12., 0}}},
      VertexColors->None]}}, 
   {RGBColor[0.24720000000000014`, 0.24, 0.6], {}, 
    PointBox[{{0., 0.}, {1., 0.}, {2., 0.}, {3., 0.08}, {4., 0.04}, {5., 
     0.08}, {6., 0.12}, {7., 0.24}, {8., 0.18}, {9., 0.04}, {10., 0.08}, {11.,
      0.08}, {12., 0.06}, {13., 0.}, {14., 0.}}], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  Method->{"MessagesHead" -> DiscretePlot},
  PlotRange->{{0, 14}, {0, 0.24}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}}]], "Output",
 ImageSize->{184, 113},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[10]=",
 CellID->331329387]
}, Open  ]],

Cell["\<\
Get a better approximation of the distribution using more rolls.\
\>", "ExampleText",
 CellID->227910638],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"simDist2", "=", 
  RowBox[{"RollTheDice", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{"6", ",", "2"}], "}"}], "}"}], ",", "1500", ",", 
    "\"\<SimulatedTotalsDistribution\>\""}], "]"}]}]], "Input",
 CellLabel->"In[11]:=",
 CellID->1530750265],

Cell[BoxData[
 RowBox[{"DataDistribution", "[", 
  RowBox[{
   RowBox[{"\[LeftSkeleton]", "\<\"Empirical\"\>", "\[RightSkeleton]"}], ",", 
   RowBox[{"{", "11", "}"}]}], "]"}]], "Output",
 ImageSize->{260, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[11]=",
 CellID->398266936]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DiscretePlot", "[", 
  RowBox[{
   RowBox[{"PDF", "[", 
    RowBox[{"simDist2", ",", "n"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "0", ",", "14"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[12]:=",
 CellID->123835897],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.24720000000000014`, 0.24, 0.6], 
    {Opacity[0.2], 
     LineBox[{{{0., 0.}, {0., 0}}, {{1., 0.}, {1., 0}}, {{13., 0.}, {
        13., 0}}, {{14., 0.}, {14., 0}}},
      VertexColors->None]}, 
    {Opacity[0.2], 
     LineBox[{{{2., 0.034}, {2., 0}}, {{3., 0.05466666666666667}, {3., 0}}, {{
        4., 0.08733333333333333}, {4., 0}}, {{5., 0.1}, {5., 0}}, {{6., 
        0.13533333333333333`}, {6., 0}}, {{7., 0.15733333333333333`}, {
        7., 0}}, {{8., 0.13866666666666666`}, {8., 0}}, {{9., 
        0.11533333333333333`}, {9., 0}}, {{10., 0.094}, {10., 0}}, {{11., 
        0.05266666666666667}, {11., 0}}, {{12., 0.030666666666666665`}, {
        12., 0}}},
      VertexColors->None]}}, 
   {RGBColor[0.24720000000000014`, 0.24, 0.6], {}, 
    PointBox[{{0., 0.}, {1., 0.}, {2., 0.034}, {3., 0.05466666666666667}, {4.,
      0.08733333333333333}, {5., 0.1}, {6., 0.13533333333333333`}, {7., 
     0.15733333333333333`}, {8., 0.13866666666666666`}, {9., 
     0.11533333333333333`}, {10., 0.094}, {11., 0.05266666666666667}, {12., 
     0.030666666666666665`}, {13., 0.}, {14., 0.}}], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{0, 0},
  Method->{"MessagesHead" -> DiscretePlot},
  PlotRange->{{0, 14}, {0, 0.15733333333333333`}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}}]], "Output",
 ImageSize->{184, 113},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[12]=",
 CellID->2113349300]
}, Open  ]],

Cell["Roll several different dice and plot the distribution.", "ExampleText",
 CellID->1829647367],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mixDist", "=", 
  RowBox[{"RollTheDice", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"4", ",", "6", ",", "8", ",", "12"}], "}"}], ",", 
    "\"\<TotalsDistribution\>\""}], "]"}]}]], "Input",
 CellLabel->"In[13]:=",
 CellID->1064955776],

Cell[BoxData[
 RowBox[{"DataDistribution", "[", 
  RowBox[{
   RowBox[{"\[LeftSkeleton]", "\<\"Empirical\"\>", "\[RightSkeleton]"}], ",", 
   RowBox[{"{", "27", "}"}]}], "]"}]], "Output",
 ImageSize->{260, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[13]=",
 CellID->526840455]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"DiscretePlot", "[", 
  RowBox[{
   RowBox[{"PDF", "[", 
    RowBox[{"mixDist", ",", "n"}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"n", ",", "2", ",", "32"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[14]:=",
 CellID->532450604],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.24720000000000014`, 0.24, 0.6], 
    {Opacity[0.2], 
     LineBox[{{{2., 0.}, {2., 0}}, {{3., 0.}, {3., 0}}, {{31., 0.}, {
        31., 0}}, {{32., 0.}, {32., 0}}},
      VertexColors->None]}, 
    {Opacity[0.2], 
     LineBox[{{{4., 0.00043402777777777775`}, {4., 0}}, {{5., 
        0.001736111111111111}, {5., 0}}, {{6., 0.004340277777777778}, {
        6., 0}}, {{7., 0.008680555555555556}, {7., 0}}, {{8., 
        0.014756944444444444`}, {8., 0}}, {{9., 0.022569444444444444`}, {
        9., 0}}, {{10., 0.031684027777777776`}, {10., 0}}, {{11., 
        0.041666666666666664`}, {11., 0}}, {{12., 0.05164930555555555}, {
        12., 0}}, {{13., 0.06076388888888889}, {13., 0}}, {{14., 
        0.0685763888888889}, {14., 0}}, {{15., 0.07465277777777778}, {
        15., 0}}, {{16., 0.07855902777777778}, {16., 0}}, {{17., 
        0.0798611111111111}, {17., 0}}, {{18., 0.07855902777777778}, {
        18., 0}}, {{19., 0.07465277777777778}, {19., 0}}, {{20., 
        0.0685763888888889}, {20., 0}}, {{21., 0.06076388888888889}, {
        21., 0}}, {{22., 0.05164930555555555}, {22., 0}}, {{23., 
        0.041666666666666664`}, {23., 0}}, {{24., 0.031684027777777776`}, {
        24., 0}}, {{25., 0.022569444444444444`}, {25., 0}}, {{26., 
        0.014756944444444444`}, {26., 0}}, {{27., 0.008680555555555556}, {
        27., 0}}, {{28., 0.004340277777777778}, {28., 0}}, {{29., 
        0.001736111111111111}, {29., 0}}, {{30., 0.00043402777777777775`}, {
        30., 0}}},
      VertexColors->None]}}, 
   {RGBColor[0.24720000000000014`, 0.24, 0.6], {}, PointBox[CompressedData["
1:eJxTTMoPSmViYGCQB2IQDQUODCiAA40v4CBzvBCIbOwhfBEoPwbKl3AogghA
+TJQfiOUr+DQ99gChKB8JQewapnpUL4KVH4BlK/mEAoGS6F8Dah9q6B8Laj+
9VC+jsMTsPEboXw9qPxmKN8Ayt8C5RtCzYPxjdDkjdH0m6CZb4pmvxma+8zR
3G+B5j9LNP9boYWPNVr42aCFry1a+NuhxY89Wvw5wPkAjpxvZg==
     "]], {}}},
  AspectRatio->NCache[GoldenRatio^(-1), 0.6180339887498948],
  Axes->True,
  AxesOrigin->{2, 0},
  Method->{"MessagesHead" -> DiscretePlot},
  PlotRange->{{2, 32}, {0, 0.0798611111111111}},
  PlotRangePadding->{{
     Scaled[0.02], 
     Scaled[0.02]}, {
     Scaled[0.02], 
     Scaled[0.02]}}]], "Output",
 ImageSize->{184, 118},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[14]=",
 CellID->332944379]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Possible Issues",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373],

Cell["\<\
When several dice with a large number of faces are used the results may be \
difficult to visualize.\
\>", "ExampleText",
 CellID->1601277418],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RollTheDice", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{"10", ",", "2"}], "}"}], "}"}], ",", "\"\<OutcomesTable\>\""}], 
  "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->404500122],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"{", 
      RowBox[{"1", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "7"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"1", ",", "10"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"2", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "7"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"2", ",", "10"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"3", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "7"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"3", ",", "10"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"4", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "7"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"4", ",", "10"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"5", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "7"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"5", ",", "10"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"6", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "7"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"6", ",", "10"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"7", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "7"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"7", ",", "10"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"8", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "7"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"8", ",", "10"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"9", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "7"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"9", ",", "10"}], "}"}]},
    {
     RowBox[{"{", 
      RowBox[{"10", ",", "1"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "2"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "3"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "4"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "5"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "6"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "7"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "8"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "9"}], "}"}], 
     RowBox[{"{", 
      RowBox[{"10", ",", "10"}], "}"}]}
   },
   AutoDelete->False,
   FrameStyle->Thickness[Large],
   GridBoxFrame->{"ColumnsIndexed" -> {{{1, -1}, {1, -1}} -> True}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Grid"]], "Output",
 ImageSize->{557, 157},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->1647807699]
}, Open  ]],

Cell["\<\
When several dice with a large number of faces are used the number of \
combinations can be very large.\
\>", "ExampleText",
 CellID->754885381],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Length", "[", 
  RowBox[{"RollTheDice", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"12", ",", "2"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"20", ",", "2"}], "}"}]}], "}"}], ",", "\"\<Outcomes\>\""}], 
   "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->25211991],

Cell[BoxData["57600"], "Output",
 ImageSize->{41, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->683654278]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[StyleBox[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"],
 FontWeight->"Bold"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"RollTheDice - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 30, 32.5696624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "RollTheDice[dice, \" property\"] returns the requested property for the \
list of dice specified.RollTheDice[dice, n, \" property\"] roll the dice n \
times and return an EmpiricalDistribution based on the \
result.RollTheDice[dice, \" dice\"] gives images of the polyhedra for the \
listed dice.RollTheDice[dice, {\"dice\", \" property\"}] returns the \
information for the polyhedron as in PolyhedronData.", "synonyms" -> {}, 
    "title" -> "RollTheDice", "titlemodifier" -> "", "windowtitle" -> 
    "RollTheDice", "type" -> "Symbol", "uri" -> 
    "Classroom Utilities/ref/RollTheDice"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[8274, 229, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->776859127]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 39791, 1286}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 2460, 55, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3089, 80, 54, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3146, 83, 1899, 55, 264, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5082, 143, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->386047661],
Cell[5694, 163, 207, 6, 70, "Notes",
 CellID->1067943069],
Cell[5904, 171, 164, 6, 70, "Notes",
 CellID->1693171005],
Cell[6071, 179, 126, 4, 70, "Notes",
 CellID->819274638],
Cell[6200, 185, 93, 1, 70, "Notes",
 CellID->1065943087],
Cell[6296, 188, 1941, 36, 70, "2ColumnTableMod",
 CellID->996879935]
}, Closed]],
Cell[CellGroupData[{
Cell[8274, 229, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->776859127],
Cell[CellGroupData[{
Cell[8789, 247, 195, 6, 31, "ExampleSection",
 CellID->243147355],
Cell[8987, 255, 67, 1, 32, "ExampleText",
 CellID->1309149583],
Cell[9057, 258, 128, 3, 28, "Input",
 CellID->1907077966],
Cell[9188, 263, 117, 3, 32, "ExampleText",
 CellID->1490790308],
Cell[CellGroupData[{
Cell[9330, 270, 195, 6, 28, "Input",
 CellID->1020997007],
Cell[9528, 278, 2309, 79, 88, "Output",
 CellID->1502357119]
}, Open  ]],
Cell[11852, 360, 72, 1, 70, "ExampleText",
 CellID->3377607],
Cell[CellGroupData[{
Cell[11949, 365, 202, 7, 70, "Input",
 CellID->932866027],
Cell[12154, 374, 2514, 90, 118, "Output",
 CellID->2048692689]
}, Open  ]],
Cell[14683, 467, 77, 1, 70, "ExampleText",
 CellID->1772711672],
Cell[CellGroupData[{
Cell[14785, 472, 193, 6, 70, "Input",
 CellID->1924436473],
Cell[14981, 480, 572, 13, 54, "Output",
 CellID->752594244]
}, Open  ]],
Cell[15568, 496, 103, 2, 70, "ExampleText",
 CellID->172778078],
Cell[CellGroupData[{
Cell[15696, 502, 206, 7, 70, "Input",
 CellID->483266202],
Cell[15905, 511, 836, 29, 36, "Output",
 CellID->471904060]
}, Open  ]],
Cell[16756, 543, 96, 1, 70, "ExampleText",
 CellID->634428049],
Cell[CellGroupData[{
Cell[16877, 548, 233, 8, 70, "Input",
 CellID->575912188],
Cell[17113, 558, 836, 29, 36, "Output",
 CellID->647346687]
}, Open  ]],
Cell[17964, 590, 122, 3, 70, "ExampleText",
 CellID->1069212378],
Cell[CellGroupData[{
Cell[18111, 597, 267, 9, 70, "Input",
 CellID->109278950],
Cell[18381, 608, 319, 9, 36, "Output",
 CellID->1516249447]
}, Open  ]],
Cell[18715, 620, 82, 1, 70, "ExampleText",
 CellID->2093341437],
Cell[CellGroupData[{
Cell[18822, 625, 252, 8, 70, "Input",
 CellID->564942858],
Cell[19077, 635, 1686, 39, 134, "Output",
 CellID->1141771897]
}, Open  ]],
Cell[20778, 677, 98, 1, 70, "ExampleText",
 CellID->915874986],
Cell[CellGroupData[{
Cell[20901, 682, 289, 9, 70, "Input",
 CellID->2095591653],
Cell[21193, 693, 319, 9, 36, "Output",
 CellID->1877101171]
}, Open  ]],
Cell[CellGroupData[{
Cell[21549, 707, 255, 8, 70, "Input",
 CellID->1904606567],
Cell[21807, 717, 1274, 31, 134, "Output",
 CellID->331329387]
}, Open  ]],
Cell[23096, 751, 115, 3, 70, "ExampleText",
 CellID->227910638],
Cell[CellGroupData[{
Cell[23236, 758, 293, 9, 70, "Input",
 CellID->1530750265],
Cell[23532, 769, 319, 9, 36, "Output",
 CellID->398266936]
}, Open  ]],
Cell[CellGroupData[{
Cell[23888, 783, 255, 8, 70, "Input",
 CellID->123835897],
Cell[24146, 793, 1588, 36, 134, "Output",
 CellID->2113349300]
}, Open  ]],
Cell[25749, 832, 98, 1, 70, "ExampleText",
 CellID->1829647367],
Cell[CellGroupData[{
Cell[25872, 837, 264, 8, 70, "Input",
 CellID->1064955776],
Cell[26139, 847, 319, 9, 36, "Output",
 CellID->526840455]
}, Open  ]],
Cell[CellGroupData[{
Cell[26495, 861, 254, 8, 70, "Input",
 CellID->532450604],
Cell[26752, 871, 2331, 48, 139, "Output",
 CellID->332944379]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[29132, 925, 278, 8, 70, "ExampleSection",
 CellID->1305812373],
Cell[29413, 935, 152, 4, 70, "ExampleText",
 CellID->1601277418],
Cell[CellGroupData[{
Cell[29590, 943, 229, 8, 70, "Input",
 CellID->404500122],
Cell[29822, 953, 6271, 222, 178, "Output",
 CellID->1647807699]
}, Open  ]],
Cell[36108, 1178, 154, 4, 70, "ExampleText",
 CellID->754885381],
Cell[CellGroupData[{
Cell[36287, 1186, 345, 12, 70, "Input",
 CellID->25211991],
Cell[36635, 1200, 162, 5, 36, "Output",
 CellID->683654278]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[36858, 1212, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[37309, 1227, 231, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[37555, 1235, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

