(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    175541,       3581]
NotebookOptionsPosition[    167512,       3321]
NotebookOutlinePosition[    170029,       3386]
CellTagsIndexPosition[    169905,       3380]
WindowTitle->SRSChart - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Visualizing Statistical Concepts\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities/ref/SRSChart\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/SRSChart"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/SRSChart.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/SRSChart", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["SRSChart", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"SRSChart", "[", 
       StyleBox["n", "TI"], "]"}]], "InlineFormula"],
     " \[LineSeparator]visualize a population of size ",
     Cell[BoxData[
      StyleBox["n", "TI"]], "InlineFormula"]
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"SRSChart", "[", 
       RowBox[{
        StyleBox["n", "TI"], ",", " ", 
        StyleBox["samp", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]visualize a population of size ",
     Cell[BoxData[
      StyleBox["n", "TI"]], "InlineFormula"],
     " with a simple random sample of size ",
     Cell[BoxData[
      StyleBox["samp", "TI"]], "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"SRSChart", "[", 
       RowBox[{
        StyleBox["n", "TI"], ",", " ", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["samp", "TI"], ",", 
          StyleBox["k", "TI"]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]visualize a population of size ",
     Cell[BoxData[
      StyleBox["n", "TI"]], "InlineFormula"],
     " with ",
     Cell[BoxData[
      StyleBox["k", "TI"]], "InlineFormula"],
     " simple random samples of size ",
     Cell[BoxData[
      StyleBox["samp", "TI"]], "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"SRSChart", "[", 
       RowBox[{
        StyleBox["pop", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["samp", "TI"], ",", 
          StyleBox["k", "TI"]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]visualize a population ",
     Cell[BoxData[
      StyleBox["pop", "TI"]], "InlineFormula"],
     " with ",
     Cell[BoxData[
      StyleBox["k", "TI"]], "InlineFormula"],
     " simple random samples of size ",
     Cell[BoxData[
      StyleBox["samp", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->611153499],

Cell[TextData[{
 "The population ",
 Cell[BoxData[
  StyleBox["pop", "TI"]], "InlineFormula"],
 " can be any set of graphics or images."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "The population list is created using ",
 Cell[BoxData[
  ButtonBox["CreatePopulation",
   BaseStyle->"Link",
   ButtonData->"paclet:Classroom Utilities/ref/CreatePopulation"]], 
  "InlineFormula"],
 "."
}], "Notes",
 CellID->1765992653],

Cell["\<\
SRSChart will take any options for Graphics with the following additions and \
modifications.\
\>", "Notes",
 CellID->615279183],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "ChartStyle", "Automatic", Cell[
    "set the style of the population objects", "TableText"]},
   {Cell["      ", "TableRowIcon"], "HexagonScale", ".91", Cell[
    "set the size of the hexagons in the chart", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["SampleColorFunction",
     BaseStyle->"Link",
     ButtonData->"paclet:Classroom Utilities/ref/SampleColorFunction"], 
    "Automatic", Cell["set the style of the samples", "TableText"]},
   {Cell["      ", "TableRowIcon"], "MatStyle", "Automatic", Cell[
    "set the color of the background disk", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True, True}}}},
 CellID->863468376]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->406254290],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->112733795],

Cell["This loads the package.", "ExampleText",
 CellID->667033784],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->972170348],

Cell["Abstract populations of sizes 14 and 19.", "ExampleText",
 CellID->1211452460],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"SRSChart", "[", 
     RowBox[{"14", ",", 
      RowBox[{"HexagonScale", "\[Rule]", " ", ".85"}]}], "]"}], ",", 
    RowBox[{"SRSChart", "[", 
     RowBox[{"19", ",", 
      RowBox[{"HexagonScale", "\[Rule]", " ", ".85"}]}], "]"}]}], "}"}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->589038013],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{
       {GrayLevel[0.75], DiskBox[{0, 0}, 4.438380194395248]}, 
       {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxdkz9IlVEYxj8/TasLJjg4NRg0CXHrNlQI5+AcEUHQHGmje4suNTSYSYOG
ihgIZoqTOYjnYEUh3qCmsLChj27wBWFTFkXXe57fhe8cOMPD+57nd/49vTeH
rw22JknSWZ8d9ZnW5/jm5P7C3g831Bgl+/TyjW931v646s7h6LTtJ3/2vdts
9bdVRz+eOhxtdkn9lcZosfhNqR77v9zt+XxlrGbQiQa8F6Hu4L2Shhe6Vzfg
4Qcv9td+bXQ+A+9h2J+B90Aa3qL64eEHL/afufvr+/j2X9ew3/lnRi8OnPn0
ps0HXmrL5aNfh58d929VPyt9vuG/H/VnZlZ+51THv6r1k69bTq/O+SYvnC93
8Na617/cmj9w8Nal4S0V+jMzJz94+MN7HtabiGfgTYd+A++RNLzFQn9mtD8D
D394ui8b3aeFp/tp8qal4Y0U+rOmHzw0vIPrE+Xa+yM+1D/qfCUf3j83y70n
rnZUu/wF1Veky0G7qN/9lt8l1fGvaD35KPLIU27IGzw0vGL+cjchP3j4wyMf
8D6kx+7vJmP98MgfPPIH79TWvdqT0YUNeFvyg4c/PPIRnc/AI3/wyB+8Yv5y
hx88NDy9R8QrWXi6fwsPHb0f/U7v3eThD4886r+5KL+OvOu/OfKu/xz1p568
6z87/CtaTx7hFfOeOfIOj7zDK+Y99eQdHv7w/gPyZBAd
         "]]}}], {192., -189.}, ImageScaled[{0.5, 0.5}], {360., 360.}], 
    InsetBox[
     GraphicsBox[{
       {GrayLevel[0.75], DiskBox[{0, 0}, 4.438380194395248]}, 
       {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxdlT1oFEEYhvc20agHKqSwsohgJcjpWagIM1iLiCBYiz9lehvTaGERz2CR
SCJBIXCeSqqYImSGqCiSE7SSKFq4eMIJEiujKF5u3mdhZmCLj/n2fXZm99kZ
uTB69tJAlmXDvWuod+W9q7E8uT736Ye73B9V+/DU+W9XF/649urm2Gm37v15
4O3ygL+ieeq7U5tj0LbUX++PiiVvSvNp/vO1PZ9Pj3cMdaYB71mYd/BeqIYX
uueX4JEHL83X89pkfQbe7fB8Bt4t1fCa6odHHrw0f+b6r++N139dP371nxk7
dvLgx1eDPvByW6tt+zr6aId/o/lDqo/089eT/sLcU95hzZPf1v2TLyv752d9
yQvr6zp4C8OLXy7e33DwFlXDa0X9hZlVHjzy4T0N95uEZ+BNh34D745qeM2o
vzB6PgOPfHjaL5vsp4Wn/Sl506rhXYv6izIPHjW8jXMTtc67LT7Mf9D6qj68
/655PLLrzFB7tz+q+Seqa6F2Sb/7rbzjmie/rvvxI+bhU9fgGzxqeLF/XTeh
PHjkw8MPeO/z7TfXsvET8PAPHv7B27dyo/NgbG4J3ory4JEPDz+S9Rl4+AcP
/+DF/nUdefCo4el9JLyqhaf9t/Cok/dHv9P7Lnnkw8NHfW8u8dfhu743h+/6
npP+3OO7vmdHfl334yO82PfC4Ts8fIcX+557fIdHPjx8THj463Q//rqGanix
77nHd3jkw8PHZD/x1+E7PHyHF/uee/LgUcPDD/3vfexfxeOb/vdlrf+9b8Xn
pcc/nSc+zccPas4/eJrn/CxreJx/8PAPXpqPH8n6OM94Ps7PsobXjM/LMg9e
mv8f4V428A==
         "]]}}], {576., -189.}, ImageScaled[{0.5, 0.5}], {360., 360.}]}, {}},
  ContentSelectable->True,
  PlotRangePadding->{6, 5}]], "Output",
 ImageSize->{184, 94},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->469833943]
}, Open  ]],

Cell["\<\
Abstract populations of sizes 14 and 19 with random samples of size 3.\
\>", "ExampleText",
 CellID->795377340],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"SRSChart", "[", 
     RowBox[{"14", ",", 
      RowBox[{"{", "3", "}"}], ",", 
      RowBox[{"HexagonScale", "\[Rule]", " ", ".85"}]}], "]"}], ",", 
    RowBox[{"SRSChart", "[", 
     RowBox[{"19", ",", 
      RowBox[{"{", "3", "}"}], ",", 
      RowBox[{"HexagonScale", "\[Rule]", " ", ".85"}]}], "]"}]}], "}"}], 
  "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1968734452],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{
       {GrayLevel[0.75], DiskBox[{0, 0}, 4.438380194395248]}, 
       {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxdVD1IQlEUfv6UlVBBQ1ODQVMQ1muoCO6lOSKCoDn6Gd2bXGpoMIsGjQop
EMwKJ3MQ78OKIjSoKSxqSDIwCJsyKVLv+YR3L9zh45zznXO+973rmvfMLNo0
TXNWr6N6rdVbnt1yF+6bjCG9dh7Z0eTc+0rcadShXmQnro5pR7bTGKH4KWG3
xELJFz/EN0Zx8OtUv7f6/eG/+RXDdVwS3tGJgadru5HN1E5euN0tb57jNpqn
JAYJ18OZPyXfauwT3y3Fwa9TPTDVM6Weox/VM/Sj+ZT8PEM/mq+xT5bq/alA
Kfz8KZbqx8mlPhWKt/Pmnq/+u5TNWKY48E6wduw8SvlyfgsHX5DiKn/gytIX
CxkNPWW/ooCe8a7E68JBGfOKBGHoGTXlW40Q8UFP8EPPi1z3y5SvwOCXB2vr
ek7zjcMv5zIu4JdLwvBLb3qtcOgNJ+GXNPHBL+CHX4Cxr0YHeqIf9EQ/6Cmz
Y0noCT7oqfKfSX0Y/EJ6MvhlV+rB4JdtwvBLxJSfZ6Q/g1/AD7/Q9+fm/6/C
oOem/N4Mem4Qhp4Rc74AH/QEhp7Aij8Z9EQ/6Il+0NPczwL/cuip8tN7oezn
5NiP3geO/YCV9wX5gt6jxn7gx37/a8FcVg==
         "]], 
        {EdgeForm[{RGBColor[
         0.996078431372549, 0.3607843137254902, 0.027450980392156862`], 
         Thickness[
          NCache[
           Rational[1, 50], 0.02]]}], PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGAAYXYgZgJiAwOOZ/lruBzOgME/+wZLJ707J1gczoL5TA7z
Wn+8mXDqr/05qPwcKN/EGAQ+2tejqH9iDzPPCCoP45+F6p+wb8bHZffe74fI
37Zf5RPxomrb7/1grvFrezbZT9oX9zEfsIDKw/gGEP7+1ajq90+CmmcFlYeZ
bwzVP+M4o+qGBQf2w/wHse/1fpj/tgnveJyy6Od+mP92QPkw/61GUf/EfgHU
PJj/YObD/AcA4+i1bg==
          "]]}}}], {192., -189.}, ImageScaled[{0.5, 0.5}], {360., 360.}], 
    InsetBox[
     GraphicsBox[{
       {GrayLevel[0.75], DiskBox[{0, 0}, 4.438380194395248]}, 
       {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxdlUFIVEEcxt8+Na2FEjp48mDQSYjN7VARzOA5JISgc5QdvXvJSx062CYd
NCykQFit8GQexBmsKMIN6iQWdWhpgxViO2lRtLvv+y3MDLzDx/zn+/4z83vv
DV2dHL/elSRJf/PpbT5p8zm4PFuofezxI8XW+GSWL175MbWW921ZrJtnQ8cu
9Vb6/VnNP5cuZNpF9e63/M5rHv+i1j+8tb9XevfXnWnrhps+N3rq89tuX9lu
jaorFPq+Tz49on4a7rR0e3r7X1Sf+kfye695/ItaX9qcayx9+ekezLdGt8/6
/aP5nD80+Gv4w2aXn9c8eqI98n5F9VneUT8rvxuaj/3n3uROri76zv6yvLpj
f2vH179de3zg2N+6NPtbCepTvyg/9oc/+0NrvQnzUkue1hvy1J8J86qGPPVn
8K9o/avdga9jMzXDfhMNzlPzjvNEc55Z9eoG57klP84z9kfD5056+M5uMnMB
Pl/KHz5fS8Pnia3btSfTSxvwSR584g+faPVr2Z/6teSpX0ue+rXsT+dh8dN5
2Nj/RXYfJuLFwIvuw8BLSRpeykF96nXfBl7whxd0xAvr7YL84eW+NLyEeVVD
HrzgDy96n2z0/hl40fvD+XQ0vJRVDy/4wUvsjw6/Z+TVzT35w8tdaXgph/UO
P3hBwwua+1wO+7XkwQt58BLm5Sx+8BL76/too++nhRd9Dzu8LEjDy82gPvX4
wQsaXtDwEualljx4IQ9ewryqwQ9e0PCi/0t0f3nL/el/Yrk/dPQ/ot7p/9W5
P/y5v/83J4Yo
         "]], 
        {EdgeForm[{RGBColor[
         0.996078431372549, 0.3607843137254902, 0.027450980392156862`], 
         Thickness[
          NCache[
           Rational[1, 50], 0.02]]}], PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGAAYXYgZgLiua0/3kw49Xf/GTD4Z99g6aR35wTLgbNgPpOD
gQHHs/w1XAfOQeUNoXwTYxD4iKb+if08qHlGUHmY+Weh+ifsm/Fx2b33+9PA
gNthlU/Ei6ptv6HyfA5ssp+0L+5jPpAOlYfxZ80EARaH1VD1YOONGR1g5s2E
yqObD+ND3HPbfhWK/tf2MPMtoPIwvgGEvx/Vvtf7J0HNs4LKw8w3huoHAC+z
sm8=
          "]]}}}], {576., -189.}, ImageScaled[{0.5, 0.5}], {360., 360.}]}, {}},
  ContentSelectable->True,
  PlotRangePadding->{6, 5}]], "Output",
 ImageSize->{184, 94},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->2016625341]
}, Open  ]],

Cell["A population of happy faces with a sample of size 3.", "ExampleText",
 CellID->408453255],

Cell[BoxData[
 RowBox[{
  RowBox[{"pop", "=", 
   RowBox[{"CreatePopulation", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Happy", "[", "]"}], "}"}], ",", "7"}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1516120973],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SRSChart", "[", 
  RowBox[{"pop", ",", 
   RowBox[{"{", "3", "}"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1551721556],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0.75], DiskBox[{0, 0}, 2.6630281166371486`]}, 
   {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGBgAWJ2IGYC4plam3b9Nnm3X671deAOubv2q3wiXlRt+71f
Hsx/a898aPVPa02WAypQeRYoXxrC378aVf3+OVDz1KDys6B8eaj+hvfnJrF9
2bzf42GVyDr3//YrwfpfQ/nMDptiteutyn/t94TKw/g7wQ78YL8Gqh4s/fCR
/QSoedug8ujmV0D5OyDy+1ei6t8PM387VB7Gd4fo378G1X0HYPZ5QeUb0MyH
6reH8SHh89oeZh9UvT3MPhgfZt8KqHqYfRuh5sHsQzcfAMmK/MI=
     "]], 
    {EdgeForm[{RGBColor[
     0.996078431372549, 0.3607843137254902, 0.027450980392156862`], Thickness[
      NCache[
       Rational[1, 30], 0.03333333333333333]]}], PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGAAYXYgZgLi3Xn/RH+Zv7SXa30duEPurn150RKuFv4JNvJg
/lv7nRD5/SpQeaj6/dIQ/v5Nq7/xu4mv2ANVv38H1Dw1qPwuKF8eqn9TrHa9
Vfkve4+HVSLr3P/br/aJeFG17TWUz+zQ8f7cJLYvm+09ofIVUP5OsAM/2K+A
qgdLP3xkvxFq3jaoPLr5LIdW/7TWZHGA+W8VWP9ve5j/Zmtt2vXb5J09zH8z
oXyY/1aiqt/PDDUP5j+Y+TD/AQCBYa6X
      "]]}, {InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], 
      NCache[{Rational[-1, 2] 3^Rational[1, 2], Rational[
        3, 2]}, {-0.8660254037844386, 1.5}], Center, 1.2], InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], 
      NCache[{Rational[1, 2] 3^Rational[1, 2], Rational[3, 2]}, {
       0.8660254037844386, 1.5}], Center, 1.2], InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], 
      NCache[{-3^Rational[1, 2], 0}, {-1.7320508075688772`, 0}], Center, 1.2],
      InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], {0, 0}, 
      Center, 1.2], InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], 
      NCache[{3^Rational[1, 2], 0}, {1.7320508075688772`, 0}], Center, 1.2], 
     InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], 
      NCache[{Rational[-1, 2] 3^Rational[1, 2], 
        Rational[-3, 2]}, {-0.8660254037844386, -1.5}], Center, 1.2], InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], 
      NCache[{Rational[1, 2] 3^Rational[1, 2], Rational[-3, 2]}, {
       0.8660254037844386, -1.5}], Center, 1.2]}}}]], "Output",
 ImageSize->{184, 170},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1835189233]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Scope",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1293636265],

Cell["This loads the package.", "ExampleText",
 CellID->623440857],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->597769886],

Cell["Use a set of different images for the chart,", "ExampleText",
 CellID->789973336],

Cell[BoxData[
 RowBox[{
  RowBox[{"pop", "=", " ", 
   RowBox[{"CreatePopulation", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Happy", "[", "]"}], ",", 
       RowBox[{"Sleepy", "[", "]"}], ",", 
       RowBox[{"Grumpy", "[", "]"}], ",", 
       RowBox[{"Oh", "[", "]"}]}], "}"}], ",", "7"}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1337952398],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SRSChart", "[", 
  RowBox[{"pop", ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->664685449],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0.75], DiskBox[{0, 0}, 2.6630281166371486`]}, 
   {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGAAYXYgZgLihvfnJrF92bzf42GVyDr3//YrfSJeVG17DeUz
O2yK1a63Kv+13xMqD+PvlGt9Hbjjg/0aqHqw9MNH9hOg5m2DyqObvzvvn+gv
85f2YGm5u/blRUu4Wvgn2MiD+W/td0Lk96tA5aHq90tD+Ps3rf7G7ya+Yg9U
/f4dUPPUoPK7oHx5qH6oe+1h9q+GuNce5r8OiPvsYf6rgPJh/lsBVQ/z30ao
eTD/oZsPANo3tN0=
     "]], {
     {EdgeForm[{RGBColor[
      0.996078431372549, 0.3607843137254902, 0.027450980392156862`], Thickness[
       NCache[
        Rational[1, 30], 0.03333333333333333]]}], 
      PolygonBox[{{{2.5201339250127166`, 0.45499999999999996`}, {
       1.7320508075688772`, 0.91}, {0.9439676901250381, 0.4550000000000003}, {
       0.9439676901250379, -0.4549999999999998}, {1.732050807568877, -0.91}, {
       2.520133925012716, -0.4550000000000004}, {2.5201339250127166`, 
       0.455}}, {{-0.9439676901250379, 
       0.45499999999999996`}, {-1.7320508075688772`, 
       0.91}, {-2.520133925012716, 
       0.4550000000000003}, {-2.5201339250127166`, -0.4549999999999998}, \
{-1.7320508075688774`, -0.91}, {-0.9439676901250382, -0.4550000000000004}, \
{-0.943967690125038, 0.455}}}]}, 
     {EdgeForm[{RGBColor[
      0.996078431372549, 0.9882352941176471, 0.03529411764705882], Thickness[
       NCache[
        Rational[1, 30], 0.03333333333333333]]}], 
      PolygonBox[{{{-0.0779422863405993, -1.045}, {-0.8660254037844385, \
-0.59}, {-1.6541085212282778`, -1.0449999999999997`}, {-1.6541085212282778`, \
-1.9549999999999998`}, {-0.8660254037844388, -2.41}, {-0.07794228634059963, \
-1.9550000000000005`}, {-0.07794228634059941, -1.045}}, {{
       1.6541085212282778`, -1.045}, {0.8660254037844387, -0.59}, {
       0.07794228634059941, -1.0449999999999997`}, {
       0.07794228634059941, -1.9549999999999998`}, {
       0.8660254037844384, -2.41}, {
       1.6541085212282776`, -1.9550000000000005`}, {
       1.6541085212282778`, -1.045}}}]}}, {InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], 
      NCache[{Rational[-1, 2] 3^Rational[1, 2], Rational[
        3, 2]}, {-0.8660254037844386, 1.5}], Center, 1.2], InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.02], 
         CircleBox[
          NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]], 
         CircleBox[
          NCache[{Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], 
      NCache[{Rational[1, 2] 3^Rational[1, 2], Rational[3, 2]}, {
       0.8660254037844386, 1.5}], Center, 1.2], InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         CircleBox[
          NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[Rational[1, 4], 0.25], 
          NCache[{Rational[1, 2] Pi, Pi}, {1.5707963267948966`, 
           3.141592653589793}]], 
         CircleBox[
          NCache[{Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 4], 0.25], 
          NCache[{Rational[1, 2] Pi, 0}, {1.5707963267948966`, 0}]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[NCache[{0, Rational[-7, 8]}, {0, -0.875}], NCache[
          Rational[5, 8], 0.625], 
          NCache[{Rational[1, 6] Pi, Rational[5, 6] Pi}, {0.5235987755982988, 
           2.6179938779914944`}]]}}], 
      NCache[{-3^Rational[1, 2], 0}, {-1.7320508075688772`, 0}], Center, 1.2],
      InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.02], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], 
          NCache[{Rational[1, 9], Rational[1, 6]}, {0.1111111111111111, 
           0.16666666666666666`}]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], 
          NCache[{Rational[1, 9], Rational[1, 6]}, {0.1111111111111111, 
           0.16666666666666666`}]], 
         CircleBox[
          NCache[{Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], 
          NCache[{Rational[1, 8], Rational[1, 4]}, {0.125, 0.25}], 
          NCache[{Rational[1, 3] Pi, Rational[2, 3] Pi}, {1.0471975511965976`,
            2.0943951023931953`}]], 
         CircleBox[
          NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], 
          NCache[{Rational[1, 8], Rational[1, 4]}, {0.125, 0.25}], 
          NCache[{Rational[1, 3] Pi, Rational[2, 3] Pi}, {1.0471975511965976`,
            2.0943951023931953`}]]}, 
        {RGBColor[1, 0, 0], Thickness[0.02], 
         CircleBox[NCache[{0, Rational[-1, 2]}, {0, -0.5}], 
          NCache[{Rational[1, 5], Rational[1, 3]}, {0.2, 
           0.3333333333333333}]], 
         {GrayLevel[0], 
          DiskBox[NCache[{0, Rational[-1, 2]}, {
            0, -0.5}], {0.1923076923076923, 0.3125}]}}}], {0, 0}, Center, 
      1.2], InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], 
      NCache[{3^Rational[1, 2], 0}, {1.7320508075688772`, 0}], Center, 1.2], 
     InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.02], 
         CircleBox[
          NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]], 
         CircleBox[
          NCache[{Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[{0, 0}, NCache[Rational[5, 8], 0.625], 
          NCache[{Rational[-1, 6] Pi, Rational[-5, 6] 
            Pi}, {-0.5235987755982988, -2.6179938779914944`}]]}}], 
      NCache[{Rational[-1, 2] 3^Rational[1, 2], 
        Rational[-3, 2]}, {-0.8660254037844386, -1.5}], Center, 1.2], InsetBox[
      GraphicsBox[
       {RGBColor[1, 1, 0], EdgeForm[GrayLevel[0]], DiskBox[{0, 0}], 
        {GrayLevel[0], Thickness[0.03], 
         DiskBox[NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         DiskBox[NCache[{
           Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 6], 0.16666666666666666`]], 
         CircleBox[
          NCache[{Rational[9, 32] 3^Rational[1, 2], Rational[9, 32]}, {
           0.4871392896287467, 0.28125}], NCache[Rational[1, 4], 0.25], 
          NCache[{Rational[1, 2] Pi, Pi}, {1.5707963267948966`, 
           3.141592653589793}]], 
         CircleBox[
          NCache[{Rational[-9, 32] 3^Rational[1, 2], Rational[
            9, 32]}, {-0.4871392896287467, 0.28125}], NCache[
          Rational[1, 4], 0.25], 
          NCache[{Rational[1, 2] Pi, 0}, {1.5707963267948966`, 0}]]}, 
        {RGBColor[1, 0, 0], Thickness[0.03], 
         CircleBox[NCache[{0, Rational[-7, 8]}, {0, -0.875}], NCache[
          Rational[5, 8], 0.625], 
          NCache[{Rational[1, 6] Pi, Rational[5, 6] Pi}, {0.5235987755982988, 
           2.6179938779914944`}]]}}], 
      NCache[{Rational[1, 2] 3^Rational[1, 2], Rational[-3, 2]}, {
       0.8660254037844386, -1.5}], Center, 1.2]}}}]], "Output",
 ImageSize->{184, 170},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1865300817]
}, Open  ]],

Cell["Number the members of the population.", "ExampleText",
 CellID->1658732110],

Cell[BoxData[
 RowBox[{
  RowBox[{"numpop", "=", " ", 
   RowBox[{"CreatePopulation", "[", 
    RowBox[{
     RowBox[{
      RowBox[{
       RowBox[{"Text", "[", 
        RowBox[{"Style", "[", 
         RowBox[{"#", ",", 
          RowBox[{"FontColor", "\[Rule]", "Yellow"}], ",", "24", ",", 
          "Bold"}], "]"}], "]"}], "&"}], "/@", 
      RowBox[{"Range", "[", "7", "]"}]}], ",", "7"}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1825351063],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SRSChart", "[", 
  RowBox[{"numpop", ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1871418446],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0.75], DiskBox[{0, 0}, 2.6630281166371486`]}, 
   {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGAAYXYgZgLimVqbdv02ebdfrvV14A65u/arfCJeVG37vV8e
zH9rz3xo9U9rTZYDKlB5FihfGsLfvxpV/f45UPPUoPKzoHx5qP6K9+cmsX3Z
vH8H2MIP+1eC9b/e/7BKZJ37w0f7N8Vq11uV/9q/HSoP47uDFfzfvwaq3gPM
Zz4wAWqeF1S+Ac18qH57GB/i3tf2MPug6u1h9sH4MPtWQNXD7NsINQ9mH7r5
AGzgvoo=
     "]], {
     {EdgeForm[{RGBColor[
      0.996078431372549, 0.3607843137254902, 0.027450980392156862`], Thickness[
       NCache[
        Rational[1, 30], 0.03333333333333333]]}], 
      PolygonBox[{{{1.6541085212282778`, 1.955}, {0.8660254037844387, 2.41}, {
       0.07794228634059952, 1.9550000000000003`}, {0.0779422863405993, 
       1.0450000000000002`}, {0.8660254037844384, 0.59}, {1.6541085212282776`,
        1.0449999999999995`}, {1.6541085212282778`, 1.955}}, {{
       0.7880831174438393, 0.45499999999999996`}, {5.572142936120457*^-17, 
       0.91}, {-0.7880831174438391, 
       0.4550000000000003}, {-0.7880831174438393, -0.4549999999999998}, \
{-1.671642880836137*^-16, -0.91}, {0.788083117443839, -0.4550000000000004}, {
       0.7880831174438392, 0.455}}}]}, 
     {EdgeForm[{RGBColor[
      0.996078431372549, 0.9882352941176471, 0.03529411764705882], Thickness[
       NCache[
        Rational[1, 30], 0.03333333333333333]]}], 
      PolygonBox[{{{2.5201339250127166`, 0.45499999999999996`}, {
       1.7320508075688772`, 0.91}, {0.9439676901250381, 0.4550000000000003}, {
       0.9439676901250379, -0.4549999999999998}, {1.732050807568877, -0.91}, {
       2.520133925012716, -0.4550000000000004}, {2.5201339250127166`, 
       0.455}}, {{-0.07794228634059941, 1.955}, {-0.8660254037844385, 
       2.41}, {-1.6541085212282778`, 
       1.9550000000000003`}, {-1.6541085212282778`, 
       1.0450000000000002`}, {-0.8660254037844388, 
       0.59}, {-0.07794228634059963, 
       1.0449999999999995`}, {-0.07794228634059941, 1.955}}}]}}, {InsetBox[
      GraphicsBox[InsetBox[
        StyleBox["1",
         StripOnInput->False,
         FontSize->24,
         FontWeight->Bold,
         FontColor->RGBColor[1, 1, 0]], {0, 0}]], 
      NCache[{Rational[-1, 2] 3^Rational[1, 2], Rational[
        3, 2]}, {-0.8660254037844386, 1.5}], Center, 1.2], InsetBox[
      GraphicsBox[InsetBox[
        StyleBox["2",
         StripOnInput->False,
         FontSize->24,
         FontWeight->Bold,
         FontColor->RGBColor[1, 1, 0]], {0, 0}]], 
      NCache[{Rational[1, 2] 3^Rational[1, 2], Rational[3, 2]}, {
       0.8660254037844386, 1.5}], Center, 1.2], InsetBox[
      GraphicsBox[InsetBox[
        StyleBox["3",
         StripOnInput->False,
         FontSize->24,
         FontWeight->Bold,
         FontColor->RGBColor[1, 1, 0]], {0, 0}]], 
      NCache[{-3^Rational[1, 2], 0}, {-1.7320508075688772`, 0}], Center, 1.2],
      InsetBox[
      GraphicsBox[InsetBox[
        StyleBox["4",
         StripOnInput->False,
         FontSize->24,
         FontWeight->Bold,
         FontColor->RGBColor[1, 1, 0]], {0, 0}]], {0, 0}, Center, 1.2], 
     InsetBox[
      GraphicsBox[InsetBox[
        StyleBox["5",
         StripOnInput->False,
         FontSize->24,
         FontWeight->Bold,
         FontColor->RGBColor[1, 1, 0]], {0, 0}]], 
      NCache[{3^Rational[1, 2], 0}, {1.7320508075688772`, 0}], Center, 1.2], 
     InsetBox[
      GraphicsBox[InsetBox[
        StyleBox["6",
         StripOnInput->False,
         FontSize->24,
         FontWeight->Bold,
         FontColor->RGBColor[1, 1, 0]], {0, 0}]], 
      NCache[{Rational[-1, 2] 3^Rational[1, 2], 
        Rational[-3, 2]}, {-0.8660254037844386, -1.5}], Center, 1.2], InsetBox[
      GraphicsBox[InsetBox[
        StyleBox["7",
         StripOnInput->False,
         FontSize->24,
         FontWeight->Bold,
         FontColor->RGBColor[1, 1, 0]], {0, 0}]], 
      NCache[{Rational[1, 2] 3^Rational[1, 2], Rational[-3, 2]}, {
       0.8660254037844386, -1.5}], Center, 1.2]}}}]], "Output",
 ImageSize->{184, 170},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1144552413]
}, Open  ]],

Cell["Use custom images to create the population.", "ExampleText",
 CellID->1828707719],

Cell[BoxData[
 RowBox[{
  RowBox[{"img", "=", 
   GraphicsBox[
    TagBox[RasterBox[CompressedData["
1:eJxMvWeQU1e6LrzOuefUPXVP1f1z61bd+mxoOivHDupWS+qcc7c65wQdoKHJ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      "], {{0, 176}, {131, 0}}, {0, 255},
      ColorFunction->RGBColor],
     BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
     Selectable->False],
    BaseStyle->"ImageGraphics",
    ImageSizeRaw->{131, 176},
    PlotRange->{{0, 131}, {0, 176}}]}], ";"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->304677369],

Cell[BoxData[
 RowBox[{
  RowBox[{"facepop", "=", " ", 
   RowBox[{"CreatePopulation", "[", 
    RowBox[{
     RowBox[{"{", "img", "}"}], ",", "7"}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->1111526335],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SRSChart", "[", 
  RowBox[{"facepop", ",", 
   RowBox[{"{", 
    RowBox[{"2", ",", "2"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->462867092],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztvS+Uo8wWPXrXeubKkW0jkUgsEoks+UOW+ImSZZFIJBbz1sI9JBaJRGIj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    "], {{0, 170}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 170},
  PlotRange->{{0, 180}, {0, 170}}]], "Output",
 ImageSize->{184, 170},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[8]=",
 CellID->585466644]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(4)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2061341341],

Cell[CellGroupData[{

Cell[BoxData[
 ButtonBox[
  InterpretationBox[Cell[TextData[{
    "ChartStyle",
    "\[NonBreakingSpace]\[NonBreakingSpace]",
    Cell["(1)", "ExampleCount"]
   }], "ExampleSubsection"],
   $Line = 0; Null],
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/"]], "ExampleSubsection", \
"ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->7781165],

Cell["Load the package.", "ExampleText",
 CellID->1929021335],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->500958586],

Cell["Change the color of the Hexagons.", "ExampleText",
 CellID->759711266],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"SRSChart", "[", 
     RowBox[{"7", ",", 
      RowBox[{"ChartStyle", "\[Rule]", " ", "Red"}]}], "]"}], ",", 
    RowBox[{"SRSChart", "[", 
     RowBox[{"7", ",", 
      RowBox[{"ChartStyle", "\[Rule]", " ", "Yellow"}]}], "]"}]}], "}"}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1676966247],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{
       {GrayLevel[0.75], DiskBox[{0, 0}, 2.6630281166371486`]}, 
       {RGBColor[1, 0, 0], PolygonBox[CompressedData["
1:eJxdkjtLA1EQhRcTFGzSKBZCFiEIaisIKsxWRsVGKxsbwVbBJpLGFAqWwc5H
abFxg5AVYhKFWfwB/gOLWCnBRyGCCfhg7znF3eIWhzNzvnvvzNjmztpWynGc
AZy+/1N6fzju/7zWxXZx6Cr/K5WV9edivQOd8sKNqf3ZQleX4FM3s4ed1caH
VFEf2+0nKSOvDj+Zj36hDky/kHdk6oW8PWjyfNSTV0Meecn8k8mw1Zt+09jO
Pspl3N9TN9avkroPvucm0lEOfhp61GgN7Ho9R944/FNoF/232z/D3ZkXIa+w
ezF4kCnPk9c0vubseiUvDL4yCyP+HXkN5JHXgnbt+3qJ9wl5Z+Z+Qh7+Q8ir
2PWK//DIYz55mIc2zH9rxZ6/cj9u4FPnzTy0au9XxH1Zhl9K5HOe1IE9f9YL
edTk+fZ+RdwX8pL5f3LLqbI=
         "]]}}], {192., -189.}, ImageScaled[{0.5, 0.5}], {360., 360.}], 
    InsetBox[
     GraphicsBox[{
       {GrayLevel[0.75], DiskBox[{0, 0}, 2.6630281166371486`]}, 
       {RGBColor[1, 1, 0], PolygonBox[CompressedData["
1:eJxdkjtLA1EQhRcTFGzSKBZCFiEIaisIKsxWRsVGKxsbwVbBJpLGFAqWwc5H
abFxg5AVYhKFWfwB/gOLWCnBRyGCCfhg7znF3eIWhzNzvnvvzNjmztpWynGc
AZy+/1N6fzju/7zWxXZx6Cr/K5WV9edivQOd8sKNqf3ZQleX4FM3s4ed1caH
VFEf2+0nKSOvDj+Zj36hDky/kHdk6oW8PWjyfNSTV0Meecn8k8mw1Zt+09jO
Pspl3N9TN9avkroPvucm0lEOfhp61GgN7Ho9R944/FNoF/232z/D3ZkXIa+w
ezF4kCnPk9c0vubseiUvDL4yCyP+HXkN5JHXgnbt+3qJ9wl5Z+Z+Qh7+Q8ir
2PWK//DIYz55mIc2zH9rxZ6/cj9u4FPnzTy0au9XxH1Zhl9K5HOe1IE9f9YL
edTk+fZ+RdwX8pL5f3LLqbI=
         "]]}}], {576., -189.}, ImageScaled[{0.5, 0.5}], {360., 360.}]}, {}},
  ContentSelectable->True,
  PlotRangePadding->{6, 5}]], "Output",
 ImageSize->{184, 94},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1760815713]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 ButtonBox[
  InterpretationBox[Cell[TextData[{
    "HexagonScale",
    "\[NonBreakingSpace]\[NonBreakingSpace]",
    Cell["(1)", "ExampleCount"]
   }], "ExampleSubsection"],
   $Line = 0; Null],
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/"]], "ExampleSubsection", \
"ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1257265053],

Cell["Load the package.", "ExampleText",
 CellID->1762142938],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->389383189],

Cell["Adjust the space between the hexagons.", "ExampleText",
 CellID->980585114],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"SRSChart", "[", 
     RowBox[{"7", ",", 
      RowBox[{"HexagonScale", "\[Rule]", " ", ".75"}]}], "]"}], ",", 
    RowBox[{"SRSChart", "[", 
     RowBox[{"7", ",", 
      RowBox[{"HexagonScale", "\[Rule]", " ", ".85"}]}], "]"}]}], "}"}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->904503920],

Cell[BoxData[
 GraphicsBox[{{}, {InsetBox[
     GraphicsBox[{
       {GrayLevel[0.75], DiskBox[{0, 0}, 2.6630281166371486`]}, 
       {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxdkjFLA0EQhdeNKITYaXr/gJYhEJigbWxSWQvWNhLQwmgX4n8QQQvjWVhE
q8BcKVhZKWIpeCTVXaXIJZrbeQuzC1s85u375m5mfe+gvV8yxizLtf/3prWb
HD8+synOlG4LPRFtm6vbO+cRffOC1KtKZxQpf0L3kjedzU9KYf6ae08Bj8C7
c34C71rpjAbKn5D0R+CF+ePN2kulnXJRnr0K79f3+zAcdQ9XSvFiod+8zp2f
I+3nieQtOT8j38j70/rWxsfTJ4FX7l+06kf9BnhdV2fwzkSD1/vq/Izfr0bg
nUgeeMg3ut9m8H3+/0h/BB40eAPt56HkgYd88PQ8M9b7kjD2xfWTclXpnPW+
2Bj7Yt28OMzX8/Q836+8J/Aulc5Z74uNsS/ghfl/uihaZQ==
         "]]}}], {192., -189.}, ImageScaled[{0.5, 0.5}], {360., 360.}], 
    InsetBox[
     GraphicsBox[{
       {GrayLevel[0.75], DiskBox[{0, 0}, 2.6630281166371486`]}, 
       {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxdkrFLQmEUxV+fUDQ3NDkoNLVEryEkuP4B0tDUHDW3NzU1OJhFg0ODKAjq
0qQO4X1Y0aJBWxjY0AMDh7AtBMned87wvQffcLj3nt99nJs6Oj04SXiet4Jn
Fq/0vLRxVw60H31zaeQOv85aEx1E2mRba53P48qvvqDegd7x/7+pNJ3+UMrw
20ad/gPMt+28xHhC3q3tF/JuoMmrO/2hYD8hj/7kFbulaW30jX3ewZtpJP2J
LCd/Nl+7iWAXdeotq7Xp9us1/DKo09/H/ONw/WO/MBby3sxqfugV9sh7sHUl
7wmavHTvYlw9r92T14MfefQnD/tmY/8n5F3Z/YS8S2jy6m6/0o88avKYJ/JQ
915C5b0gD+W9IG9178UEvBfkrfT3Mc88Yzzmr5hn/lqEJs+9FxPwXsijP3l/
Xoye/A==
         "]]}}], {576., -189.}, ImageScaled[{0.5, 0.5}], {360., 360.}]}, {}},
  ContentSelectable->True,
  PlotRangePadding->{6, 5}]], "Output",
 ImageSize->{184, 94},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1705032731]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 ButtonBox[
  InterpretationBox[Cell[TextData[{
    "MatStyle",
    "\[NonBreakingSpace]\[NonBreakingSpace]",
    Cell["(1)", "ExampleCount"]
   }], "ExampleSubsection"],
   $Line = 0; Null],
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/"]], "ExampleSubsection", \
"ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->85866151],

Cell["Load the package.", "ExampleText",
 CellID->1285937184],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->470828080],

Cell["Change the color of the disk in the background.", "ExampleText",
 CellID->1877785012],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SRSChart", "[", 
  RowBox[{"19", ",", 
   RowBox[{"{", "3", "}"}], ",", 
   RowBox[{"MatStyle", "\[Rule]", " ", "LightBlue"}], ",", 
   RowBox[{"Background", "\[Rule]", " ", 
    RowBox[{"GrayLevel", "[", ".4", "]"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->513020372],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[0.87, 0.94, 1], DiskBox[{0, 0}, 4.438380194395248]}, 
   {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxdlT1oU1EcxUMbFZohCn4MQosg4hedBNFW7sXBWnGpk2C7FAQnFZdKEZKh
BTeLk1+TqZA0RWoKMW0D99rJyU0U0aFOSvBjaAWbYg155xe498EbDv//Pf97
zznvvkPjt65c706lUrtb767W29V6mwsfx+/d2OF7pxsjtd4vZu7y1W+T1Yzv
a+Mf5uR6ozrYtccfVh18MMEu6ndb4juiOrhP658PTI+sbGy5Wnvgb5c7c77/
89u0X5vc+3Jo7avrf/9m8dP+jH+tOnio3bDt8uq/2MbdviC+S6rH/OCkf9vk
wvUW/mHVwUvJepMP92eYV1U95n98vLLcPPXTjT5Y3Tg6mvaJPk3tJ+W7V8t/
B46lPfW0cOH2uZ4PhYwvqz/hy/pn4nuh+pOIn3mhf02Hf8zDP+bhXznsd8zD
P+bh3yPh2WQ/di7cr2UedeaNJfu15VAPy7xrqsf8+V/vHu5cX+zoW2qvbzj8
q4ydyJ2d2HT4B8a/efXj34z48C/mvytMfkrhegc/+QSTz/lwf5555DMf8a/c
/Ldv8/R3g58pPeSlltQ7fteFyUvSvVAnL+o35GU54mceeZm4M9szlZ0ZJC9L
4icv6nfkpVL+k71woFgnL8wjL8wjL9LHcN7E/4ZBT+lh0BOMnkX1o+cr8aFn
zA/Gz3K43t4X/3DotyEvxXB/hnnkJeZXvm30vRv8U747+ivfBv9K6sc/fT8W
/2J+cPS9G/x7Kn780/1g8K8U9jvm4R/8+Kf70HJe3YcWPXX/dfQEo6fuW4ue
8KFnzK//S3S+jOV8+p9Yzqf/l43+R/Q7+DgfmPP9ByhDpnQ=
     "]], 
    {EdgeForm[{RGBColor[
     0.996078431372549, 0.3607843137254902, 0.027450980392156862`], Thickness[
      NCache[
       Rational[1, 50], 0.02]]}], PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGAAYXYgZgLiPXn/RH+Zv7RfUmDLdX0xtwMDFHg8rBJZ587v
sBMivx8mvxvKj+0/9FUjhgWqfsOeHXKtrwN3MDjsgJoXDZVHN1/v6sHNt8S4
HSDqP+xvsHTSu3OCxQFs3cNH+xdZtwbu/vrHfjtUHsZ3Byv4v78eqh7iPuYD
MPO8oPLo5rMcWv3TWpPFAWb/Kp+IF1XbftvD/Ddba9Ou3ybv4O6bCeXD/LcS
qh7mP2aoeTD/oZsPALeLnqk=
      "]]}}},
  Background->GrayLevel[0.4]]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->463324349]
}, Open  ]],

Cell["None gives no disk.", "ExampleText",
 CellID->638268709],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SRSChart", "[", 
  RowBox[{"19", ",", 
   RowBox[{"{", "3", "}"}], ",", 
   RowBox[{"MatStyle", "\[Rule]", " ", "None"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->701375398],

Cell[BoxData[
 GraphicsBox[{
   {Opacity[0], DiskBox[{0, 0}, 4.438380194395248]}, 
   {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxdlTtoVEEYhS/ZVSFbrIKPQkgQRHyRShBNZAYLo2ITK8GkCQhWKjaRIOwW
CdgZrHxVboTdXJG4gXWTLMyYyspOFNEiVsrio0gEs8G47D3fwp0Ltzj8/5wz
M+fMzIHxm5evZaIo2tn+d7T/nvbfmv84fvf6Nt833Ryp930xc5eufJus5Xx/
B/8wx9eataGeXf6g6uD9CXZBv9sU3yHVwf0a/2xwemR5fdPVO4K/XeHU2YHP
b7N+dXL3y+HVr27g/ZuFT3tz/rXq4OFOw5Yrqv98B2d8SXwXVQ/5wUn/limk
x1v4L6gOXkzGm2J6fga9muoh/6Oj1aXWiZ9u9P7K+uHRrE/2p6X5RD6zEv8d
PJL11LPCpVtnej+Ucj5Wf8KX90/F91z1xwE/emn/Wg7/0MM/9PAvTvc79PAP
Pfx7KDybzMfOpedr0aOO3lgyXxun98Oid1X1kP/Or3cPtq8tdP2sdMY3HXmp
jh0rnJ7YcOQFTF5eqJ+8zIiPvBQD/uUb//ZsnPxu2N9IH/7Vk3p3/xvC+Jd0
zzfwT/0G/5YCfvTwb+L2bO9UfmYI/xbFj3/qd/hXjf/kz+0rN/APPfxDD/80
X8P+sj78Q486evjH+vAPPfwL+eWHYX8T/5sG/7T/Bv/A+FdWP/69Eh/+hfxg
zmOcHm/viZ/zrnwZzns5PT+DHuc95Fe+bXDeDXlRvrt+K9+GvFTUT150fix5
CfnBwXk35OWJ+MmL7gdDXirpfoceeYGfvOg+tOyv7kOLf7r/uv6B8U/3rcU/
+PAv5Nf7EqwvZ1mf3hPL+vR+2eA9or/Lx/rArO8/uficYQ==
     "]], 
    {EdgeForm[{RGBColor[
     0.996078431372549, 0.3607843137254902, 0.027450980392156862`], Thickness[
      NCache[
       Rational[1, 50], 0.02]]}], PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGAAYXYgZgJivasHN98S43bweFglss79v32DpZPenRMsUD6z
wyLr1sDdX//Ye0LlYfydcq2vA3d8sK+HqgdLP3xkDzNvG1Qe3XyWQ6t/Wmuy
OCwpsOW6vpjbYZVPxIuqbb/tIfL8DrO1Nu36bfLOHiY/E8qP7T/0VSOGxWEl
VP0OsPkMDsxQ86Kh8ujmN7w/N4nty+b9MPsh+l/vh/lvU6x2vVX5r/0w/8H4
MP+tgaqH+W8C1DyY/9DNBwDGHKi8
      "]]}}}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->316629621]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 ButtonBox[
  InterpretationBox[Cell[TextData[{
    "SampleColorFunction",
    "\[NonBreakingSpace]\[NonBreakingSpace]",
    Cell["(1)", "ExampleCount"]
   }], "ExampleSubsection"],
   $Line = 0; Null],
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/ref/"]], "ExampleSubsection", \
"ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->357613465],

Cell["Load the package.", "ExampleText",
 CellID->804513244],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->897050396],

Cell["Define your own color sequence for highlighting the samples.", \
"ExampleText",
 CellID->1390803632],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeColorList", "[", 
  RowBox[{"\"\<MyColors\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"Red", ",", "Yellow", ",", "Green"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->2024629076],

Cell[BoxData[
 RowBox[{"ColorListFunction", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
   PanelBox[
    StyleBox[
     GraphicsBox[{
       {RGBColor[1, 0, 0], EdgeForm[Opacity[0.1]], 
        RectangleBox[{1, 0}, Offset[{-1, -1}, {2, 1}]]}, 
       {RGBColor[1, 1, 0], EdgeForm[Opacity[0.1]], 
        RectangleBox[{2, 0}, Offset[{-1, -1}, {3, 1}]]}, 
       {RGBColor[0, 1, 0], EdgeForm[Opacity[0.1]], 
        RectangleBox[{3, 0}, Offset[{-1, -1}, {4, 1}]]}},
      AspectRatio->NCache[
        Rational[1, 10], 0.1],
      ImageSize->65,
      PlotRangePadding->None],
     StripOnInput->False,
     CacheGraphics->False],
    FrameMargins->5]}], "]"}]], "Output",
 ImageSize->{288, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->129562881]
}, Open  ]],

Cell["\<\
SampleStyle takes a pure function specifying the thickness and color of the \
highlight. It needs to be enclosed in parentheses.\
\>", "ExampleText",
 CellID->1003696114],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SRSChart", "[", 
  RowBox[{"19", ",", 
   RowBox[{"{", 
    RowBox[{"3", ",", "3"}], "}"}], ",", 
   RowBox[{"SampleColorFunction", "\[Rule]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "6", "]"}], ",", 
        RowBox[{
         RowBox[{"ColorList", "[", "\"\<MyColors\>\"", "]"}], "[", "#", 
         "]"}]}], "]"}], "&"}], ")"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1725398384],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0.75], DiskBox[{0, 0}, 4.438380194395248]}, 
   {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxdUksoRGEYvc1clFlIYaNMSvJqVkpe/X82g2zGShkbpaywI6mxUXbKymtl
KDNTwtSYV/3XrKzsRGLBiiaPBQtGmOaeo+5/61+czved77vfOY2Ts6NTbsMw
KouvovhcxbfZdpIudL6ohpV8INlwJ6IjY4+LiYLylvCzcOdin72tptUE3gSu
t7GKOevVDvSawW8Be9Gfmfmp/ep6EsG13EdL0LQMfMnSAoaVtHlFPgscnuuv
vAp7UH+UHbxfrDn0V7Fe7INPa/roF3s2LzkP/TIFffLYT03Y/ZLzsJ/kvHHw
uv7JRHuoZ/5L2Pq/wr5PHtgtV18v1svf42II/AJwqqT/Jg5QX6LvH8Qx9BLg
dX34Ifm/8E/wnvDj/x4bwLxnBPW8J/yWvKeuT6zlRTAv29BnXpAvwbxEnPWK
85gX6nudeZO8b9S5r+Q88pxH/yLOe0jOo3+6vu/yLH5T55F2/Zta7h7w3Z6b
En6o3d6VQObjW5yCJ/bbfqgQ6uG3Rb1h8Lo+Mf1cdvZL6jMvxMxLyLmfoB7z
out3vOcTfa5qzT+PpH/fR9eTS9Nlkv4VgOmfVq+oR/+I6d8fCGMjeg==
     "]], {
     {EdgeForm[{RGBColor[1, 0, 0], AbsoluteThickness[6]}], 
      PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGAAYXYgZgLi3Xn/RH+Zv7SXa30duEPurn150RKuFv4JNvJg
/lv7nRD5/SpQeaj6/dIQ/v5Nq7/xu4mv2ANVv38H1Dw1qPwuKF8eqn+m1qZd
v03e7Y/pP/RVI4blwCqfiBdV237v3wF2AMMB5kOrf1prshyAybNA+YsLbLmu
L+Y+sBqq3uNhlcg6d/4Dc6DmLYXKz0Iz//eGG0k1GawHYP6D2Md9AOY/nS+v
t9kwCR6A+Q/Gh/kPTf3+P1DzYP6D8WH+AwDmm7I+
       "]]}, 
     {EdgeForm[{RGBColor[1, 1, 0], AbsoluteThickness[6]}], 
      PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGAAYXYgZgLihvfnJrF92bzf42GVyDr3//YrfSJeVG17DeUz
O2yK1a63Kv+13xMqD+PvlGt9Hbjjg/0aqHqw9MNH9hOg5m2DyqObXwHl74DI
71+Jqn8/zPztUHkY3x2if/8aVPcdgNnnBZVvQDMfqt8exl8N0W8Psw+q3h5m
H4wPs28FVD3Mvo1Q82D2oZsPAMVOv9M=
       "]]}, 
     {EdgeForm[{RGBColor[0, 1, 0], AbsoluteThickness[6]}], 
      PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGAAYXYgZgLiGVqbdv02ebd/SYEt1/XF3A6rfCJeVG37vd/j
YZXIOnd+B+ZDq39aa7IcgMmzQPmx/Ye+asSwOKyGqt8h1/o6cAeDwxyoedFQ
eXTzF1m3Bu7++geq/sP+eksnvTsnWA6ArXv4aL/e1YObb4lxH9gOlYfx3cEK
/u9vgKqHuI/5wGKoeV5QeXTzYXyI+v/29aj6HWDme0LlYfydEP32Dajus4fZ
tw0qj24+APi0su8=
       "]]}}}}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->14922909]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[StyleBox[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"],
 FontWeight->"Bold"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->998493758]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"SRSChart - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 31, 7.6384624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "SRSChart[n] visualize a population of size nSRSChart[n, samp] visualize \
a population of size n with a simple random sample of size samp.SRSChart[n, \
{samp, k}] visualize a population of size n with k simple random samples of \
size samp.SRSChart[pop, {samp, k}] visualize a population pop with k simple \
random samples of size samp.", "synonyms" -> {}, "title" -> "SRSChart", 
    "titlemodifier" -> "", "windowtitle" -> "SRSChart", "type" -> "Symbol", 
    "uri" -> "Classroom Utilities/ref/SRSChart"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7729, 232, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->406254290]},
 "RasterizedOutput"->{
  Cell[127896, 2439, 23337, 391, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->585466644]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 169635, 3369},
 {"RasterizedOutput", 169778, 3373}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[601, 21, 2758, 63, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3384, 88, 51, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3438, 91, 2122, 68, 268, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5597, 164, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->611153499],
Cell[6209, 184, 170, 6, 70, "Notes",
 CellID->1067943069],
Cell[6382, 192, 254, 9, 70, "Notes",
 CellID->1765992653],
Cell[6639, 203, 138, 4, 70, "Notes",
 CellID->615279183],
Cell[6780, 209, 912, 18, 70, "3ColumnTableMod",
 CellID->863468376]
}, Closed]],
Cell[CellGroupData[{
Cell[7729, 232, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->406254290],
Cell[CellGroupData[{
Cell[8244, 250, 195, 6, 31, "ExampleSection",
 CellID->112733795],
Cell[8442, 258, 66, 1, 32, "ExampleText",
 CellID->667033784],
Cell[8511, 261, 127, 3, 28, "Input",
 CellID->972170348],
Cell[8641, 266, 84, 1, 32, "ExampleText",
 CellID->1211452460],
Cell[CellGroupData[{
Cell[8750, 271, 387, 12, 28, "Input",
 CellID->589038013],
Cell[9140, 285, 2282, 44, 115, "Output",
 CellID->469833943]
}, Open  ]],
Cell[11437, 332, 121, 3, 70, "ExampleText",
 CellID->795377340],
Cell[CellGroupData[{
Cell[11583, 339, 462, 14, 70, "Input",
 CellID->1968734452],
Cell[12048, 355, 3117, 64, 115, "Output",
 CellID->2016625341]
}, Open  ]],
Cell[15180, 422, 95, 1, 70, "ExampleText",
 CellID->408453255],
Cell[15278, 425, 239, 8, 70, "Input",
 CellID->1516120973],
Cell[CellGroupData[{
Cell[15542, 437, 154, 5, 70, "Input",
 CellID->1551721556],
Cell[15699, 444, 6956, 135, 191, "Output",
 CellID->1835189233]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[22704, 585, 268, 8, 70, "ExampleSection",
 CellID->1293636265],
Cell[22975, 595, 66, 1, 70, "ExampleText",
 CellID->623440857],
Cell[23044, 598, 127, 3, 70, "Input",
 CellID->597769886],
Cell[23174, 603, 87, 1, 70, "ExampleText",
 CellID->789973336],
Cell[23264, 606, 387, 12, 70, "Input",
 CellID->1337952398],
Cell[CellGroupData[{
Cell[23676, 622, 178, 6, 70, "Input",
 CellID->664685449],
Cell[23857, 630, 10446, 202, 191, "Output",
 CellID->1865300817]
}, Open  ]],
Cell[34318, 835, 81, 1, 70, "ExampleText",
 CellID->1658732110],
Cell[34402, 838, 464, 14, 70, "Input",
 CellID->1825351063],
Cell[CellGroupData[{
Cell[34891, 856, 182, 6, 70, "Input",
 CellID->1871418446],
Cell[35076, 864, 4115, 96, 191, "Output",
 CellID->1144552413]
}, Open  ]],
Cell[39206, 963, 87, 1, 70, "ExampleText",
 CellID->1828707719],
Cell[39296, 966, 88168, 1452, 70, "Input",
 CellID->304677369],
Cell[127467, 2420, 219, 7, 70, "Input",
 CellID->1111526335],
Cell[CellGroupData[{
Cell[127711, 2431, 182, 6, 70, "Input",
 CellID->462867092],
Cell[127896, 2439, 23337, 391, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->585466644]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[151282, 2836, 270, 8, 70, "ExampleSection",
 CellID->2061341341],
Cell[CellGroupData[{
Cell[151577, 2848, 370, 12, 70, "ExampleSubsection",
 CellID->7781165],
Cell[151950, 2862, 61, 1, 70, "ExampleText",
 CellID->1929021335],
Cell[152014, 2865, 127, 3, 70, "Input",
 CellID->500958586],
Cell[152144, 2870, 76, 1, 70, "ExampleText",
 CellID->759711266],
Cell[CellGroupData[{
Cell[152245, 2875, 385, 12, 70, "Input",
 CellID->1676966247],
Cell[152633, 2889, 1592, 33, 115, "Output",
 CellID->1760815713]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[154274, 2928, 375, 12, 70, "ExampleSubsection",
 CellID->1257265053],
Cell[154652, 2942, 61, 1, 70, "ExampleText",
 CellID->1762142938],
Cell[154716, 2945, 127, 3, 70, "Input",
 CellID->389383189],
Cell[154846, 2950, 81, 1, 70, "ExampleText",
 CellID->980585114],
Cell[CellGroupData[{
Cell[154952, 2955, 385, 12, 70, "Input",
 CellID->904503920],
Cell[155340, 2969, 1555, 32, 115, "Output",
 CellID->1705032731]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[156944, 3007, 369, 12, 70, "ExampleSubsection",
 CellID->85866151],
Cell[157316, 3021, 61, 1, 70, "ExampleText",
 CellID->1285937184],
Cell[157380, 3024, 127, 3, 70, "Input",
 CellID->470828080],
Cell[157510, 3029, 91, 1, 70, "ExampleText",
 CellID->1877785012],
Cell[CellGroupData[{
Cell[157626, 3034, 305, 8, 70, "Input",
 CellID->513020372],
Cell[157934, 3044, 1648, 34, 201, "Output",
 CellID->463324349]
}, Open  ]],
Cell[159597, 3081, 62, 1, 70, "ExampleText",
 CellID->638268709],
Cell[CellGroupData[{
Cell[159684, 3086, 207, 6, 70, "Input",
 CellID->701375398],
Cell[159894, 3094, 1609, 33, 201, "Output",
 CellID->316629621]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[161552, 3133, 381, 12, 70, "ExampleSubsection",
 CellID->357613465],
Cell[161936, 3147, 60, 1, 70, "ExampleText",
 CellID->804513244],
Cell[161999, 3150, 127, 3, 70, "Input",
 CellID->897050396],
Cell[162129, 3155, 106, 2, 70, "ExampleText",
 CellID->1390803632],
Cell[CellGroupData[{
Cell[162260, 3161, 218, 6, 70, "Input",
 CellID->2024629076],
Cell[162481, 3169, 842, 25, 49, "Output",
 CellID->129562881]
}, Open  ]],
Cell[163338, 3197, 180, 4, 70, "ExampleText",
 CellID->1003696114],
Cell[CellGroupData[{
Cell[163543, 3205, 507, 15, 70, "Input",
 CellID->1725398384],
Cell[164053, 3222, 2003, 42, 201, "Output",
 CellID->14922909]
}, Open  ]]
}, Closed]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[166129, 3272, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[166580, 3287, 231, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[166848, 3297, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[167299, 3312, 171, 4, 70, "MoreAbout",
 CellID->998493758]
}, Open  ]],
Cell[167485, 3319, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

