(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     15297,        472]
NotebookOptionsPosition[     11512,        354]
NotebookOutlinePosition[     13671,        412]
CellTagsIndexPosition[     13586,        407]
WindowTitle->SampleColorFunction - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Visualizing Statistical Concepts\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"SRSChart\"\>":>Documentation`HelpLookup[
       "paclet:Classroom Utilities/ref/SRSChart"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Classroom Utilities/ref/SampleColorFunction\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/SampleColorFunction"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/SampleColorFunction.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/SampleColorFunction", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["SampleColorFunction", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["SampleColorFunction"], "InlineFormula"],
     "\[LineSeparator]an option for SRSChart to set the style of the \
highlights on the samples."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->554940791],

Cell["\<\
The value of SampleColorFunction will normally be a pure function involving \
Directive.\
\>", "Notes",
 CellID->1067943069],

Cell["The value of the option should be wrapped in parentheses.", "Notes",
 CellID->413571292],

Cell["The generated values will be used in the function EdgeForm.", "Notes",
 CellID->1443463977]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->18105147],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->540067482],

Cell["This loads the package.", "ExampleText",
 CellID->2124272664],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->735032473],

Cell["Create a ColorList.", "ExampleText",
 CellID->1364836167],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"MakeColorList", "[", 
  RowBox[{"\"\<NiceColors\>\"", ",", 
   RowBox[{"{", 
    RowBox[{"Orange", ",", "Green", ",", "Yellow"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1528625162],

Cell[BoxData[
 RowBox[{"ColorListFunction", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "1"}], "}"}], ",", 
   PanelBox[
    StyleBox[
     GraphicsBox[{
       {RGBColor[1, 0.5, 0], EdgeForm[Opacity[0.1]], 
        RectangleBox[{1, 0}, Offset[{-1, -1}, {2, 1}]]}, 
       {RGBColor[0, 1, 0], EdgeForm[Opacity[0.1]], 
        RectangleBox[{2, 0}, Offset[{-1, -1}, {3, 1}]]}, 
       {RGBColor[1, 1, 0], EdgeForm[Opacity[0.1]], 
        RectangleBox[{3, 0}, Offset[{-1, -1}, {4, 1}]]}},
      AspectRatio->NCache[
        Rational[1, 10], 0.1],
      ImageSize->65,
      PlotRangePadding->None],
     StripOnInput->False,
     CacheGraphics->False],
    FrameMargins->5]}], "]"}]], "Output",
 ImageSize->{288, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1256228673]
}, Open  ]],

Cell["Use the ColorList to set the colors for the samples.", "ExampleText",
 CellID->1523573454],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SRSChart", "[", 
  RowBox[{"19", ",", 
   RowBox[{"{", 
    RowBox[{"4", ",", "3"}], "}"}], ",", 
   RowBox[{"SampleColorFunction", "\[Rule]", " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "4", "]"}], ",", 
        RowBox[{
         RowBox[{"ColorList", "[", "\"\<NiceColors\>\"", "]"}], "[", "#", 
         "]"}]}], "]"}], "&"}], ")"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->104034550],

Cell[BoxData[
 GraphicsBox[{
   {GrayLevel[0.75], DiskBox[{0, 0}, 4.438380194395248]}, 
   {RGBColor[0.15, 0.15, 0.7], PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGBgh2ImIF5k3Rq4++uf/R4Pq0TWuf+3r7d00rtzguUAhM/s
oHf14OZbYtwHPKHyMP5OudbXgTs+2DdA1YOlHz6yXww1bxtUHt38GVqbdv02
ebd/SYEt1/XF3A6rfCJeVG37DZXnd2A+tPqntSbLAZg8C5Qf23/oq0YMi8Nq
qPodYPMZHOZAzYuGyqOb3/D+3CS2L5vh9q8E63+9H+a/TbHa9Vblv/bD/Afj
w/y3Bqoe5r8JUPNg/kM3f3feP9Ff5i/tYyDuOcAABVD3HtgBkd8Pk98D5S+G
uBeqfsMeaHjA1NsvhcrvQjMfqt8e5l+YfbDw3Ak1HyYPdd9+WHjC7IOFJ8w+
WHiimw+NDwe0+LOH2TcbEv5w9TOhfJh9K6HqYfZB49sBZh+6+TpfXm+zYRJ0
ACuXu2sPsY/bQR7Mf2v/Z8ONpJoMVgcVqPxvKF8awt+Ppn4/zDw1qDyMLw/V
DwAi5n47
     "]], {
     {EdgeForm[{RGBColor[1, 0.5, 0], AbsoluteThickness[4]}], 
      PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGBgAWJ2IGYC4or35yaxfdm8f4dc6+vAHR/2r/SJeFG17fX+
h1Ui69wfPtq/KVa73qr81/7tUHkY3x2s4P/+NVD1HmA+84EJUPO8oPINaObr
XT24+ZYYtwNE/X/7BksnvTsnWKB8ZodF1q2Bu7/+sfeEysP4OyH67euh6qHu
s4eZtw0qj24+1L32MPtXQ9xrD/Mf1H32MP/B+DD/rYCqh/lvI9Q8mP/QzYfZ
D+M3oLp3P8w/MPtgfJh99ajhcQBmHsw+dPMBFa3ytQ==
       "]]}, 
     {EdgeForm[{RGBColor[0, 1, 0], AbsoluteThickness[4]}], 
      PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGBgAWJ2IGYC4t15/0R/mb+0l2t9HbhD7q59edESrhb+CTby
YP5b+50Q+f0qUHmo+v3SEP7+Tau/8buJr9gDVb9/B9Q8Naj8LihfHqqf5dDq
n9aaLA4x/Ye+asSwHFjlE/Giattv+x1gBzAcmKO1addvk3f2MPkZUP7iAluu
64u5D6yEqvd4WCWyzp3/ADPUvKVQeXTzYXyY/2D2wfw3G2o+zH8zoXyY/1ai
qt8Psw/mP5j5MP8tsm4N3P31z36Ifz7sr7d00rtzguUA2LkPH+3Xu3pw8y0x
7gPbofIwvjtYwf/9DVD1EP8xH1gMNc8LKo9uPgBMSuoj
       "]]}, 
     {EdgeForm[{RGBColor[1, 1, 0], AbsoluteThickness[4]}], 
      PolygonBox[CompressedData["
1:eJxTTMoPSmVmYGBgAWJ2IGYC4t8bbiTVZLAekGt9HbhD7q79Kp+IF1XbuA/I
g/lv7XW+vN5mwyR4QAUqD+NLQ/j70dTv/wM1Tw0qD+PLQ/XP1Nq067fJu/2o
9v3eD7OP+dDqn9aaLHD7WKB8mH2rUdXvnwM1D2bfLCgfZt+mWO16q/Jf9h4P
q0TWuf+3h+h/DeUzO3S8PzeJ7ctme0+ofAWUvxPswA/2K6DqwdIPH9lvhJq3
DSqPbj7MfzH9h75qxLAcgPlvB1g9wwGY/2DyMP8tLrDlur6Y+wDMfxDz+A/A
/LcUKj8LzXwAmY3tWA==
       "]]}}}}]], "Output",
 ImageSize->{184, 180},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->176301280]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["SRSChart",
   BaseStyle->"Link",
   ButtonData->"paclet:Classroom Utilities/ref/SRSChart"],
  FontFamily->"Verdana"]], "InlineFormula",
 FontWeight->"Bold"]], "SeeAlso",
 CellID->929782353],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["MakeColorList",
   BaseStyle->"Link",
   ButtonData->"paclet:Classroom Utilities/ref/MakeColorList"],
  FontFamily->"Verdana"]], "InlineFormula",
 FontWeight->"Bold"]], "SeeAlso",
 CellID->1635622952]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[StyleBox[ButtonBox["Visualizing Statistical Concepts",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/VisualizingStatisticalConcepts"],
 FontWeight->"Bold"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"SampleColorFunction - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 30, 36.8440624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "SampleColorFunction an option for SRSChart to set the style of the \
highlights on the samples.", "synonyms" -> {}, "title" -> 
    "SampleColorFunction", "titlemodifier" -> "", "windowtitle" -> 
    "SampleColorFunction", "type" -> "Symbol", "uri" -> 
    "Classroom Utilities/ref/SampleColorFunction"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4927, 145, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->18105147]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13444, 400}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[612, 21, 2821, 66, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3458, 91, 62, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3523, 94, 387, 11, 83, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3947, 110, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->554940791],
Cell[4559, 130, 134, 4, 70, "Notes",
 CellID->1067943069],
Cell[4696, 136, 94, 1, 70, "Notes",
 CellID->413571292],
Cell[4793, 139, 97, 1, 70, "Notes",
 CellID->1443463977]
}, Closed]],
Cell[CellGroupData[{
Cell[4927, 145, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->18105147],
Cell[CellGroupData[{
Cell[5441, 163, 195, 6, 31, "ExampleSection",
 CellID->540067482],
Cell[5639, 171, 67, 1, 32, "ExampleText",
 CellID->2124272664],
Cell[5709, 174, 127, 3, 28, "Input",
 CellID->735032473],
Cell[5839, 179, 63, 1, 32, "ExampleText",
 CellID->1364836167],
Cell[CellGroupData[{
Cell[5927, 184, 223, 6, 28, "Input",
 CellID->1528625162],
Cell[6153, 192, 845, 25, 49, "Output",
 CellID->1256228673]
}, Open  ]],
Cell[7013, 220, 96, 1, 32, "ExampleText",
 CellID->1523573454],
Cell[CellGroupData[{
Cell[7134, 225, 508, 15, 47, "Input",
 CellID->104034550],
Cell[7645, 242, 2100, 44, 201, "Output",
 CellID->176301280]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9806, 293, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[10255, 308, 241, 7, 70, "SeeAlso",
 CellID->929782353],
Cell[10499, 317, 252, 7, 70, "SeeAlso",
 CellID->1635622952]
}, Open  ]],
Cell[CellGroupData[{
Cell[10788, 329, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[11239, 344, 231, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[11485, 352, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

