(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     16022,        475]
NotebookOptionsPosition[     12299,        363]
NotebookOutlinePosition[     14708,        426]
CellTagsIndexPosition[     14588,        420]
WindowTitle->SecantLine - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Problems in Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/ProblemsInAnalyticGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/AnalyticGeometry"], "\<\"Classroom \
Utilities\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/SecantLine\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/SecantLine"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/SecantLine.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/SecantLine", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["SecantLine", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"SecantLine", "[", 
       RowBox[{
        StyleBox["fn", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["var", "TI"], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["var", "TI"], 
           StyleBox["2", "TR"]]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]creates an expression for the secant line determined by \
the points ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["var", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["var", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula"],
     " using the function ",
     Cell[BoxData[
      StyleBox["fn", "TI"]], "InlineFormula"],
     ". If ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["var", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     " equals ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["var", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula"],
     " the expression for the tangent line to",
     Cell[BoxData[
      RowBox[{" ", 
       StyleBox["fn", "TI"]}]], "InlineFormula"],
     " at ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["var", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     " is given."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->456425725],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->370600210],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1729333037],

Cell[TextData[{
 "If f(x) = ",
 Cell[BoxData[
  SuperscriptBox["x", "2"]], "InlineFormula"],
 " this constructs a line passing through the points f(1) and f(3)"
}], "ExampleText",
 CellID->856674361],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{"secln", "[", "x_", "]"}], "=", 
  RowBox[{"SecantLine", "[", 
   RowBox[{
    SuperscriptBox["x", "2"], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "1", ",", "3"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1395615839],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "3"}], "+", 
  RowBox[{"4", " ", "x"}]}]], "Output",
 ImageSize->{49, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1135187899]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SuperscriptBox["x", "2"], ",", 
     RowBox[{"secln", "[", "x", "]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "5"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->70215705],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS2Xq0gQhnPO/pL9GWNHRkYiLzJi9xwkFtkSiUW225ZtkciWWCQSyVbT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    "], {{0, 112}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 112},
  PlotRange->{{0, 180}, {0, 112}}]], "Output",
 ImageSize->{184, 112},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->252564005]
}, Open  ]],

Cell[BoxData["\[IndentingNewLine]"], "Input",
 CellLabel->"In[4]:=",
 CellID->775988916]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Problems in Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/ProblemsInAnalyticGeometry"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/AnalyticGeometry"]], "MoreAbout",
 CellID->422527122],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->539213001],

Cell[BoxData[
 RowBox[{"Se", " "}]], "Input",
 CellID->1350972563]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"SecantLine - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 30, 40.4164624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "SecantLine[fn, {var, var_1, var_2}] creates an expression for the secant \
line determined by the points var_1 and var_2 using the function fn. If var_1 \
equals var_2 the expression for the tangent line to fn at var_1 is given.", 
    "synonyms" -> {}, "title" -> "SecantLine", "titlemodifier" -> "", 
    "windowtitle" -> "SecantLine", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/SecantLine"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5203, 152, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->456425725]},
 "RasterizedOutput"->{
  Cell[7102, 229, 3463, 65, 133, "Output",
   CellTags->"RasterizedOutput",
   CellID->252564005]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 14322, 409},
 {"RasterizedOutput", 14465, 413}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[603, 21, 2871, 65, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3499, 90, 53, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3555, 93, 1611, 54, 101, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[5203, 152, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->456425725],
Cell[CellGroupData[{
Cell[5718, 170, 195, 6, 31, "ExampleSection",
 CellID->370600210],
Cell[5916, 178, 128, 3, 28, "Input",
 CellID->1729333037],
Cell[6047, 183, 199, 6, 34, "ExampleText",
 CellID->856674361],
Cell[CellGroupData[{
Cell[6271, 193, 274, 9, 30, "Input",
 CellID->1395615839],
Cell[6548, 204, 222, 8, 36, "Output",
 CellID->1135187899]
}, Open  ]],
Cell[CellGroupData[{
Cell[6807, 217, 292, 10, 30, "Input",
 CellID->70215705],
Cell[7102, 229, 3463, 65, 133, "Output",
 CellTags->"RasterizedOutput",
 CellID->252564005]
}, Open  ]],
Cell[10580, 297, 88, 2, 47, "Input",
 CellID->775988916]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10717, 305, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[11168, 320, 194, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[11399, 330, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[11850, 345, 164, 3, 70, "MoreAbout",
 CellID->422527122],
Cell[12017, 350, 171, 4, 70, "MoreAbout",
 CellID->539213001],
Cell[12191, 356, 66, 2, 70, "Input",
 CellID->1350972563]
}, Open  ]],
Cell[12272, 361, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

