(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     24742,        686]
NotebookOptionsPosition[     20504,        555]
NotebookOutlinePosition[     22944,        620]
CellTagsIndexPosition[     22824,        614]
WindowTitle->SecantLinePlot - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Calculus and Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/CalculusandAnalyticGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"TangentLinePlot\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/TangentLinePlot"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/AnalyticGeometry"], "\<\"Classroom \
Utilities\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/SecantLinePlot\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/SecantLinePlot"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/SecantLinePlot.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/SecantLinePlot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["SecantLinePlot", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"SecantLinePlot", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["2", "TR"]]}], "}"}]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]creates a plot of ",
     Cell[BoxData[
      RowBox[{
       StyleBox["f", "TI"], " "}]], "InlineFormula"],
     "with the points ",
     Cell[BoxData[
      RowBox[{"{", 
       RowBox[{
        SubscriptBox[
         StyleBox["x", "TI"], 
         StyleBox["1", "TR"]], ",", 
        RowBox[{
         StyleBox["f", "TI"], 
         RowBox[{"(", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["1", "TR"]], ")"}]}]}], "}"}]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      RowBox[{"{", 
       RowBox[{
        SubscriptBox[
         StyleBox["x", "TI"], 
         StyleBox["2", "TR"]], ",", 
        RowBox[{
         StyleBox["f", "TI"], 
         RowBox[{"(", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["2", "TR"]], ")"}]}]}], "}"}]], "InlineFormula"],
     " joined by a secant line."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->654547794],

Cell[TextData[{
 "The values ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["x", "TI"], 
   StyleBox["1", "TR"]]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["x", "TI"], 
   StyleBox["2", "TR"]]], "InlineFormula"],
 " should be numeric for the plot to render."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "SecantLinePlot can be used with ",
 ButtonBox["Manipulate",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Manipulate"],
 " to illustrate what happens when ",
 Cell[BoxData[
  RowBox[{
   SubscriptBox[
    StyleBox["x", "TI"], 
    StyleBox["1", "TR"]], "\[Rule]", 
   SubscriptBox[
    StyleBox["x", "TI"], 
    StyleBox["2", "TR"]]}]], "InlineFormula"],
 "."
}], "Notes",
 CellID->113891369],

Cell[TextData[{
 "SecantLinePlot will accept any options used with ",
 ButtonBox["Plot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Plot"],
 "."
}], "Notes",
 CellID->1646813235]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->44176202],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->73928833],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1220798109],

Cell["Plot a secant line between two points on a polynomial.", "ExampleText",
 CellID->895054525],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SecantLinePlot", "[", 
  RowBox[{
   SuperscriptBox["x", "4"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{".2", ",", ".7"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->58454440],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztna2Xo0wWh/uc/UtWrlz52pGRkZEvssWKyFgkEolF4rbWYZFIJBaJRLK3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    "], {{0, 182}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 182},
  PlotRange->{{0, 180}, {0, 182}}]], "Output",
 ImageSize->{184, 182},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->33012752]
}, Open  ]],

Cell["If the location is repeated the tangent line is drawn.", "ExampleText",
 CellID->1599332911],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SecantLinePlot", "[", 
  RowBox[{
   SuperscriptBox["x", "4"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{".6", ",", ".6"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->2082909325],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnSGTq0gUhadq/8DKtfsTnhy7MhIZuciIFchYZCQSi6RqDRKLRFKr2iKR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    "], {{0, 216}, {176, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{176, 216},
  PlotRange->{{0, 176}, {0, 216}}]], "Output",
 ImageSize->{180, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->19414186]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[Cell[BoxData[
 StyleBox[
  ButtonBox["TangentLinePlot",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/TangentLinePlot"],
  FontFamily->"Verdana"]], "InlineFormula"]], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Calculus and Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/CalculusandAnalyticGeometry"]], \
"Tutorials",
 CellID->764309306]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/AnalyticGeometry"]], "MoreAbout",
 CellID->195852431],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->210081423]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"SecantLinePlot - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 30, 43.7548624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "SecantLinePlot[f, {x, x_min, x_max}, {x_1, x_2}] creates a plot of f \
with the points {x_1, f (x_1)} and {x_2, f (x_2)} joined by a secant line.", 
    "synonyms" -> {}, "title" -> "SecantLinePlot", "titlemodifier" -> "", 
    "windowtitle" -> "SecantLinePlot", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/SecantLinePlot"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[7442, 237, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->44176202]},
 "RasterizedOutput"->{
  Cell[8686, 284, 4442, 81, 203, "Output",
   CellTags->"RasterizedOutput",
   CellID->33012752],
  Cell[13548, 384, 4661, 84, 237, "Output",
   CellTags->"RasterizedOutput",
   CellID->19414186]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 22461, 600},
 {"RasterizedOutput", 22603, 604}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[607, 21, 3373, 79, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4005, 104, 57, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[4065, 107, 1771, 60, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5873, 172, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->654547794],
Cell[6485, 192, 321, 13, 70, "Notes",
 CellID->1067943069],
Cell[6809, 207, 411, 16, 70, "Notes",
 CellID->113891369],
Cell[7223, 225, 182, 7, 70, "Notes",
 CellID->1646813235]
}, Closed]],
Cell[CellGroupData[{
Cell[7442, 237, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->44176202],
Cell[CellGroupData[{
Cell[7956, 255, 194, 6, 31, "ExampleSection",
 CellID->73928833],
Cell[8153, 263, 128, 3, 28, "Input",
 CellID->1220798109],
Cell[8284, 268, 97, 1, 32, "ExampleText",
 CellID->895054525],
Cell[CellGroupData[{
Cell[8406, 273, 277, 9, 30, "Input",
 CellID->58454440],
Cell[8686, 284, 4442, 81, 203, "Output",
 CellTags->"RasterizedOutput",
 CellID->33012752]
}, Open  ]],
Cell[13143, 368, 98, 1, 70, "ExampleText",
 CellID->1599332911],
Cell[CellGroupData[{
Cell[13266, 373, 279, 9, 30, "Input",
 CellID->2082909325],
Cell[13548, 384, 4661, 84, 237, "Output",
 CellTags->"RasterizedOutput",
 CellID->19414186]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18270, 475, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[18719, 490, 233, 6, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[18989, 501, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[19440, 516, 196, 5, 70, "Tutorials",
 CellID->764309306]
}, Open  ]],
Cell[CellGroupData[{
Cell[19673, 526, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[20124, 541, 164, 3, 70, "MoreAbout",
 CellID->195852431],
Cell[20291, 546, 171, 4, 70, "MoreAbout",
 CellID->210081423]
}, Open  ]],
Cell[20477, 553, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

