(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     23424,        656]
NotebookOptionsPosition[     19742,        542]
NotebookOutlinePosition[     21867,        599]
CellTagsIndexPosition[     21782,        594]
WindowTitle->SetsStyle - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Building an Understanding of Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
BuildingAnUnderstandingOfFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Understanding Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingFunctions"], \
"\<\"Classroom Utilities\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/SetsStyle\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/SetsStyle"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/SetsStyle.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/SetsStyle", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["SetsStyle", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["SetsStyle"], "InlineFormula"],
     "\[LineSeparator]is an option for ",
     Cell[BoxData[
      ButtonBox["FunctionArrowDiagram",
       BaseStyle->"Link",
       ButtonData->"paclet:UnderstandingFunctions/ref/FunctionArrowDiagram"]],
       "InlineFormula"],
     " that determines how the domain and range sets are rendered."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->770157586],

Cell["\<\
Any graphics directives that can be used with Circle can be included.\
\>", "Notes",
 CellID->1067943069],

Cell[TextData[{
 ButtonBox["EdgeForm",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/EdgeForm"],
 " can be used to specify the boundary of the set."
}], "Notes",
 CellID->238000882],

Cell[TextData[{
 ButtonBox["ColorSetter",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/ColorSetter"],
 " can be used to assign colors to the set."
}], "Notes",
 CellID->1466273060]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->24405597],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->699806540],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1276470095],

Cell["Coloring the domain set red and the range set yellow.", "ExampleText",
 CellID->271253135],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionArrowDiagram", "[", 
  RowBox[{"4", ",", "6", ",", "\"\<Relation\>\"", ",", 
   RowBox[{"SetsStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Red", ",", "Yellow"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1991141011],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[1, 0, 0], DiskBox[{0, 0}, {1.1, 1.6500000000000001`}]}, 
   {RGBColor[1, 1, 0], DiskBox[{3, 0}, {1.1, 1.6500000000000001`}]}, 
   {GrayLevel[0], PointSize[Medium], Opacity[1], 
    PointBox[{{0.1, 0.5196152422706632}, {-0.6000000000000001, 
     0.34641016151377546`}, {-0.1, 1.2124355652982142`}, {
     0.6000000000000001, -0.34641016151377546`}, {3.2, 1.3856406460551018`}, {
     2.7, 0.5196152422706632}, {2.7, -0.17320508075688773`}, {
     2.2, -0.6928203230275509}, {3.1, -0.5196152422706632}, {
     3.4, -1.0392304845413265`}}], 
    {RGBColor[0.5, 0, 0.5], Arrowheads[Medium], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAANDMzMzMz4z8iCq2GlSvWvy36h12d
T+U/HhB7Uz02zL9iHPh0c5rnP7iG/Cr097i/3VKQGX4S6j8AxFi+MnqWP4S1
+u5ttuw/piuPhmajwT/25m9O3ITvP/CsQz6I+M8/mPWBAiY+8T+CJDJUiOPW
P+LX9A6VzfI/SBi4LNaD3T/D+SBc52/0P+CsAM3U7OE/vA0C9D4k9j9buv0I
0/DkP0bPxFC06fc/4+bmK0zM5z/Ohp/XVr/5P1G5RBe8feo/Ni18WC2k+z8j
EIT6tAPtP61xMJI2l/0/xfoPFeBc7z9Gev26aZf/P9h1Fzb/w/A/CHmHhtvR
AED2YSG69MHxP05sVyuE3QFAOPWI1smn8j/Kx/DGIO4CQDZBY5gEdfM/8OmN
syADBEBc8KsaOCn0P25VYffwGwVAAssMwATE9D++6JGS/DcGQIJemWUYRfU/
b/VJzqxWB0AS22OOLqz1P45Er4xpdwhAlgjUhxD59T+amZmZmZkJQCIKrYaV
K/Y/Wk/FOw==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAANDMzMzMz4z8iCq2GlSvWvy2HDggg
R+U/gJhuutQE0b8okz2ggnjnPxCoVf+6H8i/q/nqHDHG6T8YbRaZRD29v/oK
p5vyLuw/WLm4cKktpr927Wvcf7HuP+ADSvngqJg/d4yg90Gm8D9kABmcuny2
P30BkXRO//E/6MP9oQTswj8JAORPLmPzP8wBoyH/Gco/mdr5tSTR9D8CUBbJ
PmLQP9qB53hvSPY/uhhlPvtz0z88jn53R8j3P9xZjQeUQNY/LrL1BuFP+T+u
sMzqjMbYPweF+V5s3vo/nCyOJ48E2z/PT+wHFnP8P1aBRyxq+dw/SFwaSwcN
/j/ylxM4FKTePyg9p6Rmq/8/H2Dac9UB4D9EznsbrKYAQCLY2da5i+A/rCmt
H/94AUDdyq0abu/gP9xx2cU8TAJA9lkvWL0s4T+Ec3P49B8DQM4tfQeHQ+E/
rsznYLfzA0B6OT4RvzPhP/QyOKMTxwRAWR4M1W394D+amZmZmZkFQJrHASWw
oOA/sLm+Vg==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAANDMzMzMz478iCq2GlSvWP9FIWakg
Pd2/8Bp0b4B12T8A+N5R9+/Tvyjha3zNU9w/GmVNorMHxb+HLAEP98TeP8CJ
pp0AuY+/fhmluNhj4D8gozffYDrBP3j3A8N1LeE/Ots00vZH0j8ZE8is577h
P/Aa2gVq/ds/2pqpSeEX4j9OCsChMdziP+Sy4GMzOOI/0M3oaty55z9fKTLV
zB/iP2r1PWsglew/S+oIkLrO4T/LLuX6tLXwPxBfl5gnReE/2IvpABQd8z+f
XgTuXIPgP9dIu8Nmf/U/dZVfx4IT3z+G+hVtadv3P7/ORtWysdw/inE1gNsv
+j9cvpmWjeLZP1yb4oOAe/w/IX1Mn5Cn1j96K1+qIL3+P+bi9LtyAtM/03lr
u8R5AEB+6u0RRurNPzeR/y/HjgFAeKWg148DxT9nj8a3BJ0CQDT7N7z3qrY/
9zEY7+2jA0CA1+BhoKV8P0pN3lX3ogRA5JPZmaWPtL+ZmZmZmZkFQCAKrYaV
K8a/kTTK4A==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAmpmZmZmZuT+axwElsKDgPzwJBZ1O
7co/IfEHFxqM4D/qiHPBKIPUPz2xY9liTuA/4LckRy2I2z8cO0pWVs/fPwL6
T7D9QOE/RiSGGVOw3j81J/3Ab7bkP44OYEZUQN0/rTuMBJci6D+hQeYeHYDb
P/QkIJiig+s/Cs61dZtw2T9zdLd9x9fuP65Kyi/nEtc/Rmrbx6AO8T/w0vqv
QWjUP8PVaDgqqfI/6xFzLBVy0T9O0Og7pjr0PyStBd3nY8w/P/Rfyz/C9T+s
U1T6LlPFP/HYeh4nP/c/HKVMy35ruz98380ZkrD4Pziir/WNPqY/eBYSurwV
+j+AvyPZjtaYvyVOJnzpbfs/4Ne8Dg+KuL/nLZ3BYbj8P9C2sqEg6sW/OfCi
MXb0/T+64hyIfwLQvztbBxZ/If8/pJHrHSNI1b8UTB1abh8AQOyEQvQuw9q/
ANkG0fulAEDaZlFLXTjgv73hBIsgJAFAGqSJYuEm47+amZmZmZkBQCIKrYaV
K+a/esbAew==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAmpmZmZmZuT+axwElsKDgP2NakEb4
Cs8/EsvJ+u5l4T/w/A3iGrTYP2lKZ5bV9eE/N3EJs7H24D++GVKdF1DiP4n/
I2U4luU/u8GAK4V04j99uf6MLTbqP72p0ewKY+I/EIml9RzU7j8dkUwnshvi
P+jSbb7JtvE/seY2tqCe4T+Iou4vEAD0P8aa/fUY7OA/b3tvQ6tE9j8ZFP+g
eQTgP91lTedmg/g/CO2POnvQ3T9BM54nErv6P+/Nunb3L9s/B0L/z3/q/D8p
zG7MzCjYP0MhZwuHEP8/w24riZa81D+6o9IAApYAQDEgw5cl7dA/cCUeOeyd
AUBmzVcT/3jJP6Q4IiZ2nwJAdrjACLtZwD8HAIMhF5oDQPjcFJtYBao/rDl+
L0qNBEBg//QD2Sugv3vVekWOeAVAQPTIzyKLvr/fFYGOZlsGQPRPhAqGKMu/
UOZ2rVo1B0DEJvrIwtbTv71C/fz2BQhAsmlBtvVm2r/OzMzMzMwIQJzHASWw
oOC/SCLERw==
      "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAmpmZmZmZub/eaNfVImbzP6byTv9E
yLY/EifbijQv8z8ypa4/U73RPyd+NQQZ1fI/lIzfn/u03T8VK4IRAFjyP7Uy
umZYyeQ/tLkpEyy48T9Zhi19E6jqP7xcKdfx9fA/14sm3cg58D/GoBNsuBHw
PxaHHf1fFPM/XLXD1PEX7j8/I/B3S+L1P4ypZmh8yus/DAsmYA6i+D9hpThX
STzpP//TeEszUvs/GQtYv7Nu5j+xOvYYTfH9Py7vqmA4Y+M/+GVe2fs+AEDq
l9jSdBvgP1AXdmVsewFATK+rU00y2T8zZ7JJUK0CQBpk8RJVvNE/07P6NwXU
A0Aw+0Ki7LHDP0T1S9Hu7gRAAFlPgQjGmD+kKLH4dv0FQDCCnuoTlLy/xa7p
Ig7/BkC8cflrnTbQvzRbk6Ir8wdAnI++9Zij2b8Syq/wTdkIQJg3NaJ7s+G/
y4Fe8fqwCUCSeS4Xxb3mv4RppzTAeQpABMfFOfzt6780MzMzMzMLQJrHASWw
oPC/Wx3Bag==
      "]], 
     {GrayLevel[0]}}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->False,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->True,
  FrameLabel->FormBox[
    StyleBox[
    "\"\[ScriptX] \[RightTeeArrow] \[ScriptF](\[ScriptX])\"", 18, Bold, 
     StripOnInput -> False], TraditionalForm],
  FrameStyle->{},
  FrameTicks->None,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 259},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->127198003]
}, Open  ]],

Cell["Adding styles for the edges.", "ExampleText",
 CellID->1005210991],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"FunctionArrowDiagram", "[", 
  RowBox[{"4", ",", "6", ",", "\"\<Relation\>\"", ",", 
   RowBox[{"SetsStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"EdgeForm", "[", "Black", "]"}], ",", "Red"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Yellow", ",", 
        RowBox[{"EdgeForm", "[", 
         RowBox[{"{", 
          RowBox[{"Thick", ",", "Green"}], "}"}], "]"}]}], "}"}]}], "}"}]}]}],
   "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->327274788],

Cell[BoxData[
 GraphicsBox[{
   {RGBColor[1, 0, 0], EdgeForm[GrayLevel[0]], 
    DiskBox[{0, 0}, {1.1, 1.6500000000000001`}]}, 
   {RGBColor[1, 1, 0], EdgeForm[{RGBColor[0, 1, 0], Thickness[Large]}], 
    DiskBox[{3, 0}, {1.1, 1.6500000000000001`}], 
    {GrayLevel[0], PointSize[Medium], Opacity[1], 
     PointBox[{{0.6000000000000001, 
      0.6928203230275509}, {-0.5000000000000001, -0.5196152422706632}, {
      0.2, -0.34641016151377546`}, {-0.1, 0.5196152422706632}, {2.3, 
      0.5196152422706632}, {3.5, 0.8660254037844386}, {
      2.3, -0.5196152422706632}, {2.7, 1.2124355652982142`}, {
      2.9, -0.5196152422706632}, {3.5, -0.5196152422706632}}], 
     {RGBColor[0.5, 0, 0.5], Arrowheads[Medium], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAAQAAAAAA4L+axwElsKDgv7wnXGEt
TNq/1xWzDZeu2r/EwWSrRk3Uvzr3PLv9X9S/uMfNkfQMzL/IYRMO2rHMv+RC
4Spz7L2/mkuyYS85wb+g5BJr5NSFv3BzqYpGcKm/UIXuwixtuT9A7ho13P2e
PwCxFSr8Pcs/CBaIE5Tpuj+MhG7IlhjVP9ggxE8EXsY/qkGl8B3E3D8Is87t
r5bOP/nJiNrATuI/CkG2EzgN0z8hsMPzS1DmP8AChx+kctY/UWUBHZBk6j+I
BNPJznnZP8cnDkBjie4/TL8axRwh3D+y7ME+SV7xP4RhIqElZ94/dnG5q/F9
8z+irxhFWiXgP6wFC3CKovU/VLt3dmTl4D8UU/h18Mr3P74aRH9Lc+E/slVa
o/71+T96YmYUxM7hP3RpJnWOIvw/Wk0NrZ334T+e1LKbeE/+P0pVbpzC7eE/
SvKzy8o9AEAs4kUdOLHhP5Q8xSrfUgFA/vQQTx5C4T9mZmZmZmYCQJrHASWw
oOA/4xHCCQ==
       "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAAQAAAAAA4L+axwElsKDgv1A/WlcX
t9e/hbIAhSce2L+Idde40gvOv+IH7jvHu86/3IJh80rEt7+Ua7EO5RS8v6Ab
/cXXFKw/gMobbTrtjD/UQozGN6DKP7hfW4Wix8A/RIhoeDxy1z/IUwllCNjO
P9fAjSPO8eA/CADXc0f81T/z0fhoWE/mP1Rj5nofEdw/EdvgP+TO6z/+Vy0c
qdPgPyBLQ2jDtvA/DDfIZ/Rd4z9wHyNiIpTzP6LKn5QYpuU/IjNP7Ql+9j9+
dtKw36rnP/xEEEPucvk/juC1iDdr6T86KDjIPXH8P6qyVDgy5uo/cEk54mF3
/z/mEKipBhvsP3aEcuffQQFAcstJ/xAJ7T+3OC+/XMoCQK6uZuvSr+0/PtNm
N1dUBECEz8Ly8w7uP+S7r0T+3gVA1kSsm0Em7j9V6w2AgGkHQNpkw4iv9e0/
QLwOlgzzCEBqUIp/V33tP95e2rXRegpASlG4Wnm97D8AAAAAAAAMQKpMWOh6
tus/2u3Afw==
       "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAmpmZmZmZyT8iCq2GlSvWv+IvthXa
aNI/yqeHLsus078Cvl1nfSDYP3MFys4GcNG/ALzjJq7w3T+A+aug8OzOv7C1
Llkr6+E/PIxB5VeCy7+HvecBK+fkP4zqu3oTosi/ft0ZrcDq5z+eF8QKqk3G
vyhH1PNS9Oo/XOn7CViGxL907fJBRQLuP8HNFBAPTcO/CDyEWHyJ8D9ndp9X
daLCv2fFQXJmEvI/tm7YZeWGwr/dSE1zEJvzP+tooNpt+sK/z2zEAqoi9T/Y
vrlo0fzDv5PIU1hjqPY/dkNP9oaNxb8+sXaqbSv4P70js+W5q8e/9tIvnPuq
+T9ePS+GSlbKvz1fAKpBJvs/FA+rrM6Lzb/O/uOVdpz8Pz4i6zlJpdC/YDsY
0tMM/j8s87iRTMjSvxG5duqVdv8/irseH88t1b+XLBV2fmwAQFRh/FqL1Ne/
oh/EZaYZAUAMemsiGbvavyVX6+NmwgFAbtLVde7f3b9mZmZmZmYCQJrHASWw
oOC//P3QyA==
       "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAAmpmZmZmZub+axwElsKDgP+CJ0lhJ
QWu/EtclBcF44z/KS84ODui4P1uLijQFLOY/B61/UILPyT+EpibqDbnoP5KY
GSsrz9M/e7QqpoAe6z8Qa3HCl+zaP2g02+kXW+0/m3gMPiAe4T9Wr0Xko23v
P7k+Jx8i3eQ/boy6iYWq8D9+olarVLHoP2X452wliPE/NkgVy6+Y7D9icqgD
PE/yP2JZQJ6QSPA/MZEoq1//8j8n9FnWRkzyP8QR0e0ymPM/v8746mhW9D+6
vN20ZBn0P0gIA9HhZfY/kftjc7CC9D9jQCOomXn4PwxJskre0/Q/kiFJT3aQ
+j80MPUnwwz1P+vuW/pbqfw/SR8S20At9T8Qp8/ILcP+PxruqyZGNfU/Imtm
LmduAEAamEjJziT1P+VxTTmQegFAqE+Tf+P79D+cQf67g4UCQNa3uf+ZuvQ/
4/yWEbSOA0BGuubtFGH0P+uMmoSUlQRALBbhyYPv8z+bmZmZmZkFQN5o19Ui
ZvM/q9HD0g==
       "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAANDMzMzMz4z8iCq2GlSvmP29+LZfB
/OY/vAlsJNA65j9Nv8MzAMbqPwFcMLTlHeY/mak0weyM7j+MJLSN5dTlP9T/
eRnDJ/E/CsnhbPZf5T+m3/Hj5gXzPxGRRl1Wv+Q/Ds+qDOTf9D+22SaZWvPj
P6qEIhS/tPY/6FRFXG/84j/QZx00f4P4PwJTdaoX2+E/AWym4y5L+j9XjxYK
7Y/gPx3pVlncCvw/tMQ+ZT433j/PT6ELmsH9PwolwV7n/do/8KfaLn9u/z9M
eGjtinXXP2T8XxhUiABAEtye6wig0z96CJuYm1MBQAiA0EXU/s4/Cs4BPKoY
AkC4PhxvvivGP5OHo3MX1wJAQJeW/P2WuT/x1zU1fo4DQEBm4Sh8GJc/r2ux
MH0+BEAgeX6fOCGuv8xF9AO35gRArEdcuxJxwr9EUk5s0oYFQODtSF500c2/
4/PddXoeBkAseAnhtNHUv05so6herQZAABdLqlbw2r8yMzMzMzMHQJrHASWw
oOC/ZU+7aQ==
       "]], ArrowBox[CompressedData["
1:eJwBkQFu/iFib1JlAgAAABgAAAACAAAANDMzMzMz4z8iCq2GlSvmP80y8mYL
wec/9YuWJ0Km5j/Tr+GsQ1PsP7WUlB++6+Y/SskNjbdz8D/scV+Q5PvmP1AI
cN2PvfI/KiY86KzW5j/Kw0vu8wX1P9lmiOYqfOY/tOLYq61L9z/OPECRjuzl
PzrbWWyIjfk//taCGyQo5T+UcOKTUcr7P2wUJL1TL+Q/NHEHN9kA/j9cOWB7
oQLjP5aREF75FwBA8ibP4qyi4T8qZ2W9OisBQKFAvLIwEOA/gmGlrJ45AkCC
1B/0BJjcPyqsx7OVQgNAQWX+SySu2D+uUrc7k0UEQA6UewXTZNQ/dRbs2A1C
BUBkRNe5rnzPPxmpVJR/NwZA/FNB+1F6xT/rmmsyZiUHQFhyA8u+j7U/aUZR
eEMLCEAA5QhbgJ9yv1wOxm6d6AhAUKblm3Esub/TZOGi/rwJQGC4m1N4Ncm/
j0RjZPaHCkDABkEKBDbTvwQMfwEZSQtAiBL2o3IZ2r8AAAAAAAAMQJjHASWw
oOC/Vgqz5Q==
       "]], 
      {GrayLevel[0]}}}}},
  AlignmentPoint->Center,
  AspectRatio->Automatic,
  Axes->False,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->True,
  FrameLabel->FormBox[
    StyleBox[
    "\"\[ScriptX] \[RightTeeArrow] \[ScriptF](\[ScriptX])\"", 18, Bold, 
     StripOnInput -> False], TraditionalForm],
  FrameStyle->{},
  FrameTicks->None,
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->Automatic,
  TicksStyle->{}]], "Output",
 ImageSize->{364, 259},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1070607656]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Building an Understanding of Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/BuildingAnUnderstandingOfFunctions"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Understanding Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingFunctions"]], "MoreAbout",
 CellID->2111131040],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->2116938460]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"SetsStyle - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 30, 47.5300624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "SetsStyle is an option for FunctionArrowDiagram that determines how the \
domain and range sets are rendered.", "synonyms" -> {}, "title" -> 
    "SetsStyle", "titlemodifier" -> "", "windowtitle" -> "SetsStyle", "type" -> 
    "Symbol", "uri" -> "ClassroomUtilities/ref/SetsStyle"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5318, 159, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->24405597]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 21640, 587}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[602, 21, 2908, 67, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3535, 92, 52, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3590, 95, 557, 15, 85, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4184, 115, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->770157586],
Cell[4796, 135, 115, 3, 70, "Notes",
 CellID->1067943069],
Cell[4914, 140, 182, 6, 70, "Notes",
 CellID->238000882],
Cell[5099, 148, 182, 6, 70, "Notes",
 CellID->1466273060]
}, Closed]],
Cell[CellGroupData[{
Cell[5318, 159, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->24405597],
Cell[CellGroupData[{
Cell[5832, 177, 195, 6, 31, "ExampleSection",
 CellID->699806540],
Cell[6030, 185, 128, 3, 28, "Input",
 CellID->1276470095],
Cell[6161, 190, 96, 1, 32, "ExampleText",
 CellID->271253135],
Cell[CellGroupData[{
Cell[6282, 195, 276, 7, 28, "Input",
 CellID->1991141011],
Cell[6561, 204, 5411, 124, 280, "Output",
 CellID->127198003]
}, Open  ]],
Cell[11987, 331, 72, 1, 70, "ExampleText",
 CellID->1005210991],
Cell[CellGroupData[{
Cell[12084, 336, 543, 16, 70, "Input",
 CellID->327274788],
Cell[12630, 354, 5504, 126, 280, "Output",
 CellID->1070607656]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18195, 487, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[18646, 502, 211, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[18894, 512, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[19345, 527, 180, 4, 70, "MoreAbout",
 CellID->2111131040],
Cell[19528, 533, 172, 4, 70, "MoreAbout",
 CellID->2116938460]
}, Open  ]],
Cell[19715, 540, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

