(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     44734,       1099]
NotebookOptionsPosition[     39034,        921]
NotebookOutlinePosition[     41905,        998]
CellTagsIndexPosition[     41785,        992]
WindowTitle->Shell - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Working with Riemann Sums\"\>":>
       Documentation`HelpLookup[
       "paclet:Classroom Utilities/tutorial/WorkingWithRiemannSums"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities/ref/Shell\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["Classroom Utilities/ref/Shell"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/Shell.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "Classroom Utilities/ref/Shell", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["Shell", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Shell", "[", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox[
          StyleBox["r", "TI"], 
          StyleBox["min", "TI"]], ",", " ", 
         SubscriptBox[
          StyleBox["r", "TI"], 
          StyleBox["max", "TI"]], ",", " ", 
         SubscriptBox[
          StyleBox["h", "TI"], 
          StyleBox["min", "TI"]], ",", 
         SubscriptBox[
          StyleBox["h", "TI"], 
          StyleBox["max", "TI"]]}], "}"}], "]"}]], "InlineFormula"],
     " \[LineSeparator]returns a GraphicsComplex for a shell with inner \
radius r$min outer radius r$max and height h$max- h$max."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Shell", "[", 
       RowBox[{"{", 
        RowBox[{
         SubscriptBox[
          StyleBox["l", "TI"], 
          StyleBox["1", "TR"]], ",", 
         SubscriptBox[
          StyleBox["l", "TI"], 
          StyleBox["2", "TR"]], ",", 
         StyleBox["\[Ellipsis]", "TR"]}], "}"}], "]"}]], "InlineFormula"],
     "\[LineSeparator]returns a list of GraphicsComplexes."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"Shell", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["r", "TI"], 
           StyleBox["min", "TI"]], ",", " ", 
          SubscriptBox[
           StyleBox["r", "TI"], 
           StyleBox["max", "TI"]], ",", " ", 
          SubscriptBox[
           StyleBox["h", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["h", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["ang", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]create a partial shell with wall going from 0 to ",
     Cell[BoxData[
      StyleBox["ang", "TI"]], "InlineFormula"],
     " radians."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->2483672],

Cell["Shell will take the option CapStyle.", "Notes",
 CellID->1067943069],

Cell["Shell is used to create washers using different proportions.", "Notes",
 CellID->2041787025]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->710873114],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->47520215],

Cell["This loads the package.", "ExampleText",
 CellID->274696822],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1887129951],

Cell["\<\
Create a shell with inner radius one outer radius two\[LineSeparator]and \
thickness 6.\
\>", "ExampleText",
 CellID->807103914],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"Shell", "[", 
   RowBox[{"{", 
    RowBox[{"1", ",", "2", ",", "0", ",", "6"}], "}"}], "]"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1488768146],

Cell[BoxData[
 Graphics3DBox[GraphicsComplex3DBox[CompressedData["
1:eJxtl1Fol1UYxv8uqcgJBm696sy66U4IgkwbfIcgnCBk1kWF3QSr8MaLorZa
y+FFmxvNEUVXUl6EqDdBWMTgVBfe2FYQ2UVEozKkkcpYbriajZ3neT++Z+//
YsPHb9//nPd53vM77/0vHDnY29Zqte5b12rd1uLnetWSz6kO++yHmWtV29A3
X1x64rz//z1dQ2Ojx65VI69sGNy654LrHbln7y9XrlYnbn/v67dOfO96186D
j924+2r1z4bjr57+/UfXX/pp54P9rb+rpz7c9frO9p9dP7v/mStvnJ+tbq1+
fnV97zsdzw4+/FfVt29gcfK531zffeC7U0eOXam6OrsPfj7xh+tTj7794smP
/qy+xW/q2/Ec/456P97L76G+bvXnTHUG66LOdXMf1Bewz23YN3XWhXWiPoY6
sq7UN6Hu9IH6HYc2P/TAJxPd6tvC0dXnsz4/XN6f9f3vlvVkXQ98yl2y/ifL
fvPLst9/i0/5rNTntVLPvE/qifpnrT98ylPi1yPluXyv+Pt4eW9+U/KAdWTN
D3zKT0ve4FNelHxuLnXJ70ueUcf8geQfdc/rpV/gUy6+fdytz8/BN+qG9w/C
N+rwKU/AN+rwKc/DN+rwKR+Ab9TPoT5L8I06fMr0jTp8yugv16fhF32jDp8y
faMOnzJ9o75+9edMPo11UT+EdfdiH9TXtZd9bsW+qUueXR9p5t/1O4ca/eL6
XcdP7t/df2aSvlG/erTRj64PIAcm7x9GbjplPbPI2XZZfw9yeVj3W+rD88f1
vuZ5VecBfbJH6n8RfTUtfu1CH+4Qf+FTNSB5gE8VfaMOn6rnJW9bcI60tTfz
yXNnXPLMc2pU8s9zbeNQs1/gk/SbpZhflmJ+WYr5ZSnml6WYX5ZiflmK+WUp
5pelmF+WYn5ZivllKeaXpZhflmJ+WYr5ZSnml6WYX5Zifq18b8gvSzG/LMX8
shTzy1LML0sxvyzF/PL6Z61/zC9LMb8sxfzy/GTNT8wvSzG/LMX88vwLv7xf
hF+W4JPwq36+yS9LMb+8v4Rf3l/CL0sxvyzF/LIU88v7S/hlKeaXpZhflmJ+
WYr5ZSnm10o/hvxak2fXY35ZivllKeaXpZhflmJ+rfRdyC9LMb8sxfxac/64
HvNrJQ8hvyzF/LIU88v7S/hlKeaXpZhflmJ+1bwYlzzH/Kp51OQX+6vF3/4p
z98Cv+p7Znn/LfDrkutlPcvg14zrpb+Wwa/Lch/+D/yq7+3l/FkCv+p5ofh0
E/yac7301yL4Ne96OQdvgF835P4/X/HvqPfjvfwe6iU/15GfJde5bu6D+gL2
uQ37ps66sE7Ux1BH1pX6JtSdPlCXe7z7Vvh1IevzhV+Xsr6/9PtM1vXAp9wl
6y/8mgW/6v0Wfl3LZ6U+5RycA79uav2z1h8+5Snxq5yDi+BX7W/pr5vg15zm
J2t+4BP4VecNPoFfdT4Lv5bBrxnNP/hV5x91B7/qfsHnq+Lbp936/Bx8o254
/yB8ow6fwK/63gufwK/LrsMn8Ku+t59DfZbgG3X4lOkbdfgEfs27Pg2/6Bt1
+JTpG3X4lOkb9XIOXge/llw/hHX3Yh/UC78ug1/LrkueXR9p5t/1wi/vF9cL
v76cpG/UC7+8H/35AeTA5P3DyE2nrGcWOdsu6+9BLg/rfkt9eP643tc8r+o8
oE/2SP0voq+mxa9d6MMd4i98Ar/qPMCnir5Rh0/gV523LThH2tqb+eS5My55
5jk1KvnnubZxqNkv+KTmP8k75Rf5qPwiT5VfvB8qv3gfVn7x/qz84vyl/OL9
UPnF+Uv5xfu/8ovzl/KL9x/lF+cv5RfnL+UX5y/lF+cv5RfnL+UX5y/lF+cv
5RfnL+UX76vKL85fyi/OX8ovzl/KL85fyi+vf9b6x/zi/KX84v1Q+eX5yZqf
mF+cv5RfnL+UX55/4Zf3i/DL74fCr/r5Jr84fym/vL+EX95fwi/OX8ovzl/K
L85fyi/vL+EX5y/lF+cv5RfnL+UX5y/lF+cv5RfnL+XXmjy7HvOL85fyi/OX
8ovzl/KL85fyi/OX8ovzl/KL85fya83543rML85fyi/OX8ovzl/KL+8v4Rfn
L+UX5y/lF+cv5VfNi3HJc8yvmkdNfln6HylQGns=
   "], 
   {EdgeForm[None], Polygon3DBox[CompressedData["
1:eJwtl2W0VmUUBve+l+7utLtbVESxFcVuxS7AVgwQEBMFu8Xu7u7u7u7uzm/W
nh+z3jPrmf9n7aFjxo0e2xQRQzKiufGu2aDxGU2Cr9XgjQYzG5wk+JtudM2C
r+1Gd7Lgb7nRtRB8HTe6UwR/242upeDrutGdKvg7bnStBF/Pje40wd91o2st
+Cg3utMFf8+Nro3g67vRnSH4+250bQXfwI3uTME/cKNrJ/hoN7qzBP/Qja69
4Bu60Z0t+EdudB0E38iN7hzBP3aj6yj4xm505wr+iRtdJ8E3caM7T/BP3eg6
C76pG935gn/mRtdF8M3c6GYJ/rkbXVfBN3eju0DwL9zougm+hRvdhYJ/6UbX
XfAt3eguEvwrN7oegm/lRnex4F+70fUUfGs3uksE/8aNrpfg27jRXSr4t250
vQXf1o3uMsG/c6PrI/h2bnSXC/69G11fwbd3o7tC8B/c6PoJPsaN7krBf3Sj
6y/4Dm50Vwn+kxvdAMF3dKO7WvCf3egGCr6TG901gv/iRjdI8J3d6K4V/Fc3
usGC7+JGd53gv7nRDRF8Vze66wX/3Y1uqOC7udHdIPgfbnSzCb67G92Ngv/p
Rje74Hu40d0k+F9udHMIvqcb3c2C/+1GN6fge7nR3SL4P250cwk+1o3uVsH/
daObW/BxbnS3Cf6fG908go93o7tdcH6k4+3mFXxvN7o7BM+sjW4+wfeJ2uju
FLwpa6ObX/B9oza6uwRvztroFhB8v6iN7m7BW2RtdAsKvn/URneP4C2zNrqF
BD8gaqO7V/BWWRvdwoIfGLXR3Sd466yNbhHBD4ra6O4XvE3WRreo4AdHbXQP
CN42a6NbTPAJURvdg4K3y9roFhf8kKiN7iHB22dtdEsIfmjURvew4B2yNrol
BT8saqN7RPCOWRvdUoIfHrXRPSp4p6yNbmnBJ0ZtdI8J3jlro1tG8ElRG93j
gnfJ2uiWFfyIqI3uCcG7Zm10ywk+OWqje1Lwblkb3fKCT4na6J4SvHvWRjdM
8KlRG93TgvfI2uhWEPzIqI3uGcF7Zm10Kwo+LWqje1bwXlkb3UqCHxW10T0n
eO+sjW644EdHbXTPC94na6NbWfBjoja6FwTvm7XRjRD82KiN7kXB+2VtdKsI
flzURveS4P2zNrpVBT8+aqN7WfABWRvdSMGnR210rwg+MGujW03wE6I2ulcF
H5S10a0u+IlRG91rgg/O2ujWEHxG1Eb3uuDcVDPsUnBuKja6mYJzU/0PUP2G
+w==
     "]], 
    {GrayLevel[0.75], Polygon3DBox[CompressedData["
1:eJwt0mO0EAYYx+GbbfPmtmzbXFwtu2W3uGzbLS9sadm2lm1r2a167ul+eM77
fv6df/LG7au2CxkQEBBkAiGC/1CEJgxhCUd4IhCRSEQmClGJRnRiEJNYxCYO
cYlHfBKQkEQkJglJCSQZyUlBSlKRmjSk5Qd+JB3pyUBGMpGZLGQlG9nJQU5y
kZs85CUf+SlAQQpRmCIUpRjFKUFJSlGaMsF9xnOB85zjLGc4zSlO8i8nOM4x
jnKEwxziIAfYzz72sofd7GInO9jONrayhc1sYiMbWM861rKGf1jNKlayguX8
zV8sYylLWMyfLGIhC5jPPOYyhz+YzSxmMoPpTGMqU5jMJCYGfN9QUJ+ylKM8
FajIT1SiMlWoSjWq8zM1qMkv1KI2dahLPerTgIY0ojFNaEozmvMrLWhJK1rT
hra0oz0d6EgnOtOFrvxGN7rTg570oje/04e+9KM/AxjIIAYzhKEMYzgjGMko
RjOGsYwL7nORZAYVSFKSkJhEJCQB8YlHXOIQm1jEJAbRiUZUohCZSEQkAuEJ
R1jCEJpQhCRE0Jj56nzhfz7ziY984D3veMsbXvOKl7zgOc/4j6c84TGPeMgD
7nOPu9zhNre4yQ2uc42rXOEyl4L7fAMr1IWu
      "]]}}]]], "Output",
 ImageSize->{164, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1216182286,
 ImageCache->GraphicsData["CompressedBitmap", "\<\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\
\>"]]
}, Open  ]],

Cell["Create a washer.", "ExampleText",
 CellID->2110637958],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"Shell", "[", 
   RowBox[{"{", 
    RowBox[{"1", ",", "3", ",", "0", ",", 
     RowBox[{"1", "/", "2"}]}], "}"}], "]"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->626328656],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3bFy4zYQBmDP5EnyCCqvzSOoVHkuVaTQpGLL0qVLtS7d5V4hZR7hWpdX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    "], {{0, 117}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 117},
  PlotRange->{{0, 180}, {0, 117}}]], "Output",
 ImageSize->{184, 117},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->145872923]
}, Open  ]],

Cell["Create a partial washer.", "ExampleText",
 CellID->617114689],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"Shell", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"1", ",", "3", ",", "0", ",", 
      RowBox[{"1", "/", "2"}]}], "}"}], ",", 
    RowBox[{"3", " ", 
     RowBox[{"\[Pi]", "/", "2"}]}]}], "]"}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1648046660],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3b120zAUB/Cew5PwCBlZeYSMHemYgaGHyWvGjoxdO3aDV2DkEVgZGTsK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    "], {{0, 117}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 117},
  PlotRange->{{0, 180}, {0, 117}}]], "Output",
 ImageSize->{184, 117},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->434590080]
}, Open  ]],

Cell["Create a set of shells.", "ExampleText",
 CellID->130829102],

Cell[BoxData[
 RowBox[{
  RowBox[{"lis", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"r", "+", 
        RowBox[{"1", "/", "4"}]}], ",", "0", ",", 
       RowBox[{"2", "-", 
        SuperscriptBox["r", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"3", "/", "4"}], ",", 
       RowBox[{"1", "/", "4"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1968946433],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"Shell", "[", "lis", "]"}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->1507182808],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3a2SIzcQAOCrypPkEQxD8wiGC2+hQcBCU8OFgaYLjyVPkKrAe4TQgwcP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    "], {{0, 195}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 195},
  PlotRange->{{0, 180}, {0, 195}}]], "Output",
 ImageSize->{184, 195},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[6]=",
 CellID->60078768]
}, Open  ]],

Cell["Create a set of partial shells.", "ExampleText",
 CellID->887195776],

Cell[BoxData[
 RowBox[{
  RowBox[{"lis", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"r", "+", 
        RowBox[{"1", "/", "4"}]}], ",", "0", ",", 
       RowBox[{"2", "-", 
        SuperscriptBox["r", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"3", "/", "4"}], ",", 
       RowBox[{"1", "/", "4"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[7]:=",
 CellID->1120446111],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"Shell", "[", 
   RowBox[{"lis", ",", "\[Pi]", ",", 
    RowBox[{"CapStyle", "\[Rule]", " ", 
     RowBox[{"EdgeForm", "[", "LightGray", "]"}]}]}], "]"}], "]"}]], "Input",
 CellLabel->"In[8]:=",
 CellID->53687034],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3EGSGykQBdCOmJPMEeYqcwT30otZ6Ap9FS29mzPMEbysK3jpJaPuiq5G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    "], {{0, 198}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 198},
  PlotRange->{{0, 180}, {0, 198}}]], "Output",
 ImageSize->{184, 198},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[8]=",
 CellID->498163504]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Possible Issues",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1305812373],

Cell["\<\
When a large number of shells are called for rendering may be slow and \
details may be difficult to see..\
\>", "ExampleText",
 CellID->1338452906],

Cell["This loads the package.", "ExampleText",
 CellID->486788817],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1694435896],

Cell[BoxData[
 RowBox[{
  RowBox[{"lis", "=", " ", 
   RowBox[{"Table", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"r", ",", 
       RowBox[{"r", "+", 
        RowBox[{"1", "/", "4"}]}], ",", "0", ",", 
       RowBox[{"2", "-", 
        SuperscriptBox["r", "2"]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"r", ",", "0", ",", 
       RowBox[{"49", "/", "50"}], ",", 
       RowBox[{"1", "/", "50"}]}], "}"}]}], "]"}]}], ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->603461205],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Graphics3D", "[", 
  RowBox[{"Shell", "[", 
   RowBox[{"lis", ",", 
    RowBox[{"3", " ", 
     RowBox[{"\[Pi]", "/", "2"}]}], ",", 
    RowBox[{"CapStyle", "\[Rule]", " ", 
     RowBox[{"EdgeForm", "[", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Thickness", "[", ".001", "]"}], ",", "LightGray"}], "}"}], 
      "]"}]}]}], "]"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1954691301],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnT9yHDsOh121J9kj6CoKFT6FCjZw6PRdReHL3l5lQ15jw9mxqOFiSBAN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    "], {{0, 181}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 181},
  PlotRange->{{0, 180}, {0, 181}}]], "Output",
 ImageSize->{184, 181},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->246325342]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Working with Riemann Sums",
 BaseStyle->"Link",
 ButtonData->
  "paclet:Classroom Utilities/tutorial/WorkingWithRiemannSums"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Shell - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 30, 52.4284624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "Shell[{r_min, r_max, h_min, h_max}] returns a GraphicsComplex for a \
shell with inner radius r$min outer radius r$max and height h$max- \
h$max.Shell[{l_1, l_2, ...}] returns a list of \
GraphicsComplexes.Shell[{r_min, r_max, h_min, h_max}, ang] create a partial \
shell with wall going from 0 to ang radians.", "synonyms" -> {}, "title" -> 
    "Shell", "titlemodifier" -> "", "windowtitle" -> "Shell", "type" -> 
    "Symbol", "uri" -> "Classroom Utilities/ref/Shell"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6038, 181, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->710873114]},
 "RasterizedOutput"->{
  Cell[15880, 391, 2812, 54, 138, "Output",
   CellTags->"RasterizedOutput",
   CellID->145872923],
  Cell[19118, 465, 2662, 52, 138, "Output",
   CellTags->"RasterizedOutput",
   CellID->434590080],
  Cell[22526, 549, 4507, 82, 216, "Output",
   CellTags->"RasterizedOutput",
   CellID->60078768],
  Cell[27912, 666, 3788, 70, 219, "Output",
   CellTags->"RasterizedOutput",
   CellID->498163504],
  Cell[33340, 801, 4955, 89, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->246325342]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 41120, 969},
 {"RasterizedOutput", 41263, 973}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[598, 21, 2421, 55, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3044, 80, 48, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3095, 83, 2084, 64, 217, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5216, 152, 607, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->2483672],
Cell[5826, 172, 74, 1, 70, "Notes",
 CellID->1067943069],
Cell[5903, 175, 98, 1, 70, "Notes",
 CellID->2041787025]
}, Closed]],
Cell[CellGroupData[{
Cell[6038, 181, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->710873114],
Cell[CellGroupData[{
Cell[6553, 199, 194, 6, 31, "ExampleSection",
 CellID->47520215],
Cell[6750, 207, 66, 1, 32, "ExampleText",
 CellID->274696822],
Cell[6819, 210, 128, 3, 28, "Input",
 CellID->1887129951],
Cell[6950, 215, 138, 4, 45, "ExampleText",
 CellID->807103914],
Cell[CellGroupData[{
Cell[7113, 223, 208, 6, 28, "Input",
 CellID->1488768146],
Cell[7324, 231, 8220, 143, 237, 4328, 75, "CachedBoxData", "BoxData", "Output",
 CellID->1216182286]
}, Open  ]],
Cell[15559, 377, 60, 1, 70, "ExampleText",
 CellID->2110637958],
Cell[CellGroupData[{
Cell[15644, 382, 233, 7, 28, "Input",
 CellID->626328656],
Cell[15880, 391, 2812, 54, 138, "Output",
 CellTags->"RasterizedOutput",
 CellID->145872923]
}, Open  ]],
Cell[18707, 448, 67, 1, 70, "ExampleText",
 CellID->617114689],
Cell[CellGroupData[{
Cell[18799, 453, 316, 10, 28, "Input",
 CellID->1648046660],
Cell[19118, 465, 2662, 52, 138, "Output",
 CellTags->"RasterizedOutput",
 CellID->434590080]
}, Open  ]],
Cell[21795, 520, 66, 1, 70, "ExampleText",
 CellID->130829102],
Cell[21864, 523, 493, 16, 70, "Input",
 CellID->1968946433],
Cell[CellGroupData[{
Cell[22382, 543, 141, 4, 28, "Input",
 CellID->1507182808],
Cell[22526, 549, 4507, 82, 216, "Output",
 CellTags->"RasterizedOutput",
 CellID->60078768]
}, Open  ]],
Cell[27048, 634, 74, 1, 70, "ExampleText",
 CellID->887195776],
Cell[27125, 637, 493, 16, 70, "Input",
 CellID->1120446111],
Cell[CellGroupData[{
Cell[27643, 657, 266, 7, 28, "Input",
 CellID->53687034],
Cell[27912, 666, 3788, 70, 219, "Output",
 CellTags->"RasterizedOutput",
 CellID->498163504]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[31749, 742, 278, 8, 70, "ExampleSection",
 CellID->1305812373],
Cell[32030, 752, 158, 4, 70, "ExampleText",
 CellID->1338452906],
Cell[32191, 758, 66, 1, 70, "ExampleText",
 CellID->486788817],
Cell[32260, 761, 128, 3, 70, "Input",
 CellID->1694435896],
Cell[32391, 766, 495, 16, 70, "Input",
 CellID->603461205],
Cell[CellGroupData[{
Cell[32911, 786, 426, 13, 70, "Input",
 CellID->1954691301],
Cell[33340, 801, 4955, 89, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->246325342]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[38356, 897, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[38807, 912, 185, 4, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[39007, 919, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

