(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     15582,        460]
NotebookOptionsPosition[     12009,        351]
NotebookOutlinePosition[     14324,        413]
CellTagsIndexPosition[     14204,        407]
WindowTitle->Subintervals - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Integration as Limits\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/IntegrationAsLimits"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/BinWidths\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/BinWidths"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/BinWidths.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/BinWidths", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["Subintervals", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["Subintervals"], "InlineFormula"],
     " \[LineSeparator]an option for ",
     "RiemannSumPlot",
     " specifying whether the polygons should all have the same width or have \
random widths."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->75465076],

Cell[TextData[{
 "Subintervals can take the values ",
 Cell[BoxData[
  ButtonBox["Uniform",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/Uniform"]], "InlineFormula"],
 " or ",
 Cell[BoxData[
  ButtonBox["Nonuniform",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/Nonuniform"]], "InlineFormula"],
 "."
}], "Notes",
 CellID->1067943069],

Cell[TextData[{
 "With the value Nonuniform sub-intervals are generated using ",
 ButtonBox["Join",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Join"],
 "[",
 Cell[BoxData[
  RowBox[{
   RowBox[{"{", 
    SubscriptBox[
     StyleBox["var", "TI"], 
     StyleBox["min", "TI"]], "}"}], ",", 
   RowBox[{
    ButtonBox["RandomReal",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/RandomReal"], "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SubscriptBox[
        StyleBox["var", "TI"], 
        StyleBox["min", "TI"]], ",", 
       SubscriptBox[
        StyleBox["var", "TI"], 
        StyleBox["max", "TI"]]}], "}"}], ",", 
     RowBox[{
      StyleBox["n", "TI"], "-", "1"}]}], "]"}], ",", 
   RowBox[{"{", 
    SubscriptBox[
     StyleBox["var", "TI"], 
     StyleBox["max", "TI"]], "}"}]}]], "InlineFormula"],
 "]"
}], "Notes",
 CellID->939964880]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->119663064],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->73133548],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->531409173],

Cell["Non-uniform widths for the polygons.", "ExampleText",
 CellID->9482738],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"RiemannSumPlot", "[", 
  RowBox[{
   RowBox[{"x", " ", 
    RowBox[{"Exp", "[", 
     RowBox[{"-", "x"}], "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "4"}], "}"}], ",", "12", ",", 
   "\"\<Center\>\"", ",", 
   RowBox[{"Subintervals", "\[Rule]", " ", "Nonuniform"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1100030828],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztXSGzgzgQ7s39kvsXV/tkJbLyMDeDOIHEIpFIbCQSiUUikbVIZGVvNwuU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    "], {{0, 56}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 56},
  PlotRange->{{0, 360}, {0, 56}}]], "Output",
 ImageSize->{364, 56},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->31905104]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Integration as Limits",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/IntegrationAsLimits"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->1425071446]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Subintervals - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 31, 11.4292624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "Subintervals an option for RiemannSumPlot specifying whether the \
polygons should all have the same width or have random widths.", 
    "synonyms" -> {}, "title" -> "Subintervals", "titlemodifier" -> "", 
    "windowtitle" -> "Subintervals", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/BinWidths"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5800, 182, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->119663064]},
 "RasterizedOutput"->{
  Cell[7120, 231, 3498, 65, 77, "Output",
   CellTags->"RasterizedOutput",
   CellID->31905104]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13940, 396},
 {"RasterizedOutput", 14083, 400}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[605, 21, 2735, 63, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3365, 88, 55, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3423, 91, 440, 13, 97, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3900, 109, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->75465076],
Cell[4511, 129, 379, 13, 70, "Notes",
 CellID->1067943069],
Cell[4893, 144, 870, 33, 70, "Notes",
 CellID->939964880]
}, Closed]],
Cell[CellGroupData[{
Cell[5800, 182, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->119663064],
Cell[CellGroupData[{
Cell[6315, 200, 194, 6, 31, "ExampleSection",
 CellID->73133548],
Cell[6512, 208, 127, 3, 28, "Input",
 CellID->531409173],
Cell[6642, 213, 77, 1, 32, "ExampleText",
 CellID->9482738],
Cell[CellGroupData[{
Cell[6744, 218, 373, 11, 28, "Input",
 CellID->1100030828],
Cell[7120, 231, 3498, 65, 77, "Output",
 CellTags->"RasterizedOutput",
 CellID->31905104]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[10679, 303, 448, 13, 45, "TutorialsSection",
 CellID->250839057],
Cell[11130, 318, 177, 4, 17, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[11344, 327, 448, 13, 45, "MoreAboutSection",
 CellID->38303248],
Cell[11795, 342, 172, 4, 70, "MoreAbout",
 CellID->1425071446]
}, Open  ]],
Cell[11982, 349, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

