(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     25396,        780]
NotebookOptionsPosition[     20881,        638]
NotebookOutlinePosition[     23098,        696]
CellTagsIndexPosition[     23013,        691]
WindowTitle->SubstituteIntegrate - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Using Integration Techniques Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
UsingIntegrationTechniquesFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"AutoSimplify\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/AutoSimplify"], \
"\<\"PartsIntegrate\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/PartsIntegrate"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Integration Techniques\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/IntegrationTechniques"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/SubstituteIntegrate\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/SubstituteIntegrate"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/SubstituteIntegrate.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/SubstituteIntegrate", ".html"]], 
           None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["SubstituteIntegrate", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"SubstituteIntegrate", "[", 
       RowBox[{
        StyleBox["intgrnd", "TI"], ",", 
        StyleBox["x", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           StyleBox["expr", "TI"], "\[Rule]", " ", 
           StyleBox["u", "TI"]}], ",", 
          RowBox[{
           RowBox[{"\[DifferentialD]", 
            StyleBox["x", "TI"]}], "\[Rule]", " ", 
           RowBox[{
            StyleBox["coef", "TI"], " ", 
            RowBox[{"\[DifferentialD]", 
             StyleBox["u", "TI"]}]}]}]}], "}"}]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]uses substitution to convert ",
     Cell[BoxData[
      StyleBox["intgrnd", "TI"]], "InlineFormula"],
     " to a recognizable integral."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->488128044],

Cell["\<\
\[DifferentialD]x and \[DifferentialD]u need to be entered using \
\[EscapeKey]dd\[EscapeKey]\
\>", "Notes",
 CellID->1067943069],

Cell["Symbols other than x and u can be used for the variables.", "Notes",
 CellID->1673958400]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->341704290],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->38424508],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->35569453],

Cell["Simplify a difficult integral using substitution.", "ExampleText",
 CellID->815342705],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"SubstituteIntegrate", "[", 
  RowBox[{
   FractionBox[
    RowBox[{"ArcTan", "[", "x", "]"}], 
    RowBox[{"1", "+", 
     SuperscriptBox["x", "2"]}]], ",", "x", ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{
      RowBox[{"ArcTan", "[", "x", "]"}], "\[Rule]", " ", "u"}], ",", 
     RowBox[{
      RowBox[{"\[DifferentialD]", "x"}], "\[Rule]", " ", 
      RowBox[{
       RowBox[{"(", 
        RowBox[{"1", "+", 
         SuperscriptBox["x", "2"]}], ")"}], 
       RowBox[{"\[DifferentialD]", "u"}]}]}]}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->371691428],

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{"u", 
   RowBox[{"\[DifferentialD]", "u"}]}]}]], "Output",
 ImageSize->{41, 28},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->914364431]
}, Open  ]],

Cell["Copy the result down and evaluate.", "ExampleText",
 CellID->667641776],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"\[Integral]", 
  RowBox[{"u", 
   RowBox[{"\[DifferentialD]", "u"}]}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->453273657],

Cell[BoxData[
 FractionBox[
  SuperscriptBox["u", "2"], "2"]], "Output",
 ImageSize->{22, 35},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->330013885]
}, Open  ]],

Cell["\<\
Obtain the final result by reversing the original substitution.\
\>", "ExampleText",
 CellID->569822335],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"(", 
    RowBox[{
     FractionBox[
      SuperscriptBox["u", "2"], "2"], "+", "C"}], ")"}], "/.", 
   RowBox[{"{", 
    RowBox[{"u", "\[Rule]", " ", 
     RowBox[{"ArcTan", "[", "x", "]"}]}], "}"}]}], "//", 
  "TraditionalForm"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1374402372],

Cell[BoxData[
 FormBox[
  RowBox[{"C", "+", 
   RowBox[{
    FractionBox["1", "2"], " ", 
    SuperscriptBox[
     RowBox[{
      SuperscriptBox["tan", 
       RowBox[{"-", "1"}]], "(", "x", ")"}], "2"]}]}], 
  TraditionalForm]], "Output",
 ImageSize->{86, 33},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]//TraditionalForm=",
 CellID->67862972]
}, Open  ]],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2112548305],

Cell[TextData[{
 "Combining the SubstituteIntegrate function with ",
 StyleBox["Mathematica",
  FontSlant->"Italic"],
 "'s ",
 ButtonBox["Interpretation",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Interpretation"],
 " function gives a more intuitive interface for use in the classroom. \
Because ",
 ButtonBox["Interpretation",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Interpretation"],
 " needs to take information from the constructed interface and convert to ",
 ButtonBox["InputForm",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/InputForm"],
 " you should use full function names for any package functions. "
}], "ExampleText",
 CellID->890960227],

Cell["\<\
This creates the interface for the SubstituteIntegrate function.\
\>", "ExampleText",
 CellID->1252226284],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Interpretation", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"intgrnd", "=", 
      RowBox[{"(", 
       RowBox[{"x", " ", 
        RowBox[{"Sqrt", "[", 
         RowBox[{"1", " ", "-", " ", 
          RowBox[{"x", "^", "2"}]}], "]"}]}], ")"}]}], ",", 
     RowBox[{"var", "=", "x"}], ",", 
     RowBox[{"expr", "=", 
      RowBox[{"(", 
       RowBox[{"1", "-", 
        RowBox[{"x", "^", "2"}]}], ")"}]}], ",", 
     RowBox[{"newvar", "=", "u"}], ",", 
     RowBox[{"coef", "=", 
      RowBox[{"-", 
       RowBox[{"(", 
        RowBox[{"1", "/", 
         RowBox[{"(", 
          RowBox[{"2", " ", "x"}], ")"}]}], ")"}]}]}]}], "}"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"Framed", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Panel", "[", "\[IndentingNewLine]", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Grid", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Item", "[", 
              RowBox[{
               RowBox[{"Style", "[", 
                RowBox[{
                "\"\<Integration by substitution\>\"", ",", 
                 "\"\<Subsection\>\""}], "]"}], ",", 
               RowBox[{"Alignment", "\[Rule]", " ", "Center"}]}], "]"}], ",", 
             "SpanFromLeft", ",", "SpanFromLeft", ",", "SpanFromLeft"}], 
            "}"}], ",", "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Integrand\>\"", ",", "\"\<Text\>\""}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{"Dynamic", "[", "intgrnd", "]"}], "]"}], ",", 
             "SpanFromLeft", ",", "SpanFromLeft"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Variable\>\"", ",", "\"\<Text\>\""}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{"Dynamic", "[", "var", "]"}], "]"}], ",", 
             "SpanFromLeft", ",", "SpanFromLeft"}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"Style", "[", 
              RowBox[{"\"\<Expression\>\"", ",", "\"\<Text\>\""}], "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "expr", "]"}], ",", 
               RowBox[{"FieldSize", "\[Rule]", "6"}]}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{"\"\<\[Rule]\>\"", ",", "\"\<Subsubsection\>\""}], 
              "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{"Dynamic", "[", "newvar", "]"}], "]"}]}], "}"}], ",", 
           "\[IndentingNewLine]", 
           RowBox[{"{", 
            RowBox[{
             RowBox[{"StringForm", "[", 
              RowBox[{"\"\<\[DifferentialD]`1`\[Rule]\>\"", ",", "var"}], 
              "]"}], ",", 
             RowBox[{"InputField", "[", 
              RowBox[{
               RowBox[{"Dynamic", "[", "coef", "]"}], ",", 
               RowBox[{"FieldSize", "\[Rule]", " ", "6"}]}], "]"}], ",", 
             RowBox[{"Style", "[", 
              RowBox[{
               RowBox[{"StringForm", "[", 
                RowBox[{"\"\<\[DifferentialD]`1`\>\"", ",", "newvar"}], "]"}],
                ",", "\"\<Text\>\""}], "]"}], ",", "SpanFromLeft"}], "}"}]}], 
          "}"}], ",", "\[IndentingNewLine]", "\[IndentingNewLine]", 
         RowBox[{"Alignment", "\[Rule]", " ", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Right", ",", 
              RowBox[{"{", "Left", "}"}]}], "}"}], ",", "Automatic"}], 
           "}"}]}]}], "]"}], ",", 
       RowBox[{"Background", "\[Rule]", " ", "LightBrown"}]}], "]"}], ",", 
     "\[IndentingNewLine]", "\[IndentingNewLine]", 
     RowBox[{"RoundingRadius", "\[Rule]", " ", "8"}], ",", 
     RowBox[{"FrameStyle", "\[Rule]", " ", 
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"AbsoluteThickness", "[", "18", "]"}], ",", "Brown"}], 
       "]"}]}], ",", 
     RowBox[{"Background", "\[Rule]", " ", "Brown"}]}], "]"}], ",", 
   "\[IndentingNewLine]", "\[IndentingNewLine]", 
   RowBox[{"ClassroomUtilities`SubstituteIntegrate", "[", 
    RowBox[{"intgrnd", ",", "var", ",", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"expr", "\[Rule]", " ", "newvar"}], ",", 
       RowBox[{
        RowBox[{"\[DifferentialD]", "var"}], "\[Rule]", " ", 
        RowBox[{"coef", " ", 
         RowBox[{"\[DifferentialD]", "newvar"}]}]}]}], "}"}]}], "]"}]}], 
  "\[IndentingNewLine]", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->827414588],

Cell[BoxData[
 TagBox[
  DynamicModuleBox[{$CellContext`intgrnd$$ = $CellContext`x (
     1 - $CellContext`x^2)^
    Rational[1, 2], $CellContext`var$$ = $CellContext`x, $CellContext`expr$$ =
    1 - $CellContext`x^2, $CellContext`newvar$$ = $CellContext`u, \
$CellContext`coef$$ = Rational[-1, 2]/$CellContext`x}, 
   InterpretationBox[
    FrameBox[
     PanelBox[
      TagBox[GridBox[{
         {
          ItemBox[
           StyleBox["\<\"Integration by substitution\"\>", "Subsection",
            StripOnInput->False],
           Alignment->Center,
           StripOnInput->False], "\[SpanFromLeft]", "\[SpanFromLeft]", 
          "\[SpanFromLeft]"},
         {
          StyleBox["\<\"Integrand\"\>", "Text",
           StripOnInput->False], 
          InputFieldBox[Dynamic[$CellContext`intgrnd$$]], "\[SpanFromLeft]", 
          "\[SpanFromLeft]"},
         {
          StyleBox["\<\"Variable\"\>", "Text",
           StripOnInput->False], 
          InputFieldBox[Dynamic[$CellContext`var$$]], "\[SpanFromLeft]", 
          "\[SpanFromLeft]"},
         {
          StyleBox["\<\"Expression\"\>", "Text",
           StripOnInput->False], 
          InputFieldBox[Dynamic[$CellContext`expr$$],
           FieldSize->6], 
          StyleBox["\<\"\[Rule]\"\>", "Subsubsection",
           StripOnInput->False], 
          InputFieldBox[Dynamic[$CellContext`newvar$$]]},
         {
          InterpretationBox["\<\"\[DifferentialD]\\!\\(x\\)\[Rule]\"\>",
           StringForm["\[DifferentialD]`1`\[Rule]", $CellContext`x],
           Editable->False], 
          InputFieldBox[Dynamic[$CellContext`coef$$],
           FieldSize->6], 
          StyleBox[
           InterpretationBox["\<\"\[DifferentialD]\\!\\(u\\)\"\>",
            StringForm["\[DifferentialD]`1`", $CellContext`u],
            Editable->False], "Text",
           StripOnInput->False], "\[SpanFromLeft]"}
        },
        AutoDelete->False,
        GridBoxAlignment->{
         "Columns" -> {Right, {Left}}, "Rows" -> {{Automatic}}},
        GridBoxItemSize->{
         "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
       "Grid"],
      Background->RGBColor[0.94, 0.91, 0.88]],
     Background->RGBColor[0.6, 0.4, 0.2],
     FrameStyle->Directive[
       AbsoluteThickness[18], 
       RGBColor[0.6, 0.4, 0.2]],
     RoundingRadius->8,
     StripOnInput->False],
    ClassroomUtilities`SubstituteIntegrate[$CellContext`intgrnd$$, \
$CellContext`var$$, {$CellContext`expr$$ -> $CellContext`newvar$$, 
      DifferentialD[$CellContext`var$$] -> $CellContext`coef$$ 
       DifferentialD[$CellContext`newvar$$]}]],
   DynamicModuleValues:>{}],
  Setting[#, {0}]& ]], "Output",
 ImageSize->{445, 184},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1400366191]
}, Open  ]],

Cell[TextData[{
 "The output of the Interpretation function is an input cell that can be \
evaluated after the input fields have been appropriately updated. The cell \
can be copied and used in other notebooks without including the input that \
constructed it. For an example of a notebook intended for use in the \
classroom see the tutorial ",
 ButtonBox["Integrate By Substitution",
  BaseStyle->"Link",
  ButtonData->"paclet:Classroom Utilities/tutorial/IntegrateBySubstitution"]
}], "ExampleText",
 CellID->1681284664]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 Cell[BoxData[
  StyleBox[
   ButtonBox["AutoSimplify",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/AutoSimplify"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["PartsIntegrate",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/PartsIntegrate"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " "
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Using Integration Techniques Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/UsingIntegrationTechniquesFunctions"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->362528783],

Cell[TextData[ButtonBox["Integration Techniques",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/IntegrationTechniques"]], "MoreAbout",
 CellID->188255976]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"SubstituteIntegrate - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 31, 15.7348624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "SubstituteIntegrate[intgrnd, x, {expr -> u, \\[DifferentialD]x -> coef \
\\[DifferentialD]u}] uses substitution to convert intgrnd to a recognizable \
integral.", "synonyms" -> {}, "title" -> "SubstituteIntegrate", 
    "titlemodifier" -> "", "windowtitle" -> "SubstituteIntegrate", "type" -> 
    "Symbol", "uri" -> "ClassroomUtilities/ref/SubstituteIntegrate"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[6158, 178, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->341704290]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 22870, 684}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[612, 21, 3547, 84, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4184, 109, 62, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[4249, 112, 986, 29, 85, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5272, 146, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->488128044],
Cell[5884, 166, 139, 4, 70, "Notes",
 CellID->1067943069],
Cell[6026, 172, 95, 1, 70, "Notes",
 CellID->1673958400]
}, Closed]],
Cell[CellGroupData[{
Cell[6158, 178, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->341704290],
Cell[CellGroupData[{
Cell[6673, 196, 194, 6, 31, "ExampleSection",
 CellID->38424508],
Cell[6870, 204, 126, 3, 28, "Input",
 CellID->35569453],
Cell[6999, 209, 92, 1, 32, "ExampleText",
 CellID->815342705],
Cell[CellGroupData[{
Cell[7116, 214, 602, 19, 44, "Input",
 CellID->371691428],
Cell[7721, 235, 237, 8, 49, "Output",
 CellID->914364431]
}, Open  ]],
Cell[7973, 246, 77, 1, 32, "ExampleText",
 CellID->667641776],
Cell[CellGroupData[{
Cell[8075, 251, 149, 5, 40, "Input",
 CellID->453273657],
Cell[8227, 258, 202, 7, 56, "Output",
 CellID->330013885]
}, Open  ]],
Cell[8444, 268, 114, 3, 70, "ExampleText",
 CellID->569822335],
Cell[CellGroupData[{
Cell[8583, 275, 332, 12, 70, "Input",
 CellID->1374402372],
Cell[8918, 289, 385, 14, 68, "Output",
 CellID->67862972]
}, Open  ]],
Cell[9318, 306, 128, 3, 70, "Input",
 CellID->2112548305],
Cell[9449, 311, 665, 19, 70, "ExampleText",
 CellID->890960227],
Cell[10117, 332, 116, 3, 70, "ExampleText",
 CellID->1252226284],
Cell[CellGroupData[{
Cell[10258, 339, 4765, 116, 70, "Input",
 CellID->827414588],
Cell[15026, 457, 2795, 71, 70, "Output",
 CellID->1400366191]
}, Open  ]],
Cell[17836, 531, 523, 10, 70, "ExampleText",
 CellID->1681284664]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[18408, 547, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[18857, 562, 443, 16, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[19337, 583, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[19788, 598, 212, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[20037, 608, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[20488, 623, 171, 4, 70, "MoreAbout",
 CellID->362528783],
Cell[20662, 629, 177, 4, 70, "MoreAbout",
 CellID->188255976]
}, Open  ]],
Cell[20854, 636, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

