(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     41144,       1067]
NotebookOptionsPosition[     35962,        900]
NotebookOutlinePosition[     38426,        966]
CellTagsIndexPosition[     38306,        960]
WindowTitle->TangentLine - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Calculus and Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/CalculusandAnalyticGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/TangentLine\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/TangentLine"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/TangentLine.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/TangentLine", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["TangentLine", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TangentLine", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        StyleBox["x", "TI"], ",", 
        SubscriptBox[
         StyleBox["x", "TI"], 
         StyleBox["0", "TR"]]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]create an expression for the tangent line to ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " at ",
     Cell[BoxData[
      RowBox[{
       StyleBox["x", "TI"], "=", 
       SubscriptBox[
        StyleBox["x", "TI"], 
        StyleBox["0", "TR"]]}]], "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TangentLine", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        StyleBox["x", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["2", "TR"]], ",", 
          StyleBox["\[Ellipsis]", "TR"]}], "}"}]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]creates a list of tangent lines at the points ",
     Cell[BoxData[
      RowBox[{
       SubscriptBox[
        StyleBox["x", "TI"], 
        StyleBox["1", "TR"]], ",", " ", 
       SubscriptBox[
        StyleBox["x", "TI"], 
        StyleBox["2", "TR"]]}]], "InlineFormula"],
     ", etc."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->11471416],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->90824782],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1495270996],

Cell[TextData[{
 "Create and expression for the tangent line to ",
 Cell[BoxData[
  SuperscriptBox[
   StyleBox["x", "TI"], "4"]], "InlineFormula"],
 " at ",
 Cell[BoxData[
  RowBox[{
   StyleBox["x", "TI"], "=", " ", 
   StyleBox["a", "TI"]}]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->1165992578],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TangentLine", "[", 
  RowBox[{
   SuperscriptBox["x", "4"], ",", "x", ",", "a"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1048979571],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["a", "3"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "3"}], " ", "a"}], "+", 
    RowBox[{"4", " ", "x"}]}], ")"}]}]], "Output",
 ImageSize->{89, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1506391574]
}, Open  ]],

Cell[TextData[{
 "Create the expression for the tangent line to ",
 Cell[BoxData[
  SuperscriptBox["x", "4"]], "InlineFormula"],
 "at x = .4."
}], "ExampleText",
 CellID->1238469735],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TangentLine", "[", 
  RowBox[{
   SuperscriptBox["x", "4"], ",", "x", ",", ".4"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1549329421],

Cell[BoxData[
 RowBox[{
  RowBox[{"-", "0.07680000000000002`"}], "+", 
  RowBox[{"0.25600000000000006`", " ", "x"}]}]], "Output",
 ImageSize->{112, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1340358872]
}, Open  ]],

Cell[TextData[{
 "Visualize the result using the ",
 ButtonBox["Plot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Plot"],
 " function and insert output from above."
}], "ExampleText",
 CellID->308104674],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SuperscriptBox["x", "4"], ",", 
     RowBox[{
      RowBox[{"-", "0.07680000000000002`"}], "+", 
      RowBox[{"0.25600000000000006`", " ", "x"}]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->732183001],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS2T4zgQhqfq/sTS+wkHhwYODAxcVx0JOGBoKihoKGpodoKihoaCpoaG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    "], {{0, 102}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 102},
  PlotRange->{{0, 180}, {0, 102}}]], "Output",
 ImageSize->{184, 102},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->140780522]
}, Open  ]],

Cell["Construct several tangent lines together.", "ExampleText",
 CellID->262830493],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TangentLine", "[", 
  RowBox[{
   SuperscriptBox["x", "3"], ",", "x", ",", 
   RowBox[{"Range", "[", 
    RowBox[{"0", ",", "1", ",", 
     RowBox[{"1", "/", "5"}]}], "]"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->18233972],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"0", ",", 
   RowBox[{
    FractionBox["1", "125"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", 
      RowBox[{"15", " ", "x"}]}], ")"}]}], ",", 
   RowBox[{
    FractionBox["4", "125"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "4"}], "+", 
      RowBox[{"15", " ", "x"}]}], ")"}]}], ",", 
   RowBox[{
    FractionBox["27", "125"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "2"}], "+", 
      RowBox[{"5", " ", "x"}]}], ")"}]}], ",", 
   RowBox[{
    FractionBox["16", "125"], " ", 
    RowBox[{"(", 
     RowBox[{
      RowBox[{"-", "8"}], "+", 
      RowBox[{"15", " ", "x"}]}], ")"}]}], ",", 
   RowBox[{
    RowBox[{"-", "2"}], "+", 
    RowBox[{"3", " ", "x"}]}]}], "}"}]], "Output",
 ImageSize->{495, 32},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->742909996]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Interactive Examples",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1653164318],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AnalyticGeometry`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->250947944],

Cell["Create a Manipulate with a moving tangent line.", "ExampleText",
 CellID->24212100],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{" ", 
  RowBox[{"TangentLine", "[", 
   RowBox[{
    SuperscriptBox["x", "4"], ",", "x", ",", "a"}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1058355417],

Cell[BoxData[
 RowBox[{
  SuperscriptBox["a", "3"], " ", 
  RowBox[{"(", 
   RowBox[{
    RowBox[{
     RowBox[{"-", "3"}], " ", "a"}], "+", 
    RowBox[{"4", " ", "x"}]}], ")"}]}]], "Output",
 ImageSize->{89, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1844997146]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Plot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox["x", "4"], ",", 
       RowBox[{
        SuperscriptBox["a", "3"], " ", 
        RowBox[{"(", 
         RowBox[{
          RowBox[{
           RowBox[{"-", "3"}], " ", "a"}], "+", 
          RowBox[{"4", " ", "x"}]}], ")"}]}]}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", " ", "1"}], ",", 
     RowBox[{"AspectRatio", "\[Rule]", " ", "Automatic"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"a", ",", ".3"}], "}"}], ",", "0", ",", "1"}], "}"}]}], 
  "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1334700523],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`a$$ = 0.63, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`a$$], 0.3}, 0, 1}}, Typeset`size$$ = {
    132., {106., 110.}}, Typeset`update$$ = 0, Typeset`initDone$$, 
    Typeset`skipInitDone$$ = True, $CellContext`a$4726$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`a$$ = 0.3}, 
      "ControllerVariables" :> {
        Hold[$CellContext`a$$, $CellContext`a$4726$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> 
      Plot[{$CellContext`x^4, $CellContext`a$$^3 ((-3) $CellContext`a$$ + 
          4 $CellContext`x)}, {$CellContext`x, 0, 1}, PlotRange -> 1, 
        AspectRatio -> Automatic], 
      "Specifications" :> {{{$CellContext`a$$, 0.3}, 0, 1}}, "Options" :> {}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{410., {136., 141.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 ImageSize->{414, 279},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->883233020]
}, Open  ]],

Cell[BoxData[""], "Input",
 CellLabel->"In[4]:=",
 CellID->1090399076]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Neat Examples",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->589267740],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<AnalyticGeometry`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->999839922],

Cell["Construct an envelope of tangent lines for a parabola.", "ExampleText",
 CellID->4760108],

Cell[BoxData[
 RowBox[{
  RowBox[{"tanLns", "=", 
   RowBox[{"TangentLine", "[", 
    RowBox[{
     SuperscriptBox["x", "2"], ",", "x", ",", 
     RowBox[{"Range", "[", 
      RowBox[{
       RowBox[{"-", "2"}], ",", "2", ",", ".05"}], "]"}]}], "]"}]}], 
  ";"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1859310481],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Plot", "[", 
  RowBox[{"tanLns", ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "2"}], ",", "2"}], "}"}], ",", 
   RowBox[{"AspectRatio", "\[Rule]", " ", "Automatic"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", ".3"}], ",", "2"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->305257333],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztfa175D6y9T7P+w9cuHThwguHGhoKCl5BgQsERQUFC4oKir2CpoaGhqaG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    "], {{0, 107}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 107},
  PlotRange->{{0, 180}, {0, 107}}]], "Output",
 ImageSize->{184, 107},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->145936073]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Calculus and Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/CalculusandAnalyticGeometry"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->314638212]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"TangentLine - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 31, 23.7064624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "TangentLine[f, x, x_0] create an expression for the tangent line to f at \
x = x_0.TangentLine[f, x, {x_1, x_2, ...}] creates a list of tangent lines at \
the points x_1, x_2, etc.", "synonyms" -> {}, "title" -> "TangentLine", 
    "titlemodifier" -> "", "windowtitle" -> "TangentLine", "type" -> "Symbol",
     "uri" -> "ClassroomUtilities/ref/TangentLine"}, "SearchTextTranslated" -> 
  ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[5111, 150, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->11471416]},
 "RasterizedOutput"->{
  Cell[8052, 272, 3276, 62, 123, "Output",
   CellTags->"RasterizedOutput",
   CellID->140780522],
  Cell[17646, 559, 16907, 285, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->145936073]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 37940, 946},
 {"RasterizedOutput", 38082, 950}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 2777, 64, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3406, 89, 54, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3463, 92, 1611, 53, 146, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[5111, 150, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->11471416],
Cell[CellGroupData[{
Cell[5625, 168, 194, 6, 31, "ExampleSection",
 CellID->90824782],
Cell[5822, 176, 128, 3, 28, "Input",
 CellID->1495270996],
Cell[5953, 181, 308, 12, 34, "ExampleText",
 CellID->1165992578],
Cell[CellGroupData[{
Cell[6286, 197, 166, 5, 30, "Input",
 CellID->1048979571],
Cell[6455, 204, 323, 12, 36, "Output",
 CellID->1506391574]
}, Open  ]],
Cell[6793, 219, 182, 6, 34, "ExampleText",
 CellID->1238469735],
Cell[CellGroupData[{
Cell[7000, 229, 167, 5, 30, "Input",
 CellID->1549329421],
Cell[7170, 236, 261, 8, 36, "Output",
 CellID->1340358872]
}, Open  ]],
Cell[7446, 247, 207, 7, 32, "ExampleText",
 CellID->308104674],
Cell[CellGroupData[{
Cell[7678, 258, 371, 12, 30, "Input",
 CellID->732183001],
Cell[8052, 272, 3276, 62, 123, "Output",
 CellTags->"RasterizedOutput",
 CellID->140780522]
}, Open  ]],
Cell[11343, 337, 84, 1, 70, "ExampleText",
 CellID->262830493],
Cell[CellGroupData[{
Cell[11452, 342, 258, 8, 70, "Input",
 CellID->18233972],
Cell[11713, 352, 914, 34, 53, "Output",
 CellID->742909996]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[12676, 392, 283, 8, 70, "ExampleSection",
 CellID->1653164318],
Cell[12962, 402, 125, 3, 70, "Input",
 CellID->250947944],
Cell[13090, 407, 89, 1, 70, "ExampleText",
 CellID->24212100],
Cell[CellGroupData[{
Cell[13204, 412, 186, 6, 70, "Input",
 CellID->1058355417],
Cell[13393, 420, 323, 12, 36, "Output",
 CellID->1844997146]
}, Open  ]],
Cell[CellGroupData[{
Cell[13753, 437, 774, 25, 70, "Input",
 CellID->1334700523],
Cell[14530, 464, 1747, 38, 70, "Output",
 CellID->883233020]
}, Open  ]],
Cell[16292, 505, 70, 2, 70, "Input",
 CellID->1090399076]
}, Closed]],
Cell[CellGroupData[{
Cell[16399, 512, 275, 8, 70, "ExampleSection",
 CellID->589267740],
Cell[16677, 522, 125, 3, 70, "Input",
 CellID->999839922],
Cell[16805, 527, 95, 1, 70, "ExampleText",
 CellID->4760108],
Cell[16903, 530, 317, 11, 70, "Input",
 CellID->1859310481],
Cell[CellGroupData[{
Cell[17245, 545, 398, 12, 70, "Input",
 CellID->305257333],
Cell[17646, 559, 16907, 285, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->145936073]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[34614, 851, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[35065, 866, 196, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[35298, 876, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[35749, 891, 171, 4, 70, "MoreAbout",
 CellID->314638212]
}, Open  ]],
Cell[35935, 898, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

