(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    104844,       2363]
NotebookOptionsPosition[     96718,       2102]
NotebookOutlinePosition[    100055,       2189]
CellTagsIndexPosition[     99933,       2183]
WindowTitle->TangentLinePlot - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Calculus and Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/CalculusandAnalyticGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"See Also \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Plot\"\>":>Documentation`HelpLookup[
       "paclet:ref/Plot"], "\<\"TangentLine\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/TangentLine"], "\<\"SecantLine\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/SecantLine"], "\<\"SecantLinePlot\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/ref/SecantLinePlot"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"SeeAlsoSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/TangentLinePlot\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/TangentLinePlot"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/TangentLinePlot.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/TangentLinePlot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["TangentLinePlot", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TangentLinePlot", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["pos", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]creates a plot of ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " on the interval ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["min", "TI"]]], "InlineFormula"],
     " to ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["max", "TI"]]], "InlineFormula"],
     " together with a tangent line at ",
     Cell[BoxData[
      RowBox[{
       StyleBox["x", "TI"], "=", 
       StyleBox["pos", "TI"]}]], "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TangentLinePlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          StyleBox["f", "TI"], ",", 
          StyleBox["n", "TI"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}]}]}]], "InlineFormula"],
     ",",
     Cell[BoxData[
      StyleBox["pos", "TI"]], "InlineFormula"],
     "]\[LineSeparator]creates a plot of ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " together with the first ",
     Cell[BoxData[
      StyleBox["n", "TI"]], "InlineFormula"],
     " derivatives of ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " and a tangent line to ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " at ",
     Cell[BoxData[
      StyleBox["pos", "TI"]], "InlineFormula"],
     "."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TangentLinePlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          StyleBox["f", "TI"], ",", 
          RowBox[{"{", 
           RowBox[{
            SubscriptBox[
             StyleBox["n", "TI"], 
             StyleBox["1", "TR"]], ",", 
            SubscriptBox[
             StyleBox["n", "TI"], 
             StyleBox["2", "TR"]], ",", 
            StyleBox["\[Ellipsis]", "TR"]}], "}"}]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["pos", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]creates a plot of ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " together with the ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["n", "TI"], 
       StyleBox["i", "TI"]]], "InlineFormula"],
     " derivatives of ",
     Cell[BoxData[
      RowBox[{
       StyleBox["f", "TI"], " "}]], "InlineFormula"],
     "and the tangent to ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " at ",
     Cell[BoxData[
      StyleBox["pos", "TI"]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->344891119],

Cell["\<\
The position specification can be a single number or a list of numbers.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
If the positions are specified by a list of numbers multiple tangents will be \
drawn.\
\>", "Notes",
 CellID->618379114],

Cell[TextData[{
 "Any options that can be used with ",
 ButtonBox["Plot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Plot"],
 " will work with TangentLinePlot."
}], "Notes",
 CellID->1660408279]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->855659435],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->64361279],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1725166273],

Cell["Visualize the tangent to x Cos[x] at x =3.2", "ExampleText",
 CellID->1867827298],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TangentLinePlot", "[", 
  RowBox[{
   RowBox[{"x", " ", 
    RowBox[{"Cos", "[", "x", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", "3.2"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->657445640],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztna2zq0gTh0/V/hOvXbly5dorIyMjF3nEKyIj1kRGRsYikUgsEkmtwkYi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    "], {{0, 216}, {127, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{127, 216},
  PlotRange->{{0, 127}, {0, 216}}]], "Output",
 ImageSize->{131, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->50301144]
}, Open  ]],

Cell["Include plots of the first and second derivatives.", "ExampleText",
 CellID->665651945],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TangentLinePlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", " ", 
      RowBox[{"Cos", "[", "x", "]"}]}], ",", "2"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", "3.2"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1369922392],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztXSu3s0gW/daaX9JyfkLbKyMjIzsyYgRqViwSGYlFIpFYJJI1CotEIplT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    "], {{0, 216}, {121, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{121, 216},
  PlotRange->{{0, 121}, {0, 216}}]], "Output",
 ImageSize->{125, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->52829034]
}, Open  ]],

Cell["Include only the sedond derivative.", "ExampleText",
 CellID->836124066],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TangentLinePlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", " ", 
      RowBox[{"Cos", "[", "x", "]"}]}], ",", 
     RowBox[{"{", "2", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", "3.2"}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->797737641],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS2TtDoWx5+q/SRX7ke4dmTLli1vyxYrUFttkciWWCQyEotEUquwSCSS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    "], {{0, 216}, {121, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{121, 216},
  PlotRange->{{0, 121}, {0, 216}}]], "Output",
 ImageSize->{125, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->200892479]
}, Open  ]],

Cell["\<\
Draw the function, first derivative and several tangent lines.\
\>", "ExampleText",
 CellID->1065456919],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TangentLinePlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     RowBox[{"x", " ", 
      RowBox[{"Cos", "[", "x", "]"}]}], ",", 
     RowBox[{"{", "1", "}"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", 
     RowBox[{"2", " ", "\[Pi]"}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"1.8", ",", "3.2", ",", "4.6"}], "}"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", " ", "5"}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1415788947],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztXa2TrMqTvRH7lzy58slrR7ZEIn9IxAokFolEbWBLlixZFlmyYhUWiUSy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    "], {{0, 216}, {154, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{154, 216},
  PlotRange->{{0, 154}, {0, 216}}]], "Output",
 ImageSize->{158, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[5]=",
 CellID->319012611]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->2061341341],

Cell[CellGroupData[{

Cell[TextData[{
 "PointStyle",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1757724783],

Cell[TextData[{
 "The option ",
 Cell[BoxData[
  ButtonBox["PointStyle",
   BaseStyle->"Link",
   ButtonData->"paclet:AnalyticGeometry/ref/PointStyle"]], "InlineFormula"],
 " can be used to set the size and color of the tangent points."
}], "ExampleText",
 CellID->1210218905],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1331515598],

Cell["Use large purple points for the tangent points.", "ExampleText",
 CellID->2003053846],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TangentLinePlot", "[", 
  RowBox[{
   SuperscriptBox["x", "4"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", ".5", ",", 
   RowBox[{"PointStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"PointSize", "[", "Large", "]"}], ",", "Purple"}], "}"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1372339350],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnaGXozoUh3vOM0+uXPv+hCfHVo6sRC6y4glkLZLzFBKLxL1ILBIZiUUi
kX2h0JalDS0hIbfw+87s7B6mJ5vpfHNzE5LLX7/+Ofz6Y7fb/Sv+/Cf+NP8+
60BXO2B97C7Y7gWgCMQAMuAGTU6n1HYX4AZFqqp2nMR2L+AGRZKER1Fuuxdw
gyLHIyuKynYv4AY5iAwoZ8xh6UFkQDkjbtDDdZOyrG33ogFukEJYIdyw3YsO
uEGKOOJJzM21z9wmhfgKnvwXPPgafAlukOJwiEUuaqp1YYbLLn8P7RBiPAoD
N+jAeeV5BpdDhQAXNR7kaENGQ/f1FrhBhzDMGDM7oDx14xY0xAswptBEDChG
25fFDdn13RWjvQIvybLSN31/TZZvXOPFXZILsIIIvp8JPUz/L7/PU/qDzGO6
ATdIUNfGBxQF4AYF6KyT94EbFHBdEjdeB8AN6wgrjkf2+nWLAzesEwQZY4Xt
XjwBE1jrOIekJnHfdQjEsEuaFmL2arsXz4EbdvE8xjm5LLQFblhEZKGuSzEL
bYEbFomiPEkM3lybCdywCMG10D5wwxaM8TAktxbaB27Y4khyLbQP1jesQGrP
sAyIYQXfz9KU4lpoH7ixPHV9JnJybRy4sTxxzGN6d+QfgRvLQ/YGygC4sTDN
Nh7aU9cbcGNhiNRPeAfMYZckz0oKxZreBGIsyQcFjTPcWBDid10fgRuL4fvp
AidQxhk5Rz88uQQ3lqIoCCySy8/Rd9bADRuIFDTPLQcN6Tn65oLLEDdsQKS8
m+wc/cUMjCl2ILK/SxI37tU3Huv2YInDKITOuo7lG4gbFgjDnM7RJNk5+ga4
sSxEMg014IZRiGQaasANc3zExr8R4IY5KKxpzAFuGKKpnPBRd08ewQTWEMvU
7zIKxDCBGEo877ODxhlumIHOswzmADe0cznMSLSkxiTghnYcJzFYr35B4IZe
wvCDF7sGwA2NiBxjyYp/VVGmp7jMTKkINzTiHRcq0HSxImJuWOYGYxTWN3SR
pkVgvqpbY4Ufs6Owwvi9XYihC9MpaF1UXawwNogMgBtaMLpJo+Jl5seJGywQ
K/rAjfmIHMNQClrxQgwf4qNYKlb0gRvzcZvRRHObXbbphSJoaG76beDGTLTv
3rnnFcuOII/AjTkUWkcTESus5BUyMIdVpq6b555omZvcYoWVvEIGxFAmCDTU
c2vXK+jEij5wQ435K13Lr1dMBW4oMHOTsMW8QnKOvnvM4+A63FBAeeuO5bxC
cq6NBwHrvvzbdbgxFbXd4xTyipFz9Odnl+HGJOJ48sM6K14yj0ReIT1Hf/s6
zjyqIsLFpEpuJS9SYYUXVTTmIONx4zqy3ME5+jcpisrz0jdrxrZ5hRCD1sxU
fo5eaHO5xILfayws3MFPpKpq7/jWMheFvGKEp+fou1nKwxPp4cY7iIjxckMX
/fWKqcCNl/h+Nj4xoXYfRBdwY5zxhz7TvA+iC7gxwsgdE+J5hRbghgxZxFhf
XiEDE9inPI0Ya80rZECMRx4jxrrzChlwY8DgKXtbyCtkwI0bdd08wyLLOge2
k1fIgBstTQmm68NNtpZXyIAbgpQVQoyyrLeZV8iAGyLzFB8VLzabV8jYshvt
1j4WZc3ZMS/abF4hY7PrG0nCj06cnuJmf4W9s2OU2aAYZVmd3CRyQuQV46zZ
jerMXBbv48RJqry7w56EWXgIYgd5xWvW6kZd1sGPwN/5t480yPy9Hx185BVv
slY3RKzoi9F8/PCL2cfQNsVa3Qh/hkM3dr7tTn0Yq3Xj72ggRvAzsN2pD2Nl
c9i6PrM4F3lF+DUMGnkw7VwJWI0YWVYGJxZ8B9G3z9Mm2+Qx79LRPyGGCp/u
Rp6Vvp8531E7M8V6hUY+0Y2yrBkrTqf0cIh9jyXHCPdBTPApbhRFlSRchIjD
d+w6SRBkOeMb319hGnNuzGm5qmrOqzjOhQPHI9vvI/E5ivIsLUS2if0VyzDp
J6j3xa0APC9FGileLGKCd2Sum3x9RY6TiH/HMRdjR7vfpqXdXyFebCiveNpn
Ld+1oZaNhn3RePMD4uXlc/tRXi++dV1cFD9E8Ts++NxeD8Pc81LPY+1ncXH/
Fe33sQgFh0PSXvf9VFxP00K01q950v/G+/s2J71L636xCTd2YHWYkER7m7qw
VccbtNB0o9u3aamON2ih5saWz4NQg44bOA9CDV1uTCpcOWB8vULS8oV7BSuN
fe4aftnt6S23rc5ot2vhyfc89i6poseNiYUrb7w+DyIvUdW9H8puvC5+pYqs
5avJ93p9Kjz7fRh7l9TRMv2ZWrjy/HZeMdJyU/FwRtyQtnz95VbWTt7nW32t
GWo8c+Pl+6+GlrgxqXDlpLxC2nLb5Aw3ZC3fgoY02Cn3+Tw31F07OGzg1fuv
iBY33ixcqXAfRNLy/XdbeZCV9Xn+7+BY3OjK8s35AX5Y3Hg5dtdF7O59lfMg
4yPpnFxU1vL1R6fe9kjLl+vz8plF8w0t7bwsXOkEiusVT1vu0DlP6QfmOenG
SMu3cKfe9O8Tv2GfKc5TnoH1ik/HhBvYX7EO9LqB+hVrQtftXdwHWR/zxUBe
sVbmuIG8Yt2ouYG8YgtMdQN5xXZ43w3kFVvjHTewb3ObjM9hK140NfSwb3OT
yMSoumcUhqiht1ke3RDZZldvEyPItum70a5XCDEQK9aKwvPosV6xCaY/j17k
FZiDbAGF59HDio2g8Dx6QydtgU36W+6umYTC8+iX6Sywz8Tn0YNNMel59AAA
AAAAI/wPwPqo8g==
    "], {{0, 142}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 142},
  PlotRange->{{0, 180}, {0, 142}}]], "Output",
 ImageSize->{184, 142},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->681301248]
}, Open  ]],

Cell["Set only the color of the tangent point.", "ExampleText",
 CellID->1462072296],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TangentLinePlot", "[", 
  RowBox[{
   SuperscriptBox["x", "3"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", ".6", ",", 
   RowBox[{"PointStyle", "\[Rule]", " ", "Orange"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1541189898],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnauXo8oWh3ut+09ce+TII8eObBkZeZARV0TGRiKRWCSyJBZZknUVFolE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    "], {{0, 216}, {173, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{173, 216},
  PlotRange->{{0, 173}, {0, 216}}]], "Output",
 ImageSize->{177, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->141217559]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Applications",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->258228157],

Cell["Visualize a tangent at a point of inflection.", "ExampleText",
 CellID->808215095],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"der2", "=", " ", 
  RowBox[{"D", "[", 
   RowBox[{
    RowBox[{"x", " ", 
     RowBox[{"Cos", "[", "x", "]"}]}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "2"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[1]:=",
 CellID->837034390],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"-", "x"}], " ", 
   RowBox[{"Cos", "[", "x", "]"}]}], "-", 
  RowBox[{"2", " ", 
   RowBox[{"Sin", "[", "x", "]"}]}]}]], "Output",
 ImageSize->{129, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->2019104880]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"derSol", "=", 
  RowBox[{"FindRoot", "[", 
   RowBox[{
    RowBox[{"der2", "\[Equal]", "0"}], ",", 
    RowBox[{"{", 
     RowBox[{"x", ",", "3"}], "}"}]}], "]"}]}]], "Input",
 CellLabel->"In[2]:=",
 CellID->559128266],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"x", "\[Rule]", "2.2889297281034042`"}], "}"}]], "Output",
 ImageSize->{91, 15},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->2068089984]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TangentLinePlot", "[", 
  RowBox[{
   RowBox[{"x", " ", 
    RowBox[{"Cos", "[", "x", "]"}]}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "1", ",", "4"}], "}"}], ",", 
   RowBox[{"x", "/.", "derSol"}], ",", 
   RowBox[{"PlotRange", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"-", "3.5"}], ",", "2"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1365534393],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnSGXszgUhuec/SX7E1aOHVlZiVxkxQokFrEiMhIbGRkZi0TmrMIikUj2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    "], {{0, 216}, {136, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{136, 216},
  PlotRange->{{0, 136}, {0, 216}}]], "Output",
 ImageSize->{140, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->680018745]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Interactive Examples",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1653164318],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1011288783],

Cell["Create a moving tangent line.", "ExampleText",
 CellID->1544993523],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"TangentLinePlot", "[", 
    RowBox[{
     SuperscriptBox["x", "2"], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", "a", ",", 
     RowBox[{"PlotRange", "\[Rule]", " ", "1"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1481365184],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`a$$ = -0.365, Typeset`show$$ = True, 
    Typeset`bookmarkList$$ = {}, Typeset`bookmarkMode$$ = "Menu", 
    Typeset`animator$$, Typeset`animvar$$ = 1, Typeset`name$$ = 
    "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`a$$], -1, 1}}, Typeset`size$$ = {180., {85., 90.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`a$5636$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`a$$ = -1}, 
      "ControllerVariables" :> {
        Hold[$CellContext`a$$, $CellContext`a$5636$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> 
      ClassroomUtilities`TangentLinePlot[$CellContext`x^2, {$CellContext`x, \
-1, 1}, $CellContext`a$$, PlotRange -> 1], 
      "Specifications" :> {{$CellContext`a$$, -1, 1}}, "Options" :> {}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{458., {116., 121.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 ImageSize->{462, 239},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->591750164]
}, Open  ]],

Cell["Include a plot of the derivative.", "ExampleText",
 CellID->341548809],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"TangentLinePlot", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       SuperscriptBox["x", "2"], ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", 
       RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", "a", ",", 
     RowBox[{"PlotRange", "\[Rule]", " ", "1"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"a", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->187044432],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`a$$ = -0.42000000000000004`, 
    Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`a$$], -1, 1}}, Typeset`size$$ = {180., {85., 90.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`a$5701$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, "Variables" :> {$CellContext`a$$ = -1}, 
      "ControllerVariables" :> {
        Hold[$CellContext`a$$, $CellContext`a$5701$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> 
      ClassroomUtilities`TangentLinePlot[{$CellContext`x^2, 
         1}, {$CellContext`x, -1, 1}, $CellContext`a$$, PlotRange -> 1], 
      "Specifications" :> {{$CellContext`a$$, -1, 1}}, "Options" :> {}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{458., {116., 121.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 ImageSize->{462, 239},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->548237091]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Neat Examples",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->589267740],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1692832164],

Cell[TextData[{
 "Visualize an envelope of tangent lines for the function ",
 Cell[BoxData[
  SuperscriptBox["x", "4"]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->471287617],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TangentLinePlot", "[", 
  RowBox[{
   SuperscriptBox["x", "4"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", 
     RowBox[{"-", "1"}], ",", "1"}], "}"}], ",", 
   RowBox[{"Range", "[", 
    RowBox[{
     RowBox[{"-", "1"}], ",", "1", ",", 
     RowBox[{"1", "/", "50"}]}], "]"}], ",", 
   RowBox[{"PointStyle", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"{", 
      RowBox[{
       RowBox[{"PointSize", "[", "Small", "]"}], ",", "Red"}], "}"}], "}"}]}],
    ",", 
   RowBox[{"PlotRange", "\[Rule]", " ", "1"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1566824892],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzsvS10JLkSNdjnLFn44KMNGw40TZhQUPATFFggKCooKCgqqHMWrKCooGDC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    "], {{0, 176}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 176},
  PlotRange->{{0, 180}, {0, 176}}]], "Output",
 ImageSize->{184, 176},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->265983148]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["SEE ALSO",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "SeeAlsoSection",
 WholeCellGroupOpener->True,
 CellID->1255426704],

Cell[TextData[{
 StyleBox[ButtonBox["Plot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Plot"],
  FontFamily->"Verdana"],
 " . ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["TangentLine",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/TangentLine"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["SecantLine",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/SecantLine"],
   FontFamily->"Verdana"]], "InlineFormula"],
 " . ",
 Cell[BoxData[
  StyleBox[
   ButtonBox["SecantLinePlot",
    BaseStyle->"Link",
    ButtonData->"paclet:ClassroomUtilities/ref/SecantLinePlot"],
   FontFamily->"Verdana"]], "InlineFormula"]
}], "SeeAlso",
 CellID->929782353]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Calculus and Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/CalculusandAnalyticGeometry"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->244938662]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"TangentLinePlot - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 31, 28.5112624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "TangentLinePlot[f, {x, x_min, x_max}, pos] creates a plot of f on the \
interval x_min to x_max together with a tangent line at x = \
pos.TangentLinePlot[{f, n}, {x, x_min, x_max},pos] creates a plot of f \
together with the first n derivatives of f and a tangent line to f at \
pos.TangentLinePlot[{f, {n_1, n_2, ...}}, {x, x_min, x_max}, pos] creates a \
plot of f together with the n_i derivatives of f and the tangent to f at \
pos.", "synonyms" -> {}, "title" -> "TangentLinePlot", "titlemodifier" -> "", 
    "windowtitle" -> "TangentLinePlot", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/TangentLinePlot"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9092, 281, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->855659435]},
 "RasterizedOutput"->{
  Cell[10346, 328, 4446, 81, 237, "Output",
   CellTags->"RasterizedOutput",
   CellID->50301144],
  Cell[15278, 430, 7138, 125, 237, "Output",
   CellTags->"RasterizedOutput",
   CellID->52829034],
  Cell[22912, 577, 6069, 107, 237, "Output",
   CellTags->"RasterizedOutput",
   CellID->200892479],
  Cell[29630, 711, 8359, 145, 237, "Output",
   CellTags->"RasterizedOutput",
   CellID->319012611],
  Cell[39450, 916, 3345, 63, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->681301248],
  Cell[43211, 997, 4675, 85, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->141217559],
  Cell[49878, 1168, 4455, 81, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->680018745],
  Cell[60629, 1443, 33450, 556, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->265983148]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 98965, 2151},
 {"RasterizedOutput", 99108, 2155}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[608, 21, 3537, 81, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[4170, 106, 58, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[4231, 109, 3723, 124, 207, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[7991, 238, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->344891119],
Cell[8603, 258, 117, 3, 70, "Notes",
 CellID->1067943069],
Cell[8723, 263, 131, 4, 70, "Notes",
 CellID->618379114],
Cell[8857, 269, 198, 7, 70, "Notes",
 CellID->1660408279]
}, Closed]],
Cell[CellGroupData[{
Cell[9092, 281, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->855659435],
Cell[CellGroupData[{
Cell[9607, 299, 194, 6, 31, "ExampleSection",
 CellID->64361279],
Cell[9804, 307, 128, 3, 28, "Input",
 CellID->1725166273],
Cell[9935, 312, 87, 1, 32, "ExampleText",
 CellID->1867827298],
Cell[CellGroupData[{
Cell[10047, 317, 296, 9, 28, "Input",
 CellID->657445640],
Cell[10346, 328, 4446, 81, 237, "Output",
 CellTags->"RasterizedOutput",
 CellID->50301144]
}, Open  ]],
Cell[14807, 412, 93, 1, 70, "ExampleText",
 CellID->665651945],
Cell[CellGroupData[{
Cell[14925, 417, 350, 11, 28, "Input",
 CellID->1369922392],
Cell[15278, 430, 7138, 125, 237, "Output",
 CellTags->"RasterizedOutput",
 CellID->52829034]
}, Open  ]],
Cell[22431, 558, 78, 1, 70, "ExampleText",
 CellID->836124066],
Cell[CellGroupData[{
Cell[22534, 563, 375, 12, 28, "Input",
 CellID->797737641],
Cell[22912, 577, 6069, 107, 237, "Output",
 CellTags->"RasterizedOutput",
 CellID->200892479]
}, Open  ]],
Cell[28996, 687, 114, 3, 70, "ExampleText",
 CellID->1065456919],
Cell[CellGroupData[{
Cell[29135, 694, 492, 15, 28, "Input",
 CellID->1415788947],
Cell[29630, 711, 8359, 145, 237, "Output",
 CellTags->"RasterizedOutput",
 CellID->319012611]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[38038, 862, 270, 8, 70, "ExampleSection",
 CellID->2061341341],
Cell[CellGroupData[{
Cell[38333, 874, 198, 6, 70, "ExampleSubsection",
 CellID->1757724783],
Cell[38534, 882, 276, 8, 70, "ExampleText",
 CellID->1210218905],
Cell[38813, 892, 128, 3, 70, "Input",
 CellID->1331515598],
Cell[38944, 897, 91, 1, 70, "ExampleText",
 CellID->2003053846],
Cell[CellGroupData[{
Cell[39060, 902, 387, 12, 70, "Input",
 CellID->1372339350],
Cell[39450, 916, 3345, 63, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->681301248]
}, Open  ]],
Cell[42810, 982, 84, 1, 70, "ExampleText",
 CellID->1462072296],
Cell[CellGroupData[{
Cell[42919, 987, 289, 8, 70, "Input",
 CellID->1541189898],
Cell[43211, 997, 4675, 85, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->141217559]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[47947, 1089, 274, 8, 70, "ExampleSection",
 CellID->258228157],
Cell[48224, 1099, 88, 1, 70, "ExampleText",
 CellID->808215095],
Cell[CellGroupData[{
Cell[48337, 1104, 261, 9, 70, "Input",
 CellID->837034390],
Cell[48601, 1115, 309, 11, 36, "Output",
 CellID->2019104880]
}, Open  ]],
Cell[CellGroupData[{
Cell[48947, 1131, 242, 8, 70, "Input",
 CellID->559128266],
Cell[49192, 1141, 228, 7, 36, "Output",
 CellID->2068089984]
}, Open  ]],
Cell[CellGroupData[{
Cell[49457, 1153, 418, 13, 70, "Input",
 CellID->1365534393],
Cell[49878, 1168, 4455, 81, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->680018745]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[54382, 1255, 283, 8, 70, "ExampleSection",
 CellID->1653164318],
Cell[54668, 1265, 128, 3, 70, "Input",
 CellID->1011288783],
Cell[54799, 1270, 73, 1, 70, "ExampleText",
 CellID->1544993523],
Cell[CellGroupData[{
Cell[54897, 1275, 456, 14, 70, "Input",
 CellID->1481365184],
Cell[55356, 1291, 1673, 37, 70, "Output",
 CellID->591750164]
}, Open  ]],
Cell[57044, 1331, 76, 1, 70, "ExampleText",
 CellID->341548809],
Cell[CellGroupData[{
Cell[57145, 1336, 510, 16, 70, "Input",
 CellID->187044432],
Cell[57658, 1354, 1701, 37, 70, "Output",
 CellID->548237091]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[59408, 1397, 275, 8, 70, "ExampleSection",
 CellID->589267740],
Cell[59686, 1407, 128, 3, 70, "Input",
 CellID->1692832164],
Cell[59817, 1412, 182, 6, 70, "ExampleText",
 CellID->471287617],
Cell[CellGroupData[{
Cell[60024, 1422, 602, 19, 70, "Input",
 CellID->1566824892],
Cell[60629, 1443, 33450, 556, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->265983148]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[94140, 2006, 446, 13, 70, "SeeAlsoSection",
 CellID->1255426704],
Cell[94589, 2021, 744, 27, 70, "SeeAlso",
 CellID->929782353]
}, Open  ]],
Cell[CellGroupData[{
Cell[95370, 2053, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[95821, 2068, 196, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[96054, 2078, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[96505, 2093, 171, 4, 70, "MoreAbout",
 CellID->244938662]
}, Open  ]],
Cell[96691, 2100, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

