(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     30953,        795]
NotebookOptionsPosition[     25992,        642]
NotebookOutlinePosition[     28308,        704]
CellTagsIndexPosition[     28188,        698]
WindowTitle->TenSidedDie - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[Cell[
    BoxData[
     ActionMenuBox[
      FrameBox["\<\"URL \[RightGuillemet]\"\>",
       StripOnInput->False], {"\<\"Classroom Utilities/ref/TenSidedDie\"\>":>
      None, "\<\"Copy Mathematica URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell["Classroom Utilities/ref/TenSidedDie"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; Null], 
      Delimiter, "\<\"Copy web URL\"\>":>
      Module[{DocumentationSearch`Private`nb$}, 
       DocumentationSearch`Private`nb$ = NotebookPut[
          Notebook[{
            Cell[
             BoxData[
              MakeBoxes[
               Hyperlink[
               "http://reference.wolfram.com/mathematica/Classroom \
Utilities/ref/TenSidedDie.html"], StandardForm]], "Input", TextClipboardType -> 
             "PlainText"]}, Visible -> False]]; 
       SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
       FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
       NotebookClose[DocumentationSearch`Private`nb$]; 
       Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
        NotebookLocate[{
          URL[
           StringJoin[
           "http://reference.wolfram.com/mathematica/", 
            "Classroom Utilities/ref/TenSidedDie", ".html"]], None}]}]},
      Appearance->None,
      MenuAppearance->Automatic]],
     LineSpacing->{1.4, 0}]], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["TenSidedDie", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TenSidedDie", "[", "]"}]], "InlineFormula"],
     " \[LineSeparator]gives an image of a ten sided die."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TenSidedDie", "[", "\"\<\!\(\*
StyleBox[\"property\", \"TI\"]\)\>\"", "]"}]], "InlineFormula"],
     "\[LineSeparator]returns the requested property for the ten sided die."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->256126939],

Cell["Basic graphics-related properties include:", "Notes",
 CellID->270166015],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Edges\>\"", Cell[
    "graphics primitives for edges in the polyhedron", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Faces\>\"", Cell[
    "graphics primitives for faces of the polyhedron", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Image\>\"", Cell[
    "complete image of the polyhedron", "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True}}}},
 CellID->25428423],

Cell["Combinatorial properties include:", "Notes",
 CellID->112965608],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<AdjacentFaceIndices\>\"", Cell[
    "lists of indices for adjacent pairs of faces", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<EdgeCount\>\"", Cell[
    "total number of edges", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<EdgeIndices\>\"", Cell[
    "indices specifying the vertices on each edge ", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<FaceCount\>\"", Cell[
    "total number of faces", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<FaceCountRules\>\"", Cell[TextData[{
     "rules for the numbers of ",
     Cell[BoxData[
      StyleBox["n", "TI"]], "InlineFormula"],
     "-sided faces"
    }], "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<FaceIndices\>\"", Cell[
    "lists of indices for the vertices of each face", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<VertexCount\>\"", Cell[
    "total number of vertices", "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, None, None, None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Rows" -> {{True, True, True, True, True, True, True, True}}}},
 CellID->383955074],

Cell["Coordinate-related properties include:", "Notes",
 CellID->485086907],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Centroid\>\"", Cell[
    "coordinates of the centroid in the standard embedding", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<VertexCoordinates\>\"", Cell[
    "coordinates of vertices assuming unit smallest edge length", "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}},
 CellID->798493051],

Cell["Geometrical properties include:", "Notes",
 CellID->115436353],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Circumcenter\>\"", Cell[
    "center of circumscribed sphere", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Circumradius\>\"", Cell[
    "circumradius assuming unit smallest edge length", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Circumsphere\>\"", Cell[
    "graphics primitive for the circumscribed sphere", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<DihedralAngleRules\>\"", Cell[
    "rules for dihedral angles", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<EdgeLengths\>\"", Cell[
    "relative lengths of edges", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<GeneralizedDiameter\>\"", Cell[
    "maximum distance between a pair of vertices", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Incenter\>\"", Cell[
    "center of inscribed sphere", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Inradius\>\"", Cell[
    "inradius assuming unit smallest edge length", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Insphere\>\"", Cell[
    "inscribed sphere", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<SurfaceArea\>\"", Cell[
    "total surface area assuming unit smallest edge length", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Volume\>\"", Cell[
    "enclosed volume assuming unit smallest edge length", "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {
    None, None, None, None, None, None, None, None, None, None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Rows" -> {{
     True, True, True, True, True, True, True, True, True, True, True, 
      True}}}},
 CellID->416448982],

Cell["Properties of polyhedron nets include:", "Notes",
 CellID->66655508],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<NetCoordinates\>\"", Cell[
    "coordinates of vertices in the net", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<NetEdgeIndices\>\"", Cell[
    "indices specifying the vertices on each edge in the net", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<NetEdges\>\"", Cell[
    "graphics primitives for edges in the net", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<NetFaceIndices\>\"", Cell[
    "indices specifying the incidence of faces in the net", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<NetFaces\>\"", Cell[
    "graphics primitives for faces in the net", "TableText"]},
   {Cell["\[FilledVerySmallSquare]", "TableRowIcon",
     FontColor->None], "\"\<NetGraph\>\"", Cell[
    "net as a Graph object", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<NetImage\>\"", Cell[
    "image of the polyhedron net", "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, None, None, 
     Dynamic[
      If[CurrentValue[{TaggingRules, "ModificationHighlight"}] === True, 
       RGBColor[0.92, 1, 0.59], None]], {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{
  "Rows" -> {{True, True, True, True, True, True, True, True}}}},
 CellID->865729],

Cell["Properties of polyhedron skeleton graphs include:", "Notes",
 CellID->141029063],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<SkeletonCoordinates\>\"", Cell[
    "vertex positions in an embedding of the skeleton graph ", "TableText"]},
   {Cell["\[FilledVerySmallSquare]", "TableRowIcon",
     FontColor->None], "\"\<SkeletonGraph\>\"", Cell[
    "skeleton graph as a Graph object", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<SkeletonImage\>\"", Cell[
    "image of the skeleton graph", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<SkeletonRules\>\"", Cell[
    "rules specifying the connectivity of the skeleton graph", "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, 
     Dynamic[
      If[CurrentValue[{TaggingRules, "ModificationHighlight"}] === True, 
       RGBColor[0.92, 1, 0.59], None]], None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True, True}}}},
 CellID->234091111],

Cell["Overall properties include:", "Notes",
 CellID->22458508],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<DualName\>\"", Cell[
    "name of the dual of the polyhedron", "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True}}}},
 CellID->118619863],

Cell[TextData[{
 Cell[BoxData[
  RowBox[{"TenSidedDie", "[", "\"\<\!\(\*
StyleBox[\"class\", \"TI\"]\)\>\"", "]"}]], "InlineFormula"],
 " gives ",
 Cell[BoxData[
  ButtonBox["True",
   BaseStyle->"Link",
   ButtonData->"paclet:ref/True"]], "InlineFormula"],
 " if the polyhedron is in the specified class."
}], "Notes",
 CellID->482514198],

Cell["Classes of polyhedra include:", "Notes",
 CellID->178890765],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Compound\>\"", Cell[
    "compound of two or more polyhedra", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Concave\>\"", Cell[
    "concave solid", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<Convex\>\"", Cell[
    "convex solid", "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True}}}},
 CellID->139981555],

Cell["\<\
Classes of polyhedra that are members of finite families include:\
\>", "Notes",
 CellID->2098505786],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Platonic\>\"", Cell[
    "one of the five Platonic solids", "TableText"]},
   {Cell["\[FilledVerySmallSquare]", "TableRowIcon",
     FontColor->None], "\"\<PlatonicDual\>\"", Cell[
    "one of the five Platonic duals", "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {
      Dynamic[
       If[CurrentValue[{TaggingRules, "ModificationHighlight"}] === True, 
        RGBColor[0.92, 1, 0.59], None]]}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}},
 CellID->1462810621],

Cell["Naming-related properties include:", "Notes",
 CellID->699856716],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], "\"\<Name\>\"", Cell[
    "English name as a string ", "TableText"]},
   {Cell["      ", "TableRowIcon"], "\"\<StandardName\>\"", Cell[TextData[{
     "standard ",
     StyleBox["Mathematica",
      FontSlant->"Italic"],
     " name"
    }], "TableText"]}
  }]], "2ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {None, {None}}, 
   "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True}}}},
 CellID->38918036]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->334243350],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->1309254],

Cell["This loads the package.", "ExampleText",
 CellID->319260100],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1390350494],

Cell["Visualize the form of a ten sided die.", "ExampleText",
 CellID->851189651],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TenSidedDie", "[", "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1555891690],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3cmR3TYQBuBX5UgcgtPwUSGIRx98cGoOwTE4BR911JF+GtbANBewgV7w
d6P/Gqm0zAObjU/g8jijn7/+/uXrT6/X66/3jz/fP378eo2S5TOH35Y/ycyZ
PYnLv00nc2Y/44+zn04myXmKm2Z8+X+kq8sMy93hgzNgOvGeyvRJTWs68Zj6
ZGlMZTpxEcqppnYB6QQtxOmwnLI8lUUIvfMD5yidGKe11SDzkk6009FYwLlI
J7Lp7iR4//MUhRnm/SvBSrSTTprC7JLfJqeTSqTaEqC36WQfwSYE6+fMpyji
uxy7gfM40djB8E0rCexEaY/iNYqSME5Ud8F7c/jx60S7YHcNUY2XU1mb8pA7
MDyYTsyKgdpr5IA4sdx62ujIECf2LNMGMzZIhkxT2uBH+0Jy1BylDWa2Boa8
+5Q2mNGzMXxqhhfgOkowhl8NlTJGl+A1pXWyPcSZEZxKfGXfN6kegiwXJVDF
eMmhaSI9BJwIwJLwI24DcxYwq0LOuWOcHqIdR/aBLQwzl+3q7iF488HLg4og
DOTlogS/QpDcNaqjgV56LlJnpO+geJlKl5oa6GK5KOGX+tpFpCTAiNhwpGIL
p+DNwx+/fawbf69RhdRbRGygOxgro+YCo9gIyeOxP5RP8Ahj7bVxCWOz8e37
t/dHDCGU5oisKpjpKL6oONvY89iEaNRsEyYMv8tFSWv9BxhnG2ceToVwbHhX
sYW+F/vjSN3GgYdHIZwzzBgwtlD25Q7GnQ3XPLovSwMcRw553J0KjIqNMw8X
QlrvZe1/HQzG+tSNOoxWG+DnqK2Te37CZ/mMcGWDUtkRDoxHHoBC+Db2vw3g
5LL4RxVEGxUeaEI4MOov94vkXDMRBtGGCx4ib6cS75E6QnIolQ6DbqPOY7iQ
7mcwusfxgmRfYROMJhuPPEadowo+tdW3+CAjKYV9+fWfJhitNog8jIWMtbF/
LaCTdzHv6eiAoWHDWAhzNgVHO4wDgsQMBhoPZvP1bOwHHIjk9ZlWGN026DxU
hYjD4I9Z35wxkm4VTBtNPDTOUflNvhtBe/pskPQdR6RsdPCQEiLS2FE29htS
csKHwbfRykNKSAwbh42KIOk+80SwwecheCmhOn5fOEgEYYjY6OPRLURw4jBt
lLQiAYTB4dF6jio7a+A2SihIONeq2jYMeNjA0NiWVO7OXQWXCyUbnIMLsTOy
fTbblkYKEg0YGjb0eGjcrrTcnFLeMAoSfBsaPDRmyruN85mnLBIXNpSmybWN
+iWJCBIlG4I8VN/d6P7bsaFfq+7PXUFgdPNIG4/ZVHScfDYh0bbB5zEKhvbW
uyNySUJBYmCDw0N1ajzaEL9WrSCxsdHB4/352vPizobSTYw7JLA2lo/nG1Vb
7ciG7LskRCQ/9t3ERiuPd2H12x38eLFhCeNwTLFEQuSxwUgb68dxZBSM/cTZ
IHnkUWCo8iBO+lgbo2CcbZghqfA4wBhuo+kzZdN9E0PVhgGSSx5nGHo8wG2M
Wi7oNs5IBJ0ceNzBUOKBbGM4jCYbGotJ2rgMAoxuG4JICo86DA0emDZAYPBt
iCDZLqKJNz0EeQDawIEhaIODZLv/aWyjabptbMSGcYmk7qT8rTGP1unW5jHw
WtXeBnEx2f8hkUc8G1AqjG3cITlosVw6cGwAwhhi44Dk/OdmPEBsYMIYa+O8
aLTyCGADFgasDRseacOpDSKPbhsdEz3VMWUsjEcbFB6WNrpfVU/a6LPxyCOA
jRWSRwAb3dORNgLYqPCwPBHlvIoSNB7IJ6IUHmkjbdzxSBtp446H8Yko/7X1
4PDwcrJR4ZE20sbBxvvnIRcp/Nc+BoSHUxv7paN7CtJGVBuFR/cUpI3ANjYe
3VMAa2PF4OHahvG781KvpSRtcGwMhCE1Qj1evpYNzYb9o4AaI9STNvruffE7
j29jHcrDo40hX5aiNMJj0oY9jDVtxLIx6mtg9UagBPZ7bkSFsaaNKDYAYciO
U489j+EwiDbGfqMem3HqSRsVGP99gaRQ0oZ3G+cVQwqJLxurOQ9wG/VDCRNJ
2vBrg36OsexCb7U7G6stD1gbnGf8iEjc2Vg+vqPR5Dak3iupIJGdUAMeZRM2
PBBgnG1o3Mc4I/FlYz/+6z6xbWjcx9h3uCDxa2NL8fDll6V8VNi0ckKzoQrj
0GpHNh4HPyOhfzziQbBhBmNVmEo9G00jXy4mzI+xWhb9/1DpEC82OMNqOLHX
Ynl/YNWZR+Qx9ZDcaXEKY4X8N649WomBE6mF5aX/XzceAnJiYDbUXWyQdGt5
6f9/r4eMvZowHoceYyePWsrJZ9oQH4STIU4OWkoxlm9GgI8/HMY+2kiOi8ZV
bBpi+X7HkJerhuPk4thBThgbnK0gw9injoTD4DL4/6K1N+QFxiGyDC4zuQ2n
MGyCf4qot62EUQ/+daXS5hLGY+a0kTAocXETW3aLCYOYSDYoG00Y9Lh4V1Rq
uwmDnmAw6ptOGE2Zx0bCaA3y41KCW08YHZnBRsLoi5dnersLGF6P37h4xrI1
pQyQepwmsA2QYvzG1/O3xIh/0dyc8fv8bT1o9XhMVBtrrh7sxHg2u5LlM6ML
8ZfwNkpSSGuCPbf/mBRCT+Dn9ivJAw0lc9ooSSGVcDoTpqu5jJwz+aJxTgop
yUXjMilkneArBDmZ/ECTNiiZU0jfLk/YqHW+ZSRtdGQSIR37OENbKAkvpHXv
YnejI4EPNGlDKvGENO1OsH3XSKRlhL4XMfbXLAGEpA3VuBZCrNzvDiLE6YEm
bVjGlxBKqY52x0VcLCMJY2yQhaQNhGAuI4/1oBUcO1BC0gZgQITUa0CocNoM
P9BUNp0wQDJKSNrwEvtl5G5bCQM2ZkLShtMYCLkcP2F4ieqB5jxswvAYDSFp
I1Jkl5HDOAkjRkSE7EdIGMHCFJI2wqfvQJMwpkqTkLQxYYjLSPmEhDFh6kKW
/K7O0+dOSNrIbDkfaECeIcngpJBIG5nLJIxMpPwLQn/2zg==
    "], {{0, 196}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 196},
  PlotRange->{{0, 180}, {0, 196}}]], "Output",
 ImageSize->{184, 196},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->251752322]
}, Open  ]],

Cell["Get an image for the net.", "ExampleText",
 CellID->1058565313],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TenSidedDie", "[", "\"\<NetImage\>\"", "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1552683843],

Cell[BoxData[
 GraphicsBox[
  {RGBColor[1., 1., 0.85], EdgeForm[GrayLevel[0]], 
   GraphicsComplexBox[CompressedData["
1:eJxTTMoPSmViYGAQA2IQjQ4mrJa+HHHijb2iIduxX99v71dLcTxzc/1Hexzy
9uWTlXdevPPU/vGeLZ6i51/bf3Jh7vPWO23v1pDfpu363n5pm02F2OYL+7km
v+98rv/R/vRPsXciSU/2Lz2uNlly9Qt7jqaKgEbxD/vFZs4+Xx9z177L01hv
yt/3+xM4bLQ+P5mxn2cPy8Hpee/3B51Zu97D6sF+l6WCfF80Hu//na1yyHXh
y/3f5zyXYuZicEB3L4T/er9RgW3kXNWv9rteRYd1Pv2yP+Ai3xGbdX/ss312
lkxZ8G3/Gd33L1MVmByC5Autn+n+2J8VnRvWocTqIP1BpLo7+PP+33eVDx8W
5XCQeXrBy3bVm/1R+SVqGZwcDrMLkiavzry1/9dpDe6VT9kdeOaFpkZ92mjv
wZYj53CFxeHqMqd9E7yu2wMAQhSofg==
    "], PolygonBox[{{1, 2, 3, 4}, {1, 4, 5, 6}, {1, 6, 7, 8}, {1, 8, 9, 10}, {
     1, 10, 11, 12}, {13, 3, 2, 14}, {13, 14, 15, 16}, {13, 16, 17, 18}, {13, 
     18, 19, 20}, {13, 20, 21, 22}}]]}]], "Output",
 ImageSize->{184, 118},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1883554604]
}, Open  ]],

Cell["A skeleton graph.", "ExampleText",
 CellID->845789001],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TenSidedDie", "[", "\"\<SkeletonGraph\>\"", "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->981480314],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12}, {
      Null, {{1, 4}, {1, 6}, {1, 8}, {1, 10}, {1, 12}, {2, 3}, {2, 5}, {2, 
       7}, {2, 9}, {2, 11}, {3, 4}, {3, 12}, {4, 5}, {5, 6}, {6, 7}, {7, 8}, {
       8, 9}, {9, 10}, {10, 11}, {11, 12}}}, {
      VertexCoordinates -> {{0., 0.5}, {0., 2.}, {0.7071067811865475, 
        0.7071067811865475}, {0.518532217484962, 0.7760383048157089}, {
        0.3826834323650898, 0.9238795325112867}, {0.18208430054838637`, 
        0.915399595043015}, {0., 1.}, {-0.18208430054838637`, 
        0.915399595043015}, {-0.3826834323650898, 
        0.9238795325112867}, {-0.518532217484962, 
        0.7760383048157089}, {-0.7071067811865475, 0.7071067811865475}, {
        0., -0.25}}}]], Typeset`boxes, Typeset`boxes$s2d = GraphicsGroupBox[{{
       Directive[
        Hue[0.6, 0.2, 0.8], 
        EdgeForm[
         Directive[
          GrayLevel[0], 
          Opacity[0.7]]]], 
       TagBox[
        DiskBox[{0., 0.5}, 0.024608150470219414`], "DynamicName", BoxID -> 
        "VertexID$1"], 
       TagBox[
        DiskBox[{0., 2.}, 0.024608150470219414`], "DynamicName", BoxID -> 
        "VertexID$2"], 
       TagBox[
        DiskBox[{0.7071067811865475, 0.7071067811865475}, 
         0.024608150470219414`], "DynamicName", BoxID -> "VertexID$3"], 
       TagBox[
        DiskBox[{0.518532217484962, 0.7760383048157089}, 
         0.024608150470219414`], "DynamicName", BoxID -> "VertexID$4"], 
       TagBox[
        DiskBox[{0.3826834323650898, 0.9238795325112867}, 
         0.024608150470219414`], "DynamicName", BoxID -> "VertexID$5"], 
       TagBox[
        DiskBox[{0.18208430054838637`, 0.915399595043015}, 
         0.024608150470219414`], "DynamicName", BoxID -> "VertexID$6"], 
       TagBox[
        DiskBox[{0., 1.}, 0.024608150470219414`], "DynamicName", BoxID -> 
        "VertexID$7"], 
       TagBox[
        DiskBox[{-0.18208430054838637`, 0.915399595043015}, 
         0.024608150470219414`], "DynamicName", BoxID -> "VertexID$8"], 
       TagBox[
        DiskBox[{-0.3826834323650898, 0.9238795325112867}, 
         0.024608150470219414`], "DynamicName", BoxID -> "VertexID$9"], 
       TagBox[
        DiskBox[{-0.518532217484962, 0.7760383048157089}, 
         0.024608150470219414`], "DynamicName", BoxID -> "VertexID$10"], 
       TagBox[
        DiskBox[{-0.7071067811865475, 0.7071067811865475}, 
         0.024608150470219414`], "DynamicName", BoxID -> "VertexID$11"], 
       TagBox[
        DiskBox[{0., -0.25}, 0.024608150470219414`], "DynamicName", BoxID -> 
        "VertexID$12"]}, {
       Directive[
        Opacity[0.7], 
        Hue[0.6, 0.7, 0.5]], 
       LineBox[{{
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}, {
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}, {
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$10", Automatic, Center]}, {
          DynamicLocation["VertexID$1", Automatic, Center], 
          DynamicLocation["VertexID$12", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$3", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$7", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$9", Automatic, Center]}, {
          DynamicLocation["VertexID$2", Automatic, Center], 
          DynamicLocation["VertexID$11", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$4", Automatic, Center]}, {
          DynamicLocation["VertexID$3", Automatic, Center], 
          DynamicLocation["VertexID$12", Automatic, Center]}, {
          DynamicLocation["VertexID$4", Automatic, Center], 
          DynamicLocation["VertexID$5", Automatic, Center]}, {
          DynamicLocation["VertexID$5", Automatic, Center], 
          DynamicLocation["VertexID$6", Automatic, Center]}, {
          DynamicLocation["VertexID$6", Automatic, Center], 
          DynamicLocation["VertexID$7", Automatic, Center]}, {
          DynamicLocation["VertexID$7", Automatic, Center], 
          DynamicLocation["VertexID$8", Automatic, Center]}, {
          DynamicLocation["VertexID$8", Automatic, Center], 
          DynamicLocation["VertexID$9", Automatic, Center]}, {
          DynamicLocation["VertexID$9", Automatic, Center], 
          DynamicLocation["VertexID$10", Automatic, Center]}, {
          DynamicLocation["VertexID$10", Automatic, Center], 
          DynamicLocation["VertexID$11", Automatic, Center]}, {
          DynamicLocation["VertexID$11", Automatic, Center], 
          DynamicLocation["VertexID$12", Automatic, Center]}}]}}], 
    Typeset`data}, 
    TagBox[
     DynamicBox[GraphComputation`NetworkGraphicsBox[
      2, Typeset`graph, Typeset`boxes], {
      CachedValue :> Typeset`boxes, SingleEvaluation -> True, 
       SynchronousUpdating -> False, TrackedSymbols :> {}},
      ImageSizeCache->{{1.7801660671246626`, 
       137.22813728910833`}, {-108.33104057556034`, 103.33104057556031`}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False,
    UnsavedVariables:>{Typeset`data}]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FrameTicks->None]], "Output",
 ImageSize->{144, 216},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->917744791]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"TenSidedDie - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        StyleBox[
         ButtonBox[
         "Mathematica", ButtonData -> "paclet:guide/Mathematica", 
          BaseStyle -> {"Link", "DockedLinkTrail"}], FontSlant -> "Italic"], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 31, 43.0504624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "TenSidedDie[] gives an image of a ten sided \
die.TenSidedDie[\"property\"] returns the requested property for the ten \
sided die.", "synonyms" -> {}, "title" -> "TenSidedDie", "titlemodifier" -> 
    "", "windowtitle" -> "TenSidedDie", "type" -> "Symbol", "uri" -> 
    "Classroom Utilities/ref/TenSidedDie"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[13830, 360, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->334243350]},
 "RasterizedOutput"->{
  Cell[14953, 404, 3560, 66, 217, "Output",
   CellTags->"RasterizedOutput",
   CellID->251752322]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 27920, 687},
 {"RasterizedOutput", 28064, 691}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[604, 21, 1918, 42, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[2547, 67, 54, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[2604, 70, 613, 17, 142, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[3254, 92, 609, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->256126939],
Cell[3866, 112, 79, 1, 70, "Notes",
 CellID->270166015],
Cell[3948, 115, 645, 13, 70, "2ColumnTableMod",
 CellID->25428423],
Cell[4596, 130, 70, 1, 70, "Notes",
 CellID->112965608],
Cell[4669, 133, 1282, 27, 70, "2ColumnTableMod",
 CellID->383955074],
Cell[5954, 162, 75, 1, 70, "Notes",
 CellID->485086907],
Cell[6032, 165, 552, 11, 70, "2ColumnTableMod",
 CellID->798493051],
Cell[6587, 178, 68, 1, 70, "Notes",
 CellID->115436353],
Cell[6658, 181, 1772, 34, 70, "2ColumnTableMod",
 CellID->416448982],
Cell[8433, 217, 74, 1, 70, "Notes",
 CellID->66655508],
Cell[8510, 220, 1367, 26, 70, "2ColumnTableMod",
 CellID->865729],
Cell[9880, 248, 86, 1, 70, "Notes",
 CellID->141029063],
Cell[9969, 251, 980, 18, 70, "2ColumnTableMod",
 CellID->234091111],
Cell[10952, 271, 63, 1, 70, "Notes",
 CellID->22458508],
Cell[11018, 274, 369, 9, 70, "2ColumnTableMod",
 CellID->118619863],
Cell[11390, 285, 339, 11, 70, "Notes",
 CellID->482514198],
Cell[11732, 298, 66, 1, 70, "Notes",
 CellID->178890765],
Cell[11801, 301, 584, 13, 70, "2ColumnTableMod",
 CellID->139981555],
Cell[12388, 316, 111, 3, 70, "Notes",
 CellID->2098505786],
Cell[12502, 321, 660, 14, 70, "2ColumnTableMod",
 CellID->1462810621],
Cell[13165, 337, 71, 1, 70, "Notes",
 CellID->699856716],
Cell[13239, 340, 554, 15, 70, "2ColumnTableMod",
 CellID->38918036]
}, Closed]],
Cell[CellGroupData[{
Cell[13830, 360, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->334243350],
Cell[CellGroupData[{
Cell[14345, 378, 193, 6, 31, "ExampleSection",
 CellID->1309254],
Cell[14541, 386, 66, 1, 32, "ExampleText",
 CellID->319260100],
Cell[14610, 389, 128, 3, 28, "Input",
 CellID->1390350494],
Cell[14741, 394, 81, 1, 32, "ExampleText",
 CellID->851189651],
Cell[CellGroupData[{
Cell[14847, 399, 103, 3, 28, "Input",
 CellID->1555891690],
Cell[14953, 404, 3560, 66, 217, "Output",
 CellTags->"RasterizedOutput",
 CellID->251752322]
}, Open  ]],
Cell[18528, 473, 69, 1, 70, "ExampleText",
 CellID->1058565313],
Cell[CellGroupData[{
Cell[18622, 478, 123, 3, 70, "Input",
 CellID->1552683843],
Cell[18748, 483, 923, 19, 139, "Output",
 CellID->1883554604]
}, Open  ]],
Cell[19686, 505, 60, 1, 70, "ExampleText",
 CellID->845789001],
Cell[CellGroupData[{
Cell[19771, 510, 127, 3, 70, "Input",
 CellID->981480314],
Cell[19901, 515, 6025, 120, 70, "Output",
 CellID->917744791]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[25965, 640, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

