(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[    194425,       4171]
NotebookOptionsPosition[    184832,       3865]
NotebookOutlinePosition[    188255,       3953]
CellTagsIndexPosition[    188131,       3947]
WindowTitle->TimeIntervalPlot - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"], \
"\<\"Differentiation\"\>":>Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/Differentiation"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/ref/TimeIntervalPlot\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/TimeIntervalPlot"]}, Visible -> 
            False]]; SelectionMove[
         DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/TimeIntervalPlot.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/TimeIntervalPlot", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 GridBoxOptions->{GridBoxItemSize->{"Columns" -> {
     Scaled[0.65], {
      Scaled[0.34]}}, "ColumnsIndexed" -> {}, "Rows" -> {{1.}}, 
   "RowsIndexed" -> {}}},
 CellID->1],

Cell[CellGroupData[{

Cell["TimeIntervalPlot", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TimeIntervalPlot", "[", 
       RowBox[{
        StyleBox["f", "TI"], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["n", "TI"], ",", 
        StyleBox["opts", "TI"]}], "]"}]], "InlineFormula"],
     " \[LineSeparator]plot f on the interval (x$min,x$max) partitioning the \
interval into n equal parts with bars indicating the change in f on each of \
the intervals."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TimeIntervalPlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          SubscriptBox[
           StyleBox["f", "TI"], 
           StyleBox["1", "TR"]], ",", 
          SubscriptBox[
           StyleBox["f", "TI"], 
           StyleBox["2", "TR"]]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["n", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]plot f$1 and f$2 on the specified interval with bars \
indicating the change in f$1."
    }]]},
   {"", Cell[TextData[{
     Cell[BoxData[
      RowBox[{"TimeIntervalPlot", "[", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{
            SubscriptBox[
             StyleBox["f", "TI"], 
             StyleBox["1", "TR"]], ",", 
            SubscriptBox[
             StyleBox["f", "TI"], 
             StyleBox["2", "TR"]]}], "}"}], ",", 
          SubscriptBox[
           StyleBox["f", "TI"], 
           StyleBox["i", "TI"]], ",", 
          StyleBox["\[Ellipsis]", "TR"]}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{
          StyleBox["x", "TI"], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["min", "TI"]], ",", 
          SubscriptBox[
           StyleBox["x", "TI"], 
           StyleBox["max", "TI"]]}], "}"}], ",", 
        StyleBox["n", "TI"]}], "]"}]], "InlineFormula"],
     "\[LineSeparator]plot ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["f", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["f", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula"],
     " together with other functions ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["f", "TI"], 
       StyleBox["i", "TI"]]], "InlineFormula"],
     " with bars to compare the changes in",
     Cell[BoxData[
      RowBox[{" ", 
       SubscriptBox[
        StyleBox["f", "TI"], 
        StyleBox["1", "TR"]]}]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["f", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula"],
     "."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, {None}}, "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->11594396],

Cell["\<\
To compare the changes in two functions requires those functions to be in a \
separate list.\
\>", "Notes",
 CellID->1067943069],

Cell["\<\
A single list with two functions can be used to compare the changes in the \
first function with its derivative.\
\>", "Notes",
 CellID->283458494],

Cell[TextData[{
 "In addition to the options for ",
 ButtonBox["Plot",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Plot"],
 " the following options can be used."
}], "Notes",
 CellID->968179612],

Cell[BoxData[GridBox[{
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["ArrowStyles",
     BaseStyle->"Link",
     ButtonData->"paclet:ClassroomUtilities/ref/ArrowStyles"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[
    "set the style of the arrows in the plot", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["BarStyles",
     BaseStyle->"Link",
     ButtonData->"paclet:ClassroomUtilities/ref/BarStyles"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell["\<\
set the style of the bars used to indicate the change in the function\
\>", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["BarWidths",
     BaseStyle->"Link",
     ButtonData->"paclet:ClassroomUtilities/ref/BarWidths"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell["\<\
set the widths of the bars as as fraction of the width of the plot\
\>", "TableText"]},
   {Cell["      ", "TableRowIcon"], 
    ButtonBox["ReferenceLine",
     BaseStyle->"Link",
     ButtonData->"paclet:ClassroomUtilities/ref/ReferenceLine"], 
    ButtonBox["Automatic",
     BaseStyle->"Link",
     ButtonData->"paclet:ref/Automatic"], Cell[
    "set the position of the base line for measuring change", "TableText"]}
  }]], "3ColumnTableMod",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, 
   "Rows" -> {None, None, None, {None}}, "RowsIndexed" -> {}},
 GridBoxDividers->{"Rows" -> {{True, True, True, True, True}}}},
 CellID->1654168308],

Cell["\<\
Arrows, indicating the direction of change, can be omitted using ArrowStyles \
\[Rule] None.\
\>", "Notes",
 CellID->711145565]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->82919490],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->608720942],

Cell["\<\
TimeIntervalPlot can be used to help students recognize the relationship \
between rate of change of a function and slope.\
\>", "ExampleText",
 CellID->1434352127],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1652260914],

Cell["Compare the change of a cubic on different intervals.", "ExampleText",
 CellID->438142241],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   SuperscriptBox["x", "3"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "8"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->135218924],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3S90s86CxvHuWVNZWVtZWVlbGRkZeTG7B7ECiUUikVgkEolFIpFYJBI5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    "], {{0, 361}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 361},
  PlotRange->{{0, 360}, {0, 361}}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->189144459]
}, Open  ]],

Cell["Include a plot of the derivative.", "ExampleText",
 CellID->382378570],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
     SuperscriptBox["x", "3"], ",", 
     RowBox[{"3", " ", 
      SuperscriptBox["x", "2"]}]}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "8"}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1365554166],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3S90pM6axvHZs2bkyLEjIyNjIyNbtryY3dNiBRKLRCKxSGTJssiSSCwS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    "], {{0, 361}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 361},
  PlotRange->{{0, 360}, {0, 361}}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->112728101]
}, Open  ]],

Cell["Compare the change in a cubic and quartic.", "ExampleText",
 CellID->1256978156],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
      SuperscriptBox["x", "3"], ",", 
      SuperscriptBox["x", "4"]}], "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "8"}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->1235232353],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS10s862xt+7rqmsrK2srKyNjIyMPJizFuIKJBaJRGKRyJFjkSORY0eO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    "], {{0, 354}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 354},
  PlotRange->{{0, 360}, {0, 354}}]], "Output",
 ImageSize->{364, 354},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->531075589]
}, Open  ]],

Cell["\<\
Examine the rate of change in a function as it changes direction.\
\>", "ExampleText",
 CellID->1195071940],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   RowBox[{"Sin", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", "\[Pi]"}], "}"}], ",", "12"}], 
  "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->159545189],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS90q063hnvXNZWVx1ZGVh57ZGRk1lVfzF0r4gpkLBKJxCKRSCwSiYxF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    "], {{0, 348}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 348},
  PlotRange->{{0, 360}, {0, 348}}]], "Output",
 ImageSize->{364, 348},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[5]=",
 CellID->22328867]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Options",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(4)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->738429516],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "ArrowStyles",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->476879399],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->564627589],

Cell["Setting ArrowStyles to None omits the arrows from the plot.", \
"ExampleText",
 CellID->2113135877],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   SuperscriptBox["x", "7"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "8", ",", 
   RowBox[{"ArrowStyles", "\[Rule]", " ", "None"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->390130653],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3S94q8q+xvHe55ott1y2snLJZSuRkciDufeJuAKJRSKRWCQSiUUikVgk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    "], {{0, 361}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 361},
  PlotRange->{{0, 360}, {0, 361}}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->762116577]
}, Open  ]],

Cell["ArrowStyles should be set to a list with two elements.", "ExampleText",
 CellID->391849416],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   SuperscriptBox["x", "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "2"}], "}"}], ",", "8", ",", 
   RowBox[{"ArrowStyles", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Black", ",", "Gray"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1628273010],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.}], Scaled[{-0.04, 0}, {0, 0.0625}], 
        Scaled[{0, 0}, {0, 0.0625}], Scaled[{0, 0}, {0, 0.}]}, {
       Scaled[{-0.04, 0}, {0, 0.25}], Scaled[{-0.04, 0}, {0, 0.5625}], 
        Scaled[{0, 0}, {0, 0.5625}], Scaled[{0, 0}, {0, 0.25}]}, {
       Scaled[{-0.04, 0}, {0, 1.}], Scaled[{-0.04, 0}, {0, 1.5625}], 
        Scaled[{0, 0}, {0, 1.5625}], Scaled[{0, 0}, {0, 1.}]}, {
       Scaled[{-0.04, 0}, {0, 2.25}], Scaled[{-0.04, 0}, {0, 3.0625}], 
        Scaled[{0, 0}, {0, 3.0625}], Scaled[{0, 0}, {0, 2.25}]}}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.0625}], Scaled[{-0.04, 0}, {0, 0.25}], 
        Scaled[{0, 0}, {0, 0.25}], Scaled[{0, 0}, {0, 0.0625}]}, {
       Scaled[{-0.04, 0}, {0, 0.5625}], Scaled[{-0.04, 0}, {0, 1.}], 
        Scaled[{0, 0}, {0, 1.}], Scaled[{0, 0}, {0, 0.5625}]}, {
       Scaled[{-0.04, 0}, {0, 1.5625}], Scaled[{-0.04, 0}, {0, 2.25}], 
        Scaled[{0, 0}, {0, 2.25}], Scaled[{0, 0}, {0, 1.5625}]}, {
       Scaled[{-0.04, 0}, {0, 3.0625}], Scaled[{-0.04, 0}, {0, 4.}], 
        Scaled[{0, 0}, {0, 4.}], Scaled[{0, 0}, {0, 3.0625}]}}], 
     {GrayLevel[0], Opacity[1], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.328125}], Scaled[{-0.02, 0}, {0, 0.484375}]}],
       ArrowBox[{
       Scaled[{-0.02, 0}, {0, 1.140625}], Scaled[{-0.02, 0}, {0, 1.421875}]}],
       ArrowBox[{
       Scaled[{-0.02, 0}, {0, 2.453125}], Scaled[{-0.02, 0}, {0, 2.859375}]}], 
      {GrayLevel[0.5], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 0.671875}], 
         Scaled[{-0.02, 0}, {0, 0.890625}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 1.734375}], 
         Scaled[{-0.02, 0}, {0, 2.078125}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 3.296875}], 
         Scaled[{-0.02, 0}, {0, 3.765625}]}]}, 
      {GrayLevel[0.4], Thickness[Small], Opacity[1], 
       LineBox[NCache[{{
          Scaled[{-0.04, 0}, {0, 0.0625}], {
           Rational[1, 4], Rational[1, 16]}, {Rational[1, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.25}], {Rational[1, 2], Rational[1, 4]}, {
           Rational[1, 2], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.5625}], {
           Rational[3, 4], Rational[9, 16]}, {Rational[3, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 1.}], {1, 1}, {1, 0}}, {
          Scaled[{-0.04, 0}, {0, 1.5625}], {
           Rational[5, 4], Rational[25, 16]}, {Rational[5, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 2.25}], {Rational[3, 2], Rational[9, 4]}, {
           Rational[3, 2], 0}}, {
          Scaled[{-0.04, 0}, {0, 3.0625}], {
           Rational[7, 4], Rational[49, 16]}, {Rational[7, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 4.}], {2, 4}, {2, 0}}}, {{
          Scaled[{-0.04, 0}, {0, 0.0625}], {0.25, 0.0625}, {0.25, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.25}], {0.5, 0.25}, {0.5, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.5625}], {0.75, 0.5625}, {0.75, 0}}, {
          Scaled[{-0.04, 0}, {0, 1.}], {1, 1}, {1, 0}}, {
          Scaled[{-0.04, 0}, {0, 1.5625}], {1.25, 1.5625}, {1.25, 0}}, {
          Scaled[{-0.04, 0}, {0, 2.25}], {1.5, 2.25}, {1.5, 0}}, {
          Scaled[{-0.04, 0}, {0, 3.0625}], {1.75, 3.0625}, {1.75, 0}}, {
          Scaled[{-0.04, 0}, {0, 4.}], {2, 4}, {2, 0}}}]], 
       LineBox[{{0, 0}, {2, 0}}], 
       {RGBColor[1, 0, 0], PointSize[Medium], 
        PointBox[
         NCache[{{0, 0}, {Rational[1, 4], Rational[1, 16]}, {
           Rational[1, 2], Rational[1, 4]}, {
           Rational[3, 4], Rational[9, 16]}, {1, 1}, {
           Rational[5, 4], Rational[25, 16]}, {
           Rational[3, 2], Rational[9, 4]}, {
           Rational[7, 4], Rational[49, 16]}, {2, 4}}, {{0, 0}, {0.25, 
           0.0625}, {0.5, 0.25}, {0.75, 0.5625}, {1, 1}, {1.25, 1.5625}, {1.5,
            2.25}, {1.75, 3.0625}, {2, 4}}]]}}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVlfk7lAsDhm1Jqplo0UwcZSulSQvazPNaSrYWW5FEJKljqQ6lE42MUkQd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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->623838389]
}, Open  ]],

Cell["\<\
If a single value is given all arrows will have identical styles.\
\>", "ExampleText",
 CellID->2035002437],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   SuperscriptBox["x", "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "8", ",", 
   RowBox[{"ArrowStyles", "\[Rule]", " ", "Red"}]}], "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->2095336989],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.}], Scaled[{-0.04, 0}, {0, 0.015625}], 
        Scaled[{0, 0}, {0, 0.015625}], Scaled[{0, 0}, {0, 0.}]}, {
       Scaled[{-0.04, 0}, {0, 0.0625}], Scaled[{-0.04, 0}, {0, 0.140625}], 
        Scaled[{0, 0}, {0, 0.140625}], Scaled[{0, 0}, {0, 0.0625}]}, {
       Scaled[{-0.04, 0}, {0, 0.25}], Scaled[{-0.04, 0}, {0, 0.390625}], 
        Scaled[{0, 0}, {0, 0.390625}], Scaled[{0, 0}, {0, 0.25}]}, {
       Scaled[{-0.04, 0}, {0, 0.5625}], Scaled[{-0.04, 0}, {0, 0.765625}], 
        Scaled[{0, 0}, {0, 0.765625}], Scaled[{0, 0}, {0, 0.5625}]}}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.015625}], Scaled[{-0.04, 0}, {0, 0.0625}], 
        Scaled[{0, 0}, {0, 0.0625}], Scaled[{0, 0}, {0, 0.015625}]}, {
       Scaled[{-0.04, 0}, {0, 0.140625}], Scaled[{-0.04, 0}, {0, 0.25}], 
        Scaled[{0, 0}, {0, 0.25}], Scaled[{0, 0}, {0, 0.140625}]}, {
       Scaled[{-0.04, 0}, {0, 0.390625}], Scaled[{-0.04, 0}, {0, 0.5625}], 
        Scaled[{0, 0}, {0, 0.5625}], Scaled[{0, 0}, {0, 0.390625}]}, {
       Scaled[{-0.04, 0}, {0, 0.765625}], Scaled[{-0.04, 0}, {0, 1.}], 
        Scaled[{0, 0}, {0, 1.}], Scaled[{0, 0}, {0, 0.765625}]}}], 
     {RGBColor[1, 0, 0], Opacity[1], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.08203125}], 
        Scaled[{-0.02, 0}, {0, 0.12109375}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.28515625}], 
        Scaled[{-0.02, 0}, {0, 0.35546875}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.61328125}], 
        Scaled[{-0.02, 0}, {0, 0.71484375}]}], 
      {RGBColor[1, 0, 0], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 0.16796875}], 
         Scaled[{-0.02, 0}, {0, 0.22265625}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 0.43359375}], 
         Scaled[{-0.02, 0}, {0, 0.51953125}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 0.82421875}], 
         Scaled[{-0.02, 0}, {0, 0.94140625}]}]}, 
      {GrayLevel[0.4], Thickness[Small], Opacity[1], 
       LineBox[NCache[{{
          Scaled[{-0.04, 0}, {0, 0.015625}], {
           Rational[1, 8], Rational[1, 64]}, {Rational[1, 8], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.0625}], {
           Rational[1, 4], Rational[1, 16]}, {Rational[1, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.140625}], {
           Rational[3, 8], Rational[9, 64]}, {Rational[3, 8], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.25}], {Rational[1, 2], Rational[1, 4]}, {
           Rational[1, 2], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.390625}], {
           Rational[5, 8], Rational[25, 64]}, {Rational[5, 8], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.5625}], {
           Rational[3, 4], Rational[9, 16]}, {Rational[3, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.765625}], {
           Rational[7, 8], Rational[49, 64]}, {Rational[7, 8], 0}}, {
          Scaled[{-0.04, 0}, {0, 1.}], {1, 1}, {1, 0}}}, {{
          Scaled[{-0.04, 0}, {0, 0.015625}], {0.125, 0.015625}, {0.125, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.0625}], {0.25, 0.0625}, {0.25, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.140625}], {0.375, 0.140625}, {0.375, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.25}], {0.5, 0.25}, {0.5, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.390625}], {0.625, 0.390625}, {0.625, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.5625}], {0.75, 0.5625}, {0.75, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.765625}], {0.875, 0.765625}, {0.875, 0}}, {
          Scaled[{-0.04, 0}, {0, 1.}], {1, 1}, {1, 0}}}]], 
       LineBox[{{0, 0}, {1, 0}}], 
       {RGBColor[1, 0, 0], PointSize[Medium], 
        PointBox[
         NCache[{{0, 0}, {Rational[1, 8], Rational[1, 64]}, {
           Rational[1, 4], Rational[1, 16]}, {
           Rational[3, 8], Rational[9, 64]}, {
           Rational[1, 2], Rational[1, 4]}, {
           Rational[5, 8], Rational[25, 64]}, {
           Rational[3, 4], Rational[9, 16]}, {
           Rational[7, 8], Rational[49, 64]}, {1, 1}}, {{0, 0}, {0.125, 
           0.015625}, {0.25, 0.0625}, {0.375, 0.140625}, {0.5, 0.25}, {0.625, 
           0.390625}, {0.75, 0.5625}, {0.875, 0.765625}, {1, 
           1}}]]}}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVlWk01AsYxm2VVBNaNBNX2UppUtlS5rGVLSpbiSayJHUZJUo3jIxSRF2X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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1891930617]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   SuperscriptBox["x", "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "8", ",", 
   RowBox[{"ArrowStyles", "\[Rule]", " ", 
    RowBox[{"{", "Blue", "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[5]:=",
 CellID->1903308715],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.}], Scaled[{-0.04, 0}, {0, 0.015625}], 
        Scaled[{0, 0}, {0, 0.015625}], Scaled[{0, 0}, {0, 0.}]}, {
       Scaled[{-0.04, 0}, {0, 0.0625}], Scaled[{-0.04, 0}, {0, 0.140625}], 
        Scaled[{0, 0}, {0, 0.140625}], Scaled[{0, 0}, {0, 0.0625}]}, {
       Scaled[{-0.04, 0}, {0, 0.25}], Scaled[{-0.04, 0}, {0, 0.390625}], 
        Scaled[{0, 0}, {0, 0.390625}], Scaled[{0, 0}, {0, 0.25}]}, {
       Scaled[{-0.04, 0}, {0, 0.5625}], Scaled[{-0.04, 0}, {0, 0.765625}], 
        Scaled[{0, 0}, {0, 0.765625}], Scaled[{0, 0}, {0, 0.5625}]}}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.015625}], Scaled[{-0.04, 0}, {0, 0.0625}], 
        Scaled[{0, 0}, {0, 0.0625}], Scaled[{0, 0}, {0, 0.015625}]}, {
       Scaled[{-0.04, 0}, {0, 0.140625}], Scaled[{-0.04, 0}, {0, 0.25}], 
        Scaled[{0, 0}, {0, 0.25}], Scaled[{0, 0}, {0, 0.140625}]}, {
       Scaled[{-0.04, 0}, {0, 0.390625}], Scaled[{-0.04, 0}, {0, 0.5625}], 
        Scaled[{0, 0}, {0, 0.5625}], Scaled[{0, 0}, {0, 0.390625}]}, {
       Scaled[{-0.04, 0}, {0, 0.765625}], Scaled[{-0.04, 0}, {0, 1.}], 
        Scaled[{0, 0}, {0, 1.}], Scaled[{0, 0}, {0, 0.765625}]}}], 
     {RGBColor[0, 0, 1], Opacity[1], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.08203125}], 
        Scaled[{-0.02, 0}, {0, 0.12109375}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.28515625}], 
        Scaled[{-0.02, 0}, {0, 0.35546875}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.61328125}], 
        Scaled[{-0.02, 0}, {0, 0.71484375}]}], 
      {RGBColor[0, 0, 1], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 0.16796875}], 
         Scaled[{-0.02, 0}, {0, 0.22265625}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 0.43359375}], 
         Scaled[{-0.02, 0}, {0, 0.51953125}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 0.82421875}], 
         Scaled[{-0.02, 0}, {0, 0.94140625}]}]}, 
      {GrayLevel[0.4], Thickness[Small], Opacity[1], 
       LineBox[NCache[{{
          Scaled[{-0.04, 0}, {0, 0.015625}], {
           Rational[1, 8], Rational[1, 64]}, {Rational[1, 8], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.0625}], {
           Rational[1, 4], Rational[1, 16]}, {Rational[1, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.140625}], {
           Rational[3, 8], Rational[9, 64]}, {Rational[3, 8], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.25}], {Rational[1, 2], Rational[1, 4]}, {
           Rational[1, 2], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.390625}], {
           Rational[5, 8], Rational[25, 64]}, {Rational[5, 8], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.5625}], {
           Rational[3, 4], Rational[9, 16]}, {Rational[3, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.765625}], {
           Rational[7, 8], Rational[49, 64]}, {Rational[7, 8], 0}}, {
          Scaled[{-0.04, 0}, {0, 1.}], {1, 1}, {1, 0}}}, {{
          Scaled[{-0.04, 0}, {0, 0.015625}], {0.125, 0.015625}, {0.125, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.0625}], {0.25, 0.0625}, {0.25, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.140625}], {0.375, 0.140625}, {0.375, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.25}], {0.5, 0.25}, {0.5, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.390625}], {0.625, 0.390625}, {0.625, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.5625}], {0.75, 0.5625}, {0.75, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.765625}], {0.875, 0.765625}, {0.875, 0}}, {
          Scaled[{-0.04, 0}, {0, 1.}], {1, 1}, {1, 0}}}]], 
       LineBox[{{0, 0}, {1, 0}}], 
       {RGBColor[1, 0, 0], PointSize[Medium], 
        PointBox[
         NCache[{{0, 0}, {Rational[1, 8], Rational[1, 64]}, {
           Rational[1, 4], Rational[1, 16]}, {
           Rational[3, 8], Rational[9, 64]}, {
           Rational[1, 2], Rational[1, 4]}, {
           Rational[5, 8], Rational[25, 64]}, {
           Rational[3, 4], Rational[9, 16]}, {
           Rational[7, 8], Rational[49, 64]}, {1, 1}}, {{0, 0}, {0.125, 
           0.015625}, {0.25, 0.0625}, {0.375, 0.140625}, {0.5, 0.25}, {0.625, 
           0.390625}, {0.75, 0.5625}, {0.875, 0.765625}, {1, 
           1}}]]}}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVlWk01AsYxm2VVBNaNBNX2UppUtlS5rGVLSpbiSayJHUZJUo3jIxSRF2X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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[5]=",
 CellID->1126810389]
}, Open  ]],

Cell[TextData[{
 ButtonBox["Arrowheads",
  BaseStyle->"Link",
  ButtonData->"paclet:ref/Arrowheads"],
 " can be included in the style declarations."
}], "ExampleText",
 CellID->836639269],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   SuperscriptBox["x", "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "2"}], "}"}], ",", "8", ",", 
   RowBox[{"ArrowStyles", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Arrowheads", "[", "Small", "]"}], ",", "Black"}], "}"}], ",",
       "Gray"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[6]:=",
 CellID->1820757174],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.}], Scaled[{-0.04, 0}, {0, 0.0625}], 
        Scaled[{0, 0}, {0, 0.0625}], Scaled[{0, 0}, {0, 0.}]}, {
       Scaled[{-0.04, 0}, {0, 0.25}], Scaled[{-0.04, 0}, {0, 0.5625}], 
        Scaled[{0, 0}, {0, 0.5625}], Scaled[{0, 0}, {0, 0.25}]}, {
       Scaled[{-0.04, 0}, {0, 1.}], Scaled[{-0.04, 0}, {0, 1.5625}], 
        Scaled[{0, 0}, {0, 1.5625}], Scaled[{0, 0}, {0, 1.}]}, {
       Scaled[{-0.04, 0}, {0, 2.25}], Scaled[{-0.04, 0}, {0, 3.0625}], 
        Scaled[{0, 0}, {0, 3.0625}], Scaled[{0, 0}, {0, 2.25}]}}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.0625}], Scaled[{-0.04, 0}, {0, 0.25}], 
        Scaled[{0, 0}, {0, 0.25}], Scaled[{0, 0}, {0, 0.0625}]}, {
       Scaled[{-0.04, 0}, {0, 0.5625}], Scaled[{-0.04, 0}, {0, 1.}], 
        Scaled[{0, 0}, {0, 1.}], Scaled[{0, 0}, {0, 0.5625}]}, {
       Scaled[{-0.04, 0}, {0, 1.5625}], Scaled[{-0.04, 0}, {0, 2.25}], 
        Scaled[{0, 0}, {0, 2.25}], Scaled[{0, 0}, {0, 1.5625}]}, {
       Scaled[{-0.04, 0}, {0, 3.0625}], Scaled[{-0.04, 0}, {0, 4.}], 
        Scaled[{0, 0}, {0, 4.}], Scaled[{0, 0}, {0, 3.0625}]}}], 
     {GrayLevel[0], Opacity[1], Arrowheads[Small], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.328125}], Scaled[{-0.02, 0}, {0, 0.484375}]}],
       ArrowBox[{
       Scaled[{-0.02, 0}, {0, 1.140625}], Scaled[{-0.02, 0}, {0, 1.421875}]}],
       ArrowBox[{
       Scaled[{-0.02, 0}, {0, 2.453125}], Scaled[{-0.02, 0}, {0, 2.859375}]}], 
      {GrayLevel[0.5], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 0.671875}], 
         Scaled[{-0.02, 0}, {0, 0.890625}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 1.734375}], 
         Scaled[{-0.02, 0}, {0, 2.078125}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 3.296875}], 
         Scaled[{-0.02, 0}, {0, 3.765625}]}]}, 
      {GrayLevel[0.4], Thickness[Small], Opacity[1], 
       LineBox[NCache[{{
          Scaled[{-0.04, 0}, {0, 0.0625}], {
           Rational[1, 4], Rational[1, 16]}, {Rational[1, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.25}], {Rational[1, 2], Rational[1, 4]}, {
           Rational[1, 2], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.5625}], {
           Rational[3, 4], Rational[9, 16]}, {Rational[3, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 1.}], {1, 1}, {1, 0}}, {
          Scaled[{-0.04, 0}, {0, 1.5625}], {
           Rational[5, 4], Rational[25, 16]}, {Rational[5, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 2.25}], {Rational[3, 2], Rational[9, 4]}, {
           Rational[3, 2], 0}}, {
          Scaled[{-0.04, 0}, {0, 3.0625}], {
           Rational[7, 4], Rational[49, 16]}, {Rational[7, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 4.}], {2, 4}, {2, 0}}}, {{
          Scaled[{-0.04, 0}, {0, 0.0625}], {0.25, 0.0625}, {0.25, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.25}], {0.5, 0.25}, {0.5, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.5625}], {0.75, 0.5625}, {0.75, 0}}, {
          Scaled[{-0.04, 0}, {0, 1.}], {1, 1}, {1, 0}}, {
          Scaled[{-0.04, 0}, {0, 1.5625}], {1.25, 1.5625}, {1.25, 0}}, {
          Scaled[{-0.04, 0}, {0, 2.25}], {1.5, 2.25}, {1.5, 0}}, {
          Scaled[{-0.04, 0}, {0, 3.0625}], {1.75, 3.0625}, {1.75, 0}}, {
          Scaled[{-0.04, 0}, {0, 4.}], {2, 4}, {2, 0}}}]], 
       LineBox[{{0, 0}, {2, 0}}], 
       {RGBColor[1, 0, 0], PointSize[Medium], 
        PointBox[
         NCache[{{0, 0}, {Rational[1, 4], Rational[1, 16]}, {
           Rational[1, 2], Rational[1, 4]}, {
           Rational[3, 4], Rational[9, 16]}, {1, 1}, {
           Rational[5, 4], Rational[25, 16]}, {
           Rational[3, 2], Rational[9, 4]}, {
           Rational[7, 4], Rational[49, 16]}, {2, 4}}, {{0, 0}, {0.25, 
           0.0625}, {0.5, 0.25}, {0.75, 0.5625}, {1, 1}, {1.25, 1.5625}, {1.5,
            2.25}, {1.75, 3.0625}, {2, 4}}]]}}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVlfk7lAsDhm1Jqplo0UwcZSulSQvazPNaSrYWW5FEJKljqQ6lE42MUkQd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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[6]=",
 CellID->1971337315]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "BarStyles",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->503088389],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->613407706],

Cell["BarStyles should be given as a list with two elements.", "ExampleText",
 CellID->1621809142],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   RowBox[{"Sin", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", 
     RowBox[{"\[Pi]", "/", "2"}]}], "}"}], ",", "6", ",", 
   RowBox[{"BarStyles", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{"Red", ",", "Green"}], "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1883801870],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"RGBColor", "[", 
    RowBox[{"1", ",", "0", ",", "0"}], "]"}], ",", 
   RowBox[{"RGBColor", "[", 
    RowBox[{"0", ",", "1", ",", "0"}], "]"}]}], "}"}]], "Print",
 CellLabel->"During evaluation of In[9]:=",
 CellID->69685236],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0, 0], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.}], 
        Scaled[{-0.04, 0}, {0, 0.2588190451025207}], 
        Scaled[{0, 0}, {0, 0.2588190451025207}], Scaled[{0, 0}, {0, 0.}]}, {
       Scaled[{-0.04, 0}, {0, 0.5}], 
        Scaled[{-0.04, 0}, {0, 0.7071067811865475}], 
        Scaled[{0, 0}, {0, 0.7071067811865475}], Scaled[{0, 0}, {0, 0.5}]}, {
       Scaled[{-0.04, 0}, {0, 0.8660254037844386}], 
        Scaled[{-0.04, 0}, {0, 0.9659258262890682}], 
        Scaled[{0, 0}, {0, 0.9659258262890682}], 
        Scaled[{0, 0}, {0, 0.8660254037844386}]}}]}, 
    {RGBColor[0, 1, 0], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.2588190451025207}], 
        Scaled[{-0.04, 0}, {0, 0.5}], Scaled[{0, 0}, {0, 0.5}], 
        Scaled[{0, 0}, {0, 0.2588190451025207}]}, {
       Scaled[{-0.04, 0}, {0, 0.7071067811865475}], 
        Scaled[{-0.04, 0}, {0, 0.8660254037844386}], 
        Scaled[{0, 0}, {0, 0.8660254037844386}], 
        Scaled[{0, 0}, {0, 0.7071067811865475}]}, {
       Scaled[{-0.04, 0}, {0, 0.9659258262890682}], 
        Scaled[{-0.04, 0}, {0, 1.}], Scaled[{0, 0}, {0, 1.}], 
        Scaled[{0, 0}, {0, 0.9659258262890682}]}}]}, 
    {RGBColor[0.9, 0, 1.], Thickness[Medium], Opacity[0.95], Arrowheads[
     Small], ArrowBox[{
      Scaled[{-0.02, 0}, {0, 0.06470476127563017}], 
       Scaled[{-0.02, 0}, {0, 0.1941142838268905}]}], 
     ArrowBox[{
      Scaled[{-0.02, 0}, {0, 0.5517766952966369}], 
       Scaled[{-0.02, 0}, {0, 0.6553300858899106}]}], 
     ArrowBox[{
      Scaled[{-0.02, 0}, {0, 0.891000509410596}], 
       Scaled[{-0.02, 0}, {0, 0.9409507206629109}]}], 
     {RGBColor[1, 0.95, 0], Thickness[Large], Opacity[0.95], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.3191142838268905}], 
        Scaled[{-0.02, 0}, {0, 0.4397047612756302}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.7468364368360203}], 
        Scaled[{-0.02, 0}, {0, 0.8262957481349659}]}]}, 
     {GrayLevel[0.4], Thickness[Small], Opacity[1], 
      LineBox[NCache[{{
         Scaled[{-0.04, 0}, {0, 0.2588190451025207}], {
          Rational[1, 12] 
           Pi, (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}, {
          Rational[1, 12] Pi, 0}}, {
         Scaled[{-0.04, 0}, {0, 0.5}], {Rational[1, 6] Pi, Rational[1, 2]}, {
          Rational[1, 6] Pi, 0}}, {
         Scaled[{-0.04, 0}, {0, 0.7071067811865475}], {
          Rational[1, 4] Pi, 2^Rational[-1, 2]}, {Rational[1, 4] Pi, 0}}, {
         Scaled[{-0.04, 0}, {0, 0.8660254037844386}], {
          Rational[1, 3] Pi, Rational[1, 2] 3^Rational[1, 2]}, {
          Rational[1, 3] Pi, 0}}, {
         Scaled[{-0.04, 0}, {0, 0.9659258262890682}], {
          Rational[5, 12] 
           Pi, (Rational[1, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {
          Rational[5, 12] Pi, 0}}, {
         Scaled[{-0.04, 0}, {0, 1.}], {Rational[1, 2] Pi, 1}, {
          Rational[1, 2] Pi, 0}}}, {{
         Scaled[{-0.04, 0}, {0, 0.2588190451025207}], {0.2617993877991494, 
          0.2588190451025207}, {0.2617993877991494, 0}}, {
         Scaled[{-0.04, 0}, {0, 0.5}], {0.5235987755982988, 0.5}, {
          0.5235987755982988, 0}}, {
         Scaled[{-0.04, 0}, {0, 0.7071067811865475}], {0.7853981633974483, 
          0.7071067811865475}, {0.7853981633974483, 0}}, {
         Scaled[{-0.04, 0}, {0, 0.8660254037844386}], {1.0471975511965976`, 
          0.8660254037844386}, {1.0471975511965976`, 0}}, {
         Scaled[{-0.04, 0}, {0, 0.9659258262890682}], {1.3089969389957472`, 
          0.9659258262890682}, {1.3089969389957472`, 0}}, {
         Scaled[{-0.04, 0}, {0, 1.}], {1.5707963267948966`, 1}, {
          1.5707963267948966`, 0}}}]], 
      LineBox[NCache[{{0, 0}, {Rational[1, 2] Pi, 0}}, {{0, 0}, {
         1.5707963267948966`, 0}}]], 
      {RGBColor[1, 0, 0], PointSize[Medium], 
       PointBox[
        NCache[{{0, 0}, {
          Rational[1, 12] 
           Pi, (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}, {
          Rational[1, 6] Pi, Rational[1, 2]}, {
          Rational[1, 4] Pi, 2^Rational[-1, 2]}, {
          Rational[1, 3] Pi, Rational[1, 2] 3^Rational[1, 2]}, {
          Rational[5, 12] 
           Pi, (Rational[1, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {
          Rational[1, 2] Pi, 1}}, {{0, 0}, {0.2617993877991494, 
          0.2588190451025207}, {0.5235987755982988, 0.5}, {0.7853981633974483,
           0.7071067811865475}, {1.0471975511965976`, 0.8660254037844386}, {
          1.3089969389957472`, 0.9659258262890682}, {
          1.5707963267948966`, 1}}]]}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwt1Akw1lsDx3HhRnW7V2WLUFSakDa3utSvRSjdQkmJFvtVloRKllba3PSQ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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->821173837]
}, Open  ]],

Cell["You can include directives such as Opacity and EdgeForm.", "ExampleText",
 CellID->1789275847],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   RowBox[{"Sin", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", " ", 
     RowBox[{"\[Pi]", "/", "2"}]}], "}"}], ",", "6", ",", 
   RowBox[{"BarStyles", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"EdgeForm", "[", "Black", "]"}], ",", 
        RowBox[{"Opacity", "[", ".5", "]"}], ",", "Red"}], "]"}], ",", 
      RowBox[{"Directive", "[", 
       RowBox[{
        RowBox[{"EdgeForm", "[", "Yellow", "]"}], ",", 
        RowBox[{"Opacity", "[", ".5", "]"}], ",", "Green"}], "]"}]}], 
     "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1145651588],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0, 0], Opacity[0.5], EdgeForm[GrayLevel[0]], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.}], 
        Scaled[{-0.04, 0}, {0, 0.2588190451025207}], 
        Scaled[{0, 0}, {0, 0.2588190451025207}], Scaled[{0, 0}, {0, 0.}]}, {
       Scaled[{-0.04, 0}, {0, 0.5}], 
        Scaled[{-0.04, 0}, {0, 0.7071067811865475}], 
        Scaled[{0, 0}, {0, 0.7071067811865475}], Scaled[{0, 0}, {0, 0.5}]}, {
       Scaled[{-0.04, 0}, {0, 0.8660254037844386}], 
        Scaled[{-0.04, 0}, {0, 0.9659258262890682}], 
        Scaled[{0, 0}, {0, 0.9659258262890682}], 
        Scaled[{0, 0}, {0, 0.8660254037844386}]}}]}, 
    {RGBColor[0, 1, 0], Opacity[0.5], EdgeForm[RGBColor[1, 1, 0]], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.2588190451025207}], 
        Scaled[{-0.04, 0}, {0, 0.5}], Scaled[{0, 0}, {0, 0.5}], 
        Scaled[{0, 0}, {0, 0.2588190451025207}]}, {
       Scaled[{-0.04, 0}, {0, 0.7071067811865475}], 
        Scaled[{-0.04, 0}, {0, 0.8660254037844386}], 
        Scaled[{0, 0}, {0, 0.8660254037844386}], 
        Scaled[{0, 0}, {0, 0.7071067811865475}]}, {
       Scaled[{-0.04, 0}, {0, 0.9659258262890682}], 
        Scaled[{-0.04, 0}, {0, 1.}], Scaled[{0, 0}, {0, 1.}], 
        Scaled[{0, 0}, {0, 0.9659258262890682}]}}], 
     {RGBColor[0.9, 0, 1.], Thickness[Medium], Opacity[0.95], Arrowheads[
      Small], ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.06470476127563017}], 
        Scaled[{-0.02, 0}, {0, 0.1941142838268905}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.5517766952966369}], 
        Scaled[{-0.02, 0}, {0, 0.6553300858899106}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.891000509410596}], 
        Scaled[{-0.02, 0}, {0, 0.9409507206629109}]}], 
      {RGBColor[1, 0.95, 0], Thickness[Large], Opacity[0.95], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 0.3191142838268905}], 
         Scaled[{-0.02, 0}, {0, 0.4397047612756302}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 0.7468364368360203}], 
         Scaled[{-0.02, 0}, {0, 0.8262957481349659}]}]}, 
      {GrayLevel[0.4], Thickness[Small], Opacity[1], 
       LineBox[NCache[{{
          Scaled[{-0.04, 0}, {0, 0.2588190451025207}], {
           Rational[1, 12] 
            Pi, (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}, {
           Rational[1, 12] Pi, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.5}], {Rational[1, 6] Pi, Rational[1, 2]}, {
           Rational[1, 6] Pi, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.7071067811865475}], {
           Rational[1, 4] Pi, 2^Rational[-1, 2]}, {Rational[1, 4] Pi, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.8660254037844386}], {
           Rational[1, 3] Pi, Rational[1, 2] 3^Rational[1, 2]}, {
           Rational[1, 3] Pi, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.9659258262890682}], {
           Rational[5, 12] 
            Pi, (Rational[1, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {
           Rational[5, 12] Pi, 0}}, {
          Scaled[{-0.04, 0}, {0, 1.}], {Rational[1, 2] Pi, 1}, {
           Rational[1, 2] Pi, 0}}}, {{
          Scaled[{-0.04, 0}, {0, 0.2588190451025207}], {0.2617993877991494, 
           0.2588190451025207}, {0.2617993877991494, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.5}], {0.5235987755982988, 0.5}, {
           0.5235987755982988, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.7071067811865475}], {0.7853981633974483, 
           0.7071067811865475}, {0.7853981633974483, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.8660254037844386}], {1.0471975511965976`, 
           0.8660254037844386}, {1.0471975511965976`, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.9659258262890682}], {1.3089969389957472`, 
           0.9659258262890682}, {1.3089969389957472`, 0}}, {
          Scaled[{-0.04, 0}, {0, 1.}], {1.5707963267948966`, 1}, {
           1.5707963267948966`, 0}}}]], 
       LineBox[NCache[{{0, 0}, {Rational[1, 2] Pi, 0}}, {{0, 0}, {
          1.5707963267948966`, 0}}]], 
       {RGBColor[1, 0, 0], PointSize[Medium], 
        PointBox[
         NCache[{{0, 0}, {
           Rational[1, 12] 
            Pi, (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}, {
           Rational[1, 6] Pi, Rational[1, 2]}, {
           Rational[1, 4] Pi, 2^Rational[-1, 2]}, {
           Rational[1, 3] Pi, Rational[1, 2] 3^Rational[1, 2]}, {
           Rational[5, 12] 
            Pi, (Rational[1, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {
           Rational[1, 2] Pi, 1}}, {{0, 0}, {0.2617993877991494, 
           0.2588190451025207}, {0.5235987755982988, 0.5}, {
           0.7853981633974483, 0.7071067811865475}, {1.0471975511965976`, 
           0.8660254037844386}, {1.3089969389957472`, 0.9659258262890682}, {
           1.5707963267948966`, 1}}]]}}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwt1Akw1lsDx3HhRnW7V2WLUFSakDa3utSvRSjdQkmJFvtVloRKllba3PSQ
WxKpLEV6nspSJLdSSEY8ZHmsWbIexPOcB/GeZt4zc+Y7n5lzzvxn/mfOPAcv
K2dJCQmJO2z+rNTrqaVfDQ6tk/x/F3TmGapHAly/9do/O8LVd6rh7MD50VUz
f7ZN3o1mcg7Axiecm8Faa3L+TSLHC9P+0rx/l7XyAEf7DicEkavUH11ktToy
u/Ym5xoMdGNaTVivD9o9i+bEo7HxbtP26/EwLNg6deMxLtJTCjfaeXPhHbD9
0DPvbNTamtmtcM2GR7bzP5Ja+UjQTAiepZwP/rctU5Id3qFUQfhv3LZ3uKwv
lMjcW4hb+k8L9VYW4qhO4Y38xBJYW542SncrwYjj4fR6zzLIe00tK15fBodX
uy0iXMrxVHuhCllQDscBfn7+RT4an18MnqzPx9WlWV5JoVXYKOe/10quCpL5
WavOB1TD/V5v/peWL5ix2Ly08WYtAmf75l+vqoFZ/Mb7/RwBJtT13u66Vwcl
UmISktWAni3JLr+H1yPmw8tJUn83oTWJyHFcGmGktmFirlMzflVW9dS72gSd
JrnWIN8WjKfFfuv0acbjlJluGT5fsUn3fU3F5hYENthX6IS2wpbM6jZZ8BVH
jVabx0W1YavroffGo18xEm/s0B3RDput/ieaX7WizDvm4PF7HZh074yp/pU2
rDHVHK9P+IauMfciq83tKNq8JmV9bCfmTFIu8hC2I5F3a01LaheKxzKr93A7
oKCl677/YTfOmtl+rbT5hvJJsmdn5/ZAOTA0Lm5yJzJkjyWVFfXiiF5l+MrU
TugqyLk7FPQhOt9U/691XSD/COVXVBFkWxk3J1d1QSssTN/LvR9DZ7T6JfZ3
o8W2rnZjRz9cfNWC1QTdMGurEGd4DiDPfLqTv30PTvg4uyn2DuCiTS8dK+3B
9szbWxX9BzFNRfaaxsZe9I25B0oJB7GwfNnamUm9SPhy5rnnse+Yr8NLa5To
w4jb2oMnR79DS5kqr9nXB7Uf1/cdDRjCnJ5nT8qS+9BueqVYVnoYo2UyLdsG
+/B2YQnUrwxDtn7lpZzlBO6ySdLzpggh8Er7VdKV4KPkxfBN04QIXc6V5TPr
/vhb0WW6EAcnRfgluhGQAb1FqTOEUBfwE0zcCXzrMswNVIT4/Hqa8VkPgqD0
As4WHSE2eNLUhmMEEbva5vr8JcSujw/6dU4TZN2dv/btdSHM7FyuKv1LMH/C
+NR/kULw0jOUXzJH2Du/eH1DiMXF57TtbhK4qSQZ5N4SYvYOTkncLQKVKO0l
GQlCXEhYvlI9liAwbLFGMk8IbSub478kEGz0XDrpymchTl/Ynuv3iCC9xAKX
KoR44PQqUjaVQFXnaFBYpRCutvt7Y5iHOnjiczVCLPHX085LI0g8tGIwsFmI
Nqv/no+nE8ha//HVc0CIvYs/Gbg9Iyg1NCqwmiHCn/pm+YIcgsvZfqMms0R4
66htap9LYGrwZJmhggg2NoJd9cz5SzTjtGaLwK95LS14RfBsnuzxobkilBmv
zqx4TXBThr8oeqkIES7b9qe9JXCsOHy1ZocIh122Z0p+JJhrkfjmk6UIpzZb
y/syC0oa6H87RXhsSmkr8+73ls6PbERYNTptd0EJgdmLVetOHRDh6BHDA6dL
CZbES/XP8RJhfuXWtMbPBNT99s6D/4hA3k9fuKma4FrAfZmQCBGmNg8nPmZe
eDk15w5HhCfVedFKNQTWD3O06qJFSB7sLu5kftpR9906XoQwu5CgsDqCI05z
osy57Ly7oikpDQRN9nf4f5SLkJuu+DyoleC4R+JFa74IiZncbVXMvwU9NvKt
EsFPNGS9pI1gbeyrB7xaETJFfi8FzDG19b66X0UwMNf/uLyDYJeNuoLmkAjS
xsunvuskKLSIt56uSNFbeWMooI/d33dteTLKFLpju7tymaev1l0kqULhOl/L
cZzZSuPFiFCNou9UdX0IIajrLY9vWkDR9eK2KLCfoO/y5K5nBhTUPD3nwCC7
f+PbdqavoriRnNp8i3mFT2RuyhoKg44HlyuYT+yde+3OWor68DDnzd8JJBf9
uTJsM8XZTcPrtIYIFAo8gm2tKWS6M0M+DLN3YfXzjl02FIsGfq0UM9umjVjs
2EsRmmT5WEdIEBcZpmVsT8GVf9AezrzIIaFQz5ni/bw9gdtEBEYT/JmT/Ch2
29uteEoJGnxUA0f9Kb4rmWQJmM+0H2obPkHh/cesvMligvef+rK6Aik0f7fe
tZd5R6ysPf88hXyq833K7LDGKDk5iiKEt/KjxijB372fhgXRFEpRzUEmzN4J
B4xn3qLokboddYQ5ZMq55sA7FPbJS/symWNrilStkih+uFZYGo8R3A/f5x6W
QuE09fN8F+ZHG3qzcx+x9a8r94Uxv3got1v7CcU8wcDwB+aqkzYRY1nse9oc
azf8IKjX62xY9pLtn3bp037m1uYAPddcildh3PmnmL9viSv+nE+RZyc9wWOW
U2mTTi6iSFPgOSqPEyiV+u8UfKRY6Vfrv5RZ/azsvRml7P/rSvaZMut16SCw
nEK5bqusH/PWlz4nLesohN4ZPR+YLT2lC0PrKZy5BRp1zHs0oxVzGyksZT5n
9jK7Xn7xbGErxVjkF7kZEwSe68wl7dop9qqVV8xj9h8UWFz/RuHh/H5kGfN5
W4m+0R6KFHGMrwXzld84RssIxQpewIf9zJw3WldcBijWjlsFH2FOWGy66PMw
xRaLHqVQ5pSGav/JlMK/Om3kOjOX415gOEJxcsxpwx3mvJFwh6RxCmnkjPCY
C9I1eHUSYgTTPR45zCUOvAk5KTGenuvd9I6Zr7hpu8kvYpzPOBFcwlxXzI89
JSPGF+eROXzmlmCXbu4UMc54+WjUMXctp2vap4mxm9t0oZl5oP3SRdXfxNCY
stmig5nGqH6xkBPjrn18cA/zxPbHC0JnihEdReQGmCdLwTdHXoyMfw1khpmn
Z5W96VcUI3Xn0UOUWf6ww4yFs8WYm31PY5RZVWPowD5VMZ5nFW34waxZcSE9
Qk2MCdP2D+PMi8OUfhRoiBF5iPImmJcZPjQfnSfG6MTPQfA/p0NHIQ==
      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[3]=",
 CellID->1864501087]
}, Open  ]],

Cell["\<\
If you specify styles for the edges set and include Opacity[0] the polygons \
will be rendered as clear.\
\>", "ExampleText",
 CellID->588392185],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   SuperscriptBox["x", "2"], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "8", ",", 
   RowBox[{"BarStyles", "\[Rule]", " ", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{
        RowBox[{"EdgeForm", "[", "Black", "]"}], ",", 
        RowBox[{"Opacity", "[", "0", "]"}]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"EdgeForm", "[", "Red", "]"}], ",", 
        RowBox[{"Opacity", "[", "0", "]"}]}], "}"}]}], "}"}]}]}], 
  "]"}]], "Input",
 CellLabel->"In[4]:=",
 CellID->2092742507],

Cell[BoxData[
 GraphicsBox[{{
    {Opacity[0], EdgeForm[GrayLevel[0]], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.}], Scaled[{-0.04, 0}, {0, 0.015625}], 
        Scaled[{0, 0}, {0, 0.015625}], Scaled[{0, 0}, {0, 0.}]}, {
       Scaled[{-0.04, 0}, {0, 0.0625}], Scaled[{-0.04, 0}, {0, 0.140625}], 
        Scaled[{0, 0}, {0, 0.140625}], Scaled[{0, 0}, {0, 0.0625}]}, {
       Scaled[{-0.04, 0}, {0, 0.25}], Scaled[{-0.04, 0}, {0, 0.390625}], 
        Scaled[{0, 0}, {0, 0.390625}], Scaled[{0, 0}, {0, 0.25}]}, {
       Scaled[{-0.04, 0}, {0, 0.5625}], Scaled[{-0.04, 0}, {0, 0.765625}], 
        Scaled[{0, 0}, {0, 0.765625}], Scaled[{0, 0}, {0, 0.5625}]}}]}, 
    {Opacity[0], EdgeForm[RGBColor[1, 0, 0]], 
     PolygonBox[{{
       Scaled[{-0.04, 0}, {0, 0.015625}], Scaled[{-0.04, 0}, {0, 0.0625}], 
        Scaled[{0, 0}, {0, 0.0625}], Scaled[{0, 0}, {0, 0.015625}]}, {
       Scaled[{-0.04, 0}, {0, 0.140625}], Scaled[{-0.04, 0}, {0, 0.25}], 
        Scaled[{0, 0}, {0, 0.25}], Scaled[{0, 0}, {0, 0.140625}]}, {
       Scaled[{-0.04, 0}, {0, 0.390625}], Scaled[{-0.04, 0}, {0, 0.5625}], 
        Scaled[{0, 0}, {0, 0.5625}], Scaled[{0, 0}, {0, 0.390625}]}, {
       Scaled[{-0.04, 0}, {0, 0.765625}], Scaled[{-0.04, 0}, {0, 1.}], 
        Scaled[{0, 0}, {0, 1.}], Scaled[{0, 0}, {0, 0.765625}]}}], 
     {RGBColor[0.9, 0, 1.], Thickness[Medium], Opacity[0.95], Arrowheads[
      Small], ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.08203125}], 
        Scaled[{-0.02, 0}, {0, 0.12109375}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.28515625}], 
        Scaled[{-0.02, 0}, {0, 0.35546875}]}], 
      ArrowBox[{
       Scaled[{-0.02, 0}, {0, 0.61328125}], 
        Scaled[{-0.02, 0}, {0, 0.71484375}]}], 
      {RGBColor[1, 0.95, 0], Thickness[Large], Opacity[0.95], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 0.16796875}], 
         Scaled[{-0.02, 0}, {0, 0.22265625}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 0.43359375}], 
         Scaled[{-0.02, 0}, {0, 0.51953125}]}], 
       ArrowBox[{
        Scaled[{-0.02, 0}, {0, 0.82421875}], 
         Scaled[{-0.02, 0}, {0, 0.94140625}]}]}, 
      {GrayLevel[0.4], Thickness[Small], Opacity[1], 
       LineBox[
        NCache[{{
          Scaled[{-0.04, 0}, {0, 0.015625}], {
           Rational[1, 8], Rational[1, 64]}, {Rational[1, 8], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.0625}], {
           Rational[1, 4], Rational[1, 16]}, {Rational[1, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.140625}], {
           Rational[3, 8], Rational[9, 64]}, {Rational[3, 8], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.25}], {Rational[1, 2], Rational[1, 4]}, {
           Rational[1, 2], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.390625}], {
           Rational[5, 8], Rational[25, 64]}, {Rational[5, 8], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.5625}], {
           Rational[3, 4], Rational[9, 16]}, {Rational[3, 4], 0}}, {
          Scaled[{-0.04, 0}, {0, 0.765625}], {
           Rational[7, 8], Rational[49, 64]}, {Rational[7, 8], 0}}, {
          Scaled[{-0.04, 0}, {0, 1.}], {1, 1}, {1, 0}}}, {{
          Scaled[{-0.04, 0}, {0, 0.015625}], {0.125, 0.015625}, {0.125, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.0625}], {0.25, 0.0625}, {0.25, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.140625}], {0.375, 0.140625}, {0.375, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.25}], {0.5, 0.25}, {0.5, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.390625}], {0.625, 0.390625}, {0.625, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.5625}], {0.75, 0.5625}, {0.75, 0}}, {
          Scaled[{-0.04, 0}, {0, 0.765625}], {0.875, 0.765625}, {0.875, 0}}, {
          Scaled[{-0.04, 0}, {0, 1.}], {1, 1}, {1, 0}}}]], 
       LineBox[{{0, 0}, {1, 0}}], 
       {RGBColor[1, 0, 0], PointSize[Medium], 
        PointBox[
         NCache[{{0, 0}, {Rational[1, 8], Rational[1, 64]}, {
           Rational[1, 4], Rational[1, 16]}, {
           Rational[3, 8], Rational[9, 64]}, {
           Rational[1, 2], Rational[1, 4]}, {
           Rational[5, 8], Rational[25, 64]}, {
           Rational[3, 4], Rational[9, 16]}, {
           Rational[7, 8], Rational[49, 64]}, {1, 1}}, {{0, 0}, {0.125, 
           0.015625}, {0.25, 0.0625}, {0.375, 0.140625}, {0.5, 0.25}, {0.625, 
           0.390625}, {0.75, 0.5625}, {0.875, 0.765625}, {1, 
           1}}]]}}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwVlWk01AsYxm2VVBNaNBNX2UppUtlS5rGVLSpbiSayJHUZJUo3jIxSRF2X
MIUYJcugQcaSLVpQthBGISH8c+OqVK4+vOc55znP7/f1XX/cx9pdREhI6M78
/U5z9+HmyhE72pT1zNZJkYrdYkYURh9ZAxEGed6d+hdoO5Jvsx+RjfFU/f4B
L/0E2qCsEjNAxQr+Rbz9Vp7ZNIvGjoI7ZFto5/8w2KFfQlOKlOPMyTtgxQlT
X3l+De2HuWu8iwodwg4vxZQ9G2ijYW21LnEu0Iiv2bLKrpV2yG2m/BbZDZwv
5XwZ/S5arRGluIbtgbYqW1XKdB9NXVEvb0r+JARCtbtJ/AEaW8Q5UzntFPK6
suyiBR9p4v2h9+xVvOHyyeWYpOcYjf+upbHGloEZypds06zPNMYBN3OnOF/k
OrEVFtt9ofVuvWIURfaDl6bSzGL9b7TY5DWVyo7nwGgQsTdn/qCZL3+4u4Lt
j4Fg0xyJ6Tla0USDJiF/AUvuht1bwBfFaTq94IpLILwUqqs5TxZAoYmgrku7
CBHNHX0swSLcyJHeeFAlCB1ieUsXei7FHrn09JETwZCpLpXLaCEhqC5Rsso2
BPXhl1YZZUlCQ0styiGOiZgNEnKidiuQsmp/+DVyGHwqDq8S1SfjYmN8rT0/
DGPt2SSbtxTYs96JKDqywOJRFhoxZbF02je4lB0OiXojQmRaHufbYs+PyUcg
P8XdTpivCJvI3qLHlREQPPM3zyxRAtVYZTrM5RoS22JpqU+UMfio2Fcu7Tr4
cTOKTMEGHPz7rZeVyg2kPz00IOSpBjULxUxK/Q0YSLx+vTFxC8RFT38cOhGN
P7fblae0UHGs5Ff+E9sYFK2uMdPPUscq1Rjq4bibED9hQBGy2wGm+KMNEeRY
fHc6mz6HndhkcvNqASMWs3uz1nXK6qKF5TPSXR8L0zU8A4+fulASVcui+v+D
ZobOmbTnu1H3M53a1hKHqh+sugMm+lj6JU5TPjIBlRqErb27MQq3nYszHUjA
VrdbJT6TxqAzbGZ8dROxZ9Hdz67Be8AdX15SO5wItwcT7T0pe2E9fHW31x42
AuzPXZL8borbvYFGhb/u4qPLGv3gBVYwkHVIF9gl4+lLw5d7uFYYPaK9QDwn
GWaZ7Rs/HtmPP8YuuOZsSUHascQtvY4H4HNSS1moJwVXN5+2aq45CGk37gOO
zj18S3xrpldpi8MOqdzPk+lgdPZvUDrlCKLbVuIehQNHD9W8VW8cEU4Xd7cx
4mDsmb3mGwMnPHL1oRTFcvBjiYdW7dqjIHnrsS5qZ+B9hP0K2y46noZ2HVl4
6T6cCsBO1XPB9myphbLiD2Fi8TV+6xZ3PKc+dW5Uf4i4nqubbvu4wzn/fGmQ
w0Nod0bu8ixwR1RRH+P9w4fwJRGdtJ0eGK7M6c6wzEK9v6xwncUJ3G03y9/2
dzZmtNYu2h12EkvmmE4mf3DBOPdgpM7QG7dPHqKr7eXierJiV3SMN5Ta1Jyl
vLmICGo3KBN4g5bZ4dpdzoW2Y28Q/vJBSWZcYTE1D5z6itaZowyM24yVWTTl
QXUy2GE2wxd2D+Jfnl1WgC/k8K79dD+wj4bu81hfAMufuYOnrvuhX/rPxsOa
BZDZdTa75LEffC4ZvtI7WgCxukbf0RXnEGE93rIopwA7yS9bUxrOofyH4duk
fY+wqnBoytkkAMoHJ4ZrrvNwozo1i3o8EJRgE90TqTw0JFUZCBICIZmTcl2i
mAevZGv6s+ZAfBe3oR7s56Fc+dmmfYYX8bqy+KxApxCdVGEpaZW/EKjO/PX1
QyGqtmdJx3+9hKblK1dS9YtREeIzXT0YgoCmnbg9VQKz3uMBF5exQKIWfngu
zsff5B3B5lQW0qPUI2dl+ahml4vu2M9C874NXfQ9fHQECF8+cJOFzS9XnlWO
46M9xPhI+epw9NUTGQXapaAIik/RVa7ApIpDagwsw+unNpSKwxGQ4UkJhIWf
YMLMOePL4hso6jdqeLW7Gi8Ck7P5z2NR7XVnrcNYLchnHiwJdUrCtIre8pw/
6+HBuZK9bkMqRL5lSa5VfoGgoVrhACcOtOaci2xyG3BnrRv1GS8TDWEaTXWb
XkFxoxad4pgL+ZhP3zInXoM0x53d9Skfn2b6BO3qLWiY6Tbyz+UhfbT0BelG
K9hMiueBoWKQ5O4Tg4NtCE5OerfQrBSRJws9UpTewGltxL9LORX4Tz9r0DO4
AwwpjrSCQRX8ttfyVtd0wjl48pSJag36cmuvN69/C2JZtv6aQ08x69WWpBrY
jaBqRuzX+HpsNlj0y6O0B0oKN0v0Gp7D5N76E/kyArxq0lUL2teAALljCu+d
+hDUYVkvXN4EtTG7JR2W77BQo6Z+453XWLH8s3jt93f4sdfBrF+sBWJPkriK
7PeoGz0S9cSlFac0SrsWW/QjlGm8Wmu0DVlmx1Mq/utHyNoQGYnAN5j+RJEc
ihuA8deuyMnZDhTamIjGGg9C4/T9mfjsLgSbspJ5Q4OIPp8rX23ZjfW95p1p
rA/w20Gz3vSlB7raYbHk7UN4XOyn4/pCAKc/Xn0Tbh3CEePr5Fsm7zD9Iqqf
wfwIcppTr5zxe9wWo/tZKw0j4MDH4XStfqwQFN4TqR1GtM6RWN6mASy4xLTd
6TuC+m67bYG6gxDKpHP7pUfxddw4tJT2AWcSuVHS1aMQJdE2zBwbQvnmq+JS
3p+w/HKEjfblj5AyP6MWShrDT+9KF6+EYfRsed16oWwM2eNTFpubRpB3F0qD
9HHIvDg+uHp6FEe5WlJyv8ah+Xz+a8qOIYSVyux5OIGpjL4n467jyBmWSyLt
I3Dt1KSUFHsCV++wnAVWBL49U9C7mToBN+tx5dyDBAqjXg1J3Z+AbFlZnuUh
AtKWSYUrCyZwLdqxLvI4AYe0Wf11zybgqZUwKXGBgGZuH2n/1AQUwlaaLsog
IK6neWWJJYFfOn8t63hA4OflVmaSNYGu8YGWjCwCetvHv28+TCDm0KOje/MJ
pNXe8rRyJTC3yfosq4yASFXGtoR5b09z9F3RVgIL1/wbuHfe+zh8xrW1nUBF
696jgnlP7K5jqmmdBGr+W13hP++x4FB5hgICuWdUZx/Me/jnG58zRwisMZRx
XTHviduiGX1wjMA2HZOd3HnOt59tu54g8M8//0ZZzHMb953uq5wiYBheWsCa
58SE29JjZghEkrtCFed37wp3eTl/J6C48kxz1fyuzCttq/pPAgv8w+/+7uPl
l0zPzRHYjtWjv/N/9SW6zA==
      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 361},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[4]=",
 CellID->1125205403]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "BarWidths",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->763435684],

Cell[TextData[{
 "Bar widths are given as a fraction of the total width of the plot, that is \
as a fraction of the distance between ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["x", "TI"], 
   StyleBox["min", "TI"]]], "InlineFormula"],
 " and ",
 Cell[BoxData[
  SubscriptBox[
   StyleBox["x", "TI"], 
   StyleBox["max", "TI"]]], "InlineFormula"],
 "."
}], "ExampleText",
 CellID->1130371363],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1912064953],

Cell["This makes wide bars.", "ExampleText",
 CellID->1511156579],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   RowBox[{"Sin", "[", "x", "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", 
     RowBox[{"\[Pi]", "/", "2"}]}], "}"}], ",", "6", ",", 
   RowBox[{"BarWidths", "\[Rule]", " ", ".1"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1867013831],

Cell[BoxData[
 GraphicsBox[{{
    {RGBColor[1, 0.95, 0], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.1, 0}, {0, 0.}], Scaled[{-0.1, 0}, {0, 0.2588190451025207}],
         Scaled[{0, 0}, {0, 0.2588190451025207}], Scaled[{0, 0}, {0, 0.}]}, {
       Scaled[{-0.1, 0}, {0, 0.5}], 
        Scaled[{-0.1, 0}, {0, 0.7071067811865475}], 
        Scaled[{0, 0}, {0, 0.7071067811865475}], Scaled[{0, 0}, {0, 0.5}]}, {
       Scaled[{-0.1, 0}, {0, 0.8660254037844386}], 
        Scaled[{-0.1, 0}, {0, 0.9659258262890682}], 
        Scaled[{0, 0}, {0, 0.9659258262890682}], 
        Scaled[{0, 0}, {0, 0.8660254037844386}]}}]}, 
    {RGBColor[0.9, 0, 1.], Opacity[0.4], EdgeForm[{GrayLevel[0.5], 
     AbsoluteThickness[0.4]}], 
     PolygonBox[{{
       Scaled[{-0.1, 0}, {0, 0.2588190451025207}], 
        Scaled[{-0.1, 0}, {0, 0.5}], Scaled[{0, 0}, {0, 0.5}], 
        Scaled[{0, 0}, {0, 0.2588190451025207}]}, {
       Scaled[{-0.1, 0}, {0, 0.7071067811865475}], 
        Scaled[{-0.1, 0}, {0, 0.8660254037844386}], 
        Scaled[{0, 0}, {0, 0.8660254037844386}], 
        Scaled[{0, 0}, {0, 0.7071067811865475}]}, {
       Scaled[{-0.1, 0}, {0, 0.9659258262890682}], Scaled[{-0.1, 0}, {0, 1.}],
         Scaled[{0, 0}, {0, 1.}], Scaled[{0, 0}, {0, 0.9659258262890682}]}}], 
     {RGBColor[0.9, 0, 1.], Thickness[Medium], Opacity[0.95], Arrowheads[
      Small], ArrowBox[{
       Scaled[{-0.05, 0}, {0, 0.06470476127563017}], 
        Scaled[{-0.05, 0}, {0, 0.1941142838268905}]}], 
      ArrowBox[{
       Scaled[{-0.05, 0}, {0, 0.5517766952966369}], 
        Scaled[{-0.05, 0}, {0, 0.6553300858899106}]}], 
      ArrowBox[{
       Scaled[{-0.05, 0}, {0, 0.891000509410596}], 
        Scaled[{-0.05, 0}, {0, 0.9409507206629109}]}], 
      {RGBColor[1, 0.95, 0], Thickness[Large], Opacity[0.95], 
       ArrowBox[{
        Scaled[{-0.05, 0}, {0, 0.3191142838268905}], 
         Scaled[{-0.05, 0}, {0, 0.4397047612756302}]}], 
       ArrowBox[{
        Scaled[{-0.05, 0}, {0, 0.7468364368360203}], 
         Scaled[{-0.05, 0}, {0, 0.8262957481349659}]}]}, 
      {GrayLevel[0.4], Thickness[Small], Opacity[1], 
       LineBox[
        NCache[{{
          Scaled[{-0.1, 0}, {0, 0.2588190451025207}], {
           Rational[1, 12] 
            Pi, (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}, {
           Rational[1, 12] Pi, 0}}, {
          Scaled[{-0.1, 0}, {0, 0.5}], {Rational[1, 6] Pi, Rational[1, 2]}, {
           Rational[1, 6] Pi, 0}}, {
          Scaled[{-0.1, 0}, {0, 0.7071067811865475}], {
           Rational[1, 4] Pi, 2^Rational[-1, 2]}, {Rational[1, 4] Pi, 0}}, {
          Scaled[{-0.1, 0}, {0, 0.8660254037844386}], {
           Rational[1, 3] Pi, Rational[1, 2] 3^Rational[1, 2]}, {
           Rational[1, 3] Pi, 0}}, {
          Scaled[{-0.1, 0}, {0, 0.9659258262890682}], {
           Rational[5, 12] 
            Pi, (Rational[1, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {
           Rational[5, 12] Pi, 0}}, {
          Scaled[{-0.1, 0}, {0, 1.}], {Rational[1, 2] Pi, 1}, {
           Rational[1, 2] Pi, 0}}}, {{
          Scaled[{-0.1, 0}, {0, 0.2588190451025207}], {0.2617993877991494, 
           0.2588190451025207}, {0.2617993877991494, 0}}, {
          Scaled[{-0.1, 0}, {0, 0.5}], {0.5235987755982988, 0.5}, {
           0.5235987755982988, 0}}, {
          Scaled[{-0.1, 0}, {0, 0.7071067811865475}], {0.7853981633974483, 
           0.7071067811865475}, {0.7853981633974483, 0}}, {
          Scaled[{-0.1, 0}, {0, 0.8660254037844386}], {1.0471975511965976`, 
           0.8660254037844386}, {1.0471975511965976`, 0}}, {
          Scaled[{-0.1, 0}, {0, 0.9659258262890682}], {1.3089969389957472`, 
           0.9659258262890682}, {1.3089969389957472`, 0}}, {
          Scaled[{-0.1, 0}, {0, 1.}], {1.5707963267948966`, 1}, {
           1.5707963267948966`, 0}}}]], 
       LineBox[NCache[{{0, 0}, {Rational[1, 2] Pi, 0}}, {{0, 0}, {
          1.5707963267948966`, 0}}]], 
       {RGBColor[1, 0, 0], PointSize[Medium], 
        PointBox[
         NCache[{{0, 0}, {
           Rational[1, 12] 
            Pi, (Rational[1, 2] 2^Rational[-1, 2]) (-1 + 3^Rational[1, 2])}, {
           Rational[1, 6] Pi, Rational[1, 2]}, {
           Rational[1, 4] Pi, 2^Rational[-1, 2]}, {
           Rational[1, 3] Pi, Rational[1, 2] 3^Rational[1, 2]}, {
           Rational[5, 12] 
            Pi, (Rational[1, 2] 2^Rational[-1, 2]) (1 + 3^Rational[1, 2])}, {
           Rational[1, 2] Pi, 1}}, {{0, 0}, {0.2617993877991494, 
           0.2588190451025207}, {0.5235987755982988, 0.5}, {
           0.7853981633974483, 0.7071067811865475}, {1.0471975511965976`, 
           0.8660254037844386}, {1.3089969389957472`, 0.9659258262890682}, {
           1.5707963267948966`, 1}}]]}}}}}, {{}, {}, 
    {Hue[0.67, 0.6, 0.6], LineBox[CompressedData["
1:eJwt1Akw1lsDx3HhRnW7V2WLUFSakDa3utSvRSjdQkmJFvtVloRKllba3PSQ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      "]]}}},
  AlignmentPoint->Center,
  AspectRatio->1,
  Axes->True,
  AxesLabel->None,
  AxesOrigin->Automatic,
  AxesStyle->{},
  Background->None,
  BaseStyle->{},
  BaselinePosition->Automatic,
  ColorOutput->Automatic,
  ContentSelectable->Automatic,
  CoordinatesToolOptions:>Automatic,
  DisplayFunction:>$DisplayFunction,
  Epilog->{},
  FormatType:>TraditionalForm,
  Frame->False,
  FrameLabel->None,
  FrameStyle->{},
  FrameTicks->{{None, None}, {Automatic, None}},
  FrameTicksStyle->{},
  GridLines->None,
  GridLinesStyle->{},
  ImageMargins->0.,
  ImagePadding->All,
  ImageSize->Automatic,
  ImageSizeRaw->Automatic,
  LabelStyle->{},
  Method->Automatic,
  PlotLabel->None,
  PlotRange->All,
  PlotRangeClipping->False,
  PlotRangePadding->Automatic,
  PlotRegion->Automatic,
  PreserveImageOptions->Automatic,
  Prolog->{},
  RotateLabel->True,
  Ticks->{Automatic, None},
  TicksStyle->{}]], "Output",
 ImageSize->{364, 342},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->2017891300]
}, Open  ]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "ReferenceLine",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSubsection"],
  $Line = 0; Null]], "ExampleSubsection", "ExampleSubsection",
 WholeCellGroupOpener->True,
 CellID->1996233810],

Cell["\<\
The ReferenceLine option allows choosing the origins of the lines demarcating \
the uniform intervals.\
\>", "ExampleText",
 CellID->1479675906],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->1052319882],

Cell["\<\
Here the default location is used putting the line at the bottom of the plot.\
\>", "ExampleText",
 CellID->1812423729],

Cell[CellGroupData[{

Cell["\<\
TimeIntervalPlot[Sin[x], {x, \[Pi]/2, 3 \[Pi]/2}, 12, BarWidths \[Rule] .06]\
\>", "Input",
 CellLabel->"In[2]:=",
 CellID->1497564255],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS2Us762h+euaypHjq2srBw7srKy8mDOWogrkFgkEolFRiKxSCQSG4lE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    "], {{0, 346}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 346},
  PlotRange->{{0, 360}, {0, 346}}]], "Output",
 ImageSize->{364, 346},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->29747292]
}, Open  ]],

Cell[BoxData[
 RowBox[{"`", 
  RowBox[{"\[AliasDelimiter]", "\[AliasDelimiter]"}]}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1999057660],

Cell["Here the reference line is taken to be the axis.", "ExampleText",
 CellID->1513908512],

Cell[CellGroupData[{

Cell["\<\
TimeIntervalPlot[Sin[ x], {x, \[Pi]/2, 3 \[Pi]/2}, 12, BarWidths \[Rule] \
.06,ReferenceLine \[Rule] 0.0]\
\>", "Input",
 CellLabel->"In[4]:=",
 CellID->874111528],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3S14q1C2xvHe55rKI4+trKysrYysjBzMPA/iCiQWiURikUgkFolEYpFI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    "], {{0, 346}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 346},
  PlotRange->{{0, 360}, {0, 346}}]], "Output",
 ImageSize->{364, 346},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[4]=",
 CellID->360232148]
}, Open  ]]
}, Closed]]
}, Closed]],

Cell[CellGroupData[{

Cell[BoxData[
 InterpretationBox[Cell[TextData[{
   "Neat Examples",
   "\[NonBreakingSpace]\[NonBreakingSpace]",
   Cell["(1)", "ExampleCount"]
  }], "ExampleSection"],
  $Line = 0; Null]], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->589267740],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->581429451],

Cell["\<\
Compare the different rates of acceleration of two polynomials.\
\>", "ExampleText",
 CellID->1034189107],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"TimeIntervalPlot", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"{", 
     RowBox[{
      SuperscriptBox["x", "2"], ",", 
      SuperscriptBox["x", "6"]}], "}"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", "8"}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->2031166178],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnS90q0y3xnvXNZWVx1YeWVlbGRkZ+WG+tRBXILFIJBKLHDly7EjkSOxI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    "], {{0, 354}, {360, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{360, 354},
  PlotRange->{{0, 360}, {0, 354}}]], "Output",
 ImageSize->{364, 354},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->493324182]
}, Open  ]]
}, Closed]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->131815360],

Cell[TextData[ButtonBox["Differentiation",
 BaseStyle->"Link",
 ButtonData->"paclet:ClassroomUtilities/guide/Differentiation"]], "MoreAbout",
 CellID->362149722]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"TimeIntervalPlot - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 31, 50.5540624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "TimeIntervalPlot[f, {x, x_min, x_max}, n, opts] plot f on the interval \
(x$min,x$max) partitioning the interval into n equal parts with bars \
indicating the change in f on each of the intervals.TimeIntervalPlot[{f_1, \
f_2}, {x, x_min, x_max}, n] plot f$1 and f$2 on the specified interval with \
bars indicating the change in f$1.TimeIntervalPlot[{{f_1, f_2}, f_i, ...}, \
{x, x_min, x_max}, n] plot f_1 and f_2 together with other functions f_i with \
bars to compare the changes in f_1 and f_2.", "synonyms" -> {}, "title" -> 
    "TimeIntervalPlot", "titlemodifier" -> "", "windowtitle" -> 
    "TimeIntervalPlot", "type" -> "Symbol", "uri" -> 
    "ClassroomUtilities/ref/TimeIntervalPlot"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[9580, 292, 489, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->82919490]},
 "RasterizedOutput"->{
  Cell[10953, 343, 9587, 165, 382, "Output",
   CellTags->"RasterizedOutput",
   CellID->189144459],
  Cell[20994, 529, 9929, 171, 382, "Output",
   CellTags->"RasterizedOutput",
   CellID->112728101],
  Cell[31388, 721, 13605, 231, 375, "Output",
   CellTags->"RasterizedOutput",
   CellID->531075589],
  Cell[45401, 972, 14474, 245, 369, "Output",
   CellTags->"RasterizedOutput",
   CellID->22328867],
  Cell[61053, 1266, 7725, 135, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->762116577],
  Cell[146095, 3144, 11705, 200, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->29747292],
  Cell[158249, 3365, 10738, 184, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->360232148],
  Cell[169935, 3591, 14008, 238, 70, "Output",
   CellTags->"RasterizedOutput",
   CellID->493324182]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 187151, 3915},
 {"RasterizedOutput", 187293, 3919}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[609, 21, 2586, 59, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3220, 84, 59, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3282, 87, 3351, 107, 217, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[6670, 199, 608, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->11594396],
Cell[7281, 219, 138, 4, 70, "Notes",
 CellID->1067943069],
Cell[7422, 225, 157, 4, 70, "Notes",
 CellID->283458494],
Cell[7582, 231, 197, 7, 70, "Notes",
 CellID->968179612],
Cell[7782, 240, 1621, 41, 70, "3ColumnTableMod",
 CellID->1654168308],
Cell[9406, 283, 137, 4, 70, "Notes",
 CellID->711145565]
}, Closed]],
Cell[CellGroupData[{
Cell[9580, 292, 489, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->82919490],
Cell[CellGroupData[{
Cell[10094, 310, 195, 6, 31, "ExampleSection",
 CellID->608720942],
Cell[10292, 318, 174, 4, 45, "ExampleText",
 CellID->1434352127],
Cell[10469, 324, 128, 3, 28, "Input",
 CellID->1652260914],
Cell[10600, 329, 96, 1, 32, "ExampleText",
 CellID->438142241],
Cell[CellGroupData[{
Cell[10721, 334, 229, 7, 30, "Input",
 CellID->135218924],
Cell[10953, 343, 9587, 165, 382, "Output",
 CellTags->"RasterizedOutput",
 CellID->189144459]
}, Open  ]],
Cell[20555, 511, 76, 1, 70, "ExampleText",
 CellID->382378570],
Cell[CellGroupData[{
Cell[20656, 516, 335, 11, 30, "Input",
 CellID->1365554166],
Cell[20994, 529, 9929, 171, 382, "Output",
 CellTags->"RasterizedOutput",
 CellID->112728101]
}, Open  ]],
Cell[30938, 703, 86, 1, 70, "ExampleText",
 CellID->1256978156],
Cell[CellGroupData[{
Cell[31049, 708, 336, 11, 30, "Input",
 CellID->1235232353],
Cell[31388, 721, 13605, 231, 375, "Output",
 CellTags->"RasterizedOutput",
 CellID->531075589]
}, Open  ]],
Cell[45008, 955, 117, 3, 70, "ExampleText",
 CellID->1195071940],
Cell[CellGroupData[{
Cell[45150, 962, 248, 8, 28, "Input",
 CellID->159545189],
Cell[45401, 972, 14474, 245, 369, "Output",
 CellTags->"RasterizedOutput",
 CellID->22328867]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[59924, 1223, 269, 8, 70, "ExampleSection",
 CellID->738429516],
Cell[CellGroupData[{
Cell[60218, 1235, 282, 8, 70, "ExampleSubsection",
 CellID->476879399],
Cell[60503, 1245, 127, 3, 70, "Input",
 CellID->564627589],
Cell[60633, 1250, 105, 2, 70, "ExampleText",
 CellID->2113135877],
Cell[CellGroupData[{
Cell[60763, 1256, 287, 8, 70, "Input",
 CellID->390130653],
Cell[61053, 1266, 7725, 135, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->762116577]
}, Open  ]],
Cell[68793, 1404, 97, 1, 70, "ExampleText",
 CellID->391849416],
Cell[CellGroupData[{
Cell[68915, 1409, 343, 10, 70, "Input",
 CellID->1628273010],
Cell[69261, 1421, 8481, 175, 382, "Output",
 CellID->623838389]
}, Open  ]],
Cell[77757, 1599, 117, 3, 70, "ExampleText",
 CellID->2035002437],
Cell[CellGroupData[{
Cell[77899, 1606, 287, 8, 70, "Input",
 CellID->2095336989],
Cell[78189, 1616, 8764, 181, 382, "Output",
 CellID->1891930617]
}, Open  ]],
Cell[CellGroupData[{
Cell[86990, 1802, 313, 9, 70, "Input",
 CellID->1903308715],
Cell[87306, 1813, 8764, 181, 382, "Output",
 CellID->1126810389]
}, Open  ]],
Cell[96085, 1997, 187, 6, 70, "ExampleText",
 CellID->836639269],
Cell[CellGroupData[{
Cell[96297, 2007, 452, 14, 70, "Input",
 CellID->1820757174],
Cell[96752, 2023, 8501, 175, 382, "Output",
 CellID->1971337315]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[105302, 2204, 280, 8, 70, "ExampleSubsection",
 CellID->503088389],
Cell[105585, 2214, 127, 3, 70, "Input",
 CellID->613407706],
Cell[105715, 2219, 98, 1, 70, "ExampleText",
 CellID->1621809142],
Cell[CellGroupData[{
Cell[105838, 2224, 381, 11, 70, "Input",
 CellID->1883801870],
Cell[106222, 2237, 277, 8, 70, "Print",
 CellID->69685236],
Cell[106502, 2247, 8883, 187, 382, "Output",
 CellID->821173837]
}, Open  ]],
Cell[115400, 2437, 100, 1, 70, "ExampleText",
 CellID->1789275847],
Cell[CellGroupData[{
Cell[115525, 2442, 716, 20, 70, "Input",
 CellID->1145651588],
Cell[116244, 2464, 9030, 187, 382, "Output",
 CellID->1864501087]
}, Open  ]],
Cell[125289, 2654, 155, 4, 70, "ExampleText",
 CellID->588392185],
Cell[CellGroupData[{
Cell[125469, 2662, 615, 19, 70, "Input",
 CellID->2092742507],
Cell[126087, 2683, 8742, 180, 382, "Output",
 CellID->1125205403]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[134878, 2869, 280, 8, 70, "ExampleSubsection",
 CellID->763435684],
Cell[135161, 2879, 394, 14, 70, "ExampleText",
 CellID->1130371363],
Cell[135558, 2895, 128, 3, 70, "Input",
 CellID->1912064953],
Cell[135689, 2900, 65, 1, 70, "ExampleText",
 CellID->1511156579],
Cell[CellGroupData[{
Cell[135779, 2905, 320, 9, 70, "Input",
 CellID->1867013831],
Cell[136102, 2916, 9066, 188, 363, "Output",
 CellID->2017891300]
}, Open  ]]
}, Closed]],
Cell[CellGroupData[{
Cell[145217, 3110, 285, 8, 70, "ExampleSubsection",
 CellID->1996233810],
Cell[145505, 3120, 154, 4, 70, "ExampleText",
 CellID->1479675906],
Cell[145662, 3126, 128, 3, 70, "Input",
 CellID->1052319882],
Cell[145793, 3131, 129, 3, 70, "ExampleText",
 CellID->1812423729],
Cell[CellGroupData[{
Cell[145947, 3138, 145, 4, 70, "Input",
 CellID->1497564255],
Cell[146095, 3144, 11705, 200, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->29747292]
}, Open  ]],
Cell[157815, 3347, 138, 4, 70, "Input",
 CellID->1999057660],
Cell[157956, 3353, 92, 1, 70, "ExampleText",
 CellID->1513908512],
Cell[CellGroupData[{
Cell[158073, 3358, 173, 5, 70, "Input",
 CellID->874111528],
Cell[158249, 3365, 10738, 184, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->360232148]
}, Open  ]]
}, Closed]]
}, Closed]],
Cell[CellGroupData[{
Cell[169048, 3556, 275, 8, 70, "ExampleSection",
 CellID->589267740],
Cell[169326, 3566, 127, 3, 70, "Input",
 CellID->581429451],
Cell[169456, 3571, 115, 3, 70, "ExampleText",
 CellID->1034189107],
Cell[CellGroupData[{
Cell[169596, 3578, 336, 11, 70, "Input",
 CellID->2031166178],
Cell[169935, 3591, 14008, 238, 70, "Output",
 CellTags->"RasterizedOutput",
 CellID->493324182]
}, Open  ]]
}, Closed]]
}, Open  ]],
Cell[CellGroupData[{
Cell[184004, 3836, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[184455, 3851, 171, 4, 70, "MoreAbout",
 CellID->131815360],
Cell[184629, 3857, 161, 3, 70, "MoreAbout",
 CellID->362149722]
}, Open  ]],
Cell[184805, 3863, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

