(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     14745,        431]
NotebookOptionsPosition[     11262,        324]
NotebookOutlinePosition[     13545,        386]
CellTagsIndexPosition[     13425,        380]
WindowTitle->Uniform - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Integrals as Limits\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/IntegralsAsLimits"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/Uniform\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/Uniform"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/Uniform.html"], StandardForm]], "Input", TextClipboardType -> 
              "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/Uniform", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["Uniform", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["Uniform"], "InlineFormula"],
     "\[LineSeparator]an option value for the option ",
     Cell[BoxData[
      ButtonBox["Subintervals",
       BaseStyle->"Link",
       ButtonData->"paclet:IntegrationTechniques/ref/Subintervals"]], 
      "InlineFormula"],
     " in ",
     "RiemannSumPlot",
     " specifying polygons should have equal widths"
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}},
 CellID->982511436]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->9522990],

Cell[TextData[{
 "Uniform is the default value for ",
 Cell[BoxData[
  ButtonBox["Subintervals",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/Subintervals"]], 
  "InlineFormula"],
 "."
}], "Notes",
 CellID->1067943069]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->209558170],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->445658964],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->345266201],

Cell["\<\
By default polygons will have equal widths in RiemannSumPlot.\
\>", "ExampleText",
 CellID->388226013],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"GraphicsRow", "[", 
  RowBox[{"{", 
   RowBox[{
    RowBox[{"RiemannSumPlot", "[", 
     RowBox[{"x", ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", "6"}], "}"}], ",", "7", ",", 
      "\"\<Right\>\""}], "]"}], ",", 
    RowBox[{"RiemannSumPlot", "[", 
     RowBox[{"x", ",", 
      RowBox[{"{", 
       RowBox[{"x", ",", "0", ",", "6"}], "}"}], ",", "7", ",", 
      "\"\<Right\>\"", ",", 
      RowBox[{"Subintervals", "\[Rule]", " ", "Uniform"}]}], "]"}]}], "}"}], 
  "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->859280905],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJztnbFy4zgMhjNzT3KPsa9wZcotrliVLq7Y0u2WKlW6VZnuXO4rpHSZNuWV
KXmyJdESCUAUCFCUzX+yO55ElshvAAiCQOnPH/+8/vjj5eXl7+7fv92/62dT
VFRUVFRUVFRUVFS0B13qb90lzLf6svVAMlJhYm4QnpyAr8Lkqt49rqrOk18/
dSUEYWKeDIt1kHM1i58vo7YbWpB+4bpc/uPtE2NiRiwC49YUweR4rMP303EY
fONcObYhPWQVdfM15uT/1HVbVSs4TIUxMTvBgjF5f29f/2q+voJ3NPrGHchN
u4BgZhxaC+F0at/a0+1PLCFMzE6wgEw+Pt5+/uyYrPOXjoR/at1F8DSQjzRN
2xlH94FvGwgTsz/bGH4ul/ZwOH19tTFMrHYBwQwc2ump5HwePotwcLQLLA6T
z89rxOh/I2Ub++EAGIaebeSPZcrk82OIGIJM8ifQy3JobznG9Dz73HHDjRhP
Gzfadsgxpj9PHjeciMFkMpR6Zpdr+RPo1U22vWoWMQRsA2JidoKlm7gfMXhM
zjVQHd6Fg3SqqsaPGPG2ATIxO8FyPNZ+xOAwGRwk3+IwUeU7HJrONvyIEXtu
RZiYPWDpDOP1tfEjBp/JlYZ7PyUTH8GqfH2Ogf1VIN/wmJic4gY48T7HuBW4
JJlc6irPfAOs8tkcw7mWF8s3bnKYmByxAHUMcSbnCogbUhOJke8gvSaT1Ykb
HhOTMZbpVYkUE3s7OtsbB44XtKfZVQkYVSLzDYyJyQ6LGzH0mEyVp4P4dQzV
uOErEyZmWuDy6hjaTDKE0DRAHUM13/CVGxawjqHNJDcIYOXzyeMGWPmUZ+J1
KmR1TsEqn7rnVr97IyfbOB5rsPIpzeTWreDZhuBEFkUUuIjKp2bcAJiYbLBc
C1zXDi6g8inL5HqltnXcmE9nVscgKp9651aQidkSi1vHGAtcmkz6a3jINoTn
SQo09cXKp1bcQJiYDLDYHGNp4gJMbLe9c9Mxcc3cr/KFVD6V8g2MidkGC9HB
lYRJZnFjelWyQdzolVncgDq4kjDJKd9w6hiEF9BRRck2NsFyuYAdXMmZ3LSV
gzg9n1vGDUibYME7uLZhsomDgHWM9PkGofRYyA6ubZikdxBG5fPh48ZSB9fj
xA2ywHViVD7pqLIL2yCYBHRwKTMZb0gnWPiJ2XOXYxwqulUpbdxAmBgd2wAH
H9bBpczkcrnN310VrGwbbh2D5wVa51aEidG1DUYHVxIml7r2ensS+IjNMXhe
oBU3enlMTJK4saaDS50J2FWtFjdmq91tjsHzAjqqxNgG1mmuYxv3MTt1jKUI
kIbJudLvM58agHNVkmPc8JgYhXA6Hf/6Dq40TNyWatV8w69j5JVvDPLbzBXP
KawOLl0mw4MmoMV9Shzwtau5xA2MiVGLG9wOrvSx9CqluEGuXV3tBQGeJSwN
f8Eqn9nkG67YDkIUc6rv9NrVXOKGOBaCCVH5fLy4gUUAuoMry3wDENtfwPF3
EYOofAZEgG2YxMQN31zD1q4+ctzwh7dY+WRjkWMyZF5SNXM/Ath+DHEvCNgn
TzATNhafSUjlc/N8Yyz+uY9ZlYobgR1cWcUNjAkbizPIwMqnBjEeE+fmgUi+
sXLt6mov0D63+jdU4v2lf85nSOUzIAKkYeIuGWfXRe3ApqvdlbxAw0cIJiY6
bqyqfGoQYzDxbytFxo21HVyZ5RswEzaWfgprK5+b5xvm/mj32TOuYmzDPhlY
2wvEfYRmwsbyi7V2VYPYKiZjfdi968jORavvp0kzsK4XKOUbGBPDtQ3e2tWA
CJCOSSAEpMJ3VVU1FauDK7e4IYiFvXZVg5iUbWAcMIuN6eDKMN+IwOLWMXhr
V3PINzAI2J9As5y/fSCRFyTwkRgs7+9Ra1fVYApAWHIQN2JAA9tlvhGBBah8
spnQc0+Sb/TtbyuePeuYpUgHV2ZxA2YSjkVk7aoazLUoVjS/TQ8t1cGVX74B
rYYNw4K8fWD1+PPIN2DbwLa2Axbs4MosbsBMQrAIrl1VgxnLgaiZ94c+nSQ7
uPLLNzhxQ3btKj33JPkGzIF2EGztqpqpsz2LrdVxQ3ztqhrMWA69g/yCdDg0
2NpVw40AO8o3QCYaa1dzyDfARpabgwCGd2vtS9+qxD4cU1hzD4hFae2qGsxY
TSDcra7PMQiL9Qa233yDxnI/ll2JtkVU3IbJmHTdTa6u27e3rUydfThhOUxU
166qwRSBcLe6zjB+/162WMONAPnlGwSW0TDWvX1g9fhzyDcwCJZD0/jvXU1s
6uzDCctisW9q3nR22zCxhrGq8ukN7DHzjTRrVzX2KRg3iMondiFjB+Zv4Njz
dAPf1O1fMS/oNyB8hN26togF6+CSZcLAkoZJbxh2JP2HkP9HRO3kl8Dn8H1O
TJGxT2F1++wiBjZOexXjjI1gYr+VbJ/xBB5GIibxYExe4rBEfv1RVbAUFRUV
FRWJqL/NBDzPaBDaLzffAb4H/Mmus22IIwx7WNjBwhYrRWJJwsSQWBIwGZ+N
Bzx3NWiI1CL0cQv0ya6TQVCk3cVm0PgErWIY0QIWbSaGxpKAyX2G1DBprx5E
zxNebjp8EX5X2v3gL6Tp2NdCU468TgFYdJkYGksSJvdHasbaBrAIffp9dJj4
u9K8XcBbWAfBvXS1ArBoMjFhWJSZSMUN0gPMcABoIsS70rxDeE//dAa34KUr
JBI32Eymbk9j0WUSnW8YfBG6uxU8j5Aj9CPFTr2DbwRF+UDF5RtGhMnyQdSZ
LF2nLOTcxCL0+QYLZ15sDtaFlq8KxCzjvk9s0CmYGBTLVkyKioqKioqKioqK
ioqKioqKctP/UkHJjw==
    "], {{0, 94}, {180, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{180, 94},
  PlotRange->{{0, 180}, {0, 94}}]], "Output",
 ImageSize->{184, 94},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->319708346]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Integrals as Limits",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/IntegralsAsLimits"]], "Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Classroom Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomUtilities"]], "MoreAbout",
 CellID->899696910]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Uniform - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 32, 9.8512624}", 
    "history" -> {"0.0", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "Uniform an option value for the option Subintervals in RiemannSumPlot \
specifying polygons should have equal widths", "synonyms" -> {}, "title" -> 
    "Uniform", "titlemodifier" -> "", "windowtitle" -> "Uniform", "type" -> 
    "Symbol", "uri" -> "ClassroomUtilities/ref/Uniform"}, 
  "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4919, 148, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->209558170]},
 "RasterizedOutput"->{
  Cell[6470, 205, 3406, 64, 115, "Output",
   CellTags->"RasterizedOutput",
   CellID->319708346]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 13159, 369},
 {"RasterizedOutput", 13302, 373}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[600, 21, 2723, 63, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3348, 88, 50, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3401, 91, 593, 18, 99, "Usage",
 CellID->982511436]
}, Open  ]],
Cell[CellGroupData[{
Cell[4031, 114, 607, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->9522990],
Cell[4641, 134, 241, 9, 70, "Notes",
 CellID->1067943069]
}, Closed]],
Cell[CellGroupData[{
Cell[4919, 148, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->209558170],
Cell[CellGroupData[{
Cell[5434, 166, 195, 6, 31, "ExampleSection",
 CellID->445658964],
Cell[5632, 174, 127, 3, 28, "Input",
 CellID->345266201],
Cell[5762, 179, 112, 3, 32, "ExampleText",
 CellID->388226013],
Cell[CellGroupData[{
Cell[5899, 186, 568, 17, 47, "Input",
 CellID->859280905],
Cell[6470, 205, 3406, 64, 115, "Output",
 CellTags->"RasterizedOutput",
 CellID->319708346]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[9937, 276, 448, 13, 45, "TutorialsSection",
 CellID->250839057],
Cell[10388, 291, 173, 4, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[10598, 300, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[11049, 315, 171, 4, 70, "MoreAbout",
 CellID->899696910]
}, Open  ]],
Cell[11235, 322, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

