(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     33740,        756]
NotebookOptionsPosition[     29885,        637]
NotebookOutlinePosition[     32248,        701]
CellTagsIndexPosition[     32128,        695]
WindowTitle->XGrid - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES SYMBOL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Tutorials \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"Building an Understanding of Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/\
BuildingAnUnderstandingOfFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"TutorialsSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Understanding Utilities\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/UnderstandingUtilities"]},
       Appearance->None,
       MenuAppearance->Automatic,
       MenuStyle->"MoreAboutSection"]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"ClassroomUtilities/ref/XGrid\"\>":>
       None, "\<\"Copy Mathematica URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/ref/XGrid"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web URL\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
ref/XGrid.html"], StandardForm]], "Input", TextClipboardType -> "PlainText"]},
             Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web URL\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/ref/XGrid", ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["XGrid", "ObjectName",
 CellID->1224892054],

Cell[BoxData[GridBox[{
   {"", Cell[TextData[{
     Cell[BoxData["XGrid"], "InlineFormula"],
     "\[LineSeparator]is an option value for GridLineStyle in ",
     Cell[BoxData[
      ButtonBox["PlotGrid",
       BaseStyle->"Link",
       ButtonData->"paclet:UnderstandingFunctions/ref/PlotGrid"]], 
      "InlineFormula"],
     " to have the grid rendered as a set of crosses."
    }]]}
  }]], "Usage",
 GridBoxOptions->{
 GridBoxBackground->{
  "Columns" -> {{None}}, "ColumnsIndexed" -> {}, "Rows" -> {{None}}, 
   "RowsIndexed" -> {}}}]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[Cell[BoxData[
 ButtonBox[
  FrameBox[
   StyleBox[
    RowBox[{"MORE", " ", "INFORMATION"}], "NotesFrameText"],
   StripOnInput->False],
  Appearance->{Automatic, None},
  BaseStyle->None,
  ButtonFunction:>(FrontEndExecute[{
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], All, ButtonCell], 
     FrontEndToken["OpenCloseGroup"], 
     FrontEnd`SelectionMove[
      FrontEnd`SelectedNotebook[], After, CellContents]}]& ),
  Evaluator->None,
  Method->"Preemptive"]]]], "NotesSection",
 WholeCellGroupOpener->True,
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1357249],

Cell["The crosses are positioned at integer lattice points.", "Notes",
 CellID->1067943069],

Cell["Color and thickness directives can be included.", "Notes",
 CellID->1696459294]
}, Closed]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["EXAMPLES",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "PrimaryExamplesSection",
 WholeCellGroupOpener->True,
 CellTags->"PrimaryExamplesSection",
 CellID->734484182],

Cell[CellGroupData[{

Cell[TextData[{
 "Basic Examples",
 "\[NonBreakingSpace]\[NonBreakingSpace]",
 Cell["(1)", "ExampleCount"]
}], "ExampleSection", "ExampleSection",
 WholeCellGroupOpener->True,
 CellID->540686561],

Cell[BoxData[
 RowBox[{"Needs", "[", "\"\<ClassroomUtilities`\>\"", "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->250973039],

Cell["Creating a plot grid with crosses in place of lines.", "ExampleText",
 CellID->445983765],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PlotGrid", "[", 
  RowBox[{"All", ",", 
   RowBox[{"GridLinesStyle", "\[Rule]", " ", "XGrid"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->931210325],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3SFUI8uXx3H2rEEiY0ciI7GRSCRyIxErIseujIzEovbknDWRschIZOxI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    "], {{0, 427}, {432, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{432, 427},
  PlotRange->{{0, 432}, {0, 427}}]], "Output",
 ImageSize->{436, 427},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[2]=",
 CellID->455341007]
}, Open  ]],

Cell["Changing the color and weight of the crosses.", "ExampleText",
 CellID->959021063],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PlotGrid", "[", 
  RowBox[{"All", ",", 
   RowBox[{"GridLinesStyle", "\[Rule]", 
    RowBox[{"{", 
     RowBox[{"Red", ",", 
      RowBox[{"Thickness", "[", "Medium", "]"}], ",", " ", "XGrid"}], 
     "}"}]}]}], "]"}]], "Input",
 CellLabel->"In[3]:=",
 CellID->1402235106],

Cell[BoxData[
 GraphicsBox[
  TagBox[RasterBox[CompressedData["
1:eJzt3SFUHFm39nHuugaJxI6MRGIjkUjki0RcgYwd2RKJjbqLta5p2RaJRGJH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    "], {{0, 427}, {432, 0}}, {0, 255},
    ColorFunction->RGBColor],
   BoxForm`ImageTag["Byte", ColorSpace -> "RGB", Interleaving -> True],
   Selectable->False],
  BaseStyle->"ImageGraphics",
  ImageSize->Automatic,
  ImageSizeRaw->{432, 427},
  PlotRange->{{0, 432}, {0, 427}}]], "Output",
 ImageSize->{436, 427},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellTags->"RasterizedOutput",
 CellLabel->"Out[3]=",
 CellID->377913051]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["TUTORIALS",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "TutorialsSection",
 WholeCellGroupOpener->True,
 CellID->250839057],

Cell[TextData[ButtonBox["Building an Understanding of Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/BuildingAnUnderstandingOfFunctions"]], \
"Tutorials",
 CellID->341631938]
}, Open  ]],

Cell[CellGroupData[{

Cell[TextData[ButtonBox["MORE ABOUT",
 BaseStyle->None,
 Appearance->{Automatic, None},
 Evaluator->None,
 Method->"Preemptive",
 ButtonFunction:>(FrontEndExecute[{
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], All, ButtonCell], 
    FrontEndToken["OpenCloseGroup"], 
    FrontEnd`SelectionMove[
     FrontEnd`SelectedNotebook[], After, 
     CellContents]}]& )]], "MoreAboutSection",
 WholeCellGroupOpener->True,
 CellID->38303248],

Cell[TextData[ButtonBox["Understanding Utilities",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/UnderstandingUtilities"]], "MoreAbout",
 CellID->1054573546]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 602},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"XGrid - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, "ColorType" -> "SymbolColor", "LinkTrails" -> 
  GridBox[{{
      RowBox[{
        ButtonBox[
        "Classroom Utilities", ButtonData -> 
         "paclet:ClassroomUtilities/guide/ClassroomUtilities", 
         BaseStyle -> {"Link", "DockedLinkTrail"}], 
        Cell[">", "DockedLinkTrailSeparator"]}]}}, ColumnAlignments -> Left], 
  "RootCaptions" -> "", 
  "Metadata" -> {
   "built" -> "{2012, 1, 4, 18, 32, 21.8476624}", 
    "history" -> {"XX", "", "", ""}, "context" -> "ClassroomUtilities`", 
    "keywords" -> {}, "specialkeywords" -> {}, 
    "tutorialcollectionlinks" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Symbol", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "XGrid is an option value for GridLineStyle in PlotGrid to have the grid \
rendered as a set of crosses.", "synonyms" -> {}, "title" -> "XGrid", 
    "titlemodifier" -> "", "windowtitle" -> "XGrid", "type" -> "Symbol", 
    "uri" -> "ClassroomUtilities/ref/XGrid"}, "SearchTextTranslated" -> ""},
CellContext->"Global`",
FrontEndVersion->"8.0 for Microsoft Windows (64-bit) (April 26, 2011)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"]}, Visible -> False, 
  FrontEndVersion -> "8.0 for Microsoft Windows (64-bit) (April 26, 2011)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{
 "PrimaryExamplesSection"->{
  Cell[4845, 142, 490, 14, 45, "PrimaryExamplesSection",
   CellTags->"PrimaryExamplesSection",
   CellID->734484182]},
 "RasterizedOutput"->{
  Cell[5992, 185, 11104, 190, 448, "Output",
   CellTags->"RasterizedOutput",
   CellID->455341007],
  Cell[17523, 394, 10929, 187, 448, "Output",
   CellTags->"RasterizedOutput",
   CellID->377913051]}
 }
*)
(*CellTagsIndex
CellTagsIndex->{
 {"PrimaryExamplesSection", 31758, 681},
 {"RasterizedOutput", 31901, 685}
 }
*)
(*NotebookFileOutline
Notebook[{
Cell[598, 21, 2769, 65, 46, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3392, 90, 48, 1, 51, "ObjectName",
 CellID->1224892054],
Cell[3443, 93, 539, 15, 85, "Usage"]
}, Open  ]],
Cell[CellGroupData[{
Cell[4019, 113, 607, 18, 39, "NotesSection",
 CellGroupingRules->{"SectionGrouping", 50},
 CellID->1357249],
Cell[4629, 133, 91, 1, 70, "Notes",
 CellID->1067943069],
Cell[4723, 136, 85, 1, 70, "Notes",
 CellID->1696459294]
}, Closed]],
Cell[CellGroupData[{
Cell[4845, 142, 490, 14, 45, "PrimaryExamplesSection",
 CellTags->"PrimaryExamplesSection",
 CellID->734484182],
Cell[CellGroupData[{
Cell[5360, 160, 195, 6, 31, "ExampleSection",
 CellID->540686561],
Cell[5558, 168, 127, 3, 28, "Input",
 CellID->250973039],
Cell[5688, 173, 95, 1, 32, "ExampleText",
 CellID->445983765],
Cell[CellGroupData[{
Cell[5808, 178, 181, 5, 28, "Input",
 CellID->931210325],
Cell[5992, 185, 11104, 190, 448, "Output",
 CellTags->"RasterizedOutput",
 CellID->455341007]
}, Open  ]],
Cell[17111, 378, 88, 1, 70, "ExampleText",
 CellID->959021063],
Cell[CellGroupData[{
Cell[17224, 383, 296, 9, 28, "Input",
 CellID->1402235106],
Cell[17523, 394, 10929, 187, 448, "Output",
 CellTags->"RasterizedOutput",
 CellID->377913051]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[28513, 588, 448, 13, 70, "TutorialsSection",
 CellID->250839057],
Cell[28964, 603, 211, 5, 70, "Tutorials",
 CellID->341631938]
}, Open  ]],
Cell[CellGroupData[{
Cell[29212, 613, 448, 13, 70, "MoreAboutSection",
 CellID->38303248],
Cell[29663, 628, 180, 4, 70, "MoreAbout",
 CellID->1054573546]
}, Open  ]],
Cell[29858, 635, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

