(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 8.0' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       157,          7]
NotebookDataLength[     23392,        673]
NotebookOptionsPosition[     19875,        571]
NotebookOutlinePosition[     22015,        625]
CellTagsIndexPosition[     21972,        622]
WindowTitle->Calculus and Analytic Geometry - Wolfram Mathematica
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{
Cell[" ", "TutorialColorBar",
 CellMargins->{{Inherited, Inherited}, {-5, 0}}],

Cell[TextData[{
 ButtonBox["Mathematica",
  BaseStyle->{"Link", "LinkTrail"},
  ButtonData->"paclet:ClassroomUtilities/guide/ClassroomUtilities"],
 StyleBox[" > ", "LinkTrailSeparator"]
}], "LinkTrail"],

Cell[BoxData[GridBox[{
   {Cell["CLASSROOM UTILITIES TUTORIAL", "PacletNameCell"], Cell[TextData[{
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"Related Tutorials \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Problems in Analytic Geometry\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/tutorial/ProblemsInAnalyticGeometry"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"More About \[RightGuillemet]\"\>",
        StripOnInput->False], {"\<\"Classroom Functions\"\>":>
       Documentation`HelpLookup[
       "paclet:ClassroomUtilities/guide/ClassroomFunctions"]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}],
     "\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\[ThickSpace]\
\[ThickSpace]",
     Cell[BoxData[
      ActionMenuBox[
       FrameBox["\<\"URL \[RightGuillemet]\"\>",
        StripOnInput->
         False], {"\<\"ClassroomUtilities/tutorial/\
CalculusandAnalyticGeometry\"\>":>None, "\<\"Copy Mathematica url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell["ClassroomUtilities/tutorial/CalculusandAnalyticGeometry"]},
             Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; Null], 
       Delimiter, "\<\"Copy web url\"\>":>
       Module[{DocumentationSearch`Private`nb$}, 
        DocumentationSearch`Private`nb$ = NotebookPut[
           Notebook[{
             Cell[
              BoxData[
               MakeBoxes[
                Hyperlink[
                "http://reference.wolfram.com/mathematica/ClassroomUtilities/\
tutorial/CalculusandAnalyticGeometry.html"], StandardForm]], "Input", 
              TextClipboardType -> "PlainText"]}, Visible -> False]]; 
        SelectionMove[DocumentationSearch`Private`nb$, All, Notebook]; 
        FrontEndTokenExecute[DocumentationSearch`Private`nb$, "Copy"]; 
        NotebookClose[DocumentationSearch`Private`nb$]; 
        Null], "\<\"Go to web url\"\>":>FrontEndExecute[{
         NotebookLocate[{
           URL[
            StringJoin[
            "http://reference.wolfram.com/mathematica/", 
             "ClassroomUtilities/tutorial/CalculusandAnalyticGeometry", 
             ".html"]], None}]}]},
       Appearance->None,
       MenuAppearance->Automatic]],
      LineSpacing->{1.4, 0}]
    }], "AnchorBar"]}
  }]], "AnchorBarGrid",
 CellID->1],

Cell[CellGroupData[{

Cell["Calculus and Analytic Geometry", "Title",
 CellID->509267359],

Cell["\<\
Some of the functions in the ClassroomUtilities` package are intended for use \
in studying analytic geometry and calculus. The provide convenient tools for \
generating expressions for lines and for visualizing results.\
\>", "Text",
 CellID->1534169418],

Cell[BoxData[GridBox[{
   {
    RowBox[{"TangentLine", "[", 
     RowBox[{
      StyleBox["f", "TI"], ",", 
      StyleBox["x", "TI"], ",", 
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["0", "TR"]]}], "]"}], 
    RowBox[{
    "create", " ", "an", " ", "expression", " ", "for", " ", "the", " ", 
     "tangent", " ", "line", " ", "to", " ", 
     StyleBox["f", "TI"], " ", "at", " ", 
     RowBox[{
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["0", "TR"]], "."}]}]},
   {
    RowBox[{"TangentLinePlot", "[", 
     RowBox[{
      StyleBox["f", "TI"], ",", 
      RowBox[{"{", 
       RowBox[{
        StyleBox["x", "TI"], ",", 
        SubscriptBox[
         StyleBox["x", "TI"], 
         StyleBox["min", "TI"]], ",", 
        SubscriptBox[
         StyleBox["x", "TI"], 
         StyleBox["max", "TI"]]}], "}"}], ",", 
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["0", "TR"]]}], "]"}], 
    RowBox[{
    "visualize", " ", "a", " ", "tangent", " ", "line", " ", "to", " ", 
     StyleBox["f", "TI"], " ", "at", " ", 
     SubscriptBox[
      StyleBox["x", "TI"], 
      StyleBox["0.", "TR"]]}]},
   {
    RowBox[{"SecantLine", "[", 
     RowBox[{
      StyleBox["f", "TI"], ",", 
      RowBox[{"{", 
       RowBox[{
        StyleBox["x", "TI"], ",", 
        SubscriptBox[
         StyleBox["x", "TI"], 
         StyleBox["1", "TR"]], ",", 
        SubscriptBox[
         StyleBox["x", "TI"], 
         StyleBox["2", "TR"]]}], "}"}]}], "]"}], Cell[TextData[{
     "create an expression for the secant between the pts ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["x", "TI"], 
       StyleBox["2", "TR"]]], "InlineFormula"],
     " on ",
     Cell[BoxData[
      StyleBox[
       RowBox[{"f", "."}], "TI"]], "InlineFormula"]
    }], "TableText"]},
   {
    RowBox[{"SecantLinePlot", "[", 
     RowBox[{
      StyleBox["f", "TI"], ",", 
      RowBox[{"{", 
       RowBox[{
        StyleBox["x", "TI"], ",", 
        SubscriptBox[
         StyleBox["x", "TI"], 
         StyleBox["min", "TI"]], ",", 
        SubscriptBox[
         StyleBox["x", "TI"], 
         StyleBox["max", "TI"]]}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{
        SubscriptBox[
         StyleBox["p", "TI"], 
         StyleBox["1", "TR"]], ",", 
        SubscriptBox[
         StyleBox["p", "TI"], 
         StyleBox["2", "TR"]]}], "}"}]}], "]"}], Cell[TextData[{
     "visualize a secant line for the function ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " between the points ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["p", "TI"], 
       StyleBox["1", "TR"]]], "InlineFormula"],
     " and ",
     Cell[BoxData[
      SubscriptBox[
       StyleBox["p", "TI"], 
       StyleBox["2.", "TR"]]], "InlineFormula"]
    }], "TableText"]},
   {
    RowBox[{"PointCurveDistance", "[", 
     RowBox[{
      StyleBox["pt", "TI"], ",", 
      StyleBox["f", "TI"], ",", 
      StyleBox["x", "TI"]}], "]"}], Cell[TextData[{
     "find the distance from ",
     Cell[BoxData[
      StyleBox["pt", "TI"]], "InlineFormula"],
     " to the nearest point on",
     Cell[BoxData[
      RowBox[{" ", 
       StyleBox["f", "TI"]}]], "InlineFormula"],
     "."
    }], "TableText"]},
   {
    RowBox[{"PointCurvePlot", "[", 
     RowBox[{
      StyleBox["f", "TI"], ",", 
      RowBox[{"{", 
       RowBox[{
        StyleBox["x", "TI"], ",", 
        SubscriptBox[
         StyleBox["x", "TI"], 
         StyleBox["min", "TI"]], ",", 
        SubscriptBox[
         StyleBox["x", "TI"], 
         StyleBox["max", "TI"]]}], "}"}], ",", 
      StyleBox["pt", "TI"]}], "]"}], Cell[TextData[{
     "visualize the point on ",
     Cell[BoxData[
      StyleBox["f", "TI"]], "InlineFormula"],
     " closest to ",
     Cell[BoxData[
      StyleBox["pt", "TI"]], "InlineFormula"],
     "."
    }], "TableText"]}
  }]], "DefinitionBox",
 CellID->2096742444],

Cell["Secants and tangents.", "Caption",
 CellID->1673156713],

Cell[TextData[{
 Cell[BoxData[
  ButtonBox["SecantLinePlot",
   BaseStyle->"Link",
   ButtonData->"paclet:ClassroomUtilities/ref/SecantLinePlot"]], 
  "InlineFormula"],
 " can be used to visualize what happens as two points on a curve approach \
one another. The ",
 ButtonBox["Maniipulate",
  BaseStyle->"Link",
  ButtonData->"paclet:ClassroomUtilities/ref/Maniipulate"],
 " function provides a convenient tool to accomplish this."
}], "Caption",
 CellID->1891092685],

Cell["Approximating slope using secants.", "MathCaption",
 CellID->836781195],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"SecantLinePlot", "[", 
    RowBox[{
     SuperscriptBox["x", "4"], ",", 
     RowBox[{"{", 
      RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"x1", ",", "x2"}], "}"}], ",", 
     RowBox[{"PlotRange", "\[Rule]", " ", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"-", ".1"}], ",", "1"}], "}"}]}]}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x1", ",", 
       RowBox[{"1", "/", "4"}]}], "}"}], ",", "0", ",", 
     RowBox[{"1", "/", "2"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x2", ",", 
       RowBox[{"3", "/", "4"}]}], "}"}], ",", 
     RowBox[{"1", "/", "2"}], ",", "1"}], "}"}], ",", 
   RowBox[{"SaveDefinitions", "\[Rule]", " ", "True"}]}], "]"}]], "Input",
 CellLabel->"In[1]:=",
 CellID->2058623809],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`x1$$ = Rational[1, 4], $CellContext`x2$$ = 
    Rational[3, 4], Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`x1$$], 
       Rational[1, 4]}, 0, 
      Rational[1, 2]}, {{
       Hold[$CellContext`x2$$], 
       Rational[3, 4]}, 
      Rational[1, 2], 1}}, Typeset`size$$ = {180., {87., 92.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`x1$1331$$ = 0, $CellContext`x2$1332$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`x1$$ = Rational[1, 4], $CellContext`x2$$ = 
        Rational[3, 4]}, "ControllerVariables" :> {
        Hold[$CellContext`x1$$, $CellContext`x1$1331$$, 0], 
        Hold[$CellContext`x2$$, $CellContext`x2$1332$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> 
      ClassroomUtilities`SecantLinePlot[$CellContext`x^4, {$CellContext`x, 0, 
         1}, {$CellContext`x1$$, $CellContext`x2$$}, PlotRange -> {-0.1, 1}], 
      "Specifications" :> {{{$CellContext`x1$$, 
          Rational[1, 4]}, 0, 
         Rational[1, 2]}, {{$CellContext`x2$$, 
          Rational[3, 4]}, 
         Rational[1, 2], 1}}, "Options" :> {}, "DefaultOptions" :> {}],
     ImageSizeCache->{251., {143., 149.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 ImageSize->{255, 294},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[1]=",
 CellID->445616919]
}, Open  ]],

Cell["Include the tangent line using Show and TangentLinePlot.", "MathCaption",
 CellID->1675057462],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", 
  RowBox[{
   RowBox[{"Show", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"SecantLinePlot", "[", 
       RowBox[{
        SuperscriptBox["x", "4"], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"{", 
         RowBox[{"x1", ",", "x2"}], "}"}], ",", 
        RowBox[{"PlotRange", "\[Rule]", " ", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"-", ".1"}], ",", "1"}], "}"}]}]}], "]"}], ",", 
      RowBox[{"TangentLinePlot", "[", 
       RowBox[{
        SuperscriptBox["x", "4"], ",", 
        RowBox[{"{", 
         RowBox[{"x", ",", "0", ",", "1"}], "}"}], ",", 
        RowBox[{"1", "/", "2"}]}], "]"}]}], "}"}], "]"}], ",", 
   "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x1", ",", 
       RowBox[{"1", "/", "4"}]}], "}"}], ",", "0", ",", 
     RowBox[{"1", "/", "2"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"x2", ",", 
       RowBox[{"3", "/", "4"}]}], "}"}], ",", 
     RowBox[{"1", "/", "2"}], ",", "1"}], "}"}], ",", 
   RowBox[{"SaveDefinitions", "\[Rule]", " ", "True"}]}], "]"}]], "Input",
 CellLabel->"In[2]:=",
 CellID->1327635311],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`x1$$ = Rational[1, 4], $CellContext`x2$$ = 
    Rational[3, 4], Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {{{
       Hold[$CellContext`x1$$], 
       Rational[1, 4]}, 0, 
      Rational[1, 2]}, {{
       Hold[$CellContext`x2$$], 
       Rational[3, 4]}, 
      Rational[1, 2], 1}}, Typeset`size$$ = {180., {87., 92.}}, 
    Typeset`update$$ = 0, Typeset`initDone$$, Typeset`skipInitDone$$ = 
    True, $CellContext`x1$1412$$ = 0, $CellContext`x2$1413$$ = 0}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`x1$$ = Rational[1, 4], $CellContext`x2$$ = 
        Rational[3, 4]}, "ControllerVariables" :> {
        Hold[$CellContext`x1$$, $CellContext`x1$1412$$, 0], 
        Hold[$CellContext`x2$$, $CellContext`x2$1413$$, 0]}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> Show[{
         ClassroomUtilities`SecantLinePlot[$CellContext`x^4, {$CellContext`x, 
           0, 1}, {$CellContext`x1$$, $CellContext`x2$$}, 
          PlotRange -> {-0.1, 1}], 
         ClassroomUtilities`TangentLinePlot[$CellContext`x^4, {$CellContext`x,
            0, 1}, 1/2]}], "Specifications" :> {{{$CellContext`x1$$, 
          Rational[1, 4]}, 0, 
         Rational[1, 2]}, {{$CellContext`x2$$, 
          Rational[3, 4]}, 
         Rational[1, 2], 1}}, "Options" :> {}, "DefaultOptions" :> {}],
     ImageSizeCache->{251., {143., 149.}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    SynchronousInitialization->True,
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 ImageSize->{255, 294},
 ImageMargins->{{0, 0}, {0, 0}},
 ImageRegion->{{0, 1}, {0, 1}},
 CellLabel->"Out[2]=",
 CellID->1208080544]
}, Open  ]],

Cell[CellGroupData[{

Cell["MORE ABOUT", "TutorialMoreAboutSection",
 CellID->23220180],

Cell[TextData[ButtonBox["Classroom Functions",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/guide/ClassroomFunctions"]], "TutorialMoreAbout",\

 CellID->1899304270]
}, Open  ]],

Cell[CellGroupData[{

Cell["RELATED TUTORIALS", "RelatedTutorialsSection",
 CellID->415694126],

Cell[TextData[ButtonBox["Problems in Analytic Geometry",
 BaseStyle->"Link",
 ButtonData->
  "paclet:ClassroomUtilities/tutorial/ProblemsInAnalyticGeometry"]], \
"RelatedTutorials",
 CellID->806871991]
}, Open  ]],

Cell[CellGroupData[{

Cell["RELATED WOLFRAM EDUCATION GROUP COURSES", "TutorialRelatedLinksSection",
 CellID->415694148],

Cell[TextData[{
 ButtonBox["M50",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox[":",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox[" ",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox["An",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox[" ",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox["Introduction",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox[" ",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox["to",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox[" ",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox["Mathematica",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox[" ",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox["in",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox[" ",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox["the",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox[" ",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"],
 ButtonBox["Classroom",
  BaseStyle->"Hyperlink",
  ButtonData->{
    URL["http://www.wolfram.com/services/education/courses/m50.html"], None},
  ButtonNote->"http://www.wolfram.com/services/education/courses/m50.html"]
}], "TutorialRelatedLinks",
 CellID->415694149]
}, Open  ]]
}, Open  ]],

Cell[" ", "FooterCell"]
},
Saveable->False,
ScreenStyleEnvironment->"Working",
WindowSize->{725, 750},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
WindowTitle->"Calculus and Analytic Geometry - Wolfram Mathematica",
TaggingRules->{
 "ModificationHighlight" -> False, 
  "Metadata" -> {
   "built" -> "{2011, 2, 22, 7, 2, 30.173398}", "context" -> 
    "ClassroomUtilities`", "keywords" -> {}, "index" -> True, "label" -> 
    "Classroom Utilities Tutorial", "language" -> "en", "paclet" -> 
    "ClassroomUtilities", "status" -> "None", "summary" -> 
    "Some of the functions in the ClassroomUtilities` package are intended \
for use in studying analytic geometry and calculus. The provide convenient \
tools for generating expressions for lines and for visualizing results. \
Secants and tangents. SecantLinePlot can be used to visualize what happens as \
two points on a curve approach one another. The Maniipulate function provides \
a convenient tool to accomplish this.", "synonyms" -> {}, "title" -> 
    "Calculus and Analytic Geometry", "type" -> "Tutorial", "uri" -> 
    "ClassroomUtilities/tutorial/CalculusandAnalyticGeometry"}, "LinkTrails" -> 
  "", "SearchTextTranslated" -> ""},
FrontEndVersion->"8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 7, \
2010)",
StyleDefinitions->Notebook[{
   Cell[
    StyleData[
    StyleDefinitions -> FrontEnd`FileName[{"Wolfram"}, "Reference.nb"]]], 
   Cell[
    StyleData["Input"], CellContext -> "Global`"], 
   Cell[
    StyleData["Output"], CellContext -> "Global`"], 
   Cell[
    StyleData["TutorialMoreAboutSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["RelatedTutorialsSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}], 
   Cell[
    StyleData["TutorialRelatedLinksSection"], 
    CellGroupingRules -> {"SectionGrouping", 30}]}, Visible -> False, 
  FrontEndVersion -> 
  "8.0 for Mac OS X x86 (32-bit, 64-bit Kernel) (November 7, 2010)", 
  StyleDefinitions -> "Default.nb"]
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[623, 21, 78, 1, 2, "TutorialColorBar"],
Cell[704, 24, 202, 5, 19, "LinkTrail"],
Cell[909, 31, 2807, 64, 47, "AnchorBarGrid",
 CellID->1],
Cell[CellGroupData[{
Cell[3741, 99, 67, 1, 50, "Title",
 CellID->509267359],
Cell[3811, 102, 265, 5, 73, "Text",
 CellID->1534169418],
Cell[4079, 109, 4051, 140, 165, "DefinitionBox",
 CellID->2096742444],
Cell[8133, 251, 61, 1, 30, "Caption",
 CellID->1673156713],
Cell[8197, 254, 468, 13, 42, "Caption",
 CellID->1891092685],
Cell[8668, 269, 77, 1, 30, "MathCaption",
 CellID->836781195],
Cell[CellGroupData[{
Cell[8770, 274, 943, 29, 61, "Input",
 CellID->2058623809],
Cell[9716, 305, 2162, 47, 315, "Output",
 CellID->445616919]
}, Open  ]],
Cell[11893, 355, 100, 1, 70, "MathCaption",
 CellID->1675057462],
Cell[CellGroupData[{
Cell[12018, 360, 1271, 38, 70, "Input",
 CellID->1327635311],
Cell[13292, 400, 2285, 49, 70, "Output",
 CellID->1208080544]
}, Open  ]],
Cell[CellGroupData[{
Cell[15614, 454, 65, 1, 70, "TutorialMoreAboutSection",
 CellID->23220180],
Cell[15682, 457, 182, 5, 70, "TutorialMoreAbout",
 CellID->1899304270]
}, Open  ]],
Cell[CellGroupData[{
Cell[15901, 467, 72, 1, 70, "RelatedTutorialsSection",
 CellID->415694126],
Cell[15976, 470, 201, 5, 70, "RelatedTutorials",
 CellID->806871991]
}, Open  ]],
Cell[CellGroupData[{
Cell[16214, 480, 98, 1, 70, "TutorialRelatedLinksSection",
 CellID->415694148],
Cell[16315, 483, 3506, 82, 70, "TutorialRelatedLinks",
 CellID->415694149]
}, Open  ]]
}, Open  ]],
Cell[19848, 569, 23, 0, 70, "FooterCell"]
}
]
*)

(* End of internal cache information *)

